######################################################################
## 
## Main FFX code
## By Dr Mike 2000
## with contributions from C4, CatWhoWalksByHimself, Chazz da Mighty,
## pimthe, Kuertee, M25, Shazam, Stumpy, SouperIan, TaskMasterX and
## Yellow Lantern
## 
######################################################################

# please update as needed
FFX_VERSION ={
'majorVersion': 3, # official major version, ex.: 3 for 3.0.4
'minorVersion': 3, # official update version, ex.: 0 for 3.0.4
'patchVersion': 1, # official patch version, ex.: 4 for 3.0.4
'buildVersion': 0, # for each new main branch, new build number; for someone's branch, name of the main build from which this was branched
'buildBranch': "main release update" # either 'main' (followed by some identification for public releases, such as 'beta 1' or 'final') for merged code or name of the author of the branch, optionally followed by the branch's numbering
}
print "Starting ffx.py v. %i.%i.%i build %i; branch = %s" %  (FFX_VERSION['majorVersion'], FFX_VERSION['minorVersion'], FFX_VERSION['patchVersion'], FFX_VERSION['buildVersion'], FFX_VERSION['buildBranch'])





import js
import cshelper
import ai
import shutil
import string
import m25ai

import m25custompowers
import m25config

import pickle # for time master attribute's time travel and other file manipulations - Ep.
import math # used by getAngleFromWidthAndHeight(size) and by Nemesis - Ep.
import sys # Used by the plugins importer and pseudo-event registration - Ep. 2006-06-24
import os # Used by the plugins importer - Ep. 2006-06-24
import types # Used by Heavy Lifter

import missionobjvar ###! Stumpy's Mission and Object Variable Functions, used by FFq and Telepathy
import datfiles ###! Stumpy's mission.dat reader for map size detection, etc.
import chardata
import mlogreader

import ffxcustom
try:
    import ffxcustom2
except:
    pass
import ffxpuppets
import ffxID
import ffxbuiltins
import ffxextras
import ffxfx
import ffxtransmutes
import ffxpowerids

from js import *
from cshelper import *
from ai import *
from shutil import *
from m25ai import *
from chardata import *

from ffxcustom import *
try:
    from ffxcustom2 import *
except:
    pass
from ffxpuppets import *
from ffxID import *
from ffxbuiltins import *
from ffxextras import *
from ffxfx import *
from ffxtransmutes import *
from ffxtraits import *
from ffxmulti import *

from ChangeNIFLighting import *

##import m25skirmish    # stumpy 2006-12-24: moved into FFX_SetupSkirmish() to prevent import during non-skirmish missions
import m25getset

import sysutils # For auto-detection the current mod's folder name, etc. - Ep. 2006-06-11
import generalutils # General utility functions - Ep. 2006-06-22

import ffx2
from ffx2 import *

############################ CONFIGURATION SECTION ########################################

#detection of mission starting from savegame
FFX_SAVEGAME=1

#prevents multiple initialisations when more than one .py file
#or a file loaded more than once calls one of the initialising functions
FFX_INITIALIZED=0

#the range at which various powers kick in
FFX_ABSORBRANGE=5
FFX_MIMICRANGE=5
FFX_DRAINRANGE=30
FFX_SHIELDRANGE=30

#EP costs for certain activities
FFX_EP_SHAPESHIFT=33
FFX_EP_MIMIC=33
FFX_EP_EXPLODE=33
FFX_EP_LIVINGLASER=33
FFX_EP_GAS=33
FFX_EP_SPIN=33
FFX_EP_ICE=33
FFX_EP_SAND=33
FFX_EP_ABSORB=33
FFX_EP_SCAN=33
FFX_EP_PEACEFIELD=33
FFX_EP_LIFTTK=33
FFX_EP_THROWTK=33
FFX_EP_MOVETK=0
FFX_EP_THROWMAG=33
FFX_EP_EARTHWALL=33
FFX_EP_EARTHSPIKE=33
FFX_EP_ANIMATE=33
FFX_EP_SUSTAIN=0
FFX_EP_MINDSHIELD=33
FFX_EP_PHYSICALSHIELD=66

#strength/chance of effects
FFX_RPG_DEPRESSED_CHANCE=5
FFX_PRESENCE_CHANCE=5
FFX_JINX_CHANCE_JAM=10
FFX_JINX_CHANCE_SLIP=10
FFX_PHEREMONE_CHANCE=10
FFX_MAGNET_FORCE=30000
FFX_SCARY_CHANCE=10

########################### CONSTANTS ################################################################

#not included in FF API, but makes code more readable
#Ep. 2006-08-22: made accessible without doing a from ffx import * or prefixing with the ffx. module; added PCSTATE_DEAD; regrouped
OC_GENERIC=0x400000
js.OC_GENERIC=OC_GENERIC
OC_STANDALONEHERO=0x800 #heroes have this class and the OC_CONTROLLABLE one; however heroes' lures have only OC_STANDALONEHERO (enemies' lures have OC_MINION instead)- Ep. 2006-07-18
js.OC_STANDALONEHERO=OC_STANDALONEHERO
OC_VILLAIN=OC_VILLIAN
js.OC_VILLAIN=OC_VILLAIN

PCSTATE_DEAD=1
js.PCSTATE_DEAD=PCSTATE_DEAD
PCSTATE_EXILE=3 #js.PCSTATE_DIMENSION_SHIFT in FFvsTTR
js.PCSTATE_EXILE=PCSTATE_EXILE

EVENT_POWER_HIT=21
js.EVENT_POWER_HIT=EVENT_POWER_HIT

#heroes with AI_DestroyAI applied DONT flag as OC_CHARACTER! using this fixes it!
FFX_CHARACTER=OC_CHARACTER

#some weird numbers used by the FF engine... (FWIW, this number is also hex 0x40000000 or octal 010000000000 -Ep. 2006-06-15.)
FFX_POWER_CUSTOM=1073741824
builtinPowerIDs=(536870912,536870944,536870976,536871008,536871040,536871072,536871104,536871136,536871168,536871200)

#gender
FFX_GENDER_UNKNOWN=-1
FFX_GENDER_OPPOSITE=0
FFX_GENDER_MALE=1
FFX_GENDER_FEMALE=2
FFX_GENDER_ANIMAL=3
FFX_GENDER_ROBOT=4
FFX_GENDER_ALIEN=5
FFX_GENDER_GOOD=0
FFX_GENDER_EVIL=32

#FFX secondary states
SCSTATE_CRYSTALLISED=65536
SCSTATE_SHRUNK=32768
SCSTATE_VERTIGO=16384
SCSTATE_TRANSMUTED=8192
SCSTATE_CAGED=4096
SCSTATE_REINFORCED=2048
SCSTATE_DENSITY=65536

#collection of 'fake' attributes forced by script
ffxAttribsBase=[]
ffxAttribs=[]
ffxMeshes=[]
templates=[]
charTemplates=[]
throwObjects=[]

FFX_STATE_GAS=1
FFX_STATE_SAND=2
FFX_STATE_ICE=3
FFX_STATE_SPIN=4
FFX_STATE_ENERGYSHIELD=5
FFX_STATE_SHRUNK=6
FFX_STATE_TRANSMUTED=7
FFX_STATE_PUPPET=800
FFX_STATE_UNINITIALISED=100

FFX_GENDER_GOOD=0
FFX_GENDER_EVIL=32

# materials
# - Material 11 is neutral and weights the same as flesh (FFvsTTR's other neutral material), hence the repetition of "flesh" here.
# - Dark Matter (material 12): hidden material:
#   - defenseless against crushing, piercing, energy, fire, radiation, electricity, acid and cold
#   - weak against mental and mystical
# - Ectoplasm (material 13): hidden material:
#   - defenseless against crushing, piercing, energy, electricity and acid
#   - weak against mental and mystical
#   - normal against fire, radiation and cold
# - Setting Object_SetAttr(char, 'material' x) to a value above 13 tends (?) 
#   to make the character completely immune to these two damage types.
materialNames = ['flesh',
                 'metal',
                 'stone',
                 'rubber',
                 'fire',
                 'energy',
                 'air',
                 'wood',
                 'stone',
                 'frozen',
                 'cloth',
                 'flesh',
                 'darkmatter',
                 'ectoplasm',
                 ] 
materialFactors=(1.0, #flesh # flesh/neutral is both 0 and 11
                 3.0, #metal
                 2.5, #stone
                 1.25,#rubber 
                 0.75,#fire
                 1.0, #energy
                 0.1, #air
                 1.5, #wood
                 2.5, #stone
                 1.5, #frozen
                 1.0, #cloth
                 1.0, #flesh # flesh/neutral is both 0 and 11
                 1.0, #darkmatter hidden material
                 1.0, #ectoplasm hidden material
                 )


#Ep. 2006-08-29: DAT Files: read from start so the main dictionaries are always populated from the get go
#to limit errors/conditional code
datfiles.Campaign_ReadCharacters()
datfiles.Campaign_ReadPowers()
datfiles.Campaign_ReadObjects()

######################### INITIALISATION AND SYSTEM ###############################################################

def FFX_InitMission():
    mlogreader.MLOG_Init()  # stumpy 2005-10-13: bumped this ahead in the initialization queue
    initialise(0)

def FFX_InitBase():
    initialise(0)

def FFX_InitSkirmish(m25mode=0):
    #used to start up FFX
    mlogreader.MLOG_Init()  # stumpy 2005-10-13: bumped this ahead in the initialization queue
    Mission_SetAttr('_cs_mission_number',69)
    initialise(1)
    if m25mode==0:
        RegTimer('FFX_SkirmishCheck',1)

#call this from non M25 skirmish modes in the OnPostInit
def FFX_SetupSkirmish():
    import m25skirmish  # stumpy 2006-12-24: moved import here to prevent import during non-skirmish matches
    #Its a skirmish! cross the entire map to get to the heroes!
    m25ai.SetSkirmishModeOn()
    # initialize the AI
    m25ai.InitScripts()
    #launch FFX - initialising attributes and carriers etc
    FFX_InitSkirmish()
    # check for any characters that already exist on the map (put there by the map-maker)
    m25skirmish.SetupPreexisting()
    # put the heroes on the appropriate teams (or set them as neutral if watch mode)
    m25skirmish.SetupHeroTeam()
    # give the teams their orders
    m25skirmish.SetupGroups()
    #monitor new enemies (eg private armies, spawning, minions etc)
    RegTimer('SkirmishNewEnemyCheck',1)

#start up the Expansion Pack!
def initialise(skirmish=0):
    ###! prevents multiple initialisations when more than one .py file
    ###! or a file loaded more than once calls one of the initialising functions
    global FFX_INITIALIZED
    if FFX_INITIALIZED:
        return
    FFX_INITIALIZED=1
    if FFX_RULES_PUSHEP:
        Global_RegisterAttr('maxEnergyPoints',105)
    global FFX_SAVEGAME
    ff.RPG_ATTACK_BONUS_MIN = 0.0
    #try to tell difference between danger room and actual campaign missions
    Mission_SetAttr('ffxCampaign',0)
    if FFX_RULES_EXTRASTUN:
        ff.RPG_INTENS_STUN=0.4
    if FFX_RULES_NOPCAI:
        ff.AI_RESPOND_TEAM_DISTANCE=0
    if ( not skirmish ) and ( cshelper.getMission()<23 ): # Kuertee 2006-07-30 #cshelper.getMission () fails when "initialise (skirmish = 1)" is called
        for hero in cshelper.getAllHeroes():
            if Object_GetTemplate(hero)[:6]!='custom':
                Mission_SetAttr('ffxCampaign',1)
    if (cshelper.getMission()==23) | (cshelper.getMission()==24):
        Mission_SetAttr('ffxCampaign',1)
    print 'initialising FFX: skirmish=%d'%(skirmish)
    Mission_SetAttr('ffxSkirmish',skirmish)
    Mission_SetAttr('skirmish',skirmish)
    Mission_SetAttr('MPlayer',0)
    if Object_Exists('s1:h0'):
        Mission_SetAttr('MPlayer',1)
    MPStart()
    initialiseSpecialObjects()
    ff.RPG_RECHARGE_DEFEND=0.5
    ff.RPG_RECHARGE_FLY=0.5
    FFX_SAVEGAME=0
    #save the info on who was taken in a failsafe save-game safe manner
    storeHeroes()
    Mission_SetAttr('hiders',0)
    Mission_SetAttr('shapeReady',0)
    Mission_SetAttr('dummyCount',1)
    Mission_SetAttr('tigCount',1)
    Mission_SetAttr('formCount',1)
    Mission_SetAttr('pickupReged',0)
    Mission_SetAttr('shapechanged',0)
    Mission_SetAttr('teleportIndex',0)
    Mission_SetAttr("FFX_RULES_FROZENDAMAGE",FFX_RULES_FROZENDAMAGE)
    Mission_SetAttr("FFX_RULES_STASIS",FFX_RULES_STASIS)
    Mission_SetAttr("FFX_RULES_CLONECOMMANDS",FFX_RULES_CLONECOMMANDS)
    Mission_SetAttr("FFX_RULES_CAMPAIGN_M25AI",FFX_RULES_CAMPAIGN_M25AI)
    Mission_SetAttr('cloneKey',1000)
    FFX_InitStates()
    # stumpy 2006-12-29: make sure the game difficulty is set to what
    # it should be after a saved game load.
    Init_DifficultyCheck()
    #this is used to assign a unique ID to each character who appears
    Global_RegisterAttr('ffxID',-1)
    Global_RegisterAttr('ffxMPID',-1)
    Global_RegisterAttr('ffxCustomID',-1)
    Global_RegisterAttr('ffxArmed',0)
    Global_RegisterAttr('ai_critical',0)
    Global_RegisterAttr('templateSpeed',0)
    Global_RegisterAttr('templateStrength',0)
    Global_RegisterAttr('templateAgility',0)
    Global_RegisterAttr('lastX',-6000)
    Global_RegisterAttr('lastY',-6000)
    Mission_SetAttr('tpArrow',0)
    Mission_SetAttr('lightStep',0)
    Mission_SetAttr('ffxNextID',0)
    #used to indicate character states (both primary and secondary
    Global_RegisterAttr('ffxState',FFX_STATE_UNINITIALISED)
    #gender and alignment combined into one flag
    Global_RegisterAttr('gender',FFX_GENDER_UNKNOWN)
    #bases - these get modified by certain character states
    Global_RegisterAttr('baseStrength',-1)
    Global_RegisterAttr('baseSpeed',-1)
    #used by rally
    Global_RegisterAttr('attackBonus',1)
    Global_RegisterAttr('oldAttackBonus',1)
    Global_RegisterAttr('oldCharState',0)
    #m25 ai stuff
##    Global_RegisterAttr('team',0) # Ep. 2006-07-21: Obsolete; to be removed
##    Global_RegisterAttr('brawler',0) # Ep. 2006-08-28: Obsolete; to be removed
    Global_RegisterAttr('initialized',0)
    #mp carrier coding stuff
    Global_RegisterAttr('ffx1',0)
    Global_RegisterAttr('ffx2',0)
    Global_RegisterAttr('ID',-1)

    Mission_SetAttr('heroCount',len(cshelper.getAllHeroes()))
    Mission_SetAttr('random',50)

    RegTimer('callM25AI_InitScripts',0.8)
    RegTimer('initAttribs',1.5)
    fillTemplateList()

    #mod specific initialisation
    RegTimer('OnInitialiseLevelCB',0.1)

    #set the sunlight code going
    Mission_SetAttr('cosmeticSun',0)
    RegTimer('FFX_UpdateSun',1)

    #a couple of tiggots
    if Object_Exists('ffxtarget')==0:
        cshelper.spawn('ffxtarget','ffx_tiggot',(-6010,10,0))
    if Object_Exists('ffxgun')==0:
        cshelper.spawn('ffxgun','ffx_tiggot',(-6010,0,0))

    Mission_SetAttr('sscancount',0)

    #kick off the missile tracker
    RegTimer('projCheck',0.01)
    
    global FFX_Transformers
    FFX_Transformers = getBuiltinTransformers()


def isMP():
    try:
        return Mission_GetAttr('MPlayer')
    except:
        return 0

def FFX_InitStates():
    if Mission_GetAttr("FFX_RULES_FROZENDAMAGE"):
        ff.RPG_ICE_HP=10
    else:
        ff.RPG_ICE_HP=15

#formerly at the end of parseLogFile()
def callM25AI_InitScripts(event):
    #always do this - required for brawling code etc.
    if m25config.M25_USE_AI: # Kuertee 2006-07-30
        m25ai.InitScripts()



##################### SPECIAL OBJECT INITIALISATION ########################################

ffxteleporters=[]

def initialiseSpecialObjects():
    #teleporters
    if isMP()==0:
        Mission_CustomAction('CUSTOM_USE_TP','','ffx_teleporter','FFX_OnUseTP',4,0)
        Mission_CustomAction('CUSTOM_ACTIVATE','','switch','FFX_OnUseSwitch',4,0)
    else:
        index=1
        finished=0
        while(finished==0):
            tp='tp%d'%(index)
            if Object_Exists(tp):
                if Object_GetTemplate(tp)=='ffx_teleporter':
                    for hero in mpChars:
                        if Object_Exists(hero):
                            RegPowerHit(hero,tp,'OnTPMP',FFX_POWER_CUSTOM)
                index=index+1
            else:
                finished=1
    index=1
    finished=0
    while(finished==0):
        tp='tp%d'%(index)
        if Object_Exists(tp):
            if Object_GetTemplate(tp)=='ffx_teleporter':
                ffxteleporters.append(tp)
            index=index+1
        else:
            finished=1

    #explosions: find all tiggots and turn them into explosive things
    for obj in cshelper.getAll('ffx_tiggot'):
        power=obj[:len(obj)-4]
        try:
            #small test explosion
            Trigger_Explosion(obj,power,-2)
            name='o%s'%(obj)
            if Object_Exists(name)==0:
                cshelper.spawn(name,'portal_start_proxy',obj)
            RegTimer('ffxExplode',2,0,name,power)
            RegTimer('destroyTemp',0.5,0,obj)
        except:
            print '%s is not a valid explosion object'%(obj)

#switches:

def FFX_OnUseSwitch(target,char):
    AI_Animate(char,'drop_pole')
    obj=target[2:]
    if Object_Exists(obj):
        template=Object_GetTemplate(obj)
        Object_SetAttr(obj,'ffxArmed',1-Object_GetAttr(obj,'ffxArmed'))
        RegTimer('FFX_Switch%s'%(template),1,0,obj,char)
    else:
        template=obj[3:-4]
        if Template_Exists(template):
            RegTimer('FFX_Switch%s'%(template),1,0,obj,char)
        else:
            Mission_StatusText("switch is broken")

#weapons:

def AddWeaponCommands(char):
    for type in FFX_Weapons:
        Mission_CustomAction('CUSTOM_USEWEAPON',char,type[0],'FFX_OnUseWeapon',4,0)
    Mission_RemoveCustomAction('CUSTOM_DISARM',char,char)

def RemoveWeaponCommands(char):
    for type in FFX_Weapons:
        Mission_RemoveCustomAction('CUSTOM_USEWEAPON',char,type[0])
    Mission_CustomAction('CUSTOM_DISARM',char,char,'FFX_OnDropWeapon',4,0)

def getWeaponData(template):
    for type in FFX_Weapons:
        if type[0]==template:
            return type
    return FFX_Weapons[0]

def addWeaponPowers(weapon,char,update):
    for slot in weapon[2:]:
        fn='OnUse%s'%(slot[0])
        if slot[1]==0:
            addCommand(slot[0],char,fn,30,update)
        else:
            if update==0:
                Mission_CustomAction(slot[0],char,char,fn,4,0)

def removeWeaponPowers(weapon,char):
    for slot in weapon[2:]:
        if slot[1]==0:
            removeCommand(slot[0],char)
        else:
            Mission_RemoveCustomAction(slot[0],char,char)

def FFX_OnDropEvent(event):
    FFX_OnDropWeapon('',event.object)

def FFX_OnDropWeapon(target,char):
    if target!='':
        AI_Animate(char,'drop_pole')
    for type in FFX_Weapons:
        amstat='a%s'%(type[0])
        ammo=FFX_ObjectGetAttr(char,amstat)
        if ammo!=0:
            name=getDummyName()
            pos=Get_ObjectPos(char)
            cshelper.spawn(name,type[0],(pos[0]+10,pos[1]+10,pos[2]))
            Object_SetAttr(name,'maxEnergyPoints',ammo)
            #remove all commands from the weapon
            removeWeaponPowers(type,char)
            handle=int(FFX_ObjectGetAttr(char,'fx%s'%(type[0])))
            Object_StopEffect(char,handle)
            Object_SetAttr(char,'ffxArmed',0)
            AddWeaponCommands(char)
            FFX_ObjectSetAttr(char,amstat,0)
            #remove the sheathe command for weaponbearers
            Mission_RemoveCustomAction('CUSTOM_SHEATHE',char,char)

#called when the user picks up a weapon
def FFX_OnUseWeapon(target,char):
    template=Object_GetTemplate(target)
    RegTimer('OnWeaponPickupCB',0.1,0,char,template)
    data=getWeaponData(template)
    ammo=Object_GetAttr(target,'maxEnergyPoints')
    amstat='a%s'%(template)
    existingAmmo=FFX_ObjectGetAttr(char,amstat)
    #print out weapon info
    if cshelper.isPlaying()==0 and Object_GetAttr(target,'maxEnergyPoints')>0:
        Mission_StatusText('%s armed: shots=%d'%(template[4:],ammo))
    #if they dont have this type of weapon
    if existingAmmo==0:
        RegTimer('targetWeapon',1,0,char,template)
        AI_Animate(char,'pick_up_pole')
        handle=Object_PlayEffect(char,'effect_%s'%(template),'',FX_LOOP|FX_TRACK_OBJECT_FULL,0,data[1])
        FFX_ObjectSetAttr(char,'fx%s'%(template),handle)
        Object_Destroy(target)
        RegCharState(char,PCSTATE_STUNNED,'FFX_OnDropEvent',0)
        RegDeath(char,'FFX_OnDropEvent',0)
        #add a stash command if possible
        if hasAttribute(char,'weaponbearer'):
            stash=0
            if getByTemplate(char,FFX_WEAPONMASTER_CUSTOM,2)==template:
                if FFX_ObjectGetAttr(char,'shots1')==0:
                    stash=1
            if getByTemplate(char,FFX_WEAPONMASTER_CUSTOM,4)==template:
                if FFX_ObjectGetAttr(char,'shots2')==0:
                    stash=1
            if getByTemplate(char,FFX_WEAPONMASTER_CUSTOM,6)==template:
                if FFX_ObjectGetAttr(char,'shots3')==0:
                    stash=1
            if stash:
                Mission_CustomAction('CUSTOM_SHEATHE',char,char,'OnSheatheWeapon',5,0)
    FFX_ObjectSetAttr(char,amstat,existingAmmo+ammo)
    Object_SetAttr(char,'ffxArmed',1)
    RemoveWeaponCommands(char)

def targetWeapon(event):
    weapon=event.string
    data=getWeaponData(weapon)
    char=event.object
    ammo=FFX_ObjectGetAttr(char,'a%s'%(weapon))
    if ammo>0:
        addWeaponPowers(data,char,event.user)
        RegTimer('targetWeapon',5,1,char,weapon)

def OnUseWeapon(target,char,weapon,power='',ammocost=1):
    if power=='':
        power=weapon
    Trigger_Power(char,target,power,'do_%s'%(weapon))
    amstat='a%s'%(weapon)
    ammo=FFX_ObjectGetAttr(char,amstat)-ammocost
    FFX_ObjectSetAttr(char,amstat,ammo)
    ammoText(ammo)
    if ammo<=0:
        #remove SHEATHE commands for weaponbearers
        Mission_RemoveCustomAction('CUSTOM_SHEATHE',char,char)
        removeWeaponPowers(getWeaponData(weapon),char)
        RegTimer('useupWeapon',2,0,weapon,char)

def ammoText(ammo):
    if (ammo>5) & ((ammo%5)!=0):
        return
    if ammo>1:
        Mission_StatusText('%d shots remaining'%(ammo))
    elif ammo==1:
        Mission_StatusText('1 shot remaining')

def useupWeapon(event):
    weapon=event.object
    char=event.string
    handle=int(FFX_ObjectGetAttr(char,'fx%s'%(weapon)))
    Object_StopEffect(char,handle)
    Object_SetAttr(char,'ffxArmed',0)
    AddWeaponCommands(char)

def ffxExplode(event):
    if Object_Exists(event.object)==0:
        return
    if Object_IsAlive(event.object)==0:
        return
    if Object_GetAttr(event.object,'ffxArmed')==0:
        Trigger_Explosion(event.object,event.string)
    timer=2.5+(randint(1,100)*0.01)
    RegTimer('ffxExplode',timer,0,event.object,event.string)

def OnTPMP(event):
    char=event.string
    target=event.object
    if distanceSq(target,char)<3600:
        FFX_OnUseTP(target,char)

def FFX_OnUseTP(target,char):
    targetpos='pos_%s'%(target)
    try:
        cshelper.teleport(char,targetpos)
        Object_PlayEffect(char,'effect_microwave_teleport_in')
        Object_PlayEffect(target,'effect_microwave_teleport_out')
    except:
        Object_PlayEffect(target,'effect_ffx_magnetised')
        Mission_StatusText('teleporter broken! no marker called %s'%(targetpos))

##################### INITIALISATION AND UPDATE OF ALL ATTRIBUTES ##########################

def initAttribs(event):
    #identify which heros have the 'modified' attributes
    #do all tempforms first so we can fill in the default arrays
    for object in js.Mission_GetDynamicObjects():
        if (Object_GetClass(object) & FFX_CHARACTER):
            if (hasAttribute(object,'tempform')!=0) | (hasAttribute(object,'involuntaryform')!=0) | (hasAttribute(object,'ffqamalgam')!=0):
                object=initialiseChar(object)
    for object in js.Mission_GetDynamicObjects():
        if (Object_GetClass(object) & FFX_CHARACTER):
            if (hasAttribute(object,'tempform')==0) & (hasAttribute(object,'involuntaryform')==0) | (hasAttribute(object,'ffqamalgam')!=0):
                object=initialiseChar(object)
    RegTimer('updateAttribs5',0.5)
    RegTimer('updateFFX',1)
    RegTimer('updateStates',1.25)

# changed for character-specific attributes such as Latent Mutant
# Ep 2006-07-17:
# - added detection of built-in attributes; to disable, set ffxOnly=1
# - Note that the built-in "fast healing" (for example) and the scripted "fasthealing" aren't considered as one attribute to keep
#   overhead low, since the attribute is used constantly in the FFX update loops.
# Ep. 2006-08-19
# - An attribute used to be set for the whole template in parseLogFile; it's now set here at the character level only.
#   Consequently, the templateOnly parameter has been removed.
# Ep. 2006-09-10: Added check to prevent error on non-characters.
# For other attribute-related functions, see the CHARACTER ATTRIBUTES MANIPULATION section under FFQ.
def hasAttribute(char, attrib, ffxOnly=0):
    if FFX_ObjectGetAttr(char, 'attr_%s' % attrib) != 0:
        return 1
    elif not ffxOnly: #check for built-in attributes
        if Object_GetClass(char) & FFX_CHARACTER:
            return chardata.Character_HasAttribute(char, attrib)
    return 0


def FFX_Report(string):
    print string

##########################################################################
#
# Set up a few low-frequency, ongoing callbacks.
#
##########################################################################

# stumpy 2006-12-29: Set up some callbacks to re-set the game
# difficulty level after a saved game load (which the game often sets
# to "very easy") to what it should be. This won't work if the game is
# saved in the first five seconds of game play.

def Init_DifficultyCheck():
    regTimer('onDifficultyCheck',5)
    regSavedGameLoad('ffx.DifficultyReset',persistent=1)

def onDifficultyCheck(event):
    # assume that if the difficulty has changed in the last 10 seconds
    # that the user has changed it
    try:        # we've previously set it
        difflevel = Mission_GetAttr('RPG_GAME_DIFFICULTY')
    except:     # this is the first time
        difflevel = -1
    if difflevel != ff.RPG_GAME_DIFFICULTY:
        ##print 'ffx.onDifficultyCheck: user has set difficulty to %d' % ff.RPG_GAME_DIFFICULTY
        Mission_SetAttr('RPG_GAME_DIFFICULTY',ff.RPG_GAME_DIFFICULTY)
    regTimer('onDifficultyCheck',10)    # recheck every 10 seconds

def DifficultyReset(event):
    try:        # we've previously set it
        difflevel = Mission_GetAttr('RPG_GAME_DIFFICULTY')
        if difflevel != ff.RPG_GAME_DIFFICULTY:
            ##print 'ffx.DifficultyReset: resetting difficulty from %d to %d' % (ff.RPG_GAME_DIFFICULTY,difflevel)
            ff.RPG_GAME_DIFFICULTY = difflevel
    except:     # it wasn't set in the saved game we just loaded
        difflevel = -1
        ##print 'ffx.DifficultyReset: game difficulty not registered, leaving at %d' % (ff.RPG_GAME_DIFFICULTY,)
    

##########################################################################
#
# CHARACTER INITIALISATION
#
##########################################################################

# Replaces the hard-coded FFX_Transformers list of characters with the transform power or a flight FX -Ep. 2006-09-05
def getBuiltinTransformers():
    fxDat = datfiles.Campaign_ReadFX()
    charDat = datfiles.Campaign_ReadCharacters()
    datfiles.Campaign_ReadPowers()
    flyers = []
    transformers = []
    nonTransformers = []
    for k in fxDat.keys():
        if k[:7] == 'flying_':
            flyers.append(k[7:])
    for char in getAllCharacters(checkLiving = 1, lures = 0, specialCharacters = 0):
        found = 0
        template = FFX_GetTemplate(char)
        if template in transformers:
            break
        elif template in nonTransformers:
            break
        try:
            specials = chardata.Character_GetSpecialPowers(char)
            for special in specials:
                if special['SpecialType'] == datfiles.PT_SPECIAL_LAWORDER:
                    transformers.append(template)
                    found = 1
                    break
        except:
            print "getBuiltinTransformers non-fatal error:"
            print "    Unable to check if %s of template %s has a law/order type transformation power." % (char, template)
        if not found:
            for f in flyers:
                if f == template[ : len(f) ]:
                    transformers.append(template)
                    found = 1
                    break
        if not found:
            nonTransformers.append(char)
    return transformers


def transformCheck(event):
    char=event.object
    if not Object_Exists(char):
        return
    #print 'Transformcheck:%s,%d vs %d'%(char,FFX_ObjectGetAttr(char,'original'),Object_GetAttr(char,'complex'))
    if FFX_ObjectGetAttr(char,'original')!=Object_GetAttr(char,'complex'):
        Object_SetAttr(char,'ffxState',FFX_STATE_UNINITIALISED)
    elif event.user != 0:  #Ep. 2006-09-07: prevent skirmish FFX_Transformers from looping forever; reduced campaign frequency
        RegTimer('transformCheck',0.5,1,char)

def initialiseCharEv(event):
    initialiseChar(event.object)

def initialiseChar(obj):
    char=obj
    #m25ai.AIDisable(char)
    t=FFX_GetTemplate(char)
    force=0
    if FFX_ObjectGetAttr(char,'original',-1)!=-1:
        if FFX_ObjectGetAttr(char,'original')!=Object_GetAttr(char,'complex'):
            force=1
    if t!=Object_GetTemplate(char) or force==1:
        for temp in FFX_Transformers:
            if t==temp:
                print 'reconstructing transformer'
                char=getFormName()
                port=FFX_HasPortrait(obj)
                AI_DestroyHeroAI(obj)
                FFX_Spawn(char,temp,obj,0)
                FFX_AdjustPortrait(char,port)
                Object_SetAttr(char,'health',Object_GetAttr(obj,'health'))
                Object_SetAttr(char,'energyPoints',Object_GetAttr(obj,'energyPoints'))
                Object_SetAttr(char,'heroPoints',Object_GetAttr(obj,'heroPoints'))
                if usingM25AI ():#Kuertee 2006-07-30 check if m25 is used first
                    m25ai.TransferAI(char,obj)  #make sure the AI gets transfered to the new version!
                Object_Destroy(obj)
                FFX_ObjectSetAttr(char,'original',Object_GetAttr(char,'complex'))
                RegTimer('transformCheck',1,0,char)
                Mission_SelectHero(char)
                RegTimer('initialiseCharEv',0.05,0,char)
                return char #some functions require a return of char
    else:
        #in campaign mode - this keeps checking law and order to see if a transform has happened
        if Mission_GetAttr('ffxCampaign') == 1: #Ep. 2006-0907: prevents the code from running forever in Rumble Room mode
            for temp in FFX_Transformers:
                if t==temp:
                    print 'transformer detected:%s,%s'%(t,char)
                    FFX_ObjectSetAttr(char,'original',Object_GetAttr(char,'complex'))
                    RegTimer('transformCheck',1,1,char) #Ep. 2006-09-07: identifies campaign-related calls with event.user=1
                    break # stumpy 2006-09-05
    Object_SetAttr(char,'ffxState',0)
    Object_SetAttr(char,'baseStrength',Object_GetAttr(char,'strength'))
    Object_SetAttr(char,'baseSpeed',Object_GetAttr(char,'speed'))
    FFX_ObjectSetAttr(char,'baseEnergy',Object_GetAttr(char,'energy'))
    FFX_ObjectSetAttr(char,'baseMat',Object_GetAttr(char,'material')) ###!
    FFX_ObjectSetAttr(char,'baseMass',Object_GetAttr(char,'mass'))
    FFX_ObjectSetAttr(char,'baseMinForce',Object_GetAttr(char,'minForce'))
    Object_SetAttr(char,'templateSpeed',Object_GetAttr(char,'speed'))
    Object_SetAttr(char,'templateStrength',Object_GetAttr(char,'strength'))
    Object_SetAttr(char,'templateAgility',Object_GetAttr(char,'agility'))
    cshelper.addAttr('ffxNextID',1)
    Object_SetAttr(char,'ffxID',Mission_GetAttr('ffxNextID'))
    if Object_GetTemplate(char)=='ffx_tiggot':
        return char
    RegTimer('initAttribsEvent',1,0,char)
    RegTimer('OnInitialiseCharCB',1,0,char)
    template=Object_GetTemplate(char)
    if (template[:6]=='custom') & (template[:10]!='custom_vil'):
        templateNumber=string.atoi(template[16:])
        Mission_SetAttr('%s_ID'%(FFX_GetTemplate(char)),templateNumber)
    initCarriers(char)
    setGender(char)
    #print '%s has gender %d'%(char,Object_GetAttr(char,'gender'))
    initFX(char)
    if isMP()==0:
        if Object_GetClass(char)&OC_CONTROLLABLE:
            AddWeaponCommands(char)
    #m25ai.AIEnable(char)
    if m25ai.InSkirmishMode():
        m25ai.SetupCharacter(char)
    CharacterInitializedEvent(char) # throws an event for new characters - Ep. 2006-07-06  # stumpy 20060925: renamed
    return char

def initFX(char):
    temp=FFX_GetTemplate(char)
    for set in FFX_CUSTOM_FX:
        if set[0]==temp:
            fx=set[1]
            flags=FX_LOOP|FX_TRACK_OBJECT_POS
            if set[2]=='rotate':
                flags=FX_LOOP|FX_TRACK_OBJECT_FULL
            node=set[3]
            Object_PlayEffect(char,fx,'',flags,0,node)

def initAttribsForChar(char,update=0):
    #kuertee 2006-07-30 - use datfiles to initialise ffx-attributes rather than using ff.log
    #Ep. 2006-08-24: Made code more modular, added unbranded error code
    #Stumpy 2006-08-25: Improved call to DAT Files for efficiency and campaign compatibility
    ffxTemplate = FFX_GetTemplate (char, verbose=1)
    print 'initAttribsForChar: working on %s (%s)' % (char,ffxTemplate)
    if ffxTemplate[:7] == 'custom_':
        print "initAttribsForChar() fatal error:"
        print "    can't initialise FFX for unbranded character %s (%s)" % (char, ffxTemplate)
    else:
        Object_SetAttr (char, "ffxState", 0)
        character = chardata.GetCharacterData(char)
        # stumpy 2006-10-01: don't initialize un-bought attributes
        for attribute in character['characterAttributes'][:character['activeAttributes']]:
            print 'initAttribsForChar (%s): looking at attribute %s' % (ffxTemplate,attribute)
            done = None
            for multi in ffxMultis:
                if multi [0] == attribute:
                    done = 1
                    for component in multi [1:]:
                        execInitAttrib(char, component, update, combo=attribute, multi=multi)
            if not done:
                ffxAttribute = None
                if not isBuiltinAttribute(attribute): # Ep. 2006-08-03 - prevent built-in attributes from being initialised
                    try: ffxAttribute = eval ("init" + attribute)
                    except: pass
                    if ffxAttribute:
                        execInitAttrib(char, attribute, update)
    #delay this so it knows what attributes a character has
    #M25 updated May 10, 2005
    if update==0:
        if usingM25AI():
            m25ai.SetDefaultTactics(char)
        #end update


#manage error messages and call execInitAttrib() -Ep.2006-08-24
def execInitAttrib(char, attribute, update=0, combo='', multi=[]):
    init = "init%s('%s',%d)"% (attribute, char, update)
    if combo != '':
        statusMsg = "execInitAttrib: init %s attribute inside %s combo" % (attribute, multi)
        errorMsg = 'execInitAttrib: ERROR in initialising attribute %s inside combo %s' % (attribute, combo)
    else:
        statusMsg = "execInitAttrib: init %s attribute" % attribute
        errorMsg = 'execInitAttrib: ERROR in initialising attribute %s' % attribute
    print statusMsg
    print "    on %s of template %s (%s)" % (char, Object_GetTemplate(char), FFX_GetTemplate(char))
    try:
        execInitAttrib2(char, attribute, init)
    except:
        print errorMsg
        Mission_StatusText(errorMsg)
        raise

#initialise and register the FFX attribute -Ep.2006-08-24
def execInitAttrib2(char, attribute, init):
    exec init
    FFX_ObjectSetAttr(char, 'attr_%s' % attribute, 1) #used by hasAttribute()
    attrs = missionobjvar.Object_GetVar(char, 'attrs_', []) #used by getAttributes()
    attrs.extend([attribute])
    missionobjvar.Object_SetVar(char, 'attrs_', attrs)

def initAttribsEvent(event):
    if Object_Exists(event.object): # stumpy 20060919: check that this wasn't some transient object that's now gone. (saw this happening in 06a_redsun)
        initAttribsForChar(event.object,event.user)

def usingM25AI():
    if m25config.M25_USE_AI: # kuertee 2006-07-30 - set m25config.M25_USE_AI to 0 to turn m25 ai completely off
        return Mission_GetAttr('ffxCampaign')==0 or Mission_GetAttr("FFX_RULES_CAMPAIGN_M25AI")!=0

def FFX_GetTemplate(char, verbose=0):
	return chardata.GetCharacterData(char).get('charName')

#strips off '_mp' at the end
def FFX_GetTemplateMP(char):
    temp=FFX_GetTemplate(char)
    if temp[-3:]=='_mp':
        temp=temp[:-3]
    return temp

def testtemp(char):
    id=storeTemplate(char)
    t1=Object_GetTemplate(char)
    t2=retrieveTemplate(id)
    print 'char=%s temp=%s ->ID=%d->temp%s'%(char,t1,id,t2)

#given a name returns a unique integer ID
def storeTemplate(char):
    index=Object_GetAttr(char,'complex')
    temp=Object_GetTemplate(char)
    #deal with specials like squadX_templateY and custom_template_XX
    if temp[:5]=='squad':
        squad=string.atoi(temp[5])
        num=string.atoi(temp[15])
        index=-1000-squad*16-num
    if temp[:16]=='custom_template_':
        index=-string.atoi(temp[16:])
    if temp[:11]=='custom_vil_':
        index=-2000-string.atoi(temp[11:])
    return index

#given an ID form store template, returns the original template name
def retrieveTemplate(id):
    complex=int(id)
    if complex>1000:
        return ffxIDs[complex-1001][0]
    elif complex>0:
        return ffxbuiltins[complex-1]
    elif complex>-1000:
        return 'custom_template_%d'%(-complex)
    elif complex>-2000:
        num=(-1000-complex)&15
        squad=(-1000-complex)&240
        return 'squad%d_template%d'%(squad,num)
    else:
        return 'custom_vil_%d'%(-2000-complex)

customTemplates=[]

def makeTemplateForCustom(name):
    #check our list first
    for temp in ffx.customTemplates:
        if temp==name:
            return 1
    #do any exist at the moment?
    if len(cshelper.getAll(name))>0:
        ffx.customTemplates.append(name)
        return 1
    #no? try spawning one then
    js.new(name,(3000,3000,0))
    res=0
    for obj in cshelper.getAll(name):
        if res==0:
            ffx.customTemplates.append(name)
            res=1
        Object_Destroy(obj)
    return res


# Given a character template name, returns the Rumble Room "custom_template_n" name if present in the current mission.
# Returns None if not found.
# Added FFX 3.3 pre-alpha - Ep.
def getCustomTemplateName(realTemplateName):
    for object in Mission_GetDynamicObjects():
        if Object_GetTemplate(object)[0:7] == 'custom_':
            if FFX_GetTemplate(object) == realTemplateName:
                return Object_GetTemplate(object)
    return None


######################################################################
#
# MAIN UPDATE LOOP
#
######################################################################
def updateFFX(event):
    #Mission_StatusText("UpdateFFX")
    global FFX_SAVEGAME
    global FFX_Transformers
    #deal with save games and restoration
    restoreMimics=0
    if FFX_SAVEGAME!=0:
        #STRANGERS# shapeChangerSets.append(['thespider','thespider_big',])
        #if cshelper.getMission()==18:
        #    addAttributeToTemplate('thespider','shapeshifter')
        print 'updateFFX: mid level save game detected'
        restoreMimics=1
        FFX_Transformers = getBuiltinTransformers()
        #recover the list of attributes immediately
        #parseLogFile(event) #Ep. 2006-08-18: parseLogFile) isn't used anymore
        FFX_SAVEGAME=0
    RegTimer('updateFFX',1)
    if cshelper.isPlaying():
        return

    redoShapes=0
    slaves=[]
    masters=[]
    causes=[]
    effects=[]

    for obj in Mission_GetDynamicObjects():
        if ((Object_GetClass(obj) & FFX_CHARACTER)!=0):

            if (Object_GetAttr(obj,'ffxState')==FFX_STATE_UNINITIALISED):
                #parseLogFile(event) #Ep. 2006-08-18: parseLogFile) isn't used anymore
                #print 'initialising %s'%(obj)
                obj=initialiseChar(obj)
            else:
                if restoreMimics:
                    oclass=Object_GetClass(obj)
                    if ((oclass&OC_CONTROLLABLE)!=0) & ((oclass&(OC_VILLIAN|OC_MINION|OC_POLICE|OC_CIVILIAN))!=0):
                        print 'updateFFX: restoring status to mimicked NPC type:%s'%(obj)
                        AI_MakeIntoHero(obj)
                        RegTimer('OnMimicMinion1',0.2,Object_GetAttr(obj,'health'),obj)

            #update states for the character
            FFX_UpdateStates(obj)

            #apply damage to frozen characters if appropriate
            if Mission_GetAttr("FFX_RULES_FROZENDAMAGE"):
                if Object_GetPrimaryState(obj)==PCSTATE_FROZEN:
                    damage=randint(0,2)
                    if isIce(obj): ###!Ep 2006-02-05: Characters made of ice material don't get damaged, but healed; of course, getting them frozen is hard anyway
                        damage = randint(-1, 0)
                    nhp=Object_GetAttr(obj,'health')-damage
                    FFX_ApplyDamage(obj,damage)
                    if nhp<=0:
                        RegTimer('OnDie',3,0,obj)

            #check the stasis thing:
            if Mission_GetAttr("FFX_RULES_STASIS"):
                if Object_GetPrimaryState(obj)==PCSTATE_STATIC or Object_GetPrimaryState(obj)==PCSTATE_FROZEN:
                    savingThrow=randint(6,9)
                    if Object_GetAttr(obj,'strength')>=savingThrow:
                        Object_SetPrimaryState(obj,PCSTATE_STATIC,0,REMOVE_STATE)
                        RegTimer('breakFree',0.1,0,obj)

            #deal with gravitroned characters here for now
            str=Object_GetAttr(obj,'strength')
            bStr=Object_GetAttr(obj,'baseStrength')
            if str<bStr:
               if str<0:
                    damage=-(str)
                    Object_SetAttr(obj,'health',Object_GetAttr(obj,'health')-damage)
                    if Object_GetAttr(obj,'health')<1:
                        Object_SetAttr(obj,'health',1)
                        Trigger_Damage(obj,2)
               str=str+0.33
               Object_SetAttr(obj,'strength',str)

            #sensitive characters can see at all times
            if FFX_HasPortrait(obj):
                if hasAttribute(obj,'sensitive'):
                    Mission_SetDetectionEnabled(0)
            #deal with characters in the various different states
            state=Object_GetAttr(obj,'ffxState')
            metamorphic=hasAttribute(obj,'metamorphic')
            if hasAttribute(obj,'gaseousform') | metamorphic:
                updateGaseousForm(obj)
            if hasAttribute(obj,'sandstorm') | metamorphic:
                updateSandstorm(obj)
            if hasAttribute(obj,'icecloud') | metamorphic:
                updateIceCloud(obj)
            #symbiosis/interference check ###!Ep 3.2a1 2006-02-05
            #if hasAttribute(obj,'symbiote'):
                #symbiotes.append(obj)
            #if hasAttribute(obj,'parasite'):
                #parasites.append(obj)

    #check the clone commands thing
    if Mission_GetAttr("FFX_RULES_CLONECOMMANDS"):
        for hero in cshelper.getAllHeroes():
            clones=FindControllableClones(hero)
            cmdstate=FFX_ObjectGetAttr(hero,'CUSTOM_TARGETCLONES')
            if len(clones)>0:
                if cmdstate==0:
                    Mission_CustomAction('CUSTOM_GATHERCLONES',hero,hero,'OnCloneGather',5,0)
                    Mission_CustomAction('have idle clones follow',hero,hero,'OnCloneSetFollowMode',5000,0)
                addCommand('CUSTOM_TARGETCLONES',hero,'OnCloneTarget',30,cmdstate)
            elif cmdstate:
                removeCommand('CUSTOM_TARGETCLONES',hero)
                Mission_RemoveCustomAction('CUSTOM_GATHERCLONES',hero,hero)

    updatePuppets()

    #initialises shapechanger-tempform match up in casual danger room mode or campaign
    Mission_SetAttr('shapeReady',1)
    return


def breakFree(event):
    FFX_Animate(event.object,'swing_pole')

def FFX_Animate(char,anim):
    try:
        name=getDummyName()
        cshelper.spawn(name,'portal_start_proxy',char)
        RegTimer('destroyTemp',3,0,name)
        Trigger_Power(char,name,anim,'')
    except:
        AI_Animate(char,anim)

def isReal(char):
    if Object_GetPrimaryState(char)==PCSTATE_EXILE:
        return 0
    if Object_GetSecondaryStates(char)&SCSTATE_DISPLACE_IMAGE:
        return 0
    return 1

#5 second intervals
def updateAttribs5(event):
    RegTimer('updateAttribs5',5)
    if cshelper.isPlaying():
        return
    for obj in Mission_GetDynamicObjects():
        if Object_GetClass(obj) & FFX_CHARACTER:
            #hack to get correct values for health/death
#            if Object_GetPrimaryState(obj)==15:
#                Object_SetAttr(obj,'health',0)
            #custom commands that need refreshing for new characters on the scene
            if Object_GetClass(obj) & OC_CONTROLLABLE:
            ##########################################
            # this stuff can be moved to timers from init functions
            ##########################################
                #checks for new objects to add commands to basically
                if hasAttribute(obj,'guardianm'):
                    initguardianm(obj,1) 
                if hasAttribute(obj,'guardianp'):
                    initguardianp(obj,1)
                if hasAttribute(obj,'telekinetic'):
                    inittelekinetic(obj,1)
                if hasAttribute(obj,'supertk'):
                    initsupertk(obj,1)
                if hasAttribute(obj,'earthcontrol'):
                    initearthcontrol(obj,1)
                if hasAttribute(obj,'magnetic'):
                    initmagnetic(obj,1)
                if hasAttribute(obj,'earthcontrol2'):
                    initearthcontrol2(obj,1)
                if hasAttribute(obj,'magnetic2'):
                    initmagnetic2(obj,1)
                if hasAttribute(obj,'scary'):
                    initscary(obj)
            #deal with attributes that have a regular chance of doing something
            if Object_IsAlive(obj):
                if hasAttribute(obj,'presence'):
                    updatePresence(obj)
                if hasAttribute(obj,'scary'):
                    updateScary(obj)
                if hasAttribute(obj,'vunstablemols'):
                    if randint(1,2)==1:
                        Object_SetAttr(obj,'material',randint(1,10))
                if isReal(obj):
                    if hasAttribute(obj,'pheremones'):
                        updatePheremones(obj)
                    if hasAttribute(obj,'biohazard'):
                        Trigger_Explosion(obj,getByTemplate(obj,FFX_BIOHAZARD_CUSTOM,2))
                    if hasAttribute(obj,'frostbite') | ((Object_GetTemplate(obj)=='chaosgirl') & (Object_GetAttr(obj,'material')==9)):
                        Trigger_Explosion(obj,getByTemplate(obj,FFX_FROSTBITE_CUSTOM,2))
                    if hasAttribute(obj,'overheated') | ((Object_GetTemplate(obj)=='chaosgirl') & (Object_GetAttr(obj,'material')==4)):
                        if FFX_ObjectGetAttr('mission','heatoff')==0:
                            Trigger_Explosion(obj,getByTemplate(obj,FFX_OVERHEATED_CUSTOM,2))
                    if hasAttribute(obj,'shortcirc'):
                        Trigger_Explosion(obj,getByTemplate(obj,FFX_SHORTCIRCUITED_CUSTOM,2))
            #########################################################
            # end - this stuff can be moved to timers from init functions (and then this function can go completely)
            #########################################################

########################## CLONE COMMAND STUFF ####################################################

# stumpy 2007-12-12: *sigh* another attempt to get the clone commands to work
# I am *just* trying to return a list of friendly clones of OC_CONTROLLABLE characters
def FindControllableClones(char):
    clones=[]
    temp=Object_GetTemplate(char)
    baddies = getAllBaddies()
    heroes = getAllHeroes()
    SameTemplate = cshelper.getAll(temp)
    if len(SameTemplate)==0:
        return []
    originals = filter(isHero,SameTemplate) # grab the OC_CONTROLLABLEs
    if len(originals) == 0: # no originals, rest should be clones
        return SameTemplate
    else:
        clones = SameTemplate
        for o in originals:
            clones.remove(o)
    return filter(lambda c: Object_GetClass(c)&OC_MINION == 0, clones)

def getPoliceClones(char):
    clones=[]
    temp=Object_GetTemplate(char)
    for clone in cshelper.getAll(temp):
        if Object_GetClass(clone)&OC_POLICE:
            if m25ai.GetTeam(clone)==m25ai.TEAM_GOODGUYS:
                clones.append(clone)
    return clones

def OnCloneTarget(target,char):
    clones=FindControllableClones(char)
    for clone in clones:
        cshelper.clearGoals(clone)
        cshelper.addKillGoal(clone,target,PRI_HI)

def OnCloneGather(dummy,char):
    clones=FindControllableClones(char)
    for clone in clones:
        cshelper.clearGoals(clone)
        cshelper.addMoveGoal(clone,char,PRI_HI)

def OnCloneSetFollowMode(dummy,char):   # stumpy, have clones follow when they're not doing something else
    clones=FindControllableClones(char)
    if not FFX_ObjectGetAttr(char,'clonesfollowing'):
        Mission_RemoveCustomAction('have idle clones follow',char)
        Mission_CustomAction('cancel clone following',char,char,'OnCloneCancelFollowMode',5000,0)
        FFX_ObjectSetAttr(char,'clonesfollowing',1)
    for clone in clones:
        ##print 'OnCloneSetFollowMode: adding follow %s goal for %s' % (char,clone)
        cshelper.addMoveGoal(clone,char,PRI_ZERO-1,'CheckCloneFollowing',Object_GetAttr(char,'ffxID'))

def CheckCloneFollowing(event):
    clone = event.object
    master = findCharByID(int(event.user))
    if FFX_ObjectGetAttr(master,'clonesfollowing'):
        if distanceSq(clone,master) < 100:
            RegTimer('CheckCloneFollowing',3,event.user,clone)
        else:
            cshelper.addMoveGoal(clone,master,PRI_ZERO-1,'CheckCloneFollowing',event.user)

def OnCloneCancelFollowMode(dummy,char):   # stumpy: don't have unoccupided clones follow
    clones=FindControllableClones(char)
    if FFX_ObjectGetAttr(char,'clonesfollowing'):
        Mission_RemoveCustomAction('cancel clone following',char)
        Mission_CustomAction('have idle clones follow',char,char,'OnCloneSetFollowMode',5000,0)
        FFX_ObjectSetAttr(char,'clonesfollowing',0)
    for clone in clones:
        print 'OnCloneCancelFollowMode: clearing goals for %s' % clone
        cshelper.clearGoals(clone)

########################## SPECIAL CHARACTER STATE CODE ###########################################

def FFX_UpdateStates(char):
    if char == None: ###! for law/order transform
        return
    if Object_Exists(char)==0:
        return
    state=Object_GetPrimaryState(char)|(Object_GetSecondaryStates(char)/256)
    if densityaltered(char):
        state=state|256
    Object_SetAttr(char,'oldCharState',state)
    Object_SetAttr(char,'oldAttackBonus',Object_GetAttr(char,'attackBonus'))

def FFX_GotState(char,state,override=0):
    if state<16:
        return (Object_GetPrimaryState(char)==state) & ((int(Object_GetAttr(char,'oldCharState'))&15)!=state)
    elif state==SCSTATE_DENSITY:
        return (densityaltered(char)!=0) & ((int(Object_GetAttr(char,'oldCharState'))&256)==0)
    else:
        return ((Object_GetSecondaryStates(char)&state)!=0) & (override!=0 or (( (256*int(Object_GetAttr(char,'oldCharState')))&state)==0))

def densityaltered(char):
    if (Object_GetSecondaryStates(char)&SCSTATE_SPEED_DECREASED)==0:
        return Object_GetAttr(char,'speed')<(Object_GetAttr(char,'baseSpeed')/2)

mpFrom=["stun","hypnosis","rage","blind",
"stasis","frozen","blank","exile",
"hex","panic","powernull","density",
"energise","rally","energysurge",
"empathy","displace","cloak","possession"]
mpTo=["crystallise","magnetise","vertigo","firecage","shrink","transmute","gravityincrease","gravityreverse","pull","lifedrain",
"mentaldamage","taunt","teleport","phase","shield","cloak","normalise","heal","accelerate","hex","hypnosis",
"rage","blind","density","blank","exile","panic","powernull","acidburn","irradiate","stasis","frozen",
"leadership","breach","castle","remoteempathy","knockoutgas","bleeding","bodysnatch","forcefield"] ###! new state swaps added

def getCarrierString(code):
    code1=code&31
    code2=code/32
    return '%sto%s'%(mpFrom[code1],mpTo[code2])

def initCarriers(char):
    template=FFX_GetTemplate(char)
    #print 'initCarriers on %s(%s)'%(char,template)
    index=0

    mpType=Mission_GetAttr('ffxMPType')

    #client -do nothing but get events from the host
    if mpType==2:
        return

    #host - register attacks from character attributes
    if mpType==1:
        ffx1=int(Object_GetAttr(char,'ffx1'))
        if ffx1!=0:
            #print '%s:%s:'%(char,template)
            ffx1a=ffx1&2047
            ffx2a=ffx1/2048
            if ffx1a!=0:
                fn=getCarrierString(ffx1a)
                #print fn
                RegTimer('carrier',0.1,FFX_POWER_CUSTOM,char,fn)
            if ffx2a!=0:
                fn=getCarrierString(ffx2a)
                #print fn
                RegTimer('carrier',0.1,FFX_POWER_CUSTOM,char,fn)
        ffx2=int(Object_GetAttr(char,'ffx2'))
        if ffx2!=0:
            ffx1a=ffx2&2047
            ffx2a=ffx2/2048
            if ffx1a!=0:
                fn=getCarrierString(ffx1a)
                #print fn
                RegTimer('carrier',0.1,FFX_POWER_CUSTOM,char,fn)
            if ffx2a!=0:
                fn=getCarrierString(ffx2a)
                #print fn
                RegTimer('carrier',0.1,FFX_POWER_CUSTOM,char,fn)
        return

    #not multiplayer - so use customisation data on local machine
    #m25 modified May 20, 2005
    cdata = GetCharacterData(char)
    #print template
    null=0
    for entry in FFX_CARRIERS:
        if entry[0]==template:
            powerName=entry[3]
            if ( powerName != 'all' ) and ( cdata['powerLevels'][powerName] < 1 ):
                continue    # skip powers the character hasn't bought yet
            if (powerName=='all') or ((Mission_GetAttr('ffxSkirmish')!=0) and (Object_GetTemplate(char)[:6]=='custom')) and (Object_GetClass(char)&OC_CONTROLLABLE):
                fn='%sto%s'%(entry[1],entry[2])
                RegTimer('carrier',0.1,FFX_POWER_CUSTOM,char,fn)
                #print 'registering %s(%s) attacks with %s'%(template,Object_GetTemplate(char),fn)
            else:
                temppowerName = m25custompowers.GetPowerName(char,powerName,default=powerName)
                powerID=0
                for set in ffxpowerids.powerIDs:
                    if set[0]==temppowerName:
                        powerID=set[2]
                fn='%sto%s'%(entry[1],entry[2])
                #print '%s:%s,powerID=%d'%(fn,temppowerName,powerID)
                RegTimer('carrier',0.1,powerID,char,fn)
                #print 'registering %s(%s) attacks with %s'%(template,Object_GetTemplate(char),fn)

#                print 'Using power:%s %s'%(char,powerName)
#                #compose a number made up of the characters unique ID plus the index into the array
#                user=index+1024*int(Object_GetAttr(char,'ffxID'))
#                temppowerName = m25custompowers.GetPowerName(char,powerName,default=powerName)
#                print 'powername = ' + `temppowerName`
#                if temppowerName != None:
#                    y=30+FFX_ObjectGetAttr('gun','y',6000)
#                    FFX_ObjectSetAttr('gun','y',y)
#                    gun=getDummyName()
#                    target=getDummyName()
#                    spawn(gun,'ffx_tiggot',(-10,y,0))
#                    spawn(target,'ger_sandbags',(0,y,0))
#                    Trigger_Power(gun,target,temppowerName,'carrierBuiltIn',0,Get_ObjectPos(target),user)
#                    RegTimer('destroyTemp',10,0,gun)
#                    RegTimer('destroyTemp',10,0,target)
#                null=1
        #end m25 modified May 20, 2005
        index=index+1




def carrierBuiltIn(event):
    #print 'carrierBuiltIn'
    user=int(event.user)
    ID=user/1024
    char=findCharByID(ID)
    entry=FFX_CARRIERS[user&1023]
    #print 'calling carrierbuiltIn for %s(%d %d)'%(char,event.data,event.float)
    RegTimer('carrier',0.1,event.float,char,'%sto%s'%(entry[1],entry[2]))
    #print '%sto%s:%d'%(entry[1],entry[2],event.float)

def carrier(event):
    char=event.object
    fn=event.string
#    print event.user
    #print 'carrier ' + char + ' ' + fn
    if fn[:7]=='empathy':
        RegTimer('empathyCheck',1,0,char,fn,1)
    elif fn[:8]=='displace':
        RegTimer('displaceCheck',1,0,char,fn,1)
    elif fn[:5]=='cloak':
        RegTimer('cloakCheckA',1,0,char,fn,1)
    else:
        powerID=event.user
#        print 'carrier:powerID(%s,%s)=%d'%(char,fn,powerID)
        regPowerAgainstChars(char,fn,powerID,0)
        RegTimer('carrierupdate',2,powerID,char,fn)

def carrierupdate(event):
    char=event.object
    fn=event.string
#    print event.user
    #print 'carrier ' + char + ' ' + fn
    if fn[:7]=='empathy':
        RegTimer('empathyCheck',1,0,char,fn,1)
    elif fn[:8]=='displace':
        RegTimer('displaceCheck',1,0,char,fn,1)
    elif fn[:5]=='cloak':
        RegTimer('cloakCheckA',1,0,char,fn,1)
    else:
        powerID=event.user
#        print 'carrier:powerID(%s,%s)=%d'%(char,fn,powerID)
        regPowerAgainstChars(char,fn,powerID,1)
        RegTimer('carrierupdate',2,powerID,char,fn)

def empathyCheck(event):
    char=event.object
    if not Object_Exists(char): ###!Ep 2006-03-07
        return
    count=FFX_ObjectGetAttr(char,'area1',0)
    if count>0:
        count=count-1
        FFX_ObjectSetAttr(char,'area1',count)
    if Object_GetSecondaryStates(char)&SCSTATE_EMPATHY:
        if count==0:
            RegTimer(event.string,0.01,0,char)
            FFX_ObjectSetAttr(char,'area1',30)
        Object_SetSecondaryState(char,SCSTATE_EMPATHY,0,REMOVE_STATE)

def displaceCheck(event):
    char=event.object
    if not Object_Exists(char): ###!Ep 2006-03-07
        return
    count=FFX_ObjectGetAttr(char,'area2',0)
    if count>0:
        count=count-1
        FFX_ObjectSetAttr(char,'area2',count)
    if Object_GetSecondaryStates(char)&SCSTATE_DISPLACE_IMAGE:
        if (FFX_ObjectGetAttr(char,'phased')==0):
            if (count==0):
                RegTimer(event.string,0.01,2,char,'',0)
                FFX_ObjectSetAttr(char,'area2',30)
            Object_SetSecondaryState(char,SCSTATE_DISPLACE_IMAGE,0,REMOVE_STATE)
    else:
        FFX_ObjectSetAttr(char,'phased',0)

def cloakCheckA(event):
    char=event.object
    if not Object_Exists(char): ###!Ep 2006-02-05
        return
    count=FFX_ObjectGetAttr(char,'area3',0)
    if count>0:
        count=count-1
        FFX_ObjectSetAttr(char,'area3',count)
    if Object_GetSecondaryStates(char)&SCSTATE_INVISIBLE:
        if (FFX_ObjectGetAttr(char,'cloaked')==0):
            if (count==0):
               RegTimer(event.string,0.01,1,char)
               FFX_ObjectSetAttr(char,'area3',30)
            Object_SetSecondaryState(char,SCSTATE_INVISIBLE,0,REMOVE_STATE)
    else:
        FFX_ObjectSetAttr(char,'cloaked',0)

#####################################################################
#area attacks triggered by empathy or blind justice
#####################################################################

def empathytocrystallise(event):
    char=event.object
    Trigger_Explosion(char,'ffx_hexarea')
    RegTimer('crystalCheck',1,stateintensity[int(event.user)],char)

def empathytovertigo(event):
    char=event.object
    Trigger_Explosion(char,'ffx_blankarea')
    RegTimer('vertigoCheck',1,stateintensity[int(event.user)],char)

def empathytofirecage(event):
    char=event.object
    Trigger_Explosion(char,'ffx_hexarea')
    RegTimer('firecageCheck',1,stateintensity[int(event.user)],char)

def empathytoshrink(event):
    char=event.object
    Trigger_Explosion(char,'ffx_hexarea')
    RegTimer('shrinkCheck',1,stateintensity[int(event.user)],char)

def empathytotransmute(event):
    char=event.object
    Trigger_Explosion(char,'ffx_hexarea')
    RegTimer('transmuteCheck',1,stateintensity[int(event.user)],char)

def empathytogravityincrease(event):
    char=event.object
    Trigger_Explosion(char,'ffx_hexarea')
    RegTimer('gravityCheck',1,stateintensity[int(event.user)],char)

def empathytopull(event):
    char=event.object
    pullCheck(char,stateintensity[int(event.user)])

def empathytomagnetpull(event):
    char=event.object
    pullCheck(char,stateintensity[int(event.user)*3],1)

def densitytomagnetthrow(event):
    char=event.object
    source=event.string
    if (Object_GetClass(char)&FFX_CHARACTER)==0:
        if Object_GetAttr(char,'physical'):
            subtype = m25ai.FindTacticType(char, 'subtype')
            if (Object_GetAttr(char,'material')==FFX_MATERIAL_METAL) or ('metal' in subtype) | ('adamantium' in subtype) | ('super_alloy' in subtype):
                makethrow(char,source,20)
                return
    if densityaltered(char):
        Object_SetGenericState(char,OBJSTATE_DENSITY_CHANGE,0,REMOVE_STATE)
        FFX_UpdateStates(char)
        subtype = m25ai.FindTacticType(char, 'subtype')
        if (Object_GetAttr(char,'material')==FFX_MATERIAL_METAL) or ('metal' in subtype) | ('adamantium' in subtype) | ('super_alloy' in subtype):
            makethrow(char,source,COST_DENSITY)

def empathytomagnetthrow(event):
    char=event.object
    throwCheck(char,stateintensity[int(event.user)*3],1)

def empathytomentaldamage(event):
    char=event.object
    Trigger_Explosion(char,'ffx_blankarea')
    RegTimer('mentaldamageCheck',1,stateintensity[int(event.user)],char)

def empathytotaunt(event):
    char=event.object
    Trigger_Explosion(char,'ffx_blankarea')
    RegTimer('tauntCheck',1,stateintensity[int(event.user)],char)

def empathytoteleport(event):
    char=event.object
    Trigger_Explosion(char,'ffx_hexarea')
    RegTimer('teleportCheck',1,stateintensity[int(event.user)],char)

def displacetocrystallise(event):
    char=event.object
    Trigger_Explosion(char,'ffx_hexarea')
    RegTimer('crystalCheck',1,stateintensity[int(event.user)],char)

def displacetovertigo(event):
    char=event.object
    Trigger_Explosion(char,'ffx_blankarea')
    RegTimer('vertigoCheck',1,stateintensity[int(event.user)],char)

def displacetofirecage(event):
    char=event.object
    Trigger_Explosion(char,'ffx_hexarea')
    RegTimer('firecageCheck',1,stateintensity[int(event.user)],char)

def displacetoshrink(event):
    char=event.object
    Trigger_Explosion(char,'ffx_hexarea')
    RegTimer('shrinkCheck',1,stateintensity[int(event.user)],char)

def displacetotransmute(event):
    char=event.object
    Trigger_Explosion(char,'ffx_hexarea')
    RegTimer('transmuteCheck',1,stateintensity[int(event.user)],char)

def displacetogravityincrease(event):
    char=event.object
    Trigger_Explosion(char,'ffx_hexarea')
    RegTimer('gravityCheck',1,stateintensity[int(event.user)],char)

def displacetopull(event):
    char=event.object
    pullCheck(char,stateintensity[int(event.user)])

def displacetomagnetpull(event):
    char=event.object
    pullCheck(char,stateintensity[int(event.user)*3],1)

def displacetothrow(event):
    char=event.object
    throwCheck(char,stateintensity[int(event.user)])

def displacetomagnetthrow(event):
    char=event.object
    throwCheck(char,stateintensity[int(event.user)*3],1)

def displacetostaticcage(event):
    char=event.object
    Trigger_Explosion(char,'ffx_hexarea')
    RegTimer('staticcageCheck',1,stateintensity[int(event.user)],char)

def displacetoweaken(event):
    char=event.object
    Trigger_Explosion(char,'ffx_hexarea')
    RegTimer('weakenCheck',1,stateintensity[int(event.user)],char)

def displacetomentaldamage(event):
    char=event.object
    Trigger_Explosion(char,'ffx_blankarea')
    RegTimer('mentaldamageCheck',1,stateintensity[int(event.user)],char)

def displacetotaunt(event):
    char=event.object
    Trigger_Explosion(char,'ffx_blankarea')
    RegTimer('tauntCheck',1,stateintensity[int(event.user)],char)

def displacetoteleport(event):
    char=event.object
    Trigger_Explosion(char,'ffx_hexarea')
    RegTimer('teleportCheck',1,stateintensity[int(event.user)],char)

def displacetophase(event):
    char=event.object
    phaseCheck(char,5)

def displacetoshield(event):    # stumpy 2007-10-31: allowing more than one shield power
    char=event.object
    shieldCheckS(char,0,datfiles.PT_SPECIAL_DISPLACE_IMAGE)

def displacetocloak(event):
    char=event.object
    cloakCheck(char,5)

def displacetonormalise(event):
    char=event.object
    normaliseCheck(char)

def displacetoaccelerate(event):
    char=event.object
    accelerateCheck(char)

def cloaktocrystallise(event):
    char=event.object
    Trigger_Explosion(char,'ffx_hexarea')
    RegTimer('crystalCheck',1,stateintensity[int(event.user)],char)

def cloaktovertigo(event):
    char=event.object
    Trigger_Explosion(char,'ffx_blankarea')
    RegTimer('vertigoCheck',1,stateintensity[int(event.user)],char)

def cloaktofirecage(event):
    char=event.object
    Trigger_Explosion(char,'ffx_hexarea')
    RegTimer('firecageCheck',1,stateintensity[int(event.user)],char)

def cloaktoshrink(event):
    char=event.object
    Trigger_Explosion(char,'ffx_hexarea')
    RegTimer('shrinkCheck',1,stateintensity[int(event.user)],char)

def cloaktotransmute(event):
    char=event.object
    Trigger_Explosion(char,'ffx_hexarea')
    RegTimer('transmuteCheck',1,stateintensity[int(event.user)],char)

def cloaktogravityincrease(event):
    char=event.object
    Trigger_Explosion(char,'ffx_hexarea')
    RegTimer('gravityCheck',1,stateintensity[int(event.user)],char)

def cloaktopull(event):
    char=event.object
    pullCheck(char,stateintensity[int(event.user)])

def cloaktomagnetpull(event):
    char=event.object
    pullCheck(char,stateintensity[int(event.user)*3],1)

def cloaktomentaldamage(event):
    char=event.object
    Trigger_Explosion(char,'ffx_blankarea')
    RegTimer('mentaldamageCheck',1,stateintensity[int(event.user)],char)

def cloaktotaunt(event):
    char=event.object
    Trigger_Explosion(char,'ffx_blankarea')
    RegTimer('tauntCheck',1,stateintensity[int(event.user)],char)

def cloaktoteleport(event):
    char=event.object
    Trigger_Explosion(char,'ffx_hexarea')
    RegTimer('teleportCheck',1,stateintensity[int(event.user)],char)

def cloaktothrow(event):
    char=event.object
    throwCheck(char,stateintensity[int(event.user)])

def cloaktomagnetthrow(event):
    char=event.object
    throwCheck(char,stateintensity[int(event.user)*3],1)

def cloaktostaticcage(event):
    char=event.object
    Trigger_Explosion(char,'ffx_hexarea')
    RegTimer('staticcageCheck',1,stateintensity[int(event.user)],char)

def cloaktoweaken(event):
    char=event.object
    Trigger_Explosion(char,'ffx_hexarea')
    RegTimer('weakenCheck',1,stateintensity[int(event.user)],char)

def cloaktophase(event):
    char=event.object
    phaseCheck(char,5)

def cloaktoshield(event):   # stumpy 2007-10-31: allowing more than one shield power
    char=event.object
    shieldCheckS(char,0,datfiles.PT_SPECIAL_CLOAK)

def cloaktocloak(event):
    char=event.object
    cloakCheck(char,5)

def cloaktonormalise(event):
    char=event.object
    normaliseCheck(char)

def cloaktoaccelerate(event):
    char=event.object
    accelerateCheck(char)

def crystalCheck(event):
    char=event.object
    for obj in Mission_GetDynamicObjects():
        if obj!=char:
            if Object_GetClass(obj)&FFX_CHARACTER:
                if distanceSq(obj,char)<40000:
                    if Object_GetSecondaryStates(obj)&SCSTATE_HEXED:
                        makeCrystallised(obj,char,event.user)
                        Object_SetSecondaryState(obj,SCSTATE_HEXED,0,REMOVE_STATE)

def vertigoCheck(event):
    char=event.object
    for obj in Mission_GetDynamicObjects():
        if obj!=char:
            if Object_GetClass(obj)&FFX_CHARACTER:
                if distanceSq(obj,char)<40000:
                    if Object_GetPrimaryState(obj)==PCSTATE_BLANK:
                        makevertigo(obj,char,event.user)
                        Object_SetPrimaryState(obj,PCSTATE_BLANK,0,REMOVE_STATE)

def firecageCheck(event):
    char=event.object
    for obj in Mission_GetDynamicObjects():
        if obj!=char:
            if Object_GetClass(obj)&FFX_CHARACTER:
                if distanceSq(obj,char)<40000:
                    if Object_GetSecondaryStates(obj)&SCSTATE_HEXED:
                        makefirecage(obj,char,event.user)
                        Object_SetSecondaryState(obj,SCSTATE_HEXED,0,REMOVE_STATE)

def shrinkCheck(event):
    char=event.object
    for obj in Mission_GetDynamicObjects():
        if obj!=char:
            if Object_GetClass(obj)&FFX_CHARACTER:
                if distanceSq(obj,char)<40000:
                    if Object_GetSecondaryStates(obj)&SCSTATE_HEXED:
                        makeshrink(obj,char,event.user)
                        Object_SetSecondaryState(obj,SCSTATE_HEXED,0,REMOVE_STATE)

def transmuteCheck(event):
    char=event.object
    hero=event.string
    for obj in Mission_GetDynamicObjects():
        if obj!=char:
            if Object_GetClass(obj)&FFX_CHARACTER:
                if distanceSq(obj,char)<40000:
                    if Object_GetSecondaryStates(obj)&SCSTATE_HEXED:
                        maketransmuted(obj,char,event.user,hero)
                        Object_SetSecondaryState(obj,SCSTATE_HEXED,0,REMOVE_STATE)

def gravityCheck(event):
    char=event.object
    for obj in Mission_GetDynamicObjects():
        if obj!=char:
            if Object_GetClass(obj)&FFX_CHARACTER:
                if distanceSq(obj,char)<40000:
                    if Object_GetSecondaryStates(obj)&SCSTATE_HEXED:
                        makegravityincrease(obj,char,event.user)
                        Object_SetSecondaryState(obj,SCSTATE_HEXED,0,REMOVE_STATE)

def pullCheck(char,intensity,metalonly=0):
    #Ep./Kuertee 2006-09-10: Prevent the map itself (whose template is '') from appearing in that list
    staticObjects = list( Mission_GetObjects() )
    staticObjects.remove( Object_GetTerrain() )
    for obj in staticObjects:
        if obj!=char:
            if Object_GetAttr(obj,'physical'):
                subtype = m25ai.FindTacticType(obj, 'subtype')
                if (metalonly==0) or (Object_GetAttr(obj,'material')==FFX_MATERIAL_METAL) or ('metal' in subtype) | ('adamantium' in subtype) | ('super_alloy' in subtype):
                    if distanceSq(obj,char)<40000:
                        makepull(obj,char,intensity)

def mentaldamageCheck(event):
    char=event.object
    for obj in Mission_GetDynamicObjects():
        if obj!=char:
            if Object_GetClass(obj)&FFX_CHARACTER:
                if distanceSq(obj,char)<40000:
                    if Object_GetPrimaryState(obj)==PCSTATE_BLANK:
                        makementaldamaged(obj,event.user)
                        Object_SetPrimaryState(obj,PCSTATE_BLANK,0,REMOVE_STATE)

def tauntCheck(event):
    char=event.object
    for obj in Mission_GetDynamicObjects():
        if obj!=char:
            if Object_GetClass(obj)&FFX_CHARACTER:
                if distanceSq(obj,char)<40000:
                    if Object_GetPrimaryState(obj)==PCSTATE_BLANK:
                        maketaunt(obj,char,event.user)
                        Object_SetPrimaryState(obj,PCSTATE_BLANK,0,REMOVE_STATE)

def magnetiseCheck(event):
    char=event.object
    for obj in Mission_GetDynamicObjects():
        if obj!=char:
            if Object_GetClass(obj)&FFX_CHARACTER:
                if distanceSq(obj,char)<40000:
                    if Object_GetPrimaryState(obj)==PCSTATE_BLANK:
                        makemagnetise(obj,char,event.user)
                        Object_SetPrimaryState(obj,PCSTATE_BLANK,0,REMOVE_STATE)

def teleportCheck(event):
    char=event.object
    for obj in Mission_GetDynamicObjects():
        if obj!=char:
            if Object_GetClass(obj)&FFX_CHARACTER:
                if distanceSq(obj,char)<40000:
                    if Object_GetSecondaryStates(obj)&SCSTATE_HEXED:
                        Object_SetSecondaryState(obj,SCSTATE_HEXED,0,REMOVE_STATE)
                        maketeleportother(obj,char)

def staticcageCheck(event):
    char=event.object
    for obj in Mission_GetDynamicObjects():
        if obj!=char:
            if Object_GetClass(obj)&FFX_CHARACTER:
                if distanceSq(obj,char)<40000:
                    if Object_GetSecondaryStates(obj)&SCSTATE_HEXED:
                        Object_SetSecondaryState(obj,SCSTATE_HEXED,0,REMOVE_STATE)
                        makestaticcage(obj,char,event.user)

def weakenCheck(event):
    char=event.object
    for obj in Mission_GetDynamicObjects():
        if obj!=char:
            if Object_GetClass(obj)&FFX_CHARACTER:
                if distanceSq(obj,char)<40000:
                    if Object_GetSecondaryStates(obj)&SCSTATE_HEXED:
                        Object_SetSecondaryState(obj,SCSTATE_HEXED,0,REMOVE_STATE)
                        makeweakened(obj,char,event.user)

def phaseCheck(char,intensity):
    for obj in Mission_GetDynamicObjects():
        if obj!=char:
            if Object_GetClass(obj)&FFX_CHARACTER:
                if distanceSq(obj,char)<40000:
                    makephase(obj,intensity)

# stumpy 2007-10-31: allowing more than one shield power
# added two forms for special and normal damage types, keeping this just for compatibility
def shieldCheck(char,intensity,state=''):
    for obj in Mission_GetDynamicObjects():
        if obj!=char:
            if Object_GetClass(obj)&FFX_CHARACTER:
                if distanceSq(obj,char)<40000:
                    makeshieldS(obj,char,intensity,state)

def shieldCheckS(char,intensity,state=-1):
    for obj in Mission_GetDynamicObjects():
        if obj!=char:
            if Object_GetClass(obj)&FFX_CHARACTER:
                if distanceSq(obj,char)<40000:
                    makeshieldS(obj,char,intensity,state)

def shieldCheckN(char,intensity,state=-1):
    for obj in Mission_GetDynamicObjects():
        if obj!=char:
            if Object_GetClass(obj)&FFX_CHARACTER:
                if distanceSq(obj,char)<40000:
                    makeshieldN(obj,char,intensity,state)

def cloakCheck(char,intensity):
    for obj in Mission_GetDynamicObjects():
        if obj!=char:
            if Object_GetClass(obj)&FFX_CHARACTER:
                if distanceSq(obj,char)<40000:
                    makecloak(obj,intensity)

def normaliseCheck(char):
    for obj in Mission_GetDynamicObjects():
        if obj!=char:
            if Object_GetClass(obj)&FFX_CHARACTER:
                if distanceSq(obj,char)<40000:
                    makenormalise(obj)

def accelerateCheck(char):
    for obj in Mission_GetDynamicObjects():
        if obj!=char:
            if Object_GetClass(obj)&FFX_CHARACTER:
                if distanceSq(obj,char)<40000:
                    makeaccelerate(obj)

def throwCheck(char,intensity,metalonly=0):
    #Ep./Kuertee 2006-09-10: Prevent the map itself (whose template is '') from appearing in that list
    staticObjects = list( Mission_GetObjects() )
    staticObjects.remove( Object_GetTerrain() )
    for obj in staticObjects:
        if obj!=char:
            if Object_GetAttr(obj,'physical'):
                subtype = m25ai.FindTacticType(obj, 'subtype')
                if (metalonly==0) or (Object_GetAttr(obj,'material')==FFX_MATERIAL_METAL) or ('metal' in subtype) | ('adamantium' in subtype) | ('super_alloy' in subtype):
                    if distanceSq(obj,char)<40000:
                        makethrow(obj,char,intensity)

################## SELF_HEALING SPECIAL ########################

def empathytoselfheal(event):
    char=event.object
    Trigger_Damage(char,-randint(6,12))

def cloaktoselfheal(event):
    char=event.object
    Trigger_Damage(char,-randint(18,36))

def displacetoselfheal(event):
    char=event.object
    Trigger_Damage(char,-randint(24,48))

################# SPEED BOOST SPECIAL ############################

def empathytospeedboost(event):
    char=event.object
    overclock(char,2)

def cloaktospeedboost(event):
    char=event.object
    overclock(char,3)

def displacetospeedboost(event):
    char=event.object
    overclock(char,4)

def overclock(char,intensity):
    spd=Object_GetAttr(char,'baseSpeed')
    Object_SetAttr(char,'energy',0)
    Object_SetAttr(char,'speed',spd+intensity*2)
    Object_SetAttr(char,'baseSpeed',spd+intensity*2)
    RegTimer('overclockcheck',1,0,char)
    if FFX_ObjectGetAttr(char,'overclockfx',-1)==-1:
        handle=Object_PlayEffect(char,'effect_ffx_energysparks','',FX_LOOP|FX_TRACK_OBJECT_POS)
        FFX_ObjectSetAttr(char,'overclockfx',handle)

def overclockcheck(event):
    char=event.object
    ep=Object_GetAttr(char,'energyPoints')-1
    #print 'overclock:%d'%(ep)
    if ep>0:
        Object_SetAttr(char,'energyPoints',ep)
        RegTimer('overclockcheck',1,0,char)
    else:
        endoverclock(char)

def endoverclock(char):
    Object_SetAttr(char,'energy',FFX_ObjectGetAttr(char,'baseEnergy'))
    Object_SetAttr(char,'speed',Object_GetAttr(char,'templateSpeed'))
    Object_SetAttr(char,'baseSpeed',Object_GetAttr(char,'templateSpeed'))
    Object_StopEffect(char,FFX_ObjectGetAttr(char,'overclockfx'))
    FFX_ObjectSetAttr(char,'overclockfx',-1)

################## STROBE SPECIAL ########################

def empathytostrobe(event):
    char=event.object
    strobe=FFX_ObjectGetAttr(char,'strobe')
    if strobe==0:
        FFX_ObjectSetAttr(char,'strobe',3)
        RegTimer('updatestrobe',1,0,char)
    else:
        FFX_ObjectSetAttr(char,'strobe',strobe+2)

def displacetostrobe(event):
    char=event.object
    strobe=FFX_ObjectGetAttr(char,'strobe')
    if strobe==0:
        FFX_ObjectSetAttr(char,'strobe',6)
        RegTimer('updatestrobe',1,0,char)
    else:
        FFX_ObjectSetAttr(char,'strobe',strobe+4)

def cloaktostrobe(event):
    char=event.object
    strobe=FFX_ObjectGetAttr(char,'strobe')
    if strobe==0:
        FFX_ObjectSetAttr(char,'strobe',8)
        RegTimer('updatestrobe',1,0,char)
    else:
        FFX_ObjectSetAttr(char,'strobe',strobe+6)

def updatestrobe(event):
    char=event.object
    strobe=FFX_ObjectGetAttr(char,'strobe')-1
    FFX_ObjectSetAttr(char,'strobe',strobe)
    power=getByTemplate(char,FFX_STROBE,1)
    Trigger_Explosion(char,power)
    if strobe>0:
        RegTimer('updatestrobe',3,0,char)

###############################################################
#carrier attacks that ride on stun chance
###############################################################

def replacePtoP(char,state1,state2,duration=10):
    if Object_GetPrimaryState(char)==state1:
        Object_SetPrimaryState(char,state2,duration,0)

def replacePtoS(char,state1,state2,duration=5):
    if Object_GetPrimaryState(char)==state1:
        Object_SetPrimaryState(char,state1,0,REMOVE_STATE)
        Object_SetSecondaryState(char,state2,duration,0)

def replaceStoP(char,state1,state2,duration=10):
    if Object_GetSecondaryStates(char)&state1:
        Object_SetSecondaryState(char,state1,0,REMOVE_STATE)
        Object_SetPrimaryState(char,state2,duration,0)

def replaceStoS(char,state1,state2,duration=5):
    if Object_GetSecondaryStates(char)&state1:
        Object_SetSecondaryState(char,state1,0,REMOVE_STATE)
        Object_SetSecondaryState(char,state2,duration,0)

def replacePtoO(char,state1,state2,duration=5):
    if Object_GetPrimaryState(char)==state1:
        Object_SetPrimaryState(char,state1,0,REMOVE_STATE)
        Object_SetGenericState(char,state2,duration,0)

def densitytostun(event):
    Object_SetSecondaryState(event.object,SCSTATE_DENSITY,0,REMOVE_STATE)
    Object_SetPrimaryState(event.object,PCSTATE_STUNNED,10)
#    replaceStoP(event.object,SCSTATE_DENSITY,PCSTATE_STUNNED)

def stuntoacidburn(event):
    replacePtoS(event.object,PCSTATE_STUNNED,SCSTATE_ACID_BURNT)
def stuntoblank(event):
    replacePtoP(event.object,PCSTATE_STUNNED,PCSTATE_BLANK)
def stuntohex(event):
    replacePtoS(event.object,PCSTATE_STUNNED,SCSTATE_HEXED,15)
def stuntohypnosis(event):
    replacePtoP(event.object,PCSTATE_STUNNED,PCSTATE_HYPNOTISED)
def stuntorage(event):
    replacePtoP(event.object,PCSTATE_STUNNED,PCSTATE_ENRAGED)
def stuntostasis(event):
    replacePtoP(event.object,PCSTATE_STUNNED,PCSTATE_STATIC,5)
def stuntofrozen(event):
    replacePtoP(event.object,PCSTATE_STUNNED,PCSTATE_FROZEN,5)
def stuntoblind(event):
    replacePtoS(event.object,PCSTATE_STUNNED,SCSTATE_BLIND,20)
def stuntodensity(event):
    replacePtoO(event.object,PCSTATE_STUNNED,OBJSTATE_DENSITY_CHANGE,20)
def stuntoexile(event):
    replacePtoP(event.object,PCSTATE_STUNNED,PCSTATE_EXILE)
def stuntopanic(event):
    replacePtoP(event.object,PCSTATE_STUNNED,PCSTATE_PANICKED)
def stuntopowernull(event):
    replacePtoS(event.object,PCSTATE_STUNNED,SCSTATE_POWER_NULLIFICATION,30)
def stuntoirradiate(event):
    replacePtoS(event.object,PCSTATE_STUNNED,SCSTATE_IRRADIATED)

#################### CRYSTALLISATION #############################

COST_EMPATHY=1
COST_CLOAK=4
COST_DISPLACE=3

#relative costs for special powers that trigger an event:
#empathy, cloak, displace in that order
stateintensity=[COST_EMPATHY,COST_CLOAK,COST_DISPLACE]

#based on the cost of swappable state attacks ---

#mental attacks
COST_HYPNO=10
COST_RAGE=3.833
COST_BLANK=3.333
COST_PANIC=1
COST_NULL=1
COST_WEAKEN=0.333

#mystical attacks
COST_STASIS=2.2
COST_BLIND=1.667
COST_HEX=1
COST_EXILE=0.667

#other
COST_FROZEN=1.333 #cold
COST_DENSITY=0.667 #energy
COST_DECREASE=0.3333 #piercing

#stun carriers - now rarer and more costly than in FF1
COST_STUN=1.5

#non-resistable
COST_RALLY=1.75
COST_ENERGYSURGE=1
COST_BUOYANCY=0.855
COST_INCREASE=0.833

def hypnosistocrystallise(event):
    crystalliseP(event.object,event.string,PCSTATE_HYPNOTISED,COST_HYPNO)
def ragetocrystallise(event):
    crystalliseP(event.object,event.string,PCSTATE_ENRAGED,COST_RAGE)
def exiletocrystallise(event):
    crystalliseP(event.object,event.string,PCSTATE_EXILE,COST_EXILE)
def blanktocrystallise(event):
    crystalliseP(event.object,event.string,PCSTATE_BLANK,COST_BLANK)
def panictocrystallise(event):
    crystalliseP(event.object,event.string,PCSTATE_PANICKED,COST_PANIC)
def stasistocrystallise(event):
    crystalliseP(event.object,event.string,PCSTATE_STATIC,COST_STASIS)

def hextocrystallise(event):
    crystalliseS(event.object,event.string,SCSTATE_HEXED,COST_HEX,COST_HEX)
def blindtocrystallise(event):
    crystalliseS(event.object,event.string,SCSTATE_BLIND,COST_BLIND)
def powernulltocrystallise(event):
    crystalliseS(event.object,event.string,SCSTATE_POWER_NULLIFICATION,COST_NULL)
def weakentocrystallise(event):
    crystalliseS(event.object,event.string,SCSTATE_WEAKENED,COST_WEAKEN)
def speeddecreasetocrystallise(event):
    crystalliseS(event.object,event.string,SCSTATE_SPEED_DECREASED,COST_DECREASE)

def densitytocrystallise(event):
    char=event.object
    source=event.string
    if FFX_GotState(char,SCSTATE_DENSITY):
        Object_SetGenericState(char,OBJSTATE_DENSITY_CHANGE,0,REMOVE_STATE)
        FFX_UpdateStates(char)
        makeCrystallised(char,source,COST_DENSITY)

def crystalliseP(char,source,state,intensity):
    if state==PCSTATE_STATIC:
        Object_SetPrimaryState(char,state,0,REMOVE_STATE)
        FFX_UpdateStates(char)
        mlogreader.regGetupStop(char,'ffx.makeCrystallisedEvent',0,0,intensity,source)
        return
    if FFX_GotState(char,state):
        Object_SetPrimaryState(char,state,0,REMOVE_STATE)
        FFX_UpdateStates(char)
        makeCrystallised(char,source,intensity)

def crystalliseS(char,source,state,intensity,override=0):
    if FFX_GotState(char,state,override):
        Object_SetSecondaryState(char,state,0,REMOVE_STATE)
        FFX_UpdateStates(char)
        makeCrystallised(char,source,intensity)

def makeCrystallisedEvent(event):
    char = event.object
    source = event.string
    intensity = event.user
    makeCrystallised(char,source,intensity)

def makeCrystallised(char,source,intensity):
    MPSendMessage(MP_CRYSTALLISE,Object_GetAttr(char,'ffxMPID'),intensity)
    crystalName='c%s'%(char)
    if Object_Exists(crystalName):
        Object_SetAttr(crystalName,'health',Object_GetAttr(crystalName,'health')+0.5*intensity)
    else:
        pos=Get_ObjectPos(char)
        t=getByTemplate(source,FFX_CRYSTALS,1)
        Object_SpawnAt(t,pos,crystalName)
        alignWith(crystalName,char)
        try:
            handle=Object_PlayEffect(crystalName,'effect_%s'%(t),'',FX_LOOP|FX_TRACK_OBJECT_FULL,0,'',(0,0,10),0,(0,0,2))
            ffx.FFX_ObjectSetAttr(char,'crystalFX',handle)
        except:
            pass
        Object_SetAttr(crystalName,'health',10*intensity)
        if isGiant(char):
            Trigger_Damage(crystalName,100)
        else:
            Trigger_Move(char,'lock')
            if FFX_HasPortrait(char):
                goal=ai.goal.KillObjects(crystalName)
                addGoalToAI(char, goal, PRI_ALWAYS+1)
            RegDeath(crystalName,'OnCrystalDown')
            js.Event_RegisterSink(EVENT_OBJ_PROXIMITY_LEAVE, 'OnCrystalLeave', char, crystalName, 2)

def isGiant(char):
    temp=Object_GetTemplate(char)
    return (temp[:4]=='trex') | (temp=='mr_mechanical') | (temp=='time_master') | (temp=='frozen_giant') ###!Ep 2006-02-05

def OnCrystalDown(event):
    crystal=event.object
    length=len(crystal)
    char=crystal[1:]
    if Object_Exists(char):
        handle=ffx.FFX_ObjectGetAttr(char,'crystalFX')
        Object_StopEffect(char,handle)
        Trigger_Move(char,'unlock')
        chpos = Get_ObjectPos(char)  
        # stumpy: added distance check so chars who escaped (e.g. teleported) don't trip when they are a far away already
        crpos = Get_ObjectPos(crystal)
        d = distance2D(chpos,crpos)
        if ( d < 10 ):  # char is within a meter, then trip him
            fallOver(char)

def OnCrystalLeave(event):
    Trigger_Damage(event.string,Object_GetAttr(event.string,'health')+5)

########################## PSYCHIC DAMAGE ###################################

def stuntomentaldamage(event):
    mentaldamageP(event,PCSTATE_STUNNED,COST_STUN)
def hypnosistomentaldamage(event):
    mentaldamageP(event,PCSTATE_HYPNOTISED,COST_HYPNO)
def ragetomentaldamage(event):
    mentaldamageP(event,PCSTATE_ENRAGED,COST_RAGE)
def exiletomentaldamage(event):
    mentaldamageP(event,PCSTATE_EXILE,COST_EXILE)
def blanktomentaldamage(event):
    mentaldamageP(event,PCSTATE_BLANK,COST_BLANK)
def panictomentaldamage(event):
    mentaldamageP(event,PCSTATE_PANICKED,COST_PANIC)
def stasistomentaldamage(event):
    mentaldamageP(event,PCSTATE_STATIC,COST_STASIS)

def hextomentaldamage(event):
    mentaldamageS(event,SCSTATE_HEXED,COST_HEX)
def blindtomentaldamage(event):
    mentaldamageS(event,SCSTATE_BLIND,COST_BLIND)
def powernulltomentaldamage(event):
    mentaldamageS(event,SCSTATE_POWER_NULLIFICATION,COST_NULL)
def weakentomentaldamage(event):
    mentaldamageS(event,SCSTATE_WEAKENED,COST_WEAKEN)
def speeddecreasetomentaldamage(event):
    mentaldamageS(event,SCSTATE_SPEED_DECREASED,COST_DECREASE)

def densitytomentaldamage(event):
    char=event.object
    source=event.string
    if densityaltered(char):
        Object_SetGenericState(char,OBJSTATE_DENSITY_CHANGE,0,REMOVE_STATE)
        FFX_UpdateStates(char)
        makementaldamaged(char,COST_DENSITY)

def mentaldamageP(event,state,intensity):
    char=event.object
    source=event.string
    if Object_GetPrimaryState(char)==state:
        Object_SetPrimaryState(char,state,0,REMOVE_STATE)
        FFX_UpdateStates(char)
        makementaldamaged(char,intensity)

def mentaldamageS(event,state,intensity):
    char=event.object
    source=event.string
    if Object_GetSecondaryStates(char)&state:
        Object_SetSecondaryState(char,state,0,REMOVE_STATE)
        FFX_UpdateStates(char)
        makementaldamaged(char,intensity)

#HYPNO: 24-36
#NORMAL: 8-24
#WEAK: 6-20
#STUN: 4-16
def makementaldamaged(char,intensity):
    if hasAttribute(char,'mindless'):
        return
    if FFX_ObjectGetAttr(char,'mentalDmg',0)==1:
        FFX_ObjectSetAttr(char,'mentalDmg',0)    
        return
    damage=randint(4,16)+(intensity-0.5)*15
    #print 'damage=%d'%(damage)
#   damage=(2*intensity+randint(1,3))*randint(2,4)
    FFX_SetDamageAttrs(char,Object_GetAttr(char,'health')-damage)
    Trigger_Damage(char,damage)
    FFX_ObjectSetAttr(char,'mentalDmg',1)
    RegTimer('cancelmentalDmg',0.6,0,char)

def cancelmentalDmg(event):
    FFX_ObjectSetAttr(event.object,'mentalDmg',0)


##################### ORIGINAL ABSORBER ##############################################################

FFX_ABSORBMAT=[
["default",-1],
["mp_car",4],
["pat_TV_aerial",5],
["pat_streetlight",5],
["pat_neon_sign",5],
["pat_park_lamp",5],
["pat_trafficlight",3],
]

def initabsorber(char,update=0):
    if isMP():
        return
    attrName='%s_absorb'%(char)
    Global_RegisterAttr(attrName,0)
    isCustom=(Object_GetTemplate(char)[:6]=='custom')
    for obj in Mission_GetDynamicObjects():
        if ((Object_GetClass(obj) & FFX_CHARACTER)!=0) & (obj!=char):
            if (Object_GetAttr(obj,attrName)==0):
                if isCustom:
                    powerID=FFX_POWER_CUSTOM
                    #print 'registering against %s'%(obj)
                    Event_RegisterSink(21,'onAbsorbEvent',obj,char,powerID,1.0,1)
                else:
                    for id in builtinPowerIDs:
                        Event_RegisterSink(21,'onAbsorbEvent',obj,char,id,1.0,1)
                Object_SetAttr(obj,attrName,1)
    if update==0:
        Object_SetAttr(char,'templateEnergy',Object_GetAttr(char,'energy'))
        Object_SetAttr(char,'matStrength',Object_GetAttr(char,'templateStrength'))
        for template in templates:
            Mission_CustomAction('CUSTOM_ABSORB',char,template[0],'OnAbsorb',FFX_ABSORBRANGE,0)
        RegTimer('updateAbsorber',5,0,char)

def onAbsorbEvent(event):
    #print 'OnAbsorbEvent'
    OnAbsorb(event.object,event.string)

#put overrides in here for more interesting stuff than just metal/stone all the time
def GetAbsorbMaterial(target):
    mat=getByTemplate(target,FFX_ABSORBMAT,1)
    if mat==-1:
        mat=Object_GetAttr(target,'material')
    return mat

def OnAbsorb(target,char):
    #see if we can do a morph here:
    mat=GetAbsorbMaterial(target)
    #print '%d vs %d'%(mat,Object_GetAttr(char,'material'))
    if isNotSpecialMat(mat) & (mat<=10) & (mat!=Object_GetAttr(char,'material')):
        temp=FFX_GetTemplate(char)
        root=GetRootName(temp)
        #print 'root name=%s'%(root)
        #create the new material marker
        template='%s_%s'%(root,materialNames[int(mat)])
        #print 'try template:%s?'%(template)
        if Template_Exists(template):
            #print 'morphing!'
            name=getFormName()
            portrait=FFX_HasPortrait(char)
            morph(name,char,template,0,portrait)
            Mission_CustomAction('CUSTOM_REVERT',name,name,'OnRevertAbsorb',5,0)
            return
        template='%s (%s)'%(root,materialNames[int(mat)])
        #print 'try custom:%s?'%(template)
        if Custom_Exists(template):
            #print 'morphing!'
            name=getFormName()
            portrait=FFX_HasPortrait(char)
            morph(name,char,template,0,portrait)
            Mission_CustomAction('CUSTOM_REVERT',name,name,'OnRevertAbsorb',5,0)
            return
    if (Object_GetClass(target)&FFX_CHARACTER)!=0:
        #absorb strength, speed and energy
        myStr=Object_GetAttr(char,'baseStrength')
        targetStr=Object_GetAttr(target,'baseStrength')
        if targetStr>myStr:
            FFX_SetStrength(char,targetStr-myStr)
        else:
            bonus=targetStr/myStr
            FFX_SetStrength(char,bonus)
        absorb(char,target,'speed')
        absorb(char,target,'energy')
    #dont absorb flesh material type from characters when hitting them
    if isNotSpecialMat(mat):
        if mat!=Object_GetAttr(char,'material'):
            Object_SetAttr(char,'material',mat)
            initMaterial(char)
#    FFX_Report('absorbed(%s): St=%f Sp=%f M=%d E=%f'%(char,Object_GetAttr(char,'strength'),Object_GetAttr(char,'speed'),Object_GetAttr(char,'material'),Object_GetAttr(char,'energy')))

def updateAbsorber(event):
    char=event.object
    initabsorber(char,1)
    basename=getByTemplate(char,FFX_ABSORB_CUSTOM,2)
    baseStr=Object_GetAttr(char,'baseStrength')
    if baseStr>Object_GetAttr(char,'matStrength'):
        Object_PlayEffect(char,'%sstrength'%(basename),'',FX_TRACK_OBJECT_FULL)
        str=baseStr-0.25
        if str<Object_GetAttr(char,'matStrength'):
            str=Object_GetAttr(char,'matStrength')
        FFX_SetStrength(char,str-Object_GetAttr(char,'templateStrength'))
    if Object_GetAttr(char,'baseSpeed')>Object_GetAttr(char,'templateSpeed'):
        Object_PlayEffect(char,'%sspeed'%(basename),'',FX_TRACK_OBJECT_FULL)
        Object_SetAttr(char,'baseSpeed',Object_GetAttr(char,'baseSpeed')-0.25)
    if Object_GetAttr(char,'energy')>Object_GetAttr(char,'templateEnergy'):
        Object_PlayEffect(char,'%senergy'%(basename),'',FX_TRACK_OBJECT_FULL)
        Object_SetAttr(char,'energy',Object_GetAttr(char,'energy')-0.5)
    RegTimer('updateAbsorber',5,0,char)
#    FFX_Report('absorbed(%s): St=%f Sp=%f M=%d E=%f'%(char,Object_GetAttr(char,'strength'),Object_GetAttr(char,'speed'),Object_GetAttr(char,'material'),Object_GetAttr(char,'energy')))

def initMaterial(char):
    #print 'initMaterial'
    mat=Object_GetAttr(char,'material')
    Object_SetAttr(char,'matStrength',Object_GetAttr(char,'templateStrength'))
    if mat==1: #metal, high strength
        Object_SetAttr(char,'matStrength',Object_GetAttr(char,'templateStrength')+2)
        Object_SetAttr(char,'baseStrength',Object_GetAttr(char,'templateStrength')+2)
        Object_SetAttr(char,'strength',Object_GetAttr(char,'templateStrength')+2)
        FFX_SetStrength(char,Object_GetAttr(char,'strength')-Object_GetAttr(char,'templateStrength'))
    if mat==2: #stone, high strength, low speed
        Object_SetAttr(char,'matStrength',Object_GetAttr(char,'templateStrength')+1)
        Object_SetAttr(char,'baseStrength',Object_GetAttr(char,'templateStrength')+1)
        Object_SetAttr(char,'strength',Object_GetAttr(char,'templateStrength')+1)
        FFX_SetStrength(char,Object_GetAttr(char,'strength')-Object_GetAttr(char,'templateStrength'))
        spd=Object_GetAttr(char,'templateSpeed')-1
        if spd<0:
            spd=0
        Object_SetAttr(char,'speed',spd)
        Object_SetAttr(char,'baseSpeed',spd)
    if mat==3: #rubber- very fast
        spd=Object_GetAttr(char,'templateSpeed')+2
        if spd>9:
            spd=9
        Object_SetAttr(char,'speed',spd)
        Object_SetAttr(char,'baseSpeed',spd)
    if mat==4: #fire - display overheated aura
        handle=Object_PlayEffect(char,'effect_ffx_flames2','',FX_LOOP|FX_TRACK_OBJECT_POS)
        RegTimer('OnFire',1,handle,char)
    if mat==5: #energy - high recharge rate
        Object_SetSecondaryState(char,SCSTATE_ENERGIZED,10,0)
    if mat==9: #frozen - display frostbite aura
        handle=Object_PlayEffect(char,'effect_ffx_icesparks','',FX_LOOP|FX_TRACK_OBJECT_POS)
        RegTimer('OnIce',1,handle,char)
    if mat==10: #cloth, low strength
        Object_SetAttr(char,'matStrength',Object_GetAttr(char,'templateStrength')-2)
        Object_SetAttr(char,'baseStrength',Object_GetAttr(char,'templateStrength')-2)
        Object_SetAttr(char,'strength',Object_GetAttr(char,'templateStrength')-2)
        FFX_SetStrength(char,Object_GetAttr(char,'strength')-Object_GetAttr(char,'templateStrength'))


########################## MIMIC ###################################

def exiletomimic(event):
    mimicP(event,PCSTATE_EXILE,COST_EXILE)
def blanktomimic(event):
    mimicP(event,PCSTATE_BLANK,COST_BLANK)
def panictomimic(event):
    mimicP(event,PCSTATE_PANICKED,COST_PANIC)

def hextomimic(event):
    mimicS(event,SCSTATE_HEXED,COST_HEX)
def blindtomimic(event):
    mimicS(event,SCSTATE_BLIND,COST_BLIND)
def powernulltomimic(event):
    mimicS(event,SCSTATE_POWER_NULLIFICATION,COST_NULL)
def weakentomimic(event):
    mimicS(event,SCSTATE_WEAKENED,COST_WEAKEN)
def speeddecreasetomimic(event):
    mimicS(event,SCSTATE_SPEED_DECREASED,COST_DECREASE)

def densitytomimic(event):
    char=event.object
    source=event.string
    if densityaltered(char):
        Object_SetGenericState(char,OBJSTATE_DENSITY_CHANGE,0,REMOVE_STATE)
        FFX_UpdateStates(char)
        makemimic(char,source,COST_DENSITY)

def mimicP(event,state,intensity):
    char=event.object
    source=event.string
    if Object_GetPrimaryState(char)==state:
        Object_SetPrimaryState(char,state,0,REMOVE_STATE)
        FFX_UpdateStates(char)
        makemimic(char,source,intensity)

def mimicS(event,state,intensity):
    char=event.object
    source=event.string
    if Object_GetSecondaryStates(char)&state:
        Object_SetSecondaryState(char,state,0,REMOVE_STATE)
        FFX_UpdateStates(char)
        makemimic(char,source,intensity)

def makemimic(char,source,intensity):
    RegTimer('OnMimicA',0.1,0,char,source)

#################### VERTIGO #############################

def stuntovertigo(event):
    vertigoP(event,PCSTATE_STUNNED,COST_STUN)
def hypnosistovertigo(event):
    vertigoP(event,PCSTATE_HYPNOTISED,COST_HYPNO)
def ragetovertigo(event):
    vertigoP(event,PCSTATE_ENRAGED,COST_RAGE)
def exiletovertigo(event):
    vertigoP(event,PCSTATE_EXILE,COST_EXILE)
def blanktovertigo(event):
    vertigoP(event,PCSTATE_BLANK,COST_BLANK)
def panictovertigo(event):
    vertigoP(event,PCSTATE_PANICKED,COST_PANIC)
def frozentovertigo(event):
    vertigoP(event,PCSTATE_FROZEN,COST_FROZEN)
def stasistovertigo(event):
    vertigoP(event,PCSTATE_STATIC,COST_STASIS)

def hextovertigo(event):
    vertigoS(event,SCSTATE_HEXED,COST_HEX)
def blindtovertigo(event):
    vertigoS(event,SCSTATE_BLIND,COST_BLIND)
def powernulltovertigo(event):
    vertigoS(event,SCSTATE_POWER_NULLIFICATION,COST_NULL)
def weakentovertigo(event):
    vertigoS(event,SCSTATE_WEAKENED,COST_WEAKEN)
def speeddecreasetovertigo(event):
    vertigoS(event,SCSTATE_SPEED_DECREASED,COST_DECREASE)

def densitytovertigo(event):
    char=event.object
    source=event.string
    if densityaltered(char):
        Object_SetGenericState(char,OBJSTATE_DENSITY_CHANGE,0,REMOVE_STATE)
        FFX_UpdateStates(char)
        makevertigo(char,source,COST_DENSITY)

def vertigoP(event,state,intensity):
    char=event.object
    source=event.string
    if Object_GetPrimaryState(char)==state:
        Object_SetPrimaryState(char,state,0,REMOVE_STATE)
        FFX_UpdateStates(char)
        makevertigo(char,source,intensity)

def vertigoS(event,state,intensity):
    char=event.object
    source=event.string
    if Object_GetSecondaryStates(char)&state:
        Object_SetSecondaryState(char,state,0,REMOVE_STATE)
        FFX_UpdateStates(char)
        makevertigo(char,source,intensity)

def makevertigo(char,source,intensity):
    MPSendMessage(MP_VERTIGO,Object_GetAttr(char,'ffxMPID'),intensity)
    if FFX_ObjectGetAttr(char,'vertigoHandle',-1)==-1:
        handle=Object_PlayEffect(char,'effect_ffx_vertigo','',FX_LOOP|FX_TRACK_OBJECT_POS,0,'Bip01 Head')
        FFX_ObjectSetAttr(char,'vertigoHandle',handle)
    FFX_ObjectSetAttr(char,'vertigo',12*intensity)

############################# GRAVITY DOWN #################################

def stuntogravityincrease(event):
    gravityincreaseP(event,PCSTATE_STUNNED,COST_STUN)
def hypnosistogravityincrease(event):
    gravityincreaseP(event,PCSTATE_HYPNOTISED,COST_HYPNO)
def ragetogravityincrease(event):
    gravityincreaseP(event,PCSTATE_ENRAGED,COST_RAGE)
def exiletogravityincrease(event):
    gravityincreaseP(event,PCSTATE_EXILE,COST_EXILE)
def blanktogravityincrease(event):
    gravityincreaseP(event,PCSTATE_BLANK,COST_BLANK)
def panictogravityincrease(event):
    gravityincreaseP(event,PCSTATE_PANICKED,COST_PANIC)
def frozentogravityincrease(event):
    gravityincreaseP(event,PCSTATE_FROZEN,COST_FROZEN)
def stasistogravityincrease(event):
    gravityincreaseP(event,PCSTATE_STATIC,COST_STASIS)

def hextogravityincrease(event):
    gravityincreaseS(event,SCSTATE_HEXED,COST_HEX)
def blindtogravityincrease(event):
    gravityincreaseS(event,SCSTATE_BLIND,COST_BLIND)
def powernulltogravityincrease(event):
    gravityincreaseS(event,SCSTATE_POWER_NULLIFICATION,COST_NULL)
def weakentogravityincrease(event):
    gravityincreaseS(event,SCSTATE_WEAKENED,COST_WEAKEN)
def speeddecreasetogravityincrease(event):
    gravityincreaseS(event,SCSTATE_SPEED_DECREASED,COST_DECREASE)

def densitytogravityincrease(event):
    char=event.object
    source=event.string
    if densityaltered(char):
        Object_SetGenericState(char,OBJSTATE_DENSITY_CHANGE,0,REMOVE_STATE)
        FFX_UpdateStates(char)
        gravityincreaseFall(char,source,COST_DENSITY)

def gravityincreaseP(event,state,intensity):
    char=event.object
    source=event.string
    if Object_GetPrimaryState(char)==state:
        Object_SetPrimaryState(char,state,0,REMOVE_STATE)
        FFX_UpdateStates(char)
        gravityincreaseFall(char,source,intensity)
    if state==PCSTATE_STATIC:
        FFX_ObjectSetAttr(char, 'stasisGravityDown', 1)

def gravityincreaseS(event,state,intensity):
    char=event.object
    source=event.string
    if Object_GetSecondaryStates(char)&state:
        Object_SetSecondaryState(char,state,0,REMOVE_STATE)
        FFX_UpdateStates(char)
        gravityincreaseFall(char,source,intensity)

# stumpy 2007-01-02: we need to have this attack act pay attention to
# character attributes like density control and characters made of
# (say) air. For right now, I am nerfing intensity for them; i.e., if
# you can control your density (or it is effectively zero already),
# then increased gravity doesn't hit you as hard.  We should probably
# say they are entirely immune, but we'll try this first.
def gravityincreaseFall(char,source,intensity):
    if FFX_ObjectGetAttr(char,'gravityDown',0)==1:
        return
    duration=10*intensity
    if hasAttribute(char,'density control') or ( Object_GetAttr(char,'material')==6 ) :
        intensity = intensity/10.0
    MPSendMessage(MP_GRAVITYINCREASE,Object_GetAttr(char,'ffxMPID'),intensity)
    FFX_ObjectSetAttr(char,'gravityDown',1)
    if FFX_ObjectGetAttr(char, 'stasisGravityDown') == 1:
        FFX_ObjectSetAttr(char, 'gravityDown_duration', duration)
        RegTimer('makegravityincreaseFlyer', 0.2, intensity, char)
        FFX_ObjectSetAttr(char, 'gravityDown_flier', 1)
    else:
        flying=mlogreader.MLOG_IsFlying(char)
        if flying:
            ff.RESULTBUBBLE_SCALE=0
            RegTimer('bubblesOn',0.1)
            Object_SetPrimaryState(char,PCSTATE_STATIC,10,0)
            FFX_ObjectSetAttr(char, 'gravityDown_duration', duration)
            RegTimer('makegravityincreaseFlyer', 0.2, intensity, char)
            FFX_ObjectSetAttr(char, 'gravityDown_flier', 1)
        else:
            makegravityincrease(char,duration,intensity)

def makegravityincrease(char,duration,intensity):
    str=Object_GetAttr(char,'strength')
    if intensity > 2:
        newStr=str-FFX_Rand(3,8)*intensity/2
    else:
        newStr=str-FFX_Rand(4,10)*intensity/2
    spdLoss=((newStr*100)/str)*.01
    spd=Object_GetAttr(char,'baseSpeed')
    newSpd=spd*spdLoss
    Object_SetAttr(char,'strength',newStr)
    Object_SetAttr(char,'speed',newSpd)
    if FFX_ObjectGetAttr(char,'gravityFX',0)==0:
        RegTimer('OnGravityFX',0.1,0,char)
    RegTimer('OnGravityDownCancel',duration,0,char)
    if newStr<0:
        AI_Animate(char,'land_back','OnGravityDown',0,1)

def OnGravityFX(event):
    char = event.object
    if FFX_ObjectGetAttr(char,'gravityDown',0)!=0:
        Object_PlayEffect(char,'effect_ffx_gravity','',FX_TRACK_OBJECT_FULL,0)
        FFX_ObjectSetAttr(char,'gravityFX',1)
        RegTimer('OnGravityFX',1,0,char)

def makegravityincreaseFlyer(event):
    char = event.object
    intensity = event.user
    duration=FFX_ObjectGetAttr(char, 'gravityDown_duration')
    if FFX_ObjectGetAttr(char, 'gravityDown_flier', 0)==1:
        Object_SetPrimaryState(char,PCSTATE_STATIC,0,REMOVE_STATE)
        RegTimer('makegravityincreaseFlyer', 0.2, intensity, char)
        FFX_ObjectSetAttr(char, 'gravityDown_flier', 0)
        return
    falling=mlogreader.MLOG_IsFlailing(char)
    if falling:
        RegTimer('makegravityincreaseFlyer', 0.2, intensity, char)
    else:
        makegravityincrease(char,duration,intensity)
    if FFX_ObjectGetAttr(char,'gravityFX',0)==0:
        RegTimer('OnGravityFX',0.1,0,char)

def OnGravityDown(event):
    char=event.object
    ff.RESULTBUBBLE_SCALE=0
    RegTimer('bubblesOn',0.1)
    Object_SetPrimaryState(char,PCSTATE_STATIC,10,0)

def OnGravityDownCancel(event):
    char=event.object
    if Object_GetPrimaryState(char)==PCSTATE_STATIC:
        Object_SetPrimaryState(char,PCSTATE_STATIC,0,REMOVE_STATE)
        mlogreader.regGetupStop(char,'OnGravityDownCancel2',0,0,0)
    else:
        RegTimer('OnGravityDownCancel2', 0.5, 0, char)

def OnGravityDownCancel2(event):
    char=event.object
    str=Object_GetAttr(char,'baseStrength')
    spd=Object_GetAttr(char,'baseSpeed')
    Object_SetAttr(char,'strength',str)
    Object_SetAttr(char,'speed',spd)
    FFX_ObjectSetAttr(char,'gravityDown',0)
    FFX_ObjectSetAttr(char,'gravityFX',0)

############################# GRAVITY UP #################################

def hypnosistogravityreverse(event):
    gravityreverseP(event,PCSTATE_HYPNOTISED,COST_HYPNO)
def ragetogravityreverse(event):
    gravityreverseP(event,PCSTATE_ENRAGED,COST_RAGE)
def exiletogravityreverse(event):
    gravityreverseP(event,PCSTATE_EXILE,COST_EXILE)
def blanktogravityreverse(event):
    gravityreverseP(event,PCSTATE_BLANK,COST_BLANK)
def panictogravityreverse(event):
    gravityreverseP(event,PCSTATE_PANICKED,COST_PANIC)

def hextogravityreverse(event):
    gravityreverseS(event,SCSTATE_HEXED,COST_HEX)
def blindtogravityreverse(event):
    gravityreverseS(event,SCSTATE_BLIND,COST_BLIND)
def powernulltogravityreverse(event):
    gravityreverseS(event,SCSTATE_POWER_NULLIFICATION,COST_NULL)
def weakentogravityreverse(event):
    gravityreverseS(event,SCSTATE_WEAKENED,COST_WEAKEN)
def speeddecreasetogravityreverse(event):
    gravityreverseS(event,SCSTATE_SPEED_DECREASED,COST_DECREASE)

def densitytogravityreverse(event):
    char=event.object
    source=event.string
    if densityaltered(char):
        Object_SetGenericState(char,OBJSTATE_DENSITY_CHANGE,0,REMOVE_STATE)
        FFX_UpdateStates(char)
        makegravityreverse(char,source,COST_DENSITY)

def gravityreverseP(event,state,intensity):
    char=event.object
    source=event.string
    if Object_GetPrimaryState(char)==state:
        Object_SetPrimaryState(char,state,0,REMOVE_STATE)
        FFX_UpdateStates(char)
        makegravityreverse(char,source,intensity)

def gravityreverseS(event,state,intensity):
    char=event.object
    source=event.string
    if Object_GetSecondaryStates(char)&state:
        Object_SetSecondaryState(char,state,0,REMOVE_STATE)
        FFX_UpdateStates(char)
        makegravityreverse(char,source,intensity)

# stumpy 2007-02-15: made this proportional to target mass to better simulate "real" reverse gravity
def makegravityreverse(char,source,intensity):
    Trigger_Force(char,0,0,1,200*intensity*Object_GetAttr(char,'mass'),TF_ABSOLUTE)
    RegTimer('OnGravityUp',0.8,0,char)

def OnGravityUp(event):
    char=event.object
    Object_SetPrimaryState(char,PCSTATE_STATIC,5,0)

############################# TELEPORT OTHER #################################

def stuntoteleport(event):
    teleportP(event,PCSTATE_STUNNED,COST_STUN)
def exiletoteleport(event):
    teleportP(event,PCSTATE_EXILE,COST_EXILE)
def panictoteleport(event):
    teleportP(event,PCSTATE_PANICKED,COST_PANIC)

def hextoteleport(event):
    teleportS(event,SCSTATE_HEXED,COST_HEX)
def blindtoteleport(event):
    teleportS(event,SCSTATE_BLIND,COST_BLIND)
def powernulltoteleport(event):
    teleportS(event,SCSTATE_POWER_NULLIFICATION,COST_NULL)

def densitytoteleport(event):
    char=event.object
    source=event.string
    if Object_GetClass(char)&FFX_CHARACTER==0:
        if Object_GetAttr(source,'complex')<1000:
            maketeleportobject(char,source,COST_DENSITY)
            return
    if densityaltered(char):
        Object_SetGenericState(char,OBJSTATE_DENSITY_CHANGE,0,REMOVE_STATE)
        FFX_UpdateStates(char)
        maketeleportother(char,source,COST_DENSITY)

def teleportP(event,state,intensity):
    char=event.object
    source=event.string
    if Object_GetClass(char)&FFX_CHARACTER==0:
        if Object_GetAttr(source,'complex')<1000:
            maketeleportobject(char,source,intensity)
        return
    if Object_GetPrimaryState(char)==state:
        Object_SetPrimaryState(char,state,0,REMOVE_STATE)
        FFX_UpdateStates(char)
        maketeleportother(char,source,intensity)

def teleportS(event,state,intensity):
    char=event.object
    source=event.string
    if Object_GetClass(char)&FFX_CHARACTER==0:
        if Object_GetAttr(source,'complex')<1000:
            maketeleportobject(char,source,intensity)
        return
    if Object_GetSecondaryStates(char)&state:
        Object_SetSecondaryState(char,state,0,REMOVE_STATE)
        FFX_UpdateStates(char)
        maketeleportother(char,source,intensity)

def maketeleportother(char,source,intensity):
    MPSendMessage(MP_TELEPORTOTHER,Object_GetAttr(char,'ffxMPID'))
    try:    # *** stumpy: added this because I was getting lots of missing FX (e.g. microwave's weaken)
        Object_PlayEffect(char,getByTemplate(source,FFX_TELEPORT_FX,1))
    except:
        pass
    RegTimer('teleportother2',0.1,intensity,char,source)

def teleportother2(event):
    char=event.object
    source=event.string
    name=getDummyName()
    pos=Get_ObjectPos(char)
    z=pos[2]+100*event.user
    if z>400:
        z=400
    targetPos=(pos[0]+FFX_Rand(-150,150),pos[1]+FFX_Rand(-150,150),z)
    cshelper.spawn(name,'podium_invisible',targetPos)
    FFX_Teleport(char,targetPos)
    RegTimer('teleportother3',0.1,0,char,source)
    RegTimer('teleportother4',0.2,0,name)

#drop the character
def teleportother3(event):
    char=event.object
    source=event.string
    fallOver(char,1)
    if usingM25AI():
        m25ai.SetFlailing(char)
        m25ai.AIDoGeneric(char,time=5,priority=m25ai.TACTIC_PRIORITY_CRITICAL+1,description='falling')
    Object_PlayEffect(char,getByTemplate(source,FFX_TELEPORT_FX,1))

#kill the invisible podium
def teleportother4(event):
    name=event.object
    kill(name)
    RegTimer('destroyTemp',1,0,name)

def maketeleportobject(obj,source,intens=1):
    if FFX_ObjectGetAttr(obj,'tpproof',0)==1:
        return
    FFX_ObjectSetAttr(obj,'tpproof',1)
    RegTimer('restoretpflag',2,0,obj)
    Object_PlayEffect(obj,getByTemplate(source,FFX_TELEPORT_FX,1))
    RegTimer('maketeleportobject2',1,0,obj,source)

def restoretpflag(event):
    FFX_ObjectSetAttr(event.object,'tpproof',0)

def maketeleportobject2(event):
    obj=event.object
    source=event.string
    #find a target
    evil=isEvil(obj)
    target=''
    minDist=100*100
    if usingM25AI():
        target = m25ai.GetCurrentTarget(source)
        if target == None: target = ''
    else:
        for char in Mission_GetDynamicObjects():
            if Object_GetClass(char)&FFX_CHARACTER:
                if evil!=isEvil(char):
                    dist=distanceSq(char,obj)
                    if dist<minDist:
                        target=char
                        minDist=dist
    pos=Get_ObjectPos(obj)
    x=pos[0]
    y=pos[1]
    z=pos[2]+200
    if target!='':
        pos2=Get_ObjectPos(target)
        x=pos2[0]
        y=pos2[1]
    else:
        x=x+randint(-100,100)
        y=y+randint(-100,100)
    FFX_Teleport(obj,(x,y,z))
    fallOver(obj,10)
    Object_PlayEffect(obj,getByTemplate(source,FFX_TELEPORT_FX,1))

#################### TRANSMUTE #############################

def hypnosistotransmute(event):
    transmuteP(event,PCSTATE_HYPNOTISED,COST_HYPNO)
def ragetotransmute(event):
    transmuteP(event,PCSTATE_ENRAGED,COST_RAGE)
def exiletotransmute(event):
    transmuteP(event,PCSTATE_EXILE,COST_EXILE)
def blanktotransmute(event):
    transmuteP(event,PCSTATE_BLANK,COST_BLANK)
def panictotransmute(event):
    transmuteP(event,PCSTATE_PANICKED,COST_PANIC)
def frozentotransmute(event):
    transmuteP(event,PCSTATE_FROZEN,COST_FROZEN)
def stasistotransmute(event):
    transmuteP(event,PCSTATE_STATIC,COST_STASIS)

def hextotransmute(event):
    transmuteS(event,SCSTATE_HEXED,COST_HEX)
def blindtotransmute(event):
    transmuteS(event,SCSTATE_BLIND,COST_BLIND)
def powernulltotransmute(event):
    transmuteS(event,SCSTATE_POWER_NULLIFICATION,COST_NULL)
def weakentotransmute(event):
    transmuteS(event,SCSTATE_WEAKENED,COST_WEAKEN)
def speeddecreasetotransmute(event):
    transmuteS(event,SCSTATE_SPEED_DECREASED,COST_DECREASE)

def densitytotransmute(event):
    char=event.object
    source=event.string
    hero=event.string
    if densityaltered(char):
        Object_SetGenericState(char,OBJSTATE_DENSITY_CHANGE,0,REMOVE_STATE)
        FFX_UpdateStates(char)
        maketransmuted(char,source,COST_DENSITY,hero)

def transmuteP(event,state,intensity):
    char=event.object
    source=event.string
    hero=event.string
    if Object_GetPrimaryState(char)==state:
        Object_SetPrimaryState(char,state,0,REMOVE_STATE)
        FFX_UpdateStates(char)
        maketransmuted(char,source,intensity,hero)

def transmuteS(event,state,intensity):
    char=event.object
    source=event.string
    hero=event.string
    if Object_GetSecondaryStates(char)&state:
        Object_SetSecondaryState(char,state,0,REMOVE_STATE)
        FFX_UpdateStates(char)
        maketransmuted(char,source,intensity,hero)

def maketransmuted(char,source,intensity,hero):
    RegTimer('OnTransmuteCB',0.1,0,char,source)
    MPSendMessage(MP_TRANSMUTE,Object_GetAttr(char,'ffxMPID'),intensity)
    obj='t%s'%(char)
    if Object_Exists(obj)==0:
        template=getTransmute(hero,char)
        if template=='':
            return
        ### 02/02/07-Updated so intensity stays consistent whether char is a hero or computer-controlled -TMX ###
        if Object_GetClass(hero)&OC_CONTROLLABLE:
            if Object_GetPrimaryState(char)!=PCSTATE_EXILE:
                Object_SetPrimaryState(char,PCSTATE_EXILE,4*intensity,0)
        else:
            if Object_GetPrimaryState(char)!=PCSTATE_EXILE:
                Object_SetPrimaryState(char,PCSTATE_EXILE,16*intensity,0)
        FFX_Spawn(obj,template,char,1)
        Object_PlayEffect(obj,'effect_ffx_transmute','',0,0,'centre')
        if Object_GetClass(obj)&FFX_CHARACTER:
            initMinionAI(obj,m25ai.GetTeam(source),'',isEvil(source))
        setFFXState(char,FFX_STATE_TRANSMUTED)
        makecloak(char,100)
        flying=mlogreader.MLOG_IsFlying(char)
        if flying:
            Trigger_Force(obj,0,0,1,Object_GetAttr(obj,'mass')*100,TF_ABSOLUTE)
        RegTimer('Transmute2',0.15,0,obj,char)

def getTransmute(char,target):
    group=getByTemplate(char,FFX_TRANSMUTES,1)
    try:
        cmd='group=getTransmute%s(target)'%(group)
        exec(cmd)
        return group
    except:
        if group=='bizarre':
            return ('blitz_pot_plant','cub_fruit_stand1','cub_wind_guage','ger_barbed_wire','ger_phone_booth','nazihq_lab_machine_1','nazihq_lab_machine_2')[int(FFX_Rand(0,7))]
        if group=='urban':
            return ('pat_streetlight','statue_eagle','flora_small','hourglass')[int(FFX_Rand(0,3))]
        if group=='elemental':
            return ('ffx_elem_stone','ffx_elem_ice','ffx_elem_metal','ffx_elem_wood','ffx_elem_plastic')[int(FFX_Rand(0,4))]
        return group

#special function for pan's transmutations
def getTransmutedionysian(target):
    gender=getGender(target)
    if gender==FFX_GENDER_FEMALE:
        return ('bacchite_red','bacchite_green','bacchite_silver')[randint(0,2)]
    if gender==FFX_GENDER_MALE:
        return 'manbull'
    return ''

def Transmute2(event):
    obj=event.object
    char=event.string
    Object_SetAttr(obj,'maxHealth',Object_GetAttr(char,'maxHealth'))
    Object_SetAttr(obj,'health',Object_GetAttr(char,'health'))
    RegDeath(obj,'TransmuteKill')
    RegCharState(char,PCSTATE_NORMAL,'DeTransmute')

def TransmuteKill(event):
    char=event.object[1:]
    FFX_Teleport(char,Get_ObjectPos(event.object))
    Object_SetSecondaryState(char,SCSTATE_INVISIBLE,0,REMOVE_STATE)
    Object_SetPrimaryState(char,PCSTATE_EXILE,0,REMOVE_STATE)
    Trigger_Damage(char,Object_GetAttr(char,'health')+5)

def playTransmuteFX(event):
    Object_PlayEffect(event.object,'effect_ffx_transmute','',0,0,'centre')

def DeTransmute(event):
    char=event.object
    setFFXState(char,0)
    obj='t%s'%(char)
    makeUncloak(char)
    if Object_Exists(obj)==0:
        Trigger_Damage(char,Object_GetAttr(char,'health')+5)
        Object_SetPrimaryState(char,PCSTATE_STUNNED,1,0)
        Object_PlayEffect(char,'effect_ffx_transmute','',0,0,'centre')
    else:
        FFX_Teleport(char,Get_ObjectPos(obj))
        Object_PlayEffect(char,'effect_ffx_transmute','',0,0,'centre')
        damage=Object_GetAttr(char,'health')-Object_GetAttr(obj,'health')
        Trigger_Damage(char,damage)
        ffx.fallOver(char,1)
        if Object_GetClass(obj)&FFX_CHARACTER:
            RegTimer('destroyTemp',3,0,obj)
            Object_SetPrimaryState(obj,PCSTATE_EXILE,5,0)
            Object_SetSecondaryState(obj,SCSTATE_INVISIBLE,5,0)
        else:
            Object_Destroy(obj)

#################### LIFEDRAIN #############################

def stuntolifedrain(event):
    lifedrainP(event,PCSTATE_STUNNED,1)
def hypnosistolifedrain(event):
    lifedrainP(event,PCSTATE_HYPNOTISED,COST_HYPNO)
def ragetolifedrain(event):
    lifedrainP(event,PCSTATE_ENRAGED,COST_RAGE)
def exiletolifedrain(event):
    lifedrainP(event,PCSTATE_EXILE,COST_EXILE)
def blanktolifedrain(event):
    lifedrainP(event,PCSTATE_BLANK,COST_BLANK)
def panictolifedrain(event):
    lifedrainP(event,PCSTATE_PANICKED,COST_PANIC)
def frozentolifedrain(event):
    lifedrainP(event,PCSTATE_FROZEN,COST_FROZEN)
def stasistolifedrain(event):
    lifedrainP(event,PCSTATE_STATIC,COST_STASIS)

def hextolifedrain(event):
    lifedrainS(event,SCSTATE_HEXED,COST_HEX)
def blindtolifedrain(event):
    lifedrainS(event,SCSTATE_BLIND,COST_BLIND)
def powernulltolifedrain(event):
    lifedrainS(event,SCSTATE_POWER_NULLIFICATION,COST_NULL)
def weakentolifedrain(event):
    lifedrainS(event,SCSTATE_WEAKENED,COST_WEAKEN)
def speeddecreasetolifedrain(event):
    lifedrainS(event,SCSTATE_SPEED_DECREASED,COST_DECREASE)

def densitytolifedrain(event):
    char=event.object
    source=event.string
    if densityaltered(char):
        Object_SetGenericState(char,OBJSTATE_DENSITY_CHANGE,0,REMOVE_STATE)
        FFX_UpdateStates(char)
        makelifedrained(char,source,COST_DENSITY)

def lifedrainP(event,state,intensity):
    char=event.object
    source=event.string
    if Object_GetPrimaryState(char)==state:
        Object_SetPrimaryState(char,state,0,REMOVE_STATE)
        FFX_UpdateStates(char)
        makelifedrained(char,source,intensity)

def lifedrainS(event,state,intensity):
    char=event.object
    source=event.string
    if Object_GetSecondaryStates(char)&state:
        Object_SetSecondaryState(char,state,0,REMOVE_STATE)
        FFX_UpdateStates(char)
        makelifedrained(char,source,intensity)

################################################
#
# modified - so stun does 3+2+1=6 total
#          - rage etc does 5+4+3+2+1 = 15 total 
#          - hypnosis does 8+..+1=28 total
#
################################################
def makelifedrained(char,source,intensity):
    MPSendMessage(MP_LIFEDRAIN,Object_GetAttr(char,'ffxMPID'),Object_GetAttr(source,'ffxMPID'),intensity)
    if FFX_ObjectGetAttr(char,'lifedrainHandle',-1)==-1:
        handle=Object_PlayEffect(char,'effect_ffx_lifedrain','',FX_LOOP|FX_TRACK_OBJECT_FULL,0,'centre')
        FFX_ObjectSetAttr(char,'lifedrainHandle',handle)
        RegTimer('onLifeDrain',1,0,char,source)
    FFX_ObjectSetAttr(char,'lifedrain',(1+intensity)*2)

def onLifeDrain(event):
    char=event.object
    source=event.string
    drain=FFX_ObjectGetAttr(char,'lifedrain')
    drain=drain-1
    if Object_IsAlive(char)==0:
        drain=0
    if drain<=0:
        Object_StopEffect(char,FFX_ObjectGetAttr(char,'lifedrainHandle'))
        FFX_ObjectSetAttr(char,'lifedrainHandle',-1)
    else:
        RegTimer('onLifeDrain',2,0,char,source)
        FFX_ObjectSetAttr(char,'lifedrain',drain)
    intensity=FFX_Rand(1,3)+drain/2
    Trigger_Damage(char,intensity)
    Trigger_Damage(source,-intensity)

#################### STRENGTHDRAIN #############################

def stuntostrengthdrain(event):
    strengthdrainP(event,PCSTATE_STUNNED,1)
def hypnosistostrengthdrain(event):
    strengthdrainP(event,PCSTATE_HYPNOTISED,COST_HYPNO)
def ragetostrengthdrain(event):
    strengthdrainP(event,PCSTATE_ENRAGED,COST_RAGE)
def exiletostrengthdrain(event):
    strengthdrainP(event,PCSTATE_EXILE,COST_EXILE)
def blanktostrengthdrain(event):
    strengthdrainP(event,PCSTATE_BLANK,COST_BLANK)
def panictostrengthdrain(event):
    strengthdrainP(event,PCSTATE_PANICKED,COST_PANIC)
def frozentostrengthdrain(event):
    strengthdrainP(event,PCSTATE_FROZEN,COST_FROZEN)
def stasistostrengthdrain(event):
    strengthdrainP(event,PCSTATE_STATIC,COST_STASIS)

def hextostrengthdrain(event):
    strengthdrainS(event,SCSTATE_HEXED,COST_HEX)
def blindtostrengthdrain(event):
    strengthdrainS(event,SCSTATE_BLIND,COST_BLIND)
def powernulltostrengthdrain(event):
    strengthdrainS(event,SCSTATE_POWER_NULLIFICATION,COST_NULL)
def weakentostrengthdrain(event):
    strengthdrainS(event,SCSTATE_WEAKENED,COST_WEAKEN)
def speeddecreasetostrengthdrain(event):
    strengthdrainS(event,SCSTATE_SPEED_DECREASED,COST_DECREASE)

def densitytostrengthdrain(event):
    char=event.object
    source=event.string
    if densityaltered(char):
        Object_SetGenericState(char,OBJSTATE_DENSITY_CHANGE,0,REMOVE_STATE)
        FFX_UpdateStates(char)
        makestrengthdrained(char,source,COST_DENSITY)

def strengthdrainP(event,state,intensity):
    char=event.object
    source=event.string
    if Object_GetPrimaryState(char)==state:
        Object_SetPrimaryState(char,state,0,REMOVE_STATE)
        FFX_UpdateStates(char)
        makestrengthdrained(char,source,intensity)

def strengthdrainS(event,state,intensity):
    char=event.object
    source=event.string
    if Object_GetSecondaryStates(char)&state:
        Object_SetSecondaryState(char,state,0,REMOVE_STATE)
        FFX_UpdateStates(char)
        makestrengthdrained(char,source,intensity)

def makestrengthdrained(char,source,intensity):
    srcstr=Object_GetAttr(source,'baseStrength')-Object_GetAttr(source,'templateStrength')+intensity
    FFX_SetStrength(source,srcstr)
    charstr=Object_GetAttr(char,'baseStrength')-Object_GetAttr(char,'templateStrength')-intensity
    FFX_SetStrength(char,charstr)
    if FFX_ObjectGetAttr(char,'strdrainHandle',-1)==-1:
        handle=Object_PlayEffect(char,'effect_ffx_strdrain','',FX_LOOP|FX_TRACK_OBJECT_FULL,0,'centre')
        FFX_ObjectSetAttr(char,'strdrainHandle',handle)
        RegTimer('onStrDrain',1,0,char,source)

def onStrDrain(event):
    char=event.object
    source=event.string
    loss=Object_GetAttr(char,'templateStrength')-Object_GetAttr(char,'baseStrength')
    loss=loss-0.1
    if loss<0:
        loss=0
    FFX_SetStrength(char,-loss)
    gain=Object_GetAttr(source,'baseStrength')-Object_GetAttr(source,'templateStrength')
    gain=gain-0.1
    FFX_SetStrength(source,gain)
    Mission_DisplayTimer('str bonus',gain*10)
    if loss==0:
        Object_StopEffect(char,FFX_ObjectGetAttr(char,'strdrainHandle'))
        FFX_ObjectSetAttr(char,'strdrainHandle',-1)
    else:
        RegTimer('onStrDrain',1,0,char,source)

#################### ABSORB #############################

def stuntoabsorb(event):
    absorbP(event,PCSTATE_STUNNED,1)
def hypnosistoabsorb(event):
    absorbP(event,PCSTATE_HYPNOTISED,COST_HYPNO)
def ragetoabsorb(event):
    absorbP(event,PCSTATE_ENRAGED,COST_RAGE)
def exiletoabsorb(event):
    absorbP(event,PCSTATE_EXILE,COST_EXILE)
def blanktoabsorb(event):
    absorbP(event,PCSTATE_BLANK,COST_BLANK)
def panictoabsorb(event):
    absorbP(event,PCSTATE_PANICKED,COST_PANIC)
def frozentoabsorb(event):
    absorbP(event,PCSTATE_FROZEN,COST_FROZEN)
def stasistoabsorb(event):
    absorbP(event,PCSTATE_STATIC,COST_STASIS)

def hextoabsorb(event):
    absorbS(event,SCSTATE_HEXED,COST_HEX)
def blindtoabsorb(event):
    absorbS(event,SCSTATE_BLIND,COST_BLIND)
def powernulltoabsorb(event):
    absorbS(event,SCSTATE_POWER_NULLIFICATION,COST_NULL)
def weakentoabsorb(event):
    absorbS(event,SCSTATE_WEAKENED,COST_WEAKEN)
def speeddecreasetoabsorb(event):
    absorbS(event,SCSTATE_SPEED_DECREASED,COST_DECREASE)

def densitytoabsorb(event):
    char=event.object
    source=event.string
    if (Object_GetClass(char)&FFX_CHARACTER)==0:
        makeabsorbed(char,source,1)
        return
    if densityaltered(char):
        Object_SetGenericState(char,OBJSTATE_DENSITY_CHANGE,0,REMOVE_STATE)
        FFX_UpdateStates(char)
        makeabsorbed(char,source,COST_DENSITY)

def absorbP(event,state,intensity):
    char=event.object
    source=event.string
    if (Object_GetClass(char)&FFX_CHARACTER)==0:
        makeabsorbed(char,source,intensity)
        return
    if Object_GetPrimaryState(char)==state:
        Object_SetPrimaryState(char,state,0,REMOVE_STATE)
        FFX_UpdateStates(char)
        makeabsorbed(char,source,intensity)

def absorbS(event,state,intensity):
    char=event.object
    source=event.string
    if (Object_GetClass(char)&FFX_CHARACTER)==0:
        makeabsorbed(char,source,intensity)
        return
    if Object_GetSecondaryStates(char)&state:
        Object_SetSecondaryState(char,state,0,REMOVE_STATE)
        FFX_UpdateStates(char)
        makeabsorbed(char,source,intensity)

def makeabsorbed(char,source,intensity):
    OnAbsorb(char,source)

#################### SHRINK #############################

def stuntoshrink(event):
    shrinkP(event,PCSTATE_STUNNED,1)
def hypnosistoshrink(event):
    shrinkP(event,PCSTATE_HYPNOTISED,COST_HYPNO)
def ragetoshrink(event):
    shrinkP(event,PCSTATE_ENRAGED,COST_RAGE)
def exiletoshrink(event):
    shrinkP(event,PCSTATE_EXILE,COST_EXILE)
def blanktoshrink(event):
    shrinkP(event,PCSTATE_BLANK,COST_BLANK)
def panictoshrink(event):
    shrinkP(event,PCSTATE_PANICKED,COST_PANIC)

def hextoshrink(event):
    shrinkS(event,SCSTATE_HEXED,COST_HEX)
def blindtoshrink(event):
    shrinkS(event,SCSTATE_BLIND,COST_BLIND)
def powernulltoshrink(event):
    shrinkS(event,SCSTATE_POWER_NULLIFICATION,COST_NULL)
def weakentoshrink(event):
    shrinkS(event,SCSTATE_WEAKENED,COST_WEAKEN)
def speeddecreasetoshrink(event):
    shrinkS(event,SCSTATE_SPEED_DECREASED,COST_DECREASE)

def densitytoshrink(event):
    char=event.object
    source=event.string
    if densityaltered(char):
        Object_SetGenericState(char,OBJSTATE_DENSITY_CHANGE,0,REMOVE_STATE)
        FFX_UpdateStates(char)
        makeshrink(char,source,COST_DENSITY)

def shrinkP(event,state,intensity):
    char=event.object
    source=event.string
    if Object_GetPrimaryState(char)==state:
        Object_SetPrimaryState(char,state,0,REMOVE_STATE)
        FFX_UpdateStates(char)
        makeshrink(char,source,intensity)

def shrinkS(event,state,intensity):
    char=event.object
    source=event.string
    if Object_GetSecondaryStates(char)&state:
        Object_SetSecondaryState(char,state,0,REMOVE_STATE)
        FFX_UpdateStates(char)
        makeshrink(char,source,intensity)

def makeshrink(char,source,intensity):
    RegTimer('OnShrinkCB',0.1,0,char)
    MPSendMessage(MP_SHRINK,Object_GetAttr(char,'ffxMPID'),intensity)
    duration=7*intensity
    if (isMP()!=0) or FFX_HasPortrait(char):
        Object_SetPrimaryState(char,0,duration,0)
    makecloak(char,duration)
    ff.RESULTBUBBLE_SCALE=0
    RegTimer('bubblesOn',0.1)
    Object_SetPrimaryState(char,PCSTATE_STUNNED,duration,0)
    Object_SetAttr(char,'speed',0)
    Object_SetAttr(char,'baseSpeed',0)
    AI_SetEnabled(char,0)
    RegTimer('OnUnShrink',duration,0,char)
    RegTimer('OnShrinkFX',0.2,0,char)
    #third their hit points here
    FFX_FactorHealth(char,0.334)

def OnShrinkFX(event):
    char=event.object
    handle=Object_PlayEffect(char,'effect_ffx_shrunk','',FX_LOOP|FX_TRACK_OBJECT_POS,0,'top')
    FFX_ObjectSetAttr(char,'shrHandle',handle)

def OnUnShrink(event):
    char=event.object
    if FFX_ObjectGetAttr(char,'shrHandle',-1)!=-1:
        Object_StopEffect(char,int(FFX_ObjectGetAttr(char,'shrHandle',-1)))
    AI_SetEnabled(char,1)
    Object_SetSecondaryState(char,SCSTATE_INVISIBLE,0,REMOVE_STATE)
    Object_SetPrimaryState(char,PCSTATE_STUNNED,0,REMOVE_STATE)
    if (isMP()!=0) or FFX_HasPortrait(char):
        Object_SetPrimaryState(char,0,0,REMOVE_STATE)
    fallOver(char)
    #triple their hit points here
    FFX_FactorHealth(char,3)
    spd=Object_GetAttr(char,'templateSpeed')
    Object_SetAttr(char,'speed',spd)
    Object_SetAttr(char,'baseSpeed',spd)

#################### FIRECAGE #############################

def stuntofirecage(event):
    firecageP(event,PCSTATE_STUNNED,COST_STUN)
def hypnosistofirecage(event):
    firecageP(event,PCSTATE_HYPNOTISED,COST_HYPNO)
def ragetofirecage(event):
    firecageP(event,PCSTATE_ENRAGED,COST_RAGE)
def exiletofirecage(event):
    firecageP(event,PCSTATE_EXILE,COST_EXILE)
def blanktofirecage(event):
    firecageP(event,PCSTATE_BLANK,COST_BLANK)
def panictofirecage(event):
    firecageP(event,PCSTATE_PANICKED,COST_PANIC)

def hextofirecage(event):
    firecageS(event,SCSTATE_HEXED,COST_HEX)
def blindtofirecage(event):
    firecageS(event,SCSTATE_BLIND,COST_BLIND)
def powernulltofirecage(event):
    firecageS(event,SCSTATE_POWER_NULLIFICATION,COST_NULL)
def weakentofirecage(event):
    firecageS(event,SCSTATE_WEAKENED,COST_WEAKEN)
def speeddecreasetofirecage(event):
    firecageS(event,SCSTATE_SPEED_DECREASED,COST_DECREASE)

def densitytofirecage(event):
    char=event.object
    source=event.string
    if densityaltered(char):
        Object_SetGenericState(char,OBJSTATE_DENSITY_CHANGE,0,REMOVE_STATE)
        FFX_UpdateStates(char)
        makefirecage(char,source,COST_DENSITY)

def firecageP(event,state,intensity):
    char=event.object
    source=event.string
    if FFX_GotState(char,state):
        Object_SetPrimaryState(char,state,0,REMOVE_STATE)
        FFX_UpdateStates(char)
        makefirecage(char,source,intensity)

def firecageS(event,state,intensity):
    char=event.object
    source=event.string
    if FFX_GotState(char,state):
        Object_SetSecondaryState(char,state,0,REMOVE_STATE)
        FFX_UpdateStates(char)
        makefirecage(char,source,intensity)

def makefirecage(char,source,intensity):
    MPSendMessage(MP_FIRECAGE,Object_GetAttr(char,'ffxMPID'),intensity)
    name='h%s'%(char)
    if Object_Exists(name):
        return
    cshelper.spawn(name,'ffx_firecage',char)
    Object_PlayEffect(name,'effect_ffx_firerings','',FX_LOOP)
    RegDeath(name,'OnFireCageBurst')
    if isGiant(char):
        Trigger_Damage(name,100)
    else:
        Trigger_Move(char,'lock')
        RegTimer('OnFireCageOut',10*intensity,0,name)
        RegTimer('OnFireCageDamage',2,0,char)
        if FFX_HasPortrait(char)==0 and (isMP()==0):
            if randint(1,2)==1:
                goal=ai.goal.KillObjects(name)
                addGoalToAI(char, goal, PRI_ALWAYS+1)
            else:
                FFX_Animate(char,'stunned')

firemult=[1,1,0.5,2,0.25,1,0.5,2,0.5,3,1]

def OnFireCageDamage(event):
    char=event.object
    cage='h%s'%(char)
    if Object_Exists(cage):
        damage=FFX_Rand(1,2)
        mat=int(Object_GetAttr(char,'material'))
        damage=damage*firemult[mat]
        FFX_ApplyDamage(char,damage)
        RegTimer('OnFireCageDamage',2,0,char)

def OnFireCageBurst(event):
    name=event.object
    char=name[1:]
    if Object_Exists(char):
        chpos = Get_ObjectPos(char)  
        # stumpy: added distance check so chars who escaped (e.g. teleported) don't trip when they are a far away already
        crpos = Get_ObjectPos(name)
        d = distance2D(chpos,crpos)
        if ( d < 10 ):  # char is within a meter, then trip him
            fallOver(char)

def OnFireCageOut(event):
    name=event.object
    char=name[1:]
    if Object_Exists(char):
        chpos = Get_ObjectPos(char)  
        # stumpy: added distance check so chars who escaped (e.g. teleported) don't trip when they are a far away already
        crpos = Get_ObjectPos(name)
        d = distance2D(chpos,crpos)
        if ( d < 10 ):  # char is within a meter, then trip him
            fallOver(char)
    Object_PlayEffect(name,'effect_darkness_cloud')
    RegTimer('destroyTemp',1,0,name)

#################### pull #############################

def stuntopull(event):
    pullP(event,PCSTATE_STUNNED,1)
def hypnosistopull(event):
    pullP(event,PCSTATE_HYPNOTISED,COST_HYPNO)
def ragetopull(event):
    pullP(event,PCSTATE_ENRAGED,COST_RAGE)
def exiletopull(event):
    pullP(event,PCSTATE_EXILE,COST_EXILE)
def blanktopull(event):
    pullP(event,PCSTATE_BLANK,COST_BLANK)
def panictopull(event):
    pullP(event,PCSTATE_PANICKED,COST_PANIC)
def frozentopull(event):
    pullP(event,PCSTATE_FROZEN,COST_FROZEN)
def stasistopull(event):
    pullP(event,PCSTATE_STATIC,COST_STASIS)

def hextopull(event):
    pullS(event,SCSTATE_HEXED,COST_HEX)
def blindtopull(event):
    pullS(event,SCSTATE_BLIND,COST_BLIND)
def powernulltopull(event):
    pullS(event,SCSTATE_POWER_NULLIFICATION,COST_NULL)
def weakentopull(event):
    pullS(event,SCSTATE_WEAKENED,COST_WEAKEN)
def speeddecreasetopull(event):
    pullS(event,SCSTATE_SPEED_DECREASED,COST_DECREASE)
def speedincreasetopull(event):
    pullS(event,SCSTATE_SPEED_INCREASED,COST_INCREASE)

def densitytopull(event):
    char=event.object
    source=event.string
    if (Object_GetClass(char)&FFX_CHARACTER)==0:
        if Object_GetAttr(source,'complex')<1000:
            makepull(char,source)
        return
    if densityaltered(char):
        Object_SetGenericState(char,OBJSTATE_DENSITY_CHANGE,0,REMOVE_STATE)
        FFX_UpdateStates(char)
        makepull(char,source,COST_DENSITY)

def pullP(event,state,intensity):
    char=event.object
    source=event.string
    if (Object_GetClass(char)&FFX_CHARACTER)==0:
        if Object_GetAttr(source,'complex')<1000:
            makepull(char,source)
        return
    if Object_GetPrimaryState(char)==state:
        Object_SetPrimaryState(char,state,0,REMOVE_STATE)
        FFX_UpdateStates(char)
        makepull(char,source,intensity)

def pullS(event,state,intensity):
    char=event.object
    source=event.string
    if (Object_GetClass(char)&FFX_CHARACTER)==0:
        if Object_GetAttr(source,'complex')<1000:
            makepull(char,source)
        return
    if (Object_GetClass(char)&FFX_CHARACTER)==0:
        makepull(char,source,intensity)
        return
    if Object_GetSecondaryStates(char)&state:
        Object_SetSecondaryState(char,state,0,REMOVE_STATE)
        FFX_UpdateStates(char)
        makepull(char,source,intensity)

def makepull(char,source,intensity=1):
    if FFX_ObjectGetAttr(char,'noforce'):
        RegTimer('resetForce',0.1,0,char)
        return
    FFX_ObjectSetAttr(char,'noforce',1)
    direction=Vector_Sub(Get_ObjectPos(source),Get_ObjectPos(char))
    magnitude=25000*intensity
    forceForDist=Object_GetAttr(char,'mass')*(sqrt(direction[0]*direction[0]+direction[1]*direction[1])-20)*5
    if magnitude>forceForDist:
        magnitude=forceForDist
        if magnitude<10000:
            magnitude=10000
    sideforce=float(FFX_Rand(5,10))*0.005
    if FFX_Rand(1,2)==1:
        sideforce=-sideforce
    Trigger_Force(char,direction[0]+sideforce*direction[1],direction[1]-sideforce*direction[0],0.5,magnitude,TF_ABSOLUTE)

#################### magnetise #############################

def stuntomagnetise(event):
    magnetiseP(event,PCSTATE_STUNNED,COST_STUN)
def hypnosistomagnetise(event):
    magnetiseP(event,PCSTATE_HYPNOTISED,COST_HYPNO)
def ragetomagnetise(event):
    magnetiseP(event,PCSTATE_ENRAGED,COST_RAGE)
def exiletomagnetise(event):
    magnetiseP(event,PCSTATE_EXILE,COST_EXILE)
def blanktomagnetise(event):
    magnetiseP(event,PCSTATE_BLANK,COST_BLANK)
def panictomagnetise(event):
    magnetiseP(event,PCSTATE_PANICKED,COST_PANIC)
def frozentomagnetise(event):
    magnetiseP(event,PCSTATE_FROZEN,COST_FROZEN)
def stasistomagnetise(event):
    magnetiseP(event,PCSTATE_STATIC,COST_STASIS)

def hextomagnetise(event):
    magnetiseS(event,SCSTATE_HEXED,COST_HEX)
def blindtomagnetise(event):
    magnetiseS(event,SCSTATE_BLIND,COST_BLIND)
def powernulltomagnetise(event):
    magnetiseS(event,SCSTATE_POWER_NULLIFICATION,COST_NULL)
def weakentomagnetise(event):
    magnetiseS(event,SCSTATE_WEAKENED,COST_WEAKEN)
def speeddecreasetomagnetise(event):
    magnetiseS(event,SCSTATE_SPEED_DECREASED,COST_DECREASE)

def densitytomagnetise(event):
    char=event.object
    source=event.string
    if densityaltered(char):
        Object_SetGenericState(char,OBJSTATE_DENSITY_CHANGE,0,REMOVE_STATE)
        FFX_UpdateStates(char)
        makemagnetise(char,source,COST_DENSITY)

def magnetiseP(event,state,intensity):
    char=event.object
    source=event.string
    if Object_GetPrimaryState(char)==state:
        Object_SetPrimaryState(char,state,0,REMOVE_STATE)
        FFX_UpdateStates(char)
        makemagnetise(char,source,intensity)

def magnetiseS(event,state,intensity):
    char=event.object
    source=event.string
    if Object_GetSecondaryStates(char)&state:
        Object_SetSecondaryState(char,state,0,REMOVE_STATE)
        FFX_UpdateStates(char)
        makemagnetise(char,source,intensity)

def makemagnetise(char,source,intensity):
    RegTimer('OnMagnetiseCB',0.1,0,char)
    MPSendMessage(MP_MAGNETISE,Object_GetAttr(char,'ffxMPID'),intensity)
    if FFX_ObjectGetAttr(char,'magnetHandle',-1)==-1:
        handle=Object_PlayEffect(char,'effect_ffx_magnetised','',FX_LOOP|FX_TRACK_OBJECT_FULL,0,'centre')
        FFX_ObjectSetAttr(char,'magnetHandle',handle)
        RegTimer('doMagnetised',1,0,char)
    FFX_ObjectSetAttr(char,'magnetised',13*intensity)

def doMagnetised(event):
    char=event.object
    dur=FFX_ObjectGetAttr(char,'magnetised')
    dur=dur-1
    if Object_IsAlive(char)==0:
        dur=0
    if dur<=0:
        Object_StopEffect(char,FFX_ObjectGetAttr(char,'magnetHandle'))
        FFX_ObjectSetAttr(char,'magnetHandle',-1)
    else:
        RegTimer('doMagnetised',2,0,char)
    FFX_ObjectSetAttr(char,'magnetised',dur)
    myPos=Get_ObjectPos(char)
    m=getMetals()
    md=Mission_GetDynamicObjects()
    for obj in md:
        if Object_GetAttr(obj,'material')==1:
            m.append(obj)
    for obj in m:
        if Object_Exists(obj) & (obj!=char):
            pos=Get_ObjectPos(obj)
            dpos=Vector_Sub(pos,myPos)
            length=sqrt(dpos[0]*dpos[0]+dpos[1]*dpos[1]+dpos[2]*dpos[2])
            #force is 2000 at d=200 and 200000 at length=30
            if (length>5) & (length<150):
                force=(150-length)*2000
                if force>25000:
                    force=25000
                Trigger_Force(obj,-dpos[0],-dpos[1],0.5,force,TF_ABSOLUTE)
                Object_PlayEffect(obj,'effect_ffx_magnetised','',FX_TRACK_OBJECT_POS,0,'centre')

metals=[]

def getMetals():
    global metals
    if len(metals)==0:
        for name in Mission_GetObjects():
            if Object_GetClass(name)&FFX_CHARACTER==0:
                subtype = m25ai.FindTacticType(name, 'subtype')
                if Object_GetAttr(name,'material')==1 | ('metal' in subtype) | ('adamantium' in subtype) | ('super_alloy' in subtype):
                    metals.append(name)
    return metals

#################### taunt #############################

def stuntotaunt(event):
    tauntP(event,PCSTATE_STUNNED)
def hypnosistotaunt(event):
    tauntP(event,PCSTATE_HYPNOTISED)
def ragetotaunt(event):
    tauntP(event,PCSTATE_ENRAGED)
def exiletotaunt(event):
    tauntP(event,PCSTATE_EXILE)
def blanktotaunt(event):
    tauntP(event,PCSTATE_BLANK)
def panictotaunt(event):
    tauntP(event,PCSTATE_PANICKED)

def hextotaunt(event):
    tauntS(event,SCSTATE_HEXED)
def blindtotaunt(event):
    tauntS(event,SCSTATE_BLIND)
def powernulltotaunt(event):
    tauntS(event,SCSTATE_POWER_NULLIFICATION)
def weakentotaunt(event):
    tauntS(event,SCSTATE_WEAKENED)
def speeddecreasetotaunt(event):
    tauntS(event,SCSTATE_SPEED_DECREASED)

def tauntP(event,state):
    char=event.object
    source=event.string
    if Object_GetPrimaryState(char)==state:
        Object_SetPrimaryState(char,state,0,REMOVE_STATE)
        FFX_UpdateStates(char)
        maketaunt(char,source)

def tauntS(event,state):
    char=event.object
    source=event.string
    if Object_GetSecondaryStates(char)&state:
        Object_SetSecondaryState(char,state,0,REMOVE_STATE)
        FFX_UpdateStates(char)
        maketaunt(char,source)

def maketaunt(char,source):
    Object_PlayEffect(char,'effect_ffx_taunt','',FX_TRACK_OBJECT_POS,0,'top')
    Trigger_Power(char,source,'default Punch','')
    cshelper.addKillGoal(char,source,PRI_ALWAYS-1)

#################### WEAKEN - a basic damage mezz state #############################

def hypnosistoweaken(event):
    weakenP(event.object,event.string,PCSTATE_HYPNOTISED,COST_HYPNO)
def ragetoweaken(event):
    weakenP(event.object,event.string,PCSTATE_ENRAGED,COST_RAGE)
def exiletoweaken(event):
    weakenP(event.object,event.string,PCSTATE_EXILE,COST_EXILE)
def blanktoweaken(event):
    weakenP(event.object,event.string,PCSTATE_BLANK,COST_BLANK)
def panictoweaken(event):
    weakenP(event.object,event.string,PCSTATE_PANICKED,COST_PANIC)

def hextoweaken(event):
    weakenS(event.object,event.string,SCSTATE_HEXED,COST_HEX)
def blindtoweaken(event):
    weakenS(event.object,event.string,SCSTATE_BLIND,COST_BLIND)
def powernulltoweaken(event):
    weakenS(event.object,event.string,SCSTATE_POWER_NULLIFICATION,COST_NULL)
def weakentoweaken(event):
    weakenS(event,SCSTATE_WEAKENED,COST_WEAKEN)
def speeddecreasetoweaken(event):
    weakenS(event,SCSTATE_SPEED_DECREASED,COST_DECREASE)

def densitytoweaken(event):
    char=event.object
    source=event.string
    if FFX_GotState(char,SCSTATE_DENSITY):
        Object_SetGenericState(char,OBJSTATE_DENSITY_CHANGE,0,REMOVE_STATE)
        FFX_UpdateStates(char)
        makeweakened(char,source,COST_DENSITY)

def weakenP(char,source,state,intensity):
    if FFX_GotState(char,state):
        Object_SetPrimaryState(char,state,0,REMOVE_STATE)
        FFX_UpdateStates(char)
        makeweakened(char,source,intensity)

def weakenS(char,source,state,intensity):
    if FFX_GotState(char,state):
        Object_SetSecondaryState(char,state,0,REMOVE_STATE)
        FFX_UpdateStates(char)
        makeweakened(char,source,intensity)

def makeweakened(char,source,intensity):
    count=FFX_ObjectGetAttr(char,'weak',0)
    if count==0:
        handle=Object_PlayEffect(char,'effect_ffx_weaken','',FX_LOOP|FX_TRACK_OBJECT_POS)
        FFX_ObjectSetAttr(char,'weakhdl',handle)
        FFX_SetStrength(char,-2)
        RegTimer('weakUpdate',1,0,char)
    FFX_ObjectSetAttr(char,'weak',count+intensity*12)

def weakUpdate(event):
    char=event.object
    count=FFX_ObjectGetAttr(char,'weak',0)-1
    FFX_ObjectSetAttr(char,'weak',count)
    if count<=0:
        FFX_ObjectSetAttr(char,'weak',0)
        Object_StopEffect(char,FFX_ObjectGetAttr(char,'weakhdl'))
        FFX_SetStrength(char,0)
    else:
        FFX_SetStrength(char,-2)
        RegTimer('weakUpdate',1,0,char)

#################### WEAKSPOT - per template damage bonus #############################

def stuntoweakspot(event):
    weakspotP(event.object,event.string,PCSTATE_STUNNED,1)
def hypnosistoweakspot(event):
    weakspotP(event.object,event.string,PCSTATE_HYPNOTISED,COST_HYPNO)
def ragetoweakspot(event):
    weakspotP(event.object,event.string,PCSTATE_ENRAGED,COST_RAGE)
def exiletoweakspot(event):
    weakspotP(event.object,event.string,PCSTATE_EXILE,COST_EXILE)
def blanktoweakspot(event):
    weakspotP(event.object,event.string,PCSTATE_BLANK,COST_BLANK)
def panictoweakspot(event):
    weakspotP(event.object,event.string,PCSTATE_PANICKED,COST_PANIC)

def hextoweakspot(event):
    weakspotS(event.object,event.string,SCSTATE_HEXED,COST_HEX)
def blindtoweakspot(event):
    weakspotS(event.object,event.string,SCSTATE_BLIND,COST_BLIND)
def powernulltoweakspot(event):
    weakspotS(event.object,event.string,SCSTATE_POWER_NULLIFICATION,COST_NULL)
def weakentoweakspot(event):
    weakspotS(event,SCSTATE_WEAKENED,COST_WEAKEN)
def speeddecreasetoweakspot(event):
    weakspotS(event,SCSTATE_SPEED_DECREASED,COST_DECREASE)

def densitytoweakspot(event):
    char=event.object
    source=event.string
    if FFX_GotState(char,SCSTATE_DENSITY):
        Object_SetGenericState(char,OBJSTATE_DENSITY_CHANGE,0,REMOVE_STATE)
        FFX_UpdateStates(char)
        makeweakspot(char,source,COST_DENSITY)

def weakspotP(char,source,state,intensity):
    if FFX_GotState(char,state):
        Object_SetPrimaryState(char,state,0,REMOVE_STATE)
        FFX_UpdateStates(char)
        makeweakspot(char,source,intensity)

def weakspotS(char,source,state,intensity):
    if FFX_GotState(char,state):
        Object_SetSecondaryState(char,state,0,REMOVE_STATE)
        FFX_UpdateStates(char)
        makeweakspot(char,source,intensity)

def makeweakspot(char,source,intensity):
    bonus=FFX_ObjectGetAttr(source,'ws%s'%(Object_GetTemplate(char)),0)
#    Mission_StatusText('bonus=%d (%s)'%(bonus,Object_GetTemplate(char)))
    Trigger_Damage(char,bonus)
    bonus=bonus+3*intensity
    FFX_ObjectSetAttr(source,'ws%s'%(Object_GetTemplate(char)),bonus)

############# THROW ATTACK ##############################################

def stuntothrow(event):
    throwP(event.object,event.string,PCSTATE_STUNNED,COST_STUN)
def hypnosistothrow(event):
    throwP(event.object,event.string,PCSTATE_HYPNOTISED,COST_HYPNO)
def ragetothrow(event):
    throwP(event.object,event.string,PCSTATE_ENRAGED,COST_RAGE)
def exiletothrow(event):
    throwP(event.object,event.string,PCSTATE_EXILE,COST_EXILE)
def blanktothrow(event):
    throwP(event.object,event.string,PCSTATE_BLANK,COST_BLANK)
def panictothrow(event):
    throwP(event.object,event.string,PCSTATE_PANICKED,COST_PANIC)

def hextothrow(event):
    throwS(event.object,event.string,SCSTATE_HEXED,COST_HEX)
def blindtothrow(event):
    throwS(event.object,event.string,SCSTATE_BLIND,COST_BLIND)
def powernulltothrow(event):
    throwS(event.object,event.string,SCSTATE_POWER_NULLIFICATION,COST_NULL)
def weakentothrow(event):
    throwS(event.object,event.string,SCSTATE_WEAKENED,COST_WEAKEN)
def speeddecreasetothrow(event):
    throwS(event.object,event.string,SCSTATE_SPEED_DECREASED,COST_DECREASE)
def buoyancytothrow(event):
    throwS(event.object,event.string,SCSTATE_BUOYANT,1.0)
def speedincreasetothrow(event):
    throwS(event.object,event.string,SCSTATE_SPEED_INCREASED,1.0)

def densitytothrow(event):
    char=event.object
    source=event.string
    if FFX_GotState(char,SCSTATE_DENSITY):
        Object_SetGenericState(char,OBJSTATE_DENSITY_CHANGE,0,REMOVE_STATE)
        FFX_UpdateStates(char)
        makethrow(char,source,COST_DENSITY)

def throwP(char,source,state,intensity):
    if (Object_GetClass(char)&FFX_CHARACTER)==0:
        if Object_GetAttr(source,'complex')<1000:
            makethrow(char,source)
        return
    if FFX_GotState(char,state):
        Object_SetPrimaryState(char,state,0,REMOVE_STATE)
        FFX_UpdateStates(char)
        makethrow(char,source,intensity)

def throwS(char,source,state,intensity):
    if (Object_GetClass(char)&FFX_CHARACTER)==0:
        if Object_GetAttr(source,'complex')<1000:
            makethrow(char,source)
        return
    if FFX_GotState(char,state):
        Object_SetSecondaryState(char,state,0,REMOVE_STATE)
        FFX_UpdateStates(char)
        makethrow(char,source,intensity)

def makethrow(char,source,intensity=1):
    direction=Vector_Sub(Get_ObjectPos(source),Get_ObjectPos(char))
    d=1+sqrt(direction[0]*direction[0]+direction[1]*direction[1])
    dx=direction[0]/d
    dy=direction[1]/d
    h=1
    objMass=Object_GetAttr(char,'mass')
    if objMass < 121:
        magnitude=objMass*160
    if objMass > 121:
        if objMass < 176:
            magnitude=objMass*170
    if objMass > 175:
        magnitude=objMass*175

    # adjust for distance
    if d<40:
        h=1.5
        if objMass < 121:
            magnitude=objMass*165

        if objMass > 121:
            if objMass < 176:
                magnitude=objMass*170

        if objMass > 175:
            magnitude=objMass*175
    if d<30:
        h=2
        if objMass < 121:
            magnitude=objMass*170
        if objMass > 121:
            if objMass < 176:
                magnitude=objMass*175
        if objMass > 175:
            magnitude=objMass*180

    # adjust for thrower mesh size
    meshSize=getByTemplate(source,FFX_THROW_CUSTOM,1)
    magnitude=magnitude*meshSize
    h=h*meshSize
    if meshSize > 3:
        dx=-0.5
        dy=-0.1

    # adjust for target mesh size
    subtype = m25ai.FindTacticType(char, 'subtype')
    if ((Object_GetClass(char)&js.OC_VEHICLE)!=0) | ('vehicle' in subtype):
        FFX_ObjectSetAttr(char,'throw2Vehicle',dy)
        dx=0.0
        dy=0.0
    Trigger_Force(char,dx,dy,h,magnitude,TF_ABSOLUTE)
    RegTimer('throwTurnTo',2,0,char,source)

###################################################
#    maxmag=getThrowForce(char,dist*2)
#    if magnitude>maxmag:
#        magnitude=maxmag
#    h=1
#    print 'makethrow'
#    print dist
#    if dist<30:
#        magnitude=magnitude*2
#        h=3
#    Trigger_Force(char,dx,dy,h,magnitude,TF_ABSOLUTE)
####################################################

def throwTurnTo(event):
    char=event.object
    source=event.string
    turnTo(source,char)

def resetForce(event):
    FFX_ObjectSetAttr(event.object,'noforce',0)

def getThrowForce(char,dist):
    mass=Object_GetAttr(char,'mass')
    force=100*mass*(-0.5+sqrt(0.25+0.04*dist))
    minForce=Object_GetAttr(char,'minForce')
    if force<minForce and (force*4)>minForce:
        force=minForce*1.1
    return force

def ThrowTest(mass,dist):
    Object_SetAttr('hero_0','mass',mass)
    pos=Get_ObjectPos('hero_0')
    Mission_SetAttr('startX',pos[0])
    Mission_SetAttr('startY',pos[1])
    force=getThrowForce('hero_0',dist)
    Mission_SetAttr('force',force)
    Trigger_Force('hero_0',1,0,1,force,TF_ABSOLUTE)
    RegTimer('ThrowTest2',4)
    Object_SetAttr('hero_0','minHealth',10)

def ThrowTest2(event):
    pos=Get_ObjectPos('hero_0')
    dx=Mission_GetAttr('startX')-pos[0]
    dy=Mission_GetAttr('startY')-pos[1]
    dist=sqrt(dx*dx+dy*dy)
    #print 'Force=%d Mass=%d Dist=%d guess=%d'%(Mission_GetAttr('force'),Object_GetAttr('hero_0','mass'),dist,Mission_GetAttr('force')/(Object_GetAttr('hero_0','mass')*5))
    Mission_StatusText( 'Force=%d Mass=%d Dist=%d'%(Mission_GetAttr('force'),Object_GetAttr('hero_0','mass'),dist) )


################### STATIC CAGE #############################

def hypnosistostaticcage(event):
    staticcageP(event.object,event.string,PCSTATE_HYPNOTISED,COST_HYPNO)
def ragetostaticcage(event):
    staticcageP(event.object,event.string,PCSTATE_ENRAGED,COST_RAGE)
def exiletostaticcage(event):
    staticcageP(event.object,event.string,PCSTATE_EXILE,COST_EXILE)
def blanktostaticcage(event):
    staticcageP(event.object,event.string,PCSTATE_BLANK,COST_BLANK)
def panictostaticcage(event):
    staticcageP(event.object,event.string,PCSTATE_PANICKED,COST_PANIC)

def hextostaticcage(event):
    staticcageS(event.object,event.string,SCSTATE_HEXED,COST_HEX)
def blindtostaticcage(event):
    staticcageS(event.object,event.string,SCSTATE_BLIND,COST_BLIND)
def powernulltostaticcage(event):
    staticcageS(event.object,event.string,SCSTATE_POWER_NULLIFICATION,COST_NULL)
def weakentostaticcage(event):
    staticcageS(event.object,event.string,SCSTATE_WEAKENED,COST_WEAKEN)
def speeddecreasetostaticcage(event):
    staticcageS(event.object,event.string,SCSTATE_SPEED_DECREASED,COST_DECREASE)

def densitytostaticcage(event):
    char=event.object
    source=event.string
    if FFX_GotState(char,SCSTATE_DENSITY):
        Object_SetGenericState(char,OBJSTATE_DENSITY_CHANGE,0,REMOVE_STATE)
        FFX_UpdateStates(char)
        makestaticcage(char,source,COST_DENSITY)

def staticcageP(char,source,state,intensity):
    if FFX_GotState(char,state):
        Object_SetPrimaryState(char,state,0,REMOVE_STATE)
        FFX_UpdateStates(char)
        makestaticcage(char,source,intensity)

def staticcageS(char,source,state,intensity):
    if FFX_GotState(char,state):
        Object_SetSecondaryState(char,state,0,REMOVE_STATE)
        FFX_UpdateStates(char)
        makestaticcage(char,source,intensity)

def makestaticcage(char,source,intensity):
    name='s%s'%(char)
    if Object_Exists(name):
        return
    cshelper.spawn(name,'ffx_staticcage',char)
    Object_PlayEffect(name,'effect_ffx_staticcage','',FX_LOOP)
    RegDeath(name,'OnFireCageBurst')
    if isGiant(char):
        Trigger_Damage(name,100)
    else:
        Trigger_Move(char,'lock')
        RegTimer('OnFireCageOut',5*intensity,0,name)
        RegTimer('OnStaticCageDamage',2,0,name)
        if FFX_HasPortrait(char)==0 and (isMP()==0):
            if randint(1,2)==1:
                goal=ai.goal.KillObjects(name)
                addGoalToAI(char, goal, PRI_ALWAYS+1)
            else:
                FFX_Animate(char,'stunned')

def OnStaticCageDamage(event):
    cage=event.object
    if Object_Exists(cage):
        if Object_IsAlive(cage):
            Trigger_Explosion(cage,'ffx_staticcage')
            RegTimer('OnStaticCageDamage',2,0,cage)

#################### ZEROG #############################

def stuntozerog(event):
    zerogP(event,PCSTATE_STUNNED,COST_STUN)
def hypnosistozerog(event):
    zerogP(event,PCSTATE_HYPNOTISED,COST_HYPNO)
def ragetozerog(event):
    zerogP(event,PCSTATE_ENRAGED,COST_RAGE)
def exiletozerog(event):
    zerogP(event,PCSTATE_EXILE,COST_EXILE)
def blanktozerog(event):
    zerogP(event,PCSTATE_BLANK,COST_BLANK)
def panictozerog(event):
    zerogP(event,PCSTATE_PANICKED,COST_PANIC)

def hextozerog(event):
    zerogS(event,SCSTATE_HEXED,COST_HEX)
def blindtozerog(event):
    zerogS(event,SCSTATE_BLIND,COST_BLIND)
def powernulltozerog(event):
    zerogS(event,SCSTATE_POWER_NULLIFICATION,COST_NULL)
def weakentozerog(event):
    zerogS(event,SCSTATE_WEAKENED,COST_WEAKEN)
def speeddecreasetozerog(event):
    zerogS(event,SCSTATE_SPEED_DECREASED,COST_DECREASE)

def densitytozerog(event):
    char=event.object
    source=event.string
    if densityaltered(char):
        Object_SetGenericState(char,OBJSTATE_DENSITY_CHANGE,0,REMOVE_STATE)
        FFX_UpdateStates(char)
        makezerog(char,source,COST_DENSITY)

def zerogP(event,state,intensity):
    char=event.object
    source=event.string
    if FFX_GotState(char,state):
        Object_SetPrimaryState(char,state,0,REMOVE_STATE)
        FFX_UpdateStates(char)
        makezerog(char,source,intensity)

def zerogS(event,state,intensity):
    char=event.object
    source=event.string
    if FFX_GotState(char,state):
        Object_SetSecondaryState(char,state,0,REMOVE_STATE)
        FFX_UpdateStates(char)
        makezerog(char,source,intensity)

def makezerog(char,source,intensity):
    Object_SetSecondaryState(char,SCSTATE_BUOYANT,100,0)
    pos=Get_ObjectPos(char)
    RegTimer('zerog2',1,pos[2],char)
    FFX_SetMassFactor(char,0.2)
    RegTimer('zerogoff',intensity*6,0,char,'z%s'%(char))

def zerog2(event):
    z=event.user
    char=event.object
    pos=Get_ObjectPos(char)
    if z<pos[2]:
        Trigger_Move(char,'lock')

def zerogoff(event):
    char=event.object
    if FFX_ObjectGetAttr(char,'ffxflier')==0:
        Object_SetSecondaryState(char,SCSTATE_BUOYANT,0,REMOVE_STATE)
    FFX_SetMassFactor(char,1)
    fallOver(char,1)

#
################### BENEFICIAL STATE SWAPS ##########################
#

################### PHASER ##########################################

def rallytophase(event):
    char=event.object
    source=event.string
    bonus=Object_GetAttr(char,'attackBonus')
    oldBonus=Object_GetAttr(char,'oldAttackBonus')
    if bonus!=oldBonus:
        Object_SetAttr(char,'attackBonus',oldBonus)
        makephase(char,10*bonus)

def energisetophase(event):
    char=event.object
    source=event.string
    if FFX_GotState(char,SCSTATE_ENERGIZED):
        Object_SetSecondaryState(char,SCSTATE_ENERGIZED,0,REMOVE_STATE)
        FFX_UpdateStates(char)
        makephase(char,5)

def energysurgetophase(event):
    char=event.object
    source=event.string
    if FFX_GotState(char,SCSTATE_AREA_ENERGIZED):
        Object_SetSecondaryState(char,SCSTATE_AREA_ENERGIZED,0,REMOVE_STATE)
        FFX_UpdateStates(char)
        makephase(char,5)

def makephase(char,intensity):
    Object_SetSecondaryState(char,SCSTATE_DISPLACE_IMAGE,intensity,0)
    FFX_ObjectSetAttr(char,'phased',1)

def makeUnphase(char):
    Object_SetSecondaryState(char,SCSTATE_DISPLACE_IMAGE,0,REMOVE_STATE)
    FFX_ObjectSetAttr(char,'phased',0)

################### CLOAKER ##########################################

def rallytocloak(event):
    char=event.object
    source=event.string
    bonus=Object_GetAttr(char,'attackBonus')
    oldBonus=Object_GetAttr(char,'oldAttackBonus')
    if bonus!=oldBonus:
        Object_SetAttr(char,'attackBonus',oldBonus)
        makecloak(char,10*bonus)

def energisetocloak(event):
    char=event.object
    source=event.string
    if FFX_GotState(char,SCSTATE_ENERGIZED):
        Object_SetSecondaryState(char,SCSTATE_ENERGIZED,0,REMOVE_STATE)
        FFX_UpdateStates(char)
        makecloak(char,5)

def energysurgetocloak(event):
    char=event.object
    source=event.string
    if FFX_GotState(char,SCSTATE_AREA_ENERGIZED):
        Object_SetSecondaryState(char,SCSTATE_AREA_ENERGIZED,0,REMOVE_STATE)
        FFX_UpdateStates(char)
        makecloak(char,5)

def makecloak(char,intensity):
    Object_SetSecondaryState(char,SCSTATE_INVISIBLE,intensity,0)
    FFX_ObjectSetAttr(char,'cloaked',1)

def makeUncloak(char):
    Object_SetSecondaryState(char,SCSTATE_INVISIBLE,0,REMOVE_STATE)
    FFX_ObjectSetAttr(char,'cloaked',0)

################### SHIELD ##########################################
# stumpy 2007-10-31: trying to make it so a character can have more
# than one shield power, if they use a different carrier for each.

def rallytoshield(event):
    char=event.object
    source=event.string
    bonus=Object_GetAttr(char,'attackBonus')
    oldBonus=Object_GetAttr(char,'oldAttackBonus')
    if bonus!=oldBonus:
        Object_SetAttr(char,'attackBonus',oldBonus)
        makeshieldS(char,source,0,datfiles.PT_SPECIAL_RALLY)

def energisetoshield(event):
    char=event.object
    source=event.string
    if FFX_GotState(char,SCSTATE_ENERGIZED):
        Object_SetSecondaryState(char,SCSTATE_ENERGIZED,0,REMOVE_STATE)
        FFX_UpdateStates(char)
        makeshieldS(char,source,-1,datfiles.PT_SPECIAL_ENERGIZE)

def energysurgetoshield(event):
    char=event.object
    source=event.string
    if FFX_GotState(char,SCSTATE_AREA_ENERGIZED):
        Object_SetSecondaryState(char,SCSTATE_AREA_ENERGIZED,0,REMOVE_STATE)
        FFX_UpdateStates(char)
        makeshieldS(char,source,-1,datfiles.PT_SPECIAL_ENERGIZE_AREA)

def speedincreasetoshield(event):
    char=event.object
    source=event.string
    if FFX_GotState(char,SCSTATE_SPEED_INCREASED):
        Object_SetSecondaryState(char,SCSTATE_SPEED_INCREASED,0,REMOVE_STATE)
        FFX_UpdateStates(char)
        makeshieldN(char,source,-1,datfiles.PT_DAMAGE_SPEED_INCREASE)

# Need to add other types: speed increase, weaken, deep sensor, etc.

# Note that we could pass the Power ID numbers instead of the state
# numbers for non-'custom_template_#' template characters. In that
# way, such characters could have multiple shield powers with the same
# carrier type and have non-carrier powers with the same damage type
# as the carriers. Probably worth doing for campaign use.

# make shield from a normal damage type, e.g. hex, speed increase, etc
def makeshieldN(char,source,intensity,state=-1):
    global getByTemplateAndMatch_matched    # declaration not needed
    ##print 'ffx.makeshieldN(%s,%s,%d,%d) called' % (repr(char),repr(source),intensity,state)
    MPSendMessage(MP_SHIELD_N,Object_GetAttr(char,'ffxMPID'),Object_GetAttr(source,'ffxMPID'),intensity*100+state)
    if ( source != '' ) and ( state != -1 ):    # source and state were given
        SourcePowers = GetCharacterData(source)['powers']
        found = 0
        for p in SourcePowers.keys():
            if SourcePowers[p].get('DamageType') == state:
                shield = getByTemplateAndMatch(source,p, FFX_REMOTEAD_CUSTOM,2)
                found = getByTemplateAndMatch_matched
                if found:   break
        if found:
            Trigger_Power(char,char,shield,'',intensity)
            return
        else:   # print warning, but still use default
            print 'ffx.makeshieldN WARNING: No power matched for shield for source=%s(%s) state=%d(%s)' % \
                  (source,GetCharacterData(source)['charName'],state,datfiles.PT_DAMAGE_TYPES.get(state))
    shield=getByTemplate(source,FFX_SHIELD_POWERS,1)
    Trigger_Power(char,char,shield,'',intensity)

# make shield from a special damage type, e.g. energize,cloak
def makeshieldS(char,source,intensity,state=-1):
    global getByTemplateAndMatch_matched    # declaration not needed
    ##print 'ffx.makeshieldS(%s,%s,%d,%d) called' % (repr(char),repr(source),intensity,state)
    MPSendMessage(MP_SHIELD_S,Object_GetAttr(char,'ffxMPID'),Object_GetAttr(source,'ffxMPID'),intensity*100+state)
    if ( source != '' ) and ( state != -1 ):    # source and state were given
        SourcePowers = GetCharacterData(source)['powers']
        found = 0
        for p in SourcePowers.keys():
            if SourcePowers[p].get('SpecialType') == state:
                shield = getByTemplateAndMatch(source,p, FFX_REMOTEAD_CUSTOM,2)
                found = getByTemplateAndMatch_matched
                if found:   break
        if found:
            Trigger_Power(char,char,shield,'',intensity)
            return
        else:   # print warning, but still use default
            print 'ffx.makeshieldS warning: No power matched for shield for source=%s(%s) state=%d(%s)' % \
                  (source,GetCharacterData(source)['charName'],state,datfiles.PT_SPECIAL_TYPES.get(state))
    shield=getByTemplate(source,FFX_SHIELD_POWERS,1)
    Trigger_Power(char,char,shield,'',intensity)

################### NORMALISER ##########################################

def rallytonormalise(event):
    char=event.object
    source=event.string
    bonus=Object_GetAttr(char,'attackBonus')
    oldBonus=Object_GetAttr(char,'oldAttackBonus')
    if bonus!=oldBonus:
        Object_SetAttr(char,'attackBonus',oldBonus)
        makenormalise(char)

def energisetonormalise(event):
    char=event.object
    source=event.string
    if FFX_GotState(char,SCSTATE_ENERGIZED):
        Object_SetSecondaryState(char,SCSTATE_ENERGIZED,0,REMOVE_STATE)
        FFX_UpdateStates(char)
        makenormalise(char)

def energysurgetonormalise(event):
    char=event.object
    source=event.string
    if FFX_GotState(char,SCSTATE_AREA_ENERGIZED):
        Object_SetSecondaryState(char,SCSTATE_AREA_ENERGIZED,0,REMOVE_STATE)
        FFX_UpdateStates(char)
        makenormalise(char)

def makenormalise(target):
    MPSendMessage(MP_NORMALISE,Object_GetAttr(target,'ffxMPID'))
    #magnetised
    if FFX_ObjectGetAttr(target,'magnetised')>1:
        FFX_ObjectSetAttr(target,'magnetised',1)
    #vertigo
    if FFX_ObjectGetAttr(target,'vertigo')>1:
        FFX_ObjectSetAttr(target,'vertigo',1)
    #gravity control
    if (Object_GetAttr(target,'baseStrength')>(Object_GetAttr(target,'strength')+0.4)):
        Object_GetAttr(target,'strength',Object_GetAttr(target,'baseStrength')-0.4)
    Object_SetSecondaryState(target,SCSTATE_ACID_BURNT,0,REMOVE_STATE)
    Object_SetSecondaryState(target,SCSTATE_IRRADIATED,0,REMOVE_STATE)
    Object_SetPrimaryState(target,PCSTATE_STATIC,0,REMOVE_STATE)
    Object_SetPrimaryState(target,PCSTATE_FROZEN,0,REMOVE_STATE)

################### HEALER ##########################################

def rallytoheal(event):
    char=event.object
    source=event.string
    bonus=Object_GetAttr(char,'attackBonus')
    oldBonus=Object_GetAttr(char,'oldAttackBonus')
    if bonus!=oldBonus:
        RegTimer('removeFX',0.5,1,char)
        bonus=Object_GetAttr(char,'attackBonus')*COST_RALLY
        Object_SetAttr(char,'attackBonus',oldBonus)
        makehealed(char,bonus)

def buoyancytoheal(event):
    char=event.object
    source=event.string
    bonus=5*COST_BUOYANCY
    if bonus>=1:
        RegTimer('removeFX',0.5,1,char)
        makehealed(char,bonus)

def increasetoheal(event):
    char=event.object
    source=event.string
    bonus=5*COST_INCREASE
    if bonus>=1:
        RegTimer('removeFX',0.5,1,char)
        makehealed(char,bonus)

def energisetoheal(event):
    char=event.object
    source=event.string
    bonus=5*COST_ENERGYSURGE
    if bonus>=1:
        RegTimer('removeFX',0.5,1,char)
        makehealed(char,bonus)

def energysurgetoheal(event):
    char=event.object
    source=event.string
    bonus=5*COST_ENERGYSURGE
    if bonus>=1:
        RegTimer('removeFX',0.5,1,char)
        makehealed(char,bonus)

def makehealed(target,bonus):
    Trigger_Damage(target,-bonus*5)

#################### LIMEYLURE SWAPS ################################

def getLure():
    list=cshelper.getAll('standard_image_projection')
    if len(list)>0:
        focus=list[-1]
        if Object_GetAttr(focus,'complex')==69:
            return ''
        Object_SetAttr(focus,'complex',69)
        return focus
    else:
        return ''

def limeyluretoicepatch(event):
    focus=getLure()
    #print 'lltoicepatch:focus=%s'%(focus)
    if focus=='':
        return
    name='x%s'%(focus)
    if Object_Exists(name):
        return
    template=getByTemplate(event.string,FFX_OBJECT_TEMPLATE,1)
    cshelper.spawn(name,template,focus)
    fx='effect_%s'%(Object_GetTemplate(name))
    try:
        Object_PlayEffect(name,fx,'',FX_LOOP)
    except:
        pass
    Object_Destroy(focus)
    RegTimer('OnIcePatch2',1,6,name)

def limeyluretoicewall(event):
    focus=getLure()
    if focus=='':
        return
    source=event.string
    name=getDummyName()
    cshelper.spawn(name,'ffx_icewall',focus)
    RegTimer('OnIceWall2',0.1,0,name,source)
    Object_Destroy(focus)

def limeyluretofirewall(event):
    focus=getLure()
    if focus=='':
        return
    source=event.string
    name=getDummyName()
    cshelper.spawn(name,'ffx_flames',focus)
    Object_PlayEffect(name,'effect_ffx_flames2','',FX_LOOP)
    RegTimer('OnFireWall2',0.1,0,name,source)
    RegTimer('OnFlames',1,6,name)
    Object_Destroy(focus)

def limeyluretosummon(event):
    focus=getLure()
    if focus=='':
        return
    source=event.string
    name=getDummyName()
    template=getByTemplate(source,FFX_OBJECT_TEMPLATE,1)
    FFX_Spawn(name,template,focus)
    Object_Destroy(focus)
    if Object_GetClass(name)&OC_CONTROLLABLE:
        FFX_DestroyPortrait(name)
    initMinionAI(name,m25ai.GetTeam(source),'',isEvil(source))
    if usingM25AI():
        m25ai.AddGoal_HuntEnemy(name)
    #m25ai.DoBrawl(name)

#removes the portrait but keeps the character ticking as a real live AI
def FFX_DestroyPortrait(name):
    AI_DestroyHeroAI(name)
    AI_MakeHeroAI(name)
    FFX_ObjectSetAttr(name,'fakehero',1)
    #refresh their brawl parameters
    if usingM25AI(): # Kuertee 2006-07-30 - check usingM25AI () first before calling brawl
        m25getset.SetObjectVar(name,m25ai.BRAWL_OLDTARGET,'')
        m25ai.DoBrawl(name)

def FFX_AdjustPortrait(char,port):
    hasport=FFX_HasPortrait(char)
    if port and hasport==0:
        FFX_AddPortrait(char)
    if port==0 and hasport:
        FFX_DestroyPortrait(char)

def FFX_AddPortrait(name):
    if Object_GetClass(name)&OC_CONTROLLABLE==0:
       AI_MakeHeroAI(name)
    AI_MakeIntoHero(name)
    FFX_ObjectSetAttr(name,'fakehero',0)

#returns if they have a portrait or not
def FFX_HasPortrait(name):
    if Object_GetClass(name)&OC_CONTROLLABLE==0:
        return 0
    return FFX_ObjectGetAttr(name,'fakehero',0)!=1

def limeyluretopull(event):
    focus=getLure()
    if focus!='':
        pullCheck(focus,2)
        Object_Destroy(focus)

def limeyluretocrystallise(event):
    focus=getLure()
    if focus=='':
        return
    Trigger_Explosion(focus,'ffx_hexarea')
    RegTimer('crystalCheck',1,stateintensity[int(event.user)],focus)
    RegTimer('destroyTemp',1.1,0,focus)

def limeyluretovertigo(event):
    focus=getLure()
    if focus=='':
        return
    Trigger_Explosion(focus,'ffx_blankarea')
    RegTimer('vertigoCheck',1,stateintensity[int(event.user)],focus)
    RegTimer('destroyTemp',1.1,0,focus)

def limeyluretofirecage(event):
    focus=getLure()
    if focus=='':
        return
    Trigger_Explosion(focus,'ffx_hexarea')
    RegTimer('firecageCheck',1,stateintensity[int(event.user)],focus)
    RegTimer('destroyTemp',1.1,0,focus)

def limeyluretoshrink(event):
    focus=getLure()
    if focus=='':
        return
    Trigger_Explosion(focus,'ffx_hexarea')
    RegTimer('shrinkCheck',1,stateintensity[int(event.user)],focus)
    RegTimer('destroyTemp',1.1,0,focus)

def limeyluretogravityincrease(event):
    focus=getLure()
    if focus=='':
        return
    Trigger_Explosion(focus,'ffx_hexarea')
    RegTimer('gravityCheck',1,stateintensity[int(event.user)],focus)
    RegTimer('destroyTemp',1.1,0,focus)

def limeyluretomagnetpull(event):
    focus=getLure()
    if focus=='':
        return
    pullCheck(focus,6,1)
    Object_Destroy(focus)

def limeyluretomentaldamage(event):
    focus=getLure()
    if focus=='':
        return
    Trigger_Explosion(focus,'ffx_blankarea')
    RegTimer('mentaldamageCheck',1,stateintensity[int(event.user)],focus)
    RegTimer('destroyTemp',1.1,0,focus)

def limeyluretoteleport(event):
    focus=getLure()
    if focus=='':
        return
    Trigger_Explosion(focus,'ffx_hexarea')
    RegTimer('teleportCheck',1,stateintensity[int(event.user)],focus)
    RegTimer('destroyTemp',1.1,0,focus)

def limeyluretopull(event):
    focus=getLure()
    if focus=='':
        return
    pullCheck(focus,2)
    Object_Destroy(focus)

def limeyluretothrow(event):
    focus=getLure()
    if focus=='':
        return
    throwCheck(focus,2)
    Object_Destroy(focus)

def limeyluretomagnetthrow(event):
    focus=getLure()
    if focus=='':
        return
    throwCheck(focus,6,1)
    Object_Destroy(focus)

def limeyluretostaticcage(event):
    focus=getLure()
    if focus=='':
        return
    Trigger_Explosion(focus,'ffx_hexarea')
    RegTimer('staticcageCheck',1,stateintensity[int(event.user)],focus)
    RegTimer('destroyTemp',1.1,0,focus)

def limeyluretoweaken(event):
    focus=getLure()
    if focus=='':
        return
    Trigger_Explosion(focus,'ffx_hexarea')
    RegTimer('weakenCheck',1,stateintensity[int(event.user)],focus)
    RegTimer('destroyTemp',1.1,0,focus)

#####################################################################

def FFX_SetStrength(char,value,lifting=1):
    if lifting:
        str=Object_GetAttr(char,'templateStrength')+value
        if str<0:
            str=0
        if str>9:
            str=9
        Object_SetAttr(char,'strength',str)
        Object_SetAttr(char,'baseStrength',str)
    if Object_GetAttr(char,'oldAttackBonus')==1 and value!=0:
        Object_SetGenericState(char,OBJSTATE_ATTACKBONUS,10000,0)
        RegTimer('removeFX',0.5,1,char)
    if value==0:
        Object_SetAttr(char,'attackBonus',1)
        Object_SetAttr(char,'oldAttackBonus',1)
        Object_SetGenericState(char,OBJSTATE_ATTACKBONUS,0,REMOVE_STATE)
        return
    if value>=0:
        Object_SetAttr(char,'attackBonus',1.0+value/3.0)
        Object_SetAttr(char,'oldAttackBonus',1.0+value/3.0)
        if FFX_ObjectGetAttr(char,'xtrakb')==0:
            RegExtraKB(char)
    else:
        Object_SetAttr(char,'attackBonus',-1.0/(value-1.0))
        Object_SetAttr(char,'oldAttackBonus',-1.0/(value-1.0))

def FFX_SetMassFactor(char,factor):
    Object_SetAttr(char,'mass',FFX_ObjectGetAttr(char,'baseMass')*factor)
    Object_SetAttr(char,'minForce',FFX_ObjectGetAttr(char,'baseMinForce')*factor)

def RegExtraKB(char):
#    print 'setting extra knockback up'
    FFX_ObjectSetAttr(char,'xtrakb',1)
    RegTimer('KBUpdate',1,0,char)

def KBUpdate(event):
    char=event.object
    attrName='OnKB%s'%(char)
    for obj in Mission_GetDynamicObjects():
        if Object_GetClass(obj)&FFX_CHARACTER:
            if (FFX_ObjectGetAttr(obj,attrName)==0):
                FFX_ObjectSetAttr(obj,'lhKB',Object_GetAttr(obj,'health'))
                RegDamage(obj,'OnKBDamage',0,1)
    if Object_GetAttr(char,'complex')>1000:
        regPowerAgainstChars(char,'OnKB',FFX_POWER_CUSTOM,event.user)
    else:
        regPowerAgainstChars(char,'OnKB',0)
    RegTimer('KBUpdate',6,1,char)

EXTRA_KB_SCALE=10000

def OnKBDamage(event):
    char=event.object
    if Object_Exists(char):
        FFX_ObjectSetAttr(char,'lhKB',Object_GetAttr(char,'health'))
        RegTimer('OnKBDamageOff',0.1,0,char)

def OnKBDamageOff(event):
    char=event.object
    FFX_ObjectSetAttr(char,'kbdamage',0)

def OnKB(event):
    char=event.string
    mag=Object_GetAttr(char,'attackBonus')-1
    if mag<=0:
        return
    target=event.object
    if Object_GetAttr(target,'health')==FFX_ObjectGetAttr(target,'lhKB') and FFX_ObjectGetAttr(target,'kbdamage')==0:
        return
    if FFX_ObjectGetAttr(target,'noforce'):
        #print 'forces turned off'
        return
    FFX_ObjectSetAttr(target,'noforce',1)
    RegTimer('resetForce',0.1,0,target)
    pos=Get_ObjectPos(char)
    tpos=Get_ObjectPos(target)
    dx=tpos[0]-pos[0]
    dy=tpos[1]-pos[1]
    d=sqrt(dx*dx+dy*dy)
    if d<60:
        Trigger_Force(target,dx/d,dy/d,1,mag*ffx.EXTRA_KB_SCALE,TF_ABSOLUTE)
    FFX_ScaleMass(target,1/(1+mag),0.1)

def FFX_ScaleMass(char,scale,duration):
    FFX_SetMassFactor(char,scale)
    if scale!=1:
        RegTimer('FFX_RestoreMass',duration,0,char)

def FFX_RestoreMass(event):
    FFX_ScaleMass(event.object,1,0)

def FFX_Rand(min,max):
    pct=Mission_GetAttr('random')
    pct=pct*2.1+23.7
    while pct>100:
        pct=pct-100
    Mission_SetAttr('random',pct)
    alpha=pct/100
    return int(alpha*(max+0.99)+(1-alpha)*min)

def FFX_ApplyDamage(char,damage,mental=0):
    hp=Object_GetAttr(char,'health')-damage
    if hp<Object_GetAttr(char,'minHealth'):
        hp=Object_GetAttr(char,'minHealth')
    elif hp>Object_GetAttr(char,'maxHealth'): ###!Ep 2006-02-06: for compatibility with negative damage
        hp=Object_GetAttr(char,'maxHealth')
    #mental damage bypasses most of these powers:
    if mental:
        FFX_SetDamageAttrs(char,hp)
    if hp>0:
        Object_SetAttr(char,'health',hp)
    else:
        Trigger_Damage(char,damage)

def FFX_SetDamageAttrs(char,hp):
    FFX_ObjectSetAttr(char,'ivlastdam',hp)
    Object_SetAttr(char,'lastHealthNS',hp)
    Object_SetAttr(char,'lastHealthAB',hp)
    Object_SetAttr(char,'lastHealthSP',hp)
    Object_SetAttr(char,'lastHealthES',hp)
    Object_SetAttr(char,'lastHealthDG',hp)
    Object_SetAttr(char,'lastHealthPL',hp)

def FFX_FactorHealth(char,factor):
    hp=Object_GetAttr(char,'health')*factor
    maxHP=Object_GetAttr(char,'maxHealth')*factor
    FFX_ObjectSetAttr(char,'ivlastdam',hp)
    Object_SetAttr(char,'lastHealthNS',hp)
    Object_SetAttr(char,'lastHealthAB',hp)
    Object_SetAttr(char,'lastHealthPC',hp)
    Object_SetAttr(char,'lastHealthSP',hp)
    Object_SetAttr(char,'lastHealthES',hp)
    Object_SetAttr(char,'lastHealthDG',hp)
    Object_SetAttr(char,'lastHealthPL',hp)
    Object_SetAttr(char,'health',hp)
    Object_SetAttr(char,'maxHealth',maxHP)

def FFX_SetEnergy(char,value):
    if hasAttribute(char,'battery')==0:
        Object_SetAttr(char,'energy',value)
    else:
        ep=Object_GetAttr(char,'energyPoints')
        maxEP=Object_GetAttr(char,'maxEnergyPoints')
        #are we initialising?
        if ((ep==100) | (ep==50) | (ep==400)) & (ep==maxEP):    # stumpy 2007-03-30: shouldn't this take into account the extra 5 EP DrMike adds to alter the number of energy bars?
            Object_SetAttr(char,'energy',0)
            maxEP=200*(1+value)
            Object_SetAttr(char,'energyPoints',maxEP)
            Object_SetAttr(char,'maxEnergyPoints',maxEP)
        else:
            Object_SetAttr(char,'energy',0)
            newEP=200*(1+value)
            Object_SetAttr(char,'energyPoints',ep*newEP/maxEP)
            Object_SetAttr(char,'maxEnergyPoints',newEP)
        Mission_StatusText('[%d] %d:%d'%(value,Object_GetAttr(char,'energyPoints'),Object_GetAttr(char,'maxEnergyPoints')))

def FFX_GetSpeed(char):
    speed=Object_GetAttr(char,'speed')
    if speed<=9:
        return speed
    else:
        return Object_GetAttr(char,'baseSpeed')

def updateStates(event):
    RegTimer('updateStates',1)
    if cshelper.isPlaying():
        return
    for char in Mission_GetDynamicObjects():
        if Object_GetClass(char)&FFX_CHARACTER:
            #prevent shrunken players from breaking the spell
            if FFX_HasPortrait(char):
                if Object_GetAttr(char,'ffxState')==FFX_STATE_SHRUNK:
                    makecloak(char,1)
                    Trigger_Move(char,'lock')
                #and make sure TK ers drop their stuff when stunned etc and get commands for throwing at the right time.
                if hasAttribute(char,'telekinetic') | hasAttribute(char,'supertk') | hasAttribute(char,'magnetic') | hasAttribute(char,'earthcontrol'):
                    updateTK(char)
            #vertigo'd characters 
            vertigo=FFX_ObjectGetAttr(char,'vertigo')
            if vertigo>0:
                #todo - screen out frozen and static and crystallised etc.
                if Object_IsAlive(char):
                    thing=FFX_Rand(1,6)
                    if (thing==1):
                        fallOver(char)
                    elif (thing==2):
                        pos=Get_ObjectPos(char)
                        pos2=(pos[0]+FFX_Rand(-50,50),pos[1]+FFX_Rand(-50,50),pos[2])
                        Trigger_Move(char,'move',pos2)
                else:
                    vertigo=1
                vertigo=vertigo-1
                if vertigo<=0:
                    Object_StopEffect(char,FFX_ObjectGetAttr(char,'vertigoHandle',-1))
                    FFX_ObjectSetAttr(char,'vertigoHandle',-1)
                    vertigo=0
                FFX_ObjectSetAttr(char,'vertigo',vertigo)
            #gravitied characters
            str=Object_GetAttr(char,'strength')
            if str<0:
                FFX_ApplyDamage(char,-str)
            baseStr=Object_GetAttr(char,'baseStrength')
            if str<baseStr:
                str=str+0.33
                dstr=(baseStr-str)/baseStr
                if dstr<0:
                    dstr=0
                #modify speed
                speed=Object_GetAttr(char,'baseSpeed')*dstr+(1-dstr)
                Object_SetAttr(char,'speed',speed)
                mass=FFX_ObjectGetAttr(char,'baseMass')
                while dstr>0:
                    dstr=dstr-0.33
                    mass=mass*1.5
                Object_SetAttr(char,'mass',mass)
                #Mission_StatusText('%s:STR=%d SPD=%d mass=%d'%(char,Object_GetAttr(char,'strength'),Object_GetAttr(char,'speed'),Object_GetAttr(char,'mass')))
            else:
                handle=FFX_ObjectGetAttr(char,'gravityHandle',-1)
                if handle!=-1:
                    Object_StopEffect(char,handle)
                    FFX_ObjectSetAttr(char,'gravityHandle',-1)
                    Object_SetAttr(char,'speed',Object_GetAttr(char,'baseSpeed'))
                    Object_SetAttr(char,'mass',FFX_ObjectGetAttr(char,'baseMass'))

def setFFXState(char,state):
    myState=Object_GetAttr(char,'ffxState')
    if myState>800:
        Object_SetAttr(char,'ffxState',800+state)
    else:
        Object_SetAttr(char,'ffxState',state)

################### GENDER DETERMINATION ####################################

def getGender(char):
    template=FFX_GetTemplate(char)
    for v in beasts:
        if v==template:
            return FFX_GENDER_ANIMAL
    for v in mechs:
        if v==template:
            return FFX_GENDER_ROBOT
    for v in aliens:
        if v==template:
            return FFX_GENDER_ALIEN
    for v in girls:
        if v==template:
            return FFX_GENDER_FEMALE
    for v in boys:
        if v==template:
            return FFX_GENDER_MALE
    try:
        voice=Template_GetSpeechID(Object_GetTemplate(char))
    except:
        voice=''
    for v in beasts:
        if v==voice:
            return FFX_GENDER_ANIMAL
    for v in mechs:
        if v==voice:
            return FFX_GENDER_ROBOT
    for v in aliens:
        if v==voice:
            return FFX_GENDER_ALIEN
    for v in girls:
        if v==voice:
            return FFX_GENDER_FEMALE
    return FFX_GENDER_MALE

def setGender(char,force=0):
    if (force!=0) | (Object_GetAttr(char,'gender')==FFX_GENDER_UNKNOWN):
        gender=getGender(char)
        #print 'determining gender %s (team=%d)'%(char,m25ai.GetTeam(char))
        #evil gender if an enemy to the default hero team 
        if usingM25AI() and m25ai.GetTeamsReaction(m25ai.GetTeam(char),m25ai.TEAM_GOODGUYS)==m25ai.TEAM_ENEMIES:
            #if Object_GetAttr(char,'team')>1:
             #print 'M25 evil! - (*ahem* M25 is not evil)'
             gender=gender+FFX_GENDER_EVIL
        else:
            if ((Object_GetClass(char)&OC_MINION)!=0) | ((Object_GetClass(char)&OC_VILLIAN)!=0):
                gender=gender+FFX_GENDER_EVIL
        Object_SetAttr(char,'gender',gender)

##################################################################
#
# given a character's template, find their entry (if any) in customisation array
#
##################################################################

def getByTemplate(char,array,index,isTemplate=0):
    #dont check the special arrays for multiplayer
    result=array[0][index]
    if isMP():
        return result

    template=char
    realName=''
    if isTemplate==0:
        template=Object_GetTemplate(char)
        realName=FFX_GetTemplate(char)
    for elem in array:
        if (elem[0]==template) | (elem[0]==realName):
            result=elem[index]
            break ####! Ep. 2008-05-15: added to prevent looping uselessly through the rest of the lists 
    return result

def getRowByTemplate(char,array):
    realName=FFX_GetTemplate(char)
    template=Object_GetTemplate(char)
    index=0
    for elem in array:
        if (elem[0]==template) | (elem[0]==realName):
            return index
        index=index+1
    return 0

def getTemplateFromRealName(name):
    try:
       num=Mission_GetAttr('%s_ID'%(name))
       return 'custom_template_%i'%(num)
    except:
       return ''

# stumpy 2007-10-31: for use with modified shield swaps
# Grab a value from an array that is indexed both by a character
# template and by a match of the second column with parameter matchstr
# NB: The getByTemplateAndMatch_matched global indicated whether a
# match was found (otherwise the default was returned). It's possible
# that another function will have called this function before the
# previous caller checks the value of getByTemplateAndMatch_matched.
def getByTemplateAndMatch(char,matchstr,array,index,isTemplate=0):
    global getByTemplateAndMatch_matched
    result=array[0][index]
    #dont check the special arrays for multiplayer
    if isMP():
        getByTemplateAndMatch_matched = 1
        return result

    template=char
    realName=''
    if isTemplate==0:
        template=Object_GetTemplate(char)
        realName=FFX_GetTemplate(char)
    getByTemplateAndMatch_matched = 0
    for elem in array:
        if ( ( elem[0] == template ) or ( elem[0] == realName ) ) and ( elem[1] == matchstr ):
            getByTemplateAndMatch_matched = 1
            result=elem[index]
    return result

###################### FIND THE TEMPLATES OF ALL PROP OBJECTS ##################################

#the tuples stored in here are template, mass and material
#if the object isnt throwable, mass gets listed as :

FFX_TOO_HEAVY=10000000

def fillTemplateList(): # stumpy 2006-08-26: removed Object_Exists(obj) test
    #Ep. 2006-09-10: Prevent the map itself (whose template is '') from appearing in that list
    staticObjects = list( Mission_GetObjects() )
    staticObjects.remove( Object_GetTerrain() )
    for obj in staticObjects:
        if (Object_GetClass(obj)&FFX_CHARACTER)==0:
            if Object_GetAttr(obj,'throwable')!=0:
                throwObjects.append(obj)
            temp=Object_GetTemplate(obj)
            match=0
            for template in templates:
                if temp==template[0]:
                    match=1
            if match==0:
                mass=FFX_TOO_HEAVY
                if isTKable(obj):
                    mass=Object_GetAttr(obj,'mass')    
                templates.append((temp,mass,Object_GetAttr(obj,'material')))
    #special case for debris
    templates.append('building_debris_0',150,FFX_MATERIAL_STONE)
    templates.append('red_int_stalagmite',200,FFX_MATERIAL_STONE)
    templates.append('alien_mineral',20,0)
    templates.append('ffx_flames',FFX_TOO_HEAVY,4)
    templates.append('ffx_firecage',FFX_TOO_HEAVY,4)
    templates.append('ffx_crystalprison',FFX_TOO_HEAVY,2)
    templates.append('ffx_amber',FFX_TOO_HEAVY,2)
    templates.append('ffx_greencage',FFX_TOO_HEAVY,5)
    templates.append('ffx_atomiccage',FFX_TOO_HEAVY,5)
    templates.append('door_1',FFX_TOO_HEAVY,FFX_MATERIAL_METAL)
    templates.append('door_2',FFX_TOO_HEAVY,FFX_MATERIAL_METAL)
    templates.append('door_3',FFX_TOO_HEAVY,FFX_MATERIAL_METAL)
    #add in any throwable plasma sculptor objects that may get spawned
    for set in FFX_PLASMA_CUSTOM:
        templates.append(set[2],1000,5)

###################### UPDATE #############################################################

def GetAllHeroes():
    objects = js.Mission_GetDynamicObjects()
    heroes = []
    for object in objects:
        if FFX_HasPortrait(object):
            heroes.append(object)
    return heroes

def OnDie(event):
    obj=event.object
    damage=Object_GetAttr(obj,'health')
    if damage<1:
        damage=1
    Trigger_Damage(obj,damage)

###################### HERO (and non-HERO!) MORPHING ######################################################

def getFormName():
    count=Mission_GetAttr('formCount')
    dummyName='form_%d'%(count)
    Mission_SetAttr('formCount',count+1)
    return dummyName

def makeAttrSafe(char):
    if not Object_Exists(char): ###! changed from if Object_Exists(char)
        return
    Object_SetAttr(char,'spinning',0)
    Object_SetAttr(char,'lastX',Get_ObjectPos(char)[0])
    Object_SetAttr(char,'lastY',Get_ObjectPos(char)[1]) ###! changed from Object_SetAttr(char,'lastY',Get_ObjectPos(char)[0])

################## new FFvTTR compatible morph function #################################
# name - object name for new form
# char - object name of old form
# template - template to morph into
# proprotional - whether to scale or retain maximum Health
# hasPortrait - true if triggered from a custom command, ie the character is controllable
##########################################################################################


def morph(name,char,template,proportional=0,hasPortrait=1):
    morphVars=['shapeRow','ffqgestaltRow','originalIndex','shots0','shots1','shots2','shots3'] #Ep. 2008-04-20: added ffqgestaltRow for said attribute
    if FFX_ObjectGetAttr(char,'morphing',0)==1:
        return
    FFX_ObjectSetAttr(char,'morphing',1)
    OnDrop(char,char)
    #store the RPG state of the character
    Mission_SetAttr('maxHealth_%s'%(name),Object_GetAttr(char,'maxHealth'))
    Mission_SetAttr('health_%s'%(name),Object_GetAttr(char,'health'))
    Mission_SetAttr('energyPoints_%s'%(name),Object_GetAttr(char,'energyPoints'))
    Mission_SetAttr('maxEnergyPoints_%s'%(name),Object_GetAttr(char,'maxEnergyPoints'))
    Mission_SetAttr('heroPoints_%s'%(name),Object_GetAttr(char,'heroPoints'))
    for var in morphVars:
        FFX_ObjectSetAttr(name,var,FFX_ObjectGetAttr(char,var))
    #set up appropriate M25 AI variables
    try:
        Mission_SetAttr('team_%s'%(name),m25ai.GetTeam(char))
        Mission_SetAttr('brawler_%s'%(name),m25ai.GetBrawler(char))
    except:
        pass
    #destroy the old portrait and turn off AI
    if (hasPortrait):
        AI_DestroyHeroAI(char)
    m25ai.AIDisable(char)
    Trigger_Move(char,'lock')
    cmd="morph2('%s','%s','%s',%d,%d)"%(name,char,template,proportional,hasPortrait)
    RegTimer('execTimer',0.1,0,cmd)
    RegTimer('destroyTemp',0.2,0,char)

def execTimer(event):
    #print event.object
    exec(event.object)

def morph2(name,char,template,proportional,hasPortrait):
    #spawn the new form in the same spot as the old one
    FFX_Spawn(name,template,char)
    FFX_ObjectSetAttr(name,'morph',1)
    #make sure they have a template as appropriate
    if hasPortrait and (Object_GetClass(name)&OC_CONTROLLABLE)==0:
        AI_MakeIntoHero(name)
    if (hasPortrait==0) and (Object_GetClass(name)&OC_CONTROLLABLE)!=0:
        FFX_DestroyPortrait(name)
    if hasPortrait:
        Mission_SelectHero(name)
    team=Mission_GetAttr('team_%s'%(name))
    initMinionAI(name,team,'',isEvil(name))
    if usingM25AI():
        m25ai.TransferAI(name,char)
    Object_PlayEffect(name,getMorphFX(char),'',FX_TRACK_OBJECT_FULL)
    #restore health etc as appropriate
    if proportional==0:
        Object_SetAttr(name,'health',Mission_GetAttr('health_%s'%(name)))
        Object_SetAttr(name,'maxHealth',Mission_GetAttr('maxHealth_%s'%(name)))
    else:
        #maxhealth is set by template
        Object_SetAttr(name,'health',(Mission_GetAttr('health_%s'%(name))*Object_GetAttr(name,'maxHealth'))/Mission_GetAttr('maxHealth_%s'%(name)))
    Object_SetAttr(name,'energyPoints',Mission_GetAttr('energyPoints_%s'%(name)))
    Object_SetAttr(name,'heroPoints',Mission_GetAttr('heroPoints_%s'%(name)))
    if Object_IsAlive(name)==0:
        Object_SetAttr(name,'health',1)
        kill(name)

def getMorphFX(char):
    name=FFX_GetTemplate(char)
    fx='effect_entropy_spawn'
    for set in FFX_SHAPESHIFT_CUSTOM:
        if set[0]==name:
            fx=set[1]
    for set in FFX_TEMPFORM_CUSTOM:
        if set[0]==name:
            fx=set[1]
    for set in FFX_MIMIC_CUSTOM:
        if set[0]==name:
            fx=set[1]
    for set in FFX_FFQGESTALT_CUSTOM:
        if set[0]==name:
            fx=set[1]
    return fx



def getDummyName():
    count=Mission_GetAttr('dummyCount')
    dummyName='mobjdummy_%d'%(count)
    Mission_SetAttr('dummyCount',count+1)
    return dummyName

def getLastDummyName():
    count=Mission_GetAttr('dummyCount')
    dummyName='mobjdummy_%d'%(count-1)
    return dummyName

###################### SPECIFIC ATTRIBUTES ################################################

###################### SHAPESHIFTER #######################################################

def initshapeshifter(char,update=0):
    if isMP():
        return
    for i in range(1,7):
        form=getByTemplate(char,FFX_SHAPESHIFT_CUSTOM,3+i)
        if form!='':
             customForm=form
             command=getByTemplate(customForm,FFX_TEMPFORM_CUSTOM,3,1)
             if command!='':
                 if command=='CUSTOM_FORM':
                     command='CUSTOM_FORM%i'%(i)
                 #print '%s to become %s'%(command,form)
                 action='OnForm%i'%(i)
                 Mission_CustomAction(command,char,char,action,5,0)
    #store the original row
    template=Object_GetTemplate(char)
    realName=''
    if template[:6]=='custom':
        realName=FFX_GetTemplate(char)
        #print realName
        newSet=[]
        needToAdd=1
        for set in FFX_SHAPESHIFT_CUSTOM:
            if set[0]==realName:
                for entry in set:
                    newSet.append(entry)
            if set[0]==template:
                needToAdd=0
        if needToAdd:
            if len(newSet) > 0: #Ep. 2006-08-24 - deals with empty shapeshifter customization list
                newSet[0]=template
            else:
                newSet = FFX_SHAPESHIFT_CUSTOM[0][:] #Ep. 2008-04-19: corrected invalid list, which had only a single item; using [:] to prevent overwriting the original data
                newSet[0] = template
            FFX_SHAPESHIFT_CUSTOM.append(newSet)
    i=0
    for set in FFX_SHAPESHIFT_CUSTOM:
        if (set[0]==template) | (set[0]==realName):
            FFX_ObjectSetAttr(char,'shapeRow',i)
            break #Ep. 2008-04-19: performance tweak
        i=i+1

def OnForm1(char,dummy):
    OnChange(char,0)

def OnForm2(char,dummy):
    OnChange(char,1)

def OnForm3(char,dummy):
    OnChange(char,2)

def OnForm4(char,dummy):
    OnChange(char,3)

def OnForm5(char,dummy):
    OnChange(char,4)

def OnForm6(char,dummy):
    OnChange(char,5)

def OnChange(char,index):
    if chargeEP(char,0)==0:
        return
    #shapechange identified - lets go! find the original form
    originalForm=FFX_SHAPESHIFT_CUSTOM[int(FFX_ObjectGetAttr(char,'shapeRow'))][0]
    newTemplate=getByTemplate(originalForm,FFX_SHAPESHIFT_CUSTOM,index+4,1)
    name=getFormName()
    morph(name,char,newTemplate,1,1)

def OnNPCChange(char,template):
    if template=='':
        return
    if chargeEP(char,0)==0:
        return
    name=getFormName()
    if FFX_HasPortrait(char): 
        morph(name,char,template,2,1)
    else:
        morph(name,char,template,2,0)

def inittempform(char,update=0):
    global FFX_SHAPESHIFT_CUSTOM
    if isMP():
        return
    #at startup add them into the default slots for shapeshifter
    if Mission_GetAttr('shapeReady')==0:
        for hero in cshelper.getAllHeroes():
            if hasAttribute(hero,'shapeshifter'):
               row=-1
               index=0
               for set in FFX_SHAPESHIFT_CUSTOM:
                   if set[0]==Object_GetTemplate(hero):
                       row=index
                   index=index+1
               if row==-1:
                   row=len(FFX_SHAPESHIFT_CUSTOM)
                   FFX_SHAPESHIFT_CUSTOM.append([Object_GetTemplate(hero),'effect_deja_clone','power','CUSTOM_FORM1','','','','','',''])
               index=4
               while index<10:
                   if FFX_SHAPESHIFT_CUSTOM[row][index]=='':
                       FFX_SHAPESHIFT_CUSTOM[row][index]=Object_GetTemplate(char)
                       index=11
                   else:
                       index=index+1
        RegTimer('destroyTemp',1,0,char)
        return
    row=int(FFX_ObjectGetAttr(char,'shapeRow'))
    for i in range(1,7):
        form=FFX_SHAPESHIFT_CUSTOM[row][3+i]
        if form!='':
             if form!=Object_GetTemplate(char):
                 command=getByTemplate(form,FFX_TEMPFORM_CUSTOM,3,1)
                 if command!='':
                     if command=='CUSTOM_FORM':
                         command='CUSTOM_FORM%i'%(i)
                     action='OnForm%i'%(i)
                     Mission_CustomAction(command,char,char,action,5,0)
    #put in a revert command to original form
    command=FFX_SHAPESHIFT_CUSTOM[row][3]
    Mission_CustomAction(command,char,char,'OnRevertFromTemp',5,0)
    #start checking for 
    revertFn=getByTemplate(char,FFX_TEMPFORM_CUSTOM,4)
    if revertFn!='':
        RegTimer('forceRevertCheck',1,0,char,revertFn)

def forceRevertCheck(event):
    char=event.object
    if Object_Exists(char)==0:
        return
    if Object_IsAlive(char)==0:
        return
    if FFX_ObjectGetAttr(char,'reverting',0)!=0:
        return
    fn=event.string
    RegTimer('forceRevertCheck',1,0,char,fn)
    forceback=0
    code='forceback=%s(char)'%(fn)
    exec code
    if forceback:
        FFX_ObjectSetAttr(char,'reverting',1)
        if event.user==0:
            OnRevertFromTemp(char,char,1)
        else:
            OnRevert(char,char)


def OnRevertFromTemp(dummy,char,forced=0):
    if forced==0:
        if chargeEP(char,0)==0:
            return
    row=int(FFX_ObjectGetAttr(char,'shapeRow'))
    template=FFX_SHAPESHIFT_CUSTOM[row][0]
    if FFX_TemplateExists(template)==0:
        customTemplate=getTemplateFromRealName(template)
        if FFX_TemplateExists(customTemplate):
            template=customTemplate
    name=getFormName()
    if FFX_HasPortrait(char): 
        morph(name,char,template,1,1)
    else:
        morph(name,char,template,1,0)

def awaken(char):
    Trigger_Move(char,'move',Get_ObjectPos(char))

def FFX_TemplateExists(template):
    if Template_Exists(template):
        return 1
    #deals with case of actual recruited characters in campaign
    if (Mission_GetAttr('ffxCampaign')!=0) & (Campaign_IsRecruited(template)):
        return 1
    #deals with danger room created templates
    if (Mission_GetAttr('ffxSkirmish')!=0) & (template[:16]=='custom_template_'):
        return 1
    return 0

##################### UNSTABLE MOLECULES ####################################################

def initxunstablemolecules(char,update=0):
    material=FFX_Rand(1,7)
    if material==6:
        material=9
    Object_SetAttr(char,'material',material)


######################### MIMIC ##############################################################
# The attribute itself (the initmimic() and OnMimic() functions) is obsolete, as it has been
# replaced by the attack type power swap of the same name. However, NPCMimic() and revertNPCMimic()
# don't seem used anywhere. The other functions are still used by the power swap.
def initmimic(char,update=0):
    if isMP():
        return
    attrName='%s_mimic'%(char)
    Global_RegisterAttr(attrName,0)
    for obj in Mission_GetDynamicObjects():
        if ((Object_GetClass(obj) & FFX_CHARACTER)!=0) & (obj!=char):
            if (Object_GetAttr(obj,attrName)==0):
                Mission_CustomAction('CUSTOM_MIMIC',char,obj,'OnMimic',FFX_MIMICRANGE,0)
                Object_SetAttr(obj,attrName,1)

def OnMimic(target,char):
    Trigger_Power(char,target,getByTemplate(char,FFX_MIMIC_CUSTOM,3),'')
    if chargeEP(char,0)!=0:
        RegTimer('OnMimicA',3,0,target,char)

def OnMimicA(event):
    global mimicTarget
    target=event.object
    char=event.string
    addHider()
    oldTemplate=FFX_GetTemplate(char)
    templateID=storeTemplate(char)
    count=Mission_GetAttr('formCount')
    dummyName=getFormName()
    template=Object_GetTemplate(target)
    if (FFX_GetTemplateMP(char)==builtinMimics[0]) & (mimicPrefix!=''):
        testTemplate='%s%s'%(mimicPrefix,FFX_GetTemplateMP(target))
        if Template_Exists(testTemplate):
            template=testTemplate
        testTemplate='%s_%s'%(FFX_GetTemplateMP(char),FFX_GetTemplateMP(target))
        if Template_Exists(testTemplate):
            template=testTemplate
    mimicTarget=target
    morph(dummyName,char,template,0,FFX_HasPortrait(char))
    RegTimer('OnMimic2',2,templateID,dummyName,oldTemplate)

def OnMimic2(event):
    name=event.object
    template=event.string
    templateID=event.user
    FFX_ObjectSetAttr(name,'mimic',1)
    FFX_ObjectSetAttr(name,'templateID',templateID)
    Mission_CustomAction('CUSTOM_REVERT',name,name,'OnRevert',5,0)
    revertFn='isStunned'
    if revertFn!='':
        RegTimer('forceRevertCheck',1,0,name,revertFn)

def OnRevert(char,dummy):
    count=Mission_GetAttr('formCount')
    name=getFormName()
    RegTimer('Change2',1,count)
    Mission_SetAttr('formCount',count+1)
    morph(name,char,retrieveTemplate(FFX_ObjectGetAttr(char,'templateID')),0,FFX_HasPortrait(char))
    addHider()
    RegTimer('OnRevert2',2)

def OnRevert2(event):
    delHider()

def NPCMimic(target,char):
    print 'NPCMimic: target=%s char=%s'%(target,char)
    mimicID=storeTemplate(char)
    FFX_ObjectSetAttr(char,'templateID',mimicID)
    name=getFormName()
    template=Object_GetTemplate(target)
    FFX_ObjectSetAttr(name,'templateID',mimicID)
    Trigger_Power(char,target,getByTemplate(char,FFX_MIMIC_CUSTOM,3),'')
    cmd="morph('%s','%s','%s',0,0)"%(name,char,template)
    RegTimer('execTimer',3,0,cmd)
    FFX_ObjectSetAttr(name,'isMimic',1)
    RegTimer('revertNPCMimic',FFX_Rand(20,30),0,name)

def revertNPCMimic(event):
    char=event.object
    id=int(FFX_ObjectGetAttr(char,'templateID'))
    originalTemplate=retrieveTemplate(id)
    name=getDummyName()
    morph(name,char,originalTemplate,0,0)

############################ BUTTERFINGERS ###########################################

def initbutterfingers(char,update=0,remove=0):
    if remove:
        FFX_ObjectSetAttr(char,'butterfingers',0)
        return
    FFX_ObjectSetAttr(char,'butterfingers',1)
    if Mission_GetAttr('pickupReged')!=0:
        return
    Mission_SetAttr('pickupReged',1)
    lastMObj = 0
    for obj in Mission_GetObjects():    # stumpy 2007-02-19: changed to use Mission_GetObjects()
        if Object_Exists(obj):
            if (Object_GetAttr(obj,'wieldable')!=0) | (Object_GetAttr(obj,'throwable')!=0):
                RegPickup(obj,'onPickUpBF')
                if obj[:5] == 'mobj_':
                    lastMObj = int(obj[5:])
    RegTimer('checkNewMobjs',5.0,user=lastMObj,thing1=getLastDummyName())

# *** stumpy: try to catch new objects created, especially rubble which is useful to throwers
def checkNewMobjs(event):
    startCheckAt = int(event.user)
    lastMobj = startCheckAt
    stopCheckAt = startCheckAt + 200    # no more than this number of new objects created in 5 sec
    for i in range(startCheckAt,stopCheckAt+1):
        mobj = 'mobj_%d' % i
        if Object_Exists(mobj):
            RegPickup(mobj,'onPickUpBF')
            lastMobj = i
    lastDummyObj = int(event.object[10:])   # stumpy 2007-02-19: check for mobjdummy_# objects, too
    stopCheckAt = int(getLastDummyName()[10:])
    for i in range(lastDummyObj,stopCheckAt+1):
        mobj = 'mobjdummy_%d' % i
        if Object_Exists(mobj):
            RegPickup(mobj,'onPickUpBF')
    RegTimer('checkNewMobjs',5.0,user=lastMobj,thing1=('mobjdummy_%d' % (stopCheckAt+1)))

def onPickUpBF(event):
    object=event.object
    char=GetClosestChar2D(object)
    print '%s has picked up %s'%(char,object)
    RegPickup(object,'onPickUpBF')
    if FFX_ObjectGetAttr(char,'butterfingers',0):
        damage=FFX_Rand(-5,40)
        if damage>0:
            print 'whoops!:%d pts to %s'%(damage,event.object)
            Trigger_Damage(event.object,damage)
    if hasAttribute(char,'atomtouch'):
        duration=FFX_Rand(10,20)
        Object_SetGenericState(event.object,OBJSTATE_MOLECULAR_EXCITE,duration,0)

def GetClosestChar2D(obj):
    it=''
    minDist=0
    oPos=Get_ObjectPos(obj)
    for char in Mission_GetDynamicObjects():
        if Object_GetClass(char)&FFX_CHARACTER:
            cPos=Get_ObjectPos(char)
            dx=cPos[0]-oPos[0]
            dy=cPos[1]-oPos[1]
            dist=dx*dx+dy*dy
            if (it=='') |  (dist<minDist):
                it=char
                minDist=dist
    return it 


########################### DISPERSED FORM ############################################

def initdispersed(char,update=0,remove=0):
    if remove:
        FFX_ObjectSetAttr(char,'dispersedForm',0)
        maxHealth=Object_GetAttr(char,'maxHealth')*2
        baseHealth=Object_GetAttr(char,'health')*2
        Object_SetAttr(char,'lastHealthPC',baseHealth)
        Object_SetAttr(char,'maxHealth',maxHealth)
        Object_SetAttr(char,'health',baseHealth)
        FFX_ObjectSetAttr(char,'healthEMP',baseHealth)
    else:
        FFX_ObjectSetAttr(char,'dispersedForm',1)
        if update==0:
            halfHealth=Object_GetAttr(char,'maxHealth')/2
            FFX_SetDamageAttrs(char,halfHealth)
            Object_SetAttr(char,'lastHealthPC',halfHealth)
            Object_SetAttr(char,'maxHealth',halfHealth)
            Object_SetAttr(char,'health',halfHealth)
            FFX_ObjectSetAttr(char,'healthEMP',halfHealth)
        RegAlmostDead(char,'onDisperse')
        FFX_ObjectSetAttr(char,'lastDamageGoo',halfHealth)
        RegDamage(char,'makeGoo')

bodyPart=('Bip01 Head','Bip01 L Forearm','Bip01 R Forearm','Bip01 L Calf','Bip01 R Calf')

def makeGoo(event):
    char=event.object
    if FFX_ObjectGetAttr(char,'dispersedForm',0)==1:
        damage=FFX_ObjectGetAttr(char,'lastDamageGoo')-Object_GetAttr(char,'health')
        if damage>0:
            Object_PlayEffect(char,getByTemplate(char,FFX_DISPERSE_CUSTOM,4),'',0,0,bodyPart[randint(0,4)])
        FFX_ObjectSetAttr(char,'lastDamageGoo',Object_GetAttr(char,'health'))
        RegDamage(char,'makeGoo')

def onDisperse(event):
    char=event.object
    if FFX_ObjectGetAttr(char,'dispersedForm',0)==1:
        newHealth=Object_GetAttr(char,'maxHealth')
        if Object_GetTemplate(char)[:7]!='connect':
            newHealth=newHealth*FFX_ObjectGetAttr(char,'dispratio',0.66)
        elif Mission_GetAttr('ffxSkirmish'):
            newHealth=newHealth*0.5
        if newHealth>20:
            FFX_ObjectSetAttr(char,'dispersed',1)
            hero=event.object
            ff.RESULTBUBBLE_SCALE=0
            Object_SetPrimaryState(hero,PCSTATE_PANICKED,100,0)
            makecloak(hero,100)
            makephase(hero,100)
            Object_SetAttr(hero,'speed',0.5)
            RegTimer('keepPanicked',0.1,0,hero)
            RegTimer('UnDisperse',8,0,hero)
            RegTimer('splat',0.1,0,hero)
            pos=Get_ObjectPos(char)
            Object_SetAttr(char,'maxHealth',newHealth)
            Object_SetAttr(char,'health',newHealth)
            RegAlmostDead(char,'onDisperse')
        else:
            Object_SetAttr(char,'minHealth',-1)
            Trigger_Damage(char,10)
        RegTimer('onDisperseCB',1,0,char)

def splat(event):
    owner=event.object
    bubblesOn(event)    # stumpy 2006-12-24: moved this outsiide if make sure bubbles are turned back on
    if FFX_ObjectGetAttr(owner,'dispersedForm',0)==1:   # stumpy 2006-12-24: changed char to owner
        Object_PlayEffect(owner,getByTemplate(owner,FFX_DISPERSE_CUSTOM,2),'',0)

def UnDisperse(event):
    hero=event.object
    FFX_ObjectSetAttr(hero,'dispersed',0)
    if Object_GetAttr(hero,'energyPoints')<0:
        Object_SetAttr(hero,'energyPoints',0)
    Object_SetPrimaryState(hero,PCSTATE_PANICKED,0,REMOVE_STATE)
    Object_SetSecondaryState(hero,SCSTATE_INVISIBLE,0,REMOVE_STATE)
    Object_SetSecondaryState(hero,SCSTATE_DISPLACE_IMAGE,0,REMOVE_STATE)
    Object_SetAttr(hero,'speed',Object_GetAttr(hero,'baseSpeed'))
    Object_PlayEffect(hero,getByTemplate(hero,FFX_DISPERSE_CUSTOM,3),'',0)
    RegTimer('OnDispersedReform',0.01,0,hero)

#Ep. 2006-07-22: Updated forFFvsTTR new states... Oops - the function was not used at all anyway.
def RestoreSStates(char,states):
    for state in (
        SCSTATE_IRRADIATED,
        SCSTATE_BLIND,
        SCSTATE_HEXED,
        SCSTATE_ACID_BURNT,
        SCSTATE_POWER_NULLIFICATION,
        SCSTATE_ENERGIZED,
        SCSTATE_EMPATHY,
        SCSTATE_AREA_ENERGIZED,
        SCSTATE_SPAWN,
        SCSTATE_SPEED_INCREASED,
        SCSTATE_SPEED_DECREASED,
        SCSTATE_WEAKENED,
        SCSTATE_BUOYANT,
        SCSTATE_ZOMBIE,
        SCSTATE_DEEP_SENSORED,
        ):
        if (states&state!=0):
            Object_SetSecondaryState(char,state,5,0)


########################### DEPRESSED #################################################

def initdepressed(char,update=0,remove=0):
    if remove:
        FFX_ObjectSetAttr(char, 'depressed',0)
    else:
        FFX_ObjectSetAttr(char, 'depressed',1)
    RegTimer('updatedepressed',5,0,char)

def updatedepressed(event):
    char=event.object
    if FFX_ObjectGetAttr(char, 'depressed',0)!=0:
        return
    if FFX_ObjectGetAttr(char, 'psychotherapy'): ###! added for the psychotherapy attribute
        return
    RegTimer('updatedepressed',5,0,char)
    if cshelper.isPlaying():
        return
    if FFX_Rand(1,100) < FFX_RPG_DEPRESSED_CHANCE:
        FFX_Animate(char,'angst_attack')
        RegTimer('OnAngstriddenCB',0.1,0,char)

########################### HOLLOW BONES ##############################################

def inithollowbones(char,update=0):
    FFX_SetMassFactor(char,0.4)
    FFX_ObjectSetAttr(char,'baseMass',Object_GetAttr(char,'mass'))
    FFX_ObjectSetAttr(char,'baseMinForce',Object_GetAttr(char,'minForce'))

########################### LIVING LASER ###############################################

def initlivinglaser(char,update=0,remove=0):
    if isMP():
        return
    FFX_ObjectSetAttr(char,'living_laser',1)
    if remove:
        cmdName=getByTemplate(char,FFX_LIVINGLASER_CUSTOM,4)
        removeCommand(cmdName,char)
        FFX_ObjectSetAttr(char,'living_laser',0)
    RegTimer('updatelivinglaser',0.1,0,char)

def updatelivinglaser(event):
    char=event.object
    update=event.user
    if FFX_ObjectGetAttr(char,'living_laser',0)==1:
        RegTimer('updatelivinglaser',5,1,char)
        cmdName=getByTemplate(char,FFX_LIVINGLASER_CUSTOM,4)
        addCommand(cmdName,char,'OnLaserTo',30,update)

def OnLaserTo(target,hero):
    if chargeEP(hero,FFX_EP_LIVINGLASER)==0:
        return
    name=getDummyName()
    spawn(name,'portal_start_proxy',hero)
    alignWith(name,hero)
    Object_PlayEffect(hero,getByTemplate(hero,FFX_LIVINGLASER_CUSTOM,2),'',0)
    Trigger_Power(hero,target,getByTemplate(hero,FFX_LIVINGLASER_CUSTOM,1),'')
    RegTimer('OnLaser',0.5,0,hero,target)
    RegTimer('OnLaser2',2.8,0,hero,target)
    RegTimer('UnLaser',3,10,hero,target)

def OnLaser(event):
    hero=event.object
    target=event.string
    ff.RESULTBUBBLE_SCALE=0
    makecloak(hero,100)
    makephase(hero,100)
    RegTimer('bubblesOn',0.1)

def OnLaser2(event):
    hero=event.object
    target=event.string
    FFX_Teleport(hero,GetTargetPos(hero,target))

def UnLaser(event):
    hero=event.object
    target=event.string
    makeUncloak(hero)
    makeUnphase(hero)
    Object_PlayEffect(hero,getByTemplate(hero,FFX_LIVINGLASER_CUSTOM,3),'',0)
    turnTo(hero,target)

########################### EXPLOSIVE ###############################################

def initexplosive(char,update=0):
    if isMP():
        return
    if update==0:
        cmd=getByTemplate(char,FFX_EXPLODE_CUSTOM,4)
        Mission_CustomAction(cmd,char,char,'OnExplode',50,0)

def OnExplode(target,hero):
    if chargeEP(hero,FFX_EP_EXPLODE)==0:
        return
    AI_Animate(hero,getByTemplate(hero,FFX_EXPLODE_CUSTOM,1),'OnExplode2')

def OnExplode2(event):
    hero=event.object
    RegTimer('OnExplodeCB',0.1,0,hero)
    FFX_ObjectSetAttr(hero,'dispersed',1)
    ff.RESULTBUBBLE_SCALE=0
    intensity=getByTemplate(hero,FFX_EXPLODE_CUSTOM,5)
    Trigger_Explosion(hero,getByTemplate(hero,FFX_EXPLODE_CUSTOM,2),intensity)
    if intensity>0:
        Trigger_Damage(hero,FFX_Rand(10,30)*intensity)
    if Object_IsAlive(hero):
        Object_SetPrimaryState(hero,PCSTATE_PANICKED,100,0)
    makephase(hero,100)
    makecloak(hero,100)
    RegTimer('keepPanicked',0.1,0,hero)
    Object_SetAttr(hero,'speed',0.5)
    RegTimer('UnExplode',8,0,hero)
    RegTimer('bubblesOn',0.1)

def keepPanicked(event):
    char=event.object
    if Object_Exists(char):
        if (Object_GetSecondaryStates(char)&SCSTATE_INVISIBLE)!=0:
            if Object_GetPrimaryState(char)!=PCSTATE_PANICKED:
                Object_SetPrimaryState(char,PCSTATE_PANICKED,100,0)
            RegTimer('keepPanicked',0.1,0,char)

def bubblesOff(event):
    ff.RESULTBUBBLE_SCALE=0

def bubblesOn(event):
    ff.RESULTBUBBLE_SCALE=0.6

def UnExplode(event):
    hero=event.object
    FFX_ObjectSetAttr(hero,'dispersed',0)
    Object_SetPrimaryState(hero,PCSTATE_PANICKED,0,REMOVE_STATE)
    Object_SetSecondaryState(hero,SCSTATE_INVISIBLE,0,REMOVE_STATE)
    Object_SetSecondaryState(hero,SCSTATE_DISPLACE_IMAGE,0,REMOVE_STATE)
    Object_SetAttr(hero,'speed',Object_GetAttr(hero,'baseSpeed'))
    Object_PlayEffect(hero,getByTemplate(hero,FFX_EXPLODE_CUSTOM,3),'',0)
    

############################# ATOMIC TOUCH ###########################################

# stumpy 2007-01-21: the butterfingers code is similar to what we want
# here, but not 100%.
def initatomtouch(char,update=0,remove=0):
    if remove:
        FFX_ObjectSetAttr(char,'atomtouch',0)
        return
    FFX_ObjectSetAttr(char,'atomtouch',1)
    if Mission_GetAttr('pickupReged')!=0:
        return
    Mission_SetAttr('pickupReged',1)
    lastMObj = 0
    for obj in Mission_GetObjects():    # stumpy 2007-02-19: changed to use Mission_GetObjects()
        if Object_Exists(obj):
            if (Object_GetAttr(obj,'wieldable')!=0) | (Object_GetAttr(obj,'throwable')!=0):
                RegPickup(obj,'onPickUpBF')
                if obj[:5] == 'mobj_':
                    lastMObj = int(obj[5:])
    RegTimer('checkNewMobjs',5.0,user=lastMObj,thing1=getLastDummyName())

########################## BATTERY POWERED ############################################

def initbattery(char,update=0):
    FFX_SetEnergy(char,Object_GetAttr(char,'energy'))

######################### PRESENCE #####################################################

def initpresence(char,update=0):
    doNothing=0

def updatePresence(obj):
    if Object_IsAlive(obj)==0:
        return
    clsMask=OC_MINION
    if (Object_GetClass(obj)&(OC_VILLIAN|OC_MINION))!=0:
        clsMask=OC_POLICE
    for minion in Mission_GetDynamicObjects():
        panickable=0
        cls=Object_GetClass(minion)
        #M25 updated May 10, 2005
        if usingM25AI():
            panickable=m25ai.TeamsReactionOfType(minion,obj,m25ai.TEAM_ENEMIES)
        else:
            panickable=(cls&clsMask)!=0
        if panickable:
            if FFX_Rand(1,100)<=FFX_PRESENCE_CHANCE:
                if distanceSq(minion,obj)<(300*300):
                    Object_SetPrimaryState(minion,PCSTATE_PANICKED,30,0)

######################### MINDLESS #####################################################

def initmindless(char,update=0):
    RegCharState(char,PCSTATE_BLANK,'clearMindBlank')
    RegCharState(char,PCSTATE_HYPNOTISED,'clearMindHyp')
    RegCharState(char,PCSTATE_ENRAGED,'clearMindRage')
    RegCharState(char,PCSTATE_PANICKED,'clearMindFear')

def clearMindBlank(event):
    char=event.object
    Object_SetPrimaryState(char,PCSTATE_BLANK,0,REMOVE_STATE)
    RegCharState(char,PCSTATE_BLANK,'clearMindBlank')

def clearMindHyp(event):
    char=event.object
    Object_SetPrimaryState(char,PCSTATE_HYPNOTISED,0,REMOVE_STATE)
    RegCharState(char,PCSTATE_HYPNOTISED,'clearMindHyp')

def clearMindRage(event):
    char=event.object
    Object_SetPrimaryState(char,PCSTATE_NORMAL,1,0)
    RegCharState(char,PCSTATE_ENRAGED,'clearMindRage')

def clearMindFear(event):
    char=event.object
    if FFX_ObjectGetAttr(char,'dispersed')==0:
        Object_SetPrimaryState(char,PCSTATE_PANICKED,0,REMOVE_STATE)
    RegCharState(char,PCSTATE_PANICKED,'clearMindFear')

#Ep. 2006-07-17: added string parameter
def RegCharState(character, state, fn, persistent = 0, user=0, string=''):
    js.Event_RegisterSink(EVENT_CHARACTER_STATE_CHANGED, fn, character, string, user, state, persistent)

######################## FEARLESS ##########################################

def initfearless(char,update=0):
    RegCharState(char,PCSTATE_PANICKED,'clearMindFear')

######################## DISPASSIONATE ######################################

def initdispassionate(char,update=0):
    RegCharState(char,PCSTATE_ENRAGED,'clearMindRage')

######################## IRON JAW ##########################################

def initironjaw(char,update=0):
    RegCharState(char,PCSTATE_STUNNED,'clearStun')

def clearStun(event):
    char=event.object
    Object_SetPrimaryState(char,PCSTATE_STUNNED,0,REMOVE_STATE)
    RegCharState(char,PCSTATE_STUNNED,'clearStun')

######################## FOURD ##########################################

def initfourd(char,update=0):
    RegCharState(char,PCSTATE_EXILE,'on4d')

def on4d(event):
    char=event.object
    Object_SetPrimaryState(char,PCSTATE_EXILE,0,REMOVE_STATE)
    Object_SetSecondaryState(char,SCSTATE_DISPLACE_IMAGE,10,0)
    RegCharState(char,PCSTATE_EXILE,'on4d')

######################### JINX #############################################

def initjinx(char,update=0):
    RegTimer('updateJinx',5,0,char)

def updateJinx(event):
    obj=event.object
    if hasAttribute(obj,'jinx')==0:
        return
    RegTimer('updateJinx',5,0,obj)
    if Object_IsAlive(obj)==0:
        return
    if Object_GetPrimaryState(obj)==PCSTATE_EXILE:
        return
    for char in Mission_GetDynamicObjects():
        if ((Object_GetClass(char)&FFX_CHARACTER)!=0) & (char!=obj) & Object_IsAlive(char):
            if distanceSq(char,obj)<(300*300):
                if FFX_Rand(1,100)<=FFX_JINX_CHANCE_JAM:
                    Object_SetSecondaryState(char,SCSTATE_POWER_NULLIFICATION,15,0)
                if FFX_Rand(1,100)<=FFX_JINX_CHANCE_SLIP:
                    fallOver(char)

######################### JINX ENEMIES #############################################
#Ep. 2007-09-26: Jinx variant per Juanjete request
def initjinxenemies(char,update=0):
    RegTimer('updateJinx',5,0,char)

def updateJinxEnemies(event):
    obj=event.object
    if hasAttribute(obj,'jinx')==0:
        return
    RegTimer('updateJinxEnemies',5,0,obj)
    if Object_IsAlive(obj)==0:
        return
    for adversary in getAllAdversaries(obj):
        if distanceSq(adversary, obj) < (300*300):
            if FFX_Rand(1,100) <= FFX_JINX_CHANCE_JAM:
                Object_SetSecondaryState(adversary, SCSTATE_POWER_NULLIFICATION, 15, 0)
            if FFX_Rand(1,100) <= FFX_JINX_CHANCE_SLIP:
                fallOver(adversary)

########################## PEACE FIELD #####################################

def initpeacefield(char,update=0):
    if isMP():
        return
    if update==0:
        cmd=getByTemplate(char,FFX_PEACE_CUSTOM,4)
        Mission_CustomAction(cmd,char,char,'OnPeaceField',5,0)
        FFX_ObjectSetAttr(char,'warzone',0)

def OnPeaceField(char,dummy):
    if chargeEP(char,FFX_EP_PEACEFIELD)==0:
        return
    FFX_Animate(char,getByTemplate(char,FFX_PEACE_CUSTOM,1))
    duration=20
    if Object_GetTemplate(char)[:7]=='connect':
        duration=50
    FFX_ObjectSetAttr(char,'warzone',1)
    RegTimer('PeaceField1',0.1,duration,char)
    handle=Object_PlayEffect(char,getByTemplate(char,FFX_PEACE_CUSTOM,2),'',FX_TRACK_OBJECT_FULL|FX_LOOP,0,'centre')
    Object_SetAttr(char,'peaceHandle',handle)

def PeaceField1(event):
    peaceKeeper=event.object
    if Object_Exists(peaceKeeper)==0:
        return
    if Object_IsAlive(peaceKeeper)==0:
        return
    if (event.user!=0):
        RegTimer('PeaceField1',0.5,event.user-1,peaceKeeper)
    else:
        FFX_ObjectSetAttr(peaceKeeper,'warzone',0)
        Object_StopEffect(peaceKeeper,Object_GetAttr(peaceKeeper,'peaceHandle'))
    for obj in Mission_GetDynamicObjects():
        if Object_GetTemplate(obj)=='projectile_standin':
            if obj[:5]=='mobj_':
                if distanceSq(obj,peaceKeeper)<300*300:
                    name='anti%s'%(obj)
                    Object_SpawnAt('portal_start_proxy',Get_ObjectPos(obj),name)
                    alignWith(name,obj)
                    Object_Destroy(obj)
                    Object_PlayEffect(name,getByTemplate(peaceKeeper,FFX_PEACE_CUSTOM,3),'destroyTemp',FX_TRACK_OBJECT_POS)
    RegTimer('PeaceField2',0.1,0,peaceKeeper)

####################### GASEOUS FORM ###########################################

def initgaseousform(char,update=0):
    if isMP():
        return
    if update==0:
        Mission_CustomAction(getByTemplate(char,FFX_GASEOUSFORM_CUSTOM,1),char,char,'OnGaseousForm',5,0)

def OnGaseousForm(char,dummy):
    if chargeEP(char,FFX_EP_GAS)==0:
        return
    makephase(char,20)
    makecloak(char,20)
    Object_SetAttr(char,'ffxState',FFX_STATE_GAS)

def updateGaseousForm(obj):
    if ((Object_GetSecondaryStates(obj)&SCSTATE_DISPLACE_IMAGE)!=0) & (Object_GetAttr(obj,'ffxState')==FFX_STATE_GAS):
       #print getByTemplate(obj,FFX_GASEOUSFORM_CUSTOM,2)
       Trigger_Explosion(obj,getByTemplate(obj,FFX_GASEOUSFORM_CUSTOM,2))
       fx=getByTemplate(obj,FFX_GASEOUSFORM_CUSTOM,3)
       if fx!='':
           Object_PlayEffect(obj,fx,'',FX_TRACK_OBJECT_POS)
    elif (Object_GetAttr(obj,'ffxState')==FFX_STATE_GAS):
       Object_SetAttr(obj,'ffxState',0)

def initbloodsucker(char,update=0):
    diddly=0
####################### SANDSTORM ###########################################

def initsandstorm(char,update=0):
    if isMP():
        return
    if update==0:
        Mission_CustomAction('CUSTOM_SANDSTORM',char,char,'OnSandStorm',5,0)
    FFX_ObjectSetAttr(char,'fxHandle',-1)

def OnSandStorm(char,dummy):
    if chargeEP(char,FFX_EP_SAND)==0:
        return
    makephase(char,10)
    makecloak(char,10)
    Object_SetAttr(char,'ffxState',FFX_STATE_SAND)
    pos=Get_ObjectPos(char)
    Object_SetAttr(char,'lastX',pos[0])
    Object_SetAttr(char,'lastY',pos[1])
#M25 Feb 17, temp fix for sandstorm
    RegTimer('OnSandStorm2',0.1,0,char)

def OnSandStorm2(event):
    updateSandstorm(event.object)
    if ((Object_GetSecondaryStates(event.object)&SCSTATE_DISPLACE_IMAGE)!=0) & (Object_GetAttr(event.object,'ffxState')==FFX_STATE_SAND):        
        RegTimer('OnSandStorm2',1,0,event.object)
# end temp fix

def updateSandstorm(obj):
    if ((Object_GetSecondaryStates(obj)&SCSTATE_DISPLACE_IMAGE)!=0) & (Object_GetAttr(obj,'ffxState')==FFX_STATE_SAND):
       Trigger_Explosion(obj,'ffx_sandstorm')
       if FFX_ObjectGetAttr(obj,'fxHandle',-1)==-1:
           handle=Object_PlayEffect(obj,'effect_sandstorm','',FX_LOOP|FX_TRACK_OBJECT_FULL)
           FFX_ObjectSetAttr(obj,'fxHandle',handle)
       pos=Get_ObjectPos(obj)
       if (pos[0]==Object_GetAttr(obj,'lastX')) & (pos[1]==Object_GetAttr(obj,'lastY')):
           Trigger_Move(obj,'move',(pos[0]+FFX_Rand(-50,50),pos[1]+FFX_Rand(-50,50),pos[2]))
       Object_SetAttr(obj,'lastX',pos[0])
       Object_SetAttr(obj,'lastY',pos[1])
    elif (Object_GetAttr(obj,'ffxState')==FFX_STATE_SAND):
       Object_SetAttr(obj,'ffxState',0)
       if FFX_ObjectGetAttr(obj,'fxHandle',-1)!=-1:
           Object_StopEffect(obj,int(FFX_ObjectGetAttr(obj,'fxHandle')))
           FFX_ObjectSetAttr(obj,'fxHandle',-1)

####################### HUMAN TOP ###########################################

def initspinner(char,update=0):
    if isMP():
        return
    if update==0:
        Mission_CustomAction('CUSTOM_SPIN',char,char,'OnSpin',5,0)
    FFX_ObjectSetAttr(char,'fxHandle',-1)
    Object_SetAttr(char,'spinning',0)
    RegTimer('updatespinner',1,0,char)

def OnSpin(char,dummy):
    if chargeEP(char,FFX_EP_SPIN)==0:
        return
    Object_SetAttr(char,'spinning',10)
    Object_SetAttr(char,'ffxState',FFX_STATE_SPIN)
    Object_SetAttr(char,'speed',9)
    pos=Get_ObjectPos(char)
    Object_SetAttr(char,'lastX',pos[0])
    Object_SetAttr(char,'lastY',pos[1])

def updatespinner(event):
    obj=event.object
    if not Object_IsAlive(obj): #Ep. 2006-08-23: Prevent error if object doesn't exist
        RegTimer('updatespinner',5,0,obj) #in case he gets better
        return
    RegTimer('updatespinner',1,0,obj)
    stop=0
    #print Object_GetAttr(obj,'spinning')
    if Object_GetAttr(obj,'spinning')>0:
        Object_SetAttr(obj,'spinning',Object_GetAttr(obj,'spinning')-1)
        pState=Object_GetPrimaryState(obj)
        #stop spinning if we trigger another power or get physically stopped
        if (pState==PCSTATE_FROZEN) | (pState==PCSTATE_STATIC) | (pState==PCSTATE_STUNNED) | (Object_GetAttr(obj,'ffxState')!=FFX_STATE_SPIN) | (Object_GetAttr(obj,'spinning')<=0):
            stop=1
        else:
            if FFX_ObjectGetAttr(obj,'fxHandle',-1)==-1:
                handle=Object_PlayEffect(obj,'effect_sandstorm','',FX_LOOP|FX_TRACK_OBJECT_FULL)
                FFX_ObjectSetAttr(obj,'fxHandle',handle)
            Trigger_Explosion(obj,'ffx_superrotate')
            stop=0
            pos=Get_ObjectPos(obj)
            if (pos[0]==Object_GetAttr(obj,'lastX')) & (pos[1]==Object_GetAttr(obj,'lastY')):
                Trigger_Move(obj,'move',(pos[0]+FFX_Rand(-50,50),pos[1]+FFX_Rand(-50,50),pos[2]))
            Object_SetAttr(obj,'lastX',pos[0])
            Object_SetAttr(obj,'lastY',pos[1])
        if stop!=0:
            Object_SetAttr(obj,'spinning',0)
            if Object_GetAttr(obj,'ffxState')==FFX_STATE_SPIN:
                Object_SetAttr(obj,'ffxState',0)
            if FFX_ObjectGetAttr(obj,'fxHandle',-1)!=-1:
                Object_SetAttr(obj,'speed',Object_GetAttr(obj,'baseSpeed'))
                Object_StopEffect(obj,int(FFX_ObjectGetAttr(obj,'fxHandle')))
                FFX_ObjectSetAttr(obj,'fxHandle',-1)

####################### ICE CLOUD ###########################################

def initicecloud(char,update=0):
    if isMP():
        return
    if update==0:
        Mission_CustomAction('CUSTOM_ICECLOUD',char,char,'OnIceCloud',5,0)

def OnIceCloud(char,dummy):
    if chargeEP(char,FFX_EP_ICE)==0:
        return
    makephase(char,20)
    Object_SetAttr(char,'ffxState',FFX_STATE_ICE)

def updateIceCloud(obj):
    if ((Object_GetSecondaryStates(obj)&SCSTATE_DISPLACE_IMAGE)!=0) & (Object_GetAttr(obj,'ffxState')==FFX_STATE_ICE):
       Trigger_Explosion(obj,'ffx_icecloud')
    elif (Object_GetAttr(obj,'ffxState')==FFX_STATE_ICE):
       Object_SetAttr(obj,'ffxState',0)

##################### VERY UNSTABLE MOLECULES ###############################

def initvunstablemols(char,update=0):
    doNothing=0
 
####################### BIOHAZARD ###########################################

# Ep. 2006-08-19: made removable
# Note that the attributes' damage aura is removed by the calling function removeFFXAttr()

def initbiohazard(char, update=0, remove=0):
    if remove:
        handle = FFX_ObjectGetAttr(char, 'biohazardfx')
        if handle != -1:
            Object_StopEffect(char, handle)
        return
    sparks = getByTemplate(char, FFX_BIOHAZARD_CUSTOM, 1)
    handle = -1
    if sparks != '':
        handle = Object_PlayEffect(char, sparks, '', FX_LOOP|FX_TRACK_OBJECT_FULL, 0, 'Bip01 Spine')
    FFX_ObjectSetAttr(char, 'biohazardfx', handle)

def initfrostbite(char, update=0, remove=0):
    if remove:
        handle = FFX_ObjectGetAttr(char, 'frostbitefx')
        if handle != -1:
            Object_StopEffect(char, handle)
        return
    sparks = getByTemplate(char, FFX_FROSTBITE_CUSTOM, 1)
    handle = -1
    if sparks != '':
        handle = Object_PlayEffect(char, sparks, '', FX_LOOP|FX_TRACK_OBJECT_POS, 0, '')
    FFX_ObjectSetAttr(char, 'frostbitefx', handle)

def initoverheated(char, update=0, remove=0):
    if remove:
        handle = FFX_ObjectGetAttr(char, 'overheatedfx')
        if handle != -1:
            Object_StopEffect(char, handle)
        return
    #addNexusCommands(char,ffxcustom.FFX_OVERHEATED_CUSTOM,'OVERHEATED') #removed Ep. 2006-08-19: Nexus was never completed, AFAIK
    sparks = getByTemplate(char, FFX_OVERHEATED_CUSTOM, 1)
    handle = -1
    if sparks != '':
        handle = Object_PlayEffect(char, sparks, '', FX_LOOP|FX_TRACK_OBJECT_POS, 0, '')
    FFX_ObjectSetAttr(char, 'overheatedfx', handle)

def initshortcirc(char, update=0, remove=0):
    if remove:
        handle = FFX_ObjectGetAttr(char, 'shortcircfx')
        if handle != -1:
            Object_StopEffect(char, handle)
        return
    sparks = getByTemplate(char, FFX_SHORTCIRCUITED_CUSTOM, 1)
    handle = -1
    if sparks != '':
        handle = Object_PlayEffect(char, sparks, '', FX_LOOP|FX_TRACK_OBJECT_POS, 0, '')
    FFX_ObjectSetAttr(char, 'shortcircfx', handle)

####################### NUCLEAR STOCKPILE ###################################

def initstockpile(char,update=0):
    RegDamage(char,'OnStockPileHit')
    Object_SetAttr(char,'stockpile',0)
    Object_SetAttr(char,'lastHealthNS',Object_GetAttr(char,'health'))
    Object_SetAttr(char,'pileHandle1',-1)
    Object_SetAttr(char,'pileHandle2',-1)

def OnStockPileHit(event):
    char=event.object
    RegDamage(char,'OnStockPileHit')
    pile=Object_GetAttr(char,'stockpile')
    damage=Object_GetAttr(char,'lastHealthNS')-Object_GetAttr(char,'health')
    if damage<1:
       damage=1    
    Object_SetAttr(char,'lastHealthNS',Object_GetAttr(char,'health'))
    pile=pile+damage
    if cshelper.isPlaying():
        return
    if FFX_Rand(1,100)<pile:
        #blow up!
        RegTimer('OnStockpileCB',0.1,0,char)
        intensity=1+(pile/20)
        pile=0
        if Object_GetAttr(char,'pileHandle1')!=-1:
            Object_StopEffect(char,Object_GetAttr(char,'pileHandle1'))
            Object_SetAttr(char,'pileHandle1',-1)  
        if Object_GetAttr(char,'pileHandle2')!=-1:
            Object_StopEffect(char,Object_GetAttr(char,'pileHandle2'))
            Object_SetAttr(char,'pileHandle2',-1)      
        Trigger_Explosion(char,getByTemplate(char,FFX_STOCKPILE_CUSTOM,2),intensity)
    else:
        if (pile>20) & (Object_GetAttr(char,'pileHandle1')==-1):       
            handle=Object_PlayEffect(char,getByTemplate(char,FFX_STOCKPILE_CUSTOM,1),'',FX_TRACK_OBJECT_FULL|FX_LOOP,0,'')
            Object_SetAttr(char,'pileHandle1',handle)
        if (pile>50) & (Object_GetAttr(char,'pileHandle2')==-1):       
            handle=Object_PlayEffect(char,getByTemplate(char,FFX_STOCKPILE_CUSTOM,1),'',FX_TRACK_OBJECT_FULL|FX_LOOP,0,'Bip01 Head')
            Object_SetAttr(char,'pileHandle2',handle)
    Object_SetAttr(char,'stockpile',pile) 

################### acid blood #################################

def initacidblood(char,update=0):
    Object_SetAttr(char,'lastHealthAB',Object_GetAttr(char,'health'))
    RegDamage(char,'OnAcidBlood')

def OnAcidBlood(event):
    char=event.object
    if hasAttribute(char,'acidblood')==0:
        return
    damage=Object_GetAttr(char,'lastHealthAB')-Object_GetAttr(char,'health')
    if damage>0:
        rnd=FFX_Rand(0,20)
        if rnd<=damage:
            Trigger_Explosion(char,getByTemplate(char,FFX_ACIDBLOOD_CUSTOM,1))
    Object_SetAttr(char,'lastHealthAB',Object_GetAttr(char,'health'))
    RegDamage(char,'OnAcidBlood')

################### glass jaw #################################

def initglassjaw(char,update=0):
    Object_SetAttr(char,'lastHealthGJ',Object_GetAttr(char,'health'))
    RegDamage(char,'OnGlassJaw')

def OnGlassJaw(event):
    char=event.object
    damage=Object_GetAttr(char,'lastHealthGJ')-Object_GetAttr(char,'health')
    if damage>0:
        if FFX_Rand(0,20)<damage:
            Object_SetPrimaryState(char,PCSTATE_STUNNED,5,0)
    Object_SetAttr(char,'lastHealthGJ',Object_GetAttr(char,'health'))
    RegDamage(char,'OnGlassJaw')

################### psychic conduit #############################

def initconduit(char,update=0,remove=0):
    if remove:
        FFX_ObjectSetAttr(char, 'conduit', 0)
    else:
        FFX_ObjectSetAttr(char, 'conduit', 1)
        Object_SetAttr(char,'lastHealthPC',Object_GetAttr(char,'health'))
        RegDamage(char,'OnConduit')

def OnConduit(event):
    char=event.object
    if FFX_ObjectGetAttr(char, 'conduit', 0)==1:
        damage=Object_GetAttr(char,'lastHealthPC')-Object_GetAttr(char,'health')
        if damage>0:
            if FFX_Rand(1,2)<=1:
                Trigger_Explosion(char,'ffx_conduit1')
            if FFX_Rand(1,2)<=1:
                Trigger_Explosion(char,'ffx_conduit2')
        Object_SetAttr(char,'lastHealthPC',Object_GetAttr(char,'health'))
        RegDamage(char,'OnConduit')

#################### spiny ######################################

def initspiny(char,update=0):
    Object_SetAttr(char,'lastHealthSP',Object_GetAttr(char,'health'))
    RegDamage(char,'OnSpiny')

def OnSpiny(event):
    char=event.object
    damage=Object_GetAttr(char,'lastHealthSP')-Object_GetAttr(char,'health')
    if damage>0:
        Trigger_Explosion(char,getByTemplate(char,FFX_SPINY_CUSTOM,1),-1)
    Object_SetAttr(char,'lastHealthSP',Object_GetAttr(char,'health'))
    RegDamage(char,'OnSpiny')

################# sensitive ######################################

def initsensitive(char,update=0):
    FFX_ObjectSetAttr(Object_GetTemplate(char),'sensitive',1)

################ telepathy ########################################

# -FOR MODDERS:
#  You can capture players triggering this power by setting missionobjvar.Mission_SetVar('ffx_telepathyCS', 'functionName')
#  where "functionName" is a user-defined function with the character using the precognitive power as parameter. Ex.:
#    missionobjvar.Mission_SetVar('ffx_telepathyCS', 'senseOminousEvent')
#  will call
#    senseOminousEvent(char)
#  Important: after calling your function, reset missionobjvar.Mission_SetVar('ffx_telepathyCS', '') to avoid triggering
#  your function more than once.

def inittelepathy(char,update=0):
    if isMP():
        return
    cmd=getByTemplate(char,FFX_SCAN_CUSTOM,3)
    Mission_CustomAction(cmd,char,char,'OnScan',5,0)
    Global_RegisterAttr('enhsenfx',-1)
    Global_RegisterAttr('enhsenfx2',-1)
    if not missionobjvar.Mission_VarExists('ffx_telepathyCS'): ###! cf "FOR MODDERS" above
        missionobjvar.Mission_SetVar('ffx_telepathyCS', '')

def OnScan(char,dummy,epcost=FFX_EP_SCAN):
    if chargeEP(char,epcost)==0:
        return
    FFX_Animate(char,getByTemplate(char,FFX_SCAN_CUSTOM,1))
    #intercept the command and play a modder's function if defined ###! cf "FOR MODDERS" above
    func = missionobjvar.Mission_GetVar('ffx_telepathyCS')
    if func != '':
        exec "%s('%s')"%(func, char)
        return
    RegTimer('OnScanCB',0.1,0,char)
    Object_PlayEffect(char,getByTemplate(char,FFX_SCAN_CUSTOM,2),'',0,0,'Bip01 Head')
    fx1=getByTemplate(char,FFX_SCAN_CUSTOM,4)
    handle=-1
    if fx1!='':
        handle=Object_PlayEffect(char,fx1,'',FX_LOOP|FX_TRACK_OBJECT_POS,0,'centre')
    Object_SetAttr(char,'enhsenfx',handle)
    FFX_ObjectSetAttr(char,'accumulator',0)
    for obj in Mission_GetObjects():
        scanned=0
        fn=getByTemplate(char,FFX_SCAN_CUSTOM,6)
        exec("scanned=%s(obj,char)"%fn)
        if scanned:
            name='tparrow_%d'%(Mission_GetAttr('tpArrow'))
            Mission_SetAttr('tpArrow',Mission_GetAttr('tpArrow')+1)
            Mission_AddArrowObject(name,obj,js.ARROW_YELLOW,1)
    if randint(1,100)<FFX_ObjectGetAttr(char,'accumulator'):
        Object_SetPrimaryState(char,PCSTATE_STUNNED,4,0)
    RegTimer('RemoveScanArrows',15,0,char)
    scan=Mission_GetAttr('sscancount')
    if scan==0:
        RegTimer('FFX_ScanUpdate',0.01,0,'',char)
    Mission_SetAttr('sscancount',10)
    #get any custom colours
    iamb=getByTemplate(char,FFX_SCAN_CUSTOM,7)
    idir=getByTemplate(char,FFX_SCAN_CUSTOM,8)
    ircl=getByTemplate(char,FFX_SCAN_CUSTOM,9)
    igcl=getByTemplate(char,FFX_SCAN_CUSTOM,10)
    ibcl=getByTemplate(char,FFX_SCAN_CUSTOM,11)
    if iamb!=-1 or idir!=-1 or ircl!=0 or igcl!=0 or ibcl!=0:
        amb=iamb*0.01
        dir=idir*0.01
        rcl=ircl/255.0
        gcl=igcl/255.0
        bcl=ibcl/255.0
        a=Mission_GetAttr('ambientLevel')
        if iamb==-1:
            amb=a
        d=Mission_GetAttr('directLevel')
        if idir==-1:
            dir=d
        r=Mission_GetAttr('redsun')
        g=Mission_GetAttr('greensun')
        b=Mission_GetAttr('bluesun')
        if ircl==0 and igcl==0 and ibcl==0:
            colour=(r,g,b)
            ffx.FFX_Sun(Mission_GetAttr('angle1'),Mission_GetAttr('angle2'),amb,dir,colour,1)
        else:
            colour=(rcl,gcl,bcl)
            ffx.FFX_Sun(Mission_GetAttr('angle1'),Mission_GetAttr('angle2'),amb,dir,colour,1)
        Mission_SetAttr('ambientLevel',a)
        Mission_SetAttr('directLevel',d)
        Mission_SetAttr('redsun',r)
        Mission_SetAttr('greensun',g)
        Mission_SetAttr('bluesun',b)

def FFX_ScanUpdate(event):
    char=event.string
    count=Mission_GetAttr('sscancount')-1
    if Object_Exists(char)==0:
        count=0
    if count<=0:
        Mission_SetAttr('sscancount',0)
        restoreSun()
        return
    Mission_SetAttr('sscancount',count)
    RegTimer('FFX_ScanUpdate',1,0,'',char)
    fx2=getByTemplate(char,FFX_SCAN_CUSTOM,5)
    screen=getByTemplate(char,FFX_SCAN_CUSTOM,6)
    for obj in Mission_GetDynamicObjects():
        if Object_IsAlive(obj):
            if Object_GetAttr(obj,'enhsenfx2')==-1:
                apply=0
                check="apply=%s(obj,char)"%(screen)
                exec(check)
                if apply:
                    handle2=-1
                    if fx2!='':
                        handle2=Object_PlayEffect(obj,fx2,'',FX_LOOP|FX_TRACK_OBJECT_POS,0,'centre')
                    Object_SetAttr(obj,'enhsenfx2',handle2)
                    ffx.RegTimer('killenhsenfx',1,0,obj)

def restoreSun():
    colour=(Mission_GetAttr('redsun'),Mission_GetAttr('greensun'),Mission_GetAttr('bluesun'))
    ffx.FFX_Sun(Mission_GetAttr('angle1'),Mission_GetAttr('angle2'),Mission_GetAttr('ambientLevel'),Mission_GetAttr('directLevel'),colour)

def killenhsenfx(event):
    if Mission_GetAttr('sscancount')>0:
        ffx.RegTimer('killenhsenfx',1,0,event.object)
        return
    obj=event.object
    handle=Object_GetAttr(obj,'enhsenfx')
    if handle!=-1:
        Object_StopEffect(obj,handle)
        Object_SetAttr(obj,'enhsenfx',-1)
    handle=Object_GetAttr(obj,'enhsenfx2')
    if handle!=-1:
        Object_StopEffect(obj,handle)
        Object_SetAttr(obj,'enhsenfx2',-1)

def RemoveScanArrows(event):
    count=0
    while count<Mission_GetAttr('tpArrow'):
        name='tparrow_%d'%(count)
        Mission_RemoveArrow(name)
        count=count+1
    Mission_SetAttr('tpArrow',0) 
    char=event.object
    Object_StopEffect(char,Object_GetAttr(char,'enhsenfx'))

################# powerscan ######################################

def initpowerscan(char,update=0):
    if isMP():
        return
    RegTimer('updatepowerscan',0.1,0,char)

def updatepowerscan(event):
    char=event.object
    update=event.user
    RegTimer('updatepowerscan',5,1,char)
    addCommandChars('CUSTOM_SCAN',char,'OnScanPowers',30,update)

HUD=[]

def OnScanPowers(target,char):
    global HUD
    HUD=GetCharHUD(target)
    Mission_StatusText('analysing target...')
    RegTimer('displayHUD',0.1,0)
    Trigger_Power(char,target,getByTemplate(char,FFX_POWERSCAN_CUSTOM,1),'')

def displayHUD(event):
    global HUD
    index=int(event.user)
    if index<len(HUD):
        Mission_StatusText('  %s'%(HUD[index]))
        index=index+1
        RegTimer('displayHUD',0.2,index)
    else:
        HUD=[]

def GetCharHUD(char):
    readout=[]
    data=chardata.GetCharacterData(char)
    if data["strength"]>5:
        readout.append("superstrength")
    if data["speed"]>6 and data["agility"]>5: 
        readout.append("superspeed")
    atts=data['characterAttributes']
    for att in atts:
        str=GetAttrString(att)
        if str!='':
            readout.append(str)
    powers=data["powers"]
    # stumpy 2006-12-30: don't display powers the character hasn't bought yet (for built-ins)
    if data.get('isCustom'):    # customs have all of their powers
        pkeys=powers.keys()
    else:                       # built-ins may not have bought a power yet
        pkeys = []
        for p in powers.keys():
            if data['powerLevels'][p]:
                pkeys.append(p)
    for pkey in pkeys:
        str=GetPowerString(powers[pkey],char)
        print str
        if str!='' and (not str in readout):
            readout.append(str)
    return readout

attrDesc=[
['flier','levitation','ffqglider','ffqbasiclevitation','ffqlowgravflier','flight'],
['heavy lifter','superstrength'],
['claws','bladed weapon'],
['telepathy','powerscan','enhanced senses'],
['shapeshifter','accidentalchange','ffqgestalt','involuntaryform','tempform','ffqamalgam','metamorphic','icecloud','gaseousform','sandstorm','shapeshifting'],
['groupteleporter','bulktp','teleportation'],
['tough guy','invulnerable','invulnerable0','invulnerable2','invulnerable22a34','invulnerable2a','invulnerable3','invulnerable34','invulnerable4','invulnerability'],
['puppetn','puppetu','transmutation'],
['spinner','superspeed'],
['telekinetic','supertk','earthcontrol','telekinesis'],
['masscontrol','density-modulation'],
['illusionist','image-projection'],
]

def GetAttrString(att):
    for set in attrDesc:
        for a in set[:-1]:
            if a==att:
                return set[-1]
    return ''

# stumpy 2006-12-30: changed types to powertypes to avoid having a global with the same name as the module types.
powertypes=['','fighting','ranged','explosion','direct','shield','resistance','special']

subtypes=['','beam','bolts','bomb','cone']

damages=['concussive','piercing','energy','flame','radiation','electrical','acidic','cold','water',
'special','binding','freezing','enraging','panicking','hypnotising','mind-blanking','irradiating',
'blinding','poisonous','bad luck','speed-increasing','speed-draining','weakening','transmuting','transmuting',
'transmuting']

spectypes=['','random','energy-transferring','energy-leeching','','dimension-shifting','molecular-excitation',
'','acrobatics','tunneling','tunneling','invisibility','invisibility','pyrokinesis','summoning','duplication','shapeshifting','shapeshifting',
'healing','leadership','life-draining','healing','bezerker','healing','transmutation','','electrical explosion',
'','super-speed','super-speed','energising','teleportation','density-modulation','empathy','power-neutralisation','energy-projection',
'dematerialisation','energy-projection','','tunneling','image-projection','possession','healing','healing','power-neutralisation','gravity-reversal',
'revivification','enhanced senses','summoning','teleportation','','transmutation','flier']

def pstest():
    for i in range(0,len(spectypes)):
        try:
           print '%s,%s'%(spectypes[i],PT_SPECIAL_TYPES[i])
        except:
           print '?'

carriersFrom=[
['power-neutralisation','powernull'],
['bad luck','hex'],
]

carriersTo=[
["crystallise",'crystallisation'],
["magnetise",'magnetic'],
["vertigo",'vertigo'],
["firecage",'pyrokinesis'],
["shrink",'tranmutation'],
["transmute",'transmutation'],
["gravityincrease",'gravity control'],
["zerog",'gravity control'],
["pull",'telekinetic'],
["magnetpull",'magnetic'],
["lifedrain",'absorption'],
["mentaldamage",'mind control'],
["taunt",''],
["teleport",'teleportation'],
["weaken",'power-neutralisation'],
["weakspot",'enhanced senses'],
["throw",'telekinetic'],
["magnetthrow",'magnetic'],
["staticcage",'electrostatic'],
["absorb",'absorption'],
["strengthdrain",'absorption'],
["mimic",'absorption'],
["phase",'mass control'],
["shield",'force fields'],
["cloak",'invisibility'],
["normalise",'healing'],
["heal",'healing'],
["speedboost",'energising'],
["selfheal",'regeneration'],
["hex",'bad luck'],
["hypnosis",'mind control'],
["rage",'emotion control'],
["blind",'blinding'],
["density",'mass control'],
["blank",'mind control'],
["bodysnatch",'mind control'], #Ep. 2006-09-14: new state
["exile",'mass control'],
["panic",'emotion control'],
["powernull",'power-neutralisation'],
["acidburn",'posionous'],
["irradiate",'radioactive'],
["stasis",'binding'],
["frozen",'freezing'],
["leadership",'healing'],
["castle",'teleportation'],
["remoteempathy",'magical'],
["icepatch",''],
["firepatch",'pyrokinesis'],
["summon",''],
["icewall",''],
["firewall",'pyrokinesis'],
["strobe",''],
]

mods=[
['piercing bolts','firearms'],
['concussive fighting','hand-to-hand combat'],
['concussive explosion','shockwave'],
['piercing fighting','bladed weapon'],
]

def GetPowerString(power,char):
#    try:
    print power
    if 1:
        itype=int(power["PowerType"])
        if itype==5:
            return 'force field'
        if itype==6:
            return 'resistance'
        type=powertypes[itype]
        if type=='ranged':
            type=subtypes[int(power["SubType"])]
        damage=damages[int(power["DamageType"])]
        spec=int(power["SpecialType"])
        if spec!=0:
            damage=spectypes[spec]
        #do we need to convert the damage type for checking carriers?
        carrierFrom=''
        for pair in carriersFrom:
            if damage==pair[0]:
                carrierFrom=pair[1]
        if carrierFrom!='':
            print 'swap for %s ?'%(carrierFrom)
            t=FFX_GetTemplate(char)
            powerName=power['PowerName']
            print t
            print powerName
            carrierTo=''
            for set in FFX_CARRIERS:
                if set[0]==t and set[1]==carrierFrom and (set[3]=='all' or set[3]==powerName):
                    carrierTo=set[2]
            print carrierTo
            if carrierTo!='':
                for pair in carriersTo:
                    if carrierTo==pair[0]:
                        damage=pair[1]
                        print damage
#    except:
    else:
        return ''
    if type=='special':
        type=''
    str='%s %s'%(damage,type)
    for mod in mods:
        if str==mod[0]:
            str=mod[1]
    return str

################# symbiote #######################################

###!Ep 2006-02-05 changed FFX 3.2: made customisable as per FFX ideas thread request by IPS
def initsymbiote(char,update=0):
    initfeedback(char,update,7)

################# interference #######################################

def initparasite(char,update=0):
    initfeedback(char,update,8)

############### pheremones ############################################

def initpheremones(char,update=0):
    targetGender=getByTemplate(char,FFX_PHEREMONE_CUSTOM,2)
    setGender(char)
    myGender=int(Object_GetAttr(char,'gender'))
    if targetGender==FFX_GENDER_OPPOSITE:
        if (myGender&31)==FFX_GENDER_FEMALE:
            targetGender=FFX_GENDER_MALE
        else:
            targetGender=FFX_GENDER_FEMALE
    if (myGender&FFX_GENDER_EVIL)==0:
        targetGender=targetGender+FFX_GENDER_EVIL
    print 'initpheremones: target gender=%d'%(targetGender)
    FFX_ObjectSetAttr(char,'targetGender',targetGender)

def updatePheremones(obj):
    fx=getByTemplate(obj,FFX_PHEREMONE_CUSTOM,1)
    if fx!='':
        Object_PlayEffect(obj,fx,'',FX_TRACK_OBJECT_POS,0,'centre')
    for char in Mission_GetDynamicObjects():
        if ((Object_GetClass(char)&FFX_CHARACTER)!=0):
            if Object_GetAttr(char,'gender')==FFX_ObjectGetAttr(obj,'targetGender'):
#                print 'checking %s for pheremone control'%(char)
                if FFX_Rand(1,100)<=FFX_PHEREMONE_CHANCE:
                    if distanceSq(char,obj)<(250*250):
                        Object_SetPrimaryState(char,PCSTATE_HYPNOTISED,30,0)

########### TELEKINETIC, SUPERTELEKINETIC AND MAGNETIC ###############################################

FFX_MATERIAL_ANY=-1
FFX_MATERIAL_METAL=1
FFX_MATERIAL_STONE=2

def inittelekinetic(char,update=0):
    if isMP():
        return
    inittk(char,250,FFX_MATERIAL_ANY,update)

def initsupertk(char,update=0):
    if isMP():
        return
    inittk(char,8000,FFX_MATERIAL_ANY,update)

# Characters with the attributes in the specialAttribs tuple will have custom commands on special objects
# Default is specialAttribs=('scientist','finetk','magnetic','telepathy')
# Cf. ffxcustoms.py.
def initmagnetic(char,update=0):
    if isMP():
        return
    inittk(char,8000,FFX_MATERIAL_METAL,update)

def initearthcontrol(char,update=0):
    if isMP():
        return
    inittk(char,8000,FFX_MATERIAL_STONE,update)

def initmagnetic2(char,update=0):
    if isMP():
        return
    inittk(char,400,FFX_MATERIAL_METAL,update)

def initearthcontrol2(char,update=0):
    if isMP():
        return
    inittk(char,600,FFX_MATERIAL_STONE,update)

#generic telekinesis

def isTKable(obj):
    return (Object_GetAttr(obj,'throwable')!=0) | (Object_GetAttr(obj,'wieldable')!=0)

#old version
def inittk(char,maxMass,materialType,update=0):
    attr='%s_tk'%(char)
    if materialType==FFX_MATERIAL_STONE:
        FFX_ObjectSetAttr(char,'earthTKType',1)
    elif materialType==FFX_MATERIAL_METAL:
        FFX_ObjectSetAttr(char,'metalTKType',1)
    FFX_ObjectSetAttr(char,'tkType',materialType)
    FFX_ObjectSetAttr(char,'maxMass',maxMass)
    if update==0:
        FFX_ObjectSetAttr(char,'tiggotCount',1)
        FFX_ObjectSetAttr(char,'tkCom',0)
    if (Object_GetClass(char)&OC_CONTROLLABLE)==0:
        return
    Global_RegisterAttr(attr,0)
    if update==0:
        for temp in templates:
            mass=temp[1]
            material=temp[2]
            if (mass<=maxMass) & ((material==materialType)|(materialType==-1)):
                Mission_CustomAction('CUSTOM_LIFT',char,temp[0],'OnLift',30,0)
        Mission_CustomAction('CUSTOM_GROUP_FLIGHT',char,char,'OnTkGroupFlight',0,0)
    for obj in Mission_GetDynamicObjects():
        if (Object_GetAttr(obj,attr)==0):
            Object_SetAttr(obj,attr,1)
            if obj!=char:
                if (isTKable(obj)) & ((Object_GetClass(obj)&FFX_CHARACTER)==0):
                     temp=Object_GetTemplate(obj)
                     match=0
                     for template in templates:
                         if temp==template[0]:
                             match=1
                     if match==0:
                         mass=Object_GetAttr(obj,'mass')
                         material=Object_GetAttr(obj,'material')
                         if (mass<=maxMass) & ((material==materialType)|(materialType==-1)):
                             Mission_CustomAction('CUSTOM_LIFT',char,obj,'OnLift',30,0)
                #add attract and repel commands if magnetic and metal object
                mat=GetSubtypeMaterial(obj)
                if (materialType==FFX_MATERIAL_METAL) & (Object_GetAttr(obj,'material')==materialType):
                    Mission_CustomAction('CUSTOM_ATTRACT',char,obj,'OnAttract',30,0)
                    Mission_CustomAction('CUSTOM_REPEL',char,obj,'OnRepel',30,0)
                    Mission_CustomAction('CUSTOM_MAGNETIC',char,obj,'magnetic_disruption',30,0)
                elif mat == 1 | (mat==14) | (mat==16):
                    Mission_CustomAction('CUSTOM_ATTRACT',char,obj,'OnAttract',30,0)
                    Mission_CustomAction('CUSTOM_REPEL',char,obj,'OnRepel',30,0)
                    Mission_CustomAction('CUSTOM_MAGNETIC',char,obj,'magnetic_disruption',30,0)
                #add wall and spike to earth control powers
                if materialType==FFX_MATERIAL_STONE:
                    Mission_CustomAction('CUSTOM_SPIKE',char,obj,'OnSpike',30,0)
                    Mission_CustomAction('CUSTOM_WALL',char,obj,'OnWall',30,0)
                if FFX_ObjectGetAttr(char,'tkCom')!=0:
                    if ( (Object_GetClass(obj)&FFX_CHARACTER)!=0):
                        Mission_CustomAction('CUSTOM_THROWTO',char,obj,'OnThrowTo',30,0)
                        Mission_CustomAction('CUSTOM_MOVETO',char,obj,'OnMoveTo',30,0)
                        
def magnetic_disruption(target,char):
    Trigger_Power(char,target,getByTemplate(char,FFX_MAGNETIC_CUSTOM,5),'')

def OnTkGroupFlight(char,dummy):
    OnTKPower(char,dummy,1)
    for obj in Mission_GetDynamicObjects():
        if obj!=char:
            myTeam=m25ai.GetTeam(char)
            team=m25ai.GetTeam(obj)
            if team==myTeam:
                pos1=Get_ObjectPos(char)
                pos2=Get_ObjectPos(obj)
                dist = cshelper.distance2D(pos1,pos2)
                radius=150
                if dist < radius:
                    mass=Object_GetAttr(obj,'mass')
                    totalMass=FFX_ObjectGetAttr(char,'totalMass')+mass
                    totalFlightMass=FFX_ObjectGetAttr(char,'totalFlightMass')+mass
                    maxMass=FFX_ObjectGetAttr(char,'maxMass')
                    tkType=FFX_ObjectGetAttr(char,'tkType')
                    mat=GetSubtypeMaterial(obj)
                    material=Object_GetAttr(obj,'material')
                    if totalMass > maxMass:
                        Mission_StatusText('total weight exceeds max')
                    if (totalMass<=maxMass) & (FFX_ObjectGetAttr(obj,'tkFlightTarget',0)==0) & ((material==tkType)|(tkType==-1)):
                        makeGroupFlight(char,obj)
                    elif (totalMass<=maxMass) & (tkType==1) & ((material==tkType) | (mat == 1) | (mat==14) | (mat==16)):
                        makeGroupFlight(char,obj)
                    elif (totalMass<=maxMass) & (tkType==2) & ((material==tkType) | (mat == 2)):
                        makeGroupFlight(char,obj)

def setTKFlightSpd(event):
    char=event.object
    if Object_Exists(char)==0:
        return
    if not Object_IsAlive(char):
        return
    tkFlightTargets=FFX_ObjectGetAttr(char,'tkFlightTargets')
    flying=mlogreader.MLOG_IsFlying(char)
    baseSpeed=Object_GetAttr(char,'baseSpeed')
    baseEnergy=FFX_ObjectGetAttr(char,'baseEnergy')
    if flying:
        if tkFlightTargets>=1:
            if FFX_ObjectGetAttr(char,'tkGroupSet',0)!=1:
                FFX_ObjectSetAttr(char,'tkGroupSet',1)
                adj=tkFlightTargets/2
                newSpd=baseSpeed-adj
                newEng=baseEnergy-adj
                if newSpd < 0:
                    newSpd=0
                if newEng < 0:
                    newEng=0
                Object_SetAttr(char,'speed',newSpd)
                Object_SetAttr(char,'energy',newEng)
        else:
            Object_SetAttr(char,'speed',baseSpeed)
            Object_SetAttr(char,'energy',baseEnergy)
    else:
        Object_SetAttr(char,'speed',baseSpeed)
        Object_SetAttr(char,'energy',baseEnergy)
    RegTimer('setTKFlightSpd',0.4,0,char)

def makeGroupFlight(char,obj):
    if not mlogreader.MLOG_IsFlying(obj):
        if not hasAttribute(obj,'flier') & (hasAttribute(obj,'levitate')) & (FFX_ObjectGetAttr(obj,'ffxflier')!=0) & ((Object_GetSecondaryStates(obj)&SCSTATE_BUOYANT)!=0):
            Object_SetSecondaryState(obj,SCSTATE_BUOYANT,20000,0)
            RegTimer('removeFX',0.1,1,obj)
            ff.RESULTBUBBLE_SCALE=0
            RegTimer('bubblesOn',0.1)
            RegTimer('addtkFlightFX',0.2,0,obj,char)
            FFX_ObjectSetAttr(obj,'tkFlightTarget',1)
            FFX_ObjectSetAttr(char,'tkFlightTargets',FFX_ObjectGetAttr(char,'tkFlightTargets')+1)
            mass=Object_GetAttr(obj,'mass')
            totalMass=FFX_ObjectGetAttr(char,'totalMass')+mass
            totalFlightMass=FFX_ObjectGetAttr(char,'totalFlightMass')+mass
            FFX_ObjectSetAttr(char,'totalMass',totalMass)
            FFX_ObjectSetAttr(char,'totalFlightMass',totalFlightMass)
            Object_SetAttr(obj,'speed',0)
            if FFX_ObjectGetAttr(char,'landCmd',0)==0:
                FFX_ObjectSetAttr(char,'landCmd',1)
                Mission_CustomAction('CUSTOM_LAND_GROUP',char,char,'OnTkLand',30,0)
                RegTimer('setTKFlightSpd',0.5,0,char)
                RegTimer('tkFlightTrack',1,0,char)

def addtkFlightFX(event):
    obj=event.object
    char=event.string
    tkType=FFX_ObjectGetAttr(char,'tkType')
    if FFX_ObjectGetAttr(char,'windflight',0)==1:#weather control
        handle1=Object_PlayEffect(obj,'effect_sandstorm','',FX_LOOP|FX_TRACK_OBJECT_FULL,0,'')
        FFX_ObjectSetAttr(obj,'tkFlightFX',handle1)
        if FFX_ObjectGetAttr(char,'tkFlightFX',0)==0:
            handle2=Object_PlayEffect(char,'effect_sandstorm','',FX_LOOP|FX_TRACK_OBJECT_FULL,0,'')
            FFX_ObjectSetAttr(char,'tkFlightFX',handle2)
        return
    elif tkType==1:#metal
        handle1=Object_PlayEffect(obj,'effect_ffx_gravity','',FX_LOOP|FX_TRACK_OBJECT_FULL,0,'')
        FFX_ObjectSetAttr(obj,'tkFlightFX',handle1)
        if FFX_ObjectGetAttr(char,'tkFlightFX',0)==0:
            handle2=Object_PlayEffect(char,'effect_rot_light','',FX_LOOP|FX_TRACK_OBJECT_FULL,0,'')
            FFX_ObjectSetAttr(char,'tkFlightFX',handle2)
    elif tkType==2:#stone
        handle1=Object_PlayEffect(obj,'effect_ffx_gravity','',FX_LOOP|FX_TRACK_OBJECT_FULL,0,'')
        FFX_ObjectSetAttr(obj,'tkFlightFX',handle1)
        if FFX_ObjectGetAttr(char,'tkFlightFX',0)==0:
            handle2=Object_PlayEffect(char,'effect_rot_light','',FX_LOOP|FX_TRACK_OBJECT_FULL,0,'')
            FFX_ObjectSetAttr(char,'tkFlightFX',handle2)
    else:#tk
        handle1=Object_PlayEffect(obj,'effect_ffx_tkbubble','',FX_LOOP|FX_TRACK_OBJECT_FULL,0,'centre')
        FFX_ObjectSetAttr(obj,'tkFlightFX',handle1)
        if FFX_ObjectGetAttr(char,'tkFlightFX',0)==0:
            handle2=Object_PlayEffect(char,'effect_ffx_energysparks','',FX_LOOP|FX_TRACK_OBJECT_FULL,0,'top')
            FFX_ObjectSetAttr(char,'tkFlightFX',handle2)

def tkFlightTrack(event):
    char=event.object
    if Object_Exists(char)==0:
        return
    flightTargets=[]
    for obj in Mission_GetDynamicObjects():
        if FFX_ObjectGetAttr(char,'tkFlightTargets',0)>=1:
            if (Object_GetPrimaryState(char)!=PCSTATE_NORMAL) | (Object_IsAlive(char)==0) | (FFX_ObjectGetAttr(char,'grappled',0)==1) | (FFX_ObjectGetAttr(char,'rangedgrappled',0)==1) | (FFX_ObjectGetAttr(char,'tangled',0)==1) | (ffx.FFX_ObjectGetAttr(char,'eTangled',0)==1) | (ffx.FFX_ObjectGetAttr(char,'thrownCharacter',0)==1):
                if FFX_ObjectGetAttr(obj,'tkFlightTarget',0)==1:
                    Trigger_Force(obj,0,0,1,Object_GetAttr(obj,'mass')*100,TF_ABSOLUTE)
                    Object_SetSecondaryState(obj,SCSTATE_BUOYANT,0,REMOVE_STATE)
                    FFX_ObjectSetAttr(obj,'tkFlightTarget',0)
                    objSpd=Object_GetAttr(obj,'baseSpeed')
                    Object_SetAttr(obj,'speed',objSpd)
                    handle=ffx.FFX_ObjectGetAttr(obj,'tkFlightFX')
                    Object_StopEffect(obj,handle)
                    mass=Object_GetAttr(obj,'mass')
                FFX_ObjectSetAttr(char,'tkFlightTargets',0)
                FFX_ObjectSetAttr(char,'tkGroupSet',0)
                handle2=FFX_ObjectGetAttr(char,'tkFlightFX')
                Object_StopEffect(char,handle2)
                speed=Object_GetAttr(char,'baseSpeed')
                energy=FFX_ObjectGetAttr(char,'baseEnergy')
                Object_SetAttr(char,'speed',speed)
                Object_SetAttr(char,'energy',energy)
                totalMass=FFX_ObjectGetAttr(char,'totalMass')-mass
                totalFlightMass=FFX_ObjectGetAttr(char,'totalFlightMass')-mass
                FFX_ObjectSetAttr(char,'totalMass',totalMass)
                FFX_ObjectSetAttr(char,'totalFlightMass',totalFlightMass)
                Mission_RemoveCustomAction('CUSTOM_LAND_GROUP',char,char)
                FFX_ObjectSetAttr(char,'landCmd',0)
            elif FFX_ObjectGetAttr(char,'landCmd',0)==1:
                if FFX_ObjectGetAttr(obj,'tkFlightTarget',0)==1:
                    pos1=Get_ObjectPos(char)
                    pos2=Get_ObjectPos(obj)
                    dist = cshelper.distance2D(pos1,pos2)
                    radius=75
                    maxRadius=150
                    if dist > maxRadius:
                        Object_SetSecondaryState(obj,SCSTATE_BUOYANT,0,REMOVE_STATE)
                        FFX_ObjectSetAttr(obj,'tkFlightTarget',0)
                        FFX_ObjectSetAttr(char,'tkFlightTargets',FFX_ObjectGetAttr(char,'tkFlightTargets')-1)
                        FFX_ObjectSetAttr(char,'tkGroupSet',0)
                        objSpd=Object_GetAttr(obj,'baseSpeed')
                        charSpd=Object_GetAttr(char,'baseSpeed')
                        charEng=FFX_ObjectGetAttr(char,'baseEnergy')
                        Object_SetAttr(obj,'speed',objSpd)
                        handle=FFX_ObjectGetAttr(obj,'tkFlightFX')
                        Object_StopEffect(obj,handle)
                        mass=Object_GetAttr(obj,'mass')
                        totalMass=FFX_ObjectGetAttr(char,'totalMass')-mass
                        totalFlightMass=FFX_ObjectGetAttr(char,'totalFlightMass')-mass
                        FFX_ObjectSetAttr(char,'totalMass',totalMass)
                    elif dist >= radius:
                        newPos=(pos1[0]+FFX_Rand(-25,25),pos1[1]+FFX_Rand(-25,25),pos1[2])
                        mySpd=Object_GetAttr(char,'speed')
                        if dist >= 120:
                            Object_SetAttr(obj,'speed',mySpd+1)
                        else:
                            tkFlightTargets=FFX_ObjectGetAttr(char,'tkFlightTargets')
                            Object_SetAttr(obj,'speed',mySpd)
                        Trigger_Move(obj,'fly',newPos)
        if FFX_ObjectGetAttr(obj,'tkFlightTarget',0)==1:
            flightTargets.append(obj)
    if len(flightTargets)<1:
        handle2=FFX_ObjectGetAttr(char,'tkFlightFX')
        Object_StopEffect(char,handle2)
    RegTimer('tkFlightTrack',0.5,0,char)

def OnTkLand(char,dummy):
    for obj in Mission_GetDynamicObjects():
        if FFX_ObjectGetAttr(obj,'tkFlightTarget',0)==1:
            Object_SetSecondaryState(obj,SCSTATE_BUOYANT,0,REMOVE_STATE)
            FFX_ObjectSetAttr(obj,'tkFlightTarget',0)
            objSpd=Object_GetAttr(obj,'baseSpeed')
            Object_SetAttr(obj,'speed',objSpd)
            handle1=FFX_ObjectGetAttr(obj,'tkFlightFX')
            Object_StopEffect(obj,handle1)
            mass=Object_GetAttr(obj,'mass')
            totalMass=FFX_ObjectGetAttr(char,'totalMass')-mass
            FFX_ObjectSetAttr(char,'totalMass',totalMass)
            totalFlightMass=FFX_ObjectGetAttr(char,'totalFlightMass')-mass
            FFX_ObjectSetAttr(char,'totalFlightMass',totalFlightMass)
    FFX_ObjectSetAttr(char,'tkFlightTargets',0)
    FFX_ObjectSetAttr(char,'tkGroupSet',0)
    handle2=FFX_ObjectGetAttr(char,'tkFlightFX')
    Object_StopEffect(char,handle2)
    speed=Object_GetAttr(char,'baseSpeed')
    energy=FFX_ObjectGetAttr(char,'baseEnergy')
    Object_SetAttr(char,'speed',speed)
    Object_SetAttr(char,'energy',energy)
    Mission_RemoveCustomAction('CUSTOM_LAND_GROUP',char,char)
    FFX_ObjectSetAttr(char,'landCmd',0)

#add throw to and move to commands for TK
def AddTKCommands(char):
    if (Object_GetClass(char)&OC_CONTROLLABLE)==0:
        return
    if FFX_ObjectGetAttr(char,'tkCom')!=0:
        return
    FFX_ObjectSetAttr(char,'tkCom',1)
    Mission_CustomAction('CUSTOM_DROP',char,char,'OnDrop',5,0)
    for temp in templates:
        Mission_CustomAction('CUSTOM_THROWTO',char,temp[0],'OnThrowTo',30,0)
        Mission_CustomAction('CUSTOM_MOVETO',char,temp[0],'OnMoveTo',30,0)
    for obj in Mission_GetDynamicObjects():
        temp=Object_GetTemplate(obj)
        match=0
        for template in templates:
            if temp==template[0]:
                match=1
        if match==0:
            Mission_CustomAction('CUSTOM_THROWTO',char,obj,'OnThrowTo',30,0)
            Mission_CustomAction('CUSTOM_MOVETO',char,obj,'OnMoveTo',30,0)

def RemoveTKCommands(char):
    if (Object_GetClass(char)&OC_CONTROLLABLE)==0:
        return
    FFX_ObjectSetAttr(char,'tkCom',0)
    Mission_RemoveCustomAction('CUSTOM_DROP',char,char)
    for temp in templates:
        Mission_RemoveCustomAction('CUSTOM_THROWTO',char,temp[0])
        Mission_RemoveCustomAction('CUSTOM_MOVETO',char,temp[0])
    for obj in Mission_GetDynamicObjects():
        temp=Object_GetTemplate(obj)
        match=0
        for template in templates:
            if temp==template[0]:
                match=1
        if match==0:
            Mission_RemoveCustomAction('CUSTOM_THROWTO',char,obj)
            Mission_RemoveCustomAction('CUSTOM_MOVETO',char,obj)

def OnTKPower(char,target,index):
    type=FFX_ObjectGetAttr(char,'tkType')
    material=GetSubtypeMaterial(target)
    custom=FFX_TK_CUSTOM
    if FFX_ObjectGetAttr(char,'metalTKType',0)==1:
        if material==1:
            custom=FFX_MAGNETIC_CUSTOM
    elif FFX_ObjectGetAttr(char,'earthTKType',0)==1:
        if material==2:
            custom=FFX_EARTHCONTROL_CUSTOM
    Trigger_Power(char,target,getByTemplate(char,custom,index),'')

def OnLift(target,char):
    if chargeEP(char,FFX_EP_LIFTTK)==0:
        return
    OnTKPower(char,target,1)
    AddTKCommands(char)
    count=FFX_ObjectGetAttr(char,'tiggotCount')
    gcount=Mission_GetAttr('tigCount')
    name='tig_%s_%d'%(char,count)
    pos=Get_ObjectPos(target)
    offX=30
    offY=30
    if (int(count)&1):
        offX=-30
    if (int(count)&2):
        offY=-30
    Object_SpawnAt('ffx_tiggot',(pos[0]+offX,pos[1]+offY,pos[2]),name)
    mass=Object_GetAttr(target,'mass')
    totalMass=FFX_ObjectGetAttr(char,'totalMass')+mass
    FFX_ObjectSetAttr(char,'totalMass',totalMass)
    Object_SetAttr(name,'weight',mass)
    FFX_ObjectSetAttr(char,'tkLiftMass',mass)
    if FFX_ObjectGetAttr(char,'maxMass')<500:
        speed=6-(mass/50)
    else:
        speed=6-(mass/500)
    if speed<1:
       speed=1
    Object_SetAttr(name,'speed',speed)
    initmindless(name)
    initironjaw(name)
    FFX_ObjectSetAttr(char,'tiggotCount',count+1)
    Object_SetAttr(name,'ID',gcount)
    Mission_SetAttr('tigCount',gcount+1)
    RegTimer('OnLift2',0.3,0,name,target)

def OnLift2(event):
    Trigger_Pickup(event.object,event.string)
    makecloak(event.object,1000)

def getTiggots(char):
    tigs=[]
    name='tig_%s'%(char)
    nlen=len(name)
    for obj in Mission_GetDynamicObjects():
        if Object_GetTemplate(obj)=='ffx_tiggot':
            if obj[:nlen]==name:
                tigs.append(obj)
    return tigs

def getTigByID(id):
    for obj in Mission_GetDynamicObjects():
        if Object_GetTemplate(obj)=='ffx_tiggot':
            if Object_GetAttr(obj,'ID')==id:
                return obj
    return ''

def OnThrowTo(target,char):
    if chargeEP(char,FFX_EP_THROWTK)==0:
        return
    OnTKPower(char,target,2)
    tigs=getTiggots(char)
    for tig in tigs:
        pos = Get_ObjectPos(target)  #m25 addition to force throws not to hit ground
        pos = (pos[0],pos[1],pos[2]+20)
        Trigger_Throw(tig,pos)
        RegTimer('tigDie',3,Object_GetAttr(tig,'ID'))
    if len(tigs)>0:
        RemoveTKCommands(char)
    mass=FFX_ObjectGetAttr(char,'tkLiftMass')
    totalMass=FFX_ObjectGetAttr(char,'totalMass')-mass
    FFX_ObjectSetAttr(char,'totalMass',totalMass)

def OnMoveTo(target,char):
    if chargeEP(char,FFX_EP_MOVETK)==0:
        return
    OnTKPower(char,target,3)
    tigs=getTiggots(char)
    for tig in tigs:
        Trigger_Move(tig,'move',Get_ObjectPos(target),'',100)

def tigDie(event):
    tig=getTigByID(event.user)
    if tig!='':
        Object_Destroy(tig)

def OnDrop(dummy,char):
    tigs=getTiggots(char)
    for tig in tigs:
        Object_Destroy(tig)
    if len(tigs)>0:
        RemoveTKCommands(char)
    mass=FFX_ObjectGetAttr(char,'tkLiftMass')
    totalMass=FFX_ObjectGetAttr(char,'totalMass')-mass
    FFX_ObjectSetAttr(char,'totalMass',totalMass)

def updateTK(char):
    if (Object_GetPrimaryState(char)!=PCSTATE_NORMAL) | (Object_IsAlive(char)==0):
        OnDrop(char,char)
    else:
        for tig in getTiggots(char):
           if distanceSq(tig,char)>(400*400):
               Trigger_Move(tig,'move',Get_ObjectPos(char),'',100)

#get the best object to throw at a target character
def GetTKTarget(target,char,minMass=200):
    minDist=0
    Mission_SetAttr('distance',0)
    bestObj=''
    for object in throwObjects:
        if Object_Exists(object):
            material=Object_GetAttr(object,'material')
            matType=FFX_ObjectGetAttr(char,'tkType',FFX_MATERIAL_ANY)
            if (matType==FFX_MATERIAL_ANY) | (matType==material):
                maxMass=FFX_ObjectGetAttr(char,'maxMass',250)
                if maxMass<=250:
                    minMass=100
                mass=Object_GetAttr(object,'mass')
                if (mass>=minMass) & (mass<=maxMass):
                    dist=distanceSq(target,object)-6000
                    if dist<0:
                        dist=-dist
                    if (minDist==0) | (dist<minDist):
                        minDist=dist
                        Mission_SetAttr('distance',dist)
                        bestObj=object
    return bestObj

def rmArrow(event):
    cshelper.removeArrow('%sa'%(event.object))

#magnetic specials

def OnAttract(target,char):
    if chargeEP(char,FFX_EP_THROWMAG)==0:
        return
    OnTKPower(char,target,4)
    RegTimer('OnAttract2',1,0,target,char)

def OnAttract2(event):
    target=event.object
    char=event.string
    if hasAttribute(char,'magnetic'):
        makepull(target,char,16)
    else:
        makepull(target,char,1)

def OnRepel(target,char):
    if chargeEP(char,FFX_EP_THROWMAG)==0:
        return
    OnTKPower(char,target,4)
    RegTimer('OnRepel2',1,0,target,char)

def OnRepel2(event):
    target=event.object
    char=event.string
    direction=Vector_Sub(Get_ObjectPos(target),Get_ObjectPos(char))
    Trigger_Force(target,direction[0],direction[1],0.5,getMagnetForce(target,char),TF_ABSOLUTE)

def getMagnetForce(target,char):
    force=40*Object_GetAttr(target,'mass')
    if hasAttribute(char,'magnetic'):
        force=800*Object_GetAttr(target,'mass')
        if force>500000:
            force=500000
    else:
        if force>8000:
            force=8000
    if force<Object_GetAttr(target,'minForce'):
        force=Object_GetAttr(target,'minForce')
    return force

#earth control specials

def OnWall(target,char):
    if chargeEP(char,FFX_EP_EARTHWALL)==0:
        return
    js.Trigger_Move(char, "turn", Get_ObjectPos(target))
    dx=Vector_Sub(Get_ObjectPos(target),Get_ObjectPos(char))
    length=0.005+sqrt(dx[0]*dx[0]+dx[1]*dx[1])
    unitdx=(dx[0]/length,dx[1]/length,0)
    myPos=Get_ObjectPos(char)
    pos=(myPos[0]+unitdx[0]*30,myPos[1]+unitdx[1]*30,myPos[2])
    name=getDummyName()
    FFX_SpawnDelayOrient(name,'red_int_rock_formation2',pos)
    RegTimer('OnWall2',0.1,0,name,char)

def FFX_SpawnDelayOrient(name,temp,pos):
    t='tmp%s'%(name)
    cshelper.spawn(t,'ffx_tiggot',pos)
    RegTimer('FFX_SpawnDelayOrient2',0.1,0,name,temp)

def FFX_SpawnDelayOrient2(event):
    name=event.object
    temp=event.string
    t='tmp%s'%(name)
    print Get_ObjectPos(t)
    cshelper.spawn(name,temp,t)
    Object_SetOrientation(name,randint(0,360),(0,0,1))
    Object_Destroy(t)

def OnWall2(event):
    target=event.object
    char=event.string
    OnTKPower(char,target,4)
    dx=Vector_Sub(Get_ObjectPos(target),Get_ObjectPos(char))
    length=0.005+sqrt(dx[0]*dx[0]+dx[1]*dx[1])
    unitdx=(dx[0]/length,dx[1]/length,0)
    pos=Get_ObjectPos(target)
    name=getDummyName()
    FFX_SpawnDelayOrient(name,'red_int_rock_formation2',(pos[0]+24*unitdx[1],pos[1]-24*unitdx[0],pos[2]))
    name=getDummyName()
    FFX_SpawnDelayOrient(name,'red_int_rock_formation2',(pos[0]-24*unitdx[1],pos[1]+24*unitdx[0],pos[2]))
    RegTimer('OnWall3',0.2,0,target,char)

def OnWall3(event):
    target=event.object
    char=event.string
    dx=Vector_Sub(Get_ObjectPos(target),Get_ObjectPos(char))
    length=0.005+sqrt(dx[0]*dx[0]+dx[1]*dx[1])
    unitdx=(dx[0]/length,dx[1]/length,0)
    pos=Get_ObjectPos(target)
    name=getDummyName()
    FFX_SpawnDelayOrient(name,'red_int_rock_formation2',(pos[0]+48*unitdx[1],pos[1]-48*unitdx[0],pos[2]))
    name=getDummyName()
    FFX_SpawnDelayOrient(name,'red_int_rock_formation2',(pos[0]-48*unitdx[1],pos[1]+48*unitdx[0],pos[2]))

def OnSpike(target,char):
    if chargeEP(char,FFX_EP_EARTHWALL)==0:
        return
    name=getDummyName()
    Object_SpawnAt('ffx_tiggot',Get_ObjectPos(target),name)
    OnTKPower(char,target,4)
    RegTimer('OnSpike1',1,0,name,char)
    RegTimer('OnSpike3',1.1,0,name,target)

def OnSpike1(event):
    target=event.object
    char=event.string
    count=Mission_GetAttr('dummyCount')
    name=getDummyName()
    Object_SpawnAt('red_int_stalagmite',Get_ObjectPos(target),name)
    RegTimer('OnSpike2',0.05,count,char)

def OnSpike3(event):
    name=event.object
    target=event.string
    Trigger_Force(target,1,0,0,Object_GetAttr(target,'minForce'),0)
    Object_Destroy(name)

def OnSpike2(event):
    name='mobjdummy_%d'%(event.user)
    char=event.object
    if hasAttribute(char,'earthcontrol'):
        Trigger_Explosion(name,'ffx_earthspike',-1)
    else:
        Trigger_Explosion(name,'ffx_earthspike2',-1)

#################### ENERGY SHIELD ###################################

# mshield is a timer, -1 means forever

def initmetashield(char,update=0):
    if isMP():
        return
    FFX_ObjectSetAttr(char,'mshield',0)
    if update==0:
        Mission_CustomAction('CUSTOM_SHIELD',char,char,'OnShield',5,0)
    Object_SetAttr(char,'lastHealthES',Object_GetAttr(char,'health'))
    RegDamage(char,'OnEShield')
    RegTimer('updateMShield',1,0,char)

def initmetashieldp(char,update=0):
    FFX_ObjectSetAttr(char,'mshield',-1)
    Object_SetAttr(char,'lastHealthES',Object_GetAttr(char,'health'))
    RegDamage(char,'OnEShield')

def OnShield(target,char):
    FFX_ObjectSetAttr(target,'mshield',20)
    Object_SetAttr(target,'ffxState',FFX_STATE_ENERGYSHIELD)
    handle=Object_PlayEffect(char,getByTemplate(char,FFX_ENERGYSHIELD_CUSTOM,1),'',FX_LOOP|FX_TRACK_OBJECT_FULL,0,'Bip01 Spine')
    FFX_ObjectSetAttr(char,'fxHandle',handle)
    FFX_Animate(char,getByTemplate(char,FFX_ENERGYSHIELD_CUSTOM,3))

def OnEShield(event):
    char=event.object
    damage=Object_GetAttr(char,'lastHealthES')-Object_GetAttr(char,'health')
    Object_SetAttr(char,'lastHealthES',Object_GetAttr(char,'health'))
    RegDamage(char,'OnEShield')
    if FFX_ObjectGetAttr(char,'mshield')==0:
        return
    if damage>0:
        maxReturn=(Object_GetAttr(char,'energyPoints')-Object_GetAttr(char,'maxEnergyPoints')*0.33)/3
        payBack=maxReturn
        if damage<payBack:
            payBack=damage
        Object_SetAttr(char,'health',Object_GetAttr(char,'health')+payBack)
        Object_SetAttr(char,'energyPoints',Object_GetAttr(char,'energyPoints')-3*payBack)
        fx=getByTemplate(char,FFX_ENERGYSHIELD_CUSTOM,2)
        if fx!='':
            Object_PlayEffect(char,fx,'',0,0,bodyPart[randint(0,4)])

def updateMShield(event):
    obj=event.object
    if Object_Exists(obj)==0:
        return
    RegTimer('updateMShield',1,0,obj)
    if Object_GetAttr(obj,'ffxState')==FFX_STATE_ENERGYSHIELD:
        if FFX_ObjectGetAttr(obj,'mshield')>0:
            FFX_ObjectSetAttr(obj,'mshield',FFX_ObjectGetAttr(obj,'mshield')-1)
        else:
            if FFX_ObjectGetAttr(obj,'fxHandle',-1)!=-1:
                Object_StopEffect(obj,FFX_ObjectGetAttr(obj,'fxHandle'))


################### HEAVY FOOTED ########################################

def initheavyfooted(char,update=0):
    pos=Get_ObjectPos(char)
    FFX_ObjectSetAttr(char,'lastY',pos[1])
    FFX_ObjectSetAttr(char,'lastX',pos[0])
    RegTimer('heavyfootUpdate',0.5,0,char)

# stumpy 2007-01-02: changed so that the triggered force respects the
# DENSITY CONTROL and ACROBATIC attribs. Should probably not work on
# airborne characters either (easy to do using MLOG_IsFlying()), but
# that's more of a judgement call.
def heavyfootUpdate(event):
    char=event.object
    if getByTemplate(char,FFX_HEAVYFOOTED_CUSTOM,3)==0: ### updated to check for flying customization 02/10/07-TMX
        flying=mlogreader.MLOG_IsFlying(char)
        if flying:
            return
    if Object_Exists(char)==0:
        return
    RegTimer('heavyfootUpdate',1,0,char)
    if Object_IsAlive(char)==0: ###! in FFvsTTR, character can get resurrected by hero point, restoration and zombie state
        return
    if Object_GetAttr(char,'speed')>9:
        return
    pos=Get_ObjectPos(char)
    dist=(pos[0]-FFX_ObjectGetAttr(char,'lastX'),pos[1]-FFX_ObjectGetAttr(char,'lastY'),0)
    FFX_ObjectSetAttr(char,'lastY',pos[1])
    FFX_ObjectSetAttr(char,'lastX',pos[0])
    if (dist[0]*dist[0]+dist[1]*dist[1]) > getByTemplate(char,FFX_HEAVYFOOTED_CUSTOM,2) * 5: #TMX 2007-02-11: * 5: Fixes error in distance, esp. for teleportation
        Trigger_Explosion(char,getByTemplate(char,FFX_HEAVYFOOTED_CUSTOM,1),-1)
        mypos=Get_ObjectPos(char)
        for o in Mission_GetDynamicObjects():
            if o!=char and Object_GetAttr(o,'mass')<210 and \
               (not (hasAttribute(o,'density control') or hasAttribute(o,'acrobatic') or hasAttribute(o,'acrobaticamateur')) ):
                pos=Get_ObjectPos(o)
                dx=pos[0]-mypos[0]
                dy=pos[1]-mypos[1]
                dz=pos[2]-mypos[2]
                r2=dx*dx+dy*dy
                if dz<20 and r2>625 and r2<2500:
                    Trigger_Force(o,0,0,1,Object_GetAttr(o,'mass')*100,TF_ABSOLUTE)

################ SCARY ####################################################

def initscary(char,update=0):
    Object_SetAttr(char,'scary',1)

def updateScary(char):
    for obj in Mission_GetDynamicObjects():
        if ((Object_GetClass(obj)&FFX_CHARACTER)!=0) & ((Object_GetClass(obj)&OC_CONTROLLABLE)==0):
            if randint(1,100)<=FFX_SCARY_CHANCE:
                if distanceSq(char,obj)<(250*250):
                    goal=ai.goal.KillObjects(char)
                    addGoalToAI(obj, goal, PRI_LOW) 

############ SUPERHEALER ###########################################

#Ep. 2007-03-24:
# - Updated to use the same code base for Superhealer ("Regenerative") and Lesser Regeneration.
# - Replaced RegTimer() by RegDamage() when not damaged.
# - Fixed an issue where character would get more than maxHealth
# - Nerfed by reducing healing frequency from every 1.0 sec. to every 1.5 sec.
def initsuperhealer(char,update=0,remove=0):
    if remove:
        FFX_ObjectSetAttr(char,'superhealer',0)
    else:
        FFX_ObjectSetAttr(char,'superhealer',1)
    if update==0:
        RegDamage(char, 'updatesuperhealer', user = 8, persistent = 0, string = '')

def updatesuperhealer(event):
    SuperHealerRatio=2  #cost in EP for each health point healed
    char=event.object
    healingSpeed=int(event.user) #The difference between Superhealer and LesserRegeneration
    if not Object_Exists(char):
        return
    if (not hasAttribute(char,'superhealer')) and (not hasAttribute(char,'lesserregeneration')):
        return
    if not Object_IsAlive(char):
        RegTimer('updatesuperhealer', 1.5, healingSpeed, char)
        return
    health=Object_GetAttr(char,'health')
    maxHealth=Object_GetAttr(char,'maxHealth')
    if health >= maxHealth:
        RegDamage(char, 'updatesuperhealer', user = healingSpeed, persistent = 0, string = '')
        return
    RegTimer('updatesuperhealer', 1.5, healingSpeed, char)
    # stumpy 2008/02/22: set maxEP back to the nominal 100 so that it
    # doesn't unfairly penalize characters with ENERGY TANKS, VOLATILE
    # STORAGE, BATTERY POWERED, etc.
    if FFX_RULES_PUSHEP:
        maxEP = 105.0
    else:
        maxEP = 100.0        
    EP = Object_GetAttr(char,'energyPoints')
    percentage=EP/maxEP
    healing=int(healingSpeed*percentage)
    if healing>(EP/SuperHealerRatio):
        healing=int(EP/SuperHealerRatio)
    if health + healing > maxHealth:
        healing = maxHealth - health
        if healing<0:
            healing=0
            health=maxHealth
    Object_SetAttr(char,'health',health+healing)
    Object_SetAttr(char,'energyPoints',EP-healing*SuperHealerRatio)

############# DEGENERATIVE ########################################

# Ep. 2006-07-17: added removability, prevented bug when character destroyed
def initdegenerative(char,update=0,remove=0):
    #attribute already set?
    if remove:
        if FFX_ObjectGetAttr(char,'degenerative'):
            FFX_ObjectSetAttr(char,'degenerative',0)
        return
    if update==0:
        FFX_ObjectSetAttr(char,'degenerative',1)
        Object_SetAttr(char,'lastHealthDG',Object_GetAttr(char,'health'))
        FFX_ObjectSetAttr(char,'degenerate',0)
        RegDamage(char,'OnDegenerate')
        RegTimer('updateDegenerative',1,0,char)

def OnDegenerate(event):
    char=event.object
    if not FFX_ObjectGetAttr(char,'degenerative'):
        return
    damage=Object_GetAttr(char,'lastHealthDG')-Object_GetAttr(char,'health')
    if damage>5:
        FFX_ObjectSetAttr(char,'degenerate',4)
    elif damage>0:
        FFX_ObjectSetAttr(char,'degenerate',damage-1)
    Object_SetAttr(char,'lastHealthDG',Object_GetAttr(char,'health'))
    RegDamage(char,'OnDegenerate')

def updateDegenerative(event):
    char=event.object
    if not Object_Exists(char):
        return
    if not FFX_ObjectGetAttr(char,'degenerative'):
        return
    RegTimer('updateDegenerative',1,0,char)
    degen=FFX_ObjectGetAttr(char,'degenerate')
    if degen>0:
        FFX_SetDamageAttrs(char,Object_GetAttr(char,'health')-degen)
        Trigger_Damage(char,degen)
        FFX_ObjectSetAttr(char,'degenerate',degen-1)
        fx=getByTemplate(char,FFX_DEGENERATIVE_CUSTOM,1)
        if fx!='':
            Object_PlayEffect(char,fx,'',0,0,bodyPart[randint(0,4)])     

############## PUPPET MASTERS #######################################

FFX_URBAN=0
FFX_NATURE=32

def initpuppetu(char,update=0):
    if isMP():
        return
    if update==0:
        temps=[]
        for template in urbanTemplates:
            Mission_CustomAction('CUSTOM_ANIMATE',char,template[0],'OnAnimateUrban',30,0)

def initpuppetn(char,update=0):
    if isMP():
        return
    if update==0:
        temps=[]
        for template in natureTemplates:
            Mission_CustomAction('CUSTOM_ANIMATE',char,template[0],'OnAnimateNature',30,0)

def OnAnimateUrban(target,char):
    OnAnimate(target,char,FFX_URBAN)

def OnAnimateNature(target,char):
    OnAnimate(target,char,FFX_NATURE)

def OnAnimate(target,char,type):
    if type==FFX_NATURE:
        Trigger_Power(char,target,getByTemplate(char,FFX_PUPPETNATURE_CUSTOM,1),'')
    else:
        Trigger_Power(char,target,getByTemplate(char,FFX_PUPPETURBAN_CUSTOM,1),'')
    RegTimer('OnAnimate2',2,type,target,char)

def OnAnimate2(event):
    target=event.object
    master=event.string
    type=int(event.user)
    if Object_Exists(target)==0:
        return
    name=getDummyName()
    found=getAnim(target,event.user)
    if Template_Exists(found[1])==0:
        print 'non existant template %s used in OnAnimate'%(found[1])
        return
    Object_SetAttr(target,'standOn',0)
    Object_SpawnAt(found[1],Get_ObjectPos(target),name)
    alignWith(name,master)
    name=initialiseChar(name)
    fn=''
    if type==FFX_URBAN:
        fn=getByTemplate(master,FFX_PUPPETURBAN_CUSTOM,2)
    if type==FFX_NATURE:
        fn=getByTemplate(master,FFX_PUPPETNATURE_CUSTOM,2)
    FFX_ObjectSetAttr(name,'lifespan',100)
    FFX_ObjectSetAttr(name,'templateID',found[0])
    FFX_ObjectSetAttr(name,'master',Object_GetAttr(master,'ffxID'))
    FFX_ObjectSetAttr(name,'minionType',2)
    pc=Object_CalcPrestige(name)
    cost=(pc/5000)-1
    FFX_ObjectSetAttr(name,'cost',cost)
    res=0
    exec('res=%s(name,master,cost)'%(fn))
    if res==0:
        UnAnimate(name)
    Object_SetAttr(name,'maxHealth',Object_GetAttr(target,'maxHealth'))
    Object_SetAttr(name,'health',Object_GetAttr(target,'health'))
    Object_SetAttr(name,'mass',Object_GetAttr(target,'mass'))
    alignment=1
    if Object_GetClass(master)&(OC_VILLIAN|OC_MINION):
        alignment=0
    RegTimer('OnAnimate3',0.1,alignment+type,name,target)
    char=event.string
    cshelper.makePeaceful(name)
    if usingM25AI():
        m25ai.SetupOneChar(name)
        m25ai.SetTeam(name,m25ai.GetTeam(char))
        setGender(name,1)
        m25ai.SetBrawler(name)

def OnAnimate3(event):
    name=event.object
    target=event.string
    alignment=int(event.user)&1
    pos=Get_ObjectPos(name)
    Trigger_Move(name,'turn',(pos[0]+randint(-50,50),pos[1]+randint(-50,50),pos[2]))
    #set the AI to attack all baddies - heroes only for now
    #this gets overriden in time by the brawler system anyway
    if not usingM25AI():
        if alignment==0:
            goal = ai.goal.KillClass(OC_CONTROLLABLE)
            addGoalToAI(name, goal, PRI_LOW, '', 0,1,1)
        else:
            goal = ai.goal.KillClass(OC_VILLIAN)
            addGoalToAI(name, goal, PRI_LOW, '', 0,1,1)
            goal = ai.goal.KillClass(OC_MINION)
            addGoalToAI(name, goal, PRI_LOW, '', 0,1,1)
    if event.user<FFX_NATURE:
        Object_Destroy(target)   
    else:
        Object_SetAttr(target,'minHealth',0)
        Trigger_Damage(target,10+Object_GetAttr(target,'health'))

def getAnim(obj,type):
    index=0
    if type==FFX_URBAN:
        temps=urbanTemplates
    else:
        temps=natureTemplates
        index=100
    template=Object_GetTemplate(obj)
    for temp in temps:
        if temp[0]==template:
            return [index,temp[1]]
        index=index+1
    return [-1,'']

def UnAnimate(obj):
    global natureObjects
    global urbanObjects
    index=int(FFX_ObjectGetAttr(obj,'templateID'))
    if index<100:
        oldTemp=urbanTemplates[index][0]
    else:
        oldTemp=natureTemplates[index-100][0]
    name=getDummyName()
    Object_SpawnAt(oldTemp,Get_ObjectPos(obj),name)
    if index<100:
        urbanObjects.append(name)
    else:
        natureObjects.append(name)
    Object_SetAttr(name,'health',Object_GetAttr(obj,'health'))
    if Object_GetAttr(name,'health')<=0:
        Object_SetAttr(name,'health',1)
        Trigger_Damage(name,2)
    AI_SetEnabled(obj, 0)
    makephase(obj,10)
    makecloak(obj,10)
    FFX_ObjectSetAttr(obj,'puppet',0)
    RegTimer('UnAnimate2',4,0,obj)

#do this on a timer so that projectiles have time to leave the world before destroying the bus-men
def UnAnimate2(event):
    Object_Destroy(event.object)

def updatePuppets():
    for obj in Mission_GetDynamicObjects():
        if FFX_ObjectGetAttr(obj,'puppet')!=0:
            lifespan=Object_GetAttr(obj,'lifespan')
            lifespan=lifespan-1
            if lifespan==3:
               Object_SetPrimaryState(obj,PCSTATE_STUNNED,4,0)
            if (lifespan==0) | (Object_IsAlive(obj)==0):
                UnAnimate(obj)
            else:
                Object_SetAttr(obj,'lifespan',lifespan)

################ METAMORPHIC ####################################

def initmetamorphic(char,update=0):
    if isMP():
        return
    initgaseousform(char,update)
    initsandstorm(char,update)
    initicecloud(char,update)

################# EPHEMERAL ####################################

def initephemeral(char,update=0,remove=0):
    if remove:
        FFX_ObjectSetAttr(char, 'ephemeral', 0)
        return
    RegTimer('updateephemeral',1,0,char)
    FFX_ObjectSetAttr(char, 'ephemeral', 1)

def updateephemeral(event):
    char=event.object
    if Object_Exists(char)==0:
        return
    if not FFX_ObjectGetAttr(char, 'ephemeral'):
        return
    RegTimer('updateephemeral',1,0,char)
    #percentEnergy=Object_GetAttr(char,'energyPoints')/Object_GetAttr(char,'maxEnergyPoints') ###!changed to solve a rare zero-division error    
    maxEP=Object_GetAttr(char,'maxEnergyPoints')
    if maxEP>0:
        percentEnergy=Object_GetAttr(char,'energyPoints')/maxEP
    else:
        percentEnergy=0
    damage=0
    if (percentEnergy<0.33):
        damage=(0.33-percentEnergy)*3
    damage=damage*Object_GetAttr(char,'maxHealth')/50
    if damage>0:
        if damage>20:
            damage=20
        newHealth=Object_GetAttr(char,'health')-damage
        if newHealth<0:
            Trigger_Damage(char,damage)
        else:
            Object_SetAttr(char,'health',newHealth)
    return

def initcharged(char,update=0):
    doNothing=0

################ METABOLIC STRENGTH ####################################

def initmetastrength(char,update=0):
    if update==0:
        RegTimer('metastrupdate',1,0,char)

# *** stumpy: attempt to get this to play well with energy tanks
def metastrupdate(event):
    char=event.object
    if Object_Exists(char)==0:
        return
    RegTimer('metastrupdate',1,0,char)
    if Object_IsAlive(char)==0: ###!
        return
    maxEP=Object_GetAttr(char,'maxEnergyPoints')
    ep=Object_GetAttr(char,'energyPoints')
    if hasAttribute(char,'energytanks') or hasAttribute(char,'volatilestorage') or hasAttribute(char,'energyredirector') or (FFX_ObjectGetAttr(char,'ffactivedefenseAbsorb',0)==1):
        quartertank = (maxEP-100)/4.0
        if ep > 100 + 3*quartertank:
            strBonus = 4.0
        elif ep > 100 + 2*quartertank:
            strBonus = 3.0
        elif ep > 100 + quartertank:
            strBonus = 2.0
        elif ep > 115:
            strBonus = 1.0
        elif ep > 50:
            strBonus = 0.0
        else:
            strBonus = -1.0
    else:   # no ENERGY TANKS attribute
        if maxEP > 0:
            strBonus=(ep/maxEP)*2.0-1.0
        else:
            strBonus=0
        if strBonus>0:
            strBonus=strBonus*2.0
    FFX_SetStrength(char,strBonus)

def initmetaspeed(char,update=0):
    if update==0:
        RegTimer('metaspdupdate',1,0,char)

def metaspdupdate(event):
    char=event.object
    if Object_Exists(char)==0:
        return
    RegTimer('metaspdupdate',1,0,char)
    if Object_IsAlive(char)==0: ###!
        return
    if Object_GetAttr(char,'speed')>9:
        return
    if FFX_ObjectGetAttr(char,'tkFlightTarget',0)==1:# added to play well with TK Group Flight
        return
    maxEP=Object_GetAttr(char,'maxEnergyPoints')
    ep=Object_GetAttr(char,'energyPoints')
    if hasAttribute(char,'energytanks') or hasAttribute(char,'volatilestorage') or hasAttribute(char,'energyredirector') or (FFX_ObjectGetAttr(char,'ffactivedefenseAbsorb',0)==1):
        quartertank = (maxEP-100)/4.0
        if ep > 100 + 3*quartertank:
            spdBonus = 4.0
        elif ep > 100 + 2*quartertank:
            spdBonus = 3.0
        elif ep > 100 + quartertank:
            spdBonus = 2.0
        elif ep > 115:
            spdBonus = 1.0
        elif ep > 50:
            spdBonus = 0.0
        else:
            spdBonus = -1.0
    else:   # no ENERGY TANKS attribute
        if maxEP > 0:
            spdBonus=(ep/maxEP)*2.0-1.0
        else:
            spdBonus=0
        spdBonus=(ep/maxEP)*2.0-1.0
    spd=Object_GetAttr(char,'templateSpeed')
    if spdBonus<0:
        spd=spd*(1.0+spdBonus*0.5)
    else:
        spd=spd+spdBonus*4.0
    if spd>9:
        spd=9
    if spd<0:
        spd=0
    Object_SetAttr(char,'speed',spd)

def initmetabolic(char,update=0):
#    initmetaspd(char,update)
#    initmetastr(char,update)
    if update==0:
        RegTimer('metafnupdate',1,0,char)

# stumpy: changed to play well with ENERGY TANKS 
def metafnupdate(event):
    char=event.object
    if Object_Exists(char)==0:
        return
    RegTimer('metafnupdate',1,0,char)
    if Object_IsAlive(char)==0: ###!
        return
    maxEP=Object_GetAttr(char,'maxEnergyPoints')
    ep=Object_GetAttr(char,'energyPoints')
    if hasAttribute(char,'energytanks') or  hasAttribute(char,'volatilestorage'):
        quartertank = (maxEP-100)/4.0
        if ep > 100 + 3*quartertank:
            bonus = 4.0
        elif ep > 100 + 2*quartertank:
            bonus = 3.0
        elif ep > 100 + quartertank:
            bonus = 2.0
        elif ep > 100:
            bonus = 1.0
        elif ep > 50:
            bonus = 0.0
        else:
            bonus = -1.0
    else:   # no ENERGY TANKS attribute
        #bonus ranges from -2 to 2
        if maxEP > 0:
            bonus=(ep/maxEP)*4.0-2.0
        else:
            bonus=0
    fn=getByTemplate(char,FFX_METABOLIC_CUSTOM,1)
    exec('%s(char,bonus)'%(fn))
    bonusFX(char,bonus,FFX_METABOLIC_CUSTOM)

def bonusStrength(char,bonus):
    FFX_SetStrength(char,bonus)

def bonusPower(char,bonus):
    FFX_SetStrength(char,bonus,0)

def bonusSpeed(char,bonus):
    bonusAttr(char,bonus,'speed')

def bonusAgility(char,bonus):
    bonusAttr(char,bonus,'agility')

def bonusSpeedAndAgility(char,bonus):
    bonusAttr(char,bonus,'speed')
    bonusAttr(char,bonus,'agility')

def bonusSpeedAndStrength(char,bonus):
    bonusStrength(char,bonus)
    bonusSpeed(char,bonus)

def bonusEnergy(char,bonus):
    energy=int(FFX_ObjectGetAttr(char,'baseEnergy')+bonus)
    if energy<1:
        energy=1
    if energy>9:
        energy=9
    FFX_SetEnergy(char,energy)

def bonusEnergyRelease(char,bonus):
    if FFX_Rand(0,100)<bonus*10:
        intensity=(bonus-2.0)
        Trigger_Explosion(char,'generic disrupt object',intensity)
        Object_SetAttr(char,'energyPoints',Object_GetAttr(char,'energyPoints')-25.0*bonus)

def bonusAttr(char,bonus,attr):
    spd=Object_GetAttr(char,attr)
    spd=spd+bonus
    if spd>9:
        spd=9
    if spd<0:
        spd=0
    Object_SetAttr(char,attr,spd)

def bonusFX(char,bonus,array,node=''):
    fx=getByTemplate(char,array,2)
    if fx!='' and bonus>=1:
        Object_PlayEffect(char,fx,'',FX_TRACK_OBJECT_POS,0,node)

###!Ep 2006-02-05
def bonusEnergized(char, bonus):
    duration = 2 + (3 * bonus)
    Object_SetSecondaryState(char, SCSTATE_ENERGIZED, duration, 0)


###!Ep 2006-02-05
# Code developped for Apfarmakis - not available through the Control Center; left only as reference for eventual further developments
# for use with Dr Mike's Nocturnal attribute
# increases strength, health, invulnerability and energy
def bonusSuperNocturnal(char,bonus):
    #run the code only if the triggering state changes
    oldBonus = FFX_ObjectGetAttr(char, 'bonusSuperNocturnal')
    if (bonus + 1) == oldBonus:
        return
    FFX_ObjectSetAttr(char, 'bonusSuperNocturnal', bonus + 1)
    #double health and maxHealth
    maxHealth = Object_GetAttr(char, 'maxHealth')
    newMaxHealth = (bonus + 1) * maxHealth / max(oldBonus, 1)
    Object_SetAttr(char, 'maxHealth', int(round(newMaxHealth)))
    health = Object_GetAttr(char, 'health')
    newHealth = (bonus + 1) * health / max(oldBonus, 1)
    Object_SetAttr(char, 'health', int(round(newHealth)))
    strengthIncrease = bonus * 4
    bonusStrength(char, strengthIncrease)
    #increase energy by 2
    energyIncrease = bonus * 2
    bonusEnergy(char, energyIncrease)
    #add 5 points of invulnerability
    bonusInvuln = (bonus - max(oldBonus, 1) + 1) * 5
    invPoints = FFX_ObjectGetAttr(char, 'invPoints')
    if invPoints == 0:
        FFX_ObjectSetAttr(char, 'ivlastdam', Object_GetAttr(char, 'health'))
        if not FFX_ObjectGetAttr(char, 'DamageManagement', 0):
            RegDamage(char, 'DamageManagement')
            FFX_ObjectSetAttr(char, 'DamageManagement', 1)
    FFX_ObjectSetAttr(char, 'invPoints', invPoints + bonusInvuln)
    FFX_ObjectSetAttr(char, 'baseInvPoints', invPoints + bonusInvuln)

################ PHOTOPHOBIC ####################################
# stumpy 2006-12-13: Attribute to reflect weakness in light.
# See http://freedomreborn.net/quattro/index.php?topic=40646.0
# I am treating this as sort of a negative version of NOCTURNAL,
# w.r.t. customizations, etc. But, it could also be a variation on
# VULNERABILITY.
# BTW, this should conform to the removability protocol for scripted
# attributes, but that would involve changing the way the bonus
# functions work so that their effects can be undone.

# strings.txt entries
#ATTRIB_PHOTOPHOBIC_01, photophobic
#ATTRIB_PHOTOPHOBIC_DESC_01, your need for sunscreen goes way beyond the normal.  you are weakened in well-lit settings.

if not 'FFX_PHOTOPHOBIC_CUSTOM' in dir():
    FFX_PHOTOPHOBIC_CUSTOM=[
        ["default","bonusStrength",""],
        ["types","mBonus Type","OOptional FX"],
        ]

def initphotophobic(char,update=0):
    RegTimer('photophobicupdate',1,0,char)

def photophobicupdate(event):
    char=event.object
    if Object_Exists(char)==0:
        return
    RegTimer('photophobicupdate',3,0,char)
    if Object_IsAlive(char)==0: ###!
        return
    if getLightLevels()<=0.9:
        bonus=0
    else:
        bonus=-1
    fn=getByTemplate(char,FFX_PHOTOPHOBIC_CUSTOM,1)
    exec('%s(char,bonus)'%(fn))
    bonusFX(char,bonus,FFX_PHOTOPHOBIC_CUSTOM)

################ NOCTURNAL AND SOLAR POWERED ####################################

def initnocturnal(char,update=0):
    RegTimer('nocturnalupdate',1,0,char)

def nocturnalupdate(event):
    char=event.object
    if Object_Exists(char)==0:
        return
    RegTimer('nocturnalupdate',1,0,char)
    if Object_IsAlive(char)==0: ###!
        return
    if getLightLevels()<1.0:
        bonus=1
    else:
        bonus=0
    fn=getByTemplate(char,FFX_NOCTURNAL_CUSTOM,1)
    exec('%s(char,bonus)'%(fn))
    bonusFX(char,bonus,FFX_NOCTURNAL_CUSTOM)

def initsolarpowered(char,update=0):
    print 'solar powered character%s has base energy %d'%(char,FFX_ObjectGetAttr(char,'baseEnergy'))
    RegTimer('solarupdate',1,0,char)

def solarupdate(event):
    char=event.object
    if Object_Exists(char)==0:
        return
    RegTimer('solarupdate',1,0,char)
    if Object_IsAlive(char)==0: ###!
        return
    light=getLightLevels()
    if Object_GetSecondaryStates(char)&SCSTATE_BLIND:
        light=0
    bonus=(light-1.0)*3
    fn=getByTemplate(char,FFX_SOLARPOWERED_CUSTOM,1)
    exec('%s(char,bonus)'%(fn))
    bonusFX(char,bonus,FFX_SOLARPOWERED_CUSTOM,'Bip01 Head')

################ PSYCHIC LINK ###################################

def initpsychiclink(char,update=0):
    Object_SetAttr(char,'lastHealthPL',Object_GetAttr(char,'health'))
    RegDamage(char,'OnPsychicLink')

def OnPsychicLink(event):
    char=event.object
    damage=Object_GetAttr(char,'lastHealthPL')-Object_GetAttr(char,'health')
    if damage>0:
        for obj in Mission_GetDynamicObjects():
            if obj!=char:
                if Object_GetClass(obj)&FFX_CHARACTER:
                    if hasAttribute(obj,'psychiclink'):
                        FFX_ApplyDamage(obj,damage,1)
                        RegTimer('OnPsychicLinkCB',0.1,0,char,obj)
    Object_SetAttr(char,'lastHealthPL',Object_GetAttr(char,'health'))
    RegDamage(char,'OnPsychicLink')

################ EMPATH ###################################

def initempath(char,update=0,remove=0):
    if remove:
        FFX_ObjectSetAttr(char,'empath',0)
    else:
        FFX_ObjectSetAttr(char,'empath',1)
    RegTimer('empathCheck',1,0,char)
    try:
       if Mission_GetAttr('empath')!=0:
           return
    except:
        RegTimer('globalEmpath',1)
        Mission_SetAttr('empath',1)

def globalEmpath(event):
    char=event.object
    if FFX_ObjectGetAttr(char,'empath',0)!=0:
        for obj in Mission_GetDynamicObjects():
            if Object_GetClass(obj)&FFX_CHARACTER:
                if FFX_ObjectGetAttr(obj,'healthEMP',-1)==-1:
                    FFX_ObjectSetAttr(obj,'healthEMP',Object_GetAttr(obj,'health'))
                    RegDamage(obj,'empathDamage')
        RegTimer('globalEmpath',5)

def empathDamage(event):
    char=event.object
    if FFX_ObjectGetAttr(char,'empath',0)!=0:
        hp=Object_GetAttr(char,'health')
        damage=FFX_ObjectGetAttr(char,'healthEMP')-hp
        if damage>0:
            damage=int(damage*0.33)
            for obj in Mission_GetDynamicObjects():
                if obj!=char:
                    if Object_GetClass(obj)&FFX_CHARACTER:
                        if hasAttribute(obj,'empath'):
                            if distanceSq(obj,char)<8000:
                                Object_PlayEffect(char,'effect_ffx_telepathy')
                                FFX_ApplyDamage(obj,damage,1)
        FFX_ObjectSetAttr(char,'healthEMP',hp)
        RegDamage(char,'empathDamage')

def empathCheck(event):
    char=event.object
    if FFX_ObjectGetAttr(char,'empath',0)!=0:
        myDamage=Object_GetAttr(char,'maxHealth')-Object_GetAttr(char,'health')
        for obj in Mission_GetDynamicObjects():
            if obj!=char:
                if Object_GetClass(obj)&FFX_CHARACTER:
                    if distanceSq(obj,char)<8000:
                        state=Object_GetPrimaryState(obj)
                        if (state>=6) & (state<=10):
                            if FFX_Rand(1,4)<2:
                                Object_SetPrimaryState(char,state,5,0)
                                Object_PlayEffect(obj,'effect_ffx_telepathy')
        if Object_Exists(char): ###!
            RegTimer('empathCheck',1,0,char)

################ NARCOLEPSY ###################################
# As per http://freedomreborn.net/quattro/index.php?topic=39129.0
#
# strings.txt entry:
# ATTRIB_NARCOLEPTIC_01, narcoleptic
# ATTRIB_NARCOLEPTIC_DESC_01, superheroics are VERY tiring.  You have a chance of being stunned whenever you use energy.
#
# Ep. 2007-02-11: Replaced the Object_Get/SetAttr() calls with the safer FFX_ObjectGet/SetAttr() versions

def initnarcoleptic(char,update=0,remove=0):
    if remove:
        FFX_ObjectSetAttr(char,'narcoleptic',0)
    else:
        FFX_ObjectSetAttr(char,'narcoleptic',1)
        if not update:
            FFX_ObjectSetAttr(char,'narcoLastEP',Object_GetAttr(char,'energyPoints'))
            RegTimer('narcostuncheck',0.25,0,char)

def narcostuncheck(event):
    char = event.object
    if FFX_ObjectGetAttr(char,'narcoleptic') > 0.0:
        lastEP = FFX_ObjectGetAttr(char,'narcoLastEP')
        ##print 'narcostuncheck: <%s (%s)> lastEP = %f   current EP = %f' % (char,GetCharacterData(char).get('charName'),lastEP,Object_GetAttr(char,'energyPoints'))
        if Object_GetAttr(char,'energyPoints') - lastEP < 0.0:
            chance = effect = getByTemplate(char,FFX_NARCOLEPTIC_CUSTOM,1)
            ##roll = randint(1,100)
            ##print 'narcostuncheck: <%s (%s)> roll = %d / chance = %d' % (char,GetCharacterData(char).get('charName'),roll,chance)
            ##if roll <= chance:
            if randint(1,100) <= chance:
                Object_SetPrimaryState(char,PCSTATE_STUNNED,5,0)
        FFX_ObjectSetAttr(char,'narcoLastEP',Object_GetAttr(char,'energyPoints'))
        RegTimer('narcostuncheck',0.25,0,char)
        

################ TELEPATHIC ###################################

# Characters with the attributes in the specialAttribs tuple will have custom commands on special objects
# Default is specialAttribs=('scientist','finetk','magnetic','telepathy')
# Cf. ffxcustoms.py.
def inittelepathic(char,update=0):
    pass

############# ACROBATIC AND ACROBATIC (AMATEUR) #############################

# Updated by Stumpy to use MLOGReader and be removable
# Ep. 2006-08-24: changed to behave more like the original
# (the character should rarely take damage when landing; customisable).
def initacrobatic(char,update=0,remove=0): 
    if remove: 
        FFX_ObjectSetAttr(char,'acrobatic',0) 
        mlogreader.cancelAnimationCallbackSink(char,'acroFlail') 
    else:
        FFX_ObjectSetAttr(char,'acrobatic',1) 
        FFX_ObjectSetAttr(char,'acrobatic_zpos', 0)
        mlogreader.regFlailStart(char,'acroFlail',persistent=1)

def acroFlail(event):
    char = event.object
    if Object_GetPrimaryState(char) != PCSTATE_NORMAL:
        return
    if FFX_ObjectGetAttr(char, 'voluntary_flailing'):
        return
    zPos = int ( Get_ObjectPos(char)[2] )
    FFX_ObjectSetAttr(char, 'acrobatic_zpos', zPos)
    RegTimer('acroFlail2', 0.2, 0, char) 
    
def acroFlail2(event):
    char = event.object
    zPos = int( Get_ObjectPos(char)[2] )
    zPosOld = FFX_ObjectGetAttr(char, 'acrobatic_zpos')
    if zPos - zPosOld < -10:
        if FFX_ObjectGetAttr(char, 'acrobatic'): 
            FFX_Animate(char, getByTemplate(char, FFX_ACROBATIC_CUSTOM, 1) )
            mlogreader.MLOG_ResetKnockBack(char)  #m25
    elif zPos > zPosOld: #Ep. 2006-08-30: don't check as frequently while still going up
        FFX_ObjectSetAttr(char, 'acrobatic_zpos', zPos)
        RegTimer('acroFlail2', 0.3, 0, char) 
    else:
        FFX_ObjectSetAttr(char, 'acrobatic_zpos', zPos)
        RegTimer('acroFlail2', 0.1, 0, char) 


# Updated by Stumpy to use MLOGReader and be removable
# Ep. 2006-08-23: minor tweaks, made into a separate attribute, as it behaves a bit differently
# (the character takes a bit of damage).
def initacrobaticamateur(char,update=0,remove=0): 
    if remove: 
        FFX_ObjectSetAttr(char,'acrobaticamateur',0) 
        mlogreader.cancelAnimationCallbackSink(char,'acroLandAmateur') 
    else:
        FFX_ObjectSetAttr(char,'acrobaticamateur',1) 
        mlogreader.regFlailStop(char,'acroLandAmateur',persistent=1) 

def acroLandAmateur(event):
    char = event.object
    if Object_GetPrimaryState(char) != PCSTATE_NORMAL:
        return
    if FFX_ObjectGetAttr(char, 'voluntary_flailing'):
        return
    RegTimer('acroLandAmateur2', 0.1, 0, char) 
    
def acroLandAmateur2(event):
    char = event.object
    if FFX_ObjectGetAttr(char,'acrobaticamateur'): 
        Trigger_Power(char,char,'land_from_jump','')
        mlogreader.MLOG_ResetKnockBack(char)    # *** stumpy 2007-09-26 


#tries to prevent a character from being frozen in a specific animation after using AI_Animate()
def FFX_Unlock(event):
    Trigger_Move(event.object,'unlock')


############### FIRE CONTROL ##############################

def initfirecontrol(char,update=0):
    if isMP():
        return
    RegTimer('updatefirewall',1,0,char)
    Mission_CustomAction('CUSTOM_EXTINGUISH',char,'ffx_flames','OnExtinguish',30,0)
    Mission_CustomAction('CUSTOM_EXTINGUISH',char,'ffx_firecage','OnExtinguish',30,0)

def updatefirewall(event):
    char=event.object
    update=event.user
    RegTimer('updatefirewall',5,1,char)
    addCommand('CUSTOM_FIREWALL',char,'OnFireWall',30,update)

def OnFireWall(target,char):
    if chargeEP(char,25)==0:
        return
    FFX_ObjectSetAttr(char,'deltaT',-6)
#    js.Trigger_Move(char,"turn", Get_ObjectPos(target))
    dx=Vector_Sub(Get_ObjectPos(target),Get_ObjectPos(char))
    length=0.005+sqrt(dx[0]*dx[0]+dx[1]*dx[1])
    unitdx=(dx[0]/length,dx[1]/length,0)
    myPos=Get_ObjectPos(target)
    pos=(myPos[0]-unitdx[0]*50,myPos[1]-unitdx[1]*50,myPos[2])
    name=getDummyName()
    cshelper.spawn(name,'ffx_flames',pos)
    Object_PlayEffect(name,'effect_ffx_flames2','',FX_LOOP)
    RegTimer('OnFireWall2',0.1,0,name,char)
    RegTimer('OnFlames',1,10,name)
    Trigger_Power(char,name,getByTemplate(char,FFX_FIRECONTROL_CUSTOM,1),'')

def OnFireWall2(event):
    target=event.object
    char=event.string
    Trigger_Power(char,target,getByTemplate(char,FFX_FIRECONTROL_CUSTOM,1),'')
    dx=Vector_Sub(Get_ObjectPos(target),Get_ObjectPos(char))
    length=0.005+sqrt(dx[0]*dx[0]+dx[1]*dx[1])
    unitdx=(dx[0]/length,dx[1]/length,0)
    pos=Get_ObjectPos(target)
    name1=getDummyName()
    name2=getDummyName()
    Object_SpawnAt('ffx_flames',(pos[0]+16*unitdx[1],pos[1]-16*unitdx[0],pos[2]),name1) 
    Object_SpawnAt('ffx_flames',(pos[0]-16*unitdx[1],pos[1]+16*unitdx[0],pos[2]),name2) 
    Object_PlayEffect(name1,'effect_ffx_flames2','',FX_LOOP)
    Object_PlayEffect(name2,'effect_ffx_flames2','',FX_LOOP)
    RegTimer('OnFireWall3',0.2,0,target,char)
    RegTimer('OnFlames',1,10,name1)
    RegTimer('OnFlames',1,10,name2)

def OnFireWall3(event):
    target=event.object
    char=event.string
    dx=Vector_Sub(Get_ObjectPos(target),Get_ObjectPos(char))
    length=0.005+sqrt(dx[0]*dx[0]+dx[1]*dx[1])
    unitdx=(dx[0]/length,dx[1]/length,0)
    pos=Get_ObjectPos(target)
    name1=getDummyName()
    name2=getDummyName()
    Object_SpawnAt('ffx_flames',(pos[0]+32*unitdx[1],pos[1]-32*unitdx[0],pos[2]),name1)
    Object_SpawnAt('ffx_flames',(pos[0]-32*unitdx[1],pos[1]+32*unitdx[0],pos[2]),name2) 
    Object_PlayEffect(name1,'effect_ffx_flames2','',FX_LOOP)
    Object_PlayEffect(name2,'effect_ffx_flames2','',FX_LOOP)
    RegTimer('OnFlames',1,10,name1)
    RegTimer('OnFlames',1,10,name2)

def OnFlames(event):
    obj=event.object
    if not Object_Exists(obj): ###! Ep. 2006-06-21
        return
    if (event.user>0) & (cshelper.isPlaying()==0):
        if cshelper.isPlaying()==0:
            Trigger_Explosion(obj,'ffx_flames',-1)
        RegTimer('OnFlames',1,event.user-1,obj)
    else:
        Object_Destroy(obj)

def OnExtinguish(target,char):
    FFX_ObjectSetAttr(char,'deltaT',4)
    Trigger_Power(char,target,getByTemplate(char,FFX_FIRECONTROL_CUSTOM,1),'')
    index=Mission_GetAttr('dummyCount')
    i=index-200
    if i<0:
        i=0
    while i<index:
        obj='mobjdummy_%d'%(i)
        i=i+1
        if Object_Exists(obj):
            if (Object_GetTemplate(obj)=='ffx_flames') | (Object_GetTemplate(obj)=='ffx_firecage'):
                if distanceSq(target,obj)<10000:
                    Object_Destroy(obj)
                    if (Object_GetTemplate(obj)=='ffx_firecage'):
                        victim=obj[1:]
                        if Object_Exists(victim):
                            fallOver(victim)
    Object_Destroy(target)

############### ICE CONTROL ###############################

def initicecontrol(char,update=0):
    if isMP():
        return
    RegTimer('updateice',1,0,char)

def updateice(event):
    char=event.object
    update=event.user
    RegTimer('updateice',5,1,char)
    addCommand('CUSTOM_ICEWALL',char,'OnIceWall',30,update)
    addCommand('CUSTOM_ICEPATCH',char,'OnIcePatch',30,update)

def OnIceWall(target,char):
    if chargeEP(char,25)==0:
        return
    FFX_ObjectSetAttr(char,'deltaT',5)
    js.Trigger_Move(char, "turn", Get_ObjectPos(target))
    dx=Vector_Sub(Get_ObjectPos(target),Get_ObjectPos(char))
    length=0.005+sqrt(dx[0]*dx[0]+dx[1]*dx[1])
    unitdx=(dx[0]/length,dx[1]/length,0)
    myPos=Get_ObjectPos(target)
    pos=(myPos[0]-unitdx[0]*50,myPos[1]-unitdx[1]*50,myPos[2])
    name=getDummyName()
    FFX_SpawnDelayOrient(name,'ffx_icewall',pos)
    RegTimer('OnIceWall2',0.1,0,name,char)
    RegTimer('OnIcewallCB',0.1,0,char)

def OnIceWall2(event):
    target=event.object
    char=event.string
    Trigger_Power(target,char,getByTemplate(char,FFX_ICECONTROL_CUSTOM,1),'')
    dx=Vector_Sub(Get_ObjectPos(target),Get_ObjectPos(char))
    length=0.005+sqrt(dx[0]*dx[0]+dx[1]*dx[1])
    unitdx=(dx[0]/length,dx[1]/length,0)
    pos=Get_ObjectPos(target)
    name1=getDummyName()
    name2=getDummyName()
    FFX_SpawnDelayOrient(name1,'ffx_icewall',(pos[0]+32*unitdx[1],pos[1]-32*unitdx[0],pos[2]))
    FFX_SpawnDelayOrient(name2,'ffx_icewall',(pos[0]-32*unitdx[1],pos[1]+32*unitdx[0],pos[2]))
    RegTimer('OnIceWall3',0.2,0,target,char)

def OnIceWall3(event):
    target=event.object
    char=event.string
    dx=Vector_Sub(Get_ObjectPos(target),Get_ObjectPos(char))
    length=0.005+sqrt(dx[0]*dx[0]+dx[1]*dx[1])
    unitdx=(dx[0]/length,dx[1]/length,0)
    pos=Get_ObjectPos(target)
    name1=getDummyName()
    name2=getDummyName()
    FFX_SpawnDelayOrient(name1,'ffx_icewall',(pos[0]+64*unitdx[1],pos[1]-64*unitdx[0],pos[2]))
    FFX_SpawnDelayOrient(name2,'ffx_icewall',(pos[0]-64*unitdx[1],pos[1]+64*unitdx[0],pos[2]))

def OnIcePatch(target,char):
    if chargeEP(char,25)==0:
        return
    FFX_ObjectSetAttr(char,'deltaT',5)
    name=getDummyName()
    targetPos = Get_ObjectPos(target)
    if mlogreader.MLOG_IsFlying(target): #Ep. 2006-08-25: Try to prevent the most obvious cases of ice patches floating above the ground; Ep. 2007-02-04: replaced obsolete FFQ_IsFlying()
        objPos = Get_ObjectPos( getNearestObject(target) )
        if targetPos[2] > objPos[2]:
            targetPos = (targetPos[0], targetPos[1], objPos[2])
    Object_SpawnAt('ffx_icepatch', targetPos, name)
    Trigger_Power(char,target,getByTemplate(char,FFX_ICECONTROL_CUSTOM,2),'')
    RegTimer('OnIcePatch2',1,6,name)
    RegTimer('OnIcepatchCB',0.1,0,char)
    
#Ep. 2006-08-25: A couple of tweaks: Fliers and ice material characters won't fall, minor performance improvements.
def OnIcePatch2(event): 
    name=event.object
    if (event.user>0) & (cshelper.isPlaying()==0):
        RegTimer('OnIcePatch2',1.5,event.user-1,name)
        for obj in Mission_GetDynamicObjects():
            if Object_GetClass(obj)&FFX_CHARACTER:
                if Object_IsAlive(obj):
                    if FFX_Rand(1,2)==1:
                        if distanceSq(name,obj)<6400:
                            if not mlogreader.MLOG_IsFlying(obj): #Ep. 2007-02-04: replaced obsolete FFQ_IsFlying()
                                state=Object_GetPrimaryState(obj)
                                if (state!=PCSTATE_FROZEN) & (state!=PCSTATE_STATIC):
                                    if not isIce(obj):
                                        if (hasAttribute(obj,'acrobatic')==0) & (hasAttribute(obj,'acrobaticamateur')==0) & (hasAttribute(obj,'icecontrol')==0) & (FFX_ObjectGetAttr(obj,'phased')==0):
                                            fallOver(obj)
    else:
        Object_Destroy(name)

############### MASS CONTROL ###############################

def initmasscontrol(char,update=0):
    if isMP():
        return
    if update==0:
        Mission_CustomAction('CUSTOM_MASSUP',char,char,'OnMassUp',5,0)
        Mission_CustomAction('CUSTOM_MASSDOWN',char,char,'OnMassDown',5,0)
        FFX_ObjectSetAttr(char,'massstate',0)

def OnMassUp(target,char):
    Object_PlayEffect(char,'effect_ffx_density','',FX_TRACK_OBJECT_POS)
    state=FFX_ObjectGetAttr(char,'massstate')
    if state==0:
        FFX_ObjectSetAttr(char,'massstate',1)
        FFX_SetMassFactor(char,5)
        FFX_MultiplyAttr(char,'speed',0.5,1)
        FFX_SetStrength(char,2)
        FFX_MultiplyAttr(char,'baseSpeed',0.5,1)
        FFX_MultiplyAttr(char,'agility',0.334,1)
        FFX_FactorHealth(char,1.5)
        Mission_RemoveCustomAction('CUSTOM_MASSUP',char,char)
    else:
        FFX_ObjectSetAttr(char,'massstate',0)
        FFX_SetMassFactor(char,1)
        Object_SetAttr(char,'speed',Object_GetAttr(char,'templateSpeed'))
        FFX_SetStrength(char,0)
        Object_SetAttr(char,'baseSpeed',Object_GetAttr(char,'templateSpeed'))
        Object_SetAttr(char,'agility',Object_GetAttr(char,'templateAgility'))
        FFX_FactorHealth(char,2)
        Mission_CustomAction('CUSTOM_MASSDOWN',char,char,'OnMassDown',5,0)

def OnMassDown(target,char):
    Object_PlayEffect(char,'effect_ffx_density','',FX_TRACK_OBJECT_POS)
    state=FFX_ObjectGetAttr(char,'massstate')
    if state==0:
        FFX_ObjectSetAttr(char,'massstate',-1)
        FFX_SetMassFactor(char,0.4)
        FFX_MultiplyAttr(char,'speed',2,1)
        FFX_SetStrength(char,-2)
        FFX_MultiplyAttr(char,'baseSpeed',2,1)
        FFX_MultiplyAttr(char,'agility',2,1)
        FFX_FactorHealth(char,0.5)
        Mission_RemoveCustomAction('CUSTOM_MASSDOWN',char,char)
    else:
        FFX_ObjectSetAttr(char,'massstate',0)
        FFX_SetMassFactor(char,1)
        Object_SetAttr(char,'speed',Object_GetAttr(char,'templateSpeed'))
        FFX_SetStrength(char,0)
        Object_SetAttr(char,'baseSpeed',Object_GetAttr(char,'templateSpeed'))
        Object_SetAttr(char,'agility',Object_GetAttr(char,'templateAgility'))
        FFX_FactorHealth(char,0.667)
        Mission_CustomAction('CUSTOM_MASSUP',char,char,'OnMassUp',5,0)

def FFX_MultiplyAttr(char,attr,factor,stat=0):
    newVal=Object_GetAttr(char,attr)*factor
    if stat!=0:
        newVal=int(newVal)
        if newVal<0:
            newVal=0
        if newVal>9:
            newVal=9
    Object_SetAttr(char,attr,newVal)

############### INVULNERABLE ###############################
###! Added initinvulnerable0() and initinvulnerable2a()
###! Modified all invulnerable grades with Stumpy's Damage Management code for compatibility with Tough Guy 2
    
###! Added for Shazam's additional grades
def initinvulnerable0(char,update=0):
    if update==0:
        invPoints=FFX_ObjectGetAttr(char,'invPoints')
        if invPoints==0:
            FFX_ObjectSetAttr(char,'ivlastdam',Object_GetAttr(char,'health'))
            if not FFX_ObjectGetAttr(char,'DamageManagement',0):
                RegDamage(char,'DamageManagement')
                FFX_ObjectSetAttr(char,'DamageManagement',1)
        FFX_ObjectSetAttr(char,'invPoints',invPoints+2)
        FFX_ObjectSetAttr(char,'baseInvPoints',invPoints+2)
        FFX_ObjectSetAttr(char,'permInvPoints',invPoints+2)

###! Added for Shazam's additional grades
def initinvulnerable2a(char,update=0):
    if update==0:
        invPoints=FFX_ObjectGetAttr(char,'invPoints')
        if invPoints==0:
            FFX_ObjectSetAttr(char,'ivlastdam',Object_GetAttr(char,'health'))
            if not FFX_ObjectGetAttr(char,'DamageManagement',0):
                RegDamage(char,'DamageManagement')
                FFX_ObjectSetAttr(char,'DamageManagement',1)
        FFX_ObjectSetAttr(char,'invPoints',invPoints+15)
        FFX_ObjectSetAttr(char,'baseInvPoints',invPoints+15)
        FFX_ObjectSetAttr(char,'permInvPoints',invPoints+15)

def initinvulnerable(char,update=0):
    if update==0:
        invPoints=FFX_ObjectGetAttr(char,'invPoints')
        if invPoints==0:
            FFX_ObjectSetAttr(char,'ivlastdam',Object_GetAttr(char,'health'))
            if not FFX_ObjectGetAttr(char,'DamageManagement',0):
                RegDamage(char,'DamageManagement')
                FFX_ObjectSetAttr(char,'DamageManagement',1)
        FFX_ObjectSetAttr(char,'invPoints',invPoints+5)
        FFX_ObjectSetAttr(char,'baseInvPoints',invPoints+5)
        FFX_ObjectSetAttr(char,'permInvPoints',invPoints+5)

def initinvulnerable2(char,update=0):
    if update==0:
        invPoints=FFX_ObjectGetAttr(char,'invPoints')
        if invPoints==0:
            FFX_ObjectSetAttr(char,'ivlastdam',Object_GetAttr(char,'health'))
            if not FFX_ObjectGetAttr(char,'DamageManagement',0):
                RegDamage(char,'DamageManagement')
                FFX_ObjectSetAttr(char,'DamageManagement',1)
        FFX_ObjectSetAttr(char,'invPoints',invPoints+10)
        FFX_ObjectSetAttr(char,'baseInvPoints',invPoints+10)
        FFX_ObjectSetAttr(char,'permInvPoints',invPoints+10)

def initinvulnerable3(char,update=0):
    if update==0:
        invPoints=FFX_ObjectGetAttr(char,'invPoints')
        if invPoints==0:
            FFX_ObjectSetAttr(char,'ivlastdam',Object_GetAttr(char,'health'))
            if not FFX_ObjectGetAttr(char,'DamageManagement',0):
                RegDamage(char,'DamageManagement')
                FFX_ObjectSetAttr(char,'DamageManagement',1)
        FFX_ObjectSetAttr(char,'invPoints',invPoints+20)
        FFX_ObjectSetAttr(char,'baseInvPoints',invPoints+20)
        FFX_ObjectSetAttr(char,'permInvPoints',invPoints+20)

def initinvulnerable4(char,update=0):
    if update==0:
        invPoints=FFX_ObjectGetAttr(char,'invPoints')
        if invPoints==0:
            FFX_ObjectSetAttr(char,'ivlastdam',Object_GetAttr(char,'health'))
            if not FFX_ObjectGetAttr(char,'DamageManagement',0):
                RegDamage(char,'DamageManagement')
                FFX_ObjectSetAttr(char,'DamageManagement',1)
        FFX_ObjectSetAttr(char,'invPoints',invPoints+30)
        FFX_ObjectSetAttr(char,'baseInvPoints',invPoints+30)
        FFX_ObjectSetAttr(char,'permInvPoints',invPoints+30)


############### UNBREAKABLE ###############################

def initunbreakable(char,update=0):
    if update==0:
        FFX_ObjectSetAttr(char,'ublastdam',Object_GetAttr(char,'health'))
        RegDamage(char,'OnUBDamage')
        Object_SetAttr(char,'minHealth',Object_GetAttr(char,'health')-30)

def onUBDamage(event):
    char=event.object
    RegDamage(char,'OnUBDamage')
    minHealth=Object_GetAttr(char,'minHealth')
    mh2=Object_GetAttr(char,'health')-30
    if mh2<minHealth:
        Object_SetAttr(char,'minHealth',mh2)

####################### ACCIDENTAL CHANGE #################################

def initaccidentalchange(char,update):
    if isMP():
        return
    trigger=getByTemplate(char,FFX_ACCIDENTALFORM_CUSTOM,1)
    print 'accidental change of %s(%s) triggered by %s' % (char, FFX_GetTemplate(char), trigger)
    RegTimer('OnAccidentalStateS',1,0,trigger,char)

def OnAccidentalStateS(event):
    fn=event.object
    char=event.string
    trigger=0
    exec 'trigger=%s(char)'%(fn)
    #print 'AccCheck:trigger=%s(char)'%(fn)
    if trigger:
        print 'trigger activated!'
        name=getFormName()
        hasPortrait=FFX_HasPortrait(char)
        morph(name,char,getByTemplate(char,FFX_ACCIDENTALFORM_CUSTOM,2),1,hasPortrait)
        fx=getByTemplate(char,FFX_ACCIDENTALFORM_CUSTOM,3)
        if fx!='':
            Object_PlayEffect(char,fx)
    else:
        RegTimer('OnAccidentalStateS',1,0,fn,char)

####################### INVOLUNTARY FORM ##################################

def initinvoluntaryform(char,update):
    global FFX_ACCIDENTALFORM_CUSTOM
    if isMP():
        return
    #at startup add them into the default slots for shapeshifter
    print 'initinvolform: shapeready=%d'%(Mission_GetAttr('shapeReady'))
    if Mission_GetAttr('shapeReady')==0:
        print 'involform at startup:'
        startform=''
        for hero in cshelper.getAllHeroes():
            if hasAttribute(hero,'accidentalchange'):
                startform=Object_GetTemplate(hero)
        FFX_ACCIDENTALFORM_CUSTOM.append([startform,7,Object_GetTemplate(char),])
        RegTimer('destroyTemp',1,0,char)
        return
    print 'Init Invol'
    me=Object_GetTemplate(char)
    template=me
    print me
    for set in FFX_ACCIDENTALFORM_CUSTOM:
        if set[2]==me:
            template=set[0]
    print template
    if FFX_TemplateExists(template)==0:
        customTemplate=getTemplateFromRealName(template)
        print customTemplate
        if FFX_TemplateExists(customTemplate):
            template=customTemplate
    print template
    if template!='default':
        RegTimer('OnAccidentalRevert',1,0,char,template)

def OnAccidentalRevert(event):
    char=event.object
    if Object_Exists(char):
        t=Object_GetTemplate(char)
        fx=FFX_ACCIDENTALFORM_CUSTOM[0][3]
        fn=FFX_ACCIDENTALFORM_CUSTOM[0][4]
        for set in FFX_ACCIDENTALFORM_CUSTOM:
            if set[2]==t:
                fx=set[3]
                fn=set[4]
        exec('res=%s(char)'%(fn))
        if res:
            if fx!='':
                Object_PlayEffect(char,fx)
            name=getFormName()
            hasPortrait=FFX_HasPortrait(char)
            morph(name,char,event.string,1,hasPortrait)
        else:
            RegTimer('OnAccidentalRevert',1,0,char,event.string)

####################### ENERGY TANKS ######################################

def initenergytanks(char,update):
    base=Object_GetAttr(char,'maxEnergyPoints')
    Object_SetAttr(char,'maxEnergyPoints',2*base)
    RegTimer('updateenergytanks',1,0,char)
    FFX_ObjectSetAttr(char,'maxEP',base)

def updateenergytanks(event):
    char=event.object
    RegTimer('updateenergytanks',1,0,char)
    if not Object_Exists(char):
        return
    energy=Object_GetAttr(char,'energyPoints')
    maxEP=FFX_ObjectGetAttr(char,'maxEP')
    if energy>maxEP:
        if getByTemplate(char,FFX_ENERGYTANKS_CUSTOM,1)=='ambient':
            Object_SetAttr(char,'energy',1)
        else:
            Object_SetAttr(char,'energy',0)
        if energy>(maxEP+10):
            FFX_ObjectSetAttr(char,'maxEP',energy-10)
            maxEP=energy-10
    else:
        Object_SetAttr(char,'energy',FFX_ObjectGetAttr(char,'baseEnergy'))
    if maxEP>100:
       maxEP=maxEP-1
       FFX_ObjectSetAttr(char,'maxEP',maxEP)

###################### POLTERGEIST ########################################

def initpoltergeist(char,update=0,remove=0):
    if isMP():
        return
    if remove:
        FFX_ObjectSetAttr(char, 'poltergeist', 0)
    else:
        FFX_ObjectSetAttr(char, 'poltergeist', 1)
        RegCharState(char,PCSTATE_ENRAGED,'poltergeistOn')
        RegCharState(char,PCSTATE_PANICKED,'poltergeistOn')

def poltergeistOn(event):
    char=event.object
    if FFX_ObjectGetAttr(char, 'poltergeist', 0)!=0:
        RegTimer('OnPoltergeistCB',0.1,0,char)
        RegCharState(char,PCSTATE_NORMAL,'poltergeistOff')
        RegDeath(char,'poltergeistOff')
        RegCharState(char,Object_GetPrimaryState(char),'poltergeistOn')
        pos=Get_ObjectPos(char)
        name='%s_p1'%(char)
        if Object_Exists(name)==0:
            cshelper.spawn(name,'ffx_poltergeist',(pos[0]-40,pos[1],pos[2]))
            initpol(name,char)
        name='%s_p2'%(char)
        if Object_Exists(name)==0:
            cshelper.spawn(name,'ffx_poltergeist',(pos[0]+20,pos[1]-31,pos[2]))
            initpol(name,char)
        name='%s_p3'%(char)
        if Object_Exists(name)==0:
            cshelper.spawn(name,'ffx_poltergeist',(pos[0]+20,pos[1]+31,pos[2]))
            initpol(name,char)

def initpol(name,char):
    obs=Mission_GetDynamicObjects()
    tgs=[]
    for ob in obs:
        if (ob!=char) & ((Object_GetClass(ob)&FFX_CHARACTER)!=0) & (Object_GetTemplate(ob)!='ffx_tiggot') & (Object_GetTemplate(ob)!='ffx_poltergeist'):
            tgs.append(ob)
    index=0
    count=len(tgs)
    if count>2:
        index=FFX_Rand(1,count-1)
    while len(tgs)<11:
        tgs.append(tgs[index])
        index=index+1
        if index==count:
            index=0
    list=(tgs[0],tgs[1],tgs[2],tgs[3],tgs[4],tgs[5],tgs[6],tgs[7],tgs[8],tgs[9],tgs[10])
    cshelper.makePeaceful(name)
    cshelper.addKillGoal(name,list,PRI_HI)

def poltergeistOff(event):
    char=event.object
    name='%s_p1'%(char)
    if Object_Exists(name):
        Object_Destroy(name)
    name='%s_p2'%(char)
    if Object_Exists(name):
        Object_Destroy(name)
    name='%s_p3'%(char)
    if Object_Exists(name):
        Object_Destroy(name)

###################### WEATHER CONTROL ########################################
#
# works by initially player can summon a storm - causes the world to go darker
# also adds a couple of commands to the menu - hail and thunder
# using either of these causes them both to dissappear until the storm is blown out
# and the proces is repeated.
#
###############################################################################

# templates of FFX objects which can be extinguished        
flameObjects = ("ffx_flames", "ffx_firecage",)
# templates of characters whose material is not fire but whose powers (or at least those which consume energy) won't work when soaked
fireTemplates = ("mech_man_flame", "mech_man_flame_extra", "pyro", "pyroness", "red_sun", "red_sun_extra","fantastic four human torch",)
# templates of characters whose material is not ice but whose powers benefit from it
waterTemplates = ("anemone", "aqualad", "aquaman", "atlantean", "attuma", "hydroman", "krang", "orka", "man_o_war_extra", "man_o_war_n", "man_o_war", "namor", "namorita", "sea_urchin", "sea_urchin_extra", "sea_urchin_n", "avengers Sub-mariner",)

def initweathercontrol(char,update=0):
    if isMP():
        return
    Mission_CustomAction('CUSTOM_STORM',char,char,'OnStorm',0,0)
    FFX_ObjectSetAttr(char,'windflight',1)
    FFX_ObjectSetAttr(char,'tkType',-1)
    FFX_ObjectSetAttr(char,'maxMass',1000)
    Mission_CustomAction('CUSTOM_GROUP_FLIGHT',char,char,'OnTkGroupFlight',0,0)
    if hasAttribute(char,'firecontrol')==0:
        Mission_CustomAction('CUSTOM_EXTINGUISH',char,'ffx_flames','OnExtinguish',30,0)
        Mission_CustomAction('CUSTOM_EXTINGUISH',char,'ffx_firecage','OnExtinguish',30,0)

def OnStorm(dummy,char):
    if chargeEP(char,50)==0:
        return
    RegTimer('OnStormCB',0.1,0,char)
    Object_PlayEffect(char,getByTemplate(char,FFX_WEATHERCONTROL_CUSTOM,2),'')
    FFX_Animate(char,getByTemplate(char,FFX_WEATHERCONTROL_CUSTOM,1))
    Mission_SetAttr('ambient',0.2)
    Mission_SetAttr('direct',0.5)
    Mission_RemoveCustomAction('CUSTOM_STORM',char,char)
    FFX_ObjectSetAttr(char,'storm',1)
    Mission_CustomAction('CUSTOM_LIGHTNING',char,char,'OnLightningStorm',0,0)
    Mission_CustomAction('CUSTOM_HAIL',char,char,'OnHailStorm',0,0)
    Mission_CustomAction('CUSTOM_RAIN',char,char,'OnRainStorm',0,0)

def OnRainStorm(target,char):
    if chargeEP(char,50)==0:
        return
    FFX_ObjectSetAttr(char,'storm',2)
    FFX_ObjectSetAttr(char,'rainFX2',0)
    Mission_RemoveCustomAction('CUSTOM_HAIL',char,char)
    Mission_RemoveCustomAction('CUSTOM_LIGHTNING',char,char)
    Mission_RemoveCustomAction('CUSTOM_RAIN',char,char)
    handle=Object_PlayEffect(char,'effect_ffx_rain','',FX_LOOP|FX_TRACK_OBJECT_FULL,0,'')
    FFX_ObjectSetAttr(char,'rainHandle',handle)
    handle2=Object_PlayEffect(char,'effect_ffx_rain','',FX_LOOP|FX_TRACK_OBJECT_FULL,0,'')
    FFX_ObjectSetAttr(char,'rainHandle2',handle2)
    handle3=Object_PlayEffect(char,'effect_ffx_rain','',FX_LOOP|FX_TRACK_OBJECT_FULL,0,'')
    FFX_ObjectSetAttr(char,'rainHandle3',handle3)
    handle4=Object_PlayEffect(char,'effect_ffx_rain','',FX_LOOP|FX_TRACK_OBJECT_FULL,0,'')
    FFX_ObjectSetAttr(char,'rainHandle4',handle4)
    handle5=Object_PlayEffect(char,'effect_ffx_rain','',FX_LOOP|FX_TRACK_OBJECT_FULL,0,'')
    FFX_ObjectSetAttr(char,'rainHandle5',handle5)
    handle6=Object_PlayEffect(char,'effect_ffx_rain','',FX_LOOP|FX_TRACK_OBJECT_FULL,0,'')
    FFX_ObjectSetAttr(char,'rainHandle6',handle6)
    handle7=Object_PlayEffect(char,'effect_ffx_rain','',FX_LOOP|FX_TRACK_OBJECT_FULL,0,'')
    FFX_ObjectSetAttr(char,'rainHandle7',handle7)
    handle8=Object_PlayEffect(char,'effect_ffx_rain','',FX_LOOP|FX_TRACK_OBJECT_FULL,0,'')
    FFX_ObjectSetAttr(char,'rainHandle8',handle8)
    handle9=Object_PlayEffect(char,'effect_ffx_rain','',FX_LOOP|FX_TRACK_OBJECT_FULL,0,'')
    FFX_ObjectSetAttr(char,'rainHandle9',handle9)
    handle10=Object_PlayEffect(char,'effect_ffx_rain','',FX_LOOP|FX_TRACK_OBJECT_FULL,0,'')
    FFX_ObjectSetAttr(char,'rainHandle10',handle10)
    FFX_Animate(char,getByTemplate(char,FFX_WEATHERCONTROL_CUSTOM,1))
    Mission_SetAttr('ambient',0.2)
    Mission_SetAttr('direct',0.5)
    RegTimer('RainStorm',1,10,char)

def RainStorm(event):
    centre=event.object
    if cshelper.isPlaying():
        Mission_CustomAction('CUSTOM_STORM',centre,centre,'OnStorm',5,0)
        FFX_ObjectSetAttr(centre,'storm',0)
        return
    if Object_Exists(centre)==0:
        cancelRain(centre)
        return
    if (event.user>0) & (cshelper.isPlaying()==0):
        RegTimer('RainStorm',2,event.user-1,centre)
    else:
        cancelRain(centre)
        return
    Mission_SetSunlight(60,0,1,0.2,(1,1,1))
    objects=Mission_GetObjects()
    for obj in objects:
        if obj!=centre:
            pos1=Get_ObjectPos(centre)
            pos2=Get_ObjectPos(obj)
            dist = cshelper.distance2D(pos1,pos2)
            radius=250
            if dist < radius:
                if (js.Object_GetClass(obj) & js.OC_VEHICLE) or (js.Object_GetClass(obj) & ffx.OC_GENERIC):
                    for entry in flameObjects:
                        template = Object_GetTemplate(obj)
                        if template == entry:
                            js.Object_Destroy(obj)
                elif js.Object_GetClass(obj) & ffx.FFX_CHARACTER:
                    fire = 0
                    if js.Object_GetAttr(obj, 'material') == 4:
                        fire = 1
                    elif GetSubtypeMaterial(obj) == 4:
                        fire = 1
                    else:
                        for entry in fireTemplates:
                            entry = generalutils.cleanUpString(entry)
                            template = FFX_GetTemplate(obj)
                            template = generalutils.cleanUpString(template)
                            if template == entry:
                                fire = 1
                    if fire:
                        if not Object_GetSecondaryStates(obj)&SCSTATE_POWER_NULLIFICATION:
                            js.Object_SetSecondaryState(obj, js.SCSTATE_POWER_NULLIFICATION, 12, 0)
                    water = 0
                    if GetSubtypeMaterial(obj) == 17:
                        water = 1
                    else:
                        for entry in waterTemplates:
                            entry = generalutils.cleanUpString(entry)
                            template = FFX_GetTemplate(obj)
                            template = generalutils.cleanUpString(template)
                            if template == entry:
                                water = 1
                                break
                    if water:
                        if not Object_GetSecondaryStates(obj)&SCSTATE_ENERGIZED:
                            js.Object_SetSecondaryState(obj, js.SCSTATE_ENERGIZED, 12, 0)
                        js.Object_SetPrimaryState(obj, js.PCSTATE_STUNNED, 0, js.REMOVE_STATE)
                    if FFX_ObjectGetAttr(obj,'rainSlowed',0)==0:
                        newSpd=Object_GetAttr(obj,'baseSpeed')-2
                        newAgl=Object_GetAttr(obj,'templateAgility')-2
                        Object_SetAttr(obj,'speed',newSpd)
                        Object_SetAttr(obj,'agility',newAgl)
                        FFX_ObjectSetAttr(obj,'rainSlowed',1)
                    if FFX_Rand(1,10)<=3:
                        if not Object_GetSecondaryStates(obj)&SCSTATE_BLIND:
                            if obj!='ai_travel_object':
                                FFX_ObjectSetAttr(obj,'rainBlind',1)
                                Object_SetSecondaryState(obj,SCSTATE_BLIND,3,0)
            else:
                if (FFX_ObjectGetAttr(obj,'rainSlowed',0)==1) or (FFX_ObjectGetAttr(obj,'rainBlind',0)==1):
                    cancelRainEffects(obj)

def cancelRain(char):
    Mission_CustomAction('CUSTOM_STORM',char,char,'OnStorm',5,0)
    FFX_ObjectSetAttr(char,'storm',0)
    objects=Mission_GetDynamicObjects()
    for obj in objects:
        if (FFX_ObjectGetAttr(obj,'rainSlowed',0)==1) or (FFX_ObjectGetAttr(obj,'rainBlind',0)==1):
            cancelRainEffects(obj)
    cancelRainFX(char)

def cancelRainFX(char):
    handle = FFX_ObjectGetAttr(char, 'rainHandle')
    Object_StopEffect(char, handle)
    RegTimer('cancelRainFX2',0.1,0,char)

def cancelRainFX2(event):
    char=event.object
    handle2 = FFX_ObjectGetAttr(char, 'rainHandle2')
    Object_StopEffect(char, handle2)
    RegTimer('cancelRainFX3',0.1,0,char)

def cancelRainFX3(event):
    char=event.object
    handle3 = FFX_ObjectGetAttr(char, 'rainHandle3')
    Object_StopEffect(char, handle3)
    RegTimer('cancelRainFX4',0.1,0,char)

def cancelRainFX4(event):
    char=event.object
    handle4 = FFX_ObjectGetAttr(char, 'rainHandle4')
    Object_StopEffect(char, handle4)
    RegTimer('cancelRainFX5',0.1,0,char)

def cancelRainFX5(event):
    char=event.object
    handle5 = FFX_ObjectGetAttr(char, 'rainHandle5')
    Object_StopEffect(char, handle5)
    RegTimer('cancelRainFX6',0.1,0,char)

def cancelRainFX6(event):
    char=event.object
    handle6 = FFX_ObjectGetAttr(char, 'rainHandle6')
    Object_StopEffect(char, handle6)
    RegTimer('cancelRainFX7',0.1,0,char)

def cancelRainFX7(event):
    char=event.object
    handle7 = FFX_ObjectGetAttr(char, 'rainHandle7')
    Object_StopEffect(char, handle7)
    RegTimer('cancelRainFX8',0.1,0,char)

def cancelRainFX8(event):
    char=event.object
    handle8 = FFX_ObjectGetAttr(char, 'rainHandle8')
    Object_StopEffect(char, handle8)
    RegTimer('cancelRainFX9',0.1,0,char)

def cancelRainFX9(event):
    char=event.object
    handle9 = FFX_ObjectGetAttr(char, 'rainHandle9')
    Object_StopEffect(char, handle9)
    RegTimer('cancelRainFX10',0.1,0,char)

def cancelRainFX10(event):
    char=event.object
    handle10 = FFX_ObjectGetAttr(char, 'rainHandle10')
    Object_StopEffect(char, handle10)

def cancelRainEffects(obj):
    if FFX_ObjectGetAttr(obj,'rainSlowed',0)==1:
        baseSpd=Object_GetAttr(obj,'baseSpeed')
        baseAgl=Object_GetAttr(obj,'templateAgility')
        Object_SetAttr(obj,'speed',baseSpd)
        Object_SetAttr(obj,'agility',baseAgl)
        FFX_ObjectSetAttr(obj,'rainSlowed',0)
    if FFX_ObjectGetAttr(obj,'rainBlind',0)==1:
        Object_SetPrimaryState(obj,SCSTATE_BLIND,0,REMOVE_STATE)
        FFX_ObjectSetAttr(obj,'rainBlind',0)

def OnLightningStorm(target,char):
    if chargeEP(char,50)==0:
        return
    FFX_ObjectSetAttr(char,'storm',2)
    Mission_RemoveCustomAction('CUSTOM_HAIL',char,char)
    Mission_RemoveCustomAction('CUSTOM_LIGHTNING',char,char)
    Mission_RemoveCustomAction('CUSTOM_RAIN',char,char)
    Object_PlayEffect(char,getByTemplate(char,FFX_WEATHERCONTROL_CUSTOM,2),'')
    FFX_Animate(char,getByTemplate(char,FFX_WEATHERCONTROL_CUSTOM,1))
    Mission_SetAttr('ambient',0.2)
    Mission_SetAttr('direct',0.5)
    RegTimer('LightningStrike',3,10,char)

def LightningStrike(event):
    centre=event.object
    if cshelper.isPlaying():
        Mission_CustomAction('CUSTOM_STORM',centre,centre,'OnStorm',5,0)
        FFX_ObjectSetAttr(centre,'storm',0)
        return
    Mission_SetSunlight(60,0,1,0.2,(1,1,1))
    name=getDummyName()
    pos=GetWeatherPosition(centre)
    cshelper.spawn(name,'portal_start_proxy',pos)
    RegTimer('LightningStrike2',0.1,0,name)
    if (event.user>0) & (cshelper.isPlaying()==0):
        RegTimer('LightningStrike',2,event.user-1,centre)
    else:
        Mission_CustomAction('CUSTOM_STORM',centre,centre,'OnStorm',5,0)
        FFX_ObjectSetAttr(centre,'storm',0)

def LightningStrike2(event):
    name=event.object
    Trigger_Explosion(name,'ffx_lightning')
    Object_PlayEffect(name,'effect_ffx_thunder','')
    RegTimer('destroyTemp',6,0,name)

def OnHailStorm(target,char):
    if chargeEP(char,50)==0:
        return
    FFX_ObjectSetAttr(char,'storm',2)
    Mission_RemoveCustomAction('CUSTOM_HAIL',char,char)
    Mission_RemoveCustomAction('CUSTOM_LIGHTNING',char,char)
    Mission_RemoveCustomAction('CUSTOM_RAIN',char,char)
    Object_PlayEffect(char,getByTemplate(char,FFX_WEATHERCONTROL_CUSTOM,2))
    FFX_Animate(char,getByTemplate(char,FFX_WEATHERCONTROL_CUSTOM,1))
    Mission_SetAttr('ambient',0.2)
    Mission_SetAttr('direct',0.5)
    RegTimer('HailStorm',3,10,char)

def HailStorm(event):
    centre=event.object
    if cshelper.isPlaying():
        Mission_CustomAction('CUSTOM_STORM',centre,centre,'OnStorm',0,0)
        FFX_ObjectSetAttr(centre,'storm',0)
        return
    Mission_SetSunlight(60,0,1,0.2,(1,1,1))
    name=getDummyName()
    pos=GetWeatherPosition(centre)
    cshelper.spawn(name,'ffx_hailstone',(pos[0],pos[1],400))
    Object_PlayEffect(name,'effect_ffx_icesparks','',FX_LOOP|FX_TRACK_OBJECT_POS)
    RegTimer('HailStorm2',1,0,name)
    if (event.user>0) & (cshelper.isPlaying()==0):
        RegTimer('HailStorm',2,event.user-1,centre)
    else:
        Mission_CustomAction('CUSTOM_STORM',centre,centre,'OnStorm',5,0)
        FFX_ObjectSetAttr(centre,'storm',0)

def HailStorm2(event):
    fallOver(event.object)


# 06/26/2008 - TMX - Updated to better target enemies of the weather controller
# ecspecially for AI vs. AI combat, and included less accuracy the lower the
# energy points of the character.
def GetWeatherPosition(char):
    targets=[]
    myTeam=m25ai.GetTeam(char)
    for obj in Mission_GetDynamicObjects():
        team=m25ai.GetTeam(obj)
        hasPortrait=FFX_HasPortrait(obj)
        pcAIEnabled=m25ai.AIInWatch(obj)
        if ((Object_GetClass(char)&FFX_CHARACTER)!=0) & (myTeam==team) & (obj!=char):
            if Mission_GetAttr('ffxSkirmish')==0:
                if not hasPortrait or pcAIEnabled:
                    if Object_IsAlive(obj):
                        if distanceSq(obj,char)<250*250:
                            if distanceSq(obj,char)>80*80:
                                targets.append(obj)
        else:
            if ((Object_GetClass(char)&FFX_CHARACTER)!=0) & (obj!=char):
                if Object_IsAlive(obj):
                    if distanceSq(obj,char)<250*250:
                        if distanceSq(obj,char)>80*80:
                            targets.append(obj)
    ep=Object_GetAttr(char,'energyPoints')
    if (FFX_Rand(1,100) < ep) & (len(targets) > 0):
        target=targets[0]
        if len(targets)>1:
            target=targets[randint(1,len(targets)-1)]
        #Mission_StatusText('targetting %s'%(target))
        offsetX=float(randint(-70,70))
        offsetY=float(randint(-70,70))
        pos=Get_ObjectPos(target)
        return(pos[0]+offsetX,pos[1]+offsetY,pos[2])
    else:
        #Mission_StatusText('random pos')
        pos=Get_ObjectPos(char)
        offsetX=float(randint(-150,150))
        offsetY=float(randint(-150,150))
        rad=sqrt(offsetX*offsetX+offsetY*offsetY)
        if rad<100.0:
            factor=100.0/(1.0+rad)
            offsetX=offsetX*factor
            offsetY=offsetY*factor
        return (pos[0]+offsetX,pos[1]+offsetY,pos[2])

###################### ENVIRONMENT CONTROL ########################################

def initenvcontrollocal(char,update=0):
    if isMP():
        return
    addNexusCommands(char,ffxcustom.FFX_ENVCONTROLA_CUSTOM,'ENVCONTROLA')
    RegTimer('updateenv',0.1,0,char)

def initenvcontrolglobal(char,update=0):
    if isMP():
        return
    cmd=getByTemplate(char,FFX_ENVCONTROLB_CUSTOM,2)
    Mission_CustomAction(cmd,char,char,'OnEnvSelf',5,0)

def updateenv(event):
    char=event.object
    update=event.user
    RegTimer('updateenv',5,1,char)
    cmd=getByTemplate(char,FFX_ENVCONTROLA_CUSTOM,2)
    if cmd!='':
        addCommand(cmd,char,'OnEnvTarget',30,update)

def OnEnvTarget(target,char):
    if chargeEP(char,FFX_ObjectGetAttr(char,'envep'))==0:
        return
    Trigger_Power(char,target,getByTemplate(char,FFX_ENVCONTROLA_CUSTOM,1),'')
    RegTimer('OnEnvTarget2',1,3,target,char)

def OnEnvTarget2(event):
    if cshelper.isPlaying():
        return
    name=event.object
    char=event.string
    timer=2
    if event.user==3:
        target=event.object
        name=getDummyName()
        cshelper.spawn(name,getByTemplate(char,FFX_ENVCONTROLA_CUSTOM,3),target)
        alignWith(name,target)
        timer=1
    else:
        Trigger_Explosion(name,getByTemplate(char,FFX_ENVCONTROLA_CUSTOM,4))
    if event.user>0:
        RegTimer('OnEnvTarget2',timer,event.user-1,name,char)
    else:
        RegTimer('destroyTemp',3,0,name)

def OnEnvSelf(dummy,char):
    if chargeEP(char,FFX_ObjectGetAttr(char,'envep'))==0:
        return
    cmd=getByTemplate(char,FFX_ENVCONTROLB_CUSTOM,2)
    if cmd!='':
        Mission_RemoveCustomAction(cmd,char,char)
        FFX_ObjectSetAttr(char,'envstorm',1)
    Trigger_Power(char,char,getByTemplate(char,FFX_ENVCONTROLB_CUSTOM,1),'')
    RegTimer('EnvStrike',1.5,6,char)

def EnvStrike(event):
    if cshelper.isPlaying():
        return
    centre=event.object
    name=getDummyName()
    pos=GetWeatherPosition(centre)
    cshelper.spawn(name,'ffx_fallobject',(pos[0],pos[1],400))
    Object_SetAttr(name,'minHealth',1)
    Object_SetAttr(name,'health',2)
    Object_PlayEffect(name,getByTemplate(centre,FFX_ENVCONTROLB_CUSTOM,3),'',FX_LOOP|FX_TRACK_OBJECT_POS)
    RegTimer('EnvStrike2',1,0,name)
    RegDamage(name,'envExplode',getRowByTemplate(centre,FFX_ENVCONTROLB_CUSTOM))
    if (event.user>0) & (cshelper.isPlaying()==0):
        RegTimer('EnvStrike',2,event.user-1,centre)
    else:
        cmd=getByTemplate(centre,FFX_ENVCONTROLB_CUSTOM,2)
        if cmd!='':
            Mission_CustomAction(cmd,centre,centre,'OnEnvSelf',5,0)
        FFX_ObjectSetAttr(centre,'envstorm',0)

def EnvStrike2(event):
    fallOver(event.object)

def envExplode(event):
    obj=event.object
    row=int(event.user)
    power=FFX_ENVCONTROLB_CUSTOM[row][4]
    Trigger_Explosion(obj,power)
    RegTimer('destroyTemp',1,0,obj)

###################### BORROWED TIME ########################################

def initborrowedtime(char,update=0):
    RegTimer('updateborrow',1,0,char)

def updateborrow(event):
    char=event.object
    # ###!Ep 2006-02-25 Exiled characters shouldn't get damaged by Borrowed Time
    # (other damages while exiled may make sense, however, hence the patch here instead of in FFX_ApplyDamage())
    # Note that Possessor can't be added here, as SCSTATE_SPAWN doesn't register with Object_GetSecondaryStates()    
    if not isExiled(char):
        FFX_ApplyDamage(char,1,1)
    RegTimer('updateborrow',1.5,0,char)

###################### PLASMA SCULPTOR ########################################

def initplasmasculptor(char,update=0):
    if isMP():
        return
    RegTimer('updateplasma',0.1,0,char)

def updateplasma(event):
    char=event.object
    update=event.user
    RegTimer('updateplasma',5,1,char)
    if getByTemplate(char,FFX_PLASMA_CUSTOM,2)!='':
        addCommandChars(getByTemplate(char,FFX_PLASMA_CUSTOM,8),char,'OnGiveThrow',30,update)
    if getByTemplate(char,FFX_PLASMA_CUSTOM,3)!='':
        addCommandChars(getByTemplate(char,FFX_PLASMA_CUSTOM,9),char,'OnGiveWield',30,update)
    if getByTemplate(char,FFX_PLASMA_CUSTOM,4)!='':
        addCommandChars(getByTemplate(char,FFX_PLASMA_CUSTOM,10),char,'OnMakeDrop',30,update,char)
    if getByTemplate(char,FFX_PLASMA_CUSTOM,5)!='':
        addCommandChars(getByTemplate(char,FFX_PLASMA_CUSTOM,11),char,'OnMakeBarrier',30,update,char)

def OnGiveThrow(target,char):
    OnMakeObject(target,char,2,30)

def OnGiveWield(target,char):
    OnMakeObject(target,char,3,30)

def OnMakeBarrier(target,char):
    OnMakeObject(target,char,5)

def OnMakeObject(target,char,index,dist=60):
    name=getDummyName()
    pos=GetSpawnPos(target,char,dist)
    FFX_SetPos('plasma%s'%(char),pos)
    cshelper.spawn(name,'ffx_target',pos)
    Trigger_Power(char,name,getByTemplate(char,FFX_PLASMA_CUSTOM,1),'')
    RegTimer('destroyTemp',6,0,name)
    RegTimer('OnMakeObjectA',1.3,index,char,target)

def OnMakeObjectA(event):
    char=event.object
    target=event.string
    index=int(event.user)
    name=getDummyName()
    cshelper.spawn(name,getByTemplate(char,FFX_PLASMA_CUSTOM,index),FFX_GetPos('plasma%s'%(char)))
    alignWith(name,char)
    FFX_ObjectSetAttr(name,'master',Object_GetAttr(char,'ffxID'))
    FFX_ObjectSetAttr(name,'minionType',1)
    fn=getByTemplate(char,FFX_PLASMA_CUSTOM,7)
    res=0
    FFX_ObjectSetAttr(name,'cost',1)
    exec('res=%s(name,char,2)'%(fn))
    if res==0:
        kill(obj)

def OnMakeDrop(target,char):
    name=getDummyName()
    pos=Get_ObjectPos(target)
    cshelper.spawn(name,getByTemplate(char,FFX_PLASMA_CUSTOM,4),(pos[0],pos[1],250))
    Object_SetAttr(name,'mass',100)
    Trigger_Power(char,name,getByTemplate(char,FFX_PLASMA_CUSTOM,1),'')
    RegTimer('OnMakeDrop2',2,0,name)

def OnMakeDrop2(event):
    fallOver(event.object)
    RegTimer('destroyTemp',10,0,event.object)

def GetSpawnPos(target,char,dist=30):
    pos=Get_ObjectPos(char)
    tpos=Get_ObjectPos(target)
    dpos=Vector_Sub(pos,tpos)
    len=sqrt(dpos[0]*dpos[0]+dpos[1]*dpos[1])
    if len<1:
        return(tpos[0]+dist,tpos[1],tpos[2])
    scale=dist/(1+len)
    return(tpos[0]+scale*dpos[0],tpos[1]+scale*dpos[1],tpos[2])

###################### OBJECT CREATION SCHEMES #########################
# gelatinous, plasmatic and demonic
# cost is 1,2 or 3
########################################################################

# formed from the user's body mass
def gelatinous(obj,char,cost):
    #transfer some of the character's hp to the object
    hp=Object_GetAttr(obj,'health')
    ratio=Object_GetAttr(char,'health')/Object_GetAttr(char,'maxHealth')
    hp=hp*ratio
    Object_SetAttr(obj,'health',hp)
    maxHP=Object_GetAttr(char,'maxHealth')-hp
    if maxHP<10:
        return 0
    FFX_ApplyDamage(char,hp,1)
    Object_SetAttr(char,'maxHealth',maxHP)
    Mission_CustomAction('CUSTOM_REABSORB',char,obj,'OnReabsorb',5,0)
    return 1

def OnReabsorb(obj,char):
    hp=Object_GetAttr(obj,'health')
    Object_SetAttr(char,'health',Object_GetAttr(char,'health')+hp)
    Object_SetAttr(char,'maxHealth',Object_GetAttr(char,'maxHealth')+hp)
    creationDestroy(obj)

# formed by sustained willpower
def plasmatic(obj,char,cost):
    if Object_GetAttr(char,'energyPoints')<10:
        return 0
    print 'plasmatic: obj=%s char=%s cost=%d'%(obj,char,cost)
    RegTimer('plasmaticCheck',1,0,obj,char)
    Mission_CustomAction('CUSTOM_DEACTIVATEPLASM',char,obj,'OnPlasmaDeactivate',30,0)
    return 1

def OnPlasmaDeactivate(target,char):
    creationDestroy(target)

def plasmaticCheck(event):
    obj=event.object
    char=event.string
    if Object_Exists(char)==0 or Object_Exists(obj)==0:
        if Object_Exists(obj):
            creationDestroy(obj)
        return
    cost=FFX_ObjectGetAttr(obj,'cost') / max( 0.1, (FFX_ObjectGetAttr(char,'summonLevel') ) / 80000.0)  # stumpy #Ep.2006-08-28: prevented rare zero-division error
    ep=Object_GetAttr(char,'energyPoints')-cost
    if ep<0 or not normal(char) or distanceSq(obj,char)>100000:
        creationDestroy(obj)
    else:
        RegTimer('plasmaticCheck',1,0,obj,char)
    Object_SetAttr(char,'energyPoints',ep)

#summoned and then free of their own accord
def independent(obj,char,cost):
    print 'independent: obj=%s char=%s cost=%d'%(obj,char,cost)
    if chargeEP(char,cost*10)==0:
        return 0
    if Object_GetClass(obj)&FFX_CHARACTER:
        RegTimer('independentCheck',1,0,obj,char)
    return 1

def independentCheck(event):
    obj=event.object
    char=event.string
    if Object_Exists(obj)==0:
        return
    if Object_Exists(char)==0:
        enrage(obj)
    elif not normal(char):
        if Object_GetPrimaryState(char)==PCSTATE_HYPNOTISED:
            hypnotize(obj)
            newTeam=m25ai.GetTeam(char)
            m25ai.SetTeam(obj,newTeam)
        else:
            enrage(obj)
    else:
        newTeam=m25ai.GetTeam(char)
        m25ai.SetTeam(obj,newTeam)
    cost=FFX_ObjectGetAttr(obj,'cost')
    lifespan=FFX_ObjectGetAttr(obj,'lifespan')-cost
    print 'lifespan=%d'%(lifespan)
    if lifespan<1:
        creationDestroy(obj)
    else:
        FFX_ObjectSetAttr(obj,'lifespan',lifespan)
        RegTimer('independentCheck',1,0,obj,char)

def creationDestroy(obj):
    print 'creationDestroy'
    char=findCharByID(FFX_ObjectGetAttr(obj,'master'))
    typ=FFX_ObjectGetAttr(obj,'minionType')
    print char
    print typ
    if typ==0: #die
        cshelper.kill(obj)
    elif typ==1: #de-create plasma
        cshelper.kill(obj)
        if char!='':
            fx=getByTemplate(char,FFX_PLASMA_CUSTOM,6)
            if fx!='':
                Object_PlayEffect(obj,fx)
    elif typ==2: #de-animate
        UnAnimate(obj)
    elif typ==3: #de-summon
        UnSummon(obj,char)
    elif typ==4:
        Object_SetPrimaryState(obj,PCSTATE_EXILE,100,0)
        RegTimer('destroyTemp',3,0,obj)

###################### SUMMONER ########################################

def initsummoner1(char,update=0):
    initsummoner(char,update,80000,1)

def initsummoner2(char,update=0):
    initsummoner(char,update,150000,1)

def initsummoner3(char,update=0):
    initsummoner(char,update,250000,1)

# *** stumpy: one more level of summoner for dedicated munchkins
def initsummoner4(char,update=0):
    initsummoner(char,update,400000,1)

def initsummoner(char,update,prestige,deathresponse):
    if isMP():
        return
    FFX_ObjectSetAttr(char,'summonType',deathresponse)
    FFX_ObjectSetAttr(char,'summonses',0)
    FFX_ObjectSetAttr(char,'summonLevel',prestige)
    RegTimer('updatesummoner',0.1,0,char)
    RegDeath(char,'masterDie',deathresponse)
    RegCharState(char,0,'masterDie',0,deathresponse)
    if deathresponse==3:
        RegTimer('masterUpdate',1,deathresponse,char)

def updatesummoner(event):
    char=event.object
    update=event.user
    summonses=0
    RegTimer('updatesummoner',5,1,char)
    cmd=getByTemplate(char,FFX_SUMMONER_CUSTOM,4)
    if cmd!='':
        addCommandChars(cmd,char,'OnSummon1',30,update,char)
        summonses=summonses+1
    cmd=getByTemplate(char,FFX_SUMMONER_CUSTOM,6)
    if cmd!='':
        addCommandChars(cmd,char,'OnSummon2',30,update,char)
        summonses=summonses+2
    cmd=getByTemplate(char,FFX_SUMMONER_CUSTOM,8)
    if cmd!='':
        addCommandChars(cmd,char,'OnSummon3',30,update,char)
        summonses=summonses+4
    FFX_ObjectSetAttr(char,'summonses',summonses)

def OnSummon1(target,char):
    OnSummon(target,char,3)

def OnSummon2(target,char):
    OnSummon(target,char,5)

def OnSummon3(target,char):
    OnSummon(target,char,7)

FFX_SUMMON_ANIM=[
['default','',''],
['ant_soldier','burrow_end','worker ant Dig'],
['ant_soldier_cop','burrow_end','worker ant Dig'],
['ant_worker','burrow_end','worker ant Dig'],
['ant_worker_cop','burrow_end','worker ant Dig'],
]

def OnSummon(target,char,index):
    name=getDummyName()
    pos=GetSpawnPos(target,char,60)
    FFX_SetPos('summon%s'%(char),pos)
    cshelper.spawn(name,'ffx_target',pos)
    Trigger_Power(char,name,getByTemplate(char,FFX_SUMMONER_CUSTOM,1),'')
    RegTimer('OnSummonA',2,index,char,target)
    RegTimer('destroyTemp',6,0,name)
    RegTimer('OnSummonCB',0.1,0,char,name)

def OnSummonA(event):
    target=event.string
    char=event.object
    index=int(event.user)
    name=getDummyName()
    cshelper.spawn(name,getByTemplate(char,FFX_SUMMONER_CUSTOM,index),FFX_GetPos('summon%s'%(char)))
    alignWith(name,char)
    anim=getByTemplate(name,FFX_SUMMON_ANIM,1)
    if anim!='':
        AI_Animate(name,anim)
    if Object_GetClass(name)&OC_CONTROLLABLE:
        FFX_DestroyPortrait(name)
    FFX_ObjectSetAttr(name,'master',Object_GetAttr(char,'ffxID'))
    FFX_ObjectSetAttr(name,'minionType',3)
    pc=Object_CalcPrestige(name)
    cost=(pc/5000)
    FFX_ObjectSetAttr(name,'cost',cost)
    FFX_ObjectSetAttr(name,'lifespan',100)
    initMinionAI(name,m25ai.GetTeam(char),target,isEvil(char))
    if usingM25AI():
        m25ai.AddGoal_HuntEnemy(name)
    fn=getByTemplate(char,FFX_SUMMONER_CUSTOM,9)
    res=0
    exec('res=%s(name,char,cost)'%(fn))
    if res==0:
        UnSummon(name,char)

def UnSummon(obj,char):
    if Object_Exists(obj)==0: ###!
        return
    anim=getByTemplate(obj,FFX_SUMMON_ANIM,2)
    if anim!='':
        Trigger_Power(obj,obj,anim,'')
    else:
        Object_SetPrimaryState(obj,PCSTATE_EXILE,100,0)
        makecloak(obj,10)
        RegTimer('UnSummon2',0.7,0,obj,char)
    RegTimer('destroyTemp',7,0,obj)

def UnSummon2(event):
    obj=event.object
    char=event.string
    if char!='':
        Object_PlayEffect(obj,getByTemplate(char,FFX_SUMMONER_CUSTOM,2))

def isEvil(char):
    return (Object_GetClass(char)&(OC_VILLIAN|OC_MINION))!=0

def initMinionAI(name,team,target='',evil=1):
    #just do this if a controllable is spawned (inner being/summoner etc)
    if FFX_HasPortrait(name):
        setGender(name,1)
        m25ai.SetTeam(name,team)
        return
    cshelper.makePeaceful(name)
    if usingM25AI():
        m25ai.SetTeam(name,team)
        m25ai.SetBrawler(name)
        m25ai.SetupAI(name)
    else:
        if target!='':
            cshelper.addKillGoal(name,target,PRI_HI)
        if evil==0:
            cshelper.addKillAllGoal(name,OC_VILLIAN,PRI_LOW)
            cshelper.addKillAllGoal(name,OC_MINION,PRI_LOW)
        else:
            cshelper.addKillAllGoal(name,OC_CONTROLLABLE,PRI_LOW)
            cshelper.addKillAllGoal(name,OC_POLICE,PRI_LOW)
    m25ai.SetTeam(name, team)
    setGender(name,1)
    m25ai.SetBrawler(name)

###################### PRIVATE ARMY ########################################
# stumpy 2006-08-26: Added several commands to this to make army more 
# controllable and to make the halt command work with M25's AI
############################################################################
# tmx 2008-04-23: Updated by Yellow_Lantern to have six templates
############################################################################

def initprivatearmy1(char,update=0):
    initprivatearmy(char,update,10000)

def initprivatearmy2(char,update=0):
    initprivatearmy(char,update,20000)

def initprivatearmy3(char,update=0):
    initprivatearmy(char,update,30000)

def initprivatearmy(char,update,prestige):
    print 'initprivatearmy: %s'%(char)
    if isMP():
        return
    if update!=0:
        return
    if FFX_ObjectGetAttr(char,'morph',0)!=0:
        return
    if FFX_ObjectGetAttr(char,'clone',0)!=0:
        print 'initprivatearmy: clones get no armies'
        return
    if char[:4]=='mobj':
        print 'initprivatearmy: clones get no armies'
        return
    template=getByTemplate(char,FFX_PRIVATEARMY_CUSTOM,1)
    template2=getByTemplate(char,FFX_PRIVATEARMY_CUSTOM,2)
    template3=getByTemplate(char,FFX_PRIVATEARMY_CUSTOM,3)
    template4=getByTemplate(char,FFX_PRIVATEARMY_CUSTOM,4)
    template5=getByTemplate(char,FFX_PRIVATEARMY_CUSTOM,5)
    template6=getByTemplate(char,FFX_PRIVATEARMY_CUSTOM,6)
    clone=1
    if template=='':
        template=Object_GetTemplate(char)
    list=[template]
    if template2!='':
        list.append(template2)
    if template3!='':
        list.append(template3)
    if template4!='':
        list.append(template4)
    if template5!='':
        list.append(template5)
    if template6!='':
        list.append(template6) 
    total=0
    count=0
    ##print 'initprivatearmy: list = %s' % (list,)
    while total<prestige:
        name=getArmyName(char,count)
        if len(list)>1:
            index=randint(0,len(list))
            if index<0:
                index=0
            if index>=len(list):
                index=len(list)-1
            t=list[index]
        else:
            t=list[0]
        ##print 'initprivatearmy: t = %s' % (t,)
        FFX_ObjectSetAttr(name,'clone',1)
        FFX_ObjectSetAttr(name,'morph',1)
        ##print 'initprivatearmy: setting clone to 1 on %s'%(name)
        cshelper.spawn(name,t,getArmyPos(char,count))
        AI_Animate(name,t)
        alignWith(name,char)
        cost=Object_CalcPrestige(name)
        total=total+cost
        count=count+1
        RegTimer('initsoldier',0.25,0,name,char)
        m25ai.AddToGroup(char+'_army', name)  #m25 added June 29, 2005
        Mission_CustomAction('select soldier',char,name,'OnSelectArmy',300,0)    # stumpy added
        Object_SetAttr(name,'PAselect',0)
        if Object_GetClass(name)&OC_CONTROLLABLE:
            FFX_DestroyPortrait(name)
    factor=float(prestige)/float(total)
    FFX_ObjectSetAttr(char,'army',count)
    for i in range(0,count):
        name=getArmyName(char,i)
        if Object_Exists(name):
            hp=Object_GetAttr(name,'maxHealth')*factor
            Object_SetAttr(name,'maxHealth',hp)
            Object_SetAttr(name,'health',hp)
    Mission_CustomAction('CUSTOM_GATHER',char,char,'OnGatherArmy',5,0)
    Mission_CustomAction('halt army',char,char,'OnHaltArmy',5,0)    # stumpy added
    m25ai.AddToGroup(char+'_army', char)  #m25 added June 29, 2005
    m25ai.GroupCommand_Guard(char+'_army', char)
    RegTimer('updateArmy',1,0,char)

def initsoldier(event):
    name=event.object
    char=event.string
    ##print 'initprivatearmy: initialising army: team=%d evil=%d'%(m25ai.GetTeam(char),isEvil(char))
    initMinionAI(name,m25ai.GetTeam(char),'',isEvil(char))

def updateArmy(event):
    char=event.object
    update=event.user
    if filter(Object_IsAlive,getAllByPrefix('%smin'%char)):
        RegTimer('updateArmy',5,1,char)
        addCommandChars('CUSTOM_TARGET',char,'OnTargetArmy',300,update,char)
        addCommandChars('target selected',char,'OnTargetArmySelected',300,update,char)
    else:
        removeCommandChars('CUSTOM_TARGET',char)
        removeCommandChars('CUSTOM_GATHER',char)
        Mission_RemoveCustomAction('halt army', char, char)
        Mission_RemoveCustomAction('enable army', char, char)

def OnSelectArmy(name,char):    # stumpy added
    handle = Object_PlayEffect(name,'effect_ffx_vertigo','',FX_LOOP|FX_TRACK_OBJECT_POS,0,'Bip01 Head')
    Object_SetAttr(name,'PAselect',handle)
    

def OnTargetArmy(target,char):
    count=FFX_ObjectGetAttr(char,'army')
    if usingM25AI():
        RegDeath(target, 'OnPATargetDeath', user = 0, string = char)
    for i in range(0,count):
        name=getArmyName(char,i)
        if Object_Exists(name):
            cshelper.turnTo(name,target)
            if usingM25AI():
                AIEnable(name)
                AddGoal_Attack(name,target=target,target_priority=2*TARGET_PRIORITY_HIGH)
            else:
                cshelper.AI_SetEnabled(name,1)
                cshelper.addKillGoal(name,target,PRI_HI)

def OnTargetArmySelected(target,char):
    count=FFX_ObjectGetAttr(char,'army')
    names = filter(Object_Exists,map(lambda i, char=char: getArmyName(char,i),range(0,count)))
    if usingM25AI():
        RegDeath(target, 'OnPATargetDeath', user = 0, string = char)
    for name in names:
        if Object_GetAttr(name,'PAselect'):
            Object_StopEffect(name,Object_GetAttr(name,'PAselect'))
            Object_SetAttr(name,'PAselect',0)
            cshelper.turnTo(name,target)
            if usingM25AI():
                AIEnable(name)
                AddGoal_Attack(name,target=target,target_priority=2*TARGET_PRIORITY_HIGH)
            else:
                cshelper.AI_SetEnabled(name,1)
                cshelper.addKillGoal(name,target,PRI_HI)

# Clean up PA AI goals if target is KOed.  Only called for M25_USE_AI set.
def OnPATargetDeath(event):
    target = event.object
    # make sure the target is really KOed
    if ( Object_IsAlive(target) ) or ( Object_GetAttr(target,'heroPoints') > 0 ):
        RegDeath(target, 'OnPATargetDeath', user = 0, string = char)
        return
    char = event.string
    count = FFX_ObjectGetAttr(char,'army')
    names = filter(Object_IsAlive,map(lambda i, char=char: getArmyName(char,i),range(0,count)))
    for name in names:
        for goal in AIGetGoals(name):
            # if attack_goal and the goal's target is the target just KOed
            if ( goal[:11] == 'Goal_Attack' ) and ( string.split(goal,',')[1] == repr(target) ):
                AIRemoveGoal(name,goal)

def OnGatherArmy(dummy,char):
    count=FFX_ObjectGetAttr(char,'army')
    for i in range(0,count):
        name=getArmyName(char,i)
        if Object_Exists(name):
            if usingM25AI():
                # remove non-guard goals
                ##print 'OnGatherArmy(%s,%s) name=%s goals=%s: ' % (dummy,char,name,AIGetGoals(name))
                for goal in AIGetGoals(name):
                    if goal[:10] != 'Goal_Guard':
                        ##print 'OnGatherArmy: removing goal %s' % repr(goal)
                        AIRemoveGoal(name,goal)
            else:
                cshelper.AI_SetEnabled(name,1)
                cshelper.addMoveGoal(name,char,PRI_HI)
            cshelper.turnTo(name,char)

def OnHaltArmy(dummy,char):
    count=FFX_ObjectGetAttr(char,'army')
    for i in range(0,count):
        name=getArmyName(char,i)
        if Object_Exists(name):
            if usingM25AI():
                AIDisable(name)
            else:
                cshelper.AI_SetEnabled(name,0)
    Mission_RemoveCustomAction('halt army', char, char)
    Mission_CustomAction('enable army',char,char,'OnEnableArmy',5,0)

def OnEnableArmy(dummy,char):
    count=FFX_ObjectGetAttr(char,'army')
    for i in range(0,count):
        name=getArmyName(char,i)
        if Object_Exists(name):
            if usingM25AI():
                AIEnable(name)
            else:
                cshelper.AI_SetEnabled(name,1)
    Mission_RemoveCustomAction('enable army', char, char)
    Mission_CustomAction('halt army',char,char,'OnHaltArmy',5,0)

def getArmyName(char,index):
    return '%smin%d'%(char,index)

def getArmyPos(char,index):
    pos=Get_ObjectPos(char)
    if int(index)&1:
        return (pos[0]+index*20,pos[1],pos[2])
    else:
        return (pos[0]-(index+1)*20,pos[1],pos[2])

####################### GROUP TELEPORT ####################################

def initgroupteleport(char, update=0):
    if isMP():
        return
    Mission_CustomAction('CUSTOM_ALLIES',char,char,'OnAddAllies',5,0)
    Mission_CustomAction('CUSTOM_FOES',char,char,'OnAddFoes',5,0)
    FFX_ObjectSetAttr(char,'tpallies',0)
    FFX_ObjectSetAttr(char,'tpfoes',0)
    pos=Get_ObjectPos(char)
    FFX_ObjectSetAttr(char,'lastX',pos[0])
    FFX_ObjectSetAttr(char,'lastY',pos[1])
    RegTimer('tpTrack',1,0,char)
    FFX_ObjectSetAttr(char,'friendhandle',-1)
    FFX_ObjectSetAttr(char,'foehandle',-1)

def OnAddAllies(dummy,char):
    FFX_ObjectSetAttr(char,'tpallies',1)
    Mission_CustomAction('CUSTOM_NOALLIES',char,char,'OnRemoveAllies',5,0)
    Mission_RemoveCustomAction('CUSTOM_ALLIES',char,char)
    handle=Object_PlayEffect(char,'effect_ffx_teleport1','',FX_LOOP|FX_TRACK_OBJECT_POS)
    FFX_ObjectSetAttr(char,'friendhandle',handle)

def OnRemoveAllies(dummy,char):
    FFX_ObjectSetAttr(char,'tpallies',0)
    Mission_CustomAction('CUSTOM_ALLIES',char,char,'OnAddAllies',5,0)
    Mission_RemoveCustomAction('CUSTOM_NOALLIES',char,char)
    if FFX_ObjectGetAttr(char,'friendhandle')!=-1:
        Object_StopEffect(char,int(FFX_ObjectGetAttr(char,'friendhandle')))
        FFX_ObjectSetAttr(char,'friendhandle',-1)

def OnAddFoes(dummy,char):
    FFX_ObjectSetAttr(char,'tpfoes',1)
    Mission_CustomAction('CUSTOM_NOFOES',char,char,'OnRemoveFoes',5,0)
    Mission_RemoveCustomAction('CUSTOM_FOES',char,char)
    handle=Object_PlayEffect(char,'effect_ffx_teleport2','',FX_LOOP|FX_TRACK_OBJECT_POS)
    FFX_ObjectSetAttr(char,'foehandle',handle)

def OnRemoveFoes(dummy,char):
    FFX_ObjectSetAttr(char,'tpfoes',0)
    Mission_CustomAction('CUSTOM_FOES',char,char,'OnAddFoes',5,0)
    Mission_RemoveCustomAction('CUSTOM_NOFOES',char,char)
    if FFX_ObjectGetAttr(char,'foehandle')!=-1:
        Object_StopEffect(char,int(FFX_ObjectGetAttr(char,'foehandle')))
        FFX_ObjectSetAttr(char,'foehandle',-1)

spdd=(200,200,650,1450,2250,3550,5300,7050,9100,12000)
def SprintDist(char):
    index=int(Object_GetAttr(char,'speed'))
    if index>9:
        index=9
    dist=spdd[index]*2
    if dist>3600:
        dist=3600
    return dist

def tpTrack(event):
    char=event.object
    if Object_Exists(char)==0:
        return
    RegTimer('tpTrack',0.7,0,char)
    pos=Get_ObjectPos(char)
    dx=pos[0]-FFX_ObjectGetAttr(char,'lastX')
    dy=pos[1]-FFX_ObjectGetAttr(char,'lastY')
    #print 'GroupTP %d'%(dx*dx+dy*dy)
    flailing=MLOG_IsInKnockBack(char)
    flying=mlogreader.MLOG_IsFlying(char)
    if (dx*dx+dy*dy)>SprintDist(char) and not flailing and not flying:
        tpf=FFX_ObjectGetAttr(char,'tpfoes')
        tpa=FFX_ObjectGetAttr(char,'tpallies')
        team=m25ai.GetTeam(char)
        #print 'team=%d tpa=%d tpf=%d'%(team,tpa,tpf)
        for obj in Mission_GetDynamicObjects():
            #print '%s:%d'%(obj,m25ai.GetTeam(obj))
            if (team==m25ai.GetTeam(obj) and tpa!=0) or (team!=m25ai.GetTeam(obj) and tpf!=0):
                pos2=Get_ObjectPos(obj)
                dx2=pos2[0]-FFX_ObjectGetAttr(char,'lastX')
                dy2=pos2[1]-FFX_ObjectGetAttr(char,'lastY')
                if ((dx2*dx2+dy2*dy2)<10000) & (obj!=char):
                    newPos=(pos2[0]+dx,pos2[1]+dy,pos[2])
                    FFX_Teleport(obj,newPos)
                    Object_PlayEffect(obj,getByTemplate(char,FFX_GROUPTELEPORT_CUSTOM,1),'',FX_TRACK_OBJECT_POS)
                    chargeEP(char,5)
    FFX_ObjectSetAttr(char,'lastX',pos[0])
    FFX_ObjectSetAttr(char,'lastY',pos[1])

####################### SUPERLEAPER #######################################

# Ep. 2006-09-11 made removable.
def initsuperleaper(char,update=0,remove=0):
    if remove:
        FFX_ObjectSetAttr(char, 'superleaper', 0)
        removeCommand('CUSTOM_LEAPTO', char)
        return
    if isMP():
        return
    FFX_ObjectSetAttr(char, 'superleaper', 1)
    FFX_ObjectSetAttr(char,'leapdist',20+Object_GetAttr(char,'baseStrength')*4)
    RegTimer('updateleaper',1,0,char)

def updateleaper(event):
    char=event.object
    update=event.user
    if FFX_ObjectGetAttr(char, 'superleaper') == 1:
        RegTimer('updateleaper',5,1,char)
        radius=FFX_ObjectGetAttr(char,'leapdist',30)
        addCommand('CUSTOM_LEAPTO',char,'OnLeapTo',radius,update)

def OnLeapTo(target,char):
    pos=GetTargetPos(char,target)
    FFX_TP(char,(pos[0],pos[1],500),'FFX_TP2',0)

####################### ACCIDENTAL CLONING #######################################

def initaccidentclone(char,update=0):
    #dont initialise for regular clones produced by clone self power!
    if char[:5]!='mobj_':
        Object_SetAttr(char,'lastHealthAC',Object_GetAttr(char,'health'))
        RegDamage(char,'OnAccClone')

def OnAccClone(event):
    char=event.object
    RegDamage(char,'OnAccClone')
    if FFX_ObjectGetAttr(char,'clone'):
        return
    if Object_GetAttr(char,'health')<=1:
        return
    damage=Object_GetAttr(char,'lastHealthAC')-Object_GetAttr(char,'health')
    if damage>0:
        while FFX_Rand(1,10)<damage:
            name=getDummyName()
            pos=Get_ObjectPos(char)
            cshelper.spawn(name,Object_GetTemplate(char),(pos[0]+randint(-30,30),pos[1]+randint(-30,30),pos[2]))
            alignWith(name,char)
            if Object_GetClass(char)&OC_CONTROLLABLE:
                FFX_DestroyPortrait(name)
            initMinionAI(name,m25ai.GetTeam(char),'',isEvil(char))
            if usingM25AI():
                m25ai.AddGoal_HuntEnemy(name)
            RegTimer('destroyClone',30,0,name)
            FFX_ObjectSetAttr(name,'clone',1)
            Object_SetAttr(name,'health',Object_GetAttr(char,'health')/2)
            Object_SetAttr(name,'maxHealth',Object_GetAttr(char,'maxHealth')/2)
            damage=(damage-10)/2
    Object_SetAttr(char,'lastHealthAC',Object_GetAttr(char,'health'))

def destroyClone(event):
    char=event.object
    if FFX_ObjectGetAttr(char,'clone'):
        Object_Destroy(char)

####################### GROUP MIND #######################################

def initgroupmind(char,update=0):
    print 'group mind initialised %s(%s,%s)'%(char,Object_GetTemplate(char),FFX_GetTemplate(char))
    RegAlmostDead(char,'OnGroupMindDie',1)
    Mission_CustomAction('CUSTOM_TRANSFER',char,Object_GetTemplate(char),'OnGroupTransfer',50,0)
    if FFX_GetTemplate(char)!=Object_GetTemplate(char):
        Mission_CustomAction('CUSTOM_TRANSFER',char,FFX_GetTemplate(char),'OnGroupTransfer',50,0)

def OnGroupTransfer(target,char):
    if target==char:
        return
    FFX_ObjectSetAttr(char,'clone',1)
    FFX_ObjectSetAttr(target,'clone',0)
    FFX_DestroyPortrait(char)
    if target[:5]=='mobj_':
        print 'its a clone!'
        nt=getDummyName()
        spawn(nt,Object_GetTemplate(target),target)
        alignWith(nt,target)
        FFX_ObjectSetAttr(nt,'morph',1)
        if Object_GetClass(nt)&OC_CONTROLLABLE==0:
            print 'adding portrait to %s'%(nt)
            FFX_AddPortrait(nt)
        #RegTimer('gmPortrait',0.5,0,nt)
        SetTeam(nt,GetTeam(target))
        Object_SetAttr(nt,'maxHealth',Object_GetAttr(target,'maxHealth'))
        Object_SetAttr(nt,'health',Object_GetAttr(target,'health'))
        Object_SetAttr(nt,'energyPoints',Object_GetAttr(target,'energyPoints'))
        Object_Destroy(target)
        target=nt
    else:
        FFX_AddPortrait(target)
    Mission_SelectHero(target)
    Object_SetAttr(target,'heroPoints',Object_GetAttr(char,'heroPoints'))
    if usingM25AI():
        m25ai.TransferAI(tochar=target,fromchar=char)

def gmPortrait(event):
    nt=event.object
    if Object_GetClass(nt)&OC_CONTROLLABLE==0:
        print 'adding portrait to %s'%(nt)
        FFX_AddPortrait(nt)

def OnGroupMindDie(event):
    char=event.object
    template=Object_GetTemplate(char)
    print 'OnGroupMindDie:%s(%s)'%(char,template)
    #turn all actual clones of this character into copies so they don't die when he does
    for obj in Mission_GetDynamicObjects():
        if Object_GetAttr(obj,'complex')==Object_GetAttr(char,'complex') and obj[:5]=='mobj_':
            print '%s is a clone!'%(obj)
            name=getDummyName()
            FFX_Spawn(name,template,obj)
            AI_DestroyHeroAI(name)
            FFX_ObjectSetAttr(name,'clone',1)
            Object_SetAttr(name,'maxHealth',Object_GetAttr(obj,'maxHealth'))
            Object_SetAttr(name,'health',Object_GetAttr(obj,'health'))
            Object_SetAttr(name,'energyPoints',Object_GetAttr(obj,'energyPoints'))
            SetTeam(name,GetTeam(obj))
            RegTimer('destroyClone',20,0,name)
            Object_Destroy(obj)
    RegTimer('OnGroupMindDie2',0.1,FFX_HasPortrait(char),char)

def OnGroupMindDie2(event):
    char=event.object
    template=Object_GetTemplate(char)
    #now safe to kill the character
    kill(char)
    print '%s is dead!'%(char)
    if FFX_ObjectGetAttr(char,'clone'):
        print 'clone! %d'%(FFX_ObjectGetAttr(char,'clone'))
        return
    print 'he was a %s'%(template)
    host=''
    hp=0
    for obj in Mission_GetDynamicObjects():
        if obj!=char and Object_GetAttr(obj,'complex')==Object_GetAttr(char,'complex'):
            if Object_GetAttr(obj,'health')>hp:
                hp=Object_GetAttr(obj,'health')
                host=obj
    print 'host=%s'%(host)
    if host!='':
        Object_SetAttr(char,'noFade',0)
        if event.user!=0:
            FFX_DestroyPortrait(char)
            FFX_AddPortrait(host)
            Object_SetAttr(host,'heroPoints',Object_GetAttr(char,'heroPoints'))
            Mission_SelectHero(host)
            if usingM25AI():
                m25ai.TransferAI(tochar=host,fromchar=char)
        FFX_ObjectSetAttr(host,'clone',0)
        Object_SetAttr(host,'enabled',0)


####################### FASTFLIER ########################################
def initfastflier(char,update=0,remove=0):
    if update==0:
        if remove == 0:
            mlogreader.regFlightStart(char,'ffx.onFastFlightStart',persistent=1)
            FFX_ObjectSetAttr(char,'fastflier',1)
        else:
            mlogreader.cancelAnimationCallbackSink(char,'ffx.onFastFlightStart')
            FFX_ObjectSetAttr(char,'fastflier',0)

# Note that we could keep track of whether the character was flying
# the last time these callbacks were checked, but the code in
# mlogreader already does that, do we will try without.
def onFastFlightStart(event):
    char=event.object
    if not ( Object_IsAlive(char) and FFX_ObjectGetAttr(char,'fastflier',0) ):
        return
    speed=Object_GetAttr(char,'templateSpeed')+3
    if speed>9:
        speed=9
    Object_SetAttr(char,'speed',speed)
    FFX_ObjectSetAttr(char,'baseSpeed',speed)
    mlogreader.regFlightStop(char,'ffx.onFastFlightStop')

def onFastFlightStop(event):
    char=event.object
    if not ( Object_IsAlive(char) and FFX_ObjectGetAttr(char,'fastflier',0) ):
        return
    speed=Object_GetAttr(char,'templateSpeed')
    Object_SetAttr(char,'speed',speed)
    FFX_ObjectSetAttr(char,'baseSpeed',speed)

def fastFlierCheck(event):
    char=event.object
    if Object_Exists(char)==0:
        return
    RegTimer('fastFlierCheck',1,0,char)
    if not Object_IsAlive(char): ###!
        return
    flying = mlogreader.MLOG_IsFlying(char)#Ep. 2007-02-04: replaced obsolete FFQ_IsFlying()
    wasFlying=FFX_ObjectGetAttr(char,'airborne')
    if flying and (wasFlying==0):
#        Mission_StatusText("up up and away!")
        speed=Object_GetAttr(char,'templateSpeed')+3
        if speed>9:
            speed=9
        Object_SetAttr(char,'speed',speed)
        Object_SetAttr(char,'baseSpeed',speed)
        FFX_ObjectSetAttr(char,'airborne',1)
    if (flying==0) and wasFlying:
#        Mission_StatusText("cool your jets")
        speed=Object_GetAttr(char,'templateSpeed')
        Object_SetAttr(char,'speed',speed)
        Object_SetAttr(char,'baseSpeed',speed)
        FFX_ObjectSetAttr(char,'airborne',0)


####################### SUPERSPEED #######################################

def initsuperspeed(char,update=0):
    FFX_ObjectSetAttr(char,'speedforce',0)
    FFX_ObjectSetAttr(char,'speedcount',0)
    RegTimer('SuperSpeedCheck',1,0,char)

def SuperSpeedCheck(event):
    char=event.object
    RegTimer('SuperSpeedCheck',0.5,0,char)
    pos=Get_ObjectPos(char)
    dx=pos[0]-FFX_ObjectGetAttr(char,'sspeedX',pos[0])
    dy=pos[1]-FFX_ObjectGetAttr(char,'sspeedY',pos[1])
    FFX_ObjectSetAttr(char,'sspeedX',pos[0])
    FFX_ObjectSetAttr(char,'sspeedY',pos[1])
    if FFX_ObjectGetAttr(char,'speedforce')==0:
        if (dx*dx+dy*dy)>100:
            count=FFX_ObjectGetAttr(char,'speedcount')
            count=count+1
            if count>3:
                FFX_ObjectSetAttr(char,'speedforce',1)
                Object_SetAttr(char,'speed',Object_GetAttr(char,'speed')+10)
                count=0
            FFX_ObjectSetAttr(char,'speedcount',count)
    else:
        if (dx*dx+dy*dy)<100:
            FFX_ObjectSetAttr(char,'speedforce',0)
            Object_SetAttr(char,'speed',Object_GetAttr(char,'speed')-10)
            FFX_ObjectSetAttr(char,'speedcount',0)

####################### INNER BEING #############################################

def initinnerbeing(char,update=0):
    for index in range(1,4):
        cmd=getByTemplate(char,FFX_INNERBEING_CUSTOM,index*2-1)
        if cmd!='':
           FFX_ObjectSetAttr(char,'inner%d'%(index),1)
           Mission_CustomAction(cmd,char,char,'OnReleaseInner%d'%(index),5,0)
    RegDeath(char,'masterDie')

#masterDie codes
#0 = minion dies
#1 = minion enrages
#2 = minion de-animates
#3 = minion vanishes in a puff of smoke

def masterDie(event):
    char=event.object
    RegCharState(char,0,'masterDie',0,event.user)
    if Object_IsAlive(char)==0:
        RegDeath(char,'masterDie',event.user)
    if cshelper.normal(char):
        return
    id=Object_GetAttr(char,'ffxID')
    for obj in Mission_GetDynamicObjects():
        if FFX_ObjectGetAttr(obj,'master')==id and FFX_ObjectGetAttr(obj,'minionType')==event.user:
            if event.user==0:
                cshelper.kill(obj)
            elif event.user==1:
                if Object_GetPrimaryState(char)==PCSTATE_HYPNOTISED:
                    Object_SetPrimaryState(obj,PCSTATE_HYPNOTISED,10000,0)
                else:
                    Object_SetPrimaryState(obj,PCSTATE_ENRAGED,10000,0)
            elif event.user==2:
                UnAnimate(obj)
            elif event.user==3:
                makecloak(obj,10)
                Object_SetPrimaryState(obj,PCSTATE_EXILE,100,0)
                RegTimer('destroyTemp',3,0,obj)
                Object_PlayEffect(obj,getByTemplate(char,FFX_SUMMONER_CUSTOM,2))
            elif event.user==4:
                Object_SetPrimaryState(obj,PCSTATE_EXILE,100,0)
                RegTimer('destroyTemp',3,0,obj)

def masterUpdate(event):
    char=event.object
    RegTimer('masterUpdate',1,event.user,char)
    if not Object_IsAlive(char): ###! quick fix, but I haven't had the time to really check if it behaves correctly under all circumstances
        return
    ep=Object_GetAttr(char,'energyPoints')
    id=Object_GetAttr(char,'ffxID')
    for obj in Mission_GetDynamicObjects():
        if FFX_ObjectGetAttr(obj,'master')==id and isReal(obj) and FFX_ObjectGetAttr(obj,'minionType')==event.user:
            if ep>0:
                ep=ep-1
            else:
                if event.user==2:
                    UnAnimate(obj)
                elif event.user==3:
                    makecloak(obj,10)
                    Object_SetPrimaryState(obj,PCSTATE_EXILE,100,0)
                    RegTimer('destroyTemp',3,0,obj)
                    Object_PlayEffect(obj,getByTemplate(char,FFX_SUMMONER_CUSTOM,2))
                elif event.user==4:
                   Object_SetPrimaryState(obj,PCSTATE_EXILE,100,0)
                   RegTimer('destroyTemp',3,0,obj)
    Object_SetAttr(char,'energyPoints',ep)

def OnReleaseInner1(dummy,char):
    OnReleaseInner(1,char)
def OnReleaseInner2(dummy,char):
    OnReleaseInner(2,char)
def OnReleaseInner3(dummy,char):
    OnReleaseInner(3,char)

def GetHeroCount():
    count=0
    for o in Mission_GetDynamicObjects():
        if FFX_HasPortrait(o):
            count=count+1
    return count

def OnReleaseInner(index,char):
    if chargeEP(char,33)==0:
        return
    template=getByTemplate(char,FFX_INNERBEING_CUSTOM,index*2)
    name=getDummyName()
    needPort=FFX_HasPortrait(char)
    if GetHeroCount()==4:
        needPort=0
    FFX_Spawn(name,template,char)
    hasPort=Object_GetClass(name)&OC_CONTROLLABLE
    if hasPort==0 and needPort:
        FFX_AddPortrait(name)
    if hasPort and needPort==0:
        FFX_DestroyPortrait(name)
    Trigger_Move(name,'hover')
    Object_PlayEffect(char,getByTemplate(char,FFX_INNERBEING_CUSTOM,8),'',FX_TRACK_OBJECT_FULL)
    FFX_Animate(char,getByTemplate(char,FFX_INNERBEING_CUSTOM,7))
    RegDeath(name,'InnerDeath',index)
    FFX_ObjectSetAttr(name,'master',Object_GetAttr(char,'ffxID'))
    FFX_ObjectSetAttr(name,'minionType',0)
    cmd=getByTemplate(char,FFX_INNERBEING_CUSTOM,index*2-1)
    Mission_RemoveCustomAction(cmd,char,char)
    FFX_ObjectSetAttr(char,'inner%d'%(index),0)
    initMinionAI(name,m25ai.GetTeam(char),'',isEvil(char))
    if usingM25AI() and m25ai.AIInWatch(char):
        m25ai.AIEnable(name)
        m25ai.SetBrawler(name)
        m25ai.AddGoal_HuntEnemy(name)

def InnerDeath(event):
    char=event.object
    RegTimer('InnerDeath2',3,event.user,char)

def InnerDeath2(event):
    index=int(event.user)
    char=event.object
    if Object_Exists(char):
        Object_Destroy(char)
    master=findCharByID(FFX_ObjectGetAttr(char,'master'))
    if master!='':
        FFX_ObjectSetAttr(master,'inner%d'%(index),1)
        cmd=getByTemplate(master,FFX_INNERBEING_CUSTOM,index*2-1)
        if cmd!='':
           Mission_CustomAction(cmd,master,master,'OnReleaseInner%d'%(index),5,0)

####################### ASTRAL ##################################################

def initastralscout(char,update=0):
    initastral(char,update)

def initastral(char,update=0):
    if isMP():
        return
    if update==0:
        if not FFX_ObjectGetAttr(char,'astral_projection'): #Ep. 2006-09-22: prevent dupes from spawning dupes themselves
            cmd=getByTemplate(char,FFX_ASTRALFORM_CUSTOM,1)
            Mission_CustomAction(cmd,char,char,'OnReleaseAstral',4,0)

def OnReleaseAstral(dummy,char):
    AI_Animate(char,getByTemplate(char,FFX_ASTRALFORM_CUSTOM,3),'OnReleaseAstral2')

def OnReleaseAstral2(event):
    char=event.object
    astralFX(char)
    FFX_AdjustPortrait(char,0)
    name=getFormName()
    FFX_ObjectSetAttr(char,'permaStun',1) ###! changed from Object_SetAttr()
    astralTemplate=getByTemplate(char,FFX_ASTRALFORM_CUSTOM,2)
    OnDrop(char,char)
    dupe=0
    if astralTemplate=='':
        astralTemplate=Object_GetTemplate(char)
        dupe=1
    FFX_Spawn(name,astralTemplate,char)
    FFX_ObjectSetAttr(name,'morph',1)
    FFX_ObjectSetAttr(name,'astral_projection',1) #Ep. 2006-09-22: identifies astral projection characters
    Object_SetPrimaryState(char,PCSTATE_STUNNED,10000,0)
    RegTimer('permaStun',1,0,char)
    if dupe:
        makeIllusion(name,1)
        spd=Object_GetAttr(name,'speed')+3
        Object_SetAttr(name,'speed',spd)
        Object_SetSecondaryState(name,SCSTATE_POWER_NULLIFICATION,10000,0)
        RegTimer('removeFX',0.5,3,name)
    Object_SetAttr(name,'maxHealth',Object_GetAttr(char,'maxHealth'))
    Object_SetAttr(name,'health',Object_GetAttr(char,'health'))
    Object_SetAttr(name,'energyPoints',Object_GetAttr(char,'energyPoints'))
    Object_SetAttr(name,'maxEnergyPoints',Object_GetAttr(char,'maxEnergyPoints'))
    Object_SetAttr(name,'heroPoints',Object_GetAttr(char,'heroPoints'))
    Mission_SelectHero(name)
    Mission_CustomAction('CUSTOM_RETURN',name,char,'OnAstralReturn',0,0)
    RegTimer('AstralLink',1,0,name,char)

def OnAstralReturn(target,char):
    astralFX(char)
    FFX_AdjustPortrait(char,0)
    RegTimer('destroyTemp',1,0,char)
    RegTimer('OnAstralReturn2',0.1,0,target)
    FFX_ObjectSetAttr(target,'permaStun',0) ###! changed from Object_SetAttr()
    normalize(target)
    astralFX(target)
    Object_SetAttr(target,'energyPoints',Object_GetAttr(char,'energyPoints'))
    Object_SetAttr(target,'heroPoints',Object_GetAttr(char,'heroPoints'))

def OnAstralReturn2(event):
    target=event.object
    FFX_AdjustPortrait(target,1)
    Mission_SelectHero(target)

def permaStun(event):
    char=event.object
    if FFX_ObjectGetAttr(char,'permaStun'): # changed from Object_GetAttr()
        Object_SetPrimaryState(char,PCSTATE_STUNNED,100,0)
        RegTimer('permaStun',1,0,char)

def astralFX(shell):
    fx=getByTemplate(shell,FFX_ASTRALFORM_CUSTOM,4)
    if fx!='':
        Object_PlayEffect(shell,fx)

def AstralLink(event):
    c1=event.object
    c2=event.string
    if Object_Exists(c1) & Object_Exists(c2):
        l1=Object_IsAlive(c1)
        l2=Object_IsAlive(c2)
        if l1 and not l2:
            cshelper.kill(c1)
        if l2 and not l1:
            cshelper.kill(c2)
        if l1 and l2:
            hp1=Object_GetAttr(c1,'health')
            hp2=Object_GetAttr(c2,'health')
            if hp2>hp1:
                Object_SetAttr(c2,'health',hp1)
            if hp1>hp2:
                Object_SetAttr(c1,'health',hp2)
            RegTimer('AstralLink',1,0,c1,c2)



####################### ASTRAL FORM #############################################

def initastralform(char,update=0):
    global FFX_ASTRALFORM_CUSTOM
    #fade out in a sec if not ready, and add to the FFX_ASTRAL_CUSTOM array
    if Mission_GetAttr('shapeReady')==0:
        print 'astral form at startup'
        host=''
        for hero in cshelper.getAllHeroes():
            if hasAttribute(hero,'astral'):
                host=hero
        if host!='':
            hostTemplate=FFX_GetTemplate(host)
            newSet=[]
            for entry in FFX_ASTRALFORM_CUSTOM[0]:
                newSet.append(entry)
            newSet[0]=Object_GetTemplate(host)
            newSet[2]=Object_GetTemplate(char)
            FFX_ASTRALFORM_CUSTOM.append(newSet)
        #remove the astral form for now - they'll be back later...
        RegTimer('destroyTemp',0.5,0,char)

####################### RUSSIAN DOLL ############################################

def initrussiandoll(char,update=0):
    if update==0:
        RegDeath(char,'OnRussianDeath')

def OnRussianDeath(event):
    char=event.object
    if event.user==0:
        if Object_GetAttr(char,'heroPoints')>0:
            #try again later in 3 seconds
            RegTimer('OnRussianDeath',3,1,char)
            return
    else:
        if Object_IsAlive(char):
            RegDeath(char,'OnRussianDeath')
            return
    template=getByTemplate(char,FFX_RUSSIANDOLL_CUSTOM,1)
    fx=getByTemplate(char,FFX_RUSSIANDOLL_CUSTOM,2)
    if fx!='':
        Object_PlayEffect(char,fx)
    port=0
    if FFX_HasPortrait(char):
        AI_DestroyHeroAI(char)
        port=1
    #stop the system closing down because all bad guys are gone...
    Object_SetAttr(char,'health',10)
    RegTimer('OnRussianRevive',0.1,port,char,template)

def OnRussianRevive(event):
    template=event.string
    obj=event.object
    port=event.user
    name=getFormName()
    FFX_Spawn(name,template,obj)
    #transfer hero points to the russian doll
    Object_SetAttr(name,'heroPoints',Object_GetAttr(obj,'heroPoints'))
    hasPort=(Object_GetClass(name)&OC_CONTROLLABLE)!=0
    if port and hasPort==0:
        AI_MakeIntoHero(name)
    if port==0 and hasPort:
        FFX_DestroyPortrait(name)
    if len(cshelper.getAllHeroes())<=1:
        Mission_SelectHero(name)
    initMinionAI(name,m25ai.GetTeam(obj),'',isEvil(obj))
    if usingM25AI():
        m25ai.TransferAI(name, obj)
    Object_SetAttr(obj,'health',0)

####################### BLAZING GLORY #######################################

def initblazingglory(char,update=0):
    if isMP():
        return
    if update==0:
        cmd=getByTemplate(char,FFX_BLAZINGGLORY_CUSTOM,2)
        FFX_ObjectSetAttr(char,'blazing',0)
        Mission_CustomAction(cmd,char,char,'OnBlazeOn',4,0)
        RegTimer('OnBlaze',1.5,0,char)

def OnBlazeOn(dummy,char):
    FFX_ObjectSetAttr(char,'blazing',1)
    Mission_RemoveCustomAction(getByTemplate(char,FFX_BLAZINGGLORY_CUSTOM,2),char,char)
    Mission_CustomAction(getByTemplate(char,FFX_BLAZINGGLORY_CUSTOM,3),char,char,'OnBlazeOff',4,0)

def OnBlazeOff(dummy,char):
    FFX_ObjectSetAttr(char,'blazing',0)
    Mission_RemoveCustomAction(getByTemplate(char,FFX_BLAZINGGLORY_CUSTOM,3),char,char)
    Mission_CustomAction(getByTemplate(char,FFX_BLAZINGGLORY_CUSTOM,2),char,char,'OnBlazeOn',4,0)

def OnBlaze(event):
    char=event.object
    if Object_Exists(char)==0:
        return
    if Object_IsAlive(char)==0:
        return
    RegTimer('OnBlaze',1.5,0,char)
    if FFX_ObjectGetAttr(char,'blazing'):
        if cshelper.isPlaying():
            OnBlazeOff('',char)
        else:
            Trigger_Explosion(char,getByTemplate(char,FFX_BLAZINGGLORY_CUSTOM,1))
            Trigger_Damage(char,FFX_Rand(2,6))

####################### KAMIKAZE #######################################

def initkamikaze(char,update=0):
    if update==0:
        RegAlmostDead(char,'OnKamikaze',1)

def OnKamikaze(event):
    char=event.object
    animation=getByTemplate(char,FFX_KAMIKAZE_CUSTOM,2)
    if animation!='':
        m25ai.AIDisable(char)
        #Object_SetAttr(char, 'enabled', 0)
        #Object_SetAttr(char, 'ai_priority', 99)
        AI_Animate(char,animation,'OnKKExplode')
        RegTimer('OnKKExplode',5,0,char)
    else:
        RegTimer('OnKKExplode',0.1,0,char)
    RegAlmostDead(char,'OnKamikaze',1)
    RegTimer('KKReset',10,0,char)

def KKReset(event):
    FFX_ObjectSetAttr(event.object,'kkexploded',0)

def OnKKExplode(event):
    char=event.object
    if FFX_ObjectGetAttr(char,'kkexploded',0)==0:
        FFX_ObjectSetAttr(char,'kkexploded',1)
        cshelper.kill(char)
        Trigger_Explosion(char,getByTemplate(char,FFX_KAMIKAZE_CUSTOM,1))

######################## FEEDBACK #######################################

feedbackArrays=(
FFX_ABSORPTION_CUSTOM,
FFX_URBANDWELLER_CUSTOM,
FFX_METALEATER_CUSTOM,
FFX_HATEMONGER_CUSTOM,
FFX_VULNERABILITY_CUSTOM,
FFX_DEPENDENCY_CUSTOM,
FFX_ABSORPTIONA_CUSTOM,
FFX_SYMBIOTE_CUSTOM,
FFX_PARASITE_CUSTOM
) ###!Ep 2006-02-05 added parasite and symbiote

def initabsorption(char,update=0):
    initfeedback(char,update,0)

def initurbandweller(char,update=0):
    initfeedback(char,update,1)

def initmetaleater(char,update=0):
    initfeedback(char,update,2)

def inithatemonger(char,update=0):
    initfeedback(char,update,3)

def initvulnerability(char,update=0):
    initfeedback(char,update,4)

def initdependency(char,update=0):
    initfeedback(char,update,5)

def initfeedback(char,update,index):
    RegTimer('FeedBackCheck',1,index,char)
    #just in case they choose invulnerability ###! changed to use the new Damage Management
    if update==0:
        invPoints=FFX_ObjectGetAttr(char,'invPoints')
        if invPoints==0:
            FFX_ObjectSetAttr(char,'ivlastdam',Object_GetAttr(char,'health'))
            if not FFX_ObjectGetAttr(char,'DamageManagement',0):
                RegDamage(char,'DamageManagement')
                FFX_ObjectSetAttr(char,'DamageManagement',1)
        FFX_ObjectSetAttr(char,'invPoints',invPoints)
        FFX_ObjectSetAttr(char,'baseInvPoints',invPoints)

#check for objects of a given template around
def FeedBackCheck(event):
    doFeedback(event,1)

def FeedBackAction(event):
    print 'feedbackaction triggered'
    doFeedback(event,0)

def doFeedback(event,timer):
    char=event.object
    if Object_Exists(char)==0:
        return
    if timer:
        RegTimer('FeedBackCheck',1,event.user,char)
    if Object_IsAlive(char)==0: ##!
        return
    count=0
    targets=[]
    array=feedbackArrays[int(event.user)]
    radius=getByTemplate(char,array,5)
    radius2=radius*radius
    fn=getByTemplate(char,array,1)
    #Ep./Kuertee 2006-09-10: Prevent the map itself (whose template is '') from appearing in that list
    staticObjects = list( Mission_GetObjects() )
    staticObjects.remove( Object_GetTerrain() )
    for obj in staticObjects:  # stumpy 2006-09-24: removed Object_Exists() check
        exec('relevant=%s(obj,char)'%(fn))
        if Object_IsAlive(obj) and relevant and Object_GetAttr(obj,'physical')!=0:
            d=distanceSq(obj,char)
            if d<radius2:
                targets.append(obj)
    #do something based on count (reverse flag for dependency)
    flip=(event.user==5)
    count=1
    if event.user==6:
        count=10
    DoFeedBack(char,targets,array,flip,count)

def DoFeedBack(char,targets,array,flip=0,count=1):
    if len(targets)>0 or flip:
        fn=getByTemplate(char,array,2)
        if flip==0:
            for i in range(0,count):
                exec('%s(char,targets,array)'%(fn))
        else:
            exec('%s(char,targets,array,flip)'%(fn))

#Ep 2006-09-06 made less verbose
def isMinuteUp(obj,char=''):
    t=1+FFX_ObjectGetAttr(obj,'acctime')
    FFX_ObjectSetAttr(obj,'acctime',t)
    t=60-t
    if (t % 5 == 0) or (t < 5):
        Mission_StatusText('%d'%t)
    return t<0

#Ep 2006-02-05 isMinupeUp() variant on request of apfarmakis
def isRandomTimeUp(obj,char=''):
    timer = randint(20, 150)
    t = 1 + FFX_ObjectGetAttr(obj, 'acctime')
    FFX_ObjectSetAttr(obj, 'acctime', t)
    return t > timer

def isNever(obj,char=''):
    return 0

# Ep 2006-02-05 Added check for the object existence to the is..() functions below
# Kuertee 2006-07-30 added default empty string to char os that these checks don't error when only 1 parameter is sent

def isBuilding(obj,char=''):
    if not Object_Exists(obj):
        return 0
    return Object_GetClass(obj)&OC_BUILDING

def isCivilianFB(obj,char=''):
    if not Object_Exists(obj):
        return 0
    return Object_GetClass(obj)&OC_CIVILIAN

def isStunned(obj,char=''):
    if not Object_Exists(obj):
        return 0
    return Object_GetPrimaryState(obj)==PCSTATE_STUNNED

def isBlank(obj,char=''):
    if not Object_Exists(obj):
        return 0
    return Object_GetPrimaryState(obj)==PCSTATE_BLANK

def isHypnotised(obj,char=''):
    if not Object_Exists(obj):
        return 0
    return Object_GetPrimaryState(obj)==PCSTATE_HYPNOTISED

def isPanicked(obj,char=''):
    if not Object_Exists(obj):
        return 0
    return Object_GetPrimaryState(obj)==PCSTATE_PANICKED

def isEnraged(obj,char=''):
    if not Object_Exists(obj):
        return 0
    return Object_GetPrimaryState(obj)==PCSTATE_ENRAGED

def isMindControlled(obj,char=''):
    if not Object_Exists(obj):
        return 0
    s=Object_GetPrimaryState(obj)
    return s==PCSTATE_BLANK or s==PCSTATE_HYPNOTISED or s==PCSTATE_PANICKED or s==PCSTATE_ENRAGED

def isStatic(obj,char=''):
    if not Object_Exists(obj):
        return 0
    return Object_GetPrimaryState(obj)==PCSTATE_STATIC

def isFrozen(obj,char=''):
    if not Object_Exists(obj):
        return 0
    return Object_GetPrimaryState(obj)==PCSTATE_FROZEN

def isExiled(obj,char=''):
    if not Object_Exists(obj):
        return 0
    return Object_GetPrimaryState(obj)==PCSTATE_EXILE

def isEnergised(obj,char=''):
    if not Object_Exists(obj):
        return 0
    return (Object_GetSecondaryStates(obj)&(SCSTATE_ENERGIZED|SCSTATE_AREA_ENERGIZED))!=0

def isIrradiated(obj,char=''):
    if not Object_Exists(obj):
        return 0
    return (Object_GetSecondaryStates(obj)&(SCSTATE_IRRADIATED))!=0

def isAcidBurnt(obj,char=''):
    if not Object_Exists(obj):
        return 0
    return (Object_GetSecondaryStates(obj)&(SCSTATE_ACIDBURNT))!=0

def isPowerNulled(obj,char=''):
    if not Object_Exists(obj):
        return 0
    return (Object_GetSecondaryStates(obj)&(SCSTATE_POWER_NULLIFICATION))!=0

def isHexed(obj,char=''):
    if not Object_Exists(obj):
        return 0
    return (Object_GetSecondaryStates(obj)&(SCSTATE_HEXED))!=0

def isBlind(obj,char=''):
    if not Object_Exists(obj):
        return 0
    return (Object_GetSecondaryStates(obj)&(SCSTATE_BLIND))!=0

def isOutOfEnergy(obj,char=''):
    if not Object_Exists(obj):
        return 0
    return Object_GetAttr(obj,'energyPoints')<=(Object_GetAttr(obj,'maxEnergyPoints')*0.05)

def isAtFullEnergy(obj,char=''):
    if not Object_Exists(obj):
        return 0
    return Object_GetAttr(obj,'energyPoints')==Object_GetAttr(obj,'maxEnergyPoints')

def isLowOnHealth(obj,char=''):
    if not Object_Exists(obj):
        return 0
    return Object_GetAttr(obj,'health')<=(Object_GetAttr(obj,'maxHealth')*0.3)

def isStone(obj,char=''):
    if not Object_Exists(obj):
        return 0
    return Object_GetAttr(obj,'material')==2

def isMetal(obj,char=''):
    if not Object_Exists(obj):
        return 0
    return Object_GetAttr(obj,'material')==1

def isRubber(obj,char=''):
    if not Object_Exists(obj):
        return 0
    return Object_GetAttr(obj,'material')==3

def isFire(obj,char=''):
    if not Object_Exists(obj):
        return 0
    return Object_GetAttr(obj,'material')==4

def isEnergy(obj,char=''):
    if not Object_Exists(obj):
        return 0
    return Object_GetAttr(obj,'material')==5

def isWood(obj,char=''):
    if not Object_Exists(obj):
        return 0
    return Object_GetAttr(obj,'material')==7

def isIce(obj,char=''):
    if not Object_Exists(obj):
        return 0
    return Object_GetAttr(obj,'material')==9

def isCloneOf(obj,char=''):
    if not Object_Exists(obj):
        return 0
    return Object_GetTemplate(obj)==Object_GetTemplate(char)

def isSameMaterial(obj,char=''):
    if not (Object_Exists(obj) and Object_Exists(char)):
        return 0
    return Object_GetAttr(obj,'material')==Object_GetAttr(char,'material')

def isAlienMineral(obj,char=''):
    if not Object_Exists(obj):
        return 0
    return Object_GetTemplate(obj)=='alien_mineral' or FFX_ObjectGetAttr(obj,'mineralised')

def isZombie(obj,char=''):
    if not Object_Exists(obj):
        return 0
    return (Object_GetSecondaryStates(obj)&SCSTATE_ZOMBIE)!=0

def isTechnoOrganic(obj,char=''):
    return Object_GetTemplate(obj)=='ffx_borgstack'

#Ep. 2006-09-05
def isNight(obj, char=''):
    return getLightLevels() < 1.0

#Ep. 2006-09-05
def isDay(obj, char=''):
    return getLightLevels() >= 1.0

# other is...() secondary state functions available under FFQ object identification helpers section

#electricalSources=(): moved to ffxextras.py

def isElectricalGrid(obj,char=''):
    if not Object_Exists(obj):
        return 0
    temp=Object_GetTemplate(obj)
    for t in electricalSources:
        if t==temp:
            return 1
    return 0

def isNotSpeedster(obj,char=''):
    if not Object_Exists(obj):
        return 0
    if Object_GetClass(obj)&FFX_CHARACTER:
        if Object_GetAttr(obj,'baseSpeed')<8:
            return 1
    return 0

# Kuertee 2006-07-30 - added "if char != '' and..." so that it doesn't return error when only 1 parameter is sent
# stumpy 2007-01-10: added check that health is half that of tested object, so that we only compare with the original.
def isEarlierVersionOf(obj,char=''):
    if ( char != '' ) and ( Object_GetTemplate(obj)==Object_GetTemplate(char) ) \
       and ( int(Object_GetAttr(obj,'maxHealth'))/2 == int(Object_GetAttr(char,'maxHealth')) ):
        if Object_GetAttr(obj,'ffxID') < Object_GetAttr(char,'ffxID'):
            hp=Object_GetAttr(obj,'health')*Object_GetAttr(char,'maxHealth')/Object_GetAttr(obj,'maxHealth')
            myhp=Object_GetAttr(char,'health')
            if hp<myhp:
                print 'isEarlierVersionOf(%s[%d],%s[%d]): hp=%d myhp=%d, calling Trigger_Damage(%s,%d)' % \
                      (repr(obj),Object_GetAttr(obj,'ffxID'),repr(char),Object_GetAttr(char,'ffxID'),hp,myhp,repr(char),myhp-hp)
                Trigger_Damage(char,myhp-hp)
                return 1
    return 0

def isCharacter(obj,char=''):
    if not Object_Exists(obj):
        return 0
    if Object_GetClass(obj)&FFX_CHARACTER:
        return 1
    return 0

# Ep. 2006-08-28: changed name from isAlive() to avoid confusion
# as this function doesn't detect if the object is currently alive;
# what it detects is if the object is a living entity (vs. a prop or a dumb machine)
def isSentient(obj,char=''):
    if not Object_Exists(obj):
        return 0
    if Object_GetClass(obj)&FFX_CHARACTER:
        if not ( (getGender(obj) == FFX_GENDER_ROBOT) and hasAttribute(obj,'mindless') ): ###! Ep 2006-02-25: previous version broken (detected non-robots with the 'mindless' attribute)
            return 1
    return 0

def isMachine(obj,char=''):
    if not Object_Exists(obj):
        return 0
    if Object_GetClass(obj)&FFX_CHARACTER:
        if getGender(obj)==FFX_GENDER_ROBOT:
            return 1

def isGoodOrEvil(obj,char=''):
    if not Object_Exists(obj):
        return 0
    if Object_GetClass(obj)&FFX_CHARACTER:
        if isEvil(obj):
            return 1
        elif Object_GetAttr(obj,'enhsenfx2')==-1:
            fx=getByTemplate(char,FFX_SCAN_CUSTOM,4)
            if fx!='':
                handle=Object_PlayEffect(obj,fx,'',FX_LOOP|FX_TRACK_OBJECT_POS,0,'centre')
            Object_SetAttr(obj,'enhsenfx2',handle)
            ffx.RegTimer('killenhsenfx',1,0,obj)

def isEnergyX(obj,char=''):
    if not Object_Exists(obj):
        return 0
    if Object_GetTemplate(obj)[:7]=='powerup':
        return 1
    if Object_GetClass(obj)&OC_CHARACTER==0:
        return 0
    if Object_GetAttr(obj,'energy')>=7:
        return 1
    return isEnergised(obj,char)

def isEnergyXFeedback(obj,char=''):
    if not Object_Exists(obj):
        return 0
    if (Object_GetClass(obj)&OC_CHARACTER==0) and (Object_GetTemplate(obj)[:7]!='powerup'):
        return 0
    res=isEnergised(obj,char)
    accum=1+(res*9)+FFX_ObjectGetAttr(char,'accumulator')
    if Object_GetAttr(obj,'energy')>=7:
        res=1
        if Object_GetAttr(obj,'energy')==9:
            accum=accum+9
    elif Object_GetTemplate(obj)[:7]=='powerup':
        res=1
    FFX_ObjectSetAttr(char,'accumulator',accum)
    return res

#see the magicBeings customization tuple in ffxextras.py
def isMagic(obj,char=''):
    if not Object_Exists(obj):
        return 0
    if Object_GetClass(obj)&FFX_CHARACTER:
        t=Object_GetTemplate(obj)
        for t0 in magicBeings:
            if t0==t:
                return 1
        return 0

def isMagicOverwhelm(obj,char=''):
    if not (Object_Exists(obj) and Object_Exists(char)):
        return 0
    if Object_GetClass(obj)&FFX_CHARACTER:
        t=Object_GetTemplate(obj)
        for t0 in magicBeings:
            if t0==t:
                if randint(1,20)==1:
                    Object_SetPrimaryState(char,PCSTATE_HYPNOTISED,10,0)
                return 1
    return 0

#see the nazis customization tuple in ffxextras.py
def isNazi(obj,char=''):
    if not Object_Exists(obj):
        return 0
    if Object_GetClass(obj)&FFX_CHARACTER:
        t=Object_GetTemplate(obj)
        for t0 in nazis:
            if t0==t:
                return 1
    return 0

def isEnemy(obj,char=''):
    if not (Object_Exists(obj) and Object_Exists(char)):
        return 0
    if obj==char:
        return 0
    if (Object_GetClass(obj)&FFX_CHARACTER)==0:
        return 0
    if isEvil(obj)!=isEvil(char):
        return 1
    if m25ai.AreEnemies(obj,char):
        return 1
    return 0

# Ep 2006-02-05 Symbiote/Parasite customisation additions
# returns 1 only if the object has the symbiote attribute and if both the object and the char are the same subtype of symbiote
def isSymbiote(obj,char=''):
    if not (Object_Exists(obj) and Object_Exists(char)):
        return 0
    if obj != char:
        if hasAttribute(obj, 'symbiote'):
            if (char == '') or (getByTemplate(obj, FFX_SYMBIOTE_CUSTOM, 6) == getByTemplate(char, FFX_SYMBIOTE_CUSTOM, 6)):
                return 1
    return 0

# returns 1 only if the object has the parasite attribute and if both the object and the char are the same subtype of parasite
def isParasite(obj,char=''):
    if not (Object_Exists(obj) and Object_Exists(char)):
        return 0
    if obj != char:
        if hasAttribute(obj, 'parasite'):
            if (char == '') or (getByTemplate(obj, FFX_PARASITE_CUSTOM, 6) == getByTemplate(char, FFX_PARASITE_CUSTOM, 6)):
                return 1
    return 0

# stumpy 2007-12-19: Added for use with BODY ARMOR
# Body armor is gone
def isBodyArmorGone(char):
    return FFX_ObjectGetAttr(char,'BAPoints',0) < 1

# Body armor is down to half or less of its initial rating
def isBodyArmorHalf(char):
    return FFX_ObjectGetAttr(char,'BAPoints',0) <= FX_ObjectGetAttr(char,'BaseBAPoints',1)/2

# Body armor is down to one-quarter or less of its initial rating
def isBodyArmorQuarter(char):
    return FFX_ObjectGetAttr(char,'BAPoints',0) <= FX_ObjectGetAttr(char,'BaseBAPoints',1)/4

def drawHealth(char,targets,array):
    drawAttr(char,targets,array,'health','maxHealth',1)

def drawEnergy(char,targets,array):
    drawAttr(char,targets,array,'energyPoints','maxEnergyPoints',5)

def leechHealth(char,targets,array):
    drawAttr(char,targets,array,'health','maxHealth',0.33,1)

def leechEnergy(char,targets,array):
    drawAttr(char,targets,array,'energyPoints','maxEnergyPoints',5,1)

def drawAttr(char,targets,array,attr,maxAttr,maxRate=1,leeching=0):
    num=float(len(targets))
    damage=Object_GetAttr(char,maxAttr)-Object_GetAttr(char,attr)
    draw=damage/num
    if draw>maxRate:
       draw=maxRate
    payback=draw*num
    if payback>damage:
        payback=damage
    if payback>0:
        playSynergyFX(char,array)
        Object_SetAttr(char,attr,Object_GetAttr(char,attr)+payback)
    if draw>0:
        playSynergyFXonTargets(char,targets,array)
    if leeching:
        for targ in targets:
            newVal=Object_GetAttr(targ,attr)-draw
            if newVal<1 and attr=='health':
                Trigger_Damage(targ,1+draw)
            else:
                Object_SetAttr(targ,attr,newVal)

def gainStrength(char,targets,array):
    power=len(targets)
    if power>0:
        playSynergyFX(char,array)
        playSynergyFXonTargets(char,targets,array)
    FFX_SetStrength(char,power*0.2)

def gainStrengthSU(char,targets,array):
    power=len(targets)
    if power>0:
        playSynergyFX(char,array)
        playSynergyFXonTargets(char,targets,array)
    FFX_SetStrength(char,power*0.2)
    for hero in getAllHeroes():
        if Object_GetTemplate(hero)[:9]=='man_o_war':
            if distanceSq(hero,char)<20000:
                playSynergyFX(hero,array)
                FFX_SetStrength(hero,power*0.2)
            else:
                FFX_SetStrength(hero,0)

def gainInvulnerability(char,targets,array):
    power=len(targets)
    if power>0:
        playSynergyFX(char,array)
        playSynergyFXonTargets(char,targets,array)
    bip=FFX_ObjectGetAttr(char,'baseInvPoints')
    FFX_ObjectSetAttr(char,'invPoints',power*2+bip)

def gainMass(char,targets,array):
    power=len(targets)
    if power>0:
        playSynergyFX(char,array)
        playSynergyFXonTargets(char,targets,array)
    mass=FFX_ObjectGetAttr(char,'baseMass')
    Object_SetAttr(char,'mass',mass*(1+power*0.5))

def gainAgility(char,targets,array,scale=1):
    power=len(targets)
    isNimble = hasAttribute(char,'nimble',ffxOnly=1)    # stumpy 2008/02/23: use correct limit for NIMBLE characters
    val=Object_GetAttr(char,'templateAgility')+power*scale
    if val>9+3*isNimble:
        val=9+3*isNimble
    Object_SetAttr(char,'agility',val)

def gainSpeed(char,targets,array,scale=1):
    power=len(targets)
    val=Object_GetAttr(char,'templateSpeed')+power*scale
    if val>9:
        val=9
    Object_SetAttr(char,'speed',val)

def leechEnergyAgilAndSpeed(char,targets,array):
    leechEnergy(char,targets,array)
    gainSpeed(char,targets,array)
    gainAgility(char,targets,array)

def gainMassAndStrength(char,targets,array):
    power=len(targets)
    if power>0:
        playSynergyFX(char,array)
        playSynergyFXonTargets(char,targets,array)
    FFX_SetStrength(char,power*0.15)
    playSynergyFX(char,array)
    mass=FFX_ObjectGetAttr(char,'baseMass')
    Object_SetAttr(char,'mass',mass*(1+power*0.5))

def gainStrengthAndInvulnerability(char,targets,array):
    power=len(targets)
    if power>0:
        playSynergyFX(char,array)
        playSynergyFXonTargets(char,targets,array)
    FFX_SetStrength(char,power*0.12)
    bip=FFX_ObjectGetAttr(char,'baseInvPoints')
    FFX_ObjectSetAttr(char,'invPoints',power+bip)

def gainDamageAura(char,targets,array):
    if len(targets)>0:
        intensity=(len(targets)-3)*0.5
        if intensity>2:
            intensity=2
        Trigger_Explosion(char,'generic electrical explosion',intensity)
    
###!Ep 2006-02-05  used by FFX_SYMBIOTE_CUSTOM
def gainStateEnergized(char,targets,array):
    duration = 2 + (3 * len(targets))
    Object_SetSecondaryState(char, SCSTATE_ENERGIZED, duration, 0)

def playSynergyFX(char,array):
    if FFX_ObjectGetAttr(char,'synfx',0)==0:
        FFX_ObjectSetAttr(char,'synfx',1)
        RegTimer('restoreSynFX',1,0,char)
        fx=getByTemplate(char,array,3)
        if fx!='':
            Object_PlayEffect(char,fx,'',FX_TRACK_OBJECT_FULL)

def restoreSynFX(event):
    char=event.object
    FFX_ObjectSetAttr(char,'synfx',0)

def playSynergyFXonTargets(char,targets,array):
    if FFX_ObjectGetAttr(char,'synfx2',0)==0:
        FFX_ObjectSetAttr(char,'synfx2',1)
        RegTimer('restoreSynFX2',1,0,char)
        fx=getByTemplate(char,array,4)
        if fx!='':
            for target in targets:
                Object_PlayEffect(target,fx,'',FX_TRACK_OBJECT_FULL)

def restoreSynFX2(event):
    char=event.object
    FFX_ObjectSetAttr(char,'synfx2',0)

def antiSpeedAura(char,targets,array):
    for target in targets:
        Object_SetPrimaryState(target,3,2,0)
    #make the character dissappear if no speedsters are around
    go=1
    for obj in Mission_GetDynamicObjects():
        if obj!=char and Object_GetClass(obj)&FFX_CHARACTER:
            if isNotSpeedster(obj,'')==0 and Object_IsAlive(obj) and Object_GetAttr(obj,'physical')!=0:
                go=0
    if go!=0:
        Object_SetPrimaryState(char,3,10,0)
        RegTimer('destroyTemp',3,0,char)

##### unpleasant states for vulnerability and dependence ############

def loseStrength(char,targets,array,flip=0):
    power=getVDPower(targets,flip)
    if power>0:
        playSynergyFX(char,array)
        FFX_SetStrength(char,-2)
    else:
        FFX_SetStrength(char,0)
    playSynergyFXonTargets(char,targets,array)

def loseInvulnerability(char,targets,array,flip=0):
    power=getVDPower(targets,flip)
    if power>0:
        playSynergyFX(char,array)
        FFX_ObjectSetAttr(char,'invPoints',0)
    else:
        bip=FFX_ObjectGetAttr(char,'baseInvPoints')
        FFX_ObjectSetAttr(char,'invPoints',bip)
    playSynergyFXonTargets(char,targets,array)

def loseFlightAndSpeed(char,targets,array,flip=0):
    power=getVDPower(targets,flip)
    if power>0:
        playSynergyFX(char,array)
        Object_SetGenericState(char,OBJSTATE_DENSITY_CHANGE,5,0)
    playSynergyFXonTargets(char,targets,array)

def losePower(char,targets,array,flip=0):
    power=getVDPower(targets,flip)
    if power>0:
        playSynergyFX(char,array)
        Object_SetSecondaryState(char,SCSTATE_POWER_NULLIFICATION,5,0)
    playSynergyFXonTargets(char,targets,array)

def getWeakened(char,targets,array,flip=0):
    power=getVDPower(targets,flip)
    if power>0:
        playSynergyFX(char,array)
        Object_SetGenericState(char,OBJSTATE_ALTERED_STRUCTURE,5,0)
    playSynergyFXonTargets(char,targets,array)

def getHexed(char,targets,array,flip=0):
    power=getVDPower(targets,flip)
    if power>0:
        playSynergyFX(char,array)
        Object_SetSecondaryState(char,SCSTATE_HEXED,5,0)
    playSynergyFXonTargets(char,targets,array)

def getBlind(char,targets,array,flip=0):
    power=getVDPower(targets,flip)
    if power>0:
        playSynergyFX(char,array)
        Object_SetSecondaryState(char,SCSTATE_BLIND,5,0)
    playSynergyFXonTargets(char,targets,array)

def loseHealth(char,targets,array,flip=0):
    power=getVDPower(targets,flip)
    if power>0:
        playSynergyFX(char,array)
        # ###!Ep 2006-02-25 Exiled characters shouldn't get damaged by periodic health loss
        # (other damages while exiled may make sense, however, hence the patch here instead of in FFX_ApplyDamage())
        # Note that Possessor can't be added here, as SCSTATE_SPAWN doesn't register with Object_GetSecondaryStates()    
        if not isExiled(char):
            Trigger_Damage(char,power)
    playSynergyFXonTargets(char,targets,array)

def loseEnergy(char,targets,array,flip=0):
    power=getVDPower(targets,flip)
    if power>0:
        playSynergyFX(char,array)
        energy=Object_GetAttr(char,'energyPoints')
        Object_SetAttr(char,'energyPoints',energy-power*5)
    playSynergyFXonTargets(char,targets,array)

def theWorks(char,targets,array,flip=0):
    power=getVDPower(targets,flip)
    if power>0:
        playSynergyFX(char,array)
        FFX_ObjectSetAttr(char,'invPoints',0) #Ep. 2007-03-31: Added missing line
        FFX_SetStrength(char,-2)
        Object_SetGenericState(char,OBJSTATE_DENSITY_CHANGE,5,0)
        Object_SetSecondaryState(char,SCSTATE_POWER_NULLIFICATION,5,0)
        Trigger_Damage(char,power)
    else:
        bip=FFX_ObjectGetAttr(char,'baseInvPoints')
        FFX_ObjectSetAttr(char,'invPoints',bip)
        FFX_SetStrength(char,0)
    playSynergyFXonTargets(char,targets,array)

def loseSanity(char,targets,array,flip=0):
    power=getVDPower(targets,flip)
    if power>0:
        playSynergyFX(char,array)
        effect=FFX_Rand(1,10)
        if effect==1:
            Object_SetPrimaryState(char,PCSTATE_PANICKED,10,0)
        elif effect==2:
            Object_SetPrimaryState(char,PCSTATE_ENRAGED,10,0)
    playSynergyFXonTargets(char,targets,array)

def smallStunChance(char,targets,array,flip=0):
    power=getVDPower(targets,flip)
    if power>0:
        if randint(1,50)<power:
            Object_SetPrimaryState(char,PCSTATE_STUNNED,3,0)

def getVDPower(targets,flip):
    power=len(targets)
    if flip:
        if power==0:
            return 5
        else:
            return 0
    return power

####################### UNTOUCHABLE ########################################################

def inituntouchable2(char,update=0):
    print 'untouchable!'
    if update==0:
        RegTimer('handsOff',1,0,char)
        pos=Get_ObjectPos(char)
        FFX_ObjectSetAttr(char,'lastuY',pos[1])
        FFX_ObjectSetAttr(char,'lastuX',pos[0])
        FFX_ObjectSetAttr(char,'stillu',3)

def handsOff(event):
    char=event.object
    if Object_Exists(char)==0:
        return
    RegTimer('handsOff',1,0,char)
    if Object_IsAlive(char)==0: ###!
        return
    if cshelper.isPlaying():
        return
    #Mission_StatusText('%s:'%(FFX_ObjectGetAttr(char,'stillu')))
    pos=Get_ObjectPos(char)
    #if they've moved, then get out of here
    if (pos[0]!=FFX_ObjectGetAttr(char,'lastuX')) or (pos[1]!=FFX_ObjectGetAttr(char,'lastuY')):
        FFX_ObjectSetAttr(char,'lastuY',pos[1])
        FFX_ObjectSetAttr(char,'lastuX',pos[0])
        FFX_ObjectSetAttr(char,'stillu',0)
        return
    still=FFX_ObjectGetAttr(char,'stillu')
    if still<3:
        FFX_ObjectSetAttr(char,'stillu',still+1)
        return
    for target in Mission_GetDynamicObjects():
        if target!=char and Object_IsAlive(target):
            dir=Vector_Sub(Get_ObjectPos(target),pos)
            if (dir[0]*dir[0]+dir[1]*dir[1]+dir[2]*dir[2])<900:
                Trigger_Force(target,dir[0],dir[1],0.5,20000,TF_ABSOLUTE)

####################### CHAMELEON ########################################################

def initchameleon(char,update=0):
    if update==0:
        RegTimer('chamcheck',1,0,char)
        pos=Get_ObjectPos(char)
        FFX_ObjectSetAttr(char,'lastcY',pos[1])
        FFX_ObjectSetAttr(char,'lastcX',pos[0])
        FFX_ObjectSetAttr(char,'stillc',3)

def chamcheck(event):
    char=event.object
    if Object_Exists(char)==0:
        return
    RegTimer('chamcheck',0.5,0,char)
    if Object_IsAlive(char)==0: ###!
        return
    if cshelper.isPlaying():
        return
#    Mission_StatusText('%s:'%(FFX_ObjectGetAttr(char,'stillc')))
    pos=Get_ObjectPos(char)
    #if they've moved, then get out of here
    if (pos[0]!=FFX_ObjectGetAttr(char,'lastcX')) or (pos[1]!=FFX_ObjectGetAttr(char,'lastcY')):
        FFX_ObjectSetAttr(char,'lastcY',pos[1])
        FFX_ObjectSetAttr(char,'lastcX',pos[0])
        FFX_ObjectSetAttr(char,'stillc',0)
        makeUncloak(char)
        return
    still=FFX_ObjectGetAttr(char,'stillc')
    if still<3:
        FFX_ObjectSetAttr(char,'stillc',still+1)
        return
    makecloak(char,2)


####################### TRANSMUTATOR #######################################################

def inittransmutator(char,update=0):
    if isMP():
        return
    if update==0:
        for set in transmutables:
            if type(set[1]) == TupleType:
                for entry in set[1]:
                    Mission_CustomAction(set[0],char,entry,set[2],30,0)
            else:
                if set[1]=='all':
                    for temp in templates:
                        if isObject(temp[0]):
                           Mission_CustomAction(set[0],char,temp[0],set[2],30,0)
                if set[1]=='solid':
                    for temp in templates:
                        if isObject(temp[0]) and isSolid(temp[2]):
                           Mission_CustomAction(set[0],char,temp[0],set[2],30,0)
                elif set[1]=='metal':
                    for temp in templates:
                        if isObject(temp[0]) and temp[2]==1:
                           Mission_CustomAction(set[0],char,temp[0],set[2],30,0)
                elif set[1]=='throwable':
                    for temp in templates:
                        if isObject(temp[0]) and temp[1]!=FFX_TOO_HEAVY:
                           Mission_CustomAction(set[0],char,temp[0],set[2],30,0)
                elif set[1]=='stone':
                    for temp in templates:
                        if isObject(temp[0]) and temp[2]==2:
                           Mission_CustomAction(set[0],char,temp[0],set[2],30,0)
                else:
                    Mission_CustomAction(set[0],char,set[1],set[2],30,0)

#true if the material passed is not energy, fire or air
def isSolid(mat):
    return mat<4 or mat>6

def isObject(temp):
    if Template_Exists(temp)==0:
        print '%s:no such template exists!'%(temp)
        return
    cls=Template_GetClassString(temp)
    return cls=='GAME_OBJ_GENERIC' or cls=='GAME_OBJ_VEHICLE'

def OnTransmute(target,char,fn,param=''):
    if chargeEP(char,25)==0:
        return
    Trigger_Power(char,target,getByTemplate(char,FFX_TRANSMUTATOR_CUSTOM,1),'')
    RegTimer(fn,2,0,target,param)

def OnIncMass(target,char):
    OnTransmute(target,char,'OnIncMass2')

def OnIncMass2(event):
    target=event.object
    mass=Object_GetAttr(target,'mass')
    Object_SetAttr(target,'mass',mass*4)
    Object_SetAttr(target,'material',1)
    Trigger_Explosion(target,'ffx_stomp')

def OnDecMass(target,char):
    OnTransmute(target,char,'OnDecMass2')

def OnDecMass2(event):
    target=event.object
    mass=Object_GetAttr(target,'mass')
    Object_SetAttr(target,'mass',mass*0.4)
    Object_SetAttr(target,'material',5)
    FFX_FactorHealth(target,0.33)

def OnAcidGas(target,char):
    OnTransmute(target,char,'OnAcidGas2')

def OnAcidGas2(event):
    target=event.object
    Trigger_Explosion(target,'ffx_gaseousform')
    damage=randint(3,6)
    Trigger_Damage(target,damage)
    if Object_IsAlive(target):
        if event.user<3:
            RegTimer('OnAcidGas2',2,event.user+1,target)

def OnHarmlessGas(target,char):
    OnTransmute(target,char,'OnHarmlessGas2')

def OnHarmlessGas2(event):
    target=event.object
    Object_PlayEffect(target,'effect_ffx_pheremones')
    damage=randint(3,7)
    Trigger_Damage(target,damage)
    if Object_IsAlive(target):
        if event.user<4:
            RegTimer('OnHarmlessGas2',2,event.user+1,target)

def OnFlashGas(target,char):
    OnTransmute(target,char,'OnFlashGas2')

def OnFlashGas2(event):
    target=event.object
    Object_PlayEffect(target,'effect_ffx_pheremones')
    if event.user==0:
        RegTimer('OnFlashGas2',2,1,target)
    else:
        Trigger_Damage(target,randint(3,12))
        Trigger_Explosion(target,'liberty Stun Grenade')

def OnMakeUranium(target,char):
    OnTransmute(target,char,'OnMakeUranium2')

def OnMakeUranium2(event):
    target=event.object
    Object_PlayEffect(target,'effect_ffx_density')
    if event.user==0:
        RegTimer('OnMakeUranium2',2,1,target)
    else:
        Trigger_Damage(target,100)
        Trigger_Explosion(target,'ffx_ex_rad_large')

def OnHeatExplode(target,char):
    OnTransmute(target,char,'OnHeatExplode2')

def OnHeatExplode2(event):
    target=event.object
    Trigger_Explosion(target,'generic fire explosion large')
    Trigger_Damage(target,100)

def OnTurnIntoMineral(target,char):
    OnTurnInto(target,char,'alien_mineral')

def OnTurnInto(target,char,template):
    OnTransmute(target,char,'OnTurnInto2',template)

def OnTurnInto2(event):
    target=event.object
    newForm=event.string
    name=getDummyName()
    cshelper.spawn(name,newForm,target)
    RegTimer('destroyTemp',1,0,target)

def OnMakeHydrogen(target,char):
    OnTransmute(target,char,'OnMakeHydrogen2')

def OnMakeHydrogen2(event):
    target=event.object
    pos=Get_ObjectPos(target)
    hp=Object_GetAttr(target,'health')
    hp=hp-FFX_Rand(6,12)
    if hp<0:
        RegTimer('destroyTemp',1,0,target)
    elif event.user<2:
        RegTimer('OnMakeHydrogen2',2,event.user+1,target)
    name=getDummyName()
    cshelper.spawn(name,'ffx_hydrogen',(pos[0]+FFX_Rand(-30,30),pos[1]+FFX_Rand(-30,30),pos[2]+5))
    Object_PlayEffect(name,'effect_ffx_pheremones','',FX_LOOP|FX_TRACK_OBJECT_POS)
    RegTimer('destroyTemp',12,0,name)

def OnShortOut(target,char):
    OnTransmute(target,char,'OnShortOut2')

def OnShortOut2(event):
    target=event.object
    if Object_GetAttr(target,'health')<=0:
        return
    obj='cu%s'%(target)
    if Object_Exists(obj):
        Trigger_Explosion(obj,'generic electrical explosion')
    else:
        cshelper.spawn(obj,'portal_start_proxy',target)
    RegTimer('OnShortOut2',2,0,target)

def initassimilator(char,update=0):
    if isMP():
        return
    if update==0:
        for set in assimilations:
            if type(set[1]) == TupleType:
                for entry in set[1]:
                    Mission_CustomAction('CUSTOM_ASSIM',char,entry,set[2],4,0)
            else:
                Mission_CustomAction('CUSTOM_ASSIM',char,set[1],set[2],4,0)
    RegTimer('AssimUpdate',1,0,char)

def AssimUpdate(event):
    char=event.object
    if Object_Exists(char)==0:
        return
    RegTimer('AssimUpdate',1,0,char)
    for set in assimilations:
        if set[3]!='':
            charges=FFX_ObjectGetAttr(char,set[0])
            if charges>0:
                addCommand(set[3],char,set[4],30,1)
            else:
                removeCommand(set[3],char)

def OnHeadlamp(target,char):
    Trigger_Power(char,target,'ffx_transmute','')
    Trigger_Damage(target,randint(0,20))
    charges=FFX_ObjectGetAttr(char,'headlamp')+4
    FFX_ObjectSetAttr(char,'headlamp',charges)
    handle=FFX_ObjectGetAttr(char,'fx_headlamp',-1)
    if handle<=0:
        handle=Object_PlayEffect(char,'effect_ffx_borgarm','',11,0,'Bip01 Head')
        FFX_ObjectSetAttr(char,'fx_headlamp',handle)
        addCommand('ffx_flash',char,'onAssimFlash',30,0)

def onAssimFlash(target,char):
    charges=FFX_ObjectGetAttr(char,'headlamp')-1
    FFX_ObjectSetAttr(char,'headlamp',charges)
    if charges==0:
        handle=FFX_ObjectGetAttr(char,'fx_headlamp')
        Object_StopEffect(char,handle)
        FFX_ObjectSetAttr(char,'fx_headlamp',-1)
    Trigger_Power(char,target,'ffx_flash','')

def OnFiremitts(target,char):
    Trigger_Power(char,target,'ffx_transmute','')
    Trigger_Damage(target,randint(0,20))
    charges=FFX_ObjectGetAttr(char,'firemitts')+4
    FFX_ObjectSetAttr(char,'firemitts',charges)
    handle=FFX_ObjectGetAttr(char,'fx_firemitts',-1)
    if handle<=0:
        handle=Object_PlayEffect(char,'effect_ffx_borgbox','',11,0,'Bip01 R Hand')
        FFX_ObjectSetAttr(char,'fx_firemitts',handle)
        addCommand('ffx_flamethrower',char,'onAssimFlame',30,0)

def onAssimFlame(target,char):
    charges=FFX_ObjectGetAttr(char,'firemitts')-1
    FFX_ObjectSetAttr(char,'firemitts',charges)
    if charges==0:
        handle=FFX_ObjectGetAttr(char,'fx_firemitts')
        Object_StopEffect(char,handle)
        FFX_ObjectSetAttr(char,'fx_firemitts',-1)
    Trigger_Power(char,target,'ffx_flamethrower','')

def OnWaterhose(target,char):
    Trigger_Power(char,target,'ffx_transmute','')
    Trigger_Damage(target,randint(0,20))
    charges=FFX_ObjectGetAttr(char,'waterhose')+4
    FFX_ObjectSetAttr(char,'waterhose',charges)
    handle=FFX_ObjectGetAttr(char,'fx_waterhose',-1)
    if handle<=0:
        handle=Object_PlayEffect(char,'effect_ffx_borgarm','',11,0,'Bip01 L ForeArm')
        FFX_ObjectSetAttr(char,'fx_waterhose',handle)
        addCommand('ffx_water_jet',char,'onAssimWaterhose',30,0)

def onAssimWaterhose(target,char):
    charges=FFX_ObjectGetAttr(char,'waterhose')-1
    FFX_ObjectSetAttr(char,'waterhose',charges)
    if charges==0:
        handle=FFX_ObjectGetAttr(char,'fx_waterhose')
        Object_StopEffect(char,handle)
        FFX_ObjectSetAttr(char,'fx_waterhose',-1)
    Trigger_Power(char,target,'ffx_water_jet','')

def initterraformer(char,update=0):
    RegTimer('terraform',1,0,char)

def terraform(event):
    char=event.object
    if Object_Exists(char)==0:
        return
    RegTimer('terraform',1,0,char)
    if Object_IsAlive(char)==0:
        return
    terra=[]
    exec('terra=%s'%(getByTemplate(char,FFX_TERRAFORMER_CUSTOM,1)))
    fx=getByTemplate(char,FFX_TERRAFORMER_CUSTOM,2)
    pos=Get_ObjectPos(char)
    count=randint(1,9)
    #Ep./Kuertee 2006-09-10: Prevent the map itself (whose template is '') from appearing in that list
    staticObjects = list( Mission_GetObjects() )
    staticObjects.remove( Object_GetTerrain() )
    for o in staticObjects:
      count=count+1
      if count>=9:
        count=0
      if count==0:
        t=Object_GetTemplate(o)
        for set in terra:
            if set[0]==t:
                p=Get_ObjectPos(o)
                dx=p[0]-pos[0]
                dy=p[1]-pos[1]
                if (dx*dx+dy*dy)<90000:
                    name=getDummyName()
                    spawn(name,set[1],o)
                    alignWith(name,o)
                    Object_PlayEffect(name,fx)
                    Object_Destroy(o)

def initabsorptiona(char,update=0):
    cmd=getByTemplate(char,FFX_ABSORPTIONA_CUSTOM,6)
    Mission_CustomAction(cmd,char,char,'OnActiveFeedback',5,0)

def OnActiveFeedback(dummy,char):
    if chargeEP(char,15)==0:
        return
    AI_Animate(char,'area','OnActiveFeedback2')

def OnActiveFeedback2(event):
    char=event.object
    RegTimer('FeedBackAction',2,6,char)

def initsuperfriction(char,update=0):
    RegTimer('frictionCheck',0.5,0,char)

def frictionCheck(event):
    char=event.object
    if Object_Exists(char)==0:
        return
    RegTimer('frictionCheck',0.03,0,char)
    if Object_IsAlive(char)==0:
        return
    if Object_GetAttr(char,'speed')>2*Object_GetAttr(char,'baseSpeed'):
        name=getDummyName()
        spawn(name,'ffx_flames',char)
        Object_PlayEffect(name,'effect_ffx_flames2','',FX_LOOP)
        RegTimer('OnFlames',1,2,name)

####################### WRAITH ##############################

def initwraith(char,update=0):
    RegTimer('wraithCheck',0.1,0,char)

def wraithCheck(event):
    char=event.object
    makephase(char,5)
    RegTimer('wraithCheck',4,0,char)

####################### UTILITY BELT ##################################

arrows=('ffx_arrow_bomb','ffx_arrow_smoke','ffx_arrow_net','ffx_arrow_punch','ffx_arrow_boomerang','ffx_arrow_tranq')
utils=('bomb','mine','medpack','tracker','laser','cuffs')
utilOffset=((0,30),(20,15),(-20,15),(0,-30),(20,-15),(-20,-15))

def initutilitybelt(char,update=0):
    initgadgets(char,update,utils)

def inittrickshot(char,update=0):
    initgadgets(char,update,arrows)

def initgadgets(char,update,array):
    if isMP():
        return
    pos=Get_ObjectPos(char)
    if update==0:
        FFX_ObjectSetAttr(char,'utils',0)
        index=0
        for util in array:
            FFX_ObjectSetAttr(char,util,0)
            name='%s_u%d'%(char,index)
            i=int(index)
            template=util
            if template[:9]!='ffx_arrow':
                template='ffx_util_%s'%(template)
            cshelper.spawn(name,template,(pos[0]+utilOffset[i][0],pos[1]+utilOffset[i][1],pos[2]+5))
            index=index+1
            Mission_CustomAction('CUSTOM_EQUIP',char,name,'OnEquip',4,0)

#pick up an object and stash it in belt
def OnEquip(target,char):
    utils=FFX_ObjectGetAttr(char,'utils')
    utils=utils+1
    Object_Destroy(target)
    template=Object_GetTemplate(target)
    if template[:9]=='ffx_arrow':
        equipffx_arrow(char,template)
    else:
        exec 'equip%s(char)'%(template)
    if utils==3:
        for i in range(0,6):
            obj='%s_u%d'%(char,i)
            if Object_Exists(obj):
                Object_Destroy(obj)
    else:
        FFX_ObjectSetAttr(char,'utils',utils)

### trick arrows ################

def equipffx_arrow(char,arrow):
    FFX_ObjectSetAttr(char,'c%s'%(arrow),3)
    addCommand(arrow,char,'onThrow%s'%(arrow),30,0)
    RegTimer('arrowcheck',1,0,char,arrow)

def arrowcheck(event):
    char=event.object
    arrow=event.string
    if Object_Exists(char)==0:
        return
    if FFX_ObjectGetAttr(char,'c%s'%(arrow))<=0:
        removeCommand(arrow,char)
    else:
        addCommand(arrow,char,'onThrow%s'%(arrow),30,1)
        RegTimer('arrowcheck',1,0,char,arrow)

def onThrowffx_arrow_bomb(target,char):
    onThrowArrow(target,char,'ffx_arrow_bomb')

def onThrowffx_arrow_smoke(target,char):
    onThrowArrow(target,char,'ffx_arrow_smoke')

def onThrowffx_arrow_net(target,char):
    onThrowArrow(target,char,'ffx_arrow_net')

def onThrowffx_arrow_punch(target,char):
    onThrowArrow(target,char,'ffx_arrow_punch')

def onThrowffx_arrow_boomerang(target,char):
    onThrowArrow(target,char,'ffx_arrow_boomerang')

def onThrowffx_arrow_tranq(target,char):
    onThrowArrow(target,char,'ffx_arrow_tranq')

def onThrowArrow(target,char,arrow):
    attr='c%s'%(arrow)
    charges=FFX_ObjectGetAttr(char,attr)-1
    Trigger_Power(char,target,arrow,'')
    FFX_ObjectSetAttr(char,attr,charges)

######### done ##################

def equipffx_util_bomb(char):
    FFX_ObjectSetAttr(char,'smokebombs',3)
    addCommand('ffx_smoke_bomb',char,'onThrowSmokeBomb',30,0)
    RegTimer('smokebombcheck',1,0,char)

def smokebombcheck(event):
    char=event.object
    if Object_Exists(char)==0:
        return
    if FFX_ObjectGetAttr(char,'smokebombs')<=0:
        removeCommand('ffx_smoke_bomb',char)
    else:
        addCommand('ffx_smoke_bomb',char,'onThrowSmokeBomb',30,1)
        RegTimer('smokebombcheck',1,0,char)

def onThrowSmokeBomb(target,char):
    charges=FFX_ObjectGetAttr(char,'smokebombs')-1
    Trigger_Power(char,target,'ffx_smoke_bomb','')
    FFX_ObjectSetAttr(char,'smokebombs',charges)

def equipffx_util_laser(char):
    FFX_ObjectSetAttr(char,'lasers',2)
    addCommand('ffx_laser_torch',char,'onLaserTorch',7,0)
    RegTimer('lasertorchcheck',1,0,char)

def lasertorchcheck(event):
    char=event.object
    if Object_Exists(char)==0:
        return
    if FFX_ObjectGetAttr(char,'lasers')<=0:
        removeCommand('ffx_laser_torch',char)
    else:
        addCommand('ffx_laser_torch',char,'onLaserTorch',7,1)
        RegTimer('lasertorchcheck',1,0,char)

def onLaserTorch(target,char):
    charges=FFX_ObjectGetAttr(char,'lasers')-1
    Mission_StatusText('charges=%d'%(charges))
    Trigger_Power(char,target,'ffx_laser_torch','')
    FFX_ObjectSetAttr(char,'lasers',charges)

def equipffx_util_cuffs(char):
    FFX_ObjectSetAttr(char,'cuffs',2)
    addCommandChars('CUSTOM_CUFF',char,'onHandCuff',7,0,char)
    RegTimer('handcuffcheck',1,0,char)

def handcuffcheck(event):
    char=event.object
    if Object_Exists(char)==0:
        return
    if FFX_ObjectGetAttr(char,'cuffs')<=0:
        removeCommandChars('CUSTOM_CUFF',char)
    else:
        addCommandChars('CUSTOM_CUFF',char,'onHandCuff',7,1,char)
        RegTimer('handcuffcheck',1,0,char)

def onHandCuff(target,char):
    Trigger_Power(char,target,'ffx_cuffs','onCuffCheck')

def onCuffCheck(event):
    char=event.string # the user
    target=event.object
    if Object_GetPrimaryState(target)==PCSTATE_STATIC:
        charges=FFX_ObjectGetAttr(char,'cuffs')-1
        FFX_ObjectSetAttr(char,'cuffs',charges)
        js.AI_NullController(char)

def equipffx_util_medpack(char):
    FFX_ObjectSetAttr(char,'meds',3)
    addCommandChars('CUSTOM_MPHEAL',char,'onMedPack',5,0)
    RegTimer('medpackcheck',1,0,char)

def medpackcheck(event):
    char=event.object
    if Object_Exists(char)==0:
        return
    if FFX_ObjectGetAttr(char,'meds')<=0:
        removeCommandChars('CUSTOM_MPHEAL',char)
    else:
        addCommandChars('CUSTOM_MPHEAL',char,'onMedPack',5,1)
        RegTimer('medpackcheck',1,0,char)

def onMedPack(target,char):
    charges=FFX_ObjectGetAttr(char,'meds')-1
    FFX_ObjectSetAttr(char,'meds',charges)
    if (target!=char):
        cshelper.turnTo(target,char)
        cshelper.turnTo(char,target)
    if Object_GetSecondaryStates(target)&(SCSTATE_IRRADIATED|SCSTATE_ACID_BURNT):
        Object_SetSecondaryState(target,SCSTATE_IRRADIATED,0,REMOVE_STATE)
        Object_SetSecondaryState(target,SCSTATE_ACID_BURNT,0,REMOVE_STATE)
    else:
        heal=-FFX_Rand(6,16)
        Trigger_Damage(target,heal)

def equipffx_util_tracker(char):
    FFX_ObjectSetAttr(char,'scans',2)
    Mission_CustomAction('CUSTOM_UTILSCAN',char,char,'OnUtilScan',4,0)

def OnUtilScan(dummy,char):
    charges=FFX_ObjectGetAttr(char,'scans')-1
    FFX_ObjectSetAttr(char,'scans',charges)
    if charges==0:
        Mission_RemoveCustomAction('CUSTOM_UTILSCAN',char,char)
    OnScan(char,char)

def equipffx_util_mine(char):
    FFX_ObjectSetAttr(char,'mines',4)
    FFX_ObjectSetAttr(char,'mdrop',0)
    addCommand('CUSTOM_DROP_MINE',char,'OnDropMine',5,0)
    RegTimer('limpetminecheck',1,0,char)

def limpetminecheck(event):
    char=event.object
    if Object_Exists(char)==0:
        return
    if FFX_ObjectGetAttr(char,'mines')<=0:
        removeCommand('CUSTOM_DROP_MINE',char)
    else:
        addCommand('CUSTOM_DROP_MINE',char,'OnDropMine',5,1)
        RegTimer('limpetminecheck',1,0,char)

def OnDropMine(target,char):
    charges=FFX_ObjectGetAttr(char,'mines')-1
    FFX_ObjectSetAttr(char,'mines',charges)
    drop=FFX_ObjectGetAttr(char,'mdrop')
    if drop==0:
        Mission_CustomAction('CUSTOM_DETONATE',char,char,'OnDetonate',4,0)
    drop=drop+1
    FFX_ObjectSetAttr(char,'mdrop',drop)
    name='%sm%d'%(char,drop)
    cshelper.spawn(name,'ffx_limpetmine',target)

def OnDetonate(dummy,char):
    FFX_ObjectSetAttr(char,'mdrop',0)
    for i in range (0,4):
        name='%sm%d'%(char,i)
        if Object_Exists(name):
            cshelper.kill(name)
    Mission_RemoveCustomAction('CUSTOM_DETONATE',char,char)

####################### WEAPONBEARER #######################################################

def initweaponbearer(char,update=0):
    if isMP():
        return
    weapon1=getByTemplate(char,FFX_WEAPONMASTER_CUSTOM,2)
    if Template_Exists(weapon1):
        name=getDummyName()
        cshelper.spawn(name,weapon1,(3000,3000,0))
        shots=Object_GetAttr(name,'maxEnergyPoints')
        RegTimer('destroyTemp',1,0,name)
        FFX_ObjectSetAttr(char,'shots1',shots)
        addWeaponDraw(char,1)
    weapon1=getByTemplate(char,FFX_WEAPONMASTER_CUSTOM,4)
    if Template_Exists(weapon1):
        name=getDummyName()
        cshelper.spawn(name,weapon1,(3000,3000,0))
        shots=Object_GetAttr(name,'maxEnergyPoints')
        RegTimer('destroyTemp',1,0,name)
        FFX_ObjectSetAttr(char,'shots2',shots)
        addWeaponDraw(char,2)
    weapon1=getByTemplate(char,FFX_WEAPONMASTER_CUSTOM,6)
    if Template_Exists(weapon1):
        name=getDummyName()
        cshelper.spawn(name,weapon1,(3000,3000,0))
        shots=Object_GetAttr(name,'maxEnergyPoints')
        RegTimer('destroyTemp',1,0,name)
        FFX_ObjectSetAttr(char,'shots3',shots)
        addWeaponDraw(char,3)

def addWeaponDraw(char,index):
    cmd=getByTemplate(char,FFX_WEAPONMASTER_CUSTOM,index*2-1)
    Mission_CustomAction(cmd,char,char,'OnDrawWeapon%s'%(index),4,0)

def OnDrawWeapon1(dummy,char):
    OnDrawWeapon(char,1)
def OnDrawWeapon2(dummy,char):
    OnDrawWeapon(char,2)
def OnDrawWeapon3(dummy,char):
    OnDrawWeapon(char,3)

#draw weapon from 'coat'
def OnDrawWeapon(char,index):
    cmd=getByTemplate(char,FFX_WEAPONMASTER_CUSTOM,index*2-1)
    Mission_RemoveCustomAction(cmd,char,char)
    #drop any weapon you're holding weapons
    FFX_OnDropWeapon('',char)
    #spawn the weapon at users feet
    name=getDummyName()
    temp=getByTemplate(char,FFX_WEAPONMASTER_CUSTOM,index*2)
    cshelper.spawn(name,temp,char)
    #set the ammo to the users 'personal' value
    ammoAttr='shots%d'%(index)
    ammo=FFX_ObjectGetAttr(char,ammoAttr)
    FFX_ObjectSetAttr(char,ammoAttr,0)
    Object_SetAttr(name,'maxEnergyPoints',ammo)
    #pick up the weapon immediately and allow the user to stash it again
    FFX_OnUseWeapon(name,char)

#withdraw weapon back into your 'coat'
def OnSheatheWeapon(dummy,char):
    for type in FFX_Weapons:
        amstat='a%s'%(type[0])
        ammo=FFX_ObjectGetAttr(char,amstat)
        if ammo!=0:
            #find index
            index=-1
            if type[0]==getByTemplate(char,FFX_WEAPONMASTER_CUSTOM,2):
                index=1
            if type[0]==getByTemplate(char,FFX_WEAPONMASTER_CUSTOM,4):
                index=2
            if type[0]==getByTemplate(char,FFX_WEAPONMASTER_CUSTOM,6):
                index=3
            if index==-1:
                print 'I dont know what to sheathe!'
                return
            FFX_ObjectSetAttr(char,'shots%d'%(index),ammo)
            #remove all commands from the weapon
            removeWeaponPowers(type,char)
            handle=int(FFX_ObjectGetAttr(char,'fx%s'%(type[0])))
            Object_StopEffect(char,handle)
            Object_SetAttr(char,'ffxArmed',0)
            AddWeaponCommands(char)
            FFX_ObjectSetAttr(char,amstat,0)
            #restore the command to draw it
            addWeaponDraw(char,index)
            Mission_RemoveCustomAction('CUSTOM_SHEATHE',char,char)

######################### LIGHT CONTROL ###################################

def initlightcontrol(char,update=0):
    Mission_CustomAction('CUSTOM_DARKEN',char,char,'OnDarken',5,0)
    Mission_CustomAction('CUSTOM_LIGHTEN',char,char,'OnLighten',5,0)

def OnDarken(dummy,char):
    doLight(char,'Darken2')
    Mission_SetAttr('directBase',0.3)
    Mission_SetAttr('ambientBase',0.1)

def OnLighten(dummy,char):
    doLight(char,'Lighten2')
    Mission_SetAttr('directBase',4)
    Mission_SetAttr('ambientBase',4)

def OnRestoreLight(dummy,char):
    doLight(char,'RestoreLight2')
    Mission_SetAttr('directBase',Mission_GetAttr('directLevel'))
    Mission_SetAttr('ambientBase',Mission_GetAttr('ambientLevel'))

def Lighten2(event):
    char=event.object
    Mission_CustomAction('CUSTOM_DARKEN',char,char,'OnDarken',5,0)
    Mission_CustomAction('CUSTOM_RESTORELIGHT',char,char,'OnRestoreLight',5,0)

def Darken2(event):
    char=event.object
    Mission_CustomAction('CUSTOM_LIGHTEN',char,char,'OnLighten',5,0)
    Mission_CustomAction('CUSTOM_RESTORELIGHT',char,char,'OnRestoreLight',5,0)

def RestoreLight2(event):
    char=event.object
    Mission_CustomAction('CUSTOM_DARKEN',char,char,'OnDarken',5,0)
    Mission_CustomAction('CUSTOM_LIGHTEN',char,char,'OnLighten',5,0)

def doLight(char,fn):
    FFX_Animate(char,getByTemplate(char,FFX_LIGHTCONTROL_CUSTOM,1))
    Object_PlayEffect(char,getByTemplate(char,FFX_LIGHTCONTROL_CUSTOM,2))
    Mission_RemoveCustomAction('CUSTOM_RESTORELIGHT',char,char)
    Mission_RemoveCustomAction('CUSTOM_DARKEN',char,char)
    Mission_RemoveCustomAction('CUSTOM_LIGHTEN',char,char)
    Mission_SetAttr('lightStep',0.3)
    RegTimer(fn,1,0,char)

####################### NEW 'OFFICIAL' ATTRIBUTES GO HERE ##################################

####################### IRRATIONAL ATTRIBUTES MIMICKED THROUGH SCRIPT #####################

# Other scripted attributes under the FFQ section

def initfasthealing(char,update=0):
    if update==0:
        FFX_ObjectSetAttr(char,'sparehp',100)
        RegTimer('fasthealcheck',5,0,char)

def fasthealcheck(event):
    char=event.object
    if Object_Exists(char)==0:
        return
    RegTimer('fasthealcheck',5,0,char)
    if Object_IsAlive(char)==0: ###!
        return
    hp=Object_GetAttr(char,'health')
    maxhp=Object_GetAttr(char,'maxHealth')
    sparehp=FFX_ObjectGetAttr(char,'sparehp')
    repair=maxhp-hp
    healingFactor=ff.RPG_FAST_HEAL_RATE ###! should be 5 by default
    if repair<=0:
        return
    if repair>healingFactor:
        repair=healingFactor
    if repair>sparehp:
        repair=sparehp
    if repair>0:
        Object_SetAttr(char,'health',hp+repair)
        FFX_ObjectSetAttr(char,'sparehp',sparehp-repair)

###! Ep. 2006-04-28: added removability
def initheroic(char,update=0,remove=0):
    if remove:
        if FFX_ObjectGetAttr(char,'heroic'):
            FFX_ObjectSetAttr(char,'heroic',0)
            hp=Object_GetAttr(char,'heroPoints')
            if hp > 0:
                Object_SetAttr(char,'heroPoints',hp-1)
    elif update==0 and not FFX_ObjectGetAttr(char,'heroic') and not Character_HasAttribute(char,'heroic'):
        FFX_ObjectSetAttr(char,'heroic',1)
        hp=Object_GetAttr(char,'heroPoints')
        Object_SetAttr(char,'heroPoints',hp+1)

###! Ep. 2006-04-28: added removability
def initextraheroic(char,update=0,remove=0):
    if remove:
        if FFX_ObjectGetAttr(char,'extraheroic'):
            FFX_ObjectSetAttr(char,'extraheroic',0)
            hp=Object_GetAttr(char,'heroPoints')
            if hp > 0:
                Object_SetAttr(char,'heroPoints',hp-1)
    elif update==0 and not FFX_ObjectGetAttr(char,'extraheroic') and not Character_HasAttribute(char,'extraheroic'):
        FFX_ObjectSetAttr(char,'extraheroic',1)
        hp=Object_GetAttr(char,'heroPoints')
        Object_SetAttr(char,'heroPoints',hp+1)

def initunheroic(char,update=0):
    if update==0:
        hp=Object_GetAttr(char,'heroPoints')
        if hp > 0: ###! in case attribute is added to a character having the built-in version already
            Object_SetAttr(char,'heroPoints',hp-1)

# stumpy: revising to fix bug where the 10% HP penalty is
# cumulative when moving from map to map in Patriot City. Also
# prevents cheating by re-use of the attribute to get a high agility
# cheaply.
###! Ep 2006-04-28: removed invalid value in "and not FFX_ObjectGetAttr(char,'nimble',0)"
# stumpy 2008-02-29: This still wasn't working right for freeroam
# campaigns (weird interaction w/ffqresilient, etc.), so I took
# another approach to avoid the guessing games for a character's
# health. Basically, in a freeroam mission, if the heroStates are
# populated, then the character just left another map and freeroam
# has already set his health to the value from the last map.
def initnimble(char,update=0,remove=0):
    if remove:
        if FFX_ObjectGetAttr(char,'nimble'):
            FFX_ObjectSetAttr(char,'nimble',0)
            baseHealth = GetBaseHealth(char)
            maxHealth = Object_GetAttr(char,'maxHealth')
            hp = Object_GetAttr(char,'health')
            Object_SetAttr(char,'health',hp/0.90)
            Object_SetAttr(char,'maxHealth',maxHealth/0.90)
            tempag = Object_GetAttr(char,'templateAgility')
            Object_SetAttr(char,'agility', Object_GetAttr(char,'agility')-3)
            Object_SetAttr(char,'templateAgility',tempag-3)
        return
    if update==0 and not FFX_ObjectGetAttr(char,'nimble') and not Character_HasAttribute(char,'nimble'):
        FFX_ObjectSetAttr(char,'nimble',1)
        # check that this wasn't already changed by FFX in an earlier freeroam map and already lowered
        ##if Object_GetAttr(char,'maxHealth') >= GetBaseHealth(char) + ('ffqresilient' in getAttributes(char))*30 :
        if ( 'freeroam_bonus' not in sys.modules.keys() )or \
           ( ( 'freeroam_bonus' in sys.modules.keys() ) and ( freeroam_bonus.heroStates==[] ) ):
            hp=Object_GetAttr(char,'health')*0.9
            Object_SetAttr(char,'health',hp)
            Object_SetAttr(char,'maxHealth',Object_GetAttr(char,'maxHealth')*0.9)
        ag=Object_GetAttr(char,'agility')+3
        if ag>13:   # disallow exceding the in-game NIMBLE/DANGER SENSE limits
            ag=13
        Object_SetAttr(char,'agility',ag)
        Object_SetAttr(char,'templateAgility',Object_GetAttr(char,'agility'))

# stumpy: revising to fix cumulative issue (see initnimble) allow
# and make the agility penalty 3 instead of 1. Prevents re-use (which
# would probably be by accident).
def initslowmoving(char,update=0,remove=0):
    if remove:
        if ( FFX_ObjectGetAttr(char,'slowmoving') ):
            FFX_ObjectSetAttr(char,'slowmoving',0)
            maxHealth = Object_GetAttr(char,'maxHealth')
            hp=Object_GetAttr(char,'health')/1.1
            Object_SetAttr(char,'health',hp)
            Object_SetAttr(char,'maxHealth',maxHealth/1.1)
            ag=Object_GetAttr(char,'templateAgility')+3
            Object_SetAttr(char,'agility',ag)
            Object_SetAttr(char,'templateAgility',ag)
        return
    if update==0 and ( not FFX_ObjectGetAttr(char,'slowmoving') ) \
       and ( not Character_HasAttribute(char,'slow moving') ):
        FFX_ObjectSetAttr(char,'slowmoving',1)
        maxHealth = Object_GetAttr(char,'maxHealth')     
        # check that this wasn't already changed by FFX in an earlier freeroam map and already lowered
        if ( 'freeroam_bonus' not in sys.modules.keys() )or \
           ( ( 'freeroam_bonus' in sys.modules.keys() ) and ( freeroam_bonus.heroStates==[] ) ):
            hp=Object_GetAttr(char,'health')*1.1
            Object_SetAttr(char,'health',hp)
            Object_SetAttr(char,'maxHealth',maxHealth*1.1)
        ag=Object_GetAttr(char,'agility')-3
        if ag<0:
            ag=0
        Object_SetAttr(char,'agility',ag)
        Object_SetAttr(char,'templateAgility',ag)

# *** stumpy: revising the scripted simulation of HEAVY LIFTER so that
# 1) the strength increase is *only* for lifting/throwing (preiously
# it was an exploit that was more powerful than the in-game version
# since it gave +3 strength all the time) and 2) it adds some speed to
# the character since it looks like the game determines the speed the
# character has while holding a heavy object with a scripted strength
# boost to be slower than if he really had that template strength or
# had the real HEAVY LIFTER.

# *** Maybe a change should be made to the CanThrow() function in
# m25generateai as well.  Can we reference FFX_ObjectGetAttr() in that
# module?

# the original function (basically)
##def initheavylifter(char,update=0):
##    if update==0:
##        str=Object_GetAttr(char,'strength')+3
##        if str>12:
##            str=12
##        Object_SetAttr(char,'strength',str)
##        Object_SetAttr(char,'baseStrength',str)
##        Object_SetAttr(char,'templateStrength',str)

def initheavylifter(char,update=0,remove=0):
    if remove:
        FFX_ObjectSetAttr(char,'heavylifter',0)
        CheckLiftableObjects(char, remove)
        return
    #Ep. 2007-03-24: Corrected stupid bug I introduced. Added delay so attribute would get registered correctly as it is checked in CheckLiftableObjects().
    #    2006-08-29: Encapsulated attribute detection for compatibility with new system; removed unused update=
    if not (hasAttribute(char, 'heavylifter') or hasAttribute(char, 'heavy lifter')):
        FFX_ObjectSetAttr(char,'heavylifter',1)
        RegTimer('OnHeavyLifter', 0.5, 0, char)

def OnHeavyLifter(event):
    char = event.object
    CheckLiftableObjects(char)

# Run this initially and periodically to see if new throwable objects need to be added.
# stumpy 2006-09-12: We could potentially trigger this as a regSpawnObject() sink.  Have to test for efficiency gain/loss.
def CheckLiftableObjects(event,remove=0):
    if isinstance(event,types.StringType):
        char = event
    else:
        char = event.object
    maxLiftableMass = getMaxLiftableMasses() #Ep. 2006-08-29: made into a function, as simlar code was used elsewhere
    strength = Object_GetAttr(char,'strength')
    liftStrength = strength + 3
    if liftStrength>12:
        liftStrength=12
    liftableMass = maxLiftableMass[int(strength)]
    newLiftableMass = maxLiftableMass[int(liftStrength)]
    throwable = filter(lambda o: Object_GetAttr(o,'throwable'),Mission_GetObjects())
    liftable = filter(lambda o,NLM=newLiftableMass: Object_GetAttr(o,'mass')<=NLM,throwable)
    liftable = filter(lambda o,LM=liftableMass: Object_GetAttr(o,'mass')>LM,liftable)
    if not ( ( ( hasAttribute(char, 'heavylifter') or hasAttribute(char, 'heavy lifter') ) == 0 ) or ( remove ) ):  # add lift commands
        for obj in liftable:
            Mission_RemoveCustomAction('Pickup',char,obj)
            Mission_CustomAction('Pickup',char,obj,'HeavyLift',2000,0)
        RegTimer('CheckLiftableObjects',5,0,char)
    else:   # remove the lift commands from these objects
        for obj in liftable:
            Mission_RemoveCustomAction('Pickup',char,obj)

# The command is given to pickup an object
def HeavyLift(object,char):
    Object_SetVar(char,'pickup_obj',object)
    Trigger_Move(char, 'move', Get_ObjectPos(object), 'HeavyLift2', 22)

# Char gets to the object
def HeavyLift2(event):
    char = event.object
    object = Object_GetVar(char,'pickup_obj')
    if Object_Exists(object) and ( Object_GetPrimaryState(char) == PCSTATE_NORMAL ):
        Trigger_Pickup(char, object, 'HeavyLift3')

# The object is picked up
def HeavyLift3(event):
    char = event.string
    object = event.object
    cpos = Get_ObjectPos(char)
    opos = Get_ObjectPos(object)
    Object_SetVar(char,'zdist',opos[2]-cpos[2])
    str=Object_GetAttr(char,'strength')+3
    Object_SetAttr(char,'preLiftStrength',str-3)
    if str>12:
        str=12
    Object_SetAttr(char,'strength',str)
    spd=Object_GetAttr(char,'speed')+5
    Object_SetAttr(char,'preLiftSpeed',spd-5)
    Object_SetAttr(char,'speed',spd)
    Event_RegisterSink(EVENT_THROW, 'HeavyLiftOver', char)
    RegTimer('HeavyLiftCheck',3,0,char)

# The object is thrown. Note that this passes its work to a timed
# HeavyLifter4 since 1) there are *lots* of false throw events and 2)
# if you lower the char's strength right when this event triggers, the
# throw is calculated using the lowered strength (and he drops it just
# past his feet), so we need to wait a little.
# NB: Though in theory it is more elegant, the EVENT_THROW sink is so
# unreliable we could probably just use HeavyLiftCheck() by itself.
# The temptation to add a regPickup() and regThrow() into
# mlogreader.py is very strong, but that poor module is working
# overtime as it is.
def HeavyLiftOver(event):
    char = event.object
    RegTimer('HeavyLift4',0.5,0,char)

# Check if the object was really thrown and, if so, return the char's strength to normal.
# Otherwise reset the EVENT_THROW sink
def HeavyLift4(event):
    char = event.object
    object = Object_GetVar(char,'pickup_obj')
    dist = distance2D(Get_ObjectPos(char),Get_ObjectPos(object))
    if dist > 40:
        ##print 'HeavyLift4: %s really threw %s (dist=%f)' % (char,object,dist)
        Object_SetVar(char,'pickup_obj','')
        Object_SetAttr(char,'strength',Object_GetAttr(char,'preLiftStrength'))
        Object_SetAttr(char,'speed',Object_GetAttr(char,'preLiftSpeed'))
    else:   # false sink trigger, re-register
        ##print 'HeavyLift4: false throw by %s for %s (dist=%f)' % (char,object,dist)
        Event_RegisterSink(EVENT_THROW, 'HeavyLiftOver', char)

# Check that the object didn't get dropped or something before the throw event could trigger
def HeavyLiftCheck(event):    
    char = event.object
    object = Object_GetVar(char,'pickup_obj')
    if object == '':    # already ran HeavyLiftOver()
        ##print 'HeavyLiftCheck: pickup_obj was empty'
        return
    if not Object_Exists(object):   # it was thrown and broken or it disappeared somehow
        ##print 'HeavyLiftCheck: pickup_obj %s doesn\'t exist' % repr(object)
        Object_SetAttr(char,'strength',Object_GetAttr(char,'preLiftStrength'))
        Object_SetAttr(char,'speed',Object_GetAttr(char,'preLiftSpeed'))
        return
    cpos = Get_ObjectPos(char)
    opos = Get_ObjectPos(object)
    if ( distance2D(cpos,opos) > 20 ) or ( opos[2]-cpos[2]+1 < Object_GetVar(char,'zdist') ):
        ##print 'HeavyLiftCheck: distance too great or z-dist too low cpos=%s  opos=%s  old z-dist=%f' % (cpos,opos,Object_GetVar(char,'zdist'))
        Object_SetAttr(char,'strength',Object_GetAttr(char,'preLiftStrength'))
        Object_SetAttr(char,'speed',Object_GetAttr(char,'preLiftSpeed'))
        return
    RegTimer('HeavyLiftCheck',3,0,char)


def initunstablemolecules(char,update=0):
    initxunstablemols(char,update)

def initflier(char,update):
    if update==0:
        addFlight(char)

############### LIBRARY CODE FOR SCIENTIST etc. ########################

# Characters with the attributes in the specialAttribs tuple will have custom commands on special objects
# Default is specialAttribs=('scientist','finetk','magnetic','telepathy')
# Cf. ffxcustoms.py.
def initscientist(char,update=0):
    pass

def initfinetk(char,update=0):
    pass

def addAnalyseCommand(target,command='ANALYZE'):
    RegTimer('cmdAttribCheck',0.1,0,target,command)
    FFX_ObjectSetAttr(target,command,1)

def removeAnalyseCommand(target,command='ANALYZE'):
    FFX_ObjectSetAttr(target,command,0)
    for hero in cshelper.getAllHeroes():
        Mission_RemoveCustomAction('CUSTOM_%s'%(command),hero,target)
        attr='%s0'%(target)
        FFX_ObjectSetAttr(hero,attr,0)

def addManipulateCommand(target,command='MANIPULATE'):
    RegTimer('cmdAttribCheck',0.1,1,target,command)
    FFX_ObjectSetAttr(target,command,1)

def removeManipulateCommand(target,command='MANIPULATE'):
    FFX_ObjectSetAttr(target,command,0)
    for hero in cshelper.getAllHeroes():
        Mission_RemoveCustomAction('CUSTOM_%s'%(command),hero,target)
        attr='%s1'%(target)
        FFX_ObjectSetAttr(hero,attr,0)

def addMagneticCommand(target,command='SPARK'):
    RegTimer('cmdAttribCheck',0.1,2,target,command)
    FFX_ObjectSetAttr(target,command,1)

def removeMagneticCommand(target,command='SPARK'):
    FFX_ObjectSetAttr(target,command,0)
    for hero in cshelper.getAllHeroes():
        Mission_RemoveCustomAction('CUSTOM_%s'%(command),hero,target)
        attr='%s2'%(target)
        FFX_ObjectSetAttr(hero,attr,0)

def addSensoryCommand(target,command='SCAN'):
    RegTimer('cmdAttribCheck',0.1,3,target,command)
    FFX_ObjectSetAttr(target,command,1)

def removeSensoryCommand(target,command='SCAN'):
    FFX_ObjectSetAttr(target,command,0)
    for hero in cshelper.getAllHeroes():
        Mission_RemoveCustomAction('CUSTOM_%s'%(command),hero,target)
        attr='%s3'%(target)
        FFX_ObjectSetAttr(hero,attr,0)

def cmdAttribCheck(event):
    target=event.object
    otarget=target
    command=event.string
    if FFX_ObjectGetAttr(target,command)==0:
        return
    attrib=specialAttribs[int(event.user)]
    attr='%s%d'%(target,event.user)
    for hero in cshelper.getAllHeroes():
        if hasAttribute(hero,attrib):
            if FFX_ObjectGetAttr(hero,attr)==0:
                FFX_ObjectSetAttr(hero,attr,1)
                if otarget=='self':
                    target=hero
                range=getRangeFromString(command)
                Mission_CustomAction('CUSTOM_%s'%(command),hero,target,'On%s%s'%(command,otarget),range,0)
    RegTimer('cmdAttribCheck',2,event.user,target,command)

def getRangeFromString(cmd):
    index=1
    range=30
    while index<len(cmd):
        try:
            range=string.atoi(cmd[:index])
        except:
            return range
        index=index+1
    return range

####################### POISONOUS ##############################################

def inittoxic(char,update=0):
    FFX_ObjectSetAttr(char,'mineralised',1)

####################### NEMESIS ##############################################

# Ep. 2006-08-16:
# - Rewrote a bit to reduce processing.
# - Reduced chances of appearing for nemeses whose prestige is above 5000. For example, Pan (25,364 prestige pts) should appear less than half as often.
# - nemFin(): added check for object existence.
# - Made removable.
def initnemesis(char, update=0, remove=0):
    FFX_ObjectSetAttr(char, 'nemesis', 1)
    FFX_ObjectSetAttr(char, 'nemesis_spawned', 0)
    delay = randint(5, 30)
    if remove:
        FFX_ObjectSetAttr(char, 'nemesis', 0)
        nem = 'anti%s' % char
        if Object_IsAlive(nem):
            RegTimer('nemFin', 1, 0, char, nem)
        FFX_ObjectSetAttr(char, 'nemesis_spawned', 0)
        return
    if delay > 28:
        print "%s's nemesis won't appear today." % char
    else:
        delay = delay * delay
        RegTimer('nemesisCheck', delay, 0, char)
        print "%s's nemesis will appear in %i secs." % (char, delay)

def nemesisCheck(event):
    char=event.object
    if Object_Exists(char)==0:
        return
    if FFX_ObjectGetAttr(char,'nemesis_spawned')!=0:
        return
    if not FFX_ObjectGetAttr(char,'nemesis'):
        return
    if Object_IsAlive(char)==0:
        return
    RegTimer('nemesisCheck',10,0,char)
    if cshelper.isPlaying():
        return
    name='anti%s'%(char)
    temp=getByTemplate(char,FFX_NEMESIS_CUSTOM,1)
    cshelper.spawn(name,temp,(randint(-300,300),randint(-300,300),0))
    #Ep. 2006-08-16: check the prestige value of the Nemesis and reduce the chance of spawning accordingly if above 7000.
    if randint(0, int(math.sqrt(Object_CalcPrestige(name)))) > 70:
        Object_Destroy(name)
        print "%s's is unworthy of measuring up with nemesis %s!" % (char, temp)
        return
    print "%s's nemesis %s is entering the fray!" % (char, temp)
    Object_PlayEffect(name,getByTemplate(char,FFX_NEMESIS_CUSTOM,2))
    FFX_ObjectSetAttr(char,'nemesis_spawned',1)
    if usingM25AI():
        team = m25ai.GetTeam(char)
        if team == m25ai.TEAM_GOODGUYS: newteam = m25ai.TEAM_BADGUYS
        else: newteam = m25ai.TEAM_GOODGUYS
        m25ai.SetTeam(name, newteam)
        m25ai.SetBrawler(name)
        m25ai.SetupAI(name)
        m25ai.AddGoal_HuntEnemy(name)
    RegDeath(char, 'nemFin', string = name)
    #give the player the heads up
    try:
        cshelper.speakNoCB(name,'SPEECH_%s_ALERT_0%d'%(Template_GetSpeechID(temp),randint(1,2)))
    except:
        pass

def nemFin(event):
    char=event.object
    nem=event.string
    if Object_IsAlive(nem):
        Object_SetPrimaryState(nem,3,10,0)
        Object_PlayEffect(nem,getByTemplate(char,FFX_NEMESIS_CUSTOM,3)) #Ep. 2006-08-16: corrected the name to 'nem'
        RegTimer('destroyTemp',4,0,nem)


####################### LASTRESORT ##############################################

def initlastresort(char,update=0):
    RegAlmostDead(char,'OnLastResort')

def OnLastResort(event):
    char=event.object
    RegTimer('OnLastResortDie',5,0,char)
    fn=getByTemplate(char,FFX_LASTRESORT_CUSTOM,1)
    param=getByTemplate(char,FFX_LASTRESORT_CUSTOM,2)
    exec("%s('%s','%s',0)"%(fn,char,param))

def OnLastResortDie(event):
    char=event.object
    cshelper.kill(char)

####################### PAINRESPONSE ##############################################

def initpainresponse(char,update=0):
    FFX_ObjectSetAttr(char,'painResponse_AS',0)
    Object_SetAttr(char,'lastHealthPR',Object_GetAttr(char,'health'))
    RegDamage(char,'OnPainResponse')

def OnPainResponse(event):
    char=event.object
    damage=Object_GetAttr(char,'lastHealthPR')-Object_GetAttr(char,'health')
    if damage>0:
        fn=getByTemplate(char,FFX_PAINRESPONSE_CUSTOM,1)
        param=getByTemplate(char,FFX_PAINRESPONSE_CUSTOM,2)
        exec("%s('%s','%s',damage)"%(fn,char,param))
    Object_SetAttr(char,'lastHealthPR',Object_GetAttr(char,'health'))
    RegDamage(char,'OnPainResponse')

####################### MIRACLE WORKER etc ##########################################

# adds a customcommand to all characters
def initmiracle1(char,update=0):
    initmiracle(char,update,1)

def initmiracle2(char,update=0):
    initmiracle(char,update,2)

def initmiracle(char,update,index):
    exec("cmd=getByTemplate(char,FFX_MIRACLE%d_CUSTOM,1)"%(index))
    exec("fn=getByTemplate(char,FFX_MIRACLE%d_CUSTOM,2)"%(index))
    addCommand(cmd,char,'%s%d'%(fn,index),30,0)
    RegTimer('updatemiracle',1,index,char,cmd)
    FFX_ObjectSetAttr(char,'boost%d'%(index),1)

def updatemiracle(event):
    char=event.object
    cmd=event.string
    index=event.user
    if FFX_ObjectGetAttr(char,'boost%d'%(index))==0:
        removeCommand(cmd,char)
    else:
        exec("fn=getByTemplate(char,FFX_MIRACLE%d_CUSTOM,2)"%(index))
        addCommand(cmd,char,'%s%d'%(fn,index),30,1)
        RegTimer('updatemiracle',1,index,char,cmd)

# adds a custom command to yourself
def initboost1(char,update=0):
    initboost(char,update,3)

def initboost2(char,update=0):
    initboost(char,update,4)

def initboost3(char,update=0):
    initboost(char,update,5)

def initboost(char,update,index):
    exec("cmd=getByTemplate(char,FFX_BOOST%d_CUSTOM,1)"%(index))
    exec("fn=getByTemplate(char,FFX_BOOST%d_CUSTOM,2)"%(index))
    Mission_CustomAction(cmd,char,char,'%s%d'%(fn,index),5,0)
    FFX_ObjectSetAttr(char,'boost%d'%(index),1)
    RegTimer('boostUpdate',3,index,char,fn)

def boostUpdate(event):
    char=event.object
    fn=event.string
    index=event.user
    if FFX_ObjectGetAttr(char,'boost%d'%(index))==0:
        Mission_RemoveCustomAction(fn,char,char)
    else:
        RegTimer('boostUpdate',1,index,char,fn)

#miracle functions:

def usePower1(target,char):
    if chargeEP(char,25)==0:
        return
    power=getByTemplate(char,FFX_MIRACLE1_CUSTOM,4)
    Trigger_Power(char,target,power,'')
    RegTimer(getByTemplate(char,FFX_MIRACLE1_CUSTOM,3),3,1,char)

def usePowerX21(target,char):
    if chargeEP(char,25)==0:
        return
    power=getByTemplate(char,FFX_MIRACLE1_CUSTOM,4)
    Trigger_Power(char,target,power,'',2)
    RegTimer(getByTemplate(char,FFX_MIRACLE1_CUSTOM,3),3,1,char)

def usePowerX41(target,char):
    if chargeEP(char,25)==0:
        return
    power=getByTemplate(char,FFX_MIRACLE1_CUSTOM,4)
    Trigger_Power(char,target,power,'',4)
    RegTimer(getByTemplate(char,FFX_MIRACLE1_CUSTOM,3),3,1,char)

def usePower2(target,char):
    if chargeEP(char,25)==0:
        return
    power=getByTemplate(char,FFX_MIRACLE2_CUSTOM,4)
    Trigger_Power(char,target,power,'')
    RegTimer(getByTemplate(char,FFX_MIRACLE2_CUSTOM,3),3,2,char)

def usePowerX22(target,char):
    if chargeEP(char,25)==0:
        return
    power=getByTemplate(char,FFX_MIRACLE2_CUSTOM,4)
    Trigger_Power(char,target,power,'',2)
    RegTimer(getByTemplate(char,FFX_MIRACLE2_CUSTOM,3),3,2,char)

def usePowerX42(target,char):
    if chargeEP(char,25)==0:
        return
    power=getByTemplate(char,FFX_MIRACLE2_CUSTOM,4)
    Trigger_Power(char,target,power,'',4)
    RegTimer(getByTemplate(char,FFX_MIRACLE2_CUSTOM,3),3,2,char)

def usePower3(target,char):
    if chargeEP(char,25)==0:
        return
    power=getByTemplate(char,FFX_BOOST3_CUSTOM,4)
    Trigger_Power(char,target,power,'')
    RegTimer(getByTemplate(char,FFX_BOOST3_CUSTOM,3),3,3,char)

def usePowerX23(target,char):
    if chargeEP(char,25)==0:
        return
    power=getByTemplate(char,FFX_BOOST3_CUSTOM,4)
    Trigger_Power(char,target,power,'',2)
    RegTimer(getByTemplate(char,FFX_BOOST3_CUSTOM,3),3,3,char)

def usePowerX43(target,char):
    if chargeEP(char,25)==0:
        return
    power=getByTemplate(char,FFX_BOOST3_CUSTOM,4)
    Trigger_Power(char,target,power,'',4)
    RegTimer(getByTemplate(char,FFX_BOOST3_CUSTOM,3),3,3,char)

def usePower4(target,char):
    if chargeEP(char,25)==0:
        return
    power=getByTemplate(char,FFX_BOOST4_CUSTOM,4)
    Trigger_Power(char,target,power,'')
    RegTimer(getByTemplate(char,FFX_BOOST4_CUSTOM,3),3,4,char)

def usePowerX24(target,char):
    if chargeEP(char,25)==0:
        return
    power=getByTemplate(char,FFX_BOOST4_CUSTOM,4)
    Trigger_Power(char,target,power,'',2)
    RegTimer(getByTemplate(char,FFX_BOOST4_CUSTOM,3),3,4,char)

def usePowerX44(target,char):
    if chargeEP(char,25)==0:
        return
    power=getByTemplate(char,FFX_BOOST4_CUSTOM,4)
    Trigger_Power(char,target,power,'',4)
    RegTimer(getByTemplate(char,FFX_BOOST4_CUSTOM,3),3,4,char)

def usePower5(target,char):
    if chargeEP(char,25)==0:
        return
    power=getByTemplate(char,FFX_BOOST5_CUSTOM,4)
    Trigger_Power(char,target,power,'')
    RegTimer(getByTemplate(char,FFX_BOOST5_CUSTOM,3),3,5,char)

def usePowerX25(target,char):
    if chargeEP(char,25)==0:
        return
    power=getByTemplate(char,FFX_BOOST5_CUSTOM,4)
    Trigger_Power(char,target,power,'',2)
    RegTimer(getByTemplate(char,FFX_BOOST5_CUSTOM,3),3,5,char)

def usePowerX45(target,char):
    if chargeEP(char,25)==0:
        return
    power=getByTemplate(char,FFX_BOOST5_CUSTOM,4)
    Trigger_Power(char,target,power,'',4)
    RegTimer(getByTemplate(char,FFX_BOOST5_CUSTOM,3),3,5,char)

def summonAlly1(target,char):
    summonAlly(target,char,1)
    RegTimer(getByTemplate(char,FFX_MIRACLE1_CUSTOM,3),3,1,char)

def summonAlly2(target,char):
    summonAlly(target,char,2)
    RegTimer(getByTemplate(char,FFX_MIRACLE2_CUSTOM,3),3,2,char)

def summonAlly(target,char,index):
    if chargeEP(char,25)==0:
        return
    name=getDummyName()
    pos=GetSpawnPos(target,char,60)
    FFX_SetPos('summon%s'%(char),pos)
    cshelper.spawn(name,'portal_start_proxy',pos)
    power=getByTemplate(char,FFX_MIRACLE1_CUSTOM,4)
    if index==2:
        power=getByTemplate(char,FFX_MIRACLE2_CUSTOM,4)
    Trigger_Power(char,name,power,'')
    RegTimer('summonAllyA',2,index,char,target)
    RegTimer('destroyTemp',6,0,name)
    Mission_StatusText('summonAlly done')
    RegTimer('OnSummonCB',0.1,0,char,name)

def summonAllyA(event):
    target=event.string
    char=event.object
    index=event.user
    name=getDummyName()
    temp=getByTemplate(char,FFX_MIRACLE1_CUSTOM,5)
    if index==2:
        temp=getByTemplate(char,FFX_MIRACLE2_CUSTOM,5)
    cshelper.spawn(name,temp,FFX_GetPos('summon%s'%(char)))
    FFX_ObjectSetAttr(name,'master',Object_GetAttr(char,'ffxID'))
    FFX_ObjectSetAttr(name,'minionType',0)
    RegTimer('UnSummon',120,0,name,char)
    initMinionAI(name,m25ai.GetTeam(char),target,isEvil(char))
    if usingM25AI():
        m25ai.AddGoal_HuntEnemy(name)

def boostStrength3(dummy,char):
    boostStrength(dummy,char,3)
    RegTimer(getByTemplate(char,FFX_BOOST3_CUSTOM,3),31,3,char)

def boostStrength4(dummy,char):
    boostStrength(dummy,char,4)
    RegTimer(getByTemplate(char,FFX_BOOST4_CUSTOM,3),31,4,char)

def boostStrength5(dummy,char):
    boostStrength(dummy,char,5)
    RegTimer(getByTemplate(char,FFX_BOOST5_CUSTOM,3),31,5,char)

def boostStrength(dummy,char,index):
    exec("cmd=getByTemplate(char,FFX_BOOST%d_CUSTOM,1)"%(index))
    exec("fx=getByTemplate(char,FFX_BOOST%d_CUSTOM,5)"%(index))
    if fx!='':
        handle=Object_PlayEffect(char,fx,'',FX_LOOP|FX_TRACK_OBJECT_POS)
        FFX_ObjectSetAttr(char,'booststrhdl',handle)
    Mission_RemoveCustomAction(cmd,char,char)
    FFX_SetStrength(char,2)
    RegTimer('unboostStrength',30,index,char)

def unboostStrength(event):
    char=event.object
    index=event.user
    RegTimer('unboostStrength2',30,index,char)
    FFX_SetStrength(char,0)
    handle=FFX_ObjectGetAttr(char,'booststrhdl',-1)
    Object_StopEffect(char,handle)

#restore the command to boost strength (or become unstoppable) again
def unboostStrength2(event):
    char=event.object
    index=event.user
    if FFX_ObjectGetAttr(char,'boost%d'%(index))!=0:
        initboost(char,0,index)

def unstoppable3(dummy,char):
    unstop(dummy,char,3)
    RegTimer(getByTemplate(char,FFX_BOOST3_CUSTOM,3),31,0,char)

def unstoppable4(dummy,char):
    unstop(dummy,char,4)
    RegTimer(getByTemplate(char,FFX_BOOST4_CUSTOM,3),31,0,char)

def unstoppable5(dummy,char):
    unstop(dummy,char,5)
    RegTimer(getByTemplate(char,FFX_BOOST5_CUSTOM,3),31,0,char)

def unstop(dummy,char,index):
    exec("cmd=getByTemplate(char,FFX_BOOST%d_CUSTOM,1)"%(index))
    Mission_RemoveCustomAction(cmd,char,char)
    FFX_ObjectSetAttr(char,'baseMinhealth',Object_GetAttr(char,'minHealth'))
    Object_SetAttr(char,'minHealth',Object_GetAttr(char,'health'))
    RegTimer('ununstop',30,index,char)
    exec("fx=getByTemplate(char,FFX_BOOST%d_CUSTOM,5)"%(index))
    if fx!='':
        handle=Object_PlayEffect(char,fx,'',FX_LOOP|FX_TRACK_OBJECT_POS)
        FFX_ObjectSetAttr(char,'unstophdl',handle)

def ununstop(event):
    char=event.object
    index=event.user
    Object_SetAttr(char,'minHealth',FFX_ObjectGetAttr(char,'baseMinHealth'))
    RegTimer('unboostStrength2',30,index,char)
    handle=FFX_ObjectGetAttr(char,'unstophdl',-1)
    Object_StopEffect(char,handle)

# gives a character 50% chance of getting an additional hero point once, up to a max of 4 hero points.
# added Ep FFX 3.2 alpha 2006-04-27; updated 2006-09-17
def getHeroPoint503(dummy,char):
    getHeroPoint50(dummy,char,3)
    RegTimer(getByTemplate(char,FFX_BOOST3_CUSTOM,3),31,0,char)

def getHeroPoint504(dummy,char):
    getHeroPoint50(dummy,char,4)
    RegTimer(getByTemplate(char,FFX_BOOST4_CUSTOM,3),31,0,char)

def getHeroPoint505(dummy,char):
    getHeroPoint50(dummy,char,5)
    RegTimer(getByTemplate(char,FFX_BOOST5_CUSTOM,3),31,0,char)

def getHeroPoint50(dummy,char,index):
    exec("cmd=getByTemplate(char,FFX_BOOST%d_CUSTOM,1)"%(index))
    Mission_RemoveCustomAction(cmd,char,char)
    char=event.object
    if (Object_GetAttr(char, 'heroPoints') < 4) and (FFX_ObjectGetAttr(char, 'getHeroPoint50') == 0):
        if randint(0, 1) == 1:
            FFX_ObjectSetAttr(char, 'getHeroPoint50', 1)
            Object_SetAttr(char, 'heroPoints', Object_GetAttr(char, 'heroPoints') + 1)
    exec("fx=getByTemplate(char,FFX_BOOST%d_CUSTOM,5)"%(index))


#side effects
#event.object is the character
#event.user is the power index (1 to 5)

def useHeroPoint(event):
    char=event.object
    index=event.user
    hp=Object_GetAttr(char,'heroPoints')-1
    Object_SetAttr(char,'heroPoints',hp)
    print 'useHeroPoint: hp=%d'%(hp)
    if hp==0:
        FFX_ObjectSetAttr(char,'boost%d'%(index),0)

def zapEnergy(event):
    char=event.object
    Object_SetAttr(char,'energy',0)
    Object_SetAttr(char,'energyPoints',0)
    RegTimer('unzapEnergy',5,0,char)

def unzapEnergy(event):
    char=event.object
    en=Object_GetAttr(char,'energy')
    if FFX_ObjectGetAttr(char,'baseEnergy')>en:
        Object_SetAttr(char,'energy',en+1)
        RegTimer('unzapEnergy',3,0,char)

def zapStrength(event):
    makeweakened(event.object,'',3)

def zapSpeed(event):
    char=event.object
    Object_SetAttr(char,'speed',0)
    RegTimer('unzapSpeed',5,0,char)

def unzapSpeed(event):
    char=event.object
    en=Object_GetAttr(char,'speed')
    if Object_GetAttr(char,'baseSpeed')>en:
        Object_SetAttr(char,'speed',en+1)
        RegTimer('unzapSpeed',3,0,char)

def takeDamage(event):
    char=event.object
    Trigger_Damage(char,randint(15,30))

def takeDamage50(event):
    char=event.object
    if randint(1,100)<50:
        Trigger_Damage(char,randint(30,50))

def faint10(event):
    char=event.object
    if randint(1,100)<10:
       cshelper.kill(char)

def halfHealth(event):
    char=event.object
    FFX_FactorHealth(char,0.5)

def irradiate50(event):
    char=event.object
    if randint(1,100)<50:
        Object_SetSecondaryState(char,SCSTATE_IRRADIATED,10,0)

def hex50(event):
    char=event.object
    if randint(1,100)<50:
        Object_SetSecondaryState(char,SCSTATE_HEXED,30,0)

###!Ep 2006-02-05 default state for Speed Force
def makeBlindAndPowerNulled(event):
    char = event.object
    Object_SetSecondaryState(char, SCSTATE_BLIND, 15, 0)
    Object_SetSecondaryState(char, SCSTATE_POWER_NULLIFICATION, 15, 0)

def zapEnergyAndStrength(event):
    zapEnergy(event)
    zapStrength(event)

def zapEnergyAndSpeed(event):
    zapEnergy(event)
    zapSpeed(event)

def zapSpeedAndStrength(event):
    zapSpeed(event)
    zapStrength(event)

####################### PLUGGABLE FUNCTIONS FOR PAIN RESPONSE/LAST RESORT ##################

def findEnemy(char):
    evil=isEvil(char)
    target=''
    minDist=10000000
    for obj in Mission_GetDynamicObjects():
        if Object_GetClass(obj)&FFX_CHARACTER:
            if isEvil(obj)!=evil:
                dist=distanceSq(obj,char)
                if dist<minDist:
                    target=obj
    return target

def m25_Disable(char):
    if Object_Exists(char):
        m25ai.AIDisable(char) #Object_SetAttr(char, 'enabled', 0)
        #Object_SetAttr(char, 'ai_priority', 99)
        #cshelper.disable(char)

#fires off a last shot
def lastShot(char,param,intensity):
    target=findEnemy(char)
    m25_Disable(char)
    if target!='':
        Trigger_Power(char,target,param,'')

#increases strength as damage is taken
def strengthThroughPain(char,param,intensity):
    bonus=1.0+intensity*0.1
    oldBonus=Object_GetAttr(char,'attackBonus')
    print 'strengthThroughPain: attackBonus=%d'%(Object_GetAttr(char,'attackBonus'))
    if bonus>oldBonus:
        FFX_SetStrength(char,intensity*0.2)
    if oldBonus==1:
        print 'setting off timer'
        RegTimer('decayStrength',5,0,char)

def decayStrength(event):
    char=event.object
    bonus=0.0+Object_GetAttr(char,'attackBonus')
    bonus=bonus-0.2
    print 'decayStrength(%s): attackBonus=%d'%(char,bonus)
    if bonus<=1.0:
        bonus=1.0
    else:
        RegTimer('decayStrength',5,0,char)
    print 'resetting bonus'
    Object_SetAttr(char,'attackBonus',bonus)

def strengthandenergyThroughPain(char,param,intensity):
    bonus=1.0+intensity*0.1
    oldBonus=Object_GetAttr(char,'attackBonus')
    print 'strengthandenergyThroughPain: attackBonus=%d'%(Object_GetAttr(char,'attackBonus'))
    if bonus>oldBonus:
        FFX_SetStrength(char,intensity*0.2)
    if oldBonus==1:
        print 'setting off timer'
        RegTimer('decayStrength',5,0,char)
    print 'strengthandenergyThroughPain: intensity=%d'%intensity
    ep=Object_GetAttr(char,'energyPoints')+intensity
    maxEP=Object_GetAttr(char,'maxEnergyPoints')
    print 'strengthandenergyThroughPain: energybonus=%d'%ep
    excess=ep-maxEP
    if excess>0:
        ep=maxEP
    Object_SetAttr(char,'energyPoints',ep)

def energyThroughPain(char,param,intensity):
    if intensity==0:
        intensity=50
    ep=Object_GetAttr(char,'energyPoints')+intensity*4
    maxEP=Object_GetAttr(char,'maxEnergyPoints')
    excess=ep-maxEP
    if excess>0:
        Trigger_Explosion(char,param,(excess-7)*0.1)
        ep=maxEP
    Object_SetAttr(char,'energyPoints',ep)

#spawns a nearby creature on death or in response to damage
def spawnAllies(char,param,intensity):
    while intensity>=0:
        if intensity==0 or intensity>randint(1,10):
            name=getDummyName()
            p=Get_ObjectPos(char)
            cshelper.spawn(name,param,(p[0]+randint(-20,20),p[1]+randint(-20,20),p[2]))
            RegTimer('spawnallies2',0.7,0,name,char)
        intensity=intensity-10
        if intensity<=0:
            return

def spawnallies2(event):
    name=event.object
    char=event.string
    if Object_GetClass(name)&FFX_CHARACTER:
        initMinionAI(name,m25ai.GetTeam(char),'',isEvil(char))
        if usingM25AI():
            m25ai.AddGoal_HuntEnemy(name)
    else:
        cshelper.kill(name)

circlepos=((0,10),(0.7,0.7),(10,0),(0.7,-0.7),(0,-10),(-0.7,-0.7),(-10,0),(-0.7,0.7))

def spawnBombs(char,param,intensity):
    if intensity==0:
        intensity=80
    number=intensity/10
    if number>8:
        number=8
    index=randint(0,7)
    count=0
    pos=Get_ObjectPos(char)
    while count<number:
        index=(index+1)&7
        dx=circlepos[index]
        name=getDummyName()
        cshelper.spawn(name,'ffx_fallobject',(pos[0]+dx[0],pos[1]+dx[1],pos[2]+2))
        RegTimer('throwBomb',0.2,index,name)
        timer=randint(150,200)*0.01
        RegTimer('detonateBomb',timer,0,name,param)
        Object_SetAttr(name,'minHealth',1)
        count=count+1

def throwBomb(event):
    name=event.object
    index=int(event.user)
    dx=circlepos[index]
    Trigger_Force(name,dx[0],dx[1],10,25000,TF_ABSOLUTE)

def detonateBomb(event):
    if Object_Exists(event.object):
        Trigger_Explosion(event.object,event.string)
        RegTimer('killTemp',4,0,event.object)

def m25_Enable(event):
    char=event.object
    if Object_Exists(char):
       m25ai.AIEnable(char) #Object_SetAttr(char, 'enabled', 1)
       #Object_SetAttr(char, 'ai_priority', 0)
       #if Object_GetAttr(char, 'ai_nostandardai') == 0:
           #enable(char)

def randomResponse(char,param,intensity):
    if intensity==0 or intensity>randint(1,15):
        index=randint(1,6)
        if index==1:
            target=findEnemy(char)
            if target!='':
                m25_Disable(char)
                Trigger_Power(char,target,'alien warrior Plasma Rocket','',2)
                RegTimer('m25_Enable',3,0,char)
        elif index==2:
            createHailStorm(char,param,intensity)
        elif index==3:
            Trigger_Explosion(char,'ffx_exile_area',3)
        elif index==4:
            Trigger_Explosion(char,'ffx_alteration_area',3)
        else:
            spawnAllies(char,'bacchite_red',intensity)

def createLightningStorm(char,param,intensity):
    centre=getDummyName()
    cshelper.spawn(centre,'portal_start_proxy',char)
    Mission_SetAttr('ambient',0.2)
    Mission_SetAttr('direct',0.5)
    m25ai.SetTeam(centre,m25ai.GetTeam(char))
    RegTimer('LightningStrike',3,10,centre)

def createHailStorm(char,param,intensity):
    centre=getDummyName()
    cshelper.spawn(centre,'portal_start_proxy',char)
    Mission_SetAttr('ambient',0.2)
    Mission_SetAttr('direct',0.5)
    m25ai.SetTeam(centre,m25ai.GetTeam(char))
    RegTimer('HailStorm',3,10,centre)

def createFireStorm(char,param,intensity):
    centre=getDummyName()
    cshelper.spawn(centre,'portal_start_proxy',char)
    Mission_SetAttr('ambient',0.2)
    Mission_SetAttr('direct',0.5)
    m25ai.SetTeam(centre,m25ai.GetTeam(char))
    RegTimer('EnvStrike',3,10,centre)


#Ep 2006-0-07: teleport multiple times around your initial position, making you harder to hit
#Note that this stops previous movement requests.
def evasiveTeleport(char):
    RegTimer('OnEvasiveTeleport', 0.1, 16, char)

def OnEvasiveTeleport(event):
    char = event.object
    count = event.user - 1
    pos = Get_ObjectPos(char)
    pos = ( randint( int(pos[0])-20, int(pos[0])+20 ),\
            randint( int(pos[1])-20, int(pos[1])+20 ),\
            pos[2] )
    teleportToPos(char, pos)
    if count > 0:
        RegTimer('OnEvasiveTeleport', 0.5, count, char)

####################### COORDINATOR #############################################

def initcoordinator(char,update):
    RegTimer('updateCoord',1,0,char)

def updateCoord(event):
    char=event.object
    if Object_IsAlive(char)==0:
        return
    bonus=3
    if cshelper.normal(char)==0:
        bonus=0
    RegTimer('updateCoord',1,0,char)
    myTeam=m25ai.GetTeam(char)
    for obj in Mission_GetDynamicObjects():
        if obj!=char and Object_GetClass(obj)&FFX_CHARACTER:
            team=m25ai.GetTeam(obj)
            if team!=myTeam:
                addAgility(obj,-bonus)
            else:
                addAgility(obj,bonus)

def addAgility(char,bonus):
    Object_SetAttr(char,'agility',Object_GetAttr(char,'templateAgility')+bonus)

####################### SLIPPERY ################################################

def initslippery(char,update=0):
    RegCharState(char,PCSTATE_STATIC,'clearStasis')

def clearStasis(event):
    char=event.object
    if hasAttribute(char,'slippery'):
        Object_SetPrimaryState(char,PCSTATE_STATIC,0,REMOVE_STATE)
        RegTimer('landonfeet',0.1,0,char)
        RegCharState(char,PCSTATE_STATIC,'clearStasis')

def landonfeet(event):
    char=event.object
    Trigger_Power(char,char,'land_from_jump','')
    FFX_ObjectSetAttr(char, 'voluntary_flailing', 0) #Ep. 2006-08-30: clear flailing triggered by Jump Travel, Fastball, etc.

####################### IRON GUTS ###############################################
################# metabolises acid & radiation but may get drunk doing so #######

def initironguts(char,update=0):
    RegTimer('irongutsupdate',1,0,char)

def irongutsupdate(event):
    char=event.object
    if hasAttribute(char,'ironguts'):
        RegTimer('irongutsupdate',0.5,0,char)
        if Object_GetSecondaryStates(char)&(SCSTATE_ACID_BURNT|SCSTATE_IRRADIATED):
            Object_SetSecondaryState(char,SCSTATE_ACID_BURNT,0,REMOVE_STATE)
            Object_SetSecondaryState(char,SCSTATE_IRRADIATED,0,REMOVE_STATE)
            guts=FFX_ObjectGetAttr(char,'guts',0)+1
            if randint(1,10)<=guts:
                makevertigo(char,'',2)
                FFX_ObjectSetAttr(char,'guts',0)
            else:
                FFX_ObjectSetAttr(char,'guts',guts)
            #heal a little bit to compensate
            hp=Object_GetAttr(char,'health')+5
            maxHP=Object_GetAttr(char,'maxHealth')
            if hp>maxHP:
                hp=maxHP
            Object_SetAttr(char,'health',hp)

################## MUTATOR ##################################

primPowers=('ice','strength','plants','electro','gravity','xray','fire')#,'superbreath','transmute','tk')
secondPowers=('invuln','speed','forcefield','duplication','probability','acid')

#Ep. 2006-08-30: made removable
def initmutator(char,update=0,remove=0):
    if remove:
        FFX_ObjectSetAttr(char, 'mutator', 0)
        removeprim(char, FFX_ObjectGetAttr(char, 'mut1'))
        removesecond(char, FFX_ObjectGetAttr(char, 'mut2'))        
        return
    if (Object_GetClass(char)&OC_CHARACTER)==0:
        return
    FFX_ObjectSetAttr(char, 'mutator', 1)
    #moved to the character initialization section to be available in every case
    #since flesh material = 0
    #ffx.FFX_ObjectSetAttr(char,'baseMat',Object_GetAttr(char,'material')) ###!
    p1=getmutation(primPowers)
    p2=getmutation(secondPowers)
    ffx.FFX_ObjectSetAttr(char,'mut1',p1)
    ffx.FFX_ObjectSetAttr(char,'mut2',p2)
    addprim(char,p1)
    addsecond(char,p2)
    ffx.RegTimer('switchprim',40,0,char)
    ffx.RegTimer('switchsecond',20,0,char)

def getmutation(list,current=-1):
    num=len(list)
    if current!=-1:
        num=num-1
    index=randint(0,num-1)
    if index==current:
        index=num
    return index

def addprim(char,index):
    cmd="add%s(char)"%(primPowers[int(index)])
    exec(cmd)

def removeprim(char,index):
    cmd="remove%s(char)"%(primPowers[int(index)])
    exec(cmd)

def switchprim(event):
    char=event.object
    if Object_Exists(char)==0:
        return
    if FFX_ObjectGetAttr(char, 'mutator')==0:
        return
    ffx.RegTimer('switchprim',40,0,char)
    if Object_IsAlive(char)==0: ###!
        return
    oldIndex=ffx.FFX_ObjectGetAttr(char,'mut1')
    newIndex=getmutation(primPowers,oldIndex)
    removeprim(char,oldIndex)
    addprim(char,newIndex)
    ffx.FFX_ObjectSetAttr(char,'mut1',newIndex)

def addsecond(char,index):
    cmd="add%s(char)"%(secondPowers[int(index)])
    exec(cmd)

def removesecond(char,index):
    cmd="remove%s(char)"%(secondPowers[int(index)])
    exec(cmd)

def switchsecond(event):
    char=event.object
    if Object_Exists(char)==0:
        return
    if FFX_ObjectGetAttr(char, 'mutator')==0:
        return
    ffx.RegTimer('switchsecond',40,0,char)
    if Object_IsAlive(char)==0:
        return
    oldIndex=ffx.FFX_ObjectGetAttr(char,'mut2')
    newIndex=getmutation(secondPowers,oldIndex)
    removesecond(char,oldIndex)
    addsecond(char,newIndex)
    ffx.FFX_ObjectSetAttr(char,'mut2',newIndex)

def updateprim(event):
    char=event.object
    cmd=event.string
    index=event.user
    if ffx.FFX_ObjectGetAttr(char,'mut1')==event.user:
        ffx.addCommand(cmd,char,cmd,30,1)
        ffx.RegTimer('updateprim',2,index,char,cmd)

def updatesecond(event):
    char=event.object
    cmd=event.string
    index=event.user
    if ffx.FFX_ObjectGetAttr(char,'mut2')==event.user:
        ffx.addCommand(cmd,char,cmd,30,1)
        ffx.RegTimer('updatesecond',2,index,char,cmd)

def mutFX(char,fx,node=''):
    handle=-1
    if fx!='':
        handle=Object_PlayEffect(char,fx,'',FX_LOOP|FX_TRACK_OBJECT_FULL,0,node)
    oldHandle=ffx.FFX_ObjectGetAttr(char,'mutfx',-1)
    if oldHandle!=-1:
        Object_StopEffect(char,oldHandle)
    ffx.FFX_ObjectSetAttr(char,'mutfx',handle)

def mutFX2(char,fx,node=''):
    handle=-1
    if fx!='':
        handle=Object_PlayEffect(char,fx,'',FX_LOOP|FX_TRACK_OBJECT_FULL,0,node)
    oldHandle=ffx.FFX_ObjectGetAttr(char,'mutfx2',-1)
    if oldHandle!=-1:
        Object_StopEffect(char,oldHandle)
    ffx.FFX_ObjectSetAttr(char,'mutfx2',handle)

####################### MUTATOR POWERSETS ###########################

######## ICE

def addice(char):
    if cshelper.isPlaying()==0:
        Mission_StatusText('ice powers activating...')
    ffx.addCommand('mut_icebeam',char,'mut_icebeam',30,0)
    FFX_ObjectSetAttr(char,'ice beam',1)
    m25ai.AddGoal_DynamicAbility(char, temp_attribute='ice beam', tactic='TRanged("mut_icebeam")')
    ffx.addCommand('custom_icepatch',char,'custom_icepatch',30,0)
    FFX_ObjectSetAttr(char,'ice patch',1)
    m25ai.AddGoal_DynamicAbility(char, temp_attribute='ice patch', tactic='TIcePatch()')
    ffx.RegTimer('updateprim',2,0,char,'mut_icebeam')
    ffx.RegTimer('updateprim',2,0,char,'custom_icepatch')
    Mission_CustomAction('mut_iceshield',char,char,'mut_iceshield',5,0)
    FFX_ObjectSetAttr(char,'ice shield',1)
    m25ai.AddGoal_DynamicAbility(char, temp_attribute='ice shield', tactic='TActiveDefense("mut_iceshield")')
    Object_SetAttr(char,'material',9)
    mutFX(char,'effect_ffx_icesparks')
    ffx.RegTimer('updatemutice',2,0,char)

def removeice(char):
    if cshelper.isPlaying()==0:
        Mission_StatusText('ice powers fading...')
    Mission_RemoveCustomAction('mut_iceshield',char,char)
    ffx.removeCommand('mut_icebeam',char)
    ffx.removeCommand('custom_icepatch',char)
    FFX_ObjectSetAttr(char,'ice beam',0)
    FFX_ObjectSetAttr(char,'ice patch',0)
    FFX_ObjectSetAttr(char,'ice shield',0)
    Object_SetAttr(char,'material',ffx.FFX_ObjectGetAttr(char,'baseMat'))
    mutFX(char,'')
    ffx.removeShield(char)

def updatemutice(event):
    char=event.object
    if ffx.FFX_ObjectGetAttr(char,'mut1')==0:
        if cshelper.isPlaying()==0:
            Trigger_Explosion(char,'ffx_frostbite')
        ffx.RegTimer('updatemutice',2,0,char)

def mut_icebeam(target,char):
    Trigger_Power(char,target,'mut_icebeam','')

def custom_icepatch(target,char):
    ffx.OnIcePatch(target,char)

def mut_iceshield(dummy,char):
    Trigger_Power(char,char,'mut_iceshield','')

############# SUPERSTRENGTH

def addstrength(char):
    if cshelper.isPlaying()==0:
        Mission_StatusText('super-strength activating...')
    ffx.FFX_SetStrength(char,3)
    Mission_CustomAction('mut_quake',char,char,'mut_quake',5,0)
    FFX_ObjectSetAttr(char,'quake',1)
    m25ai.AddGoal_DynamicAbility(char, temp_attribute='quake', tactic='TArea("mut_quake")')
    ffx.addCommand('custom_leapto',char,'custom_leapto',40,0)
    m25ai.AddGoal_DynamicAbility(char, temp_attribute='super leaper', tactic='TSuperLeap()')
    m25ai.AddGoal_DynamicAbility(char, temp_attribute='super leaper', tactic='TSuperLeapAway()')
    FFX_ObjectSetAttr(char,'super leaper',1)
    ffx.RegTimer('updateprim',2,1,char,'custom_leapto')
    mutFX(char,'effect_ffx_density')

def removestrength(char):
    if cshelper.isPlaying()==0:
        Mission_StatusText('super-strength fading...')
    ffx.FFX_SetStrength(char,0)
    Mission_RemoveCustomAction('mut_quake',char,char)
    ffx.removeCommand('custom_leapto',char)
    FFX_ObjectSetAttr(char,'super leaper',0)
    FFX_ObjectSetAttr(char,'quake',0)
    mutFX(char,'')

def mut_quake(dummy,char):
    Trigger_Power(char,char,'mut_quake','')

def custom_leapto(target,char):
    ffx.OnLeapTo(target,char)

############# NATURE CONTROL

def addplants(char):
    if cshelper.isPlaying()==0:
        Mission_StatusText('plant control activating...')
    ffx.initpuppetn(char,0)
    FFX_ObjectSetAttr(char,'nature master',1)
    m25ai.AddGoal_DynamicAbility(char, temp_attribute='nature master', tactic='TPuppetMasterNature()')

def removeplants(char):
    if cshelper.isPlaying()==0:
        Mission_StatusText('plant control fading...')
    temps=[]
    #deanimate all your plants
    ffx.RegTimer('masterDie',0.1,2,char)
    for template in natureTemplates:
        Mission_RemoveCustomAction('CUSTOM_ANIMATE',char,template[0])
        FFX_ObjectSetAttr(char,'nature master',0)
        match=0
        for temp in temps:
            if temp==template[1]:
                match=1
        if match==0:
            Mission_RemoveCustomAction('CUSTOM_DEANIMATE',char,template[1])
            Mission_RemoveCustomAction('CUSTOM_SUSTAIN',char,template[1])
            temps.append(template[1])

############# ELECTRO-MAGNETIC

def addelectro(char):
    if cshelper.isPlaying()==0:
        Mission_StatusText('electro-magnetic powers activating...')
    ffx.FFX_ObjectSetAttr(Object_GetTemplate(char),'magnetic',1)
    ffx.initmagnetic(char,0)
    FFX_ObjectSetAttr(char,'electromagnetic',1)
    m25ai.AddGoal_DynamicAbility(char, temp_attribute='electromagnetic', tactic='TMagneticRepel()')
    m25ai.AddGoal_DynamicAbility(char, temp_attribute='electromagnetic', tactic='TMagneticAttract()')
    m25ai.AddGoal_DynamicAbility(char, temp_attribute='electromagnetic', tactic='TMagneticCustom()')
    ffx.addCommand('mut_electrozap',char,'mut_electrozap',30,0)
    FFX_ObjectSetAttr(char,'electric zap',1)
    m25ai.AddGoal_DynamicAbility(char, temp_attribute='electric zap', tactic='TDirect("mut_electrozap")')
    ffx.RegTimer('updateprim',2,3,char,'mut_electrozap')
    mutFX(char,'effect_ffx_magnetised')

def removeelectro(char):
    if cshelper.isPlaying()==0:
        Mission_StatusText('electro-magnetic powers fading...')
    ffx.FFX_ObjectSetAttr(Object_GetTemplate(char),'magnetic',0)
    for temp in ffx.templates:
        Mission_RemoveCustomAction('CUSTOM_LIFT',char,temp[0])
    for obj in Mission_GetDynamicObjects():
        Mission_RemoveCustomAction('CUSTOM_LIFT',char,obj)
        Mission_RemoveCustomAction('CUSTOM_ATTRACT',char,obj)
        Mission_RemoveCustomAction('CUSTOM_REPEL',char,obj)
    ffx.removeCommand('mut_electrozap',char)
    FFX_ObjectSetAttr(char,'electromagnetic',0)
    FFX_ObjectSetAttr(char,'electric zap',0)
    mutFX(char,'')

def mut_electrozap(target,char):
    Trigger_Power(char,target,'mut_electrozap','')

############### GRAVITY

def addgravity(char):
    if cshelper.isPlaying()==0:
        Mission_StatusText('gravity control activating...')
    ffx.addCommand('mut_gravity_up',char,'mut_gravity_up',30,0)
    ffx.RegTimer('updateprim',2,4,char,'mut_gravity_up')
    ffx.addCommand('mut_gravity_down',char,'mut_gravity_down',30,0)
    ffx.RegTimer('updateprim',2,4,char,'mut_gravity_down')
    Mission_CustomAction('gravity_well',char,char,'gravity_well',5,0)
    FFX_ObjectSetAttr(char,'gravity',1)
    m25ai.AddGoal_DynamicAbility(char, temp_attribute='gravity', tactic='TDirect("mut_gravity_up")')
    m25ai.AddGoal_DynamicAbility(char, temp_attribute='gravity', tactic='TDirect("mut_gravity_down")')
    m25ai.AddGoal_DynamicAbility(char, temp_attribute='gravity', tactic='TGravityWell()')

def removegravity(char):
    if cshelper.isPlaying()==0:
        Mission_StatusText('gravity control fading...')
    ffx.removeCommand('mut_gravity_up',char)
    ffx.removeCommand('mut_gravity_down',char)
    Mission_RemoveCustomAction('gravity_well',char,char)
    FFX_ObjectSetAttr(char,'gravity',0)

def mut_gravity_up(target,char):
    Trigger_Power(char,target,'mut_gravity_up','')

def mut_gravity_down(target,char):
    Trigger_Power(char,target,'mut_gravity_down','stasistogravityincrease')

def gravity_well(dummy,char):
    ffx.pullCheck(char,16)

################ XRAY

def addxray(char):
    if cshelper.isPlaying()==0:
        Mission_StatusText('x-ray powers activating...')
    ffx.addCommand('mut_xray',char,'mut_xray',30,0)
    FFX_ObjectSetAttr(char,'xray blast',1)
    m25ai.AddGoal_DynamicAbility(char, temp_attribute='xray blast', tactic='TRanged("mut_xray")')
    ffx.RegTimer('updateprim',2,5,char,'mut_xray')
    Mission_CustomAction('custom_xray',char,char,'x_ray',5,0)
    FFX_ObjectSetAttr(char,'xray form',1)
    m25ai.AddGoal_DynamicAbility(char, temp_attribute='xray form', tactic='TDisplaceImage("microwave Displace Image")')
    ffx.RegTimer('xrayupdate',1,0,char)
    mutFX(char,'effect_ffx_energysparks')

def removexray(char):
    if cshelper.isPlaying()==0:
        Mission_StatusText('x-ray powers fading...')
    ffx.removeCommand('mut_xray',char)
    Mission_RemoveCustomAction('custom_xray',char,char)
    FFX_ObjectSetAttr(char,'xray blast',0)
    FFX_ObjectSetAttr(char,'xray form',0)
    mutFX(char,'')
    Object_SetSecondaryState(char,SCSTATE_DISPLACE_IMAGE,0,REMOVE_STATE)

def mut_xray(target,char):
    Trigger_Power(char,target,'mut_xray','')

def x_ray(dummy,char):
    Trigger_Power(char,char,'microwave Displace Image','')

def xrayupdate(event):
    char=event.object
    if ffx.FFX_ObjectGetAttr(char,'mut1')==5:
        if Object_GetSecondaryStates(char)&SCSTATE_DISPLACE_IMAGE:
            if cshelper.isPlaying()==0:
                Trigger_Explosion(char,'ffx_biohazard')
        ffx.RegTimer('xrayupdate',1,0,char)

######### FIRE

def addfire(char):
    if cshelper.isPlaying()==0:
        Mission_StatusText('flame powers activating...')
    ffx.addCommand('mut_fireball',char,'mut_fireball',30,0)
    FFX_ObjectSetAttr(char,'fireball',1)
    m25ai.AddGoal_DynamicAbility(char, temp_attribute='fireball', tactic='TRanged("mut_fireball")')
    ffx.RegTimer('updateprim',2,6,char,'mut_fireball')
    Mission_CustomAction('mut_firebomb',char,char,'mut_firebomb',5,0)
    FFX_ObjectSetAttr(char,'firebomb',1)
    m25ai.AddGoal_DynamicAbility(char, temp_attribute='firebomb', tactic='TArea("mut_firebomb")')
    Object_SetAttr(char,'material',4)
    mutFX(char,'effect_ffx_flames2')
    ffx.RegTimer('updateflame',2,0,char)

def removefire(char):
    if cshelper.isPlaying()==0:
        Mission_StatusText('flame powers fading...')
    Mission_RemoveCustomAction('mut_firebomb',char,char)
    ffx.removeCommand('mut_fireball',char)
    FFX_ObjectSetAttr(char,'fireball',0)
    FFX_ObjectSetAttr(char,'firebomb',0)
    Object_SetAttr(char,'material',ffx.FFX_ObjectGetAttr(char,'baseMat'))
    mutFX(char,'')

def updateflame(event):
    char=event.object
    if ffx.FFX_ObjectGetAttr(char,'mut1')==6:
        if cshelper.isPlaying()==0:
            Trigger_Explosion(char,'ffx_overheated',-1)
        ffx.RegTimer('updateflame',2,0,char)

def mut_fireball(target,char):
    Trigger_Power(char,target,'mut_fireball','')

def mut_firebomb(target,char):
    Trigger_Power(char,char,'mut_firebomb','')

############# INVULN

def addinvuln(char):
    if cshelper.isPlaying()==0:
        Mission_StatusText('invulnerability activating...')
    Object_SetAttr(char,'minHealth',Object_GetAttr(char,'health'))
    FFX_SetMassFactor(char,10)

def removeinvuln(char):
    if cshelper.isPlaying()==0:
        Mission_StatusText('invulnerability fading...')
    Object_SetAttr(char,'minHealth',0)
    FFX_SetMassFactor(char,1)

############ SUPERSPEED

def addspeed(char):
    if cshelper.isPlaying()==0:
        Mission_StatusText('super-speed activating...')
    Object_SetAttr(char,'speed',9)
    Object_SetAttr(char,'agility',9)
    ffx.RegTimer('mutspdupdate',1,0,char)
    mutFX2(char,'effect_ffxabsorbspeed')

def mutspdupdate(event):
    char=event.object
    if ffx.FFX_ObjectGetAttr(char,'mut2')!=1:
        return
    hp=1+Object_GetAttr(char,'health')
    mp=Object_GetAttr(char,'maxHealth')
    if hp<=mp and hp>1:
        Object_SetAttr(char,'health',hp)
    ffx.RegTimer('mutspdupdate',1,0,char)

def removespeed(char):
    if cshelper.isPlaying()==0:
        Mission_StatusText('super-speed fading...')
    Object_SetAttr(char,'speed',Object_GetAttr(char,'templateSpeed'))
    Object_SetAttr(char,'agility',Object_GetAttr(char,'templateAgility'))
    mutFX2(char,'')

############ FORCEFIELD

def addforcefield(char):
    if cshelper.isPlaying()==0:
        Mission_StatusText('forcefield activating...')
    Object_SetAttr(char,'minHealth',Object_GetAttr(char,'health'))
    mutFX2(char,'effect_ffx_blueshield','centre')
    ffx.RegTimer('mutffupdate',1,0,char)

def mutffupdate(event):
    char=event.object
    if ffx.FFX_ObjectGetAttr(char,'mut2')==2:
        if cshelper.isPlaying()==0:
            ff.RPG_KB_JITTER_SCALE = 0 ###! prevent screen from shaking
            Trigger_Explosion(char,'mut_repel')
        ffx.RegTimer('mutffupdate',2,0,char)

def removeforcefield(char):
    if cshelper.isPlaying()==0:
        ff.RPG_KB_JITTER_SCALE = Mission_GetAttr('ff_RPG_KB_JITTER_SCALE') ###!
        Mission_StatusText('forcefield fading...')
    Object_SetAttr(char,'minHealth',0)
    mutFX2(char,'')

############ DUPLICATION

def addduplication(char):
    if cshelper.isPlaying()==0:
        Mission_StatusText('duplication activating...')
    Mission_CustomAction('mut_clone',char,char,'mut_clone',5,0)
    FFX_ObjectSetAttr(char,'cloning',1)
    m25ai.AddGoal_DynamicAbility(char, temp_attribute='cloning', tactic='TCloneSelf("dejavu Clone Self",situation="not lowerenergy=90")')

def removeduplication(char):
    if cshelper.isPlaying()==0:
        Mission_StatusText('duplication fading...')
    Mission_RemoveCustomAction('mut_clone',char,char)
    FFX_ObjectSetAttr(char,'cloning',0)
    temp=Object_GetTemplate(char)
    for obj in Mission_GetDynamicObjects():
        if obj[:4]=='mobj' and Object_GetTemplate(obj)==temp:
            Object_Destroy(obj)

def mut_clone(dummy,char):
    Trigger_Power(char,char,'dejavu Clone Self','')

############### PROBABILITY

def addprobability(char):
    if cshelper.isPlaying()==0:
        Mission_StatusText('probability control activating...')
    ffx.addCommand('mut_jinx',char,'mut_jinx',30,0)
    FFX_ObjectSetAttr(char,'jinx',1)
    m25ai.AddGoal_DynamicAbility(char, temp_attribute='jinx', tactic='TDirect("mut_jinx")')
    ffx.RegTimer('updatesecond',2,4,char,'mut_jinx')
    ffx.FFX_ObjectSetAttr(Object_GetTemplate(char),'jinx',1)
    ffx.initjinx(char,0)

def removeprobability(char):
    if cshelper.isPlaying()==0:
        Mission_StatusText('probability control fading...')
    ffx.removeCommand('mut_jinx',char)
    FFX_ObjectSetAttr(char,'jinx',0)
    ffx.FFX_ObjectSetAttr(Object_GetTemplate(char),'jinx',0)

def mut_jinx(target,char):
    Trigger_Power(char,target,'mut_jinx','')

############### ACID

def addacid(char):
    if cshelper.isPlaying()==0:
        Mission_StatusText('poisonous blood activating...')
    ffx.addCommand('mut_acid',char,'mut_acid',30,0)
    FFX_ObjectSetAttr(char,'shoot acid',1)
    m25ai.AddGoal_DynamicAbility(char, temp_attribute='shoot acid', tactic='TRanged("mut_acid")')
    ffx.RegTimer('updatesecond',2,5,char,'mut_acid')
    ffx.FFX_ObjectSetAttr(Object_GetTemplate(char),'acidblood',1)
    ffx.initacidblood(char,0)

def removeacid(char):
    if cshelper.isPlaying()==0:
        Mission_StatusText('poisonous blood fading...')
    ffx.removeCommand('mut_acid',char)
    FFX_ObjectSetAttr(char,'shoot acid',0)
    ffx.FFX_ObjectSetAttr(Object_GetTemplate(char),'acidblood',0)

def mut_acid(target,char):
    Trigger_Power(char,target,'mut_acid','')

####################### BULK TELEPORTER #######################################

def initbulktp(char,update=0):
    for obj in Mission_GetObjects():
        if Object_GetClass(obj)&OC_GENERIC:
            Mission_CustomAction('CUSTOM_BULKTP',char,obj,'OnBulkTP',30,0)

def OnBulkTP(target,char):
    if chargeEP(char,33)==0:
        return
    Trigger_Power(char,target,getByTemplate(char,FFX_BULKTP_CUSTOM,1),'')
    RegTimer('OnBulkTP2',2,0,char,target)

def OnBulkTP2(event):
    maketeleportobject(event.string,event.object)

def initwebslinger(char,update=0):
    for obj in Mission_GetObjects():
        if Object_GetClass(obj)&OC_GENERIC:
            Mission_CustomAction('CUSTOM_WEBPULL',char,obj,'OnWebPull',30,0)

def OnWebPull(target,char):
    if chargeEP(char,33)==0:
        return
    Trigger_Power(char,target,getByTemplate(char,FFX_WEBSLINGER_CUSTOM,1),'')
    RegTimer('OnWebPull2',2,0,char,target)

def OnWebPull2(event):
    makepull(event.string,event.object,Object_GetAttr(event.object,'strength')/2)

###################### ILLUSIONIST ###############################

def initillusionist(char,update=0):
    if isMP():
        return
    RegTimer('updateillusionist',0.1,0,char)
    RegDeath(char,'masterDie',4)
    RegCharState(char,0,'masterDie',0,4)
    RegTimer('masterUpdate',1,4,char)

def updateillusionist(event):
    char=event.object
    if Object_Exists(char)==0:
        return
    update=event.user
    illusions=0
    RegTimer('updateillusionist',5,1,char)
    cmd='CUSTOM_ILLUSION'
    try:
        cmd=getByTemplate(char,FFX_ILLUSIONIST_CUSTOM,2)
    except:
        pass
    addCommandChars(cmd,char,'OnIllusion',30,update,char)

def OnIllusion(target,char):
    if chargeEP(char,33)==0:
        return
    name=getDummyName()
    pos=GetSpawnPos(target,char,60)
    FFX_SetPos('illusion%s'%(char),pos)
    cshelper.spawn(name,'portal_start_proxy',pos)
    Trigger_Power(char,name,getByTemplate(char,FFX_ILLUSIONIST_CUSTOM,1),'')
    RegTimer('OnIllusionA',2,0,char,target)
    RegTimer('destroyTemp',6,0,name)

def OnIllusionA(event):
    target=event.string
    char=event.object
    name=getDummyName()
    template=Object_GetTemplate(char)
    cmd='CUSTOM_ILLUSION'
    try:
        testtemp=getByTemplate(char,FFX_ILLUSIONIST_CUSTOM,3)
    except:
        pass
    if Template_Exists(testtemp):
        template=testtemp
    cshelper.spawn(name,template,FFX_GetPos('illusion%s'%(char)))
    alignWith(name,char)
    Object_SetAttr(name,'health',1)
    Object_SetSecondaryState(name,SCSTATE_POWER_NULLIFICATION,10000,0)
    FFX_DestroyPortrait(name)
    RegTimer('removeFX',0.5,2,name)
    FFX_ObjectSetAttr(name,'master',Object_GetAttr(char,'ffxID'))
    FFX_ObjectSetAttr(name,'minionType',4)
    RegTimer('UnIllusion',20,0,name,char)
    if usingM25AI(): m25ai.AIDisable(name)  #(m25) prevent the AI from doing anything before the illusion is complete
    initMinionAI(name,m25ai.GetTeam(char),target,isEvil(char))
    makeIllusion(name)
    if usingM25AI(): m25ai.AIEnable(name) #(m25) turn the AI back on now that the illusion is set up
    if Object_Exists(target)==0:
        target = m25ai.FindTarget(name)
    addKillGoal(target,name,PRI_HI)

def UnIllusion(event):
    bubblesOff(event)
    RegTimer('bubblesOn',0.5)
    Object_SetPrimaryState(event.object,PCSTATE_EXILE,10,0)
    RegTimer('destroyTemp',2,0,event.object)


####################### GENERAL UTILITY FUNCTIONS #########################

def distanceSq(object1,object2):
    pos1=Get_ObjectPos(object1)
    pos2=Get_ObjectPos(object2)
    diff=Vector_Sub(pos1,pos2)
    return diff[0]*diff[0]+diff[1]*diff[1]+diff[2]*diff[2]

def distanceSqMO(object1,object2):
    pos1=Get_MarkerPos(object1)
    pos2=Get_ObjectPos(object2)
    diff=Vector_Sub(pos1,pos2)
    return diff[0]*diff[0]+diff[1]*diff[1]+diff[2]*diff[2]

def fallOver(char,intensity=1):
    minForce=Object_GetAttr(char,'minForce')
    Object_SetAttr(char,'minForce',1)
    Trigger_Force(char,0,0,1,intensity*minForce,TF_ABSOLUTE)
    if minForce!=1:
        RegTimer('restoreBalance',0.1,minForce,char)

def restoreBalance(event):
    Object_SetAttr(event.object,'minForce',event.user)

def chargeEP(char,cost):
    if cost>0 and (Object_GetSecondaryStates(char)&SCSTATE_POWER_NULLIFICATION)!=0:
        return 0
    ep=Object_GetAttr(char,'energyPoints')
    ep=ep-cost
    if ep<0:
       if FFX_RULES_PUSHEP:
           if FFX_Rand(1,50)<(-ep):
               Object_SetPrimaryState(char,PCSTATE_STUNNED,5,0)
               return 0
       else:
           return 0
    Object_SetAttr(char,'energyPoints',ep)
    return 1

######################################################################
#
# deals with hidden heroes in mid shapeshift
#
######################################################################

def getHiddenHeroes():
    return Mission_GetAttr('hiders')
   
def addHider():
    Mission_SetAttr('hiders',Mission_GetAttr('hiders')+1)
#    Mission_StatusText('hiders=%d'%(Mission_GetAttr('hiders')))

def delHider():
    Mission_SetAttr('hiders',Mission_GetAttr('hiders')-1)
#    Mission_StatusText('hiders=%d'%(Mission_GetAttr('hiders')))

#########################################################################
#
# safe set/get attr functions
#
########################################################################

def FFX_ObjectSetAttr(char,name,value):
    Mission_SetAttr('%s_%s'%(char,name),value)

def FFX_ObjectGetAttr(char,name,default=0):
    try:
        return Mission_GetAttr('%s_%s'%(char,name))
    except:
        return default

def FFX_TemplateSetAttr(char,name,value):
    Mission_SetAttr('%s_%s'%(Object_GetTemplate(char),name),value)

def FFX_TemplateGetAttr(char,name,default=0):
    try:
        return Mission_GetAttr('%s_%s'%(Object_GetTemplate(char),name))
    except:
        return default

def FFX_SetPos(name,pos):
    FFX_ObjectSetAttr(name,'X0',pos[0])
    FFX_ObjectSetAttr(name,'Y0',pos[1])
    FFX_ObjectSetAttr(name,'Z0',pos[2])

def FFX_GetPos(name):
    try:
        return (FFX_ObjectGetAttr(name,'X0'),FFX_ObjectGetAttr(name,'Y0'),FFX_ObjectGetAttr(name,'Z0'))
    except:
        return (0,0,0)

#################################################################################
#
#utilities for adding and removing commands to all objects for simulated attack powers
#
#################################################################################

def addCommand(command,char,fn,range,update=0):
#    print 'adding command %s to %s'%(command,char)
    attrName='%s%s'%(command,char)
    if (FFX_ObjectGetAttr(char,command)!=0) & (update==0):
        return
    FFX_ObjectSetAttr(char,command,1)
    if update==0:
        for temp in templates:
            Mission_CustomAction(command,char,temp[0],fn,range,0)
        for tempc in charTemplates:
            Mission_CustomAction(command,char,tempc,fn,range,0)
    for obj in Mission_GetDynamicObjects():
        temp=Object_GetTemplate(obj)
        match=0
        for template in templates:
            if temp==template[0]:
                match=1
        for templ in charTemplates:
            if temp==templ:
                match=1
        if match==0:
            if (FFX_ObjectGetAttr(obj,attrName)==0) | (update==0):
                Mission_CustomAction(command,char,obj,fn,range,0)
                FFX_ObjectSetAttr(obj,attrName,1)

def removeCommand(command,char):
#    print 'removing command %s from %s'%(command,char)
    attrName='%s%s'%(command,char)
    FFX_ObjectSetAttr(char,command,0)
    for temp in templates:
        Mission_RemoveCustomAction(command,char,temp[0])
    for tempc in charTemplates:
        Mission_RemoveCustomAction(command,char,tempc)
    for obj in Mission_GetDynamicObjects():
        temp=Object_GetTemplate(obj)
        match=0
        for template in templates:
            if temp==template[0]:
                match=1
        for templ in charTemplates:
            if temp==templ:
                match=1
        if match==0:
            Mission_RemoveCustomAction(command,char,obj)
            FFX_ObjectGetAttr(obj,attrName,0)

def addCommandChars(command,char,fn,range,update=0,exclude=''):
#    print 'adding command %s to %s'%(command,char)
    attrName='%s%s'%(command,char)
    if (FFX_ObjectGetAttr(char,command)!=0) & (update==0):
        return
    FFX_ObjectSetAttr(char,command,1)
    if update==0:
        for tempc in charTemplates:
            Mission_CustomAction(command,char,tempc,fn,range,0)
    for obj in Mission_GetDynamicObjects():
        if FFX_ObjectGetAttr(obj,'master')!=Object_GetAttr(char,'ffxID') and obj!=exclude:
            temp=Object_GetTemplate(obj)
            match=0
            for templ in charTemplates:
                if temp==templ:
                    match=1
            if match==0:
                if (FFX_ObjectGetAttr(obj,attrName)==0) | (update==0):
                    Mission_CustomAction(command,char,obj,fn,range,0)
                    FFX_ObjectSetAttr(obj,attrName,1)

def removeCommandChars(command,char):
#    print 'removing character command %s from %s'%(command,char)
    FFX_ObjectSetAttr(char,command,0)
    for tempc in charTemplates:
        Mission_RemoveCustomAction(command,char,tempc)
    for obj in Mission_GetDynamicObjects():
        if Object_GetClass(obj)&FFX_CHARACTER:
            match=0
            temp=Object_GetTemplate(obj)
            for templ in charTemplates:
                if temp==templ:
                    match=1
            if match==0:
                Mission_RemoveCustomAction(command,char,obj)

def FFX_GetObjects(mask,update):
    if (mask&OC_GENERIC)==0:
        return Mission_GetDynamicObjects()
    if update==0:
        return Mission_GetObjects()
    else:
        return Mission_GetDynamicObjects()

#reg 21 against all characters who havent been done so far
    
# stumpy 2007-01-02: we need to clear the FFX attrib for character
# objects when they are destroyed so that they will be re-registered
# if the same names are used for another spawned character. We may do
# that sort of re-using of object names in FFX and some campaign
# missions definitely do it (e.g. the wraiths and subterrestrials in
# the main campaign). (This may also be necessary for non-character
# objects, but I am holding off on that to keep regObjectDestroy sinks
# low.)
def regPowerAgainstChars(char,fn,powerID,update=0):
    attrName='%s%s'%(fn,char)
    mask=FFX_CHARACTER
    #register against generic objects as well for pull and throw attacks
    if fn[-5:]=='throw' or fn[-4:]=='pull' or fn[:5]=='limey' or fn[-4:]=='port' or fn[-1:]=='G' or fn[-6:]=='absorb':
        mask=mask|OC_GENERIC
    objs=FFX_GetObjects(mask,update)
    for obj in objs:
        if Object_GetClass(obj)&mask:
            if FFX_ObjectGetAttr(obj,attrName)==0:
                #if type(powerID) != FloatType:
                if not ( (type(powerID) == FloatType) or (type(powerID) == IntType) ): #Ep. 2006-09-05: Prevent a bug when powerID was 0 or another integer
                    for p in powerID:
                        RegPowerHit(char,obj,fn,p)
                else:
                    if powerID!=0:
                        RegPowerHit(char,obj,fn,powerID)
                    else:
                        for id in builtinPowerIDs:
                            RegPowerHit(char,obj,fn,id)
                FFX_ObjectSetAttr(obj,attrName,1)
                # adding this to reset attribute when character objects are destroyed. I don't think that happens in RR sessions
                if Object_GetClass(obj)&FFX_CHARACTER and missionobjvar.isCampaign():
                    mlogreader.regObjectDestroy(obj, 'ffx.clearCarrierRegistration', string = attrName)
    #register against ground for limey lures
    if (fn[:5]=='limey' or fn[-1:]=='G') and update==0:
        obj=Object_GetTerrain()
        if (FFX_ObjectGetAttr(obj,attrName)==0):
            if type(powerID) != FloatType:
                for p in powerID:
                     RegPowerHit(char,obj,fn,p)
            else:
                RegPowerHit(char,obj,fn,powerID)

def clearCarrierRegistration(event):
    obj = event.object
    attrName = event.string
    print 'clearCarrierRegistration: clearing attribute %s for destroyed object %s' % (repr(attrName),repr(obj))
    FFX_ObjectSetAttr(obj,attrName,0)

######################################
#
# get layout prop objects by template
#
######################################

#Ep. 2006-08-23: Changed to use FFvsTTR's Mission_GetObjects()
def getObjectsByTemplate(template):
    objList = []
    #Ep. 2006-09-10: Prevent the map itself (whose template is '') from appearing in that list
    staticObjects = list( Mission_GetObjects() )
    staticObjects.remove( Object_GetTerrain() )
    for obj in staticObjects:
            if Object_GetTemplate(obj) == template:
                objList.append(obj)
    return objList


##################################################################
#
# get all heroes at start of game and restore using campaign stuff
#
##################################################################
#Note that much of this section is obsolete

#Ep. 2006-08-23: Added to replace the hard-coded ffxextras.builtinHeroes tuple
#Returns a list of characters in objects.dat with the GAME_OBJ_HERO class.
def getBuiltinHeroes():
    builtins = []
    chars = datfiles.Campaign_ReadObjects()
    for k in chars.keys():
        if ( chars[k].has_key('class') ) and ( chars[k]['class'] == 'GAME_OBJ_HERO' ):
            builtins.append(k)
    return builtins

builtinHeroes = getBuiltinHeroes() #Ep.2006-08-23: replaced hard-coded ffxextras.py tuple

#returns 1 for first hero above, 2 for second etc.
#or custom template number for custom recruits

def getHeroID(char):
    try:
        template=Object_GetTemplate(char)
        i=0
        for name in builtinHeroes:
            i=i+1
            if template==name:
                return i
        numberStr=template[16:]
        print 'numberStr=%s'%(numberStr)
        return -(string.atoi(numberStr))
    except:
        return 0

#gets the template which this character started the mission with
def getOriginalTemplate(char):
    attr='id_%d'%(FFX_ObjectGetAttr(char,'originalIndex'))
    try:
        id=Mission_GetAttr(attr)
        template=getTemplateFromID(id)
        return template
    except:
        return ''

#takes number above and turns it back into a template
def getTemplateFromID(id):
    if (id>0):
        return builtinHeroes[int(id-1)]
    return 'custom_template_%d'%(-id)

def storeHeroes():
    i=1
    for hero in cshelper.getAllHeroes():
        if hero[:5]!='hero_':
            attr='id_%d'%(i)
            FFX_ObjectSetAttr(hero,'originalIndex',i)
            value=getHeroID(hero)
            Mission_SetAttr(attr,value)
            print 'storing %s: %s,%d'%(hero,attr,value)
            i=i+1
    for hero in ('hero_0','hero_1','hero_2','hero_3','hero_4'):
        if Object_Exists(hero):
            attr='id_%d'%(i)
            FFX_ObjectSetAttr(hero,'originalIndex',i)
            value=getHeroID(hero)
            Mission_SetAttr(attr,value)
            print 'storing %s: %s,%d'%(hero,attr,value)
            i=i+1

def addExtraHeroToList(char,index=6):
    Mission_SetAttr('id_%d'%(index),getHeroID(char))

def originalHeroes():
    list=[]
    for i in range(1,7):
        try:
            attr='id_%d'%(i)
            print 'retrieving: %s'%(attr)
            id=Mission_GetAttr(attr)
            template=getTemplateFromID(int(id))
            list.append(template)
        except:
            print 'cant find id %d'%(i)
    return list

##############################################
#
# solves the following problems -
# hero may be pickled by explosive/laser
# hero may be in form_X after shapeshifting/mimicking
# STRANGERS SPECIFIC - hero may be penny/alculbus separated
#
##############################################

def restoreHeroes(event):
    #force explosive/living laser back to normal
    #unPickleAll()
    #force shapechangers back to normal
    for hero in cshelper.getAllHeroes():
        if hero[:5]=='form_':
            index=FFX_ObjectGetAttr(hero,'originalIndex')
            print '%s has index of %d'%(hero,index)
            originalName='hero_%d'%(index)
            templateID=Mission_GetAttr('id_%i'%(index))
            template=getTemplateFromID(int(templateID))
            print 'creating %s [%s]'%(originalName,template)
            morph(originalName,hero,template,0)
    #force alcubus to remerge - strangers specific
    if Object_Exists('alcubus') & Object_Exists('penny'):
        Object_Destroy('alcubus')
        RegTimer('OnReturn',0.3)
    if cshelper.isPlaying():
        RegTimer('removeRings',2)

def removeRings(event):
    UI_Enable(0)

###################################################
#
# places custom recruits in base cutscenes at 'custom_1','custom_2', etc.
#
###################################################

def evTest(id,ofilter='',efilter=0,user=0):
    if id>0:
        agent=getAllHeroes()[0]
        print agent
        js.Event_RegisterSink(id, 'OnInfo', agent, ofilter, efilter, user, 0)
    else:
        for i in range(1,33):
            print i
            js.Event_RegisterSink(id, 'OnInfo', 'hero_0', ofilter, efilter, user, 0)

def OnInfo(event):
    Campaign_Recruit('blitzkrieg')
    print 'obj=%s str=%s'%(event.object,event.string)
    print 'ev=%f user=%f float=%f data=%f'%(event.event,event.user,event.float,event.data)


##################################################################
#
# MESH MANIPULATION
#
##################################################################

def makeMimicSkin(template):
    mesh=getMesh(template)
    if mesh=='':
        print 'problem making a mimic skin for %s'%(char)
    try:
        dest='strangers/art/%s'%(mesh)
        os.mkdir(dest)
    except:
        standardAlreadyThere=1
    try:
        dest='strangers/art/%sskins'%(mesh)
        os.mkdir(dest)
    except:
        standardAlreadyThere=1
    try:
        dest='strangers/art/%sskins/standard'%(mesh)
        os.mkdir(dest)
    except:
        standardAlreadyThere=1
    dest='strangers/art/%sskins/standard/mimic.tga'%(mesh)
    print dest
    shutil.copy(mimicSkin,dest)

#############################################################################
#
# REPLACEMENT REG- FUNCTIONS FOR CONVENIENCE (NOTE CAPITALISATION)
#
#############################################################################

def RegDeath(object, fn, user = 0, string = '', persistent = 0): ###! added string method and persistence (because FFvsTTR resurrection) - Ep. 2006-07-05
    js.Event_RegisterSink(EVENT_OBJ_HEALTHCHANGED, fn, object, string, 0, user, persistent)

#ALERT! DIFFERENT ORDER OF VARIABLES FROM regTimer!
#
#see also RegTimer2 under the STUMPY HELPERS section toward the end of this file ###!
def RegTimer(fn, time, user = 0, thing1='', thing2='', persistent = 0):
    js.Event_RegisterSink(EVENT_TIMER, fn, thing1, thing2, time, user, persistent)
    #print 'ffx regtimer %s : %f'%(fn,time)

def RegAlmostDead(char, fn, health = 1, user = 0, string = '', persistent = 0):
    Object_SetAttr(char, 'minHealth', health)
    js.Event_RegisterSink(EVENT_OBJ_HEALTHCHANGED, fn, char, string, health+1, user, persistent)

def RegPickup(object, fn, character = '', user = 0):
    js.Event_RegisterSink(EVENT_PICKUP, fn, object, character, 0, 0, 0)

def RegDamage(object, fn, user = 0, persistent = 0, string = ''): ###! added string method (pushed back at the end for compatibility)
    js.Event_RegisterSink(EVENT_OBJ_HEALTHCHANGED, fn, object, string, 1000, user, persistent)

def RegShieldDamage(character, fn, user = 0, persistent = 0):
    js.Event_RegisterSink(EVENT_OBJ_SHIELD_DAMAGED, fn, character, '', 1000, user, persistent)

def RegPowerUse(character, power, fn, persistent = 0, user = 0):
    js.Event_RegisterPowerUse(character, power, fn, persistent, user)

#This doesn't register the start of a movement, but rather its end
#Special movements like speeding bullet don't register.
def RegMove(char,fn='OnInfo',filter='',ifilter=0):
    js.Event_RegisterSink(27,fn,char,filter,ifilter,0,1)

#the mysterious reg-21 triggers when the power specified is used by character on target
def RegPowerHit(character,target,fn,powerID,user=1,persistent=1):
    Event_RegisterSink(EVENT_POWER_HIT,fn,target,character,powerID,persistent,user)
    #print 'reg power hit ' + character + ' ' + target + ' ' + fn + ' ' + `powerID`

#used everywhere for destroying temporary objects
def destroyTemp(event):
    char=event.object
    #destroy all FX on the character - the sounds get left behind sometimes!
    handle=Object_PlayEffect(char,'effect_ffx_gun')
    for i in range(0,handle):
        Object_StopEffect(char,i)
    Object_Destroy(char)

#used everywhere for destroying temporary objects
def killTemp(event):
    cshelper.kill(event.object)


#############################################################################################
#
# SUNLIGHT CODE
#
#############################################################################################

def FFX_Sun(a1,a2,ambient,direct,color,cosmetic=0):
    Mission_SetSunlight(a1,a2,ambient,direct,color)
    if cosmetic==0:
        Mission_SetAttr('lightLevels',ambient+direct*(color[0]+color[1]+color[2])*0.4)
    Mission_SetAttr('cosmeticSun',cosmetic)
    Mission_SetAttr('ambientBase',ambient)
    Mission_SetAttr('ambient',ambient)
    Mission_SetAttr('directBase',direct)
    Mission_SetAttr('direct',direct)
    Mission_SetAttr('angle1',a1)
    Mission_SetAttr('angle2',a2)
    Mission_SetAttr('redsun',color[0])
    Mission_SetAttr('greensun',color[1])
    Mission_SetAttr('bluesun',color[2])
    Mission_SetAttr('ambientLevel',ambient)
    Mission_SetAttr('directLevel',direct)

def FFX_UpdateSun(event):
    RegTimer('FFX_UpdateSun',1)
    try:
        if Mission_GetAttr('cosmeticSun'):
            return
        ambient=Mission_GetAttr('ambient')
        direct=Mission_GetAttr('direct')
        color=(Mission_GetAttr('redsun'),Mission_GetAttr('greensun'),Mission_GetAttr('bluesun'))
        light=0
        directBase=Mission_GetAttr('directBase')
        ambientBase=Mission_GetAttr('ambientBase')
        stepUp=0.01
        if Mission_GetAttr('lightStep')!=0:
            stepUp=Mission_GetAttr('lightStep')
        stepDown=0.1
        if Mission_GetAttr('lightStep')!=0:
            stepDown=Mission_GetAttr('lightStep')
        if ambient<ambientBase:
            ambient=ambient+stepUp
            if ambient>ambientBase:
                ambient=ambientBase
            light=1
        if direct<directBase:
            direct=direct+stepUp
            if direct>directBase:
                direct=directBase
            light=1
        if ambient>ambientBase:
            ambient=ambient-stepDown
            if ambient<ambientBase:
                ambient=ambientBase
            light=1
        if direct>directBase:
            direct=direct-stepDown
            if direct<directBase:
                direct=directBase
            light=1
        if light!=0:
            Mission_SetAttr('ambient',ambient)
            Mission_SetAttr('direct',direct)
            a1=Mission_GetAttr('angle1')
            a2=Mission_GetAttr('angle2')
            Mission_SetSunlight(a1,a2,ambient,direct,color)
        else:
            Mission_SetAttr('lightStep',0)
        Mission_SetAttr('lightLevels',(ambient+direct)*(color[0]+color[1]+color[2])*0.4)
    except:
        print 'FFX_UpdateSun: getting default sun'
        settings=Mission_GetSunlight()
        print 'FFX_UpdateSun: setting = %s' % (settings,)
        Mission_SetAttr('angle1',settings[0])
        Mission_SetAttr('angle2',settings[1])
        Mission_SetAttr('ambient',settings[2])
        Mission_SetAttr('direct',settings[3])
        Mission_SetAttr('ambientBase',settings[2])
        Mission_SetAttr('directBase',settings[3])
        Mission_SetAttr('ambientLevel',settings[2])
        Mission_SetAttr('directLevel',settings[3])
        Mission_SetAttr('redsun',settings[4][0])
        Mission_SetAttr('greensun',settings[4][1])
        Mission_SetAttr('bluesun',settings[4][2])
        Mission_SetAttr('lightLevels',(settings[2]+settings[3])*(settings[4][0]+settings[4][1]+settings[4][2])*0.4)

def getLightLevels():
    try:
        return Mission_GetAttr('lightLevels')
    except:
        settings=Mission_GetSunlight()
        return (settings[2]+settings[3])*(settings[4][0]+settings[4][1]+settings[4][2])*0.4

##################### MULTIPLAYER MESSAGE SYSTEM #######################################################

MP_CRYSTALLISE=1
MP_VERTIGO=2
MP_GRAVITYINCREASE=3
MP_TELEPORTOTHER=4
MP_TRANSMUTE=5
MP_LIFEDRAIN=6
MP_SHRINK=7
MP_FIRECAGE=8
MP_MAGNETISE=9
MP_SHIELD_S=10  # shield from special power
MP_NORMALISE=11
MP_ACCELERATE=12
MP_DENSITYINCREASE=13
MP_VLIFEDRAIN=14
MP_SHIELD_N=15  # shield from normal power
###!
MP_LEADERSHIP=20
MP_BREACH=21
MP_ROQUE=22
MP_REMOTEEMPATHY=23

mpChars=['non','s1:h0','s1:h1','s1:h2','s1:h3','s2:h0','s2:h1','s2:h2','s2:h3','s3:h0','s3:h1','s3:h2','s3:h3','s4:h0','s4:h1','s4:h2','s4:h3',]

def MPStart():
    Mission_SetAttr('ffxMPType',0)
    if Object_Exists('s1:h0'):
        cshelper.spawn('message1','ffx_tiggot',(3000,3000,0))
        Object_SetAttr('message1','minHealth',1)
        Object_SetAttr('message1','maxHealth',500)
        cshelper.spawn('message2','ffx_tiggot',(3000,3000,0))
        Object_SetAttr('message2','minHealth',1)
        Object_SetAttr('message2','maxHealth',500)
        cshelper.spawn('message3','ffx_tiggot',(3000,3000,0))
        Object_SetAttr('message3','minHealth',1)
        Object_SetAttr('message3','maxHealth',500)
        cshelper.spawn('message4','ffx_tiggot',(3000,3000,0))
        Object_SetAttr('message4','minHealth',1)
        Object_SetAttr('message4','maxHealth',500)
        if Object_GetClass('s1:h0')&OC_CONTROLLABLE:
             Mission_SetAttr('ffxMPType',1)
        else:
             Mission_SetAttr('ffxMPType',2)
             RegDamage('message4','MPReceiveMessage')
        for i in range(1,17):
            if Object_Exists(mpChars[i]):
                Object_SetAttr(mpChars[i],'ffxMPID',i)

def MPSendMessage(type, param1, param2=100, param3=100):
    if Mission_GetAttr('ffxMPType')!=1:
        return
    #force a health synch across the network
    Trigger_Damage('message1',Object_GetAttr('message1','health')-type)
    Trigger_Damage('message2',Object_GetAttr('message2','health')-param1)
    Trigger_Damage('message3',Object_GetAttr('message3','health')-param2)
    damage4=Object_GetAttr('message4','health')-param3
    #force damage4 to be an actual value to trigger the event
    if damage4==0:
        if Object_GetAttr('message4','health')<50:
            damage4=-1
        else:
            damage4=1
#    print 'damage4:%d'%(damage4)
    Trigger_Damage('message4',damage4)
#    print 'Message broadcast: %d %d %d %d'%(type,param1,param2,param3)

def MPReceiveMessage(event):
    if Mission_GetAttr('ffxMPType')!=2:
        return
    RegDamage('message4','MPReceiveMessage')
    type=Object_GetAttr('message1','health')
    param1=Object_GetAttr('message2','health')
    param2=Object_GetAttr('message3','health')
    param3=Object_GetAttr('message4','health')
#    print 'Message received: %d %d %d %d'%(type,param1,param2,param3)
#    Mission_StatusText('Msg: %d %d %d %d'%(type,param1,param2,param3))
    char=mpChars[int(param1)]
    if Object_Exists(char)==0:
        return

    if type==MP_CRYSTALLISE:
        makeCrystallised(mpChars[int(param1)],'',param2)
    elif type==MP_VERTIGO:
        makevertigo(mpChars[int(param1)],'',param2)
    elif type==MP_GRAVITYINCREASE:
        makegravityincrease(mpChars[int(param1)],'',param2)
    elif type==MP_TELEPORTOTHER:
        maketeleportother(mpChars[int(param1)],'')
    elif type==MP_TRANSMUTE:
        maketransmuted(mpChars[int(param1)],'',param2)
    elif type==MP_LIFEDRAIN:
        makelifedrained(mpChars[int(param1)],mpChars[int(param2)],param3)
    elif type==MP_VLIFEDRAIN:
        makevlifedrained(mpChars[int(param1)],mpChars[int(param2)],param3)
    elif type==MP_SHRINK:
        makeshrink(mpChars[int(param1)],'',param2)
    elif type==MP_FIRECAGE:
        makeshrink(mpChars[int(param1)],'',param2)
    elif type==MP_MAGNETISE:
        makemagnetise(mpChars[int(param1)],'',param2)
    elif type==MP_SHIELD_S: # stumpy 2007-10-31: pass the extra parameter
        char = mpChars[int(param1)]
        source = mpChars[int(param2)]
        param3 = int(param3)
        intensity = param3 / 100
        state = param3 % 100
        makemshieldS(char,source,intensity,state)
    elif type==MP_SHIELD_N: # stumpy 2007-10-31: pass the extra parameter
        char = mpChars[int(param1)]
        source = mpChars[int(param2)]
        param3 = int(param3)
        intensity = param3 / 100
        state = param3 % 100
        makemshieldN(char,source,intensity,state)
    elif type==MP_NORMALISE:
        makenormalise(mpChars[int(param1)])
    elif type==MP_ACCELERATE:
        makeaccelerate(mpChars[int(param1)])

##################### OBSOLETE ATTRIBUTES _ LEFT IN FOR CHARACTERS IN OLD SAVE GAMES ###################

############## GUARDIANS #########################################

FFX_SHIELD_POWERS=[
["default","ffx_opticalshield"],
["andee-9","bullet Hyper Spin"],
["connection","ffx_mindshield"],
["baba yaga (old)","ffx_babayagashield"],
["optical girl","ffx_opticalshield"],
["adrian sharpethorne","alchemiss Deflection Shield"],
]

def initguardianm(char,update=0):
    if isMP():
        return
    attr='%s_mshield'%(char)
    Global_RegisterAttr(attr,0)
    for obj in Mission_GetDynamicObjects():
        if ((Object_GetClass(obj) & FFX_CHARACTER)!=0) & (obj!=char):
            if (Object_GetAttr(obj,attr)==0):
                Mission_CustomAction('CUSTOM_SHIELDM',char,obj,'OnMShield',30,0)
                Object_SetAttr(obj,attr,1)
    if update==0:
        Mission_CustomAction('CUSTOM_SHIELDM_TEAM',char,char,'OnMShieldAll',5,0)

def OnMShield(target,char):
    if chargeEP(char,FFX_EP_MINDSHIELD)==0:
        return
    Trigger_Power(char,target,'ffx_mindshield','')
    Trigger_Power(target,target,'ffx_tk_lift','')

def OnMShieldAll(dummy,char):
    if chargeEP(char,FFX_EP_MINDSHIELD)==0:
        return
    Trigger_Power(char,char,'ffx_tk_lift','')
    for obj in Mission_GetDynamicObjects():
        if ((Object_GetClass(obj) & (OC_CONTROLLABLE|OC_POLICE|OC_CIVILIAN))!=0) & (obj!=char):
            if distanceSq(obj,char)<250*250:
                Trigger_Power(obj,obj,'ffx_mindshield','')

def initguardianp(char,update=0):
    if isMP():
        return
    attr='%s_pshield'%(char)
    Global_RegisterAttr(attr,0)
    for obj in Mission_GetDynamicObjects():
        if ((Object_GetClass(obj) & FFX_CHARACTER)!=0) & (obj!=char):
            if (Object_GetAttr(obj,attr)==0):
                Mission_CustomAction('CUSTOM_SHIELDP',char,obj,'OnPShield',FFX_SHIELDRANGE,0)
                Object_SetAttr(obj,attr,1)
    if update==0:
        Mission_CustomAction('CUSTOM_SHIELDP_TEAM',char,char,'OnPShieldAll',5,0)

def OnPShield(target,char):
    if chargeEP(char,FFX_EP_PHYSICALSHIELD)==0:
        return
    Trigger_Power(char,target,'ffx_tk_lift','')
    Trigger_Power(target,target,getByTemplate(char,FFX_SHIELD_POWERS,1),'')

def OnPShieldAll(dummy,char):
    if chargeEP(char,FFX_EP_PHYSICALSHIELD)==0:
        return
    Trigger_Power(char,char,'ffx_tk_lift','')
    for obj in Mission_GetDynamicObjects():
        if ((Object_GetClass(obj) & (OC_CONTROLLABLE|OC_POLICE|OC_CIVILIAN))!=0) & (obj!=char):
            if distanceSq(obj,char)<250*250:
                Trigger_Power(obj,obj,getByTemplate(char,FFX_SHIELD_POWERS,1),'')

##################### BLOODSUCKER ############################################################

def initbloodsucker(char,update=0):
    attrName='%s_drain'%(char)
    Global_RegisterAttr(attrName,0)
    for obj in Mission_GetDynamicObjects():
        if ((Object_GetClass(obj) & FFX_CHARACTER)!=0) & (obj!=char):
            if (Object_GetAttr(obj,attrName)==0):
                powerID=FFX_POWER_CUSTOM
                Event_RegisterSink(21,'OnLifeDrain',obj,char,powerID,1.0,1)
                Object_SetAttr(obj,attrName,1)

def OnSuck(target,char):
    Trigger_Power(char,target,'default punch','')

def OnLifeDrain(event):
    if distanceSq(event.object,event.string)>1000:
        return
    Trigger_Damage(event.string,-randint(1,5))

def ForceTest(mass,force):
    Object_SetAttr('hero_0','mass',mass)
    pos=Get_ObjectPos('hero_0')
    Mission_SetAttr('startX',pos[0])
    Mission_SetAttr('startY',pos[1])
    Mission_SetAttr('force',force)
    Trigger_Force('hero_0',1,0,Mission_GetAttr('forceHeight'),force,TF_ABSOLUTE)
    RegTimer('ForceTest2',4)
    Object_SetAttr('hero_0','minHealth',10)

def ForceTest2(event):
    pos=Get_ObjectPos('hero_0')
    dx=Mission_GetAttr('startX')-pos[0]
    dy=Mission_GetAttr('startY')-pos[1]
    dist=sqrt(dx*dx+dy*dy)
    print 'Force=%d Mass=%d Dist=%d guess=%d'%(Mission_GetAttr('force'),Object_GetAttr('hero_0','mass'),dist,Mission_GetAttr('force')/(Object_GetAttr('hero_0','mass')*1.66))
    Mission_StatusText( 'Force=%d Mass=%d Dist=%d'%(Mission_GetAttr('force'),Object_GetAttr('hero_0','mass'),dist) )

#calculate the force required to push a character a certain distance
def GetForceForDistance(char,dist):
    mass=Object_GetAttr(char,'mass')
    return mass*dist*1.66

def FFX_Teleport(char,pos):
    marker='tp%s'%(char)
    if Marker_Exists(marker)==0:
        Marker_Spawn(marker,pos)
    else:
        Marker_SetPos(marker,pos)
    teleport(char,marker)

def FFX_TP(char,pos,fn='FFX_TP2',strboost=1):
    if pos[2]<500:
        makecloak(char,10)
    Trigger_Move(char,'walk',pos)
    spd=Object_GetAttr(char,'speed')
    if spd>Object_GetAttr(char,'baseSpeed'):
        spd=Object_GetAttr(char,'baseSpeed')
    FFX_ObjectSetAttr(char,'jumpSpeed',spd)
    str=Object_GetAttr(char,'strength')
    if str>Object_GetAttr(char,'baseStrength'):
        str=Object_GetAttr(char,'baseStrength')
    FFX_ObjectSetAttr(char,'jumpStrength',str)
    Object_SetAttr(char,'speed',1000) 
    if strboost:
        Object_SetAttr(char,'strength',1000)
    Trigger_Move(char,'move',pos,fn,strboost)

def FFX_TP2(event):
    char=event.object
#    print 'ffx_tp2:char=%s'%(char)
    Object_SetAttr(char,'strength',FFX_ObjectGetAttr(char,'jumpStrength'))
    Object_SetAttr(char,'speed',FFX_ObjectGetAttr(char,'jumpSpeed'))
    if (Object_GetSecondaryStates(char)&SCSTATE_INVISIBLE)==0:
        if hasAttribute(char,'heavyfooted'):
            pos=Get_ObjectPos(char)
            FFX_ObjectSetAttr(char,'lastY',pos[1])
            FFX_ObjectSetAttr(char,'lastX',pos[0])
            Trigger_Explosion(char,getByTemplate(char,FFX_HEAVYFOOTED_CUSTOM,1))
    else:
        makeUncloak(char)

    #M25 Feb 17 -  notify the ai when the character has finished teleporting
    try:
        if (Object_GetAttr(char,'ai_critical') > 0):
            ff.ResetCriticalAI(char,Object_GetAttr(char,'ai_critical'))
    except:
        pass
    #end update

def GetTargetPos(char,target):
    posT=Get_ObjectPos(target)
    posH=Get_ObjectPos(char)
    dx=posH[0]-posT[0]
    dy=posH[1]-posT[1]
    len=1.0+sqrt(dx*dx+dy*dy)
    len=30.0/len
    return (posT[0]+dx*len,posT[1]+dy*len,posT[2])

def findCharByID(id):
    for obj in Mission_GetDynamicObjects():
        if Object_GetAttr(obj,'ffxID')==id:
            return obj
    return ''

# makes a character physically ineffectual
def makeIllusion(char, fly=0):
    FFX_ObjectSetAttr(char, 'ffx_illusion', 1) #Ep. 2006-09-22: identifies illuory characters
    ff.RESULTBUBBLE_SCALE=0
    RegTimer('bubblesOn',0.1)
    if usingM25AI():
        m25ai.AISupport_DoSelfPowerTimed(char, 'ffx_illusion_defence', char, m25ai.TACTIC_PRIORITY_CRITICAL, 1.0, desc='activating illusion')
        #m25ai.AIDoPower(char, power='ffx_illusion_defence', target=char, priority=m25ai.TACTIC_PRIORITY_CRITICAL, description='activating illusion')
    else:   
        Trigger_Power(char,char,'ffx_illusion_defence','')
    Object_SetGenericState(char,OBJSTATE_ATTACKBONUS,10000,0)
    Object_SetAttr(char,'attackBonus',-10)
    Object_SetAttr(char,'strength',0)
    Object_SetAttr(char,'baseStrength',0)
    FFX_ObjectSetAttr(char, 'permanent_shield', FFX_ObjectGetAttr(char, 'permanent_shield') + 1 ) #Ep. 2006-09-23: indicates that the character has an active defence which shouldn't be removed by other scripts
    if fly:
        Object_SetSecondaryState(char,SCSTATE_BUOYANT,10000,0)

def removeFX(event):
    char=event.object
    handle=Object_PlayEffect(char,'effect_ffx_density')
    i=int(event.user)
    while i>=0:
        Object_StopEffect(char,handle)
        print handle
        handle=handle-1
        i=i-1

########### BASE CUTSCENE TRICKS ###########################

#initilaises a base cutscene
def FFX_InitBase(max,dupe=''):
    placeCustoms(max,dupe)

def placeCustoms(max,dupe=''):
    try:
        Mission_GetAttr('ffxCampaign')
    except:
        Mission_SetAttr('ffxCampaign',1)
    Mission_SetAttr("FFX_RULES_CAMPAIGN_M25AI",FFX_RULES_CAMPAIGN_M25AI)
    print 'placeCustoms'
    markerIndex=1
    Mission_SetAttr('ffxCustoms',markerIndex)
    for index in range(20,1000):
        template='custom_template_%d'%(index)
        if (Campaign_IsRecruited(template)!=0) & (template!=dupe):
            print 'isRecruited'
            if markerIndex<=max:
                print markerIndex
                marker='custom_%d'%(markerIndex)
                name='hero_%s'%(marker)
                cshelper.spawn(name,template,marker)
                RegTimer('tempCheck',2,0,name)
                Mission_SetAttr('ffxCustoms',markerIndex)
                markerIndex=markerIndex+1
    RegTimer('parseLogFile',0.8)

def tempCheck(event):
    name=event.object
    #stops them doing melee idle in front of villains
    cshelper.disable(name)
    if hasAttribute(name,'tempform') | hasAttribute(name,'involuntaryform') | (hasAttribute(object,'ffqamalgam')!=0):
        Object_Destroy(name)

def sayOnce(char,tag):
    said=0
    try:
       if Mission_GetAttr(tag)==1:
           said=1
    except:
       said=0
    if said==0:
        cshelper.speakNoCB(char,tag)
        Mission_SetAttr(tag,1)

def sayOnceFn(char,tag,fn):
    said=0
    try:
       if Mission_GetAttr(tag)==1:
           said=1
    except:
       said=0
    if said==0:
        cshelper.speakInternal(char,tag,fn)
        Mission_SetAttr(tag,1)

#returns a custom character by voice ID
def findByVoiceID(voice):
    candidates=[]
    for hero in cshelper.getAllHeroes():
        template=Object_GetTemplate(hero)
        if (template[:6]=='custom') & (Template_GetSpeechID(template)==voice):
            candidates.append(hero)
    if len(candidates)==0:
        return ''
    if len(candidates)==1:
        return candidates[0]
    return candidates[randint(0,len(candidates)-1)]

#determines if a character has a given trait by name
def hasTrait(char,trait):
    voice=Template_GetSpeechID(Object_GetTemplate(char))
    for set in ffxTraits:
        if set[0]==trait:
            for entry in set:
                if entry==voice:
                    return 1
    return 0

#returns a custom character by voice ID
def findByTrait(trait):
    candidates=[]
    for hero in cshelper.getAllHeroes():
        if (Object_GetTemplate(hero)[:6]=='custom') & hasTrait(hero,trait):
            candidates.append(hero)
    if len(candidates)==0:
        return ''
    if len(candidates)==1:
        return candidates[0]
    return candidates[randint(0,len(candidates)-1)]

def hextospeedkills(event):
    char=event.object
    #does nothing to non-speedsters
    if isNotSpeedster(char,''):
        Object_SetSecondaryState(char,SCSTATE_HEXED,0,REMOVE_STATE)
        return
    #kill any speedsters affected by this attack - outright!
#    print 'checking for death!'
    if FFX_GotState(char,SCSTATE_HEXED):
        print 'dead'
        cshelper.kill(char)


############################# FFQ code starts here ###########################################
# A.K.A. pimthe's playground  ;)

#---custom attributes FFQ-----------------------------------------------
#######################################################################################
###### FFQ tentative extensions to the utterly brilliant FFX/Stranger extensions ######
#######################################################################################
# Sorry about the omnipresent "FFQ" prefixes; it was only intended to allow easier debugging
# and to avoid duplicating names currently or eventually used by FFX or extensions to FFX
# (this project was begun at the time of FFX 1.2 or 1.3 and the code was directly in ffxS.py).
# BTW, the name only means "something like FFX" with the "X" replaced by the least prone to
# be used by somebody else letter I could think of. You see, at the time, I thought that there
# where already lots of people making their own custom extensions for FFX. =/

########################### INITIALISATION ############################################
# everything done automatically on startup should either be here, under the "else:" statement
# or called directly outside any function
def FFQ_initialiseExtras(event):
    #if a cutscene is playing, try again later
    if cshelper.isPlaying():
        cutsceneAlreadyLooping = event.user
        if cutsceneAlreadyLooping == 0:
            print "initialising FFQ_initialiseExtras() later: a cutscene is playing"
            cutsceneAlreadyLooping = 1
        js.Event_RegisterSink(EVENT_TIMER, 'FFQ_initialiseExtras', '', '', 1, cutsceneAlreadyLooping, 0)
    else:
        print "initialising FFQ_initialiseExtras()"
        #determine where is the first hero at the beginning
        FFQ_writeStartingPos()

if not FFX_INITIALIZED:
    js.Event_RegisterSink(EVENT_TIMER, 'FFQ_initialiseExtras', '', '', 1, 0, 0)



#################### CHARACTER ATTRIBUTES MANIPULATION ################################
# Functions related to FFX attributes. This section should probably be moved elsewhere in the file
# and regrouped with similar functions.

# The obsolete code removed FFX 3.3.0.1 TMX. Made obsolete in FFX 3.2.0.1 Ep. 2: Obsolete due to individual attribute setting by default.

# Added FFX 3.2
# Attributes which are not part of the template must be initialized with this function instead of being called directly!
# Returns whether the attribute was succesfully added or not. If the attribute was already present, the call is considered successful.
def addFFXAttrib(char, attrib):
    if not Object_Exists(char):
        print "addFFXAttrib(%s,%s) fatal error: character not found:" % (repr(char),repr(attrib))
        return 0
    if hasAttribute(char, attrib):
        print "addFFXAttrib(): attribute %s already present in %s (%s)" % (attrib, char, FFX_GetTemplate(char))
        return 1
    success = 0
    try:
        success = addFFXAttrib2(char, attrib)
    except:
        print "addFFXAttrib() fatal error:"
        print "    Cannot add new attribute %s to %s (%s)" % (attrib, char, FFX_GetTemplate(char))
        raise
        return 0
    if success != 1: #(0 or None)
        return 0
    return 1

def addFFXAttrib2(char, attrib):
    init = "init%s('%s')"%(attrib, char) # note that update isn't passed as parameter, as it's never been actually used
    exec init
    FFX_ObjectSetAttr(char, 'attr_%s' % attrib, 1)
    myAttribs = missionobjvar.Object_GetVar(char, 'ffx_attribs', defaultVal = [])
    myAttribs.extend([attrib])
    missionobjvar.Object_SetVar(char, 'ffx_attribs', myAttribs)
    print "addFFXAttrib2(): adding new attribute %s to %s (%s)" % (attrib, char, FFX_GetTemplate(char))
    return 1
    

# Added FFX 3.2
# Attributes must be removed with this function instead of being called directly with the remove parameter!
# To know which attributes are removable, use getRemovableAttributes() from the progrutils module.
# Returns whether the attribute was succesfully removed or not. If the attribute wasn't found, the call is considered successful.
def removeFFXAttrib(char, attrib):
    if not Object_Exists(char):
        print "removeFFXAttrib(%s,%s) fatal error character not found:" % (repr(char),repr(attrib))
        return 0
    if not hasAttribute(char, attrib):
        print "removeFFXAttrib(): attribute %s was not found in %s (%s)" % (attrib, char, FFX_GetTemplate(char))
        return 1
    success = 0
    if not isAttributeRemovable(attrib):
        print "removeFFXAttrib(%s,%s): attribute not removable" % (repr(char),repr(attrib))
        return 0
    try:
        success = removeFFXAttrib2(char, attrib)
    except:
        print "removeFFXAttrib() fatal error:"
        print "    Cannot remove attribute %s from %s (%s)" % (attrib, char, FFX_GetTemplate(char))
        raise
        return 0
    if success != 1: #(0 or None)
        return 0
    return 1

def removeFFXAttrib2(char, attrib):
    init = "init%s('%s', remove=1)"%(attrib, char)
    exec init
    FFX_ObjectSetAttr(char, 'attr_%s' % attrib, 0)
    myAttribs = missionobjvar.Object_GetVar(char, 'ffx_attribs', defaultVal = [])
    if attrib in myAttribs:
        myAttribs.remove(attrib)
    missionobjvar.Object_SetVar(char, 'ffx_attribs', myAttribs)
    print "removeFFXAttrib(): removing attribute %s from %s (%s)" % (attrib, char, FFX_GetTemplate(char))
    return 1

###! TO DO: Obsolete since FFX 2.6!
# FFX attributes (including simulated built-ins) which SHOULD be safe to add after startup.
# Guess what? Not all attributes have been tested. :P
# Notes:
# -Put in a function to avoid wasting more memory.
# -Combos are always considered unsafe.
# -Some attributes, while "safe", may wreck the game (ex.: borrowedtime), while others (ex.: groupteleport)
#  are useless to most characters; these are denoted by a 1 instead of a 2.
# -Currently, no attribute is marked as removable. 
# -The incompatible attribute sublist is basically to avoid initialising an attribute if the character already
#  has one from this sublist.
# -The scripted version of attribute may be assigned to a character already having the original, since
#  built-in attributes can't be detected.
# -May eventually be used (in FFX 2.6 or post FF2) as the basis for a Counter-Measure attribute ;)
def getAllFFXAttr():
    #   ["attribute", cost, safe to initialize by in-game script only (0=no, 1=yes, but should be avoided, 2=yes), removable (0=no, 1=yes), ["imcompatible attribute1", "imcompatible attribute2", "etc."]],
    ALL_FFX_ATTR = [
        ["absorber", 500, 2, 0, []],
        ["absorption", 750, 2, 0, []],
        ["accidentalchange", 250, 0, 0, []],
        ["accidentclone", 250, 2, 0, []],
        ["acidblood", -100, 2, 0, []],
        ["acrobatic", 250, 2, 0, []],
        ["airscout", 110, 2, 0, []],
        ["astral", 600, 0, 0, []],
        ["astralform", -5000, 0, 0, []],
        ["atomtouch", 150, 2, 0, []],
        ["battery", -100, 2, 0, ["ffqdeenergized"]],
        ["bezerker", -125, 2, 0, []],
        ["biohazard", -200, 2, 0, []],
        ["blastshield", 100, 2, 0, []],
        ["blazingglory", 300, 2, 0, []],
        ["bloodsucker", 400, 0, 0, []],
        ["bodyaura", 2000, 2, 0, ["metashield", "metashieldp"]],
        ["boost1", 600, 2, 0, []],
        ["boost2", 600, 2, 0, []],
        ["boost3", 600, 2, 0, []],
        ["borrowedtime", -1000, 1, 0, []],
        ["butterfingers", -50, 2, 0, []],
        ["cannonball", 500, 2, 0, []],
        ["chameleon", 500, 2, 0, []],
        ["conduit", -150, 2, 0, []],
        ["coordinator", 600, 2, 0, []],
        ["degenerative", -750, 2, 0, []],
        ["densitycontrol", 500, 1, 0, []],
        ["dependency", -400, 2, 0, []],
        ["depressed", -200, 2, 0, []],
        ["disciplined", 350, 2, 0, ["mindless"]],
        ["dispassionate", 150, 2, 0, []],
        ["dispersed", 300, 2, 0, []],
        ["earthcontrol", 800, 2, 0, []],
        ["earthcontrol2", 300, 2, 0, ["earthcontrol"]],
        ["empath", -500, 2, 0, []],
        ["energytanks", -100, 2, 0, []],
        ["envcontrolglobal", 500, 2, 0, []],
        ["envcontrollocal", 500, 2, 0, []],
        ["environmentcontrol", 1000, 2, 0, []],
        ["ephemeral", -750, 1, 0, []],
        ["explosive", 500, 2, 0, []],
        ["extraheroic", 1000, 2, 0, []],
        ["fastflier", 200, 2, 0, []],
        ["fasthealing", 500, 2, 0, []],
        ["fearless", 150, 2, 0, ["mindless"]],
        ["ffqaicarchaser", -100, 2, 0, []],
        ["ffqaimisandre", -175, 2, 0, []],
        ["ffqaimisanthrope", -250, 2, 0, []],
        ["ffqaimisogynist", -150, 2, 0, []],
        ["ffqairsuperiority", 275, 0, 0, []],
        ["ffqaitechnophobe", -125, 2, 0, []],
        ["ffqaixenophobe", -125, 2, 0, []],
        ["ffqaizoophobe", -125, 2, 0, []],
        ["ffqantimissiles", 800, 2, 0, ["ffqaurauntouchable"]],
        ["ffqaurauntouchable", 1000, 1, 0, ["untouchable2"]],
        ["ffqbasiclevitation", -450, 0, 0, []],
        ["ffqdeathwish", -650, 2, 0, []],
        ["ffqdeenergized", -50, 2, 0, ["battery"]],
        ["ffqdesesperate", 175, 2, 0, []],
        ["ffqdisguise", 500, 0, 0, []],
        ["ffqdivineintervention", 500, 2, 0, []],
        ["ffqempathinfiniterange", -600, 1, 0, []],
        ["ffqempathlongrange", -300, 2, 0, []],
        ["ffqempathnormalrange", -150, 2, 0, []],
        ["ffqevolving1", 500, 0, 0, []],
        ["ffqevolving2", 1000, 0, 0, []],
        ["ffqevolving3", 2000, 0, 0, []],
        ["ffqevolving4", 3000, 0, 0, []],
        ["ffqevolving5", 4000, 0, 0, []],
        ["ffqextradimensional", -100, 2, 0, ["fourd"]],
        ["ffqfastball", 50, 2, 0, []],
        ["ffqflawedinvulnerability", 800, 2, 0, ["ffqweakspot", "invulnerable4"]],
        ["ffqghostly", 4000, 0, 0, []],
        ["ffqglider", -225, 0, 0, []],
        ["ffqgymnast", 850, 0, 0, []],
        ["ffqhighjumper", 200, 2, 0, []],
        ["ffqimmortal", 1000, 2, 0, ["lastresort"]],
        ["ffqjumpingjack", 1250, 0, 0, []],
        ["ffqlatentmutant", -300, 0, 0, []],
        ["ffqlimitedflight", -275, 0, 0, []],
        ["ffqloner", 75, 2, 0, ["ffqteamplayer"]],
        ["ffqlongjumper", 650, 2, 0, []],
        ["ffqlowgravflier", -75, 0, 0, []],
        ["ffqlowjumper", 50, 2, 0, []],
        ["ffqmad", -400, 2, 0, []],
        ["ffqnimbleflier", 100, 2, 0, []],
        ["ffqpagangod", 850, 0, 0, []],
        ["ffqprecognitive", 150, 0, 0, []],
        ["ffqprowler", 750, 0, 0, []],
        ["ffqpsychotherapy", 300, 2, 0, []],
        ["ffqrealitymanipulation", 800, 2, 0, []],
        ["ffqresilient", 100, 2, 0, []],
        ["ffqrooted", 300, 2, 0, []],
        ["ffqropeswinger", -350, 0, 0, []],
        ["ffqstealthy", 600, 2, 0, []],
        ["ffqsuperheroic", 1750, 2, 0, []],
        ["ffqteamplayer", 75, 2, 0, ["ffqloner"]],
        ["ffqtempinvulnerability", 600, 2, 0, []],
        ["ffqtimemaster", 1000, 2, 0, []],
        ["ffqtracking", 50, 2, 0, []],
        ["ffqtrapezist", 500, 0, 0, []],
        ["ffqupgradable1", 500, 0, 0, []],
        ["ffqupgradable2", 1000, 0, 0, []],
        ["ffqupgradable3", 2000, 0, 0, []],
        ["ffqupgradable4", 3000, 0, 0, []],
        ["ffqupgradable5", 4000, 0, 0, []],
        ["ffqweakspot", -500, 2, 0, ["ffqflawedinvulnerability"]],
        ["firecontrol", 1000, 2, 0, []],
        ["fourd", 100, 2, 0, []],
        ["frostbite", -200, 2, 0, []],
        ["gaseousform", 1000, 2, 0, []],
        ["glassjaw", -200, 2, 0, []],
        ["grimresolve", 200, 2, 0, ["ironjaw"]],
        ["groupteleport", 500, 1, 0, []],
        ["guardianm", 500, 2, 0, []],
        ["guardianp", 800, 2, 0, []],
        ["hatemonger", 750, 2, 0, []],
        ["heavyfooted", -100, 2, 0, []],
        ["heavylifter", 150, 2, 0, ["ffqghostly"]],
        ["heroic", 750, 2, 0, []],
        ["hollowbones", -200, 2, 0, []],
        ["icecloud", 1000, 2, 0, []],
        ["icecontrol", 400, 2, 0, []],
        ["innerbeing", 2000, 0, 0, []],
        ["involuntaryform", -8000, 0, 0, []],
        ["invulnerable0", 300, 2, 0, []],
        ["invulnerable", 750, 2, 0, []],
        ["invulnerable2", 1500, 2, 0, []],
        ["invulnerable2a", 2000, 2, 0, []],
        ["invulnerable3", 2500, 2, 0, []],
        ["invulnerable4", 4000, 2, 0, ["ffqflawedinvulnerability"]],
        ["invulnerable34", 8000, 0, 0, []],
        ["invulnerable22a34", 16000, 0, 0, []],
        ["ironguts", 600, 2, 0, []],
        ["ironjaw", 400, 2, 0, []],
        ["jinx", 200, 2, 0, []],
        ["kamikaze", 0, 2, 0, []],
        ["lastresort", 500, 2, 0, ["ffqimmortal"]],
        ["lesserregeneration", 500, 2, 0, ["superhealer"]],
        ["levelheaded", 700, 2, 0, []],
        ["lightcontrol", 100, 2, 0, []],
        ["livinglaser", 1000, 2, 0, []],
        ["magnetic", 1000, 2, 0, []],
        ["magnetic2", 400, 2, 0, ["magnetic"]],
        ["masscontrol", 500, 2, 0, []],
        ["metabolic", 700, 2, 0, []],
        ["metaleater", 750, 2, 0, []],
        ["metamorphic", 1800, 0, 0, []],
        ["metashield", 500, 2, 0, ["metashieldp", "bodyaura"]],
        ["metashieldp", 1250, 2, 0, ["metashield", "bodyaura"]],
        ["metaspeed", 300, 2, 0, ["metabolic"]],
        ["metastrength", 500, 2, 0, ["metabolic", "ffqghostly"]],
        ["mimic", 1000, 2, 0, []],
        ["mindless", 400, 2, 0, []],
        ["miracle1", 600, 2, 0, []],
        ["miracle2", 600, 2, 0, []],
        ["mutator", 1000, 2, 0, []],
        ["nemesis", -2000, 1, 0, []],
        ["nimble", 200, 2, 0, []],
        ["nocturnal", 100, 2, 0, []],
        ["overheated", -200, 2, 0, []],
        ["painresponse", 800, 2, 0, []],
        ["peacefield", 400, 2, 0, []],
        ["pheremones", 300, 2, 0, []],
        ["plasmasculptor", 500, 2, 0, []],
        ["poltergeist", 200, 2, 0, []],
        ["powercosmic", 2500, 0, 0, []],
        ["presence", 300, 2, 0, []],
        ["privatearmy1", 1000, 2, 0, ["privatearmy2", "privatearmy3"]],
        ["privatearmy2", 1500, 2, 0, ["privatearmy3"]],
        ["privatearmy3", 2000, 2, 0, []],
        ["psychiclink", -100, 2, 0, []],
        ["puppetn", 750, 2, 0, []],
        ["puppetu", 750, 2, 0, []],
        ["rage", -420, 2, 0, []],
        ["rage2", -500, 2, 0, []],
        ["russiandoll", 1000, 2, 0, []],
        ["sandstorm", 1000, 2, 0, []],
        ["scary", -300, 2, 0, []],
        ["sensitive", -150, 2, 0, []],
        ["shakeitoff", 300, 2, 0, []],
        ["shapeshifter", 1000, 0, 0, []],
        ["shortcirc", -200, 2, 0, []],
        ["slippery", 200, 2, 0, []],
        ["slowmoving", -100, 2, 0, []],
        ["solarpowered", 100, 2, 0, []],
        ["solarstores", 800, 2, 0, []],
        ["sorcerer", 8000, 0, 0, []],
        ["speedforce", 500, 2, 0, []],
        ["spinner", 1000, 2, 0, []],
        ["spiny", -100, 2, 0, []],
        ["stockpile", -100, 2, 0, []],
        ["summoner1", 1000, 2, 0, ["summoner2", "summoner3"]],
        ["summoner2", 1500, 2, 0, ["summoner3"]],
        ["summoner3", 2000, 2, 0, []],
        ["superhealer", 900, 2, 0, []],
        ["superleaper", 400, 2, 0, []],
        ["supertk", 1500, 2, 0, []],
        ["symbiote", 200, 2, 0, []],
        ["telekinetic", 500, 2, 0, ["supertk"]],
        ["telepathy", 250, 2, 0, []],
        ["teleporter", 4000, 2, 0, []],
        ["tempform", -5000, 0, 0, []],
        ["thoughtform", 0, 0, 0, []],
        ["timid", -300, 2, 0, []],
        ["toughguy2", 2800, 2, 0, []],
        ["toxic", 100, 2, 0, []],
        ["transmutator", 600, 2, 0, []],
        ["trickshot", 600, 2, 0, []],
        ["unbeliever", 350, 2, 0, []],
        ["unheroic", -500, 2, 0, []],
        ["untouchable2", 600, 2, 0, ["ffqaurauntouchable"]],
        ["urbandweller", 750, 2, 0, []],
        ["utilitybelt", 600, 2, 0, []],
        ["vulnerability", -250, 2, 0, []],
        ["vunstablemols", 150, 2, 0, []],
        ["weaponbearer", 600, 2, 0, []],
        ["weathercontrol", 1000, 2, 0, []],
        ["xunstablemolecules", 100, 1, 0, []]
        ]
    return ALL_FFX_ATTR

###! TO DO: Obsolete since FFX 2.6!
# returns the following array:
# ["attribute name", cost, safe to initialize by in-game script only (0=no, 1=yes, but should be avoided, 2=yes), removable (0=no, 1=yes), ["incompatible attribute1", "incompatible attribute2", "etc."]]
def getFFXAttrDetails(attrName):
    allAttr = getAllFFXAttr()
    for anAttrDetails in allAttr:
        if anAttrDetails[0] == attrName:
            return anAttrDetails
    print "getFFXAttrDetails(attrName) error:"
    print "    no attribute named %s found, returning dummy list"%attrName
    return [attrName, 0, 0, 0, []]

###! TO DO: Obsolete since FFX 2.6!
# Check if the attribute within the current set (from getAllFFXAttr()) can be added to the character
# Still used by OnLatentMutant(event)! Should NOT be removed! - TMX - 07-03-08
def isAttributeSetSafe(char, attrSet):
    if attrSet[2] > 1: #is the attribute marked as safe?
        if not hasAttribute(char, attrSet[0]): #does the character already have this attribute?
            incompatibles = attrSet[4]
            for iAttr in incompatibles: #does the character already have an incompatible attribute?
                if hasAttribute(char, iAttr):
                    return 0
            return 1
    return 0


# Used with those attributes which are possibly scripted versions of built-ins before using
# Mission_StatusText("@ATTRIB_%s"%string.upper(attrib)) to get the display name of the attribute.
# Changed FFX 3.2: use reverse=1 to get the ffx name of a scripted attribute form the built-in name
def getOriginalNameOfAttrib(attrib,reverse=0):
    builtins = {
        "densitycontrol": "density control",
        "extraheroic": "extra heroic",
        "fasthealing": "fast healing",
        "grimresolve": "grim resolve",
        "heavylifter": "heavy lifter",
        "levelheaded": "level headed",
        "shakeitoff": "shake it off",
        "slowmoving": "slow moving",
        "unstablemolecules": "unstable molecules",
        }
    if reverse:
        builtins = generalutils.invertDict(builtins)
    if builtins.has_key(attrib):
        return builtins[attrib]
    else:
        return attrib


# Returns true if the attribute name corresponds to a scripted version of a built-in one
# Note that for built-in attributes with spaces in the name, it returns false, even if there's a
# scripted version, because the scripted name has no spaces. You can use getOriginalNameOfAttrib(attrib,reverse=1)
# to get the name without spaces.
def isScriptedAttribute(attr):
    return attr in getAllScriptedAttributes()

# Get a tuple of all scripted attributes
# Note that for built-in attributes with spaces in the name, it returns the scripted version's name,
# i.e., without the spaces. Use getOriginalNameOfAttrib(attrib) to get the original name
# Added FFX 3.2 Please update as needed!
def getAllScriptedAttributes():
    return (
        "bezerker",
        "disciplined",
        "densitycontrol",
        "extraheroic",
        "fasthealing",
        "flier",
        "grimresolve",
        "heavylifter",
        "heroic",
        "ironjaw",
        "levelheaded",
        "shakeitoff",
        "slowmoving",
        "timid",
        "unbeliever",
        "unheroic",
        "unstablemolecules",
        )

# return true if given attrib is one of the game's built-in character attributes
def isBuiltinAttribute(attrib):
    # This list shouldn't change unless we enable another "hidden" built-in, like untouchable
    return attrib in ('adaptive', 'alkaline', 'armoured', 'beautiful', 'bedevilled', 'bezerker',
                      'blind', 'blitzkrieg', 'charged', 'claws', 'clumsy', 'cold blooded',
                      'cosmic chump', 'crack shot', 'cybernetic brain', 'danger sense',
                      'density control', 'disciplined', 'energetic', 'extra heroic', 'fast healing',
                      'flier', 'fluctuation', 'focus', 'glass bones', 'grim resolve', 'grounded',
                      'heat sensitive', 'heavy hitter', 'heavy lifter', 'heroic', 'hirsute',
                      'hot tempered', 'invertebrate', 'jumper', 'level headed', 'levitate',
                      'light speed', 'myopic', 'nimble', 'ponderous', 'radioactive',
                      'rapid metabolism', 'shake it off', 'slow moving', 'solid skeleton',
                      'strange visitor', 'temperature control', 'thin skinned', 'timid', 'tough guy',
                      'unbeliever', 'unheroic', 'unstable energy', 'unstable molecules',
                      'untouchable', 'volcanic', 'wall climbing', 'weak minded')

#returns the list of character attributes for this object
#charAttr: if set to 1, all FFX attributes for this characterwill be added to the returned list, including
#those added with addFFXAttrib() and not present in the template
#templateAttr: if set to 1, the default attributes for the template will be added to the returned list
#ignoreBought: if set to 0, only already purchased template attributes will be added to the returned list
def getAttributes(char, charAttr=1, templateAttr=1, ignoreBought=0):
    templateAttributes = []
    charAttributes = []
    if templateAttr:
        charData = chardata.GetCharacterData(char)
        templateAttributes = charData['characterAttributes']
        if not ignoreBought:
            activeAttributes = charData['activeAttributes']
            templateAttributes = templateAttributes[:activeAttributes]
        #combos
        combosAttributes = []
        for t in templateAttributes:
            for combo in ffxMultis:
                if t == combo[0]:
                    combosAttributes.extend(combo[1:])
                    break
        print "---combos found"
        print combosAttributes
        templateAttributes.extend(combosAttributes)
    if charAttr:
        charAttributes = missionobjvar.Object_GetVar(char, 'attrs_', [])
    for c in charAttributes:
        if c not in templateAttributes:
            templateAttributes.append(c)
    print "-----------------"
    print char
    print templateAttributes
    return templateAttributes

#returns the list of character attributes specific to this object and not found in the template.
#ignoreBought: if set to 0, unpurchased template attributes will be ignored from the comparison
def getCharacterSpecificAttributes(char, ignoreBought=0):
    templateAttributes = getAttributes(char, 0, 1, ignoreBought)
    charAttributes = getAttributes(char, 1, 0, 0)
    specificAttributes = []
    for c in charAttributes:
        if c not in templateAttributes:
            specificAttributes.append(c)
    return specificAttributes


# Detects if an attribute can be removed before adding it.
# Syntax example:
# myVariable =  isAttributeRemovable('heroic')
# Note:
# -This will generate an ff.log/console error message for attributes which try to access character properties.
#  This is intentional.
# To know which attributes are removable, use getRemovableAttributes() from the progrutils module.
def isAttributeRemovable(attribute):
    init = "init%s('attrib_removable_dummy', update=0, remove=0)" % attribute
    try:
        exec init
        #print "isAttributeRemovable():"
        #print "    attribute '%s' is removable" % attribute
        return 1
    except SystemError:
        #print "isAttributeRemovable():"
        #print "    attribute '%s' is removable" % attribute
        return 1
    except TypeError:
        print "isAttributeRemovable():"
        print "    attribute '%s' is not removable" % attribute
        pass
    except NameError:
        print "isAttributeRemovable() fatal error:"
        print "    no attribute named '%s'" % attribute
    except:
        print "isAttributeRemovable() fatal error:"
        print "    unknown exception"
    return 0        

# Checks if each of the attributes of a combo are removable.
def isComboAttributeRemovable(attribute):
    subAttributes = []
    isRemovable = 0
    for multi in ffxMultis:
        if multi[0] == attribute:
            subAttributes = multi
            del subAttributes[0]
            for subAttribute in subAttributes:
                isRemovable = 0
                isRemovable = isAttributeRemovable(subAttribute)
                if isRemovable == 0:
                    break
            break
    if subAttributes == []:
        print "isComboAttributeRemovable() fatal error:"
        print "    no combo attribute named '%s' in ffxMultis" % attribute
    return isRemovable



########################### ATTRIBUTES ############################################

################ LATENT MUTANT ######################################
# If irradiated, you develop random attribute(s), good or bad, for the rest of the mission!
# Added FFX 2.5
#
# Status: 1.7

# Changes:
# 1.6 (FFX 3.0):
# -Updated Mission_StatusText for compatibility with FFvsTTR
# 1.7 (FFX 3.2):
# -Changed Attribute initialisation/listing method for compatibility with the new character-specific attribute system.

# Notes:
# -Attributes gained are alway worth at least 350 pts in total, the mean value being 750.
# -Triggering this attribute does not cure the irradiation.
# -The scripted version of attribute may be assigned to a character already having the original, since
#  built-in attributes can't be detected.
# -There are a few attributes that you'll never get: those marked as unsafe and those costing less
#  than -750 or more than 1750.
# -Your character gains a custom command on himself describing his new attributes, in case you missed
#  something the first time.
#
# Bugs:
# -Not all attribs have been checked for compatibility with this system...
# -Currently not compatible with morphing!

def initffqlatentmutant(char,update=0):
    if update == 0:
        regIrradiated(char, 'OnLatentMutant', user = update, persistent = 0)

def OnLatentMutant(event):
    char = event.object
    update = event.user   
    allAttribs = getAllFFXAttr()
    previousRandoms = []
    randomAttribNbr = -1
    newAttribs = []
    cost = 0
    while cost < 350:
        randomAttribNbr = randint(0, len(allAttribs)-1)
        if previousRandoms.count(randomAttribNbr) == 0: #avoid duplicate entries
            randomAttrib = allAttribs[randomAttribNbr] #returns an array
            if isAttributeSetSafe(char, randomAttrib):
                # avoid attributes costing < -750 or > + 1750
                if max(-751,(-751 - cost)) < randomAttrib[1] < min(1751,(1751 - cost)):
                    previousRandoms.append(randomAttribNbr)
                    newAttribs.append(randomAttrib[0])
                    cost = cost + randomAttrib[1]
    Mission_StatusText(getCharDisplayName(char))
    if len(newAttribs) == 1:
        nbrAttrText = "a new attribute"
    else:
        nbrAttrText = "%i new attributes"%len(newAttribs)
    Mission_StatusText("has been mutated by the radiation and has gained %s:"%nbrAttrText)
    for thisAttrib in newAttribs:
        thisAttribDisplay = getOriginalNameOfAttrib(thisAttrib)
        Mission_StatusText("@ATTRIB_%s"%string.upper(thisAttribDisplay)) #displays the string.txt name of the attribute
        addFFXAttrib(char, thisAttrib)
    missionobjvar.Object_SetVar(char, 'latentMutant_attribs', newAttribs)
    playRecurringEffect(char, 'effect_ffx_energysparks', frequency = 5, repeat = -1)
    Mission_CustomAction('CUSTOM_FFQLATENTMUTANTHELP', char, char, 'OnFFQLatentMutantHelp', 5, 0)
    FFX_ObjectSetAttr(char, 'latentMutantTriggered',1) #for Object_CalcFFXForCharPrestige(char)

def OnFFQLatentMutantHelp(char, dummy):
    newAttribs = missionobjvar.Object_GetVar(char, 'latentMutant_attribs')
    if len(newAttribs) == 1:
        nbrAttrText = "a new attribute"
    else:
        nbrAttrText = "%i new attributes"%len(newAttribs)
    Mission_StatusText("You've been mutated by the radiation and have gained %s:"%nbrAttrText)
    RegTimer('OnFFQLatentMutantHelpWith', 1.5, 0, char)

def OnFFQLatentMutantHelpWith(event):
    char = event.object
    whichAttrib = int(event.user)
    newAttribs = missionobjvar.Object_GetVar(char, 'latentMutant_attribs')
    if whichAttrib < len(newAttribs):
        thisAttribDisplay = getOriginalNameOfAttrib(newAttribs[whichAttrib])
        Mission_StatusText("@ATTRIB_%s"%string.upper(thisAttribDisplay))
        Mission_StatusText("@ATTRIB_%s_DESC"%string.upper(thisAttribDisplay))
        RegTimer('OnFFQLatentMutantHelpWith', 3, whichAttrib + 1, char)


########################### RESILIENT #################################################
# Attribute gives character 30 more health points. Done by requested of Mr. Nick Craft of Patriot City.;)
# This simplistic attribute is obviously designed for campaigns: a low-health character (such as LL) could
# purchase this atribute by gaining experience.

# status: 1.2
# stumpy: added removability (thanks, mate! - Ep.)
# stumpy 2008-02-29: Added freeroam check. See initnimble for note.
def initffqresilient(char,update=0,remove=0):
    if remove:
        if FFX_ObjectGetAttr(char,'ffqresilient'):
            FFX_ObjectSetAttr(char,'ffqresilient',0)
            maxHealth=Object_GetAttr(char,'maxHealth')
            maxHealth=maxHealth-30
            Object_SetAttr(char,'maxHealth',maxHealth)
            Object_SetAttr(char,'health',Object_GetAttr(char,'health')-30)
        return
    if not FFX_ObjectGetAttr(char,'ffqresilient'):
        FFX_ObjectSetAttr(char,'ffqresilient',1)
        # check that this wasn't already changed by FFX in an earlier freeroam map and already lowered
        if ( 'freeroam_bonus' not in sys.modules.keys() )or \
           ( ( 'freeroam_bonus' in sys.modules.keys() ) and ( freeroam_bonus.heroStates==[] ) ):
            maxHealth=Object_GetAttr(char,'maxHealth')
            maxHealth=maxHealth+30
            Object_SetAttr(char,'maxHealth',maxHealth)
            Object_SetAttr(char,'health',Object_GetAttr(char,'health')+30)


########################### ENERGY DEPENDANT ##########################################
# replaced by similar ffx metabolic attribute

########################### DE-ENERGIZED (SLOW STARTER) ###############################
# Character begins mission with no energy. No big deal... unless you also have the battery powered attribute.
# status:2.0
#
# Added FFX 2.5:
# -If the character has no energy, this attribute became a free cost reduction... 
#  in this case, character is now stunned for the first 30 seconds.
# -Oh boy, this was my first foray into Python - and it showed; corrected a couple of unimportant aberrations.
def initffqdeenergized(char,update=0):
    Object_SetAttr(char,'energyPoints',0)
    if cshelper.isPlaying():
        RegTimer('FFqDeEnergized',1,0,char)
    else:
        if Object_GetAttr(char,'energy') == 0:
            Object_SetPrimaryState(char, PCSTATE_STUNNED, 30)

def FFqDeEnergized(event):
    char = event.object
    Object_SetAttr(char,'energyPoints',0)
    if cshelper.isPlaying():
        RegTimer('FFqDeEnergized',1,0,char)
    else:
        if Object_GetAttr(char,'energy') == 0:
            Object_SetPrimaryState(char, PCSTATE_STUNNED, 30)
    

########################### DYING #####################################################
# replaced by similar ffx borrowed time attribute

########################### IMMORTAL ###############################################
# As an immortal,you're particularly hard to knock out: damage which would have k.o'ed you will only stun!
# However, while stunned you'll then be vulnerable to K.O.
# Each time you receive an otherwise fatal blow, you're going to progressively heal back some;
# the amount of health you get back is lessened each time.
#
# Status: 2.7

# Changed 2.5 (FFX 3.0):
# -Changed Object_IsAlive() to account for the various resurrection modes available in FFvsTTR
# Changed 2.6 (FFX 3.2.0 alpha)
# -Made removable.
# Changed 2.7 (FFX 3.2.0.1Ep2 alpha)
# -Changed removal method for compatibility with the new system.

# Notes:
# -If the character has the Iron Jaw attribute, he won't stay stunned, but he'll still be vulnerable for 15 seconds
#  (the stun duration).
# -Clones: hmmm... it's almost cheating, but there's no 100% reliable method of detecting every kind of clone I know of.
#  Edit: Added a passable clone detection function (isClone()). Detected clones have reduced immortality (sic).
# -NOT COMPATIBLE WITH LAST RESORT. Sorry. I've tried. A character having both attributes will get Last Resort only.

def initffqimmortal(char, update=0, remove=0):
    #attribute already set?
    if remove:
        if FFX_ObjectGetAttr(char,'ffqimmortal'):
            FFX_ObjectSetAttr(char, 'ffqimmortal', 0)
            FFX_ObjectSetAttr(char, 'ffqimmortal_active', 0)
            Object_SetAttr(char,'minHealth', 0)
        return
    if FFX_ObjectGetAttr(char, 'ffqimmortal'):
        return
    if cshelper.isPlaying():
        RegTimer('OnFFQInitImmortal',1,update,char)
    else:
        makeFFQImmortal(char)

def OnFFQInitImmortal(event):
    char = event.object
    update = event.user
    if cshelper.isPlaying():
        RegTimer('OnFFQInitImmortal',1,update,char)
    else:
        makeFFQImmortal(char)

def makeFFQImmortal(char):
    if Object_GetAttr(char,'minHealth') != 0:
        print "FFQ ERROR: attribute 'IMMORTAL' cannot be added to %s:"%char
        print "    minHealth is already set to %i!"%Object_GetAttr(char,'minHealth')
        hasAttr = FFX_ObjectGetAttr(Object_GetTemplate(char),'ffqimmortal')!=0
        if hasAttr == 1:
            FFX_ObjectSetAttr(Object_GetTemplate(char),'ffqimmortal',0)
        else: #for latent mutant induced Immortal
            removeFFXAttrib(char, 'ffqimmortal')
    else:
        FFX_ObjectSetAttr(char, 'ffqimmortal', 1)
        FFX_ObjectSetAttr(char, 'ffqimmortal_active', 1)
        Object_SetAttr(char,'minHealth',1)
        if isClone(char):
            FFX_ObjectSetAttr(char,'immortalKOFactor',2)
        else:
            FFX_ObjectSetAttr(char,'immortalKOFactor',0)
        Event_RegisterSink(EVENT_OBJ_HEALTHCHANGED,'OnFFQImmortal',char,'',2,0,0)

def OnFFQImmortal(event):
    char = event.object
    if not FFX_ObjectGetAttr(char,'ffqimmortal'):
        return
    koFactor = FFX_ObjectGetAttr(char,'immortalKOFactor')+1
    FFX_ObjectSetAttr(char,'immortalKOFactor',koFactor)
    countdown = int(round(Object_GetAttr(char,'maxHealth')/10))
    Object_SetPrimaryState(char,PCSTATE_STUNNED,15)
    fallOver(char)
    RegTimer('OnFFQImmortalVulnerable',2,0,char)
    delay = 0.3
    RegTimer('OnFFQImmortalHealing',delay,countdown,char)

# wait 2 seconds after being reduced to 1 hp before removing minHealth and making character vulnerable
# to prevent character receiving a new fatal blow immediatly
def OnFFQImmortalVulnerable(event):
    char = event.object
    Object_SetAttr(char,'minHealth',0)

def OnFFQImmortalHealing(event):
    char = event.object
    if not Object_Exists(char):
        return
    countdown = event.user
    delay = event.float
    delay = delay + 0.1
    koFactor = FFX_ObjectGetAttr(char,'immortalKOFactor')
    healing = 6 - koFactor
    if Object_IsAlive(char) and (healing > 0):
        FFQ_changeHP(char,healing)
    if Object_IsAlive(char) and (countdown == 0):
        Object_SetAttr(char,'minHealth',1)
        Event_RegisterSink(EVENT_OBJ_HEALTHCHANGED,'OnFFQImmortal',char,'',2,0,0)
    else:
        RegTimer('OnFFQImmortalHealing',delay,countdown-1,char)


########################### SACRIFICE ################################################
# doesn't work. Removed for now (and until the end of time). Wait for FFvs3R instead!

########################### TEMPORARY INVULNERABILITY ################################
# Character can become invulnerable for 20 seconds.
# Gives you 20 points of invulnerability (cumulative with the different grades of FFX's Invulnerability).
# Additionnaly, stun, irradiated, acid burnt, power nullified and density increased duration are reduced,
# for a small EP cost (except the last one, generic states can't be detected). However, if, for any reason
# your energy drops below 10, your shield'll go down.
#
# Completely replaced the original versions, too powerful and too similar to FFX's Energy Shield (Active).
# Well, actually, the new version is partly a rip off of FFX's Invulnerability. ;)
# Status: 3.11
#
# Changed 3.11 (FFX 3.0):
# -updated EP cost
# -Effect now tracks rotation

FFQ_EP_TEMPINVULNERABILITY=66

def initffqtempinvulnerability(char,update=0):
    if update==0:
        Mission_CustomAction('CUSTOM_FFQTEMPINVULNERABILITY',char,char,'OnFFqTempInvulnOn',0)
        FFX_ObjectSetAttr(char,'ffqtempinvuln-on',0)
        Object_SetAttr(char,'ffqtempinvuln-irradiated',0)
        Object_SetAttr(char,'ffqtempinvuln-acidburnt',0)
        Object_SetAttr(char,'ffqtempinvuln-nullified',0)

def OnFFqTempInvulnOn(char,dummy):
    if chargeEP(char,FFQ_EP_TEMPINVULNERABILITY)==0:
        Mission_StatusText(getByTemplate(char,FFQ_ENERGYSCAN_CUSTOM,3))
        return
    FFX_Animate(char,getByTemplate(char,FFQ_TEMPINVULNERABILITY_CUSTOM,1))
    sparks = getByTemplate(char,FFQ_TEMPINVULNERABILITY_CUSTOM,2)
    if sparks != '':
        handle = Object_PlayEffect(char,sparks,'',FX_LOOP|FX_TRACK_OBJECT_FULL,0,'Bip01 Spine')
        Object_SetAttr(char,'ffqtempinvuln-handle',handle)
    invPoints=FFX_ObjectGetAttr(char,'invPoints')
    if invPoints==0:
        FFX_ObjectSetAttr(char,'ivlastdam',Object_GetAttr(char,'health'))
        if not FFX_ObjectGetAttr(char,'DamageManagement',0):
            RegDamage(char,'DamageManagement')
            FFX_ObjectSetAttr(char,'DamageManagement',1)
    FFX_ObjectSetAttr(char,'invPoints',invPoints+20)
    FFX_ObjectSetAttr(char,'baseInvPoints',invPoints+20)
    FFX_ObjectSetAttr(char,'ffqtempinvuln-on',1)
    FFX_SetMassFactor(char,2)
    #check if the char already is under secondary effects, to avoid removing those
    if Object_GetSecondaryStates(char) == SCSTATE_IRRADIATED:
        Object_SetAttr(char,'ffqtempinvuln-irradiated',1)
    if Object_GetSecondaryStates(char) == SCSTATE_ACID_BURNT:
        Object_SetAttr(char,'ffqtempinvuln-acidburnt',1)
    if Object_GetSecondaryStates(char) == SCSTATE_POWER_NULLIFICATION:
        Object_SetAttr(char,'ffqtempinvuln-nullified',1)    
    RegTimer('FFqTempInvulnEffects',2,0,char)
    RegTimer('FFqTempInvulnOff',20,0,char)

def FFqTempInvulnEffects(event):
    char = event.object
    if FFX_ObjectGetAttr(char,'ffqtempinvuln-on'):
        if Object_GetPrimaryState(char) == PCSTATE_STUNNED:
            Object_SetPrimaryState(char, PCSTATE_STUNNED, 0, REMOVE_STATE)
            reduceEP = FFQ_reduceEP(char,5)
        if Object_GetAttr(char,'ffqtempinvuln-irradiated'):
            if Object_GetSecondaryStates(char) == SCSTATE_IRRADIATED:
                Object_SetSecondaryState(char, SCSTATE_IRRADIATED, 0, REMOVE_STATE)
                reduceEP = FFQ_reduceEP(char,5)
        if Object_GetAttr(char,'ffqtempinvuln-acidburnt'):
            if Object_GetSecondaryStates(char) == SCSTATE_ACID_BURNT:
                Object_SetSecondaryState(char, SCSTATE_ACID_BURNT, 0, REMOVE_STATE)
                reduceEP = FFQ_reduceEP(char,5)
        if Object_GetAttr(char,'ffqtempinvuln-nullified'):
            if Object_GetSecondaryStates(char) == SCSTATE_POWER_NULLIFICATION:
                Object_SetSecondaryState(char, SCSTATE_POWER_NULLIFICATION, 0, REMOVE_STATE)
                reduceEP = FFQ_reduceEP(char,5)
        Object_SetGenericState(char, OBJSTATE_DENSITY_CHANGE, 0, REMOVE_STATE)
        if Object_GetAttr(char,'energyPoints') < 10:
            RegTimer('FFqTempInvulnOff',0,0,char)
        else:
            RegTimer('FFqTempInvulnEffects',2,0,char)

# either called on timeout or if EP has reached 0
def FFqTempInvulnOff(event):
    char = event.object
    if FFX_ObjectGetAttr(char,'ffqtempinvuln-on'):
        invPoints=FFX_ObjectGetAttr(char,'invPoints')
        FFX_ObjectSetAttr(char,'invPoints',invPoints-20)
        FFX_ObjectSetAttr(char,'baseInvPoints',invPoints-20)
        handle = Object_GetAttr(char,'ffqtempinvuln-handle')
        Object_StopEffect(char,handle)
        FFX_ObjectSetAttr(char,'ffqtempinvuln-on',0)
        FFX_SetMassFactor(char,1)


############## TIME MASTER ###################################################
# Character can do various time-manipulation feats: slow or freeze time and travel back and forward in time a few minutes.

# TIME SLOW
# character can make time pass more slowly while retaining his speed.
# (also affects agility - dodging a 5mph bullet isn't a great feat...)
# Please note that character with maximum permitted speed  or near will lose almost any advantage as time will
# slow down nearly as much for them.
#
# TIME STOP
# character can slow time to a near-stop while he and his teammates retain their speed; however, they'll be out
# of synch with reality and can't interact with the environment. (For example, you can pass through buildings and
# attemps to attacks or move up or down will fail.) 
# So, what IS the use of this power, then? It's like getting long-range teleport for each team member. ;)
# There's a delay of 30 seconds between uses of timeflow powers by anybody.
#
# TIME TRAVEL
#
# campaign version:
# This one-shot attribute power allows you to go back or forward in time a few minutes. You'll get to meet your
# younger/older self!
# -Travelling to the past:
#  When activated, you'll have to select a saved game (not restart!) which occured during the current mission.
#  Using a saved game from the current mission but with a different try (ex.: you started the mission, decided
#  the team you selected wasn't a good choice, went back to the mission briefing and started again) won't work!
# -Travelling to the future:
#  It works in the same way, except that you use the custom action first and save your game later. When you'll
#  load that saved game, your past self will appear alongside your current one.
#
# skirmish version:
# -Travelling to the past:
#  Not allowed. :(
# -Travelling to the future:
#  When actived, your custom command will change from "time travel" to "call traveler". Using the command will
#  make a copy of your character appear in the spot you used the "time travel" command. This works only once;
#  if you want multiple copies, please buy the clone power. Note that, unlike the campaign mode version, you'll
#  still be controlling the present time version of your character, not the past one.

# Important notes
# -The inherent properties of this attribute, particularly Time travel, might break many mission scripts!
#  Please read "DISABLING ASPECTS THE TIME MASTER ATTRIBUTE" below.
# -Time Travel is automatically disabled for characters with any of these attributes: ASTRAL FORM, INVOLUNTARY FORM,
#  TEMPORARY FORM, since they cannot appear at mission startup.
# -Also note that any character created during the mission (either through mission-specific scripting, or having a
#  character with INNER BEING or RUSSIAN DOLL, or a SHAPESHIFTER reverting back to his initial form which has the
#  Timemaster attribute) may not work (because of the way I chose to implement Time travel to avoid other problems):
#   -The same character with the Timemaster attribute needs to be present both at the moment the game to which you're
#    going to revert is saved and (obviously) when you activate the power.
# -Copied the NPC swap code from 'inner being'. From the FFX 2.3 Guide: "If there are no slots available for the
#  inner being to occupy on the team, then the game will look for a template appended with '_npc', allowing designers
#  to create a NPC minion version of the inner being for improved smoothness of play. Custom AI can of course be
#  assigned to the inner being for best results."
# -M25 AI characters will use Time Slow only, and with relatively parcimony. I doubt people would find it fun to have
#  the AI use time stop multiple times or ask to load a saved game!
#
# Bugs
# -During TimeStop, character animations look crappy. Hey, it's free. ;P
# -At the end of TimeStop, your character could in theory(?) be stuck in an object. Never happened to me, through.
# -Time travel: do not save while your character is flying! After loading a game after activating timetravel,
#  the saved character, when teleported, is sent to the other side of the universe (how far is -3.601111789253e+024?)
#  EDIT: Dr. Mike corrected the bug by forcing users of FFX teleportation method to land first. Thanks, Dr.!
# -Time travel in Skirmish mode: if the original character has been destroyed (tempform, dead minion or police, script),
#  the new character won't get any scripted AI.
# -Time travel in Campaign mode: can only be used by a single character.
#
# Status: 8.1 (not tested with FFX 3)

# Added 8.0 (FFX 3.0):
# -updated EP cost
# -since speed above 10 doesn't cause problems anymore, allowed faster Time Slow and made Time Stop cancel any damage
# -immunities to time slow or time stop now work
# Added 8.1 (FFX 3.2.0 alpha 1)
# -FFQ_toScreen() call changed for plain Mission_StatusText(), as the M25report.py module duplicates that.
# -MODFOLDER variable replaced by auto-detection through getModFolder()

# TO DO:
# -AI
# -Test
# -Add sun rotation effect for time travel?

FFX_EP_FFQTIMESLOW=66
FFX_EP_FFQTIMESTOP=99
FFX_EP_FFQTIMETRAVEL=99
FFQ_MISSION_ID=0

# Characters from the list below are immune to time slow or time stop;
# all variant from the same name templates are checked if the start with the same value,
# i.e., adding "minute_man" to the list will also add "minute_man_extra" (but not mm_dupe" or "mm_neutral")
# To have an exclusion applied to any use of these powers, add the template name to the default list.
# The character specific option will probably be needed by almost no one (the only case being some ultimate
# time controler who can affect lesser time manipulators without the time master attribute).
# NB: characters with the time master attribute are always immune to time slow or time stop!
FFQ_TIMEFLOWEXCLUDE_CUSTOM=[
#["character",["template to be excluded","another","etc."]]
["default",["time_master","man_bot"]],
["time_master",["time_master"]],
]

# Time Travel should be automatically disabled for tempforms, i.e., characters which cannot appear at mission startup.
# As of FFX 2.3, they are
FFQ_TIMETRAVELFORBIDDEN=["astralform","involuntaryform","tempform"]

# DISABLING ASPECTS THE TIME MASTER ATTRIBUTE
#
# DISABLING TIME TRAVEL
# The inherent properties of Time Travel might cause problems to some mission scripts! For example, missions 
# with events triggered when characters enter a marker. To disallow Time Travel in those missions, add in you mission.py,
# under OnPostInit() the following line (without the initial "#"):
#Mission_SetAttr('allowFFQTimeMaster',20)
#
# DISABLING TIME STOP AND TIME TRAVEL
# The inherent properties of Time Stop gives the equivalent of teleport to every character on the team, which also  might
# cause problems to some mission scripts. To disallow Time Stop and Time Travel in those missions:
#Mission_SetAttr('allowFFQTimeMaster',10)
#
# DISABLING TIME MASTER ALLTOGETHER
#Mission_SetAttr('allowFFQTimeMaster',0)

def initffqtimemaster(char,update=0):
    try:
        print 'Are Time slow, Time stop and Time Travel allowed in this mission?= %d'%(Mission_GetAttr('allowFFQTimeMaster'))
    except:
        print 'Time Master powers are allowed by default in this mission.'
        Mission_SetAttr('allowFFQTimeMaster',30)
    initffqtimeflow(char,update)
    initffqtimetravel(char,update)


# initialize time slow and time stop
def initffqtimeflow(char,update=0):
    if Mission_GetAttr('allowFFQTimeMaster')>5:
        Mission_CustomAction('CUSTOM_FFQTIMESLOW',char,char,'OnFFqTimeSlow',1,0)
        if Mission_GetAttr('allowFFQTimeMaster')>15:
            Mission_CustomAction('CUSTOM_FFQTIMESTOP',char,char,'OnFFqTimeStop',1,0)
    try:
        Mission_GetAttr('ffqtimeflow')
    except:
        Mission_SetAttr('ffqtimeflow',0)

# time slow
def OnFFqTimeSlow(char,dummy):
    if Mission_GetAttr('ffqtimeflow')==1:
        Mission_StatusText('The timeflow cannot take any further tampering for the moment!')
        return
    if chargeEP(char,FFX_EP_FFQTIMESLOW)==0:
        return
    Sound_PlaySound('ui_time_slowdown',Get_ObjectPos(char),1)
    Mission_SetAttr('ffqtimeflow',1)
    immunes=getByTemplate(char,FFQ_TIMEFLOWEXCLUDE_CUSTOM,1)
    for obj in Mission_GetDynamicObjects():
        objclass = Object_GetClass(obj)
        if (objclass & FFX_CHARACTER):
            FFX_ObjectSetAttr(obj,'beforeTimeFlowSpeed',Object_GetAttr(obj,'speed'))
            FFX_ObjectSetAttr(obj,'beforeTimeFlowAgility',Object_GetAttr(obj,'agility'))
            if (hasAttribute(obj,'ffqtimemaster') | (FFX_GetTemplate(obj) in immunes)):
                newSpeed = Object_GetAttr(obj,'speed') * 2
                Object_SetAttr(obj,'speed',newSpeed) 
                Object_SetAttr(obj,'agility',Object_GetAttr(obj,'agility') * 2)
            elif (objclass & FFX_CHARACTER):
                newSpeed = Object_GetAttr(obj,'speed')
                if newSpeed < 2:
                    Object_SetAttr(obj,'speed',0)
                else:
                    Object_SetAttr(obj,'speed',newSpeed-2)
    ff.APP_TIME_SCALE = 0.5
    RegTimer('FFqTimeFlowOff',12,0,char)
    Object_PlayEffect(char, 'effect_ffq_time2', '', FX_TRACK_OBJECT_FULL)

# time stop
def OnFFqTimeStop(char,dummy):
    if cshelper.isPlaying():
        return
    if Mission_GetAttr('ffqtimeflow')==1:
        Mission_StatusText('The timeflow cannot take any further tampering for the moment!')
        return
    if chargeEP(char,FFX_EP_FFQTIMESTOP)==0:
        return
    Sound_PlaySound('ui_time_slowdown',Get_ObjectPos(char),1)
    Mission_SetAttr('ffqtimeflow',1)
    RPG_SetActive(0) #added since hi speed doesn't prevent power use in FFvsTTR
    immunes=getByTemplate(char,FFQ_TIMEFLOWEXCLUDE_CUSTOM,1)
    for obj in Mission_GetDynamicObjects():
        objclass = Object_GetClass(obj)
        if (objclass & FFX_CHARACTER):
            FFX_ObjectSetAttr(obj,'beforeTimeFlowSpeed',Object_GetAttr(obj,'speed'))
            FFX_ObjectSetAttr(obj,'beforeTimeFlowAgility',Object_GetAttr(obj,'agility'))
            if (hasAttribute(obj,'ffqtimemaster') | (FFX_GetTemplate(obj) in immunes) | FFQ_isSameSide(char,obj)):
                Object_SetAttr(obj,'speed',Object_GetAttr(obj,'speed') * 100)
                Object_SetAttr(obj,'agility',Object_GetAttr(obj,'agility') * 100)
    ff.APP_TIME_SCALE = 0.01
    RegTimer('FFqTimeFlowOff',0.5,0,char)
    Object_PlayEffect(char, 'effect_ffq_time1', '', FX_TRACK_OBJECT_FULL)

def FFqTimeFlowOff(event):
    char = event.object
    RPG_SetActive(1) #added since hi speed doesn't prevent power use in FFvsTTR; could cause problems with cutscenes
    for obj in Mission_GetDynamicObjects():
        objclass = Object_GetClass(obj)
        if (objclass & FFX_CHARACTER):
            try:
                Object_SetAttr(obj,'speed',FFX_ObjectGetAttr(obj,'beforeTimeFlowSpeed'))
            except:
                print "can't get the 'beforeTimeFlowSpeed' of %s. He may have been created after the slowing of time."%(obj)
            try:
                Object_SetAttr(obj,'agility',FFX_ObjectGetAttr(obj,'beforeTimeFlowAgility'))
            except:
                print "can't get the 'beforeTimeFlowAgility of %s. He may have been created after the slowing of time."%(obj)
            if FFX_ObjectGetAttr(obj, 'timeFlowAccelerated'):
                FFX_ObjectSetAttr(obj, 'timeFlowAccelerated', 0)
    ff.APP_TIME_SCALE = 1.0
    Sound_PlaySound('ui_time_speedup',Get_ObjectPos(char),1)
    RegTimer('FFqTimeAvailable',30,0,char)

# makes time flow changes available again
def FFqTimeAvailable(event):
    char = event.object
    Mission_SetAttr('ffqtimeflow',0)
    Sound_PlaySound('ui_time_slowdown',Get_ObjectPos(char),1)
    Sound_PlaySound('ui_time_speedup',Get_ObjectPos(char),1)
    Mission_StatusText('The timeflow is back to normal.')


#time travel
def initffqtimetravel(char,update=0):
    if isMP():
        return
    if Mission_GetAttr('allowFFQTimeMaster')<25:
        return
    for forbiddenAttr in FFQ_TIMETRAVELFORBIDDEN:
        if hasAttribute(char,forbiddenAttr):
            return
    if char[-9:] == 'pastself0':
        print "%s is already a time traveler and cannot use Time Travel."%char
        return
    if Mission_GetAttr('ffxSkirmish'):
        ffqTimeTravelSkirmish(char)
    else:
        ffqTimeTravelCampaign(char)

def ffqTimeTravelSkirmish(char):
    if isClone(char):
        return
    try:
        print Mission_GetAttr('ffqtimeflow')
    except:
        Mission_SetAttr('ffqtimeflow',0)
    #prevent shapeshifters from using the power more than once, while allowing multiple character of the same template to use it
    isShapeShifter = FFX_ObjectGetAttr(char,'shapeRow')
    try:
        if Mission_GetAttr('timeTravelUsedBy_%i'%isShapeShifter) > 0:
            print "Time Travel has already been used by this character"
            return
    except:
        Mission_CustomAction('CUSTOM_FFQTIMETRAVELSKIRMISH',char,char,'OnFFqTimeTravelSkirmishSnapshot',1,0)

def OnFFqTimeTravelSkirmishSnapshot(char,dummy):
    if Mission_GetAttr('ffqtimeflow')==1:
        Mission_StatusText('The timeflow cannot take any further tampering for the moment!')
        return
    if chargeEP(char,FFX_EP_FFQTIMETRAVEL)==0:
        return
    Sound_PlaySound('ui_time_slowdown',Get_ObjectPos(char),1)
    handle = Object_PlayEffect(char, 'effect_ffq_time1', '', FX_TRACK_OBJECT_POS)
    ff.APP_TIME_SCALE = 0.1
    RegTimer('ffqTimeTravelTimeOut',0.5)
    Object_SetSecondaryState(char,SCSTATE_DISPLACE_IMAGE,0.5,0)
    fpVarName = '%s_timeTravelSnapshot'%char
    fpTemplate = Object_GetTemplate(char)
    fpHeroPoints = Object_GetAttr(char,'heroPoints')
    fpHealth = Object_GetAttr(char,'health')
    fpEP = Object_GetAttr(char,'energyPoints')
    fpSecStates = Object_GetSecondaryStates(char)
    fpFFXSecStates = Object_GetAttr(char,'ffxState')
    fpPos = Get_ObjectPos(char)
    fpPosSimplified=(round(fpPos[0],1),round(fpPos[1],1),round(fpPos[2],1))
    fpSpeed = Object_GetAttr(char,'speed') ###! weird bug: spawned have speed set to -1 by default!
    travelerCharacteristics = [0, fpTemplate, fpHeroPoints, fpHealth, fpEP, fpSecStates, fpFFXSecStates, fpPosSimplified, fpSpeed]
    #set as missionobjvar.Mission_SetVar() rather than missionobjvar.Object_SetVar() in case object is destroyed
    missionobjvar.Mission_SetVar(fpVarName, travelerCharacteristics)
    Mission_CustomAction('CUSTOM_FFQTIMETRAVELSKIRMISH2',char,char,'OnFFqCreateTravelerSkirmish',1,0)

def OnFFqCreateTravelerSkirmish(char,dummy):
    fpVarName = '%s_timeTravelSnapshot'%char
    travelerCharacteristics = missionobjvar.Mission_GetVar(fpVarName)
    spawnName='%spastself0'%(char)
    if Object_Exists(spawnName):
        print "ffqCreateTravelerSkirmish() fatal error:"
        print "    temporal twin %s already exists!"%spawnName
    Mission_RemoveCustomAction('CUSTOM_FFQTIMETRAVELSKIRMISH', char, char)
    Mission_RemoveCustomAction('CUSTOM_FFQTIMETRAVELSKIRMISH2', char, char)
    #check for NPC version
    template=travelerCharacteristics[1]
    numberOfHeroes = len(cshelper.getAllHeroes())
    if (numberOfHeroes > 3) | ((Object_GetClass(char)&OC_CONTROLLABLE)==0):
        templateNPC='%s_npc'%(template)
        if Template_Exists(templateNPC):
            template=templateNPC
    Object_SpawnAt(template, travelerCharacteristics[7], spawnName)
    handle = Object_PlayEffect(spawnName, 'effect_ffq_time1', '', FX_TRACK_OBJECT_POS)
    Object_SetAttr(spawnName,'heroPoints',travelerCharacteristics[2])
    Object_SetAttr(spawnName,'health',travelerCharacteristics[3])
    Object_SetAttr(spawnName,'energyPoints',travelerCharacteristics[4])
    Object_SetSecondaryState(spawnName,travelerCharacteristics[5],6)
    Object_SetAttr(spawnName,'ffxState',travelerCharacteristics[6])
    Object_SetAttr(spawnName,'speed',travelerCharacteristics[8])
    Object_SetAttr(spawnName,'baseSpeed',travelerCharacteristics[8])
    Object_SetAttr(spawnName,'templateSpeed',travelerCharacteristics[8])
    spawnName=initialiseChar(spawnName) ###! character wasn't initialized in Skirmish
    if (numberOfHeroes > 3) | ((Object_GetClass(char)&OC_CONTROLLABLE)==0):
        FFQ_givesAI(char,spawnName)
    #prevent shapeshifters from using the power more than once, while allowing multiple character of the same template to use it
    isShapeShifter = FFX_ObjectGetAttr(char,'shapeRow')
    if isShapeShifter > 0:
        Mission_SetAttr('timeTravelUsedBy_%i'%isShapeShifter,1)

def ffqTimeTravelCampaign(char):
    try:
        print Mission_GetAttr('ffqtimeflow')
    except:
        Mission_SetAttr('ffqtimeflow',0)
    try:
        print "FFQ_missionID already exists=%s"%(Mission_GetAttr('FFQ_missionID'))
    except:
        global FFQ_MISSION_ID
        FFQ_MISSION_ID = randint(100000,999999)
        Mission_SetAttr('FFQ_missionID',FFQ_MISSION_ID)
        Mission_CustomAction('CUSTOM_FFQTIMETRAVEL',char,char,'OnFFqTimeTravel',1,0)
    RegTimer('ffqTimeTravelSave',4.0,0,char)

def ffqTimeTravelSave(event):
    char=event.object
    if FFQ_MISSION_ID == 0:
        ffqIsTimeTraveler(char)
    else:
        RegTimer('ffqTimeTravelSave',4.0,0,char)
    
def OnFFqTimeTravel(char,dummy):
    if Mission_GetAttr('ffqtimeflow')==1:
        Mission_StatusText('The timeflow cannot take any further tampering for the moment!')
        return
    if chargeEP(char,FFX_EP_FFQTIMETRAVEL)==0:
        return
    Sound_PlaySound('ui_time_slowdown',Get_ObjectPos(char),1)
    handle = Object_PlayEffect(char, 'effect_ffq_time1', '', FX_TRACK_OBJECT_POS)
    ff.APP_TIME_SCALE = 0.1
    RegTimer('ffqTimeTravelTimeOut',2.1)
    Object_SetSecondaryState(char,SCSTATE_DISPLACE_IMAGE,2.1,0)
    ffqTimeWriteFile(char)
    js.Event_RegisterSink(js.EVENT_TIMER, 'onStepCB', '', '', 0.1)
    Mission_StatusText("To go back in time, load a saved game (don't restart)")
    Mission_StatusText("from the current session of this mission.")

def ffqTimeTravelTimeOut(event):
    ff.APP_TIME_SCALE = 1.0

def ffqIsTimeTraveler(char):
    try:
        fp = open('%s/missions/scripts/ffqtime.txt'%(sysutils.getModFolder()), 'r')
        fpMission = pickle.load(fp)
        print "try to do it: fpMission=%s"%(fpMission)
        if fpMission == Mission_GetAttr('FFQ_missionID'):
            fpName = pickle.load(fp)
            fpTemplate = pickle.load(fp)
            fpHeroPoints = pickle.load(fp)
            fpHealth = pickle.load(fp)
            fpEP = pickle.load(fp)
            fpSecStates = pickle.load(fp)
            fpFFXSecStates = pickle.load(fp)
            fpPos = pickle.load(fp)
            global travelerCharacteristics
            travelerCharacteristics = [fpName,fpTemplate,fpHeroPoints,fpHealth,fpEP,fpSecStates,fpFFXSecStates,fpPos]
        else:
            print "Possible error if you're currently trying to use time travel:"
            print "You must load a saved game (not restart) from the current session of this mission."
            travelerCharacteristics = ['error']
        fp.close()
        js.Event_RegisterSink(js.EVENT_TIMER, 'onStepCB', '', '', 0.1)
        if travelerCharacteristics[0] != char:
            print ''
        else:
            charPos = Get_ObjectPos(char)
            ffqCreateTraveler(char,travelerCharacteristics)
    except:
        Mission_StatusText("Possible error: Cannot open 'ffqtime.txt'")
        print "Possible error in 'ffqIsTimeTraveler()': Cannot open 'ffqtime.txt' in '%s' folder"%(sysutils.getModFolder())

    
def ffqCreateTraveler(char,travelerCharacteristics):
    charTemplate = Object_GetTemplate(char)
    charPos = Get_ObjectPos(char)
    charPosSimplified = (round(charPos[0],1),round(charPos[1],1),round(charPos[2],1))
    spawnName='%spastself0'%(char)
    spawnPos = travelerCharacteristics[7]
    FFX_TP(char,spawnPos)
    Object_SetAttr(char,'heroPoints',travelerCharacteristics[2])
    Object_SetAttr(char,'health',travelerCharacteristics[3])
    Object_SetAttr(char,'energyPoints',travelerCharacteristics[4])
    Object_SetSecondaryState(char,travelerCharacteristics[5],6)
    Object_SetAttr(char,'ffxState',travelerCharacteristics[6])
    Mission_RemoveCustomAction('CUSTOM_FFQTIMETRAVEL',char,char)
    handle = Object_PlayEffect(char, 'effect_ffq_time1', '', FX_TRACK_OBJECT_POS)
    #check for NPC version
    template=travelerCharacteristics[1]
    numberOfHeroes = len(cshelper.getAllHeroes())
    if (numberOfHeroes > 3) | ((Object_GetClass(char)&OC_CONTROLLABLE)==0):
        templateNPC='%s_npc'%(template)
        if Template_Exists(templateNPC):
            template=templateNPC
    Object_SpawnAt(template, charPosSimplified, spawnName)
    if (numberOfHeroes > 3) | ((Object_GetClass(char)&OC_CONTROLLABLE)==0):
        FFQ_givesAI(char,spawnName)

def ffqTimeWriteFile(char):
    try:
        fp = open('%s/missions/scripts/ffqtime.txt'%(sysutils.getModFolder()), 'w')
        fpMission = Mission_GetAttr('FFQ_missionID')
        pickle.dump(fpMission, fp)
        pickle.dump(char, fp)
        fpTemplate = Object_GetTemplate(char)
        pickle.dump(fpTemplate, fp)
        fpHeroPoints = Object_GetAttr(char,'heroPoints')
        pickle.dump(fpHeroPoints, fp)
        fpHealth = Object_GetAttr(char,'health')
        pickle.dump(fpHealth, fp)
        fpEP = Object_GetAttr(char,'energyPoints')
        pickle.dump(fpEP, fp)
        fpSecStates = Object_GetSecondaryStates(char)
        pickle.dump(fpSecStates, fp)
        fpFFXSecStates = Object_GetAttr(char,'ffxState')
        pickle.dump(fpFFXSecStates, fp)
        fpPos = Get_ObjectPos(char)
        fpPosSimplified=(round(fpPos[0],1),round(fpPos[1],1),round(fpPos[2],1))
        pickle.dump(fpPosSimplified, fp)
        fp.close()
    except:
        Mission_StatusText("Error! Cannot open 'ffqtime.txt'")
        print "Error in 'ffqTimeWriteFile()'! Cannot open 'ffqtime.txt' in '%s' folder"%(sysutils.getModFolder())        


############## UNTOUCHABLE AURA ################################################
# Character generates a constant knockback aura. Includes anti-missiles defence attribute (see below)
# There is now a similar attribute in FFX, but this one is a bit different:
# -since it's a rip-off of Dr. Mike's auras code, power/fx are customizable
# -its default effect is more powerful... which is not necessarily an advantage, since you'll have
#  a hard time hitting those knocked-away opponents, hehe...
# -it's active whether your character is moving or not.
# -it includes anti-missiles (which was developped just for untouchable aura)
# -it's more processor-intensive (I said "different", not "better"). :(
# 
# Status: 3.4

# Changed 3.4 (FFX 3.0):
# -Updated Object_isAlive() to FFvsTTR

# Notes:
# -Characters with this attributes made the screen shake a bit. :(
#  Workaround added in 3.0... the workaround disables screen shaking each time the power is used,
#  so now aura's triggered only if there's at least one dynamic object near and no cutscene playing.
#
# To temporarily turn off this defence for any character,
# set the following variable to 0 in your script.
FFQ_AURAUNTOUCHABLE_ACTIVE=1

Mission_SetAttr('ff_RPG_KB_JITTER_SCALE',ff.RPG_KB_JITTER_SCALE)

def initffqaurauntouchable(char,update=0,remove=0):
    if remove:
        FFX_ObjectSetAttr(char,'untouchableaura',0)
    else:
        FFX_ObjectSetAttr(char,'untouchableaura',1)
        if FFX_ObjectGetAttr(char,'noantimissiles',0)!=1:
            initffqantimissiles(char,update)
        sparks=getByTemplate(char,FFQ_AURAUNTOUCHABLE_CUSTOM,1)
        if Object_IsAlive(char):
                if sparks!='':
                    handle = Object_PlayEffect(char,sparks,'',FX_LOOP|FX_TRACK_OBJECT_POS,0,'Bip01 Spine')
                    Object_SetAttr(char,'ffqaurauntouchablehandle',handle)
                    RegTimer('updateFFQAuraUntouchable',0.3,0,char)

def updateFFQAuraUntouchable(event):
    char = event.object
    if not Object_Exists(char):
        return
    if FFX_ObjectGetAttr(char,'untouchableaura',0)!=0:
        RegTimer('updateFFQAuraUntouchable',0.3,0,char)
        if Object_IsAlive(char):
            if (FFQ_AURAUNTOUCHABLE_ACTIVE != 0) & (cshelper.isPlaying() != 1):
                i = 0
                everybody = Mission_GetDynamicObjects()
                while i < len(everybody):
                    obj = everybody[i]
                    i = i + 1
                    if (distanceSq(obj,char) < 100*100) & (obj != char): 
                        ff.RPG_KB_JITTER_SCALE = 0
                        Trigger_Explosion(char,getByTemplate(char,FFQ_AURAUNTOUCHABLE_CUSTOM,2),-1)
                        break
                    elif i == len(everybody):
                        ff.RPG_KB_JITTER_SCALE = Mission_GetAttr('ff_RPG_KB_JITTER_SCALE')
            else:
                ff.RPG_KB_JITTER_SCALE = Mission_GetAttr('ff_RPG_KB_JITTER_SCALE')
        else:
            handle = Object_GetAttr(char,'ffqaurauntouchablehandle')
            Object_StopEffect(char,handle)
    else:
        handle = Object_GetAttr(char,'ffqaurauntouchablehandle')
        Object_StopEffect(char,handle)

####################### ANTI-MISSILES DEFENSE #######################################
# Spend a bit of energy to protect you from many direct and very near hits from pesky projectiles.
# Good trade-off, ain't it?
# Mostly ripped from Peace Field, except that it protect only a very small radius around one character
# and it allows that character to use missiles himself. Note, however, that missiles shot again your
# character at point blank will be immune to this defence and that SOME other missile will be able to hit
# you, especially the faster ones.
# As noted above, each use of this power will reduce your EP by 5 for each projectile destroyed. If you
# EP drops to 0, the shield is down.
#
# Sadly, projectiles do not respond to either Trigger_Move() or Trigger_Force().
# So no attract missiles curse and no deflection/reflection/redirection armor.
# Tried to mess with the mass, physical and throwable properties of the projectile_standin template:
# doesn't work either.
#
# Status 1.4

# Changed 1.4 (FFX 3.0):
# -Updated Object_isAlive() to FFvsTTR

# To temporarily turn off this defence for any character,
# set the Mission_SetAttr('allowFFQAntiMissiles',0) in your script.

def initffqantimissiles(char,update=0,remove=0):
    if remove:
        FFX_ObjectSetAttr(char,'ffqantimissiles',0)
    else:
        FFX_ObjectSetAttr(char,'ffqantimissiles',1)
    try:
        print 'Is Anti-Missiles allowed in this mission?= %d'%(Mission_GetAttr('allowFFQAntiMissiles'))
    except:
        print 'Anti-Missiles Attribute is allowed by default in this mission.'
        Mission_SetAttr('allowFFQAntiMissiles',1)
    if FFX_ObjectGetAttr(char,'ffqantimissiles',0)==1:
        RegTimer('updateFFQantiMissiles',0.1,0,char)

def updateFFQantiMissiles(event):
    char = event.object
    if not Object_Exists(char):
        return
    RegTimer('updateFFQantiMissiles',0.1,0,char)
    if Object_IsAlive(char):
        FFQantiMissiles(char)

def FFQantiMissiles(char):
    if FFX_ObjectGetAttr(char,'ffqantimissiles',0)!=1:
        return
    if Mission_GetAttr('allowFFQAntiMissiles') == 0 :
        return
    if Object_GetAttr(char,'energyPoints') < 1:
        return
    for obj in Mission_GetDynamicObjects():
        if Object_GetTemplate(obj)=='projectile_standin':
            if obj[:5]=='mobj_':
                if distanceSq(obj,char)<60*60:
                    #if the object is coming from the outside, destroy it
                    if FFX_ObjectGetAttr(obj,'FFQincomingMissile'):
                        Object_Destroy(obj)
                        reduceEP = FFQ_reduceEP(char,5)
                        sparks=getByTemplate(char,FFQ_ANTIMISSILES_CUSTOM,1)
                        if sparks!='':
                            Object_PlayEffect(char,sparks,'',FX_TRACK_OBJECT_POS,0,'Bip01 Spine')
                elif distanceSq(obj,char)<400*400:
                    FFX_ObjectSetAttr(obj,'FFQincomingMissile',1)
                    #Mission_AddArrowObject('proj_%s'%(obj),obj,js.ARROW_YELLOW,1)


############## POWERPUNCH TEST #################################
# It was a long shot, and it didn't work: using a looping area power with a range of none to enhance melee attacks.
# Do area attacks with a range of none have any kind of effect?


####################### HYPERLEAPER #######################################
# a few very simple changes to Superleaper, to allow very long leaps
# Status: 1.0 OK (more or less) DELETED:
# - tends to teleport, especially if the distance is too long (now I understand why the original's range was limited).
# - No further developments; the TRIGGERFORCE LONGJUMP is closer to what I had in mind.


###################### TRIGGERFORCE JUMPERS ######################################
# An alternative to the buit-in Jumper attribute and to FFX's super-leaper.
# It looks clumsy, but it works! The HIGH JUMP command is certainly not as easy to use nor as precise
# as the build-in JUMP command. Well, it IS cheaper (and it can be combined with other scripted attributes).
#
# Status: 1.6

# Added 1.4 (FFX 3.0):
# -Updated EP cost to new system
# Added 1.6 FFX 3.2):
# -Changed landing animation method to use dummy power, as Slippery
# -Made compatible with Acrobatic and Acrobatic Amateur.
# -High Jumper, Jump Travel: Reduced initial pos. check frequency.
# -Made removable.
# -Hard-coded Jump Travel EP cost.

# Notes/Bugs
# -What are the actual effects of TF_NO_GRAVITY and TF_NO_COLLISION? TF_NO_DAMPING isn't recognized by the game engine.
# -Very rarely, you may get stuck in an object when landing. Jump again to solve.
# -Your character may be unable to jump again just after landing; just move him a bit to solve.
# -minForce and mass are only partialy compensated, because, hey, there should be some advantage to being lighter! ;)
#  (Well, that was the idea, anyway. However, I haven't found how to account for mass; the values below are just trial
#  and error. Help!)
# -Fixed?: Character sometimes got stuck in the landing animation. The same happened from time to time with Superleaper and Acrobat,
#  if I remember correctly. Found a couple workaround, but - guess what? - Dr. Mike had again found a better one. I can't
#  reproduce this intermitent bug anymore, which doesn't imply it doesn't exist anymore, of course. ;/
#  EDIT: bug still happened sometimes, apparently. Should be OK now. EDIT 2: Changed the method for FFvsTTR.
# -Corrected a bug in Jump Travel resulting in possible stun if energy wasn't full!

def initffqhighjumper(char, update=0, remove=0):
    if remove:
        Mission_RemoveCustomAction('CUSTOM_FFQHIGHJUMP',char,char,)
    else:
        Mission_CustomAction('CUSTOM_FFQHIGHJUMP',char,char,'ffqJumpHigh',1,0)

def initffqlowjumper(char, update=0, remove=0):
    if remove:
        Mission_RemoveCustomAction('CUSTOM_FFQLOWJUMP',char,char,)
    else:
        Mission_CustomAction('CUSTOM_FFQLOWJUMP',char,char,'ffqJumpLow',1,0)

def initffqlongjumper(char, update=0, remove=0):
    if remove:
        Mission_RemoveCustomAction('CUSTOM_FFQFARJUMP',char,char,)
    else:
        Mission_CustomAction('CUSTOM_FFQFARJUMP',char,char,'ffqJumpFar',1,0)

def ffqJumpHigh(char,dummy):
    FFX_ObjectSetAttr(char, 'voluntary_flailing', 1)
    AI_Animate(char,'jump_stand','OnFFQjumpHigh',0,1)

def ffqJumpLow(char,dummy):
    FFX_ObjectSetAttr(char, 'voluntary_flailing', 1)
    AI_Animate(char,'jump_stand','OnFFQjumpLow',0,1)

def ffqJumpFar(char,dummy):
    if chargeEP(char, 33)==0:
        return
    FFX_ObjectSetAttr(char, 'voluntary_flailing', 1)
    AI_Animate(char,'jump_stand','OnFFQjumpFar',0,1)

#mass, minForce and strength matter here!
def OnFFQjumpHigh(event):
    char=event.object
    print "%s is jumping high"%(char)
    myMassFactor=Object_GetAttr(char,'mass')
    myMassFactor=sqrt(myMassFactor)
    magnitude=(Object_GetAttr(char,'strength')*5000 + 15000 + Object_GetAttr(char,'minForce')*0.9) / 9*myMassFactor
    Trigger_Force(char,0,-0.2,1,magnitude,TF_NO_ROTATION)
    Object_SetAttr(char,'prejumpMinHealth',Object_GetAttr(char,'minHealth'))
    Object_SetAttr(char,'minHealth',Object_GetAttr(char,'health'))
    pos=Get_ObjectPos(char)
    Object_SetAttr(char,'ffqz1',pos[2])
    RegTimer('ffqGetMaxHeight',0.3,0,char)

#tries to compensate for mass; ignores minForce and strength
def OnFFQjumpLow(event):
    char=event.object
    print "%s is jumping low"%(char)
    myMassFactor=Object_GetAttr(char,'mass')/100
    magnitude=(15000 + (Object_GetAttr(char,'minForce'))) * myMassFactor
    Trigger_Force(char,0,-0.2,1,magnitude,TF_NO_ROTATION)
    Object_SetAttr(char,'prejumpMinHealth',Object_GetAttr(char,'minHealth'))
    Object_SetAttr(char,'minHealth',Object_GetAttr(char,'health'))
    pos=Get_ObjectPos(char)
    Object_SetAttr(char,'ffqz1',pos[2])
    RegTimer('ffqGetMaxHeight',0.1,0,char)

#mass, minForce and strength matter here!
def OnFFQjumpFar(event):
    char=event.object
    print "%s is jumping far"%(char)
    myMassFactor=Object_GetAttr(char,'mass')
    myMassFactor=sqrt(myMassFactor)
    magnitude=(Object_GetAttr(char,'strength')*5500 + 12000 + Object_GetAttr(char,'minForce')*0.7) / 6 * myMassFactor
    Trigger_Force(char,0,-0.9,0.5,magnitude,TF_NO_ROTATION)
    Object_SetAttr(char,'prejumpMinHealth',Object_GetAttr(char,'minHealth'))
    Object_SetAttr(char,'minHealth',Object_GetAttr(char,'health'))
    pos=Get_ObjectPos(char)
    Object_SetAttr(char,'ffqz1',pos[2])
    RegTimer('ffqGetMaxHeight',0.5,0,char)

def ffqGetMaxHeight(event):
    char=event.object
    pos=Get_ObjectPos(char)
    ffqz2=pos[2]
    if (ffqz2 < Object_GetAttr(char,'ffqz1')) | (ffqz2 > 429):
        RegTimer('landonfeet', 0.1, 0, char)
        Object_SetAttr(char,'minHealth',Object_GetAttr(char,'prejumpMinHealth'))
    else:
        Object_SetAttr(char,'ffqz1',ffqz2)
        RegTimer('ffqGetMaxHeight',0.1,0,char)


########################### FASTBALL ##############################################
# A light enough character can be thrown by his stronger teammates with little damage to himself.
# Those teammates will have 2 custom commands on this character:
# -SMASH FASTBALL to throw the character in a straigth horizontal trajectory. Mostly useful for fast access
#  or to smash an enemy.
# -LOB FASTBALL to throw the character in a curved trajectory. Mostly useful to access rooftops and other
#  unreachable areas.
#
# Status: 3.6
#
# Added FFX 2.5
#
# Added 3.6 (FFX 3.2):
# -Changed landing animation method to use dummy power, as Slippery
# -Prevented conflict with Acrobatic

# Notes:
# -Ideally, this would have used FF's throw object targeting (using an invisible boulder, for example), but there were
#  some stumbling blocks, starting with how to make the thrown character follow the exact trajectory in realtime.
#  Beside, the Trigger_Throw() function doesn't behave like the manual says...
# -Throwing direction corresponds to the thrown character's facing, not the thrower's.
# -Distance thrown is in part relative to strength. A strength of "5: very strong" (i.e. 4 for the game engine) is
#  the minimum for 200 lbs and under targets.
#  Characters with the FFX-scripted version of Heavy Lifter (not the built-in one!) have a + 3 bonus to strength.
# -Heavy characters could take Hollow Bones or Mass Control to reduce their weight.
# -Since orientation can't be detected reliably (...), this script can't determinate if the thrower is in front of
#  the character to fastball. Avoid this, since the fastball char will be projected against the thrower!

def initffqfastball(char, update = 0):
    for thrower in cshelper.getAllHeroes():
        if char != thrower:
            Mission_CustomAction('CUSTOM_FFQFASTBALLLOB', thrower, char, 'OnFastballLob', 1, 0)
            Mission_CustomAction('CUSTOM_FFQFASTBALLSMASH',thrower, char, 'OnFastballSmash', 1, 0)

def fastballCheck(char, thrower):
    if Object_GetPrimaryState(char) != PCSTATE_NORMAL:
        Mission_StatusText(getCharDisplayName(char))
        Mission_StatusText("can't be fastballed while in this state!")
        return 0
    if not hasStrengthToLift(thrower, char, bonus = -2):
        Mission_StatusText(getCharDisplayName(char))
        Mission_StatusText("is too heavy for you!")
        return 0
    return 1

def OnFastballSmash(char, thrower):
    if not fastballCheck(char, thrower):
        return
    missionobjvar.Object_SetVar(thrower, 'fastball', char)
    AI_Animate(thrower, 'pick_up_object', 'OnFastBallPicked', 1, 0)#user = 1 for smash, 2 for lob
    RegTimer('OnFastballPlayJump', 1.2, 0, char)

def OnFastballLob(char, thrower):
    if not fastballCheck(char, thrower):
        return
    missionobjvar.Object_SetVar(thrower, 'fastball', char)
    AI_Animate(thrower, 'pick_up_object', 'OnFastBallPicked', 2, 0)#user = 1 for smash, 2 for lob
    RegTimer('OnFastballPlayJump', 1.2, 0, char)
    
def OnFastballPlayJump(event):
    char = event.object
    AI_Animate(char, 'jump_stand', '', 0, 1)

def OnFastBallPicked(event):
    thrower = event.object
    char = missionobjvar.Object_GetVar(thrower, 'fastball')
    throwType = event.user
    print 'OnFastBallPicked: event.user=%d' % event.user    # *** stumpy
    AI_Animate(thrower, 'throw_object')
    oldHP = Object_GetAttr(char, 'health')
    if Object_GetAttr(char, 'minHealth') == 0:
        Object_SetAttr(char, 'minHealth', 1)
        FFX_ObjectSetAttr(char, 'fastballMinHealth', 1)
    RegDamage(char, 'OnFastballHit', oldHP, 0)
    strength = Object_GetAttr(thrower, 'strength')
    FFX_ObjectSetAttr(char, 'voluntary_flailing', 1) #for compatibility with Acrobatic
    if throwType == 1:
        fastballTriggerSmash(char, strength)
    else:
        fastballTriggerLob(char, strength)

def fastballTriggerSmash(char, strength):
    magnitude = Object_GetAttr(char, 'minForce') + 450000 + (strength * 70000) #force needed on the horizontal is way higher!
    Trigger_Force(char, 0, -1, 0.04, magnitude, TF_NO_ROTATION)
    FFX_ObjectSetAttr(char, 'fastballThrown', 1)
    RegTimer('OnFastballThrown', 0.5, 0, char)

def fastballTriggerLob(char, strength):
    magnitude = Object_GetAttr(char, 'minForce') + 15000 + (strength * 1500)
    Trigger_Force(char, 0, -1, 0.9, magnitude, TF_NO_ROTATION)
    FFX_ObjectSetAttr(char, 'fastballThrown', 1)
    RegTimer('OnFastballThrown', 0.5, 0, char)
    
def OnFastballThrown(event):
    char = event.object
    i = event.user
    if i > 3: #if RegDamage hasn't been catched in the last 2.5 secs, call the function manually
        RegTimer('OnFastballHit', 0.1, 0, char)
    else:
        if FFX_ObjectGetAttr(char, 'fastballThrown'): #has RegDamage been catched?
            i = i +1
            RegTimer('OnFastballThrown', 0.5, i, char)
    
def OnFastballHit(event):
    char = event.object
    oldHP = event.user
    FFX_ObjectSetAttr(char, 'voluntary_flailing', 0)
    FFX_ObjectSetAttr(char, 'fastballThrown', 0)
    RegTimer('landonfeet', 0.1, 0, char)
    currentHP = Object_GetAttr(char, 'health')
    if currentHP < oldHP:
        newHP = (currentHP + (oldHP * 3)) / 4
        newHP = int(newHP)
        Object_SetAttr(char, 'health', newHP)
    if FFX_ObjectGetAttr(char, 'fastballMinHealth'):
        Object_SetAttr(char, 'minHealth', 0)



########################### BOUNCY ##############################################
# Character doesn't take damage from knockback and tends to bounce back. Also,
# buildings against which he collides don't suffer.
# Status: 0.0
def initffqbouncy(char, update=0, remove=0):
    FFX_ObjectSetAttr(char, 'ffqbouncy_kb', 0)
    FFX_ObjectSetAttr(char, 'ffqbouncyinvuln-on', 0)
    if remove:
        FFX_ObjectSetAttr(char, 'ffqbouncy', 0)
        Object_SetAttr(char, 'debris', 0)
        mlogreader.cancelAnimationCallbackSink(char, 'OnFFQBouncyLand')
        mlogreader.cancelMLOGDamageCallbackSinkForTarget(char, 'OnFFQBouncyAppliedDamage')
        return
    FFX_ObjectSetAttr(char, 'ffqbouncy', 1)
    Object_SetAttr(char, 'debris', 1)
    mlogreader.regFlailStop(char, 'OnFFQBouncyLand', persistent=1)
    mlogreader.regMLOGDamage('OnFFQBouncyAppliedDamage', target=char, event_type='', success=1, persistent=1)

def OnFFQBouncyLand(event):
    char = event.object
    newKB = int( FFX_ObjectGetAttr(char, 'ffqbouncy_kb') * 0.6 )
    print 'newKB. %i' % newKB
    if newKB > Object_GetAttr(char, 'minForce'):
        FFX_ObjectSetAttr(char, 'ffqbouncy_kb', newKB)
        Trigger_Force(char, 0, 1, randint(2,9) * 0.1, newKB, TF_NO_ROTATION)
    else:
        Mission_StatusText('Pfew. %i' % newKB)
        RegTimer('OnFFQBouncyInvuln', 0.5, 0, char) #remove the invulnerability

def OnFFQBouncyAppliedDamage(event):
    char = event.target
    kb = event.knockback
    FFX_ObjectSetAttr(char, 'ffqbouncy_kb', kb)
    print 'Ouch! %i' % kb
    Mission_StatusText('Ouch! %i' % kb)
    RegTimer('OnFFQBouncyInvuln', 0.5, 0, char) #wait a bit before calling the invuln. code, as flailing is reset on hitting the ground

# add/remove 20 points of temporary invulnerability while flailing
def OnFFQBouncyInvuln(event):
    char = event.object
    if mlogreader.MLOG_IsFlailing(char):
        Mission_StatusText("invulnerable 20")
        invPoints = FFX_ObjectGetAttr(char, 'invPoints')
        if invPoints == 0:
            FFX_ObjectSetAttr( char, 'ivlastdam', Object_GetAttr(char, 'health') )
            if not FFX_ObjectGetAttr(char, 'DamageManagement', 0):
                RegDamage(char, 'DamageManagement')
                FFX_ObjectSetAttr(char, 'DamageManagement', 1)
        FFX_ObjectSetAttr(char, 'invPoints', invPoints+20)
        FFX_ObjectSetAttr(char, 'baseInvPoints', invPoints+20)
        FFX_ObjectSetAttr(char, 'ffqbouncyinvuln-on', 1)
    elif FFX_ObjectGetAttr(char, 'ffqbouncyinvuln-on'):
        invPoints=FFX_ObjectGetAttr(char, 'invPoints')
        FFX_ObjectSetAttr(char, 'invPoints', invPoints-20)
        FFX_ObjectSetAttr(char, 'baseInvPoints', invPoints-20)
        FFX_ObjectSetAttr(char, 'ffqbouncyinvuln-on', 0)


########################### SUPERHEROIC ##############################################
# Character has two extra hero points, as in the never-activated standard attribute
# Note that I've decided against limiting you to a max of 3 hero points, even through only 3
# can be displayed on character portrait. Your choice! ;)
# Status: 1.0 OK
def initffqsuperheroic(char,update=0):
    availableHeroPoints = Object_GetAttr(char,'heroPoints')
    availableHeroPoints = availableHeroPoints + 2
    Object_SetAttr(char,'heroPoints',availableHeroPoints)
    doNothing=0


###################### DIVINE INTERVENTION  #########################################
# A hack of FFX's poltergeist, summoner and private army: summons one or more characters ONCE when hero's health is very low.
# Please note that a killing blow doing more than ffqdivinehealthtreshold in damage will not trigger the power.
# This is by design: there should be a way to defeat the character without undue trouble! ;)
# Getting low health multiple times through the use of hero points, self-healing, etc. doesn't activate the power a second time.
# Again by design. Duration is inversely proportional to prestige value of summoned characters; summons of more than 96,000 total
# prestige cost disappear almost instantly.
# Status: 3.9

# Changed 3.9 (FFX 3.0):
# -Customizable through the Control Center :)
# -Changed the FFQ_DIVINEINTERVENTION_CUSTOM summons sublist to six string entries for better compatibility with the Control Center
# -Restored missing effect when activated
# -Spawns now appear around character, not in a line
# -Spawns' AI now uses initMinionAI()
# -Minor cleanup

# To Do:
# -replace AI generation with initMinionAI, etc.
#
# Bugs:
# -IMPORTANT! Summoning may freeze the computer for up to 30 secs (relative to number of summons and templates)! My code must be even worse than I thought... :(

def initffqdivineintervention(char,update=0):
    if isMP():
        return
    ffqdivinehealthtreshold = 19
    if Object_GetAttr(char,'maxHealth') <= ffqdivinehealthtreshold:
        ffqdivinehealthtreshold = Object_GetAttr(char,'maxHealth') - 1
    Event_RegisterSink(EVENT_OBJ_HEALTHCHANGED, 'ffqDivineInterventionOn', char, '', ffqdivinehealthtreshold)
    for obj in getFFQDivineSquad(char):
        print "precaching %s"%(obj)
        Mission_PrecacheTemplateObj(obj)

def ffqDivineInterventionOn(event):
    char=event.object
    if Object_IsAlive(char):
        exec getByTemplate(char,FFQ_DIVINEINTERVENTION_CUSTOM,9)
        divineSquadGroup = getFFQDivineSquad(char)
        divineSquadValue=0
        currentSquadMember=0
        charPos = Get_ObjectPos(char)
        posOffset = ((0,25), (17,-17), (-17,-17), (17,17), (0,-25), (-17,17))
        fx=getByTemplate(char,FFQ_DIVINEINTERVENTION_CUSTOM,7)
        for divineSquadMember in divineSquadGroup:
            template=divineSquadGroup[currentSquadMember]
            name = '%s_div%i'%(char, currentSquadMember)
            spawnPos = (charPos[0] + posOffset[currentSquadMember][0], charPos[1] + posOffset[currentSquadMember][1], charPos[2])
            cshelper.spawn(name, template, spawnPos)
            FFX_ObjectSetAttr(name, 'master', Object_GetAttr(char, 'ffxID'))
            FFX_ObjectSetAttr(name, 'minionType', 0)
            initMinionAI(name, m25ai.GetTeam(char), target = '', evil = isEvil(char))
            divineSquadValue=Object_CalcPrestige(name) + divineSquadValue
            currentSquadMember=currentSquadMember + 1
            print "Hello mortal. Ye may call me... %s!"%(name)
            if fx!='':
                Object_PlayEffect(event.object,fx)
        FFX_ObjectSetAttr(char,'army',currentSquadMember)
        divineSquadValue=divineSquadValue / 2000
        if divineSquadValue > 48:
            print 'Your divine intervention summons are overpriced!'
            Mission_StatusText('Your divine intervention summons are overpriced!')
            divineSquadValue = 49
        divineSquadDuration=50 - divineSquadValue
        print "divineSquadDuration=%s"%(divineSquadDuration)
        RegTimer('ffqDivineInterventionOff',divineSquadDuration,0,char)
        #confuse squad on character death
        Event_RegisterSink(EVENT_OBJ_HEALTHCHANGED, 'ffqDivineInterventionPain', char, '', 1)

#if your character dies, make each of his minions confused
def ffqDivineInterventionPain(event):
    char=event.object
    divineSquadGroup = getFFQDivineSquad(char)
    nameChunk1='%s'%(char)
    currentSquadMember=0
    for divineSquadMember in divineSquadGroup:
        nameChunk2='_div%i'%(currentSquadMember)
        name=nameChunk1 + nameChunk2
        currentSquadMember=currentSquadMember + 1
        if Object_Exists(name):
            Object_SetPrimaryState(name, js.PCSTATE_BLANK, randint(1,15))

def ffqDivineInterventionOff(event):
    char=event.object
    divineSquadGroup = getFFQDivineSquad(char)
    nameChunk1='%s'%(char)
    currentSquadMember=0
    fx=getByTemplate(char,FFQ_DIVINEINTERVENTION_CUSTOM,8)
    for divineSquadMember in divineSquadGroup:
        nameChunk2='_div%i'%(currentSquadMember)
        name=nameChunk1 + nameChunk2
        currentSquadMember=currentSquadMember + 1
        if Object_Exists(name):
            if fx!='':
                Object_PlayEffect(event.object,fx)
            Object_Destroy(name)

def getFFQDivineSquad(char):
    divineSquadGroup = []
    currentEntry = 1
    while currentEntry < 7:
        currentTemplate = getByTemplate(char, FFQ_DIVINEINTERVENTION_CUSTOM, currentEntry)
        if currentTemplate != '':
            divineSquadGroup.append(currentTemplate)
        currentEntry = currentEntry + 1
    return divineSquadGroup


###################### TRACKING #########################################
# A second hack/ripoff of FFX's enhanced senses (telepathy).
# You can detect the general direction of the enemy character nearest to yours.
# Upon detection, your character will turn in the direction of the nearest enemy. Simple, no?
#
# Status: 1.3

# Added 1.2 (FFX 3.0):
# -Updated EP cost to new system
# -Customization now available, thanks to Dr Mike's nifty new configuration system for the Control Center
# Added 1.3 (FFX 3.2.0 alpha):
# -Made removable

# -FOR MODDERS:
#  You can capture players triggering this power by setting missionobjvar.Mission_SetVar('ffq_trackingCS', 'functionName')
#  where "functionName" is a user-defined function with the character using the precognitive power as parameter. Ex.:
#    missionobjvar.Mission_SetVar('ffq_trackingCS', 'senseOminousEvent')
#  will call
#    senseOminousEvent(char)
#  Important: after calling your function, reset missionobjvar.Mission_SetVar('ffq_trackingCS', '') to avoid triggering
#  your function more than once.

FFQ_EP_TRACKING=33

def initffqtracking(char, update=0, remove=0):
    cmd=getByTemplate(char,FFQ_TRACKING_CUSTOM,2)
    #attribute already set?
    if remove:
        if FFX_ObjectGetAttr(char,'ffqtracking'):
            FFX_ObjectSetAttr(char, 'ffqtracking', 0)
            FFX_ObjectSetAttr(char, 'ffqtracking_active', 0)
            Mission_RemoveCustomAction(cmd, char, char)
        return
    if FFX_ObjectGetAttr(char, 'ffqtracking'):
        return
    #set the attribute
    FFX_ObjectSetAttr(char, 'ffqtracking', 1)
    FFX_ObjectSetAttr(char, 'ffqtracking_active', 0)
    if not missionobjvar.Mission_VarExists('ffq_trackingCS'):
        missionobjvar.Mission_SetVar('ffq_trackingCS', '')
    Mission_CustomAction(cmd, char, char, 'OnFFQTrack', 5, 0)

def OnFFQTrack(char, dummy, epcost=FFQ_EP_TRACKING):
    if chargeEP(char,epcost) == 0:
        return
    #intercept the command and play a modder's function if defined
    func = missionobjvar.Mission_GetVar('ffq_trackingCS')
    if func != '':
        exec "%s('%s')"%(func, char)
        return
    Object_PlayEffect(char, getByTemplate(char, FFQ_TRACKING_CUSTOM, 1), '', 0, 0, 'Bip01 Head')
    FFX_ObjectSetAttr(char, 'ffqtracking_active', 1)
    target = getNearestAdversary(char)
    Trigger_Move(char, "turn", Get_ObjectPos(target), 'OnFFQTrackingEnd')

def OnFFQTrackingEnd(event):
    char = event.object
    FFX_ObjectSetAttr(char, 'ffqtracking_active', 0)


###################### PRECOGNITIVE #########################################
# Another  hack/ripoff of FFX's enhanced senses (telepathy), using Stumpy's datfiles module.
# Your extra-sensorial perceptions allow you to detect places which might be dangerous or important and to guess
# what your enemies' position will be in a few seconds.
#
# Of course, precognitive powers are notoriously unreliable.
#
# Status: 2.16

# Added 2.16 (FFX 3.0):
# -Updated EP cost to new system

# Bugs/Notes:
# -Detection of "dangerous or important places" simply read positional markers from the mission.dat file (what did you expect?)
#  This should work with most mods and Danger Room missions. However, maps from the main FF campaign (either in campaign
#  mode or while replaying a campaign episode in the Danger Room) usually won't have a readable mission.dat (see details 
#  in datfiles.py). In these cases, only characters and projectiles potential futures positions are shown.
# -#@&*! engine bugs (?). This was bad.
#
# -FOR MODDERS:
#  You can capture players triggering this power by setting missionobjvar.Mission_SetVar('ffq_precognitiveCS', 'functionName')
#  where "functionName" is a user-defined function with the character using the precognitive power as parameter. Ex.:
#    missionobjvar.Mission_SetVar('ffq_precognitiveCS', 'senseOminousEvent')
#  will call
#    senseOminousEvent(char)
#  Important: after calling your function, reset missionobjvar.Mission_SetVar('ffq_precognitiveCS', '') to avoid triggering
#  your function more than once.

FFQ_EP_PRECOGNITIVE=33

def initffqprecognitive(char, update=0):
    try:
        Mission_GetAttr('ffq_precognitive')
    except:
        Mission_SetAttr('ffq_precognitive', 0)
    if not missionobjvar.Mission_VarExists('ffq_precognitiveCS'):
        missionobjvar.Mission_SetVar('ffq_precognitiveCS', '')
    cmd = getByTemplate(char, FFQ_PRECOGNITIVE_CUSTOM, 3)
    Mission_CustomAction(cmd, char, char, 'OnFFQPrecognitive', 5, 0)

def OnFFQPrecognitive(char, dummy):
    if Mission_GetAttr('ffq_precognitive') != 0:
        return
    if chargeEP(char, FFQ_EP_PRECOGNITIVE) == 0:
        return
    FFX_Animate(char, getByTemplate(char, FFQ_PRECOGNITIVE_CUSTOM, 1))
    Object_PlayEffect(char, getByTemplate(char, FFQ_PRECOGNITIVE_CUSTOM, 2), '', 0, 0, 'Bip01 Head')
    #intercept the command and play a modder's function if defined
    func = missionobjvar.Mission_GetVar('ffq_precognitiveCS')
    if func != '':
        exec "%s('%s')"%(func, char)
        return
    Mission_SetAttr('ffq_precognitive', 1)
    #arrow the positional markers
    try:
        markers = datfiles.Mission_GetStartingPositionals()
    except:
        markers = []
        print "OnFFQPrecognitive non-fatal error:"
        print "    cannot read mission.dat; positional markers will be skipped"
    for marker in markers:
        Mission_AddArrowPos('precogMArw_%s'%marker, js.Get_MarkerPos(marker), js.ARROW_RED)
        RegTimer('OnRemoveFFQPrecogMarkerArrows', 5)
    baddies = []
    for obj in Mission_GetDynamicObjects():
        #initialize enemy position guess
        if ((Object_GetClass(obj) & (OC_VILLIAN | OC_MINION)) != 0 ) | (m25ai.GetTeam(obj) > 1):
            if Object_IsAlive(obj):
                baddies.append(obj)
    for obj in baddies:
        guessObjectDest(obj, 4)
    missionobjvar.Object_SetVar(char, 'precogBaddies', baddies)
    #couldn't put the baddies list either as a RegTimer2 argument or as a RegTimer string argument
    #because it usually crashed the game after a variable number of iterations!
    RegTimer('OnBaddiesGuessed', 0.2, 0, char)

def OnBaddiesGuessed(event):
    times = event.user
    char = event.object
    baddies = missionobjvar.Object_GetVar(char, 'precogBaddies')
    if times > 0:
        i = 0
        for obj in baddies:
            Mission_RemoveArrow('precogBArw%i_%i'%(times - 1, i))
            i = i + 1
    if times < 20:
        i = 0
        for obj in baddies:
            if Object_Exists(obj):
                guessedPos = (FFX_ObjectGetAttr(obj,'guessedPos_x'), FFX_ObjectGetAttr(obj,'guessedPos_y'), Get_ObjectPos(obj)[2])
                Mission_AddArrowPos('precogBArw%i_%i'%(times, i), guessedPos, js.ARROW_YELLOW)
                guessObjectDest(obj, 4)
            else:
                baddies.remove(obj)
                missionobjvar.Object_SetVar(char, 'precogBaddies', baddies)
            i = i + 1
        times = times + 1
        RegTimer('OnBaddiesGuessed', 0.2, times, char)
    else:
        Mission_SetAttr('ffq_precognitive', 0)

def OnRemoveFFQPrecogMarkerArrows(event):
    markers = datfiles.Mission_GetStartingPositionals()
    for marker in markers:
        Mission_RemoveArrow('precogMArw_%s'%marker)


###################### WEAK SPOT #########################################################
# Character has a 3% chance of receiving 50% maxHP in stunning damage on a single shot ONCE.
# Essential for the self-image of many a would-be evil genius who perversely enjoy abject failure in the grasp of success.
# Status: 2.0
#
# Changes:
# -Added code for use in Flawed Invulnerability
# -Added Genetic Damage on weakspot
#
# To do:
# -create related attributes
# -allow the custom message to be changed for a speech
FFQ_RPG_WEAKSPOT_CHANCE=3

def initffqweakspot(char,update=0):
    Object_SetAttr(char,'lastHealthFFQWS',Object_GetAttr(char,'health'))
    if hasAttribute(char,'ffqflawedinvulnerability'):
        Object_SetAttr(char,'riskFactorFFQWS',FFQ_RPG_FLAWEDINVULNERABILITY_CHANCE)
    else:
        Object_SetAttr(char,'riskFactorFFQWS',FFQ_RPG_WEAKSPOT_CHANCE)
    RegDamage(char,'OnffqWeakSpotRisk')

def OnffqWeakSpotRisk(event):
    char=event.object
    damage=Object_GetAttr(char,'lastHealthFFQWS')-Object_GetAttr(char,'health')
    Object_SetAttr(char,'lastHealthFFQWS',Object_GetAttr(char,'health'))
    riskFactor=Object_GetAttr(char,'riskFactorFFQWS')
    if (damage>0) & (randint(0,99)<riskFactor):
        print "Bullseye on %s's weakspot!"%(char)
        Mission_StatusText("Bullseye on %s's weakspot!"%(char))
        if hasAttribute(char,'ffqflawedinvulnerability'):
            #remove the Flawed Invulnerability
            FFQDesactivateInvulnerable(char)
        Object_SetPrimaryState(char,PCSTATE_STUNNED,10)
        Object_SetGenericState(char,OBJSTATE_ALTERED_STRUCTURE,10)
        Trigger_Damage(char,Object_GetAttr(char,'maxHealth')/2)
        Object_SetAttr(char,'riskFactorFFQWS',-1)
    else:
        RegDamage(char,'OnffqWeakSpotRisk')


###################### FLAWED INVULNERABILITY #########################################################
# A special combo: Character has the invulnerable (grade 4) attribute, until his weak spot (see above) is found.
# Weak spot chance is somewhat higher than for straight weakspot.
# Based on an idea by Crom Cruach.
# Weak Spot code has been modified for this attribute.
#
# Status: 1.1
#
# Changes:
# -Added Genetic Damage on weakspot
FFQ_RPG_FLAWEDINVULNERABILITY_CHANCE=5

def initffqflawedinvulnerability(char,update=0):
    initinvulnerable4(char,update)
    initffqweakspot(char,update)


# remove/restore FFX invulnerable attribute from a character, either temporarily or permanently
# could also be used independently outside of Flawed Invulnerability
def FFQDesactivateInvulnerable(char, duration = -1):
    print "%s's invulnerability has been removed!"%(char)
    FFX_ObjectSetAttr(char,'invPoints',0)
    if duration > -1:
        RegTimer('FFQReactivateInvulnerable',duration,0,char)

def FFQReactivateInvulnerable(event):
    char = event.object
    print "%s's invulnerability has been restored."%(char)
    FFX_ObjectSetAttr(char,'invPoints', FFX_ObjectGetAttr(char,'baseInvPoints'))


###################### DISGUISE ###################################################
# Character can apparently change into a civilian, thus being ignored by many enemy AIs.
# The civ disappears and the character becomes visible again when:
# -the character uses the TAKE OFF DISGUISE in order to use any power or pick an object
# -the civilian takes damage or is frozen, in stasis, blanked, enraged or hypnotised
#  (panic doesn't count)
#
# For "Fred".;)
#
#
# Status: 4.1

# Added 4.0 (FFX 3.0):
# -Updated EP cost to new system
# -Default civilian based on civilians already on map to account for FFvsTTR Cubans and Germans
# -Corrected a small phonebooth detection bug
# -Replaced ffx_tiggot mesh due to a bug apparently caused by reducing mesh size by hexing too much,
#  seemingly causing it to have difficulty interacting with the physics (moving and being hit)
# -Rewrote lots of code, mostly in the damage management
# -Character now cannot disguise in plain sight of civilians (range is somewhat smaller than for enemies)
# Added 4.1 (FFX 3.05 alpha):
# -Corrected a custom command duplication bug
# -Disguised character now reverts when getting too near enemies with Tracking, Enhanced Senses or Cosmic Awareness.

# Notes/Bugs:
# -Civilians disguises run instead of walking as civs do when there's no immediate danger.
# -Civilian disguises can't be panicked, because otherwise they'd tend to panic whenever they
#  see any danger.
# -Damage done to the civilian fully transfers to the non-disguised hero, even if his resistances
#  are different. Otherwise, turning into a civilian would make you invulnerable! ;P
# -Other characters will pass right through the disguised char instead of avoid him/her.
# -Attacks done on disguised characters (by area attacks or by enemies who don't like civs)
#  will usually be targeting a point somewhat away from the character.
# -IMPORTANT: Mousing over you disguised character displays the standard pointer instead of the hand
#  even through the character has a custom command on himself. Furthermore, the actual mousing over
#  often requires moving the character just before clicking on him. It may be easier to right-click on
#  the character's portrait instead.
# -A character can't disguise himself when enemies are nearby. May I suggest using a phone booth?
# -AI characters won't use Disguise. One reason being that disguises can't be targeted by the player.
#  (Well, it could be done, of course, but would require additional alternate code.)

FFQ_EP_DISGUISE=66

# FFQ_DISGUISE_TEMPLATES_X
# In case some modder wants to change or add civilian templates (say, a car for the robot "gender").
# You may also add a template directly to have a particular character change into a custom diguise.
# For ex., to have the campaign version of Liberty Lad disguise himself into Nick Craft, you'd add the line
#   'liberty_lad': 'disguise template name, such as ffq_civilian_nick',
#
# To get either a kid, a male or a female civilian at random each time for an illusionist named Fred:
#   'fred': ['ffq_civilian_female', 'ffq_civilian_kid', 'ffq_civilian_male'][randint(0,2)],
#
# Note that you should copy a 'ffq_civilian_...' into a new template and change the mesh to be certain of
# preserving the necessary template and character settings.
#
# getDisguiseGender() defaults to male if the character's voice isn't from the girls or boys
# (or 'LL' for Liberty Lad or 'kd' for the generic kid)

# The attribute with default settings will now try to find the most appropriate type of civilian
# template, based on the template of the first real civilian found on the map, if any.
# You can override the choice in OnPostInit() by setting
#     missionobjvar.Mission_SetVar('ffq_disguise_location', FFQ_DISGUISE_TEMPLATES_X)
# where FFQ_DISGUISE_TEMPLATES_X is one of FFQ_DISGUISE_TEMPLATES, FFQ_DISGUISE_TEMPLATES_CUBAN
# or FFQ_DISGUISE_TEMPLATES_GERMAN.

#default
FFQ_DISGUISE_TEMPLATES={
    'female': 'ffq_civilian_female',
    'kid': 'ffq_civilian_kid',
    'male': 'ffq_civilian_male',
    }

FFQ_DISGUISE_TEMPLATES_CUBAN={
    'female': 'ffq_civilian_female',
    'kid': 'ffq_civilian_kid',
    'male': 'ffq_civilian_male_cub',
    }

FFQ_DISGUISE_TEMPLATES_GERMAN={
    'female': 'ffq_civilian_female_ger',
    'kid': 'ffq_civilian_kid',
    'male': 'ffq_civilian_male_ger',
    }

# Try to find the most appropriate type of civilian template, based on the template of the first
# real civilian found on the map, if any (nothing fancy).
def getDisguiseLocation():
    global FFQ_DISGUISE_TEMPLATES
    if missionobjvar.Mission_VarExists('ffq_disguise_location'):
        FFQ_DISGUISE_TEMPLATES = missionobjvar.Mission_GetVar('ffq_disguise_location')
        print "getDisguiseLocation(): 'ffq_disguise_location' already set."
        return
    allCivs = FFQ_getAllCivilians(checkLiving = 0)
    allCivsTemplates = []
    for civ in allCivs:
        allCivsTemplates.append(Object_GetTemplate(civ))
    for civTemplate in allCivsTemplates:
        if civTemplate == 'cuban_male':
            FFQ_DISGUISE_TEMPLATES = FFQ_DISGUISE_TEMPLATES_CUBAN
            missionobjvar.Mission_SetVar('ffq_disguise_location', FFQ_DISGUISE_TEMPLATES_CUBAN)
            print "getDisguiseLocation(): 'ffq_disguise_location' set to Cuban."
            return
        elif (civTemplate == 'berlin_female') or (civTemplate == 'berlin_male'):
            FFQ_DISGUISE_TEMPLATES = FFQ_DISGUISE_TEMPLATES_GERMAN
            missionobjvar.Mission_SetVar('ffq_disguise_location', FFQ_DISGUISE_TEMPLATES_GERMAN)
            print "getDisguiseLocation(): 'ffq_disguise_location' set to German."
            return
    missionobjvar.Mission_SetVar('ffq_disguise_location', FFQ_DISGUISE_TEMPLATES)
    print "getDisguiseLocation(): 'ffq_disguise_location' set to default."
    
def getDisguiseGender(char):
    if FFQ_DISGUISE_TEMPLATES.has_key(FFX_GetTemplate(char)):
        return FFX_GetTemplate(char)
    voice = Template_GetSpeechID(Object_GetTemplate(char))
    if (voice == 'LL') or (voice == 'kd'):
        return 'kid'
    for g in girls:
        if voice == g:
            return 'female'
    return 'male'


def initffqdisguise(char,update=0):
    getDisguiseLocation()
    Mission_CustomAction('CUSTOM_FFQDISGUISEON', char, char, 'OnFFQDisguise1', 5, 0) 
    for obj in Mission_GetObjects():  # stumpy 2006-09-26: no need for terrain check
        if Object_Exists(obj):
            #this test covers pat_phone_booth and ger_phone_booth
            if Object_GetTemplate(obj)[-11:] == 'phone_booth':
                Mission_CustomAction('CUSTOM_FFQDISGUISEON2', char, obj, 'OnFFQDisguise', 3, 0)

def OnFFQDisguise1(dummy, char):
    print char
    if len(cshelper.getNearBaddies(char, 325, checkLiving = 1, template = 'none')) > 0:
        Mission_StatusText("I can't disguise myself in plain sight of enemies!")
        return
    if len(getNearCivilians(char, 275)) > 0:
        Mission_StatusText("I can't disguise myself in plain sight of bystanders!")
        return
    OnFFQDisguise(dummy, char)
    
def OnFFQDisguise(dummy, char):
    print char
    if cshelper.isPlaying():
        return
    epcost = FFQ_EP_DISGUISE
    if chargeEP(char, epcost) == 0:
        return
    disguiseName = getFormName()
    originalTemplate = Object_GetTemplate(char)
    disguiseTemplate = FFQ_DISGUISE_TEMPLATES[getDisguiseGender(char)]
    charHealth = Object_GetAttr(char, 'health')
    charMaxHealth = Object_GetAttr(char, 'maxHealth')
    morph(disguiseName, char, disguiseTemplate, proportional=0)
    RegTimer2('OnFFQDisguiseCiv', 2.5, arglist=(disguiseName, originalTemplate, charHealth, charMaxHealth), persistent = 0)

def OnFFQDisguiseCiv(disguiseName, originalTemplate, charHealth, charMaxHealth):
    print disguiseName
    print originalTemplate
    missionobjvar.Object_SetVar(disguiseName, 'disguiseOriginalTemplate', originalTemplate)
    Mission_CustomAction('CUSTOM_FFQDISGUISEOFF', disguiseName, disguiseName, 'OnFFQDisguiseOff', 5, 0)
    civ = "%s_disguise"%disguiseName
    Object_SpawnAt('ffq_civilian_disguise', Get_ObjectPos(disguiseName), civ)
    Object_SetAttr(civ, 'ffxState', 0)
    Object_SetAttr(civ, 'ffxCustomID', -99)
    m25ai.SetTeam(civ, m25ai.TEAM_NONCOMBATANT)
    m25ai.AIDisable(civ)
    initfearless(civ) #against panicked civilians
    #gives the civilian AI tiggot the same HP as the original
    Object_SetAttr(civ, 'maxHealth', charMaxHealth)
    Object_SetAttr(civ, 'health', charHealth)
    #reduces disguise's maxHealth to 20 like normal civ
    disguiseMaxHealth = Object_GetAttr(disguiseName, 'maxHealth')
    disguiseBaseHealth = Object_GetAttr(disguiseName, 'health')
    disguiseNewHealth = max(1, round((20 / disguiseMaxHealth * disguiseBaseHealth), 0)) #give the disguise proportional HP on 20, with 1 as minimum
    Object_SetAttr(disguiseName, 'maxHealth', 20)
    Object_SetAttr(disguiseName, 'health', disguiseNewHealth)
    #prevents the disguise itself from being damaged
    Object_SetAttr(disguiseName, 'minHealth', disguiseNewHealth)
    RegTimer('OnFFQDisguiseFollow', 1, charHealth, disguiseName, civ)

def OnFFQDisguiseFollow(event):
    disguiseName = event.object
    civ = event.string
    charHealth = event.user
    if not Object_Exists(civ):
        return
    if charHealth > Object_GetAttr(civ, 'health'):
        OnFFQDisguiseOff(disguiseName, disguiseName)
        return
    if Object_GetPrimaryState(civ) != PCSTATE_NORMAL: #revert to base form without applying the state, since character may be resistant or immune
        OnFFQDisguiseOff(disguiseName, disguiseName)
        return
    nearbyEnemies = getNearEnemies(disguiseName, 250)
    for enemy in nearbyEnemies:
        if hasAttribute(enemy, 'ffqtracking'):
            Object_PlayEffect(enemy, getByTemplate(enemy, FFQ_TRACKING_CUSTOM, 1), '', 0, 0, 'Bip01 Head')
            cshelper.turnTo(enemy, civ)
            Mission_StatusText("Disguised character detected through Tracking")
            OnFFQDisguiseOff(disguiseName, disguiseName)
            return
        if hasAttribute(enemy, 'telepathy'):
            Object_PlayEffect(enemy, getByTemplate(enemy, FFX_SCAN_CUSTOM, 2), '', 0, 0, 'Bip01 Head')
            Mission_StatusText("Disguised character detected through Enhanced Senses")
            OnFFQDisguiseOff(disguiseName, disguiseName)
            return
        if hasAttribute(enemy, 'sensitive'):
            Mission_StatusText("Disguised character detected through Cosmic Awareness")
            OnFFQDisguiseOff(disguiseName, disguiseName)
            return
    #continue following the disguise
    disguiseNamePos = Get_ObjectPos(disguiseName)
    #offset to allow SOME chance to get a mouse over; otherwise, the tiggot always gets in the way
    Trigger_Move(civ, 'move', (disguiseNamePos[0]+4, disguiseNamePos[1]+4, disguiseNamePos[2]), '', 0, 0)
    RegTimer('OnFFQDisguiseFollow', 1, charHealth, disguiseName, civ)

def OnFFQDisguiseOff(disguiseName, dummy):
    civ = "%s_disguise"%disguiseName
    Object_SetAttr(disguiseName, 'maxHealth', Object_GetAttr(civ, 'maxHealth'))
    Object_SetAttr(disguiseName, 'health', Object_GetAttr(civ, 'health'))
    Object_SetAttr(disguiseName, 'minHealth', 0)
    originalNewName = getFormName()
    originalTemplate = missionobjvar.Object_GetVar(disguiseName, 'disguiseOriginalTemplate')
    Object_Destroy(civ)
    morph(originalNewName, disguiseName, originalTemplate, proportional=0) 


###################### DESESPERATE ######################################################
# Character gets back additional energy points almost* equal to damage received and may get 300% percenter as well.
# (*almost: to avoid a combo of this and passive energy shield being too powerful)
# Code mostly ripped from FFX Accidental clone.
# Status: 1.1

# Changed 1.1 (FFX 3.0):
# -replaced Trigger_Power(char, char, 'minute Patriot Charge', '') with a secondary state call,
#  as the former cost EP and forced a character animation...
# Changed FFX 3.2.0:
# -Modified code called by setRalliedState() to prevent Rally from stacking.

def initffqdesesperate(char,update=0):
    Object_SetAttr(char, 'lastHealthFFQDesesperate', Object_GetAttr(char, 'health'))
    RegDamage(char, 'OnFFQDesesperate')

def OnFFQDesesperate(event):
    char= event.object
    damage= Object_GetAttr(char, 'lastHealthFFQDesesperate') - Object_GetAttr(char, 'health')
    if damage > 1:
        Object_SetAttr(char, 'energyPoints', min(Object_GetAttr(char, 'energyPoints') + damage - 1, Object_GetAttr(char, 'maxEnergyPoints')))
        if FFX_Rand(1,15) < damage:
            setRalliedState(char, duration = max(5, damage))
    Object_SetAttr(char, 'lastHealthFFQDesesperate', Object_GetAttr(char, 'health'))
    RegDamage(char, 'OnFFQDesesperate')


###################### LONER / TEAM PLAYER ###############################################
# Character gets higher/lower agility and energy recharge if there no ally around and lower/higher if there are very near.
# Note: policemen count; so, when using a team player on a single hero mission, try to stick around them.
# Loner is done by request of Mr. Matt Murdock, while Team Player was petitioned by Mr. Dick Grayson.
# Status: 1.3
#
# Added FFX 2.5

# Changed 1.3 (FFX 3.0):
# -changed handle calls to use FFX_ObjectSetAttr()
# -updated Object_IsAlive() to FFvsTTR

# Notes:
# -M252 AI enabled: AI characters will try to move away/near if they have nothing more urgent to do.

def initffqloner(char,update=0):
    if update == 0:
        Object_SetAttr(char, 'ffqloner-handle', 0)
        RegTimer('updateFFQLoner',3,0,char,'1')

def initffqteamplayer(char,update=0):
    if update == 0:
        Object_SetAttr(char, 'ffqloner-handle', 0)
        RegTimer('updateFFQLoner',3,0,char,'-1')

def updateFFQLoner(event):
    char = event.object
    if not Object_Exists(char):
        return
    previousStatus = event.user
    attrib = event.string
    attrib = int(attrib)
    nearAllies = getNearAllies(char, 300, checkLiving = 1)
    handle = FFX_ObjectGetAttr(char,'ffqloner-handle')
    if Object_IsAlive(char):
        if len(nearAllies) == 0:
            newStatus = 1 #allies are far from this character
        else:
            newStatus = 0 #allies are either between 100 and 300 distance
            pos1 = Get_ObjectPos(char)
            for ally in nearAllies:
                pos2 = Get_ObjectPos(ally)
                if cshelper.distance2D(pos1, pos2) < 100:
                    newStatus = -1 #at least one ally is very near
                    break
        newStatus = newStatus * attrib #changes 1 to -1 and vice versa if attribute is team player instead of loner
        i = previousStatus
        while i != newStatus:
            if i != 0:
                Object_StopEffect(char,handle)
            if i < newStatus:
                augmentFFQLoner(char)
                i = i + 1
            if i > newStatus:
                reduceFFQLoner(char)
                i = i - 1
        if (newStatus == 1) and (previousStatus != 1):
            handle = Object_PlayEffect(char,'effect_ffq_loner_pos','',FX_LOOP|FX_TRACK_OBJECT_POS,0)
            FFX_ObjectSetAttr(char,'ffqloner-handle',handle)
        elif (newStatus == -1) and (previousStatus != -1):
            handle = Object_PlayEffect(char,'effect_ffq_loner_neg','',FX_LOOP|FX_TRACK_OBJECT_POS,0)
            FFX_ObjectSetAttr(char,'ffqloner-handle',handle)
    else:
        Object_StopEffect(char,handle)
    RegTimer('updateFFQLoner',3,newStatus,char,str(attrib))

def augmentFFQLoner(char):
    previousAgility = Object_GetAttr(char, 'agility')
    previousEnergy = Object_GetAttr(char, 'energy')
    Object_SetAttr(char, 'agility', previousAgility + 1)
    if previousEnergy < 9:
        Object_SetAttr(char, 'energy', previousEnergy + 1)

def reduceFFQLoner(char):
    previousAgility = Object_GetAttr(char, 'agility')
    previousEnergy = Object_GetAttr(char, 'energy')
    if previousAgility > 0:
        Object_SetAttr(char, 'agility', previousAgility - 1)
    if previousEnergy > 0:
        Object_SetAttr(char, 'energy', previousEnergy - 1)



################ DEATHWISH ######################################
# Character can't recover health.
# NOTES:
# -health given back by the "invulnerable" and "temporary invulnerability" attributes is handled correctly
# -This attribute is more of a handicap in FFvsTTR, because of resurrection through hero point or restoration power;
#  cost has been adjusted accordingly
#
# Status 1.2

# Changed 1.2 (FFX 3.0):
# -When suffering damage, the health bar briefly flashes the original max health to give some feedback to the player.
# -Corrected maxHealth bug when character also has shapeshifting or a similar attribute.

def initffqdeathwish(char,update=0):
    if update == 0:
        health = Object_GetAttr(char,'health')
        maxHealth = Object_GetAttr(char,'maxHealth')
        baseMaxHealth = FFX_TemplateGetAttr(char,'baseMaxHealth')
        if baseMaxHealth == 0: #attribute hasn't been initialized yet
            FFX_TemplateSetAttr(char,'baseMaxHealth', maxHealth) #used by the isClone() function
        elif health != maxHealth:
            Object_SetAttr(char, 'maxHealth', health)
        RegDamage(char, 'OnFFQDeathWish', user = 0, persistent = 1)

def OnFFQDeathWish(event):
    char = event.object
    invPoints = FFX_ObjectGetAttr(char,'invPoints')
    newMaxHealth = Object_GetAttr(char,'health') + invPoints
    Object_SetAttr(char,'maxHealth',newMaxHealth)
    RegTimer('OnFFQDeathWishFeedbackOn', 0.1, 0, char)

#briefly sets max health back to its initial value to give the player some visual feedback
def OnFFQDeathWishFeedbackOn(event):
    char = event.object
    Object_SetAttr(char,'maxHealth', FFX_TemplateGetAttr(char,'baseMaxHealth'))
    RegTimer('OnFFQDeathWishFeedbackOff', 0.1, 0, char)

def OnFFQDeathWishFeedbackOff(event):
    char = event.object
    Object_SetAttr(char,'maxHealth', Object_GetAttr(char,'health'))

    
################ UPGRADABLE / EVOLVING ######################################
# When character has gained enough experience, he is permanently changed to a new form.
# The upgraded form will be available in the next base sequence. Campaign mode only (obviously).
# Upgradable done by request of Mr. Tony Stark. Blueprints stolen by Comrade Sukhov a.k.a. Nuclear Winter
# a.k.a the Glacial Giant for the Evolving attribute.
#
# Notes:
# -Change get triggered when the original character's prestige value is superior to the new form's. Be certain 
#  to calculate correctly the maximum value of the orginal character versus the basic value of the upgraded one;
#  otherwise, the upgraded character might never appear.
#  To give you more margin between the 2 templates values, different grades (prestige costs) of the attribute
#  have been provided.
# -The Upgradable and Evolving attributes are identical; the only difference is the name: one for tech-based heroes,
#  the other for everyone else. Yep, this is a purely cosmetic touch.
# -To allow you to continue to use the non-upgraded form (and because of limits in Campaign_Disallow()), both
#  versions will still be available for squad selection (think Hank Pym). However, DO NOT SELECT BOTH FOR THE SAME
#  MISSION. If you do, the non-upgraded form will be killed.
# -This writes the 'ffqupgradable.txt' in the current mod's root folder (used to display a message ONCE when your
#  character has been upgraded).
#
# Bugs:
# -The upgraded form will appear at mission start for a split second. Sorry.
# -When you receive a message about your character being upgraded, if you restart the mission, the message won't
#  reappear, even through your character is still upgraded.
# -FFvsTTR bug: adding a custom hero, a non-"campaign only" hero, or a character whose class is not GAME_OBJ_HERO
#  crashes the game when trying to access the "train" profile of the characters in the base. Your character will
#  now refuse to upgrade to any of these types.
#
# Added FFX 2.5
#
# Status 1.6

# Changed 1.6:
# - Replaced the MODFOLDER variable by auto-detection using getModFolder()
# - Improved error handling.
# - Prevented erronous upgrade templates from being added to roster.
# - Removed Upgradeable grade 4 and 5 to reduce a bit the crowding in the attributes list.
#   Removed the references to "Evolving" as well. To call it "Evolving", just create a combo attribute.

def initffqupgradable1(char,update=0):
    FFQUpgradable(char,update)

def initffqupgradable2(char,update=0):
    FFQUpgradable(char,update)

def initffqupgradable3(char,update=0):
    FFQUpgradable(char,update)

def FFQUpgradable(char,update):
    if isMP():
        return
    if Mission_GetAttr('ffxSkirmish'):
        print "FFQUpgradable fatal error on '%s':" % FFX_GetTemplate(char)
        print "    Upgradable/Evolving works only within a campaign, not Rumble Room."
        return
    if cshelper.isPlaying():
        RegTimer('OnFFQUpgradable',2, update, char)
        return
    upgChar = getDummyName()
    template = getByTemplate(char,FFQ_UPGRADABLE_CUSTOM,1)
    Object_SpawnAt(template, (0,0,0), upgChar)
    if not Object_Exists(upgChar):
        print "FFQUpgradable fatal error on '%s':" % FFX_GetTemplate(char)
        print "    Cannot find an upgrade template named '%s'" % template
        return
    upgValue = Object_CalcPrestige(upgChar)
    Object_Destroy(upgChar)
    print 'UPGRADABLE/EVOLVING attribute:'
    if Campaign_IsRecruited(template):
        print "    Upgrade template '%s' is already recruited!." % template
        return
    print '    spawning upgrade: %s > %s' % (FFX_GetTemplate(char), template)
    #checking if the character is valid due to FFvsTTR's crashing training screen bug
    if not Template_GetClassString(template) == "GAME_OBJ_HERO":
        print "FFQUpgradable fatal error on '%s':" % FFX_GetTemplate(char)
        print "    Upgrade template '%s' is not an FFEdit built-in of the class 'GAME_OBJ_HERO'." % template
        return
    charDB = datfiles.Campaign_ReadCharacters()[template]
    if not charDB['camp_only']:
        print "FFQUpgradable fatal error on '%s':" % FFX_GetTemplate(char)
        print "    Upgrade template '%s' is not an FFEdit built-in with the 'campaign only' flag." % template
        return
    if Object_IsCustomChar(upgChar):
        print "FFQUpgradable fatal error on '%s':" % FFX_GetTemplate(char)
        print "    Upgrade template '%s' is not an FFEdit built-in hero." % template
        return
    charValue = Object_CalcPrestige(char)
    print '    prestige value comparison:'
    print '        non-upgraded %s: %i'%(char,charValue)
    print '        upgraded %s: %i'%(template,upgValue)
    if charValue >= upgValue:
        #check if upgraded template is already among heroes
        for hero in getAllHeroes():
            if Object_GetTemplate(hero) == template:
                if hero[0:10] != 'mobjdummy_': #if the upgraded template isn't the one we just spawned
                    Mission_StatusText("Upgraded and non-upgraded versions of the same character cannot exist simultaneously:")
                    Mission_StatusText("...removing %s of template %s"%(char,Object_GetTemplate(char)))
                    killLater(char,3)
                    print '    %s and upgraded version (%s) found simultaneously: destroying %s'%(char,hero,char)
                    break
        else:
            print '        ...adding upgraded form to your roster!'
            Campaign_AddHero(template)
            Campaign_Recruit(template)
            ffqUpgradableAddToFile(char, template)
    else:
        print '        ...upgraded form is not ready to be added to your roster.'
        ffqUpgradableRemoveFromFile(char)
    
def OnFFQUpgradable(event):
    char = event.object
    update = event.user
    FFQUpgradable(char, update)

# the character has been found ready for upgrade
# add his entry to the text db so we display the message only once
def ffqUpgradableAddToFile(char, upgradedTemplate):
    template = FFX_GetTemplate(char)
    try:
        fp = open('%s/missions/scripts/ffqupgradable.txt'%sysutils.getModFolder(), 'r')
        fpAllUpgraded = pickle.load(fp)
        fp.close()
        adding = 0
        if fpAllUpgraded.count(template) == 0:
            print "    updating 'ffqupgradable.txt' with newly upgradable character %s"%template
            adding = 1
    except:
        print "    creating 'ffqupgradable.txt' to add newly upgradable character %s"%template
        fpAllUpgraded = []
        adding = 1
    if adding == 1:
        Mission_StatusText(getCharDisplayName(char))
        Mission_StatusText("will be upgraded to")
        Mission_StatusText(string.upper(upgradedTemplate))
        Mission_StatusText("when returning at the base.")
        fpAllUpgraded.append(template)
        ffqUpgradableWriteFile(fpAllUpgraded)

# the character has been found not ready for upgrade
# remove his entry from the text db if it exists, because we're not dealing with the same continuous campaign
def ffqUpgradableRemoveFromFile(char):
    template = FFX_GetTemplate(char)
    try:
        fp = open('%s/missions/scripts/ffqupgradable.txt'%sysutils.getModFolder(), 'r')
        fpAllUpgraded = pickle.load(fp)
        fp.close()
        if fpAllUpgraded.count(template) > 0:
            print "    updating 'ffqupgradable.txt' to remove non-upgradable character %s"%template
            fpAllUpgraded.remove(template)
            ffqUpgradableWriteFile(fpAllUpgraded)
    except:
        #the 'ffqupgradable.txt' file probably doesn't exists, so we don't have to remove anything
        pass
        
def ffqUpgradableWriteFile(fpAllUpgraded):
    try:
        fp = open('%s/missions/scripts/ffqupgradable.txt'%sysutils.getModFolder(), 'w')
        pickle.dump(fpAllUpgraded, fp)
        fp.close()
    except:
        Mission_StatusText("Error! Cannot open 'ffqupgradable.txt'")
        print "Fatal error in 'ffqUpgradableWriteFile()'!:"
        print "    Cannot open 'ffqupgradable.txt' in '%s' folder"%sysutils.getModFolder()


      

################ GLIDER ######################################
# You can only fly for a short while (8 seconds).
# Created from FFX's Fast Flier code.
#
# Added FFX 2.5
#
# Status: 2.2
#
# Changed 2.0 (FFX 3.0):
# -Redone by Dr Mike using buoyancy
# -Updated Object_IsAlive() for FFvsTTR
# Changed 2.1 (FFX 3.03):
# -M25 or Dr Mike (?) added updateFlightState() 
# Changed 2.2 (FFX 3.2.0 alpha)
# -Was broken if using 3.04 with MLOG activated, changed flight detection to be compatible with both modes.
        
def addFlight(char):
    Object_SetSecondaryState(char,SCSTATE_BUOYANT,20000,0)
    Trigger_Move(char,'land')
    RegTimer('removeFX',0.7,1,char)
    FFX_ObjectSetAttr(char,'ffxflier',1)
    RegTimer('updateFlightState',1,0,char)

def updateFlightState(event):
    char=event.object
    if Object_GetSecondaryStates(char)&SCSTATE_BUOYANT==0:
        print 'restoring flight state'
        Object_SetSecondaryState(char,SCSTATE_BUOYANT,20000,0)
        Trigger_Move(char,'land')
        RegTimer('removeFX',0.5,1,char)
    RegTimer('updateFlightState',3,0,char)

def initffqglider(char,update):
    if update==0:
        addFlight(char)
        FFX_ObjectSetAttr(char,'maxFlightTime',8)
        FFX_ObjectSetAttr(char,'flyCheck',0)
        FFX_ObjectSetAttr(char,'airborne_glider',0)
        RegTimer('OnFFQGliderCheck',1,0,char)

def OnFFQGliderCheck(event):
    char = event.object
    if not Object_Exists(char):
        return
    duration = 0
    if not Object_IsAlive(char):
        RegTimer('OnFFQGliderCheck',1,duration,char)
        return
    maxFlightTime = event.user
    maxFlightTime = maxFlightTime + 1
    flying = mlogreader.MLOG_IsFlying(char) #Ep. 2007-02-4: replaced obsolete FFQ_IsFlying()
    wasFlying = FFX_ObjectGetAttr(char,'airborne_glider')
    if flying:
        if wasFlying:
            if maxFlightTime > FFX_ObjectGetAttr(char,'maxFlightTime'):
                Trigger_Move(char,'land')
        else:
            FFX_ObjectSetAttr(char,'airborne_glider',1)
        duration = maxFlightTime
    elif (flying==0) and wasFlying:
        FFX_ObjectSetAttr(char,'airborne_glider',0)
    RegTimer('OnFFQGliderCheck',1,duration,char)


################ ROPE SWINGER ######################################
# You can only fly for a very short while (4 seconds) and cover a very short maximum distance (around 250 units).
# Created from FFX's Fast Flier code.
#
# Added FFX 2.5
#
# Status: 2.1
#
# Changed 2.0 (FFX 3.0):
# -Redone by Dr Mike using buoyancy
# -Updated Object_IsAlive() for FFvsTTR
# Changed 2.1 (FFX 3.2.0 alpha)
# -Was broken if using 3.04 with MLOG activated, changed flight detection to be compatible with both modes.

def initffqropeswinger(char,update=0):
    if update==0:
        addFlight(char)
        FFX_ObjectSetAttr(char,'maxFlightTime',4)
        FFX_ObjectSetAttr(char,'flyCheck',0)
        FFX_ObjectSetAttr(char,'airborn_ropeSwinger',0)
        FFX_ObjectSetAttr(char,'FFQ_ropeswinger_previousPos_x',0)
        FFX_ObjectSetAttr(char,'FFQ_ropeswinger_previousPos_y',0)
        RegTimer('OnFFQRopeSwingerCheck',1,0,char)

def OnFFQRopeSwingerCheck(event):
    char = event.object
    if not Object_Exists(char):
        return
    duration = 0
    if not Object_IsAlive(char):
        RegTimer('OnFFQRopeSwingerCheck',1,duration,char)
        return
    if Object_IsAlive(char):
        maxFlightTime = event.user
        maxFlightTime = maxFlightTime + 1
        oldPos = (FFX_ObjectGetAttr(char,'FFQ_ropeswinger_previousPos_x'),FFX_ObjectGetAttr(char,'FFQ_ropeswinger_previousPos_y'),0)
        newPos = Get_ObjectPos(char)
        flying = mlogreader.MLOG_IsFlying(char) #Ep. 2007-02-4: replaced obsolete FFQ_IsFlying()
        wasFlying = FFX_ObjectGetAttr(char,'airborn_ropeSwinger')
        if flying:
            if wasFlying:
                if (maxFlightTime > FFX_ObjectGetAttr(char,'maxFlightTime')) or (cshelper.distance2D(oldPos,newPos) > 200):
                    Trigger_Move(char,'land')
            else:
                FFX_ObjectSetAttr(char,'airborn_ropeSwinger',1)
                FFX_ObjectSetAttr(char,'FFQ_ropeswinger_previousPos_x',Get_ObjectPos(char)[0])
                FFX_ObjectSetAttr(char,'FFQ_ropeswinger_previousPos_y',Get_ObjectPos(char)[1])
            duration = maxFlightTime
        elif (flying==0) and wasFlying:
            FFX_ObjectSetAttr(char,'airborn_ropeSwinger',0)
        RegTimer('OnFFQRopeSwingerCheck',1,duration,char)

################ LIMITED FLIGHT ######################################
# Flying uses up energy. When you have no energy left, you're forced to land.
# Created from FFX's Fast Flier code.
#
# Added FFX 2.5
#
# Status: 2.1
#
# Changed 2.0 (FFX 3.0):
# -Redone by Dr Mike using buoyancy
# -Updated Object_IsAlive() for FFvsTTR
# Changed 2.1 (FFX 3.2.0 alpha)
# -Was broken if using 3.04 with MLOG activated, changed flight detection to be compatible with both modes.

def initffqlimitedflight(char,update=0):
    if update == 0:
        addFlight(char)
        RegTimer('OnFFQLimitedFlightCheck',1,0,char)
        FFX_ObjectSetAttr(char,'airborne_limitedFlight',0)
        FFX_ObjectSetAttr(char,'flyCheck',0)

def OnFFQLimitedFlightCheck(event):
    char = event.object
    if not Object_Exists(char):
        return
    RegTimer('OnFFQLimitedFlightCheck',1,0,char)
    if not Object_IsAlive(char):
        return
    flying = mlogreader.MLOG_IsFlying(char) #Ep. 2007-02-4: replaced obsolete FFQ_IsFlying()
    wasFlying = FFX_ObjectGetAttr(char,'airborne_limitedFlight')
    if flying:
        if wasFlying:
           print 'checking vs 1'
           if FFQ_reduceEP(char,1,33):
               print 'landing'
               Trigger_Move(char,'land')
        else:
            print 'checking vs 5'
            if FFQ_reduceEP(char,5,33):
                print 'landing'
                Trigger_Move(char,'land')
            FFX_ObjectSetAttr(char,'airborne_limitedFlight',1)
    if (flying == 0) and wasFlying:
        FFX_ObjectSetAttr(char,'airborne_limitedFlight',0)


################ BASIC LEVITATION ######################################
# Flying or levitating allows you to float in the air, but moving while in the air will force you to land.
# A slight modification of FFX's Fast Flier code.
#
# Added FFX 2.5
#
# Status: 2.3

# Changed 2.0 (FFX 3.0):
# -Redone by Dr Mike using buoyancy
# -Updated Object_IsAlive() for FFvsTTR
# Changed 2.2 (FFX 3.05 alpha):
# -Was broken, restored newPos to string format in RegTimer()
# -Includes M25 flying detection code change
# Changed 2.3 (FFX 3.2.0 alpha)
# -Was broken if using 3.04 with MLOG activated, changed flight detection to be compatible with both modes.

def initffqbasiclevitation(char,update=0):
    if update == 0:
        addFlight(char)
        newPos = FFQ_tupleToString(Get_ObjectPos(char))
        RegTimer('OnFFQBasicLevitationCheck',1,0,char,newPos)
        FFX_ObjectSetAttr(char,'airborne_basicLevitation',0)
        FFX_ObjectSetAttr(char,'flyCheck',0)

def OnFFQBasicLevitationCheck(event):
    char = event.object
    if not Object_Exists(char):
        return
    newPos = Get_ObjectPos(char)
    RegTimer('OnFFQBasicLevitationCheck', 1, 0, char, FFQ_tupleToString(newPos))
    if not Object_IsAlive(char):
        return
    oldPos = event.string
    oldPos = FFQ_stringToTuple(oldPos)
    flying = mlogreader.MLOG_IsFlying(char) #Ep. 2007-02-4: replaced obsolete FFQ_IsFlying()
    wasFlying = FFX_ObjectGetAttr(char,'airborne_basicLevitation')
    if flying and wasFlying:
        if cshelper.distance2D(oldPos,newPos) > 10:
            Trigger_Move(char,'land')
    if flying and (wasFlying == 0):
        Object_SetAttr(char,'speed',0)
        Object_SetAttr(char,'baseSpeed',0)
        FFX_ObjectSetAttr(char,'airborne_basicLevitation',1)
    if (flying == 0) and wasFlying:
        speed = Object_GetAttr(char,'templateSpeed')
        Object_SetAttr(char,'speed',speed)
        Object_SetAttr(char,'baseSpeed',speed)
        FFX_ObjectSetAttr(char,'airborne_basicLevitation',0)
    newPos = FFQ_tupleToString(newPos)


################ LOW-GRAV FLIER ######################################
# Your means of flying or levitating rely on reducing your mass to almost nothing, making you more vulnerable
# to knockback while in the air.
# A slight modification of FFX's Fast Flier code.
#
# Added FFX 2.5
#
# Status: 2.1
#
# Changed 2.0 (FFX 3.0):
# -Redone by Dr Mike using buoyancy
# -Updated Object_IsAlive() for FFvsTTR
# Changed 2.1 (FFX 3.2.0 alpha)
# -Was broken if using 3.04 with MLOG activated, changed flight detection to be compatible with both modes.
# -Nerfed the mass and minForce values, as requested by Urthman, so KB shouldn't be so extreme.

# Notes:
# -Mass couldn't be reduced to zero, since any knockback automatically sent the character outside the map, killing him!
# -Should be compatible with Mass Control and Gravity Increase.

def initffqlowgravflier(char,update=0):
    if update==0:
        addFlight(char)
        RegTimer('lowgravFlierCheck',1,0,char)
        FFX_ObjectSetAttr(char,'airborne_lowGravFlier',0)
        FFX_ObjectSetAttr(char,'flyCheck',0)
        Object_SetAttr(char,'previousMass',Object_GetAttr(char,'mass'))
        Object_SetAttr(char,'previousMinForce',Object_GetAttr(char,'minForce'))

def lowgravFlierCheck(event):
    char=event.object
    if not Object_Exists(char):
        return
    RegTimer('lowgravFlierCheck',1,0,char)
    if not Object_IsAlive(char):
        return
    flying = mlogreader.MLOG_IsFlying(char) #Ep. 2007-02-4: replaced obsolete FFQ_IsFlying()
    wasFlying=FFX_ObjectGetAttr(char,'airborne_lowGravFlier')
    if flying and (wasFlying==0):
        Object_SetAttr(char,'previousMass',Object_GetAttr(char,'mass'))
        Object_SetAttr(char,'previousMinForce',Object_GetAttr(char,'minForce'))
        Object_SetAttr(char,'mass',10)
        Object_SetAttr(char,'minForce',0.3)
        FFX_ObjectSetAttr(char,'airborne_lowGravFlier',1)
    if (flying==0) and wasFlying:
        Object_SetAttr(char,'mass',Object_GetAttr(char,'previousMass'))
        Object_SetAttr(char,'minForce',Object_GetAttr(char,'previousMinForce'))
        FFX_ObjectSetAttr(char,'airborne_lowGravFlier',0)

################ NIMBLE FLIER ######################################
# Character has increased (+3) agility while flying.
# A very minor modification of Fast Flier. Done in answer to a post by IPS.
#
# Added FFX 2.5
#
# Status: 1.4

# Changed 1.1 (FFX 3.0):
# -Updated Object_IsAlive() for FFvsTTR
# Changed 1.2 (FFX 3.0):
# -Speed limit of 9 (default max) removed, as the built-in Nimble doesn't have that limitation.
# -Includes M25 flying detection code change
# Changed 1.3 (FFX 3.2 alpha):
# -Was broken if using 3.04 with MLOG activated, changed flight detection to be compatible with both modes.
# -Flying now included in attribute
# Changed 1.4 (FFX 3.2 alpha):
# -Flying not included anymore for backward compatibility and Campaign mode.
# stumpy 2007-01-02: changes to use regFlightStart() instead of repeated timer checks

def initffqnimbleflier(char,update=0,remove=0):
    if update==0:
        if remove == 0:
            mlogreader.regFlightStart(char,'ffx.onNimbleFlightStart',persistent=1)
            FFX_ObjectSetAttr(char,'ffqnimbleflier',1)
        else:
            mlogreader.cancelAnimationCallbackSink(char,'ffx.onNimbleFlightStart')
            FFX_ObjectSetAttr(char,'ffqnimbleflier',0)

# Note that we could keep track of whether the character was flying
# the last time these callbacks were checked, but the code in
# mlogreader already does that, do we will try without.
def onNimbleFlightStart(event):
    char=event.object
    if not ( Object_IsAlive(char) and FFX_ObjectGetAttr(char,'ffqnimbleflier',0) ):
        return
    agility=Object_GetAttr(char,'templateAgility')+3
    if agility>13:
        agility=13
    Object_SetAttr(char,'agility',agility)
    FFX_ObjectSetAttr(char,'baseAgility',agility)
    mlogreader.regFlightStop(char,'ffx.onNimbleFlightStop')

def onNimbleFlightStop(event):
    char=event.object
    if not ( Object_IsAlive(char) and FFX_ObjectGetAttr(char,'ffqnimbleflier',0) ):
        return
    agility=Object_GetAttr(char,'templateAgility')
    Object_SetAttr(char,'agility',agility)
    FFX_ObjectSetAttr(char,'baseAgility',agility)

# previous version with recurring timer check
def nimbleFlierCheck(event):
    char=event.object
    if not Object_Exists(char):
        return
    RegTimer('nimbleFlierCheck',1,0,char)
    if not Object_IsAlive(char):
        return
    flying = mlogreader.MLOG_IsFlying(char)
    wasFlying=FFX_ObjectGetAttr(char,'airborne_nimbleFlier')
    if flying and (wasFlying==0):
        agility=Object_GetAttr(char,'templateAgility')+3
        if agility>13:
            agility=13
        Object_SetAttr(char,'agility',agility)
        FFX_ObjectSetAttr(char,'baseAgility',agility)
        FFX_ObjectSetAttr(char,'airborne_nimbleFlier',1)
    if (flying==0) and wasFlying:
        agility=Object_GetAttr(char,'templateAgility')
        Object_SetAttr(char,'agility',agility)
        FFX_ObjectSetAttr(char,'baseAgility',agility)
        FFX_ObjectSetAttr(char,'airborne_nimbleFlier',0)



################ EXTRADIMENSIONAL ######################################
# You come from another dimension. This makes you quite vulnerable to EXILE attacks, which banish you for good!
# (i.e., after 5 seconds of EXILE character state, you're k.O'ed.)
#
# Status: 1.3

# Added 1.2:
# -Made removable.
# Added 1.3:
# -Removed invisibility on death, as it doesn't work always now and because of UI changes in FFvsTTR.
# -Changed the method of dealing with immortal characters, which was broken. Immortal attribute is now removed temporarily
#  when character is KO'ed.

# Notes/bugs:
# -Probably conflicts with lots of scripts, either in FFX or in mods... (haven't heard anothing so far,though).
# -Characters with both IMMORTAL and EXTRADIMENSIONAL attributes (or PAGAN GOD combo) will be k.o'ed by an exile attack
# -Even if the character is exiled in another dimension, he now leaves a body. Go figure. No simple workaround for that in FFvsTTR.

def initffqextradimensional(char, update=0, remove=0):
    #attribute already set?
    if remove:
        if FFX_ObjectGetAttr(char,'ffqextradimensional'):
            FFX_ObjectSetAttr(char, 'ffqextradimensional', 0)
            FFX_ObjectSetAttr(char, 'ffqextradimensional_active', 0)
        return
    if FFX_ObjectGetAttr(char, 'ffqextradimensional'):
        return
    FFX_ObjectSetAttr(char, 'ffqextradimensional', 1)
    FFX_ObjectSetAttr(char, 'ffqextradimensional_active', 1)
    RegCharState(char,PCSTATE_EXILE,'OnFFQExtraDimensionalCheck',1)

def OnFFQExtraDimensionalCheck(event):
    char = event.object
    RegTimer('OnFFQExtraDimensionalBanish',5,0,char)

def OnFFQExtraDimensionalBanish(event):
    char = event.object
    if not Object_IsAlive(char):
        return
    if not FFX_ObjectGetAttr(char,'ffqextradimensional'):
        return
    if Object_GetPrimaryState(char) == PCSTATE_EXILE:
        if Object_GetAttr(char,'ffxState') != 100: #if this is truly exile and not a swap state
            if not isInvisible(char): #if character is already both invisible and exiled, we're probably dealing with something scripted
                if FFX_ObjectGetAttr(char, 'ffqimmortal'): #deals with immortals, without removing minHealth for other characters
                    initffqimmortal(char, update=0, remove=1)
                    RegTimer('OnFFQExtraDimensionalImmortal',1,0,char) #add back the immortality in case character gets better
                Object_PlayEffect(char,'effect_ffx_miniportal')
                Object_SetPrimaryState(char,PCSTATE_EXILE,0,REMOVE_STATE) #exiled characters can't be damaged
                Trigger_Damage(char,Object_GetAttr(char,'health'))

def OnFFQExtraDimensionalImmortal(event):
    char = event.object
    if Object_Exists(char):
        initffqimmortal(char, update=0) #make immortal again



################# REALITY MANIPULATION ##################################
# You can change the laws of physic for a few seconds for defensive and offensive purposes.
# The character gains 2 custom commands:
# -REALITY: ORDER turns the world red, makes everyone and everything completely invulnerable
# -REALITY: CHAOS turns the world blue, reduces dodge or resist effects chances and increases area of effect,
#  beam accuracy, knockback and damage
# Effects last 10 secs.
# status: 2.3
#
# Added FFX 2.5

# Changed 1.3 (FFX 3.0):
# -updated EP cost to new system
# -added camera distortion effect (commented out: needs fading in/out and other adjustments)
# Changed 2.0 (FFX 3.05 alpha):
# -Split into 2 separate attributes
# -Made the visual FXes customisable (see "visual effects" under the "customisation parameters functions" section)
# -Added increased stun on Chaos overpowering and reduced overpowering effects
# Changed 2.2 (FFX 3.2.0 alpha):
# -Added DEBUG_ALLPOWERS to Chaos effect; note that this will work only on characters spawned after startup.
# Changed 2.3 (FFX 3.2.0 alpha 1 Ep 3):
# -Replaced Flight detection method.

# Notes/Bugs:
# -Objects created during the Chaos are not affected by the damage increase (there was already enough processing
#  going on!)
# -M25 AI enabled: depending on the difficulty setting, etc., AI characters will try to use Order and Chaos moderately
#  if they have nothing better to do.

# TO DO:
# -check AI
# -custom command while flying: didn't succeed in using Dr Mike's Trigger_Power() method, using a crude workaround. Needs investigating.

FFQ_EP_REALITY = 66
  
def initffqrealitymanipchaos(char,update=0):
    #store the defaults values of modifiable environmental variables for Chaos
    try:
        Mission_GetAttr('ff_RPG_DODGE_BASE_CHANCE')
    except:
        Mission_SetAttr('ff_RPG_DODGE_BASE_CHANCE', ff.RPG_DODGE_BASE_CHANCE)
        Mission_SetAttr('ff_RPG_RESIST_DMG_EXP', ff.RPG_RESIST_DMG_EXP)
        Mission_SetAttr('ff_RPG_KB_RANGE_SCALE', ff.RPG_KB_RANGE_SCALE)
        Mission_SetAttr('ff_RPG_KB_MAX', ff.RPG_KB_MAX)
        Mission_SetAttr('ff_RPG_BEAM_ACCURACY', ff.RPG_BEAM_ACCURACY)
        Mission_SetAttr('ff_RPG_INTENS_DAMAGE', ff.RPG_INTENS_DAMAGE)
        Mission_SetAttr('ff_RPG_INTENS_AREARADIUS', ff.RPG_INTENS_AREARADIUS)
        Mission_SetAttr('ff_RPG_INTENS_STUN', ff.RPG_INTENS_STUN)
        Mission_SetAttr('ff_DEBUG_ALLPOWERS', ff.DEBUG_ALLPOWERS)
    cmdChaos = getByTemplate(char, FFQ_REALITYMANIPCHAOS_CUSTOM, 1)
    Mission_CustomAction(cmdChaos, char, char, 'OnFFQRealityChaos', 5, 0)
    try:
        Mission_GetAttr('realityManipulation')
    except:
        Mission_SetAttr('realityManipulation', 0)

def initffqrealitymaniporder(char,update=0):
    cmdOrder = getByTemplate(char, FFQ_REALITYMANIPORDER_CUSTOM, 1)
    Mission_CustomAction(cmdOrder, char, char, 'OnFFQRealityOrder', 5, 0)
    try:
        Mission_GetAttr('realityManipulation')
    except:
        Mission_SetAttr('realityManipulation', 0)

def OnFFQRealityChaos(char, dummy):
    if Mission_GetAttr('realityManipulation') != 0:
        Mission_StatusText('The laws of physic cannot take any further tampering for the moment!')
        return
    if chargeEP(char, FFQ_EP_REALITY) == 0:
        return
    Mission_SetAttr('realityManipulation', 1)
    if mlogreader.MLOG_IsFlying(char):
        Trigger_Move(char, 'fly', Get_ObjectPos(char))
    ff.RPG_DODGE_BASE_CHANCE = 10 #base: 50
    ff.RPG_RESIST_DMG_EXP = 0.75 #base: 0.5
    ff.RPG_KB_RANGE_SCALE = 2500 #base: 750
    ff.RPG_KB_MAX = 40000 #base: 25000
    ff.RPG_BEAM_ACCURACY = 0.9 #base: 0.75
    ff.RPG_INTENS_DAMAGE = 0.33 #base: 0.25
    ff.RPG_INTENS_AREARADIUS = 0.2 #base: 0.1
    ff.RPG_INTENS_STUN =  ff.RPG_INTENS_STUN * 1.2 #default set in the CC
    ff.DEBUG_ALLPOWERS = 1
    global objectsHealth
    objectsHealth = []
    dynamicObjects = Mission_GetDynamicObjects()
    for obj in dynamicObjects:
        hp = Object_GetAttr(obj, 'health')
        objectsHealth.append([obj, Object_GetAttr(obj, 'health')])
    #Prevent the map itself (whose template is '') from appearing in that list
    staticObjects = list( Mission_GetObjects() )
    staticObjects.remove( Object_GetTerrain() )
    for obj in staticObjects:
        if Object_Exists(obj):
            hp = Object_GetAttr(obj, 'health')
            objectsHealth.append([obj, Object_GetAttr(obj, 'health')])
    RegTimer('OnFFQRealityChaosDamageCheck', 0.5, 19)
    RegTimer('OnFFQRealityChaosOff', 10, 0)
    effectChaos = getByTemplate(char, FFQ_REALITYMANIPCHAOS_CUSTOM, 3)
    if effectChaos != '':
        visualEffect = "%s('%s', %d, '%s', %d)"%(effectChaos, char, 10, '', 0)
        exec visualEffect
    cmdChaos = getByTemplate(char, FFQ_REALITYMANIPCHAOS_CUSTOM, 2)
    AI_Animate(char, cmdChaos, 'OnFFQRealityChaos2')
    RegTimer('OnFFQRealityChaosCB', 0.1, 0, char)

def OnFFQRealityChaosDamageCheck(event):
    char = event.object
    duration = event.user
    global objectsHealth
    tmpObjectsHealth = []
    for objPair in objectsHealth:
        obj = objPair[0]
        previousHealth = objPair[1]
        damage = 0
        if Object_Exists(obj):
            currentHealth = Object_GetAttr(obj, 'health')
            if currentHealth < previousHealth:
                damage = previousHealth - currentHealth #doubles the damage actually received
                if isCharacter(obj):
                    FFX_ApplyDamage(obj, damage, mental = 1)
                else:
                    Trigger_Damage(obj, damage)
            #cannot use Object_GetAttr(obj, 'health') since damage is not applied quickly enough
            tmpObjectsHealth.append([obj, max(0, currentHealth - damage)])
    objectsHealth = tmpObjectsHealth
    if duration > 0:
        RegTimer('OnFFQRealityChaosDamageCheck', 0.5, duration - 1)
        
def OnFFQRealityChaosOff(event):
    char = event.object
    Mission_SetAttr('realityManipulation', 0)
    ff.RPG_DODGE_BASE_CHANCE = Mission_GetAttr('ff_RPG_DODGE_BASE_CHANCE')
    ff.RPG_RESIST_DMG_EXP = Mission_GetAttr('ff_RPG_RESIST_DMG_EXP')
    ff.RPG_KB_RANGE_SCALE = Mission_GetAttr('ff_RPG_KB_RANGE_SCALE')
    ff.RPG_KB_MAX = Mission_GetAttr('ff_RPG_KB_MAX')
    ff.RPG_BEAM_ACCURACY = Mission_GetAttr('ff_RPG_BEAM_ACCURACY')
    ff.RPG_INTENS_DAMAGE = Mission_GetAttr('ff_RPG_INTENS_DAMAGE')
    ff.RPG_INTENS_AREARADIUS = Mission_GetAttr('ff_RPG_INTENS_AREARADIUS')
    ff.RPG_INTENS_STUN = Mission_GetAttr('ff_RPG_INTENS_STUN')
    ff.DEBUG_ALLPOWERS = Mission_GetAttr('ff_DEBUG_ALLPOWERS')
    
def OnFFQRealityOrder(char, dummy):
    if Mission_GetAttr('realityManipulation') != 0:
        Mission_StatusText('The laws of physic cannot take any further tampering for the moment!')
        return
    if chargeEP(char, FFQ_EP_REALITY) == 0:
        return
    Mission_SetAttr('realityManipulation', 1)
    if mlogreader.MLOG_IsFlying(char):
        Trigger_Move(char, 'fly', Get_ObjectPos(char))
    RPG_SetActive(0)
    #Used for characters suffering from persistent damage states such as Irradiated, Acid burnt or FFX Frozen
    #which aren't stopped by either RPG_SetActive(0) or by the likes of RPG_ACID_DAMAGE_PERIOD:
    for obj in getAllCharacters():
        FFX_ObjectSetAttr(obj, 'baseMinhealth', Object_GetAttr(obj, 'minHealth'))
        Object_SetAttr(obj,'minHealth', Object_GetAttr(obj,'health'))
    ff.RPG_INTENS_DAMAGE = 0.0 #base: 0.25
    RegTimer('OnFFQRealityOrderOff', 10, 0)
    effectOrder = getByTemplate(char, FFQ_REALITYMANIPORDER_CUSTOM, 3)
    if effectOrder != '':
        visualEffect ="%s('%s', %d, '%s', %d)"%(effectOrder, char, 10, '', 0)
        exec visualEffect
    cmdOrder = getByTemplate(char, FFQ_REALITYMANIPORDER_CUSTOM, 2)
##    AI_Animate(char, cmdOrder, 'OnFFQRealityOrder2')
    RegTimer('OnFFQRealityOrderCB', 0.1, 0, char)

def OnFFQRealityOrderOff(event):
    char = event.object
    Mission_SetAttr('realityManipulation', 0)
    RPG_SetActive(1)
    ff.RPG_INTENS_DAMAGE = Mission_GetAttr('ff_RPG_INTENS_DAMAGE')
    for obj in getAllCharacters():
        Object_SetAttr(obj,'minHealth', FFX_ObjectGetAttr(obj, 'baseMinhealth'))



################ EXTRA CARRIER ######################################
# Your carrier powers have additional effects.
# Status: Abandoned




################ STEALTHY ######################################
# Enemies won't notice you from a distance, especially in darkness or if standing still.
# Energy-consuming activities, such as attacks, will decrease the distance above which
# you're invisible.
# If in a dark level, stay away from functioning (15 hp or more) streetlights, spotlights, lamps,
# torch poles and from any bonfire!
#
# Blatantly ripped from FFX Chameleon, with some code borrowed from Nocturnal for good measure.
# Added FFX 2.5
#
# Status: 2.10

#TO DO:
# -Not available for now, needs update (facing, object list and MAYBE replacing the invisibility with something else. :/

# Changed 2.10 (FFX 3.0):
# -Updated Object_IsAlive() for FFvsTTR

# Notes:
# -for performance reasons, light sources include only static objects placed at startup whose name
#  follow the '_impobj_xxx' convention. To include other objects, you need to add them manually with
#  FFQ_LIGHTSOURCES.append('name of the object')
# -Scratched the Enemy orientation code and the related functions, since further testing revealed
#  the problem I had overlooked: Object_GetOrientation() returned value is based on 180 degree, not 360,
#  making it useless. Sigh... stupid bug. A few days lost.
#  EDIT: added something to somewhat replicate this: if the nearest enemy gets nearer while you're visible,
#  you're going to be penalized; if he's getting farther while you're invisible, you get a bonus.
#
# Bugs:
# -Characters picking objects while invisible stay invisible, which shouldn't look too inconspicious!
#  However, using RegPickup() to remedy this would have been a bit processor intensive and wouldn't
#  have helped much, since we can't really detect when the character drops or throw the object or 
#  if it's destroyed. (OK, I can think of a way, but it's more CPU time again.)
# -Light source objects are not necessarily in-game sources, so you won't alway get a visual cue of whether
#  they're working or not.

# To do:
# -light level detection should now use getLightLevel()
# -On hiatus until I do a successful update for it... :(

def initffqstealthy(char,update=0):
    pass #TEMP!!! quick fix because I forgot to disable Prowler attribute in FFX 3.0... :/

        

################ ROOTED ######################################
# Staying on the same spot makes you immune to knockback! Note that characters can't be rooted while flying.
# Blatantly ripped from FFX Chameleon.
# Added FFX 2.5
#
# Status: 1.2
#
# Bugs/Notes:
# -Should have been more costly, but Density Control gives constant immunity AND jumper for 500 XP!
# -Character's mass is now set to a high value to prevent frozen/staticked bug
#  (RegCharState() couldn't be used, since state swaps would still apply first).
#  Contrarily to the built-in Density  Control, this version's efficiency is modified by Hollow Bones,
#  Mass Control, etc. The higher mass also influences Clumsy Jumper, Jump Travel and FastBall.

# Changed 1.2 (post FFX 2.6):
# -Corrected a bug where a frozen or staticked character returning to normal would be knocked into
#  the air and suffer 150+ damage! Thanks to Wonderraver for finding that.
#  The safe mass/minForce ratio seems to be 0.008 and above.
# -Updated Object_IsAlive() for FFvsTTR

def initffqrooted(char, update = 0):
    if update == 0:
        pos=Get_ObjectPos(char)
        FFX_ObjectSetAttr(char, 'FFQRootedLastY', pos[1])
        FFX_ObjectSetAttr(char, 'FFQRootedLastX', pos[0])
        FFX_ObjectSetAttr(char, 'FFQRootedStill', 3)
        FFX_ObjectSetAttr(char, 'baseMinForce', Object_GetAttr(char, 'minForce'))
        RegTimer('OnFFQRootedCheck', 1, 0, char)

def OnFFQRootedCheck(event):
    char = event.object
    if not Object_Exists(char):
        return
    RegTimer('OnFFQRootedCheck', 0.7, 0, char)
    if not Object_IsAlive(char):
        return
    if cshelper.isPlaying():
        return
    pos=Get_ObjectPos(char)
    #if they've moved, then get out of here
    #note that fliers never stay on the same EXACT spot, thus preventing them from being rooted
    if (pos[0]!=FFX_ObjectGetAttr(char,'FFQRootedLastX')) or (pos[1]!=FFX_ObjectGetAttr(char,'FFQRootedLastY')):
        FFX_ObjectSetAttr(char,'FFQRootedLastY',pos[1])
        FFX_ObjectSetAttr(char,'FFQRootedLastX',pos[0])
        FFX_ObjectSetAttr(char,'FFQRootedStill',0)
        Object_SetAttr(char,'minForce',FFX_ObjectGetAttr(char,'baseMinForce'))
        Object_SetAttr(char,'mass',FFX_ObjectGetAttr(char,'baseMass'))
        return
    still=FFX_ObjectGetAttr(char,'FFQRootedStill')
    if still<3:
        FFX_ObjectSetAttr(char,'FFQRootedStill',still+1)
        return
    #if everything else is false, root the character and prevent frozen/staticked bug
    originalMinForce = Object_GetAttr(char, 'minForce')
    if originalMinForce < 55000: #55000 seemed to be enough to stop 4X overpowered extreme KB
        FFX_ObjectSetAttr(char, 'baseMinForce', originalMinForce)
        Object_SetAttr(char, 'minForce', 55000)
    originalMass = Object_GetAttr(char, 'mass')
    if originalMass < 440:
        Object_SetAttr(char, 'mass', 440)
        
        
################ EMPATHIC FRIENDSHIP ######################################
# A slight modification to the FFX Empath attribute, to make it work on different distances, but only on allies taking damage
# Created for the Ghostly pseudo-combo attribute below.
# Contrarily to straight Empath, to reduce processing, Empathic Friendship's mental transfer won't get
# triggered by a character under a mental state coming into range; triggering requires the mental state
# to start within range. To compensate somewhat the fact that staying within range won't increase transfer
# risk with every passing second, the initial chance of transfer has been upped.
#
# Status: 2.1

# Changed:
# 2.0 (FFX 3.0):
# -Solved a null error caused when character didn't exist anymore due to shapeshifting, etc.
# -Prevented lures from triggering the empathic effects
# -Improved performance
# -Solved Astral form issue
# -Changed mental effect transfer mechanism
# 2.1:
# -Replaced FFQ_forceteam(), which had been removed because incompatible with M25's new AI system with something hopefully more kasher

# to do:
# -morphing shouldn't trigger!

# same range as original
def initffqempathnormalrange(char,update=0):
    FFX_ObjectSetAttr(char,'empathCustomDistance',8000)
    empathCustomRange(char,update)

# longer range
def initffqempathlongrange(char,update=0):
    FFX_ObjectSetAttr(char,'empathCustomDistance',75000)
    empathCustomRange(char,update)

# practically infinite range
def initffqempathinfiniterange(char,update=0):
    FFX_ObjectSetAttr(char,'empathCustomDistance',-1)
    empathCustomRange(char,update)

def empathCustomRange(char,update):
    RegTimer('empathCustomCheck',1,0,char)
    try:
       if Mission_GetAttr('empathCustom')!=0:
           return
    except:
        RegTimer('globalEmpathCustomInit',1,0,char)
        Mission_SetAttr('empathCustom',1)

# delay necessary, as attributes are initialised before M25 teams
# note that this assumes that a character never changes teams
def globalEmpathCustomInit(event):
    char = event.object
    charTeam = FFQ_forceTeam(char)
    RegTimer('globalEmpathCustom', 0.1, charTeam)

def globalEmpathCustom(event):
    print 'global empath custom'
    char = event.object
    charTeam = event.user
    for obj in getAllCharacters(checkLiving = 1, lures = 0):
        objTeam = FFQ_forceTeam(obj)
        if charTeam == objTeam:
            if FFX_ObjectGetAttr(obj,'healthEMP',-1)==-1:
                FFX_ObjectSetAttr(obj,'healthEMP',Object_GetAttr(obj,'health'))
                RegDamage(obj,'empathCustomDamage', persistent=1)
                RegCharState(obj, PCSTATE_BLANK, 'empathCustomMental', persistent=1)
                RegCharState(obj, PCSTATE_ENRAGED, 'empathCustomMental', persistent=1)
                RegCharState(obj, PCSTATE_PANICKED, 'empathCustomMental', persistent=1)
                RegCharState(obj, PCSTATE_HYPNOTISED, 'empathCustomMental', persistent=1)
                RegCharState(obj, PCSTATE_STUNNED, 'empathCustomMental', persistent=1)
                print 'reg-ing %s'%(obj)
    RegTimer('globalEmpathCustom', 5, charTeam)

def empathCustomDamage(event):
    char=event.object
    hp=Object_GetAttr(char,'health')
    damage=FFX_ObjectGetAttr(char,'healthEMP')-hp
    print 'empathCustomDamage:char=%s damage=%d'%(char,damage)
    if damage>0:
        damage=int(damage*0.33)
        for obj in Mission_GetDynamicObjects():
            if Object_GetClass(obj) & (OC_CHARACTER|4):
                if obj != char:
                    if FFX_ObjectGetAttr(obj,'empathCustomDistance') != 0:
                        distance = FFX_ObjectGetAttr(obj,'empathCustomDistance')
                        print 'checking vs %s'%(obj)
                        if (distance == -1) or (distanceSq(obj,char) < distance):
                            print 'ow! damage=%d'%(damage)
                            Object_PlayEffect(char,'effect_ffx_telepathy')
                            FFX_ApplyDamage(obj,damage,1)
    FFX_ObjectSetAttr(char,'healthEMP',hp)

def empathCustomMental(event):
    char = event.object
    if FFX_ObjectGetAttr(char, 'permaStun'): #active astral projectors, etc.
        return
    state = Object_GetPrimaryState(char)
    print 'empathCustomMental:char=%s state=%d'%(char, state)
    for obj in Mission_GetDynamicObjects():
        if Object_GetClass(obj) & (OC_CHARACTER|4):
            if obj != char:
                if FFX_ObjectGetAttr(obj, 'empathCustomDistance') != 0:
                    distance = FFX_ObjectGetAttr(obj, 'empathCustomDistance')
                    print 'checking vs %s'%(obj)
                    if (distance == -1) or (distanceSq(obj,char) < distance):
                        if FFX_Rand(1,3)<3:
                            print 'tranferring state'
                            Object_SetPrimaryState(obj, state, 5, 0)
                            Object_PlayEffect(char, 'effect_ffx_telepathy')


########################### GHOSTLY ######################################################
# Pseudo-combo; combines original code with Ephemeral and Degenerative to make it a bit less uber.
# Originally based on Dr. Mike's hidden FFX Wraith.
# status: 3.3

#TO DO:
# -repair, broken again; on hiatus until FFX 3.2 is released as my current build of FFX is too buggy. Check m25 files for possible solution

# Changed 2.3 (FFX 3.0):
# -Updated Object_IsAlive() for FFvsTTR
# Changed 3.0 (FFX 3.2.0 alpha 1):
# -Changed the method used from Displace Image to Passthrough Active defence, as this allows mental and mystical attacks against
#  the character.
# -Reduced cost.
# -Broken: adding a defense in FFEdit breaks m25ai.AIDoPower() (?) and not just here (astral form, illusion)
# Changed 3.1 (FFX 3.2.0 alpha 1):
# -Added vulnerability to Energy X.
# -Reduced cost.
# -Broken: adding a defense in FFEdit breaks m25ai.AIDoPower()
# Changed 3.2/3.3 (FFX 3.2):
# -Added vulnerability to Radiation, Electricity and Water. Removed direct damage block. 
# -Removed ffqempathinifiniterange and no solitary ghost nerfs.
# -Use addFFXAttr() method.
# -Made removable.
# -Made customizable.

# Notes/Bugs:
# - Strength has been set to zero because it makes sense and because throwing objects while immaterial was an easy exploit.
#   This means giving strength points to a Ghostly character is a waste.
# - Character always displays the active defence values in his status bar instead of his build-in ones.
# - Any use of active defences on a ghostly character removes the ghostly defence.

def initffqghostly(char, update=0, remove=0):
    if remove:
        pos = Get_ObjectPos(char)
        tiggot = spawnTiggot(char, pos)
        if Object_IsAlive(char):
            Trigger_Power(tiggot, char, 'ffq_remove_defence', '') # function call on completion doesn't seem to work for remove defence power ?
            RegTimer('destroyTemp', 1, 0, tiggot)
            str = FFX_ObjectGetAttr(char, 'ghostly_strength')
            Object_SetAttr(char, 'strength', str)
            Object_SetAttr(char, 'baseStrength', str)
            FFX_ObjectSetAttr( char, 'permanent_shield', max(0, FFX_ObjectGetAttr(char, 'permanent_shield') - 1) )
            removeFFXAttrib(char, 'ephemeral')
            removeFFXAttrib(char, 'degenerative')
            return
    if not FFX_ObjectGetAttr(char, 'ghostly_strength'):
        FFX_ObjectSetAttr(char, 'ghostly_strength', Object_GetAttr(char, 'strength'))
    Object_SetAttr(char, 'strength', 0)
    Object_SetAttr(char, 'baseStrength', 0)
    FFX_ObjectSetAttr(char, 'permanent_shield', FFX_ObjectGetAttr(char, 'permanent_shield') + 1 )
    addFFXAttrib(char, 'ephemeral')
    addFFXAttrib(char, 'degenerative')
    ff.RESULTBUBBLE_SCALE = 0
    RegTimer('bubblesOn', 0.1)
    activeDef = getByTemplate(char, FFQ_GHOSTLY_CUSTOM, 1)
    if usingM25AI():
        m25ai.AIDoPower(char, power=activeDef, target=char, priority=m25ai.TACTIC_PRIORITY_CRITICAL, description='activating ghostly')
    else:   
        Trigger_Power(char, char, activeDef, '')
    RegTimer('updateFFQGhostly', 5, 0, char)

def updateFFQGhostly(event):
    char = event.object
    if not Object_Exists(char):
        return
    if not hasAttribute(char, 'ffqghostly'):
        return
    RegTimer('updateFFQGhostly', 5,0, char)
    if Object_IsAlive(char):
        Object_SetAttr(char, 'strength', 0)
        Object_SetAttr(char, 'baseStrength', 0)


########################### IMMUNE TO ... ######################################################
# Character has a constant active defence against a specific damage type, either at 100% or 50%.
# status: Abandoned, because of FF bugs and various limitations.

########################## FIELD COMMANDER ######################################################
# The character is a vital part of his team. His presence gives a bonus attribute to every teammate
# (defaults to give the 'heroic' attribute if not already gotten); however, if he gets KO'ed,
# they lose the attribute and suffer a penalty (defaults to loss of energy points and weakening).
# status: 1.1
#
# Added FFX 3.2.0 alpha

# Notes/bugs:
# -Works only with removable attributes (i.e., some of the FFX attribs, including scripted versions of the built-ins).
# -The penalty occurs even if the ko'ed character still has hero points left.

def initffqfieldcommander(char, update=0, remove=0):
    teammates = getAllTeammates(char, checkLiving = 1, lures = 0)
    allyBonusAttr = getByTemplate(char, FFQ_FIELDCOMMANDER_CUSTOM, 1)
    teammatesAdded = []
    #is the bonus attribute removable?
    removable = isAttributeRemovable(allyBonusAttr)
    if not removable:
        print "initffqfieldcommander() non-fatal error on '%s':" %char
        print "    attribute '%s' is not removable. Using default attribute instead." % allyBonusAttr
        Mission_StatusText("Field Commander error for %s:" % getCharDisplayName(char))
        Mission_StatusText("attribute '%s' not removable. Using default instead." % allyBonusAttr)
        allyBonusAttr = FFQ_FIELDCOMMANDER_CUSTOM[0][1]
    #attribute already set?
    if remove:
        if FFX_ObjectGetAttr(char,'ffqfieldcommander'):
            FFX_ObjectSetAttr(char, 'ffqfieldcommander', 0)
            FFX_ObjectSetAttr(char, 'ffqfieldcommander_active', 0)
            for teammate in teammates:
                if FFX_ObjectGetAttr(teammate, 'ffqfieldcommander_%s'%char):
                    FFX_ObjectSetAttr(teammate, 'ffqfieldcommander_%s'%char, 0)
                    init = "init%s('%s', update=0, remove=1)"%(allyBonusAttr, teammate)
                    exec init
                    teammatesAdded.append(teammate)
        if len(teammatesAdded) > 0:
            for teammate in teammatesAdded:
                Mission_StatusText(getCharDisplayName(teammate))
            Mission_StatusText("lost @ATTRIB_%s from Field Commander %s" %(string.upper(allyBonusAttr), getCharDisplayName(char)) )
        return
    if FFX_ObjectGetAttr(char, 'ffqfieldcommander'):
        return
    if update != 0:
        return
    FFX_ObjectSetAttr(char, 'ffqfieldcommander', 1)
    FFX_ObjectSetAttr(char, 'ffqfieldcommander_active', 1)
    #set the attribute
    allyBonusFX = getByTemplate(char, FFQ_FIELDCOMMANDER_CUSTOM, 2)
    if allyBonusFX != '':
        Object_PlayEffect(char, allyBonusFX, '', FX_TRACK_OBJECT_POS, 0)
    for teammate in teammates:
        if not FFX_ObjectGetAttr(teammate, allyBonusAttr):
            if not Character_HasAttribute(teammate, allyBonusAttr): #for characters with built-in versions or scripted attributes
                FFX_ObjectSetAttr(teammate, 'ffqfieldcommander_%s'%char, 1)
                init = "init%s('%s', update=0)"%(allyBonusAttr, teammate)
                print init
                exec init
                if allyBonusFX != '':
                    Object_PlayEffect(teammate, allyBonusFX, '', FX_TRACK_OBJECT_POS, 0)
                teammatesAdded.append(teammate)
    if len(teammatesAdded) > 0:
        Mission_StatusText("Field Commander %s added @ATTRIB_%s to" %(getCharDisplayName(char), string.upper(allyBonusAttr)) )
        for teammate in teammatesAdded:
            Mission_StatusText(getCharDisplayName(teammate))
    js.Event_RegisterSink(EVENT_OBJ_HEALTHCHANGED, 'OnFFQFieldCommanderKO', char, allyBonusAttr, 0, 0, 0)

def OnFFQFieldCommanderKO(event):
    char = event.object
    allyBonusAttr = event.string
    teammatesAdded = []
    FFX_ObjectSetAttr(char, 'ffqfieldcommander_active', 0)
    teammates = getAllTeammates(char, checkLiving = 1, lures = 0)
    allyPenalty = getByTemplate(char, FFQ_FIELDCOMMANDER_CUSTOM, 3)
    allyPenaltyFX = getByTemplate(char, FFQ_FIELDCOMMANDER_CUSTOM, 4)
    if allyPenaltyFX != '':
        Object_PlayEffect(char, allyPenaltyFX, '', FX_TRACK_OBJECT_POS, 0)
    for teammate in teammates:
        if FFX_ObjectGetAttr(teammate, 'ffqfieldcommander_%s'%char):
            FFX_ObjectSetAttr(teammate, 'ffqfieldcommander_%s'%char, 0)
            init = "init%s('%s', update=0, remove=1)"%(allyBonusAttr, teammate)
            exec init
            RegTimer(allyPenalty, 0.1, 0, teammate)
            if allyPenaltyFX != '':
                Object_PlayEffect(teammate, allyPenaltyFX, '', FX_TRACK_OBJECT_POS, 0)
            teammatesAdded.append(teammate)
    if len(teammatesAdded) > 0:
        for teammate in teammatesAdded:
            Mission_StatusText(getCharDisplayName(teammate))
        Mission_StatusText("lost @ATTRIB_%s from Field Commander %s" %(string.upper(allyBonusAttr), getCharDisplayName(char)) )
    

#---mental traits-------------------------------------------------
###################### RANDOM STATES: MAD, CURSED, BLESSED ###################################

###################### MAD
# You are subject to bouts of madness, risking going either enraged, hypnotised, panicked or blanked 
# (by default, customizable to almost any primary state) when attacked or for no reason at all.
# A request of Mr. Joe Kerr of Arkham Asylum.
# Based on (OK, mostly stolen from) FFX angst ridden (depressed).

# To temporarily turn off this behavior for every character suffering from this trait,
# set the Mission_SetAttr('allowFFQMad',0) in your script.
# To return them to their jolly mad selves: Mission_SetAttr('allowFFQMad',1)

###################### CURSED
# Someone gave you the evil eye, making you periodically suffer from effects such as hexed, stasis or blind
# when attacked or for no reason at all.
# Basically, Mad for bad secondary effects.

# To temporarily turn off this behavior for every character suffering from this trait,
# set the Mission_SetAttr('allowFFQCursed',0) in your script.
# To return them to their unlucky old selves: Mission_SetAttr('allowFFQCursed',1)

###################### BLESSED
# Some good fairy is watching over you, making you periodically gain unexpected advanteages such as speed increase or invisibility
#  when attacked or for no reason at all.
# Basically, Mad for good secondary effects.

# To temporarily turn off this behavior for every character benefitting from this trait,
# set the Mission_SetAttr('allowFFQBlessed',0) in your script.
# To return them to their lucky old selves: Mission_SetAttr('allowFFQBlessed',1)


# Status: 2.0

# Changed 1.4 (FFX 3.0)
# -Updated Object_IsAlive() for FFvsTTR
# -Now customizable through the Control Center :)
# -Changed the customization method for compatibility with the Control Center. Note that stun isn't
#  available, since apparently, having more that 11 fields crashed the C.C.
# Changed 1.5
# -Corrected an error which made the FFQ_RPG_MAD_CHANCE actually 4%, not 5.
# Changed 2.0 (FFX 3.05 alpha)
# -Rewrote to remove calls to missionobjvar and reuse code for Cursed and Blessed

FFQ_RPG_MAD_CHANCE = 5
FFQ_RPG_CURSED_CHANCE = 5
FFQ_RPG_BLESSED_CHANCE = 5

def initffqmad(char,update=0):
    if update==0:
        startFFQRandomState(char, 'Mad')

def initffqcursed(char,update=0):
    if update==0:
        startFFQRandomState(char, 'Cursed')
        
def initffqblessed(char,update=0):
    if update==0:
        startFFQRandomState(char, 'Blessed')

def startFFQRandomState(char, state):
    try:
        print 'Is "%s" attribute currently allowed?= %d'%(state, Mission_GetAttr('allowFFQ%s'%state))
    except:
        print '"%s" attribute is allowed by default.'%state
        Mission_SetAttr('allowFFQ%s'%state, 1)
    RegTimer('OnFFQRandomStateUpdate', 20, 0, char, state)
    RegDamage(char,'OnFFQRandomStateDamage', persistent = 1, string = state)

def OnFFQRandomStateUpdate(event):
    char = event.object
    state = event.string
    if not Object_Exists(char):
        return
    RegTimer('OnFFQRandomStateUpdate', 20, 0, char, state)
    checkFFQRandomState(char, state)

def OnFFQRandomStateDamage(event):
    char = event.object
    state = event.string
    checkFFQRandomState(char, state)

def checkFFQRandomState(char, state):
    if not Object_IsAlive(char):
        return
    if cshelper.isPlaying():
        return
    if Mission_GetAttr('allowFFQ%s'%state) == 0:
        return
    chance = "FFQ_RPG_%s_CHANCE"%string.upper(state)
    chance = eval(chance)
    if FFX_Rand(0, 99) < chance:
        exec 'ffqIs%s("%s")'%(state, char)
        
def ffqIsMad(char):
    allowed = getFFQMadState(char)
    selected = allowed[randint(0, len(allowed) -1)]
    Object_SetPrimaryState(char, selected, 15)
    RegTimer('OnupdateffqMadCB', 0.1, 0, char)

def ffqIsCursed(char):
    allowed = getFFQCursedState(char)
    selected = allowed[randint(0, len(allowed) -1)]
    Object_SetSecondaryState(char, selected, 15)
    RegTimer('OnupdateffqCursedCB', 0.1, 0, char)

def ffqIsBlessed(char):
    allowed = getFFQBlessedState(char)
    selected = allowed[randint(0, len(allowed) -1)]
    Object_SetSecondaryState(char, selected, 15)
    RegTimer('OnupdateffqBlessedCB', 0.1, 0, char)

def getFFQMadState(char):
    allStates = (
        0,
        PCSTATE_BLANK,
        PCSTATE_DIMENSION_SHIFT,
        PCSTATE_DOPPELGANGER,
        PCSTATE_ENRAGED,
        PCSTATE_FROZEN,
        PCSTATE_HYPNOTISED,
        PCSTATE_OBJECT,
        PCSTATE_PANICKED,
        PCSTATE_POLYMORPHED,
        PCSTATE_STATIC,
        PCSTATE_TOAD
        )
    i = 1
    selectedStates = []
    while i < 12:
        status = getByTemplate(char, FFQ_MAD_CUSTOM, i)
        if status == 1:
            selectedStates.append(allStates[i])
        i = i + 1
    return selectedStates

def getFFQCursedState(char):
    allStates = (
        0,
        SCSTATE_IRRADIATED,
        SCSTATE_BLIND,
        SCSTATE_HEXED,
        SCSTATE_ACID_BURNT,
        SCSTATE_POWER_NULLIFICATION,
        SCSTATE_SPEED_DECREASED,
        SCSTATE_WEAKENED
        )
    i = 1
    selectedStates = []
    while i < 8:
        status = getByTemplate(char, FFQ_CURSED_CUSTOM, i)
        if status == 1:
            selectedStates.append(allStates[i])
        i = i + 1
    return selectedStates

def getFFQBlessedState(char):
    allStates = (
        0,
        SCSTATE_ENERGIZED,
        SCSTATE_AREA_ENERGIZED,
        SCSTATE_EMPATHY,
        SCSTATE_DISPLACE_IMAGE,
        SCSTATE_INVISIBLE,
        SCSTATE_BUOYANT,
        SCSTATE_SPEED_INCREASED
        )
    i = 1
    selectedStates = []
    while i < 8:
        status = getByTemplate(char, FFQ_BLESSED_CUSTOM, i)
        if status == 1:
            selectedStates.append(allStates[i])
        i = i + 1
    return selectedStates


###################### OBSESSIVE: MISANTHROPE ############################################
# Character hates everybody! Stay away from that psychopath!
# Provided as a serie of different attributes rather than as a single customizable attribute because
# of the different cost value of each variant.
# Status: 1.5

# Changed 1.5 (FFX 3.0)
# -Updated Object_IsAlive() for FFvsTTR

# To temporarily turn off this behavior for every character suffering from this trait,
# set the Mission_SetAttr('allowffqmisanthrope',0) in your script AND then use makePeaceful(), etc.
# To return them to their "nice" personalities: Mission_SetAttr('allowffqmisanthrope',1)
# Beware that this works only if set before the attribute ever starts, i.e. at startup!

def initffqaimisanthrope(char,update=0):
    if update==0:
        try:
            print 'Is "Misanthrope" attribute currently allowed?= %d'%(Mission_GetAttr('allowFFQAIMisanthrope'))
        except:
            print '"Misanthrope" attribute is allowed by default.'
            Mission_SetAttr('allowFFQAIMisanthrope',1)
        RegTimer('updateffqAIMisanthrope',10,0,char)

def updateffqAIMisanthrope(event):
    char = event.object
    if not Object_Exists(char):
        return
    if FFX_ObjectGetAttr(char, 'psychotherapy'):
        return
    initialized = event.user
    RegTimer('updateffqAIMisanthrope',10,1,char)
    if not Object_IsAlive(char):
        return
    if cshelper.isPlaying():
        return
    if Mission_GetAttr('allowFFQAIMisanthrope') == 0:
        return
    if initialized == 0:
        return
    else:
        cshelper.addKillAllGoal(char,OC_CHARACTER,PRI_LOW-1)
        cshelper.addKillAllGoal(char,4,PRI_LOW-1) # 4 is OC_CHARACTER who has been transformed by AI_DestroyHeroAI()


###################### OBSESSIVE: CAR CHASER ############################################
# Character chases moving cars, trying to bite them! Wouah! Wouah!
# Only moving (not necessarily at the moment) cars will be chased.
# Status: 2.3

# Changed 2.3 (FFX 3.0)
# -Updated Object_IsAlive() for FFvsTTR
#
# Note/Bugs:
# -Character uses a low-level piercing attack on cars instead of one of his owns. Yeah, his teeth,
#  you know. Actually, it's because using AI gave poor results and I had to trigger attacks manually,
#  and we can't really know which powers characters have.
# -This might be changed eventually, using the datfiles module, with on-the-fly powers for customs. Might.

# To temporarily turn off this behavior for every character suffering from this trait,
# set the Mission_SetAttr('allowFFQAICarchaser',0) in your script AND then use makePeaceful(), etc.
# To return them to their "nice" personalities: Mission_SetAttr('allowFFQAICarchaser',1)
# Not that this won't stop the current car chase, if any.

def initffqaicarchaser(char,update=0):
    if update==0:
        try:
            print 'Is "Car Chaser" attribute currently allowed?= %d'%(Mission_GetAttr('allowFFQAICarchaser'))
        except:
            print '"Car Chaser" attribute is allowed by default.'
            Mission_SetAttr('allowFFQAICarchaser',1)
        cars = []
        for obj in Mission_GetDynamicObjects():
            if (Object_GetClass(obj) & js.OC_VEHICLE):
                pos = Get_ObjectPos(obj)
                entry = [obj, pos]
                cars.append(entry)
        missionobjvar.Mission_SetVar('carchaserCars', cars)
        RegTimer('updateFFQAICarchaser',10,0,char)

def updateFFQAICarchaser(event):
    char = event.object
    if not Object_Exists(char):
        return
    if FFX_ObjectGetAttr(char, 'psychotherapy'):
        return
    initialized = event.user
    RegTimer('updateFFQAICarchaser',5,1,char)
    if not Object_IsAlive(char):
        return
    if cshelper.isPlaying():
        return
    if Mission_GetAttr('allowFFQAICarchaser') == 0:
        return
    if initialized == 0:
        return
    carsOldPos = missionobjvar.Mission_GetVar('carchaserCars')
    carsNewPos = []
    for obj in Mission_GetDynamicObjects():
        if (Object_GetClass(obj) & js.OC_VEHICLE):
            pos = Get_ObjectPos(obj)
            entry = [obj, pos]
            carsNewPos.append(entry)
    foundTargets = []
    for oldCar in carsOldPos:
        for newCar in carsNewPos:
            if oldCar[0] == newCar[0]:
                if oldCar[1] != newCar[1]:
                    foundTargets.append(newCar[0])
                    break
    nearestCar = getNearestVehicle(char)
    if nearestCar == '':
        return
    posCar = Get_ObjectPos(nearestCar)
    posChar = Get_ObjectPos(char)
    carDist = cshelper.distance2D(posChar, posCar)
    if carDist < 500:
        nearestEnemy = getNearestAdversary(char, checkLiving = 1, team = -1)
        posEnemy = Get_ObjectPos(nearestEnemy)
        enemyDist = cshelper.distance2D(posChar, posEnemy)
        if enemyDist > (carDist + 50):
            Trigger_Power(char, nearestCar, 'blackbird Piercing Peck', '', 3)


###################### OBSESSIVE: MISOGYNIST AND VARIANTS ############################################
# Character hates women! Ladies, please avoid that jerk!
# Variants: Hates men, hates animals, hates robots, hates aliens. Yes, I do know that phobia means fear rather than hate. :/

# Status: 1.1

# Changed 1.1 (FFX 3.0)
# -Updated Object_IsAlive() for FFvsTTR

# To temporarily turn off this behavior for every character suffering from this trait,
# set the Mission_SetAttr('allowFFQAIMisogynist',0) in your script AND then use makePeaceful(), etc.
# To return them to their "nice" personalities: Mission_SetAttr('allowFFQAIMisogynist',1)
# Beware that this works only if set before the attribute ever starts, i.e. at startup!

#sex parameter needs to be one of:
##FFX_GENDER_UNKNOWN=-1
##FFX_GENDER_OPPOSITE=0
##FFX_GENDER_MALE=1
##FFX_GENDER_FEMALE=2
##FFX_GENDER_ANIMAL=3
##FFX_GENDER_ROBOT=4
##FFX_GENDER_ALIEN=5
##FFX_GENDER_GOOD=0
##FFX_GENDER_EVIL=32
def initffqaimisogynist(char,update=0):
    FFQGenderHate(char,FFX_GENDER_FEMALE)
    
def initffqaimisandre(char,update=0):
    FFQGenderHate(char,FFX_GENDER_MALE)

def initffqaizoophobe(char,update=0):
    FFQGenderHate(char,FFX_GENDER_ANIMAL)

def initffqaitechnophobe(char,update=0):
    FFQGenderHate(char,FFX_GENDER_ROBOT)

def initffqaixenophobe(char,update=0):
    FFQGenderHate(char,FFX_GENDER_ALIEN)

def FFQGenderHate(char,sex):
    try:
        print 'Is "Misogynist" attribute currently allowed?= %d'%(Mission_GetAttr('allowFFQAIMisogynist'))
    except:
        print '"Misogynist" attribute is allowed by default.'
        Mission_SetAttr('allowFFQAIMisogynist',1)
    RegTimer('updateFFQGenderHate',10,0,char,str(sex))

def updateFFQGenderHate(event):
    char = event.object
    if not Object_Exists(char):
        return
    sex = int(event.string)
    if FFX_ObjectGetAttr(char, 'psychotherapy'):
        return
    initialized = event.user
    RegTimer('updateFFQGenderHate',10,1,char,str(sex))
    if not Object_IsAlive(char):
        return
    if cshelper.isPlaying():
        return
    if Mission_GetAttr('allowFFQAIMisogynist') == 0:
        return
    if initialized == 0:
        return
    else:
        allOfGender = getAllByGender(sex)
        for individual in allOfGender:
            cshelper.addKillGoal(char,individual,PRI_LOW-1)


###################### PSYCHOTHERAPY #####################################################
# Character is immune to the effect of mind-altering attributes (Depressed/Angst-ridden,
# Mad and all the Obsessive/Hate-filled variants). Doesn't cure Timid or Berserk, since
# those are built-ins.
# Another attribute useful only in Campaign mode.
# Pyschotherapy added by latent mutant will not cure the Hate-Filled variants.
# Status: 0.0

def initffqpsychotherapy(char,update=0):
    FFX_ObjectSetAttr(char, 'psychotherapy', 1)



#---simulated built-ins---#000000#FFFFcc----------------------------------------
############## ffq simulated built-ins attributes for combos #############################

########################### NIMBLE SCRIPTED ##############################################
# replaced by same attribute now available in ffx

########################### HEROIC SCRIPTED ##############################################
# replaced by same attribute now available in ffx

########################### EXTRA HEROIC SCRIPTED ########################################
# replaced by same attribute now available in ffx

########################### UNHEROIC SCRIPTED ############################################
# replaced by same attribute now available in ffx

########################### TIMID SCRIPTED ###############################################
# 5% chance of becoming panicked after taking damage.
# status: 1.3
# added:
# -changed duration from 12 to 10 secs, the original's duration when using the in-game clock.
# added 1.3
# -renamed isTimidPanicked() to setTimidPanicked(), since it's not a query function.
def inittimid(char,update=0):
    if update==0:
        RegDamage(char,'OnTimidDamage',persistent=1)

def OnTimidDamage(event):
    char=event.object
    if cshelper.isPlaying():
        return
    if FFX_Rand(1,20) == 1:
        setTimidPanicked(char)

def setTimidPanicked(char):
    Object_SetPrimaryState(char,PCSTATE_PANICKED,10)
    RegTimer('OnupdateTimidCB',0.1,0,char)


########################### BEZERKER SCRIPTED ####################################
# 10% chance of becoming enraged after taking damage.
# status: 1.4
# added:
# -changed duration from 12 to 10 secs to reflect cshelper rather than my approximation
# -changed name to follow original's spelling in attributes.dat
# added 1.4
# -renamed isBezerkerEnraged() to setBezerkerEnraged(), since it's not a query function.
def initbezerker(char,update=0):
    if update==0:
        RegDamage(char,'OnBezerkerDamage',persistent=1)

def OnBezerkerDamage(event):
    char=event.object
    if cshelper.isPlaying():
        return
    if FFX_Rand(1,10) == 1:
        setBezerkerEnraged(char)

def setBezerkerEnraged(char):
    Object_SetPrimaryState(char,PCSTATE_ENRAGED,10)
    RegTimer('OnupdateBezerkerCB',0.1,0,char)


########################### PRIMARY AND SECONDARY STATES RESISTANCES ###############
    
########################### UNBELIEVER SCRIPTED ####################################
# You don't know what this "magic" stuff is that everyone keeps talking about. You are more resistant to all forms of mystical attack.
# status: 1.0
#
# Bugs:
# -The resistance bonus doesn't show in the status bar.
# -Since this version doesn't resist, but instead removes immediately a atate, the character's current action is still stopped;
#  in particular, a flying character attacked with stasis will fall to the ground.

########################### DISCIPLINED SCRIPTED ####################################
# Resistant to all mental attacks (hypnosis, mental blank, rage, panic).
# status: 1.0
#
# Bugs:
# -The resistance bonus doesn't show in the status bar.
# -This version of the attribute will also cancel out beserker or enrage half of the time! Use the original version if you intend to buy these.

########################### LEVEL-HEADED SCRIPTED ####################################
# You are solidly grounded in the here and now, and have no time for this "extra damage type" malarky. You are resistant to Mystical and Mental Damage.
# A combo of Unbeliever and Disciplined

########################### GRIM RESOLVE SCRIPTED ####################################
# No time for lying down on the job! you are more resistant to stun damage.
# status: 1.1
#
# Bugs:
# -The resistance bonus doesn't show in the status bar.

def initunbeliever(char,update=0):
    if update==0:
        RegCharState(char,PCSTATE_STATIC,'OnFFQPrimaryResist',persistent=1)
        RegCharState(char,PCSTATE_EXILE,'OnFFQPrimaryResist',persistent=1)
        RegCharState(char,SCSTATE_BLIND,'OnFFQSecondaryResist',persistent=1)
        RegCharState(char,SCSTATE_HEXED,'OnFFQSecondaryResist',persistent=1)
        RegCharState(char,PCSTATE_STATIC,'OnFFQSecondaryResist',persistent=1)

def initdisciplined(char,update=0):
    if update==0:
        RegCharState(char,PCSTATE_BLANK,'OnFFQPrimaryResist',persistent=1)
        RegCharState(char,PCSTATE_ENRAGED,'OnFFQPrimaryResist',persistent=1)
        RegCharState(char,PCSTATE_PANICKED,'OnFFQPrimaryResist',persistent=1)
        RegCharState(char,PCSTATE_HYPNOTISED,'OnFFQPrimaryResist',persistent=1)

def initlevelheaded(char,update=0):
    initunbeliever(char,update)
    initdisciplined(char,update)

def initgrimresolve(char,update=0,remove=0):
    if remove:
        FFX_ObjectSetAttr(char,'grimresolve',0)
    if update==0:
        FFX_ObjectSetAttr(char,'grimresolve',1)
        RegCharState(char,PCSTATE_STUNNED,'OnFFQPrimaryResist',persistent=1,user=0,string='grimresolve')

# gives a 50% chance of resisting the effect      
def OnFFQPrimaryResist(event):
    char = event.object
    state = event.user
    attrib = event.string
    if cshelper.isPlaying():
        return
    if FFX_ObjectGetAttr(char,attrib)==0:
        return
    if FFX_Rand(0,1) == 1:
        print "%s resisted the primary state attack!"%char
        Object_SetPrimaryState(char, state, 0, REMOVE_STATE)

def OnFFQSecondaryResist(event):
    char = event.object
    state = event.user
    if cshelper.isPlaying():
        return
    if FFX_Rand(0,1) == 1:
        print "%s resisted the secondary state attack!"%char
        Object_SetSecondaryState(char, state, 0, REMOVE_STATE)


########################### SHAKE IT OFF SCRIPTED ####################################
# You can take a licking and keep on ticking! the duration of all prolonged damage states is halved.
# status: 1.0
#
# Notes/Bugs:
# -The original attribute doesn't in fact reduce the duration (10-25 secs.) of irradiate and acid burn;
#  it is the damage wich is reduced at least in half. This scripted version reduces duration by an amount
#  corresponding roughly to a bit more than half the damage.
# -FF Engine bug (?): register sinks for state changes with SCSTATE_IRRADIATED and SCSTATE_ACID_BURNT
#  don't work! Using the god ol' kludge method works, however.

def initshakeitoff(char,update=0,remove=0):
    if remove:
        FFX_ObjectSetAttr(char,'shakeitoff',0)
    if update==0:
        FFX_ObjectSetAttr(char,'shakeitoff',1)
        regAcidBurnt(char, 'OnFFQSecondaryDamageStateCheck', user = SCSTATE_ACID_BURNT, persistent = 1)
        regIrradiated(char, 'OnFFQSecondaryDamageStateCheck', user = SCSTATE_IRRADIATED, persistent = 1)

def OnFFQSecondaryDamageStateCheck(event):
    char = event.object
    state = event.user
    if FFX_ObjectGetAttr(char,'shakeitoff')==0:
        return
    if Object_GetSecondaryStates(char) == state:
        time = randint(2,3)
        RegTimer('OnFFQSecondaryDamageStateRemove',time,state,char)

def OnFFQSecondaryDamageStateRemove(event):
    char = event.object
    state = event.user
    if Object_GetSecondaryStates(char) == state:
        Object_SetSecondaryState(char, state, 0, REMOVE_STATE)


########################### DENSITY CONTROL SCRIPTED #################################
# Immune to knock-back. Jumping [dis-]abilities [not really] similar to jumper attribute.
# LOOSELY approximates the standard Density Control attribute.
# status: 1.3
# Added FFX 2.5

# Bugs/Notes:
# -Character's mass is now set to a high value to prevent frozen/staticked bug
#  (RegCharState() couldn't be used, since state swaps would still apply first).
#  Contrarily to the built-in Density  Control, this version's efficiency is modified by Hollow Bones,
#  Mass Control, etc. The higher mass also influences Clumsy Jumper, Jump Travel and FastBall.

# Changed 1.3 (post FFX 2.6):
# -Corrected a bug where a frozen or staticked character returning to normal would be knocked into
#  the air and suffer 150+ damage! Thanks to Wonderraver for finding that.
#  The safe mass/minForce ratio seems to be 0.008 and above.

def initffqdensitycontrol(char,update=0):
    if update:
        return
    initffqhighjumper(char,update)
    FFX_SetMassFactor(char,20)

    
# Other potential standard attributes which could be mimicked or approximated by script:
# beautiful (MLOG)?, claws (MLOG for customs)??, clumsy (MLOG)?, crack shot (MLOG)??,
# energetic (not compatible with FFvsTTR), fluctuation???, heavy hitter (MLOG)?,
# hot tempered???, levitate (with flying animation), tough guy (MLOG for generic states)?,
# unstable energy (which can already be simulated by customizing Spiny or Acid Blood).
#
# (Note: ?: could probably be done; ??: a longshot; ???: could probably not be done)

# done in FFX: fasthealing, unheroic, heroic, extraheroic, nimble, slowmoving, heavylifter, unstablemolecules,


#---combos---#000000#FFFFcc-----------------------------------------------------
############## ffq combo attributes ######################################################

########################### GYMNAST ######################################################
# Combines Nimble with Acrobat and Superleaper. Added Limited Jumping for good measure.
# status: 1.2 OK
# moved to ffxmulti.py

########################### TRAPEZIST ####################################################
# Combines Gymnast with rope swinger.
# status: 1.0 O.K.
# Added FFX 2.5
# moved to ffxmulti.py

########################### JUMPING JACK #################################################
# Combines Clumsy Jumper with Jump Travel and Superleaper.
# status: 1.0 OK
# moved to ffxmulti.py

########################### PAGAN GOD ####################################################
# Combines Immortal with Extradimensional.
# NOT COMPATIBLE WITH LAST RESORT ATTRIBUTE
# status: 1.0 OK
# Added FFX 2.5
# moved to ffxmulti.py

########################### PROWLER ######################################################
# Combines Stealthy with Nocturnal, Tracking and Loner.
# status: 1.0
# Added FFX 2.5
# moved to ffxmulti.py

########################### AIR SUPERIORITY ##############################################
# Combines Fast Flier with Nimble Flier.
# status: 1.0
# Added FFX 2.5
# moved to ffxmulti.py



########################### CHARACTER STATES SWAPS #######################################
# Memo: Named in the mpTo list at the beginning and in MULTIPLAYER MESSAGE SYSTEM.
# All the state swap code below is obviously and shamelessly ripped off Dr. Mike's original work.


########################### LEADERSHIP ###################################################
# Allows to transfer a hero point to an ally.
# status: 1.2
# Added FFX 2.5

# Changed FFX 3.2.0 alpha:
# - Added FFvsTTR source state Speed Increase

def rallytoleadership(event):
    char=event.object
    source=event.string
    bonus=Object_GetAttr(char,'attackBonus')
    oldBonus=Object_GetAttr(char,'oldAttackBonus')
    if bonus!=oldBonus:
        Object_SetAttr(char,'attackBonus',oldBonus)
        makeleadership(char, source)

def energisetoleadership(event):
    char=event.object
    source=event.string
    if FFX_GotState(char,SCSTATE_ENERGIZED):
        Object_SetSecondaryState(char,SCSTATE_ENERGIZED,0,REMOVE_STATE)
        FFX_UpdateStates(char)
        makeleadership(char, source)

def energysurgetoleadership(event):
    char=event.object
    source=event.string
    if FFX_GotState(char,SCSTATE_AREA_ENERGIZED):
        Object_SetSecondaryState(char,SCSTATE_AREA_ENERGIZED,0,REMOVE_STATE)
        FFX_UpdateStates(char)
        makeleadership(char, source)

def speedincreasetoleadership(event):
    char=event.object
    source=event.string
    if FFX_GotState(char,SCSTATE_SPEED_INCREASED):
        Object_SetSecondaryState(char,SCSTATE_SPEED_INCREASED,0,REMOVE_STATE)
        FFX_UpdateStates(char)
        makeleadership(char, source)
        
def makeleadership(target, source):
    MPSendMessage(MP_LEADERSHIP, Object_GetAttr(target, 'ffxMPID'))
    if Object_IsAlive(source):
        heroPoints = Object_GetAttr(source, 'heroPoints')
        if heroPoints > 0:
            Object_SetAttr(source, 'heroPoints', heroPoints - 1)
            Object_SetAttr(target, 'heroPoints', Object_GetAttr(target, 'heroPoints') + 1)
            Object_PlayEffect(source,'effect_ffx_purplesparks', '', FX_TRACK_OBJECT_FULL)
            Object_PlayEffect(target,'effect_rescuecivilian', '', FX_TRACK_OBJECT_FULL)


########################## BREACH ########################################################
# Disables an active enemy shield for the duration if the pre-swap attack type succeeds.
# status: 2.0

# Changed 2.0 (FFX 3.0):
# -Changed the method used, as Powernull and Active Defences work differently in FFvsTTR
# -Added custom FX

# Notes/Bugs:
# -This doesn't prevent activating the shield; however, it won't last more than one second while the state lasts.
# -Ironically, player Characters may sometimes be temporarily unable to attack breached characters,
#  possibly due to the Remove Defence attack???

def empathytobreach(event):
    char=event.object
    Trigger_Explosion(char,'ffx_hexarea')
    RegTimer('breachCheck',1,stateintensity[int(event.user)],char)

def displacetobreach(event):
    char=event.object
    Trigger_Explosion(char,'ffx_hexarea')
    RegTimer('breachCheck',1,stateintensity[int(event.user)],char)

def cloaktobreach(event):
    char=event.object
    Trigger_Explosion(char,'ffx_hexarea')
    RegTimer('breachCheck',1,stateintensity[int(event.user)],char)

def breachCheck(event):
    char=event.object
    for obj in Mission_GetDynamicObjects():
        if obj!=char:
            if Object_GetClass(obj) & (OC_CHARACTER|4):
                if distanceSq(obj,char)<40000:
                    if Object_GetSecondaryStates(obj)&SCSTATE_HEXED:
                        Object_SetSecondaryState(obj,SCSTATE_HEXED,0,REMOVE_STATE)
                        makebreached(obj,char,event.user)

def stuntobreach(event):
    breachP(event,PCSTATE_STUNNED,COST_STUN)
    
def hypnosistobreach(event):
    breachP(event,PCSTATE_HYPNOTISED,COST_HYPNO)
    
def ragetobreach(event):
    breachP(event,PCSTATE_ENRAGED,COST_RAGE)

def exiletobreach(event):
    breachP(event,PCSTATE_EXILE,COST_EXILE)

def weakentobreach(event):
    breachP(event,PCSTATE_EXILE,COST_WEAKEN)

def decreasetobreach(event):
    breachP(event,PCSTATE_EXILE,COST_DECREASE)

def blanktobreach(event):
    breachP(event,PCSTATE_BLANK,COST_BLANK)
    
def panictobreach(event):
    breachP(event,PCSTATE_PANICKED,COST_PANIC)
    
def frozentobreach(event):
    breachP(event,PCSTATE_FROZEN,COST_FROZEN)
    
def stasistobreach(event):
    breachP(event,PCSTATE_STATIC,COST_STASIS)

def hextobreach(event):
    breachS(event,SCSTATE_HEXED,COST_HEX)
    
def blindtobreach(event):
    breachS(event,SCSTATE_BLIND,COST_BLIND)
    
def powernulltobreach(event):
    breachS(event,SCSTATE_POWER_NULLIFICATION,COST_NULL)

def densitytobreach(event):
    char=event.object
    source=event.string
    if densityaltered(char):
        Object_SetGenericState(char,OBJSTATE_DENSITY_CHANGE,0,REMOVE_STATE)
        FFX_UpdateStates(char)
        makebreached(char,source,COST_DENSITY)

def breachP(event,state,intensity):
    char=event.object
    source=event.string
    if Object_GetPrimaryState(char)==state:
        Object_SetPrimaryState(char,state,0,REMOVE_STATE)
        FFX_UpdateStates(char)
        makebreached(char,source,intensity)

def breachS(event,state,intensity):
    char=event.object
    source=event.string
    if Object_GetSecondaryStates(char)&state:
        Object_SetSecondaryState(char,state,0,REMOVE_STATE)
        FFX_UpdateStates(char)
        makebreached(char,source,intensity)

def makebreached(char,source,intensity):
    MPSendMessage(MP_BREACH, Object_GetAttr(char, 'ffxMPID'), Object_GetAttr(source, 'ffxMPID'), intensity)
    removeShield(char, duration = int(intensity * 18))

# Prevent use of active defence for the duration
# Rewritten for FFX 3.0, since Active Defences and PowerNull work differently
# Updated FFX 3.2. Still needs work...
# Notes:
# - There is a ~0.55 sec delay between the call and the actual removal.
# - This will also remove active defences which should not be removed, such as those set by Ghostly or Illusion.
#   If you don't want to remove them, use
#   if FFX_ObjectGetAttr(char, 'permanent_shield') < 1:
#       removeShield(char)
# duration: integer value. 1 = do for 1 second only; -1 = permanent
# Bug: duration = 0 is currently not supported.
# To remove, either call the function with duration = 0 or use FFX_ObjectSetAttr(char, 'breached_duration', 0)
def removeShield(char, duration = 1, fx = 'effect_ffq_breach'):
    # increases the duration of the state if appropriate when hitting a target already breached;
    # if not already breached, initializes the state
    oldDuration = FFX_ObjectGetAttr(char, 'breached_duration')
    if oldDuration == 0:
        pos=Get_ObjectPos(char)
        tiggot = spawnTiggot(char, pos)
        FFX_ObjectSetAttr(char, 'breached_tiggot', eval(tiggot[-1]))
        if fx != '':
            if duration != 0:
                handle = Object_PlayEffect(char, fx, '', FX_LOOP|FX_TRACK_OBJECT_POS, 0)
                FFX_ObjectSetAttr(char, 'ffqbreach-handle', handle)
            else:
                Object_PlayEffect(char, fx, '', FX_TRACK_OBJECT_POS, 0)
    else:
        tiggot = 'tig_%s_%d'%(char, FFX_ObjectGetAttr(char, 'breached_tiggot'))
    FFX_ObjectSetAttr(char, 'breached_duration', duration)
    RegTimer('OnRemoveShield', 0.5, 0, char, tiggot)

def OnRemoveShield(event):
    char = event.object
    tiggot = event.string
    duration = FFX_ObjectGetAttr(char, 'breached_duration')
    if Object_IsAlive(char):
        try:
            # OnRemoveShield() was called twice when at zero if breach duration was extended... why? TEMP!!! haven't the time to find the real solution for now
            # The tiggot was thus called even if already destroyed
            Trigger_Power(tiggot, char, 'ffq_remove_defence', '')
        except:
            FFX_ObjectSetAttr(char, 'breached_duration', 0)
            return
    else:
        duration = 0
    if duration == 0:
        FFX_ObjectSetAttr(char, 'shieldNullified', 0)
        if Object_Exists(char):
            handle = FFX_ObjectGetAttr(char, 'ffqbreach-handle')
            if handle:
                Object_StopEffect(char, handle)
        if Object_Exists(tiggot):
            Object_Destroy(tiggot)
        return
    if duration != -1:
        duration = duration - 1
        FFX_ObjectSetAttr(char, 'breached_duration', duration)
    RegTimer('OnRemoveShield', 1, 0, char, tiggot)

# in FFvsTTR, PowerNull for shields only doesn't work anymore, hence this workaround.
def isBreached(obj,char=''):
    if not Object_Exists(obj):
        return 0
    if FFX_ObjectGetAttr(obj, 'breached_duration') != 0:
        return 1
    else:
        return 0


########################## CASTLE #########################################################
# Swaps position with the target. Based on the idea of the same name from the Strangers.
# Mental states to Castle correspond to illusion casting.
# status: 2.3
# Added FFX 2.5
# Changed exposed name to CASTLE by Dr Mike for 2.5 release. You're thinking of ROOK?
# Ep.: - Ethymologically, yes. I was thinking of the french "roque", which has the same origin as "rook".
#        However, "roque" in modern french means "castle"; cross-language confusion...

def stuntocastle(event):
    roqueP(event,PCSTATE_STUNNED,1)
def exiletocastle(event):
    roqueP(event,PCSTATE_EXILE,COST_EXILE)
def weakentocastle(event):
    roqueS(event.object,event.string,SCSTATE_WEAKENED,COST_WEAKEN)
def speeddecreasetocastle(event):
    roqueS(event.object,event.string,SCSTATE_SPEED_DECREASED,COST_DECREASE)

def densitytocastle(event):
    char=event.object
    source=event.string
    if densityaltered(char):
        Object_SetGenericState(char,OBJSTATE_DENSITY_CHANGE,0,REMOVE_STATE)
        FFX_UpdateStates(char)
        makeroqued(char,source,COST_DENSITY)

def roqueP(event,state,intensity):
    char=event.object
    source=event.string
    if Object_GetPrimaryState(char)==state:
        Object_SetPrimaryState(char,state,0,REMOVE_STATE)
        FFX_UpdateStates(char)
        makeroqued(char,source,intensity)

def roqueS(event,state,intensity):
    char=event.object
    source=event.string
    if Object_GetSecondaryStates(char)&state:
        Object_SetSecondaryState(char,state,0,REMOVE_STATE)
        FFX_UpdateStates(char)
        makeroqued(char,source,intensity)

def makeroqued(target, source, intensity):
    MPSendMessage(MP_ROQUE, Object_GetAttr(target, 'ffxMPID'), Object_GetAttr(source, 'ffxMPID'), intensity)
    cshelper.disable(target)
    cshelper.disable(source)
    Object_PlayEffect(target, 'effect_portal_core')
    Object_PlayEffect(source, 'effect_portal_core')
    targetDestination = Get_ObjectPos(source)
    targetDestination = FFQ_tupleToString(targetDestination)
    sourceDestination = Get_ObjectPos(target)
    sourceDestination = FFQ_tupleToString(sourceDestination)
    RegTimer('OnRoque',0.1, 0, target, targetDestination)
    RegTimer('OnRoque',0.1, 0, source, sourceDestination)

def OnRoque(event):
    char = event.object
    destination = event.string
    destination = FFQ_stringToTuple(destination)
    cshelper.disable(char)
    FFX_TP(char, destination, 'OnRoqueDone')
    
def OnRoque2(event):
    char = event.object
    destination = event.string
    destination = FFQ_stringToTuple(destination)
    cshelper.disable(char)
    FFX_TP(char, destination)

def OnRoqueDone(event):
    char = event.object
    FFX_TP2(event)
    RegTimer('OnRoqueReEnable', 1, 0, char)

def OnRoqueReEnable(event):
    cshelper.enable(event.object)


########################### REMOTE EMPATHY ##############################################
# Gives the Empathy state to the target.
# status: 1.0
# Added FFX 2.5

def rallytoremoteempathy(event):
    char=event.object
    source=event.string
    bonus=Object_GetAttr(char,'attackBonus')
    oldBonus=Object_GetAttr(char,'oldAttackBonus')
    if bonus!=oldBonus:
        Object_SetAttr(char,'attackBonus',oldBonus)
        makeremoteempathy(char)

def energisetoremoteempathy(event):
    char=event.object
    source=event.string
    if FFX_GotState(char,SCSTATE_ENERGIZED):
        Object_SetSecondaryState(char,SCSTATE_ENERGIZED,0,REMOVE_STATE)
        FFX_UpdateStates(char)
        makeremoteempathy(char)

def energysurgetoremoteempathy(event):
    char=event.object
    source=event.string
    if FFX_GotState(char,SCSTATE_AREA_ENERGIZED):
        Object_SetSecondaryState(char,SCSTATE_AREA_ENERGIZED,0,REMOVE_STATE)
        FFX_UpdateStates(char)
        makeremoteempathy(char)

def makeremoteempathy(target):
    MPSendMessage(MP_REMOTEEMPATHY, Object_GetAttr(target, 'ffxMPID'))
    setEmpathyState(target, duration = 12)



########################### BODY SNATCH ##############################################
# A variant of FFvsTTR possession with effect based on FFX 2.6's possession: the possessor is
# physically moved in the host body (i.e., when the possession ends, he appears at the host's position).
# Added at the request of Al'Kemyst.
# status: 1.1
# Added FFX 3.2
# UPDATE: 1.1 By TaskmasterX
# Updated so the possessed target takes the correct team of the possessor and gets back on their original team
# when the possession is over

# Note: available only as a swap for possession.

def possessiontobodysnatch(event):
    bodysnatchS(event, SCSTATE_POSSESSED, 1.0)

def bodysnatchS(event, state, intensity):
    char = event.object
    source = event.string
    if Object_GetSecondaryStates(char) & state:
        makebodysnatch(char, source, intensity)

def makebodysnatch(target, user, intensity=1):
    teleportToPos(user, Get_ObjectPos(target))
    RegTimer('OnBodySnatch', 0.3, 0, user, target)
    FFX_ObjectSetAttr(target,'bodysnatched',1)

def OnBodySnatch(event):
    char = event.object
    target = event.string
    if FFX_ObjectGetAttr(target,'bodysnatched')==1:
        FFX_ObjectSetAttr(target,'bodysnatched',0)
        return
    setInvisibleState(char, duration = 60)
    oldTeam=m25ai.GetTeam(target)
    FFX_ObjectSetAttr(target,'targetOldTeam',oldTeam)
    regSecondaryState2(target, SCSTATE_POSSESSED, 'OnBodySnatchEnd', user = 0, string = char, persistent = 0)
    m25ai.SetTeam(target,m25ai.GetTeam(char))
    m25ai.ClearAIStandardOnly(target)
    m25ai.AIEnableWatch(target)
    m25ai.AIEnable(target)
    m25ai.AIEnableCustom(target)
    m25ai.SetBrawler(target)
    m25event.SetTimer(1.0, 'AIRecoverBroken', target, user=m25ai.GetAITimeStamp(target))

def OnBodySnatchEnd(event):
    target = event.object
    char = event.string
    team = FFX_ObjectGetAttr(target,'targetOldTeam')
    pos = Get_ObjectPos(target)
    teleportToPos(char, pos)
    fallOver(target)
    setInvisibleState(char, duration = 0)
    Trigger_Move(char, 'move', (pos[0] + 20, pos[1], pos[2]), '', 1, 1)
    m25ai.SetTeam(target,team)
    m25ai.AIRestart(target,100000)


############## customisation parameters functions ####################################################


#---------------------------------------------
#---Visual Effects----------------------------
#---------------------------------------------


# Turns the world red
# char, string and float are ignored for this function
def visualEffectRed(char, duration, string = '', float = 0):
    changeLight(duration, iamb = 128, idir = 128, ircl = 255)

# Turns the world blue
# char, string and float are ignored for this function
def visualEffectBlue(char, duration, string = '', float = 0):
    changeLight(duration, ibcl = 255)

# Turns the world into colored wireframe
# char, string and float are ignored for this function
def visualEffectWireframe(char, duration, string = '', float = 0):
    ff.RENDER_WIREFRAME = 1
    RegTimer('OnEffectWireframeOff', duration, 0)

def OnEffectWireframeOff(event):
    ff.RENDER_WIREFRAME = 0   

# Turns the terrain and non ambiant objects invisibles
# char, string and float are ignored for this function
def visualEffectHideWorld(char, duration, string = '', float = 0):
    ff.RENDER_DRAWOBJECTS = 0
    ff.RENDER_DRAWTERRAIN = 0
    RegTimer('OnEffectHideWorldOff', duration, 0)

def OnEffectHideWorldOff(event):
    ff.RENDER_DRAWOBJECTS = 1
    ff.RENDER_DRAWTERRAIN = 1

# Shows physics displacement bubbles around moving objects
# char, string and float are ignored for this function
def visualEffectPhysicsBubbles(char, duration, string = '', float = 0):
    ff.VISUALIZE_PHYSICS = 1
    RegTimer('OnEffectPhysicsBubblesOff', duration, 0)

def OnEffectPhysicsBubblesOff(event):
    ff.VISUALIZE_PHYSICS = 0



############## helper functions ##########################################################


#---------------------------------------------
#---debugging helpers-------------------------
#---------------------------------------------
#Notes:
# - isAttributeRemovable() and isComboAttributeRemovable) moved to the "Character attributes manipulation" section
# - other debugging functions have been moved to the progrutils module


#toggle whether selected text is sent to the mission status text area or to the console
#FFX 3.2.0 alpha 1: deleted, M25report.py module duplicates that.
#def FFQ_toScreen(text):

#toggle display of selected info to the console
#FFX 3.2.0 alpha 1: deleted, M25report.py module duplicates that.
#def FFQ_toConsole(text):


#---------------------------------------------
#---AI helpers--------------------------------
#---------------------------------------------


# AUTOPILOT
# Adds a command to each hero to give them AI
# Removed, new M25 work in FFX 3.04 somewhat makes this moot


#TEMP! This needs to be replaced with more modern code based on M25 new system.
# gives AI to a spawned oc_controllable character
# basically a copy of FFX code
# v1.4
# -made the AI follow the nearest hero when idle
# v1.5
# -failsafes added for work with skirmish mode time travelers
def FFQ_givesAI(char,spawnName):
    if not Object_Exists(char): #if char has been destroyed (tempform, dead minion or police, script)
        print "FFQ_givesAI fatal error:"
        print "    %s does not exist anymore. %s will have no AI defined."%(char,spawnName)
        return
    cshelper.makePeaceful(spawnName)
    if Object_GetClass(char)&(OC_CONTROLLABLE|OC_POLICE):
        cshelper.addKillAllGoal(spawnName,OC_MINION,PRI_LOW)
        cshelper.addKillAllGoal(spawnName,OC_VILLIAN,PRI_LOW)
    else:
        #minions in the non-M25 danger room as villains attack hero characters
        cshelper.addKillAllGoal(spawnName,OC_CONTROLLABLE,PRI_LOW)
    #m25 compatibility
    #M25 updated Feb 17
    print char + ' creates ' + spawnName
    try:
        if usingM25AI():
            m2ai.SetupOneChar(spawnName)
        m25ai.SetTeam(spawnName,m25ai.GetTeam(char))
        setGender(spawnName,1)
        m25ai.SetBrawler(spawnName)
        #RegTimer('brawlTag',0.1,1,spawnName)
    except:
        m25ai.SetBrawler(spawnName,0)
    #end m25 compatibility
    FFX_ObjectSetAttr(spawnName,'FFQ_hasAI',1)
    if Object_IsAlive(char):
        RegTimer('updateFFQ_AIfollow',1,0,'',spawnName)


# used by FFQ_independantAI() and FFQ_givesAI()
def updateFFQ_AIfollow(event):
    follower = event.string
    customCommands = event.user
    nearestHero = FFQ_getNearestHero(follower)
    if cshelper.isPlaying():
        print '%s autopilot: a cutscene is playing'%(follower)
        RegTimer('updateFFQ_AIfollow',4,customCommands,'',follower)
    else:
        print '%s on autopilot: sticking around %s'%(follower,nearestHero)
        #sets the kills goals again, because a controllable might lose them when selected 
        if Object_GetClass(follower)&(OC_CONTROLLABLE|OC_POLICE):
            cshelper.addKillAllGoal(follower,OC_MINION,PRI_LOW)
            cshelper.addKillAllGoal(follower,OC_VILLIAN,PRI_LOW)
        else:
            #minions in the non-M25 danger room as villains attack hero characters
            cshelper.addKillAllGoal(follower,OC_CONTROLLABLE,PRI_LOW)
        if FFX_ObjectGetAttr(follower,'FFQ_hasAI'):
            if nearestHero != '':
                if FFQ_heightDiff(follower,nearestHero):
                    cshelper.addMoveGoal(follower,nearestHero,PRI_ZERO-1,command='jump',radius=2)
                else:
                    cshelper.addMoveGoal(follower,nearestHero,PRI_ZERO-1,radius=randint(5,25))
            #looks for new heroes added during the mission
            if customCommands:
                FFQ_AIcommands()
            RegTimer('updateFFQ_AIfollow',4,customCommands,'',follower)



# cshelper code, modified to find the nearest hero which is NOT the calling character
def FFQ_getNearestHero(char):
    minDistance = pow(10,6)
    hero = ''
    objects = js.Mission_GetDynamicObjects()
    for object in objects:
        if object != char:
            objclass = js.Object_GetClass(object)
            if (objclass & js.OC_CONTROLLABLE) and Object_IsAlive(object):
                pos1 = Get_ObjectPos(char)
                pos2 = Get_ObjectPos(object)
                vector = Vector_Sub(pos1, pos2)
                distance = sqrt(vector[0] * vector[0] + vector[1] * vector[1] + vector[2] * vector[2])
                if distance < minDistance:
                    minDistance = distance
                    hero = object
    return hero


# finds if the target is on higher ground than the character while not flying
# Ep. 2006-08-25: Updated for FFX 3.x
def FFQ_heightDiff(char,target):
    if (Get_ObjectPos(target)[2] - Get_ObjectPos(char)[2] > 10) and (mlogreader.MLOG_IsFlying(target)==0):
        #print "target is on higher ground but not flying"
        return 1
    else:
        return 0




#---------------------------------------------
#---generic helpers---------------------------
#---------------------------------------------
#Note: other generic functions have been moved to the generalutils module

# exclude from a first string array any entry of the second array contained in the first
# characters of any entry of the first
# example:
# loadedTemplates=["eve_extra","minute_man_extra","mm_dupe"]
# disallowedTemplates=["minute_man"]
# allowedTemplates=[]
# allowedTemplates=excludeFrom(loadedTemplates,disallowedTemplates)
# will give
# allowedTemplates=["eve_extra","mm_dupe"]
def FFQ_excludeFrom(probeList,excludeList):
    reducedList=[]
    for probeEntry in probeList:
        for excludeEntry in excludeList:
            if string.find(probeEntry,excludeEntry) != 0:
                if excludeEntry == excludeList[-1]:
                    reducedList.append(probeEntry)
    return reducedList

# same, but more specific and useful: with names of active game objects as targets using templates as excludes 
def FFQ_excludeFromName(probeList,excludeList):
    reducedList=[]
    for probeEntry in probeList:
        for excludeEntry in excludeList:
            if string.find(Object_GetTemplate(probeEntry),excludeEntry) != 0:
                if excludeEntry == excludeList[-1]:
                    reducedList.append(probeEntry)
    return reducedList

# instead of excluding, allow only if from list
def FFQ_selectFrom(probeList,selectList):
    reducedList=[]
    for probeEntry in probeList:
        for selectEntry in selectList:
            if string.find(probeEntry,selectEntry) == 0:
                if selectEntry == selectList[-1]:
                    reducedList.append(probeEntry)
    return reducedList

# same, but more specific and useful: with names of active game objects as targets using templates as includes 
def FFQ_selectFromName(probeList,selectList):
    reducedList=[]
    for probeEntry in probeList:
        for selectEntry in selectList:
            if string.find(Object_GetTemplate(probeEntry),selectEntry) == 0:
                if selectEntry == selectList[-1]:
                    reducedList.append(probeEntry)
    return reducedList


# Convert a 3-element tuple of numbers to a string and vice-versa, rounded down to one decimal
# see also generalutils.sequenceToString() for a less specialized implementation
# Updated FFX 3.2: Made faster
def FFQ_tupleToString(value):
    return '%f %f %f'%(round(value[0],1), round(value[1],1), round(value[2],1))

def FFQ_stringToTuple(value):
    posList = []
    for v in string.split(value):
        posList.append(float(v))
    return tuple(posList)



#---------------------------------------------
#---object modification helpers---------------
#---------------------------------------------


# Reduce EP by a specified amount and return 1 if the character has no energy left
def FFQ_reduceEP(char,amount,minEnergy=0):
    ep = Object_GetAttr(char,'energyPoints')-amount
    if ep<0:
        ep=0
    Object_SetAttr(char,'energyPoints',ep)
    if ep > minEnergy:
        return 0
    else:
        return 1


# Allows to add or remove health safely by checking for minHealth and maxHealth.
# Added FFX 2.5
def FFQ_changeHP(char,amount):
    if Object_Exists(char):
        if Object_IsAlive(char):
            if (Object_GetAttr(char,'health') + amount) > Object_GetAttr(char,'maxHealth'):
                Object_SetAttr(char, 'health', Object_GetAttr(char,'maxHealth'))
                print "FFQ_changeHP(): %s has been fully healed"%(char)
            elif (Object_GetAttr(char,'health') + amount) < Object_GetAttr(char,'minHealth'):
                Object_SetAttr(char, 'health', Object_GetAttr(char,'minHealth'))
                print "FFQ_changeHP(): %s has been K.O'ed"%(char)
            else:
                Object_SetAttr(char, 'health', Object_GetAttr(char,'health')+amount)
        else:
            print "FFQ_changeHP(): %s was already K.O'ed"%(char)
    else:
        print "FFQ_changeHP(): %s cannot be found"%(char)


# kills a character after x seconds
# Added FFX 2.5
def killLater(char, delay = 5.0):
    RegTimer('OnKillLater', delay, 0, char)

def OnKillLater(event):
    char = event.object
    cshelper.kill(char)
    print 'killLater:'
    print '    %s has been killed'%char


# IMPORTANT!: using the noFade() function is *very* *dangerous*: The game apparently checks if the object state = dead to determine the
# character's behaviour and eventually fade him. However, he is considered alive for Object_IsAlive() and possibly both alive and dead
# for RegDeath(). If some code checks for dead characters, it will return a false negative on a character under noFade()! If a persistent
# RegDeath() is set on character and you call noFade() on him, the game will stall!
# Bottom line: Don't use it.
# Prevents an already dead civilian, minion or police class character from fading, as the noFade object attribute doesn't work in FFvsTTR
# duration: if set to 0: infinite; if set to a positive value, character will start fading a few seconds after the time is up.
# To disable, set FFX_ObjectSetAttr(char, 'noFade', 0)
# (Note that the original Object_GetAttr(char, 'noFade') is left alone.
# Added 3201Ep3
def noFade(char, duration = 0):
    if not Object_Exists(char):
        print "noFade() fatal error:"
        print "    '%s' doesn't exist" % char
        return
    if Object_IsAlive(char):
        print "noFade() fatal error:"
        print "    '%s' is alive" % char
        return
    oclass = Object_GetClass(char)
    if not ((oclass & OC_CONTROLLABLE) == 0) & (( oclass & (OC_MINION | OC_POLICE | OC_CIVILIAN)) != 0):
        return
    FFX_ObjectSetAttr(char, 'noFade', 1)
    count = -1
    if duration > 0:
        count = ( int(duration) / 8 ) + 1 #characters start fading ~10 secs. after death
    RegTimer('OnNoFade', 0.1, count, char)

def OnNoFade(event):
    char = event.object
    count = event.user
    if not Object_Exists(char):
        return
    if Object_IsAlive(char):
        return
    if not FFX_ObjectGetAttr(char, 'noFade'):
        return
    Object_SetPrimaryState(char, PCSTATE_DEAD, 0, -1)
    Trigger_Move(char, 'lock')
    Object_SetPrimaryState(char, PCSTATE_DEAD, 0)
    Trigger_Move(char, 'unlock')
    if count != 0:
        RegTimer('OnNoFade', 8, count - 1, char)
    else:
        FFX_ObjectSetAttr(char, 'noFade', 0)
    

# Gives the character the selected secondary state.
# By default, duration is permanent. ADDED: duration set to 1000 secs, because flag isn't supposed to work,
# according to the scripting docs.
# To remove state, set duration to 0.
# cshelper default duration for states is usually 10.
#
# Updated in FFX 3.0
#
# Notes:
# -Irradiate and Acid Burn have a built-in set duration. This function doesn't attempt to work around that.
def setSecondaryState(char, state, duration = -1, shield = 0):
    if Object_IsAlive(char):
        returnedState = dictSecondaryStates(state)
        if shield == 0: #deals with most secondary states
            if duration < 0:
                Object_SetSecondaryState(char, returnedState, 1000, PERMANENT_STATE)
            elif duration == 0:
                Object_SetSecondaryState(char, returnedState, 0, REMOVE_STATE)
            else:
                Object_SetSecondaryState(char, returnedState, duration)
        else: #deals with active defense nullifying 
            removeShield(char, duration)

def isUnderSecondaryState(char, state):
    if not Object_Exists(char):
        return 0
    returnedState = dictSecondaryStates(state)
    if Object_GetSecondaryStates(char) == returnedState:
        return 1
    else:
        return 0

def dictSecondaryStates(state):
    stateFound = 0
    secondaryStates = [
    [SCSTATE_IRRADIATED,'irradiated','radiation'],
    [SCSTATE_BLIND,'blind'],
    [SCSTATE_HEXED,'hexed','hex'],
    [SCSTATE_ACID_BURNT,'acid','acid burn','acid burnt','acid burned','acidburn','acidburnt','acidburned','burnt','burned','burn'],
    [SCSTATE_ENERGIZED,'energized','energize','energise','energy','stun'],
    [SCSTATE_AREA_ENERGIZED,'area energized','area energize','area energise','area energy','area','unstable energy','boosted'],
    [SCSTATE_EMPATHY,'empathy','empathic'],
    [SCSTATE_DISPLACE_IMAGE,'displace image','displace','displaced'],
    [SCSTATE_INVISIBLE,'invisible','invisibility'],
    [SCSTATE_POWER_NULLIFICATION,'powernull','power null','power','null','powernullified','power nullified','nullified'],
    [SCSTATE_BUOYANT,'buoyant'],
    [SCSTATE_DEEP_SENSORED,'deep sensored','deepsensored'],
    [SCSTATE_POSSESSED,'possession','possess','possessed'],
    [SCSTATE_SPAWN,'spawn','possessor'],
    [SCSTATE_SPEED_DECREASED,'speed decrease','decrease'],
    [SCSTATE_SPEED_INCREASED,'speed increase','increase'],
    [SCSTATE_WEAKENED,'weaken','weakened'],
    [SCSTATE_ZOMBIE,'zombie','zombifie'],
    ]
    for aState in secondaryStates:
        for term in aState:
            if term == state:
                stateFound = aState[0]
                break
        if stateFound != 0:
            break
    if stateFound == 0:
        print "ERROR IN FFQ SECONDARY STATE HELPER: state %s not found"%(state)
    return stateFound


# Shorthands for the generic function above
# Changed FFX 3.0:
# -Added FFvsTTR states
# -Repaired is...() functions, as they were all broken...
# -Removed functions redundants with those done by Dr Mike

def setBuoyantState(char, duration = -1):
    setSecondaryState(char, 'buoyant', duration)

def isBuoyant(char):
    if not Object_Exists(char):
        return 0
    return Object_GetSecondaryStates(char) & SCSTATE_BUOYANT != 0

def setDeepSensoredState(char, duration = -1):
    setSecondaryState(char, 'deepsensored', duration)

def isDeepSensored(char):
    if not Object_Exists(char):
        return 0
    return Object_GetSecondaryStates(char) & SCSTATE_DEEP_SENSORED != 0

def setPossessionState(char, duration = -1):
    setSecondaryState(char, 'possession', duration)

def isPossessed(char):
    if not Object_Exists(char):
        return 0
    return Object_GetSecondaryStates(char) & SCSTATE_POSSESSED != 0

def setSpawnState(char, duration = -1):
    setSecondaryState(char, 'spawn', duration)

def isSpawn(char):
    if not Object_Exists(char):
        return 0
    return Object_GetSecondaryStates(char) & SCSTATE_SPAWN != 0

def setSpeedDecreaseState(char, duration = -1):
    setSecondaryState(char, 'decrease', duration)

def isSpeedDecreased(char):
    if not Object_Exists(char):
        return 0
    return Object_GetSecondaryStates(char) & SCSTATE_SPEED_DECREASED != 0

def setSpeedIncreaseState(char, duration = -1):
    setSecondaryState(char, 'increase', duration)

def isSpeedIncreased(char):
    if not Object_Exists(char):
        return 0
    return Object_GetSecondaryStates(char) & SCSTATE_SPEED_INCREASED != 0

def setWeakenState(char, duration = -1):
    setSecondaryState(char, 'weaken', duration)

# the FFvsTTR built-in state, not the FFX one...
def isWeakened(char):
    if not Object_Exists(char):
        return 0
    return Object_GetSecondaryStates(char) & SCSTATE_WEAKENED != 0

def setZombieState(char, duration = -1):
    setSecondaryState(char, 'zombie', duration)

def setInvisibleState(char, duration = -1):
    setSecondaryState(char, 'invisible', duration)

def isInvisible(char):
    if not Object_Exists(char):
        return 0
    return Object_GetSecondaryStates(char) & SCSTATE_INVISIBLE != 0

# Set shield = 1 to prevent use of an active defence for the duration
# Updated FFX 3.0
def setPowerNullState(char, duration = -1, shield = 0):
    setSecondaryState(char, 'powernull', duration, shield)

# removeShield(): see under BREACH section

# isBreached(): see under BREACH section
    
def setDisplaceImageState(char, duration = -1):
    setSecondaryState(char, 'displaced', duration)

def isDisplaced(char):
    if not Object_Exists(char):
        return 0
    return Object_GetSecondaryStates(char) & SCSTATE_DISPLACE_IMAGE != 0

# Notes:
# -Irradiate and Acid Burn have a built-in set duration. This function doesn't attempt to work around that.    
def setIrradiatedState(char, duration = -1):
    setSecondaryState(char, 'irradiated', duration)

def setBlindState(char, duration = -1):
    setSecondaryState(char, 'blind', duration)
        
def setHexedState(char, duration = -1):
    setSecondaryState(char, 'hexed', duration)

# Notes:
# -Irradiate and Acid Burn have a built-in set duration. This function doesn't attempt to work around that.       
def setAcidBurntState(char, duration = -1):
    setSecondaryState(char, 'acid', duration)

def setEmpathyState(char, duration = -1):
    setSecondaryState(char, 'empathy', duration)

def isEmpathic(char):
    if not Object_Exists(char):
        return 0
    return Object_GetSecondaryStates(char) & SCSTATE_EMPATHY != 0
        
def setEnergizedState(char, duration = -1):
    setSecondaryState(char, 'energized', duration)

def isStunEnergized(char):
    if not Object_Exists(char):
        return 0
    return Object_GetSecondaryStates(char) & SCSTATE_ENERGIZED != 0
        
def setAreaEnergizedState(char, duration = -1):
    setSecondaryState(char, 'area energized', duration)

def isAreaEnergized(char):
    if not Object_Exists(char):
        return 0
    return Object_GetSecondaryStates(char) & SCSTATE_AREA_ENERGIZED != 0


# set generic states; can't be detected
# cshelper default duration for states is usually 10.
# updated Rally (OBJSTATE_ATTACKBONUS) to take into account attackBonus... :P
def setGenericState(char, state, duration = -1):
    if Object_IsAlive(char):
        returnedState = dictGenericStates(state)
        if duration < 0:
            duration = 10000
        elif duration == 0:
            if returnedState == OBJSTATE_ATTACKBONUS:
                if Object_GetAttr(char, 'attackBonus') > 1: #illusions will have a negative bonus value to make them ineffective; this will not be overwritten
                    Object_SetAttr(char, 'attackBonus', 1)
                    Object_SetAttr(char, 'oldAttackBonus', 1)
            Object_SetGenericState(char, returnedState, 0, REMOVE_STATE)
        else:
            if returnedState == OBJSTATE_ATTACKBONUS:
                if Object_GetAttr(char, 'attackBonus') > 0: #illusions will have a negative bonus value to make them ineffective; this will not be overwritten
                    Object_SetAttr(char, 'attackBonus', 3)
                    Object_SetAttr(char, 'oldAttackBonus', 3)
            Object_SetGenericState(char, returnedState, duration)

def dictGenericStates(state):
    stateFound = 0
    genericStates = [
    [OBJSTATE_ELECTRIFIED,'electrified','super-charge'],
    [OBJSTATE_MOLECULAR_EXCITE,'molecular excite','excite','excited'],
    [OBJSTATE_ALTERED_STRUCTURE,'altered','altered structure','genetic damage','genetic','weakness detection','weakness'],
    [OBJSTATE_ATTACKBONUS,'attackbonus','attack bonus','rally'],
    [OBJSTATE_DENSITY_CHANGE,'density change','density max','max density','density'],
    ]
    for aState in genericStates:
        for term in aState:
            if term == state:
                stateFound = aState[0]
                break
        if stateFound != 0:
            break
    if stateFound == 0:
        print "ERROR IN FFQ GENERIC STATE HELPER: state %s not found"%(state)
    return stateFound

def setElectrifiedState(char, duration = -1):
    setGenericState(char, 'electrified', duration)

def setExcitedState(char, duration = -1):
    setGenericState(char, 'molecular excite', duration)
    
def setAlteredState(char, duration = -1):
    setGenericState(char, 'genetic damage', duration)

def setRalliedState(char, duration = -1):
    setGenericState(char, 'rally', duration)

def setDensityMaxState(char, duration = -1):
    setGenericState(char, 'density max', duration)

#make all heroes invulnerable
#1 to turn on, 0 to turn off
def FFQ_minHealthHeroes(state):
    heroes = cshelper.getAllHeroes()
    if state == 1:
        for hero in heroes:
            FFX_ObjectSetAttr(hero,'currentMinHealth',Object_GetAttr(hero,'minHealth'))
            Object_SetAttr(hero,'minHealth',Object_GetAttr(hero,'health'))
    elif state == 0:
        for hero in heroes:
            Object_SetAttr(hero,'minHealth',FFX_ObjectGetAttr(hero,'currentMinHealth'))
    else:
        print "error! FFQ_minHealthHeroes(): parameter must be 1 to activate or 0 to disable"


#---------------------------------------------
#---mission-related helpers-------------------
#---------------------------------------------

# remember the starting position of your heroes one second after the beginning of the mission
# 2.0
def FFQ_writeStartingPos():
    for hero in cshelper.getAllHeroes():
        startingPos = Get_ObjectPos(hero)
        startingPos = (round(startingPos[0],1),round(startingPos[1],1),round(startingPos[2],1))
        Mission_SetAttr('FFQ_startingPos_%s_x'%(hero),startingPos[0])
        Mission_SetAttr('FFQ_startingPos_%s_y'%(hero),startingPos[1])
        Mission_SetAttr('FFQ_startingPos_%s_z'%(hero),startingPos[2])

# returns the starting position tuple of the selected hero. If not found, return the (-1,-1,-1) tuple.
def FFQ_getStartingPos(hero):
    try:
        startingPos = (Mission_GetAttr('FFQ_startingPos_%s_x'%(hero)),Mission_GetAttr('FFQ_startingPos_%s_y'%(hero)),Mission_GetAttr('FFQ_startingPos_%s_z'%(hero)))
        print "starting position of %s was "%(hero),
        print startingPos
        return startingPos
    except:
        print "Starting position of '%s' not found. He probably wasn't there at the beginning of the mission."%(hero)
        return (-1,-1,-1)
    

# def FFQ_getMapSize():
#    Obsolete! Use Stumpy's datfile.Mission_GetMapExtents(MissionFileName='') for the *exact* map extents



# modified from original ArrowBaddie()
def arrowLastBaddie():
    baddies = cshelper.getAllBaddies()
    if len(baddies) == 1:
        cshelper.addArrow('arrow_baddie_'+baddies[0], baddies[0], delete = 1)

def arrowLastMinion():
    baddies = getAllMinions()
    if len(baddies) == 1:
        cshelper.addArrow('arrow_minion_'+baddies[0], baddies[0], colour = js.ARROW_YELLOW, delete = 1)

def arrowLastTeamMember(team = 2):
    theTeam = getAllTeamMembers(team)
    if len(theTeam) == 1:
        cshelper.addArrow('arrow_team%d_%s'%(team,theTeam[0]), theTeam[0], delete = 1)


# Get the character name as displayed to the user (ex: 'el_diablo' for the engine is displayed as 'el diablo')
# For use with Mission_StatusText(); won't work correctly for when using the print statement or FF's custom commands.
# Cf. alternate version beneath.
# Updated FFX 3.0:
# -strings.dat lookup now require @ as identifier
# Updated FFX 3.2:
# -simplified
def getCharDisplayName(char):
    return "@%s" % string.upper(FFX_GetTemplate(char))

# Get the character name as displayed to the user (ex: 'el_diablo' for the engine is displayed as 'el diablo')
# Slower than the above version, but should work when using the print statement or FF's custom commands.
# Added FFX 3.3 alpha
def getCharDisplayNameFromDAT(char):
    template = FFX_GetTemplate(char)
    if ( 'Campaign_FindDisplayString' in dir(datfiles) ) and datfiles.Campaign_FindDisplayString('%s_01'%template):
        return datfiles.Campaign_FindDisplayString('%s_01'%template)
    return string.capwords(template)

# since I had some problems with regDeaths(), here's a team-based alternative 
def teamRegDeath(function, team = 2):
    for teammate in getAllTeamMembers(team):
        cshelper.regDeath(teammate, function)        


# Relative orientation detection/conversion
# Added FFX 2.5

# Returns character orientation in radians (instead of the FF Object_GetOrientation()'s more esoteric format)
# EDIT: Useless! Object_GetOrientation() is broken
def FFQ_ObjectGetOrientation(char):
    return ffTypeToRadian(Object_GetOrientation(char)[1])

# accepts one number whose value is between -pi/2 and pi/2
# used with Object_GetOrientation(char)[1] or FFQ_ObjectGetOrientation(char)
# EDIT: Useless! Object_GetOrientation() is broken
def ffTypeToRadian(orientation):
    if orientation >= 0:
        orientation = orientation * 2
    else:
        orientation = (2 * pi) - (orientation * -4)
    return orientation

# angles are in radians
def get2DAngleBetweenObjects(char,target):
    a = (Get_ObjectPos(char)[0],Get_ObjectPos(char)[1])
    b = (Get_ObjectPos(target)[0],Get_ObjectPos(target)[1])
    return getAngleFromCoordinates(a,b)

def getAngleFromCoordinates(obj1,obj2):
    size = getSizesFromCoordinates(obj1,obj2)
    return getAngleFromWidthAndHeight(size)

def getSizesFromCoordinates(obj1,obj2):
    x = obj1[0] - obj2[0]
    y = obj1[1] - obj2[1]
    return (abs(x),abs(y))

def getAngleFromWidthAndHeight(size):
    if size[0] == 0: #both characters are on the same exact spot, or it's the same character
        return 0 #avoid a division by zero
    return math.atan(size[1] / size[0])


# Based on Dr Mike's distanceSq(), but ignores the Z-axis and requires positions instead of objects
# Added FFX 3.0
def distanceSqPos2D(pos1, pos2):
    diff=Vector_Sub(pos1,pos2)
    return diff[0]*diff[0]+diff[1]*diff[1]

# Returns the nearest (in 2D) corner of the map object; this point might or might not be reachable.
# (Note that the SkXMapInfo calipers info isn't used here, as it isn't reliable for interior maps.)
# Z-Axis value is returned, but it shouldn't be relied upon, as we're working from the bounding box's
# dimensions, not actual corners.
# Added FFX 3.3 alpha
def getNearestMapCorner(obj):
    objPos = Get_ObjectPos(obj)
    #datfiles.Mission_GetMapExtents() is more precise but doesn't work for the built-in maps,
    #which are zipped into missions.ff; in this case, use SkXMapInfo instead
    try:
        mapExtents = datfiles.Mission_GetMapExtents()
    except:
        mapExtents = ff.MapInfo['mapExtents']
    mapCorners = [(mapExtents[0], mapExtents[1], mapExtents[5]),
                  (mapExtents[0], mapExtents[4], mapExtents[5]),
                  (mapExtents[3], mapExtents[1], mapExtents[5]),
                  (mapExtents[3], mapExtents[4], mapExtents[5])]
    closest = 10000000
    closestCorner = (0,0,0)
    for c in mapCorners:
        dist = distanceSqPos2D(c, objPos)
        if dist < closest:
            closest = dist
            closestCorner = c
    return closestCorner

# Returns the edge/side position of the map nearest to the object, using getNearestMapCorner();
# cf. notes on this function.
# Added FFX 3.3 alpha
def getNearestMapSide(obj):
    objPos = Get_ObjectPos(obj)
    corner = getNearestMapCorner(obj)
    x = corner[0] - objPos[0]
    y = corner[1] - objPos[1]
    if x > y:
        return (objPos[0], corner[1], corner[2])
    #else:
    return (corner[0], objPos[1], corner[2])

# light sources detection
# used by stealthy attribute
# Added FFX 2.5
# Updated FFX 3.05 alpha
FFQ_LIGHTSOURCES = []

# see notes under stealthy attribute
def setLightSources():
    global FFQ_LIGHTSOURCES
    # note that 'lamp' and 'pat_park_lamp' templates are not included, since they're used only on daylight maps, i.e, without object light or level light sources
    lightSourceTemplates = [
        'blitz_shield_beams',
        'bonfire',
        'ffx_flames', #not a source of light in itself, but used only with fx
        'force_field_barrier',
        'ger_searchlight',
        'ger_streetlamp_night',
        'lava_trench',
        'nazihq_wall_lamp',
        'pat_neon_sign',
        'pat_neon_signanim_a',
        'pat_neon_signanim_b',
        'pat_neon_signanim_c',
        'pat_streetlight_night',
        'red_int_cauldron',
        'red_int_cauldron_massive',
        'red_int_latern_pole',
        'red_int_pedestal_light',
        'red_int_pumpkin_gate',
        'ro_generator',
        'ro_lantern_l',
        'spotlight',
        'streetlight',
        'streetlight_day',
        'streetlight_night',
        'torch_pole'
        ]
    for obj in Mission_GetObjects():
        if Object_GetTemplate(obj) in lightSourceTemplates:
            FFQ_LIGHTSOURCES.append(obj)

# returns light-emitting templates whose health is above 14 (light-emitting streetlights break under 15 health)
# or any existing bonfire
def getNearLightSources(char, dist):
    global FFQ_LIGHTSOURCES
    for obj in FFQ_LIGHTSOURCES:
        if Object_Exists(obj) and (cshelper.distance2D(Get_ObjectPos(char), Get_ObjectPos(obj)) < dist):
            if (Object_GetAttr(obj, 'health') > 14) or (Object_GetTemplate(obj) == 'bonfire'):
                return 1
            else:
                FFQ_LIGHTSOURCES.remove(obj)
    return 0


# ripped from FFX Telepathic Scan
# added FFX 2.5
def changeLight(duration = 5, iamb = -1, idir = -1, ircl = 0, igcl = 0, ibcl = 0):
    try:
        active = Mission_GetAttr('changeLightDuration')
    except:
        active = 0
    if active == 0:
        RegTimer('OnChangeLightUpdate', 0.01, 0)
    Mission_SetAttr('changeLightDuration', duration)
    #get any custom colours
    if iamb!=-1 or idir!=-1 or ircl!=0 or igcl!=0 or ibcl!=0:
        amb=iamb*0.01
        dir=idir*0.01
        rcl=ircl/255.0
        gcl=igcl/255.0
        bcl=ibcl/255.0
        a=Mission_GetAttr('ambientLevel')
        if iamb==-1:
            amb=a
        d=Mission_GetAttr('directLevel')
        if idir==-1:
            dir=d
        r=Mission_GetAttr('redsun')
        g=Mission_GetAttr('greensun')
        b=Mission_GetAttr('bluesun')
        if ircl==0 and igcl==0 and ibcl==0:
            colour=(r,g,b)
            ffx.FFX_Sun(Mission_GetAttr('angle1'),Mission_GetAttr('angle2'),amb,dir,colour)
        else:
            colour=(rcl,gcl,bcl)
            ffx.FFX_Sun(Mission_GetAttr('angle1'),Mission_GetAttr('angle2'),amb,dir,colour)
        Mission_SetAttr('ambientLevel',a)
        Mission_SetAttr('directLevel',d)
        Mission_SetAttr('redsun',r)
        Mission_SetAttr('greensun',g)
        Mission_SetAttr('bluesun',b)

def OnChangeLightUpdate(event):
    count=Mission_GetAttr('changeLightDuration')-1
    if count<=0:
        Mission_SetAttr('changeLightDuration',0)
        restoreSun()
        return
    Mission_SetAttr('changeLightDuration',count)
    RegTimer('OnChangeLightUpdate',1,0)


# play an FX at fixed intervals with full tracking on spine
# if repeat is set to a value greater than -1, the effect will repeat only x times after the first
# if the Object is a character, effect will stop on death
# Added FFX 2.5
def playRecurringEffect(obj, fxName, frequency = 5, repeat = -1):
    Object_SetAttr(obj, '%s_rFXHandle'%fxName, 1)
    RegTimer('OnPlayRecurringEffect', frequency, repeat, obj, fxName)

def OnPlayRecurringEffect(event):
    obj = event.object
    fxName = event.string
    frequency = event.float
    repeat = event.user
    print obj
    print fxName
    print frequency
    print repeat
    if Object_Exists(obj):
        if Object_GetAttr(obj, 'health') > 0:
            dontStop = Object_GetAttr(obj, '%s_rFXHandle'%fxName)
            if dontStop != 0:
                Object_PlayEffect(obj, fxName, '', FX_TRACK_OBJECT_FULL, 0, 'Bip01 Spine')
                if repeat != 0:
                    if repeat > 0:
                        repeat = repeat - 1
                    RegTimer('OnPlayRecurringEffect', frequency, repeat, obj, fxName)

def stopRecurringEffect(obj, fxName):
    if Object_Exists(obj):
        Object_SetAttr(obj, '%s_rFXHandle'%fxName, 0)


# Can the character lift this object?
# "bonus" is a positive or negative integer added to strength for the comparison
# The sum of strength and bonus shouldn't be superior to 11. Any value higher will always return true
# Changed FFX 3.2: redone to use getMaxMassToLift(), which checks Heavy Lifter. Replaced hard-coded
# mass list with getMaxLiftableMasses(), as it's more exhaustive and has more than single-decimal precision. 
def hasStrengthToLift(char, target, bonus = 0):
    mass = Object_GetAttr(target, 'mass')
    if getMaxMassToLift(char, bonus) > mass:
        return 1
    else:
        return 0

# list of masses by strength level, ripped from Stumpy's Heavy Lifter code
# the following is from testing, accurate to within attribute storage precision
# Added FFX 3.2
def getMaxLiftableMasses():
    return [0, 16.666666, 94.2809, 259.807617, 533.3333, 931.694946, 1469.693726, \
                       2160.696777, 3016.98877, 4050, 5270.462402, 6688.526367, 8313.84375, \
                       10155.63574, 12222.74707, 14523.6875]

# What strength is the minimum to lift this object?
# Added FFX 3.2
def getRequiredStrengthToLift(object):
    mass = Object_GetAttr(object, 'mass')
    maxLiftableMasses = getMaxLiftableMasses()
    for max in maxLiftableMasses:
        if max > mass:
            return maxLiftableMasses.index(max)

# What is the maximum mass this character can lift?
# Heavy Lifter bonus is calculated.
# Added FFX 3.2
def getMaxMassToLift(char, bonus = 0):
    maxMass = getMaxLiftableMasses()
    str = int(Object_GetAttr(char, 'strength'))
    str = max(0, str + bonus) # characters sometimes have negative strength...
    if hasAttribute(char, 'heavylifter') or hasAttribute(char, 'heavy lifter'):
        str = str + 3
    if str > 15:
        print "hasStrengthToLift() non-fatal error:"
        print "    strength + bonus > 15 isn't supported. Setting strength to 15."
        str = 15
    return maxMass[str]


# creates a "tiggot" related to an existing character on a specified position and returns his name
# ripped from Telekinetic
def spawnTiggot(char, pos):
    count=FFX_ObjectGetAttr(char, 'tiggotCount')
    gcount=Mission_GetAttr('tigCount')
    tiggot='tig_%s_%d'%(char, count)
    Object_SpawnAt('ffx_tiggot', pos, tiggot)
    Object_SetAttr(tiggot, 'speed', 500)
    initmindless(tiggot)
    initironjaw(tiggot)
    FFX_ObjectSetAttr(char, 'tiggotCount', count + 1)
    Object_SetAttr(tiggot,'ID', gcount)
    Mission_SetAttr('tigCount', gcount + 1)
    return tiggot


# Replaces the never-implemented command of the same name in the FF scripting manual. (Note that this becomes more important in FFvsTTR,
# because we can spawn customs and because they then retain their template name instead of being renamed to 'custom_xxx_nn'.)
# Given object name, returns non zero if it is a custom hero, otherwise returns 0.
# Added FFX 3.2
# stumpy 2006-08-26: easier with direct reference to 'isCustom' key 
def Object_IsCustomChar(char):
    return GetCharacterData(char).get('isCustom')


# Returns 1 if attribute exists (even if its value is zero), 0 otherwise
# Added FFX 2.5
def FFX_ObjectHasAttr(char,name):
    try:
        hasAttr = Mission_GetAttr('%s_%s'%(char,name))
        return 1
    except:
        return 0


# Teleport an object (including a character, of course) to a position. The object will conserve its current heading
# (i.e., the second number from the Object_GetOrientation(object) tuple), unless you set heading= to a non-zero value.
# Added FFX 3.2. This is similar to FFX_Teleport(), except that a single marker is used and that object orientation
# is preserved and modifiable.
def teleportToPos(char, pos, heading=0):
    if heading == 0:
        heading = Object_GetOrientation(char)[1]
    if not Marker_Exists('teleportToPosMarker'):
        Marker_Spawn('teleportToPosMarker', pos, heading)
    else:
        Marker_SetPos('teleportToPosMarker', pos, heading)
    js.Object_MoveToMarker(char, 'teleportToPosMarker')


# Returns the name of a marker which can be reused to avoid creating different markers every time you need one.
# Added FFX 3.2
def useMarkerAtPos(pos, heading=0):
    if not Marker_Exists('useAtPosMarker'):
        Marker_Spawn('useAtPosMarker', pos, heading)
    else:
        Marker_SetPos('useAtPosMarker', pos, heading)
    return 'useAtPosMarker'


######### Mission_CustomAction(), Mission_RemoveCustomAction() and Mission_ClearCustomActions() replacements
# Rationale: Prevents duplicate custom commands for persistent custom actions and allows to know the existing commands
# by checking WRAPPER_REGISTERED_CUSTOM_COMMANDS.

WRAPPER_REGISTERED_CUSTOM_COMMANDS = missionobjvar.Mission_GetVar('registeredCustomCommands', [])

# IMPORTANT: setting oneShot=1 prevent checking for duplicates. It is suggested that you use instead oneShot=0 and call
# FFQ_MissionRemoveCustomAction() manually in the resulting function. Ex.:
# FFQ_MissionCustomAction('CUSTOM_SAYHELLO', char, target, 'sayHelloWorld', 250, 0)
# def sayHelloWorld(target, char):
#     FFQ_MissionRemoveCustomAction(CUSTOM_SAYHELLO', char, target)
def FFQ_MissionCustomAction(actionName, heroFilter, objFilter, funcName, radius, oneShot):
    global WRAPPER_REGISTERED_CUSTOM_COMMANDS
    newCommand = (actionName, heroFilter, objFilter)   
    if oneShot or (not newCommand in WRAPPER_REGISTERED_CUSTOM_COMMANDS):
        WRAPPER_REGISTERED_CUSTOM_COMMANDS.append(newCommand)
        missionobjvar.Mission_SetVar('registeredCustomCommands', WRAPPER_REGISTERED_CUSTOM_COMMANDS)
        Mission_CustomAction(actionName, heroFilter, objFilter, funcName, radius, oneShot)

def FFQ_MissionRemoveCustomAction(actionName, heroFilter, objFilter):
    global WRAPPER_REGISTERED_CUSTOM_COMMANDS
    newCommand = (actionName, heroFilter, objFilter)
    if newCommand in WRAPPER_REGISTERED_CUSTOM_COMMANDS:
        WRAPPER_REGISTERED_CUSTOM_COMMANDS.remove(newCommand)
        missionobjvar.Mission_SetVar('registeredCustomCommands', WRAPPER_REGISTERED_CUSTOM_COMMANDS)
        Mission_RemoveCustomAction(actionName, heroFilter, objFilter)

def FFQ_MissionClearCustomActions():
    global WRAPPER_REGISTERED_CUSTOM_COMMANDS
    WRAPPER_REGISTERED_CUSTOM_COMMANDS = []
    missionobjvar.Mission_SetVar('registeredCustomCommands', [])
    Mission_ClearCustomActions()


#---------------------------------------------
#---built-in functions wrappers helpers
#---------------------------------------------
# Improved and moved to functionwrapper.py


#---------------------------------------------
#---identification helpers--------------------
#---------------------------------------------
# for the additional character states identification function, see "object modification functions" above

# warning! similarly to the cshelper functions, the is[Class] functions don't return 1 if true, but the class number
def isCharacter(object):
    if not Object_Exists(object):
        return 0
    return Object_GetClass(object) & (FFX_CHARACTER)

def isVillain(object):
    if not Object_Exists(object):
        return 0
    return Object_GetClass(object) & (js.OC_VILLIAN)

def isMinion(object):
    if not Object_Exists(object):
        return 0
    return Object_GetClass(object) & (js.OC_MINION)

def isPolice(object):
    if not Object_Exists(object):
        return 0
    return Object_GetClass(object) & (js.OC_POLICE)

def isCivilian(object):
    if not Object_Exists(object):
        return 0
    return Object_GetClass(object) & (js.OC_CIVILIAN)


# Tries to determine if the character is a clone of either a hero, a villain or a minion class character.
# Will not work on clones of same class characters generated by M25 scripted AIs if M25_DOUBLE_CLONE_HP,
# exceptif the character has the M25 clone attribute
# is set to 1 (which is the default value).
# Changed FFX 3.0:
# -baseMaxHealth now applies to template, not object
# Changed FFX 3.2:
# -now checks first if the character has been set as a clone by M25 AI
def isClone(obj):
    if m25ai.AIIsClone(obj):
        return 1
    clone = 0
    if isEvilClone(obj) or isHeroClone(obj):
        clone = 1
    elif isMinion(obj) or isPolice(obj) > 0:
        possibleMatrixes = cshelper.getAll(Object_GetTemplate(obj))
        possibleMatrixes.remove(obj)
        if FFX_TemplateGetAttr(obj,'baseMaxHealth'): # used by the Deathwish attribute, which plays with maxHealth
            minimumMatrixHealth = FFX_TemplateGetAttr(obj,'baseMaxHealth') * 2
        else:
            minimumMatrixHealth = Object_GetAttr(obj,'maxHealth') * 2
        for possibleMatrix in possibleMatrixes:
            if FFX_TemplateGetAttr(obj,'baseMaxHealth'):
                maximumMatrixHealth = FFX_TemplateGetAttr(possibleMatrix,'baseMaxHealth')
            else:
                maximumMatrixHealth = Object_GetAttr(possibleMatrix,'maxHealth')
            if minimumMatrixHealth <= maximumMatrixHealth:
                clone = 1
                break
    return clone

# Is the character a clone of a VILLAIN template?
# Note that clones of MINIONS won't register here!
# modified FFX 2.5; skirmish customs won't cause an unhandled exception anymore
def isEvilClone(obj):
    if not Object_Exists(obj):
        return 0
    clone = 0
    try:
        if Template_GetClassString(Object_GetTemplate(obj)) == "GAME_OBJ_VILLIAN":
            if isMinion(obj) > 0:
                clone = 1
    except:
        clone = isEvilCloneAlternate(obj)
    return clone

# much slower, but works in skirmish; isEvilClone(obj) will automatically use this function in skirmish
def isEvilCloneAlternate(char):
    clone = 0
    if isMinion(char) > 0:
        villains = []
        for object in Mission_GetDynamicObjects():
            if Object_IsAlive(object) and isVillain(object):
                    villains.append(object)
        for currentVillain in villains:
            if Object_GetTemplate(currentVillain) == Object_GetTemplate(char):
                clone = 1
                break
    return clone

# Is the character a clone of a HERO template?
# Note that clones of POLICES won't register here!
# added FFX 2.5
def isHeroClone(obj):
    if not Object_Exists(obj):
        return 0
    clone = 0
    try:
        if Template_GetClassString(Object_GetTemplate(obj)) == "GAME_OBJ_HERO":
            if isPolice(obj) > 0:
                clone = 1
    except:
        clone = isHeroCloneAlternate(obj)
    return clone

# much slower, but works in skirmish; isHeroClone(obj) will automatically use this function in skirmish
def isHeroCloneAlternate(char):
    clone = 0
    if isPolice(char) > 0:
        heroes = []
        for object in Mission_GetDynamicObjects():
            if Object_IsAlive(object) and isPolice(object):
                    heroes.append(object)
        for currentHero in heroes:
            if Object_GetTemplate(currentHero) == Object_GetTemplate(char):
                clone = 1
                break
    return clone

# is the character a lure?
# added FFX 3.2
def isLure(obj, char=''):
    if not Object_Exists(obj):
        return 0
    return Object_GetTemplate(obj) in ('black_jack_image', 'standard_image_projection') #please update as needed

# is the character a special FFX object?
# added FFX 3.2
def isSpecialChar(obj, char=''):
    if not Object_Exists(obj):
        return 0
    return FFX_GetTemplate(obj) in ('ffx_tiggot', 'ffx_tiggot1', '------------', '---Buddies---',) #please update as needed

# is the object a powerup/canister?
# added FFX 3.2
def isPowerup(obj, char=''):
    if not Object_Exists(obj):
        return 0
    return Object_GetClass(obj) & OC_POWERUP > 0

# are the 2 characters on the same side (both good or evil)?
def FFQ_isSameSide(char,obj):
    theUser=FFQ_isSide(char)
    theTarget=FFQ_isSide(obj)
    sameSide=0
    if theUser==theTarget:
        sameSide=1
    return sameSide

# returns 1 for minions & villains / team 2 or more
def FFQ_isSide(subject):
    badGuy=0
    if Object_Exists(subject):
        if usingM25AI():
            if m25ai.GetTeamsReaction(m25ai.GetTeam(subject),m25ai.TEAM_GOODGUYS)==m25ai.TEAM_ENEMIES:
                #print 'M25 evil! - again, M25 is not evil'
                badGuy=1
        else:
            if ((Object_GetClass(subject)&OC_MINION)!=0) | ((Object_GetClass(subject)&OC_VILLIAN)!=0):
                #print 'standard evil!'
                badGuy=1
    return badGuy

# assigns the character to a team even if not using M25AI
# returns the team
# Changed FFX 3.05 alpha: new version added back in FFX
###! Dr, I hope the new version is kasher with M25 new AI system, because Empathic Friendship depends on this 
def FFQ_forceTeam(char):
    if not (usingM25AI() or (m25ai.GetTeam(char) > 0)):
        m25ai.SetDefaultTeam(char)
    return m25ai.GetTeam(char)


#---------------------------------------------
#---get array by type and other get helpers---
#---------------------------------------------

# Changed FFX 3.2: added the possibility of ignoring special characters such as tiggots
# checkLiving: if at 1, k.o.'ed characters won't be returned
# lures: if set to 1, lures will be returned among the characters
# specialCharacters: if set to 0, tiggots, etc., won't be returned
def getAllCharacters(checkLiving = 1, lures = 0, specialCharacters = 1):
    chars = []
    for object in Mission_GetDynamicObjects():
        if isCharacter(object):
            if (checkLiving and Object_IsAlive(object)) or (checkLiving == 0):
                specialChar = isSpecialChar(object)
                lure = isLure(object)
                if  ( (specialCharacters and specialChar) or (specialChar == 0) ) \
                and ( (lures and lure) or (lure == 0) ):
                    chars.append(object)
    return chars

# New FFX 3.3: find all characters which are exiled and invisible;
# characters which are image displaced and invisble are not returned
# checkLiving: if at 1, k.o.'ed characters won't be returned
# lures: if set to 1, lures will be returned among the characters
# specialCharacters: if set to 0, tiggots, etc., won't be returned
def getAllDisabledCharacters(checkLiving = 1, lures = 0, specialCharacters = 1):
    chars = []
    for object in getAllCharacters(checkLiving, lures, specialCharacters):
        if ( Object_GetSecondaryStates(object) & SCSTATE_INVISIBLE ) and ( Object_GetPrimaryState(object) == PCSTATE_EXILE ):
            chars.append(object)
    return chars

# modified FFX 2.5; you can now choose to ignore clones of villains by setting the argument clones = 0
# also corrected a stupid indent error
def getAllVillains(checkLiving = 1, clones = 1):
    villains = []
    for object in Mission_GetDynamicObjects():
        if (checkLiving and Object_IsAlive(object)) or (checkLiving == 0):
            #consider clones of villains such as Deja Vu as villains rather than minions
            if isVillain(object) or (clone == 1 and isEvilClone(object)):
                villains.append(object)
    return villains

# modified FFX 2.5; you can now choose to include clones of villains by setting the argument clones = 1
def getAllMinions(checkLiving = 1, clones = 0):
    minions = []
    for object in Mission_GetDynamicObjects():
        if (checkLiving and Object_IsAlive(object)) or (checkLiving == 0):
            if isMinion(object):
                #disallow clones of villains such as Deja Vu
                if (isEvilClone(object) == 0) or (clones == 1):
                    minions.append(object)
    return minions

def getAllPolices(checkLiving = 1):
    polices = []
    for object in Mission_GetDynamicObjects():
        if isPolice(object):
            if (checkLiving and Object_IsAlive(object)):
                polices.append(object)
    return polices

# Changed FFX 3.2: optimized code; special characters are now ignored
def getAllGoodGuys(checkLiving = 1, lures = 0):
    goodguys = []
    for object in getAllCharacters(checkLiving = 1, lures = 1, specialCharacters = 0):
        if isPolice(object) or cshelper.isHero(object):
            goodguys.append(object)
    return goodguys

#same as CSHelper, but checks if alive
#changed FFX 3.0: ffq_civilian_disguise template is ignored
def FFQ_getAllCivilians(checkLiving = 1):
    civilians = []
    for object in Mission_GetDynamicObjects():
        if isCivilian(object) and (Object_GetTemplate(object) != 'ffq_civilian_disguise'):
            if (checkLiving and Object_IsAlive(object)):
                civilians.append(object)
    return civilians

#same as CSHelper, but checks if alive
# Changed FFX 3.0: by default, limey lures are ignored
def FFQ_getAllHeroes(checkLiving = 1, lures = 0):
    heroes = []
    for object in Mission_GetDynamicObjects():
        if isHero(object):
            if Object_GetTemplate(object) == 'standard_image_projection':
                if lures:
                    heroes.append(object)
            elif (checkLiving and Object_IsAlive(object)):
                heroes.append(object)
    return heroes

#get all characters of the corresponding FFX voice-based "gender"
# Changed FFX 3.0: by default, limey lures are ignored
#parameter needs to be one of:
##FFX_GENDER_UNKNOWN=-1
##FFX_GENDER_OPPOSITE=0
##FFX_GENDER_MALE=1
##FFX_GENDER_FEMALE=2
##FFX_GENDER_ANIMAL=3
##FFX_GENDER_ROBOT=4
##FFX_GENDER_ALIEN=5
##FFX_GENDER_GOOD=0
##FFX_GENDER_EVIL=32
def getAllByGender(sex, lures = 0):
    allOfGender = []
    for obj in Mission_GetDynamicObjects():
        if (Object_GetClass(obj) & FFX_CHARACTER):
            if sex == getGender(obj):
                if lures == (Object_GetTemplate(object) == 'standard_image_projection'):
                    allOfGender.append(obj)
    return allOfGender

# Changed FFX 3.0: by default, limey lures are ignored IF team tagging is not enabled.
# (If team tagging is enabled, lures are part of team 0, like civilians and special objects.)
def getAllTeamMembers(team = 2, checkLiving = 1, lures = 0):
    theTeam = []
    if usingM25AI():
        for char in getAllCharacters(checkLiving):
            if m25ai.GetTeam(char) == team:
                theTeam.append(char)
    else: #if we're playing the standard campaign and not using teams, use the basic ally detection instead
        if team == 0:
            theTeam = FFQ_getAllCivilians(checkLiving) #curently, this ignores special types which are also marked as team 0 in M25 mode
        elif team == 1:
            theTeam = getAllGoodGuys(checkLiving, lures)
        else:
            theTeam = cshelper.getAllBaddies(checkLiving)
    return theTeam

# finds all others charaters on the same M25 AI team as the selected character
# or, if not using M25 AI, the members of the same side (hero/police vs villain/minion0.
# Added FFX 3.2 alpha
def getAllTeammates(char, checkLiving = 1, lures = 0):
    teammates = []
    charTeam = m25ai.GetTeam(char)
    for teammate in getAllTeamMembers(charTeam, checkLiving, lures):
        if teammate != char:
                teammates.append(teammate)
    return teammates

# hacked from cshelper.getNearestHero()
# Changed FFX 3.0:
# -by default, limey lures are ignored IF team tagging is not enabled.
#  (If team tagging is enabled, lures are part of team 0, like civilians and special objects.)
# -Patched a few bugs...
def getNearestTeammate(char, checkLiving = 1, lures = 0):
    minDistance = pow(10,6)
    friendlyTarget = ''
    charTeam = m25ai.GetTeam(char)
    for teammate in getAllTeamMembers(charTeam, checkLiving, lures):
        if teammate != char:
            pos1 = Get_ObjectPos(char)
            pos2 = Get_ObjectPos(teammate)
            vector = Vector_Sub(pos1, pos2)
            distance = sqrt(vector[0] * vector[0] + vector[1] * vector[1] + vector[2] * vector[2])
            if distance < minDistance:
                minDistance = distance
                friendlyTarget = teammate
    return friendlyTarget

# finds the nearest character from any enemy team; to search for a specific team
# (other than the 0 one), set the team = x variable
# Changed FFX 3.0: by default, limey lures are ignored IF team tagging is not enabled.
# (If team tagging is enabled, lures are part of team 0, like civilians and special objects.)
def getNearestAdversary(char, checkLiving = 1, team = -1, lures = 0):
    minDistance = pow(10,6)
    target = ''
    for adversary in getAllAdversaries(char, checkLiving, team, lures):
        pos1 = Get_ObjectPos(char)
        pos2 = Get_ObjectPos(adversary)
        vector = Vector_Sub(pos1, pos2)
        distance = sqrt(vector[0] * vector[0] + vector[1] * vector[1] + vector[2] * vector[2])
        if distance < minDistance:
            minDistance = distance
            target = adversary
    return target

# finds the nearest static or dynamic vehicle; tanks are ignored
# Added FFX 2.5
def getNearestVehicle(char):
    minDistance = pow(10,6)
    car = ''
    objects = js.Mission_GetDynamicObjects()
    for object in objects:
        objclass = js.Object_GetClass(object)
        if (objclass & js.OC_VEHICLE):
            pos1 = Get_ObjectPos(char)
            pos2 = Get_ObjectPos(object)
            vector = Vector_Sub(pos1, pos2)
            distance = sqrt(vector[0] * vector[0] + vector[1] * vector[1] + vector[2] * vector[2])
            if distance < minDistance:
                minDistance = distance
                car = object
    return car

# finds the nearest object or character, projectiles excepted
# Added FFX 3.2
def getNearestObject(char):
    minDistance = pow(10,6)
    nearestObj = ''
    #Prevent the map itself (whose template is '') from appearing in that list
    objects = list( Mission_GetObjects() )
    objects.remove( Object_GetTerrain() )
    for object in objects:
        if (Object_GetTemplate(object) != 'projectile_standin') and (object != char):
            pos1 = Get_ObjectPos(char)
            pos2 = Get_ObjectPos(object)
            vector = Vector_Sub(pos1, pos2)
            distance = sqrt(vector[0] * vector[0] + vector[1] * vector[1] + vector[2] * vector[2])
            if distance < minDistance:
                minDistance = distance
                nearestObj = object
    return nearestObj

# finds the nearest projectile
# Added FFX 3.2
# stumpy 2006-08-26: A couple efficiency tweaks: 
#   1) save some compute time using distance squared, which sorts the same 
#   2) the char's pos doesn't change, so keep it outside the loop and compute 
#   it just once.  
def getNearestProjectile(char):
    minDistance = pow(10,6)
    projectile = ''
    objects = js.Mission_GetDynamicObjects()
    pos1 = Get_ObjectPos(char) 
    for object in objects:
        if Object_GetTemplate(object) == 'projectile_standin':
            pos2 = Get_ObjectPos(object)
            vector = Vector_Sub(pos1, pos2)
            distance = vector[0] * vector[0] + vector[1] * vector[1] + vector[2] * vector[2]
            if distance < minDistance:
                minDistance = distance
                projectile = object
    return projectile

# finds nearby projectiles
# Added FFX 3.2
def getNearProjectiles(object, radius):
    radsqr = radius*radius
    projectiles = []
    objects = js.Mission_GetDynamicObjects()
    for object in objects:
        if Object_GetTemplate(object) == 'projectile_standin':
            projectiles.append(object)
    results = []
    pos2 = Get_ObjectPos(object)
    for proj in projectiles:
        pos1 = Get_ObjectPos(proj)
        vector = Vector_Sub(pos1, pos2)
        distance = vector[0] * vector[0] + vector[1] * vector[1] + vector[2] * vector[2]
        if distance <= radsqr:
            results.append(proj)
    return results


# Among the projectiles near the character, gets the one(s) which might have been fired by him?
# Notes:
# - This is strictly heuristic (i.e., guess); it might get both false negatives and false positives.
#   As such, this should be used only on projectiles which have just
#   been fired before the character has a chance to do another move.
# - To be more effective, this would need to add face (of char) to back (of projectile) and parallel
#   (side-by-side + flying shooter above/ground shooter below) shooting (maybe using comparative getMyProbableProjectiles())
# - Hooks in MLOG('ranged') or MLOG('controller') could be combined with it to make that function to make it much more accurate.
# Added FFX 3.2
def getMyProbableProjectiles(char, radius='200', deviation = (1.5, 0.09, 0.2)):
    nearProjectiles = getNearProjectiles(char, radius)
    myProjectiles = []
    charOrient = Object_GetOrientation(char)
    for np in nearProjectiles:
        print np
        npOrient = Object_GetOrientation(np)
        print charOrient
        print npOrient
        if (abs(charOrient[0] - npOrient[0]) < deviation[0]) and (abs(charOrient[1] - npOrient[1]) < deviation[1]) and (abs(charOrient[2] - npOrient[2]) < deviation[2]):
            print "myprojectile"
            myProjectiles.append(np)
    if len(myProjectiles) > 1:
        myProjectiles = sortByDistance(char, myProjectiles)
    return myProjectiles


# finds near characters from any enemy team; to search for a specific team
# (other than the 0 one), set the team = x variable 
# adaptated from cshelper getNearBaddies
# Changed FFX 3.0: by default, limey lures are ignored IF team tagging is not enabled.
# (If team tagging is enabled, lures are part of team 0, like civilians and special objects.)
def getNearAdversaries(object, radius, checkLiving = 1, team = -1, lures = 0):
    adversaries = getAllAdversaries(object, checkLiving, team, lures)
    results = []
    for adversary in adversaries:
        pos1 = Get_ObjectPos(adversary)
        pos2 = Get_ObjectPos(object)
        vector = Vector_Sub(pos1, pos2)
        distance = sqrt(vector[0] * vector[0] + vector[1] * vector[1] + vector[2] * vector[2])
        if distance <= radius:
            results.append(adversary)
    return results


# finds all characters from any enemy team; to search for a specific team
# (other than the 0 one), set the team = x variable
# Changed FFX 3.0: by default, limey lures are ignored IF team tagging is not enabled.
# (If team tagging is enabled, lures are part of team 0, like civilians and special objects.)
def getAllAdversaries(char, checkLiving = 1, team = -1, lures = 0):
    adversaries = []
    if usingM25AI():
        charTeam = m25ai.GetTeam(char)
        for someone in getAllCharacters():
            someoneTeam = m25ai.GetTeam(someone)        
            if someoneTeam != 0:
                if someoneTeam != charTeam:
                    if (team == someoneTeam) or (team == -1):
                        adversaries.append(someone)
    else: #if we're playing the standard campaign and not using teams, use the basic enemy detection instead
        adversaries = getAllEnemies(char, checkLiving, lures)
    return adversaries

# finds either all other heroes & polices for heroes & polices classes or all other villains & minions for villains & minions
# to include the calling character himself in the list, set removeObject = 0
# Changed FFX 3.0: by default, limey lures are ignored
def getAllAllies(object, checkLiving = 1, removeObject = 1, lures = 0):
    if FFQ_isSide(object):
        allies = cshelper.getAllBaddies(checkLiving)
    else:
        allies = getAllGoodGuys(checkLiving, lures)
    if removeObject == 1:
        if allies.count(object) > 0:
            allies.remove(object)
    return allies


# finds near allies
# adaptated from cshelper getNearBaddies
# Changed FFX 3.0: by default, limey lures are ignored
def getNearAllies(object, radius, checkLiving = 1, lures = 0):
    allies= getAllAllies(object, checkLiving, 1, lures)
    results = []
    for ally in allies:
        pos1 = Get_ObjectPos(ally)
        pos2 = Get_ObjectPos(object)
        vector = Vector_Sub(pos1, pos2)
        distance = sqrt(vector[0] * vector[0] + vector[1] * vector[1] + vector[2] * vector[2])
        if distance <= radius:
            results.append(ally)
    return results


# finds either all other villains & minions for heroes & polices classes or all other heroes & polices for villains & minions
# Changed FFX 3.0: by default, limey lures are ignored
def getAllEnemies(object, checkLiving = 1, lures = 0):
    if FFQ_isSide(object):
        enemies = getAllGoodGuys(checkLiving, lures)
    else:
        enemies = cshelper.getAllBaddies(checkLiving)
    return enemies


# finds near enemies
# adaptated from cshelper getNearBaddies
# Changed FFX 3.0: by default, limey lures are ignored
def getNearEnemies(object, radius, checkLiving = 1, lures = 0):
    enemies= getAllEnemies(object, checkLiving, lures)
    results = []
    for enemy in enemies:
        pos1 = Get_ObjectPos(enemy)
        pos2 = Get_ObjectPos(object)
        vector = Vector_Sub(pos1, pos2)
        distance = sqrt(vector[0] * vector[0] + vector[1] * vector[1] + vector[2] * vector[2])
        if distance <= radius:
            results.append(enemy)
    return results


# finds near civilians, except ffq_civilian_disguise template
# added FFX 3.0
def getNearCivilians(object, radius, checkLiving = 1):
    civs= FFQ_getAllCivilians(checkLiving)
    results = []
    for civ in civs:
        pos1 = Get_ObjectPos(civ)
        pos2 = Get_ObjectPos(object)
        vector = Vector_Sub(pos1, pos2)
        distance = sqrt(vector[0] * vector[0] + vector[1] * vector[1] + vector[2] * vector[2])
        if distance <= radius:
            results.append(civ)
    return results    

# Tries to guess the 2D position of an object in x seconds.
# Can also be used to guess the facing of a MOVING object.
# Results can be read after 0.1 sec. by using the following commands:
#     FFX_ObjectGetAttr(obj,'guessedPos_x')
#     FFX_ObjectGetAttr(obj,'guessedPos_y'
#
# IMPORTANT:
# -there is a 0.1 second delay between the time the function is called and the time a value is returned
# -z coordinate isn't given, since future value can't be estimated correctly
#
# Added in FFX 2.5
def guessObjectDest(obj, time):
    if time < 0.1:
        print "invalid time parameter: value must be at least 0.1"
        return
    if not Object_Exists(obj):
        print "%s doesn't exist anymore"%obj
        return
    initialPos = Get_ObjectPos(obj)
    FFX_ObjectSetAttr(obj,'guessedInitialPos_x', initialPos[0])
    FFX_ObjectSetAttr(obj,'guessedInitialPos_y', initialPos[1])
    RegTimer('OnGuessObjectDest', 0.1, time - 0.1, obj)

def OnGuessObjectDest(event):
    obj = event.object
    time = event.user
    if not Object_Exists(obj):
        print "%s doesn't exist anymore"%obj
        return
    x_initialPos = FFX_ObjectGetAttr(obj,'guessedInitialPos_x')
    y_initialPos = FFX_ObjectGetAttr(obj,'guessedInitialPos_y')
    currentPos = Get_ObjectPos(obj)
    x_guessedPos = 0
    y_guessedPos = 0
    # x
    x_distMoved = currentPos[0] - x_initialPos
    x_guessedDist = x_distMoved * time * 10 # * 10 because we're moving in 0.1 sec. increments
    x_guessedPos = currentPos[0] + x_guessedDist
    # y
    y_distMoved = currentPos[1] - y_initialPos
    y_guessedDist = y_distMoved * time * 10
    y_guessedPos = currentPos[1] + y_guessedDist
    FFX_ObjectSetAttr(obj, 'guessedPos_x', x_guessedPos)
    FFX_ObjectSetAttr(obj, 'guessedPos_y', y_guessedPos)


# Returns the nearest object to the reference object from a list or a list-generating function.
# If 2 results are nearest ex-aequo, only one is returned.
# Added FFX 2.5
# Changed FFX 3.2: returns an emplty string if the list is empty instead of throwing an exception.
def getNearestFromList(obj,listOfTargets):
    listOfTargetsDistances = []
    pos1 = Get_ObjectPos(obj)
    for target in listOfTargets:
        pos2 = Get_ObjectPos(target)
        vector = Vector_Sub(pos1, pos2)
        distance = sqrt(vector[0] * vector[0] + vector[1] * vector[1] + vector[2] * vector[2])
        listOfTargetsDistances.append(distance)
    if listOfTargetsDistances != []:
        lowest = min(listOfTargetsDistances)
        nearest = listOfTargetsDistances.index(lowest)
        return listOfTargets[nearest]
    else:
        return ''
 
# returns a list re-ordered by distance to an object from a list of targetm objects 
# Added FFX 3.2
def sortByDistance(obj, listOfTargets):
    minDistance = pow(10,6)
    newList = []
    nearestTarget = ''
    while len(listOfTargets) > 0:
        nearestTarget = getNearestFromList(obj, listOfTargets)
        del listOfTargets[listOfTargets.index(nearestTarget)]
        newList.append(nearestTarget)
    return newList





############ getTypeResistanceValue() and variants ##################

# Get the character's average resistance/weakness to a type of damage from his attributes and material,
# plus active and passive defences.
# Returns the damage multiplier (i.e. 1.0 if no resistance or weakness, 2.0 if weak, 4.0 if defenceless,
# 0.0 if completely impervious, 0.75 if somewhat resistant, etc.)
# Parameters:
# - passive=1 includes passive defences in the calculation
# - active=1 includes active defences
# - attribs=1 includes both FFX and built-in attributes
# - states=1 includes attributes (such as Tough Guy) which protect only against the state alteration part
#   of some damage types (ex. cold or radiation). This parameter has no effect when checking  state
#   alteration-only damage types.
# - material=1 includes the character's material inherent resistances
# Notes/bugs:
# - This detects only resistance to specific damage types. Attributes which allow to resist to multiple
#   damage types (such as Temporary Invulnerability or Body Aura) are ignored.
# - Adaptative attribute is ignored, since the actual resistances can't be determined.
# - Adaptative (active) attribute current resistances are detected correctly.
# - Characters suffering from non-Adaptative (active) genetic damage will report incorrect values,
#   as genetic damage can't be detected.
# - For active and passive defences, special attack type is ignored, since there is no in-game UI for
#   it. The resistance multiplier is based on the sum of each type of attack blocked. 
# - Since active defences are either on or off, their weight in the overall resistances is arbitrarily based
#   on duration, energy cost and number of levels purchased, in addition to the types of attacks blocked.
# - Only the first active and the first passive defences are detected.
# - Some defences may not be detected correctly with older version of chardata.py.
# - Powers are accounted only if they are starting attributes or have been purchased.

# - material 12: hidden material: dark matter
#   - defenseless against crushing, piercing, energy, fire, radiaton, electricity, acid and cold
#   - weak against mental and mystical
# - material 13: hidden material: ectoplasm
#   - defenseless against crushing, piercing, energy, electricity and acid
#   - weak against mental and mystical
#   - normal against fire, radiation and cold

def getCrushResistanceValue(char, passive=1, active=1, attribs=1, states=1, material=1):
    return getTypeResistanceValue(
        char,
        passive,
        active,
        attribs,
        states,
        material,
        damageType = datfiles.PT_DAMAGE_BLOCKED_CRUSH,
        attribTypes =      {'solid skeleton': 0.5,
                            'glass bones': 2.0,
                            },
        stateAttribTypes = {},
        matTypes = {1: 0.5,
                    2: 0.5,
                    3: 0.5,
                    5: 0.5,
                    6: 0.5,
                    8: 0.5,
                    10: 0.5,
                    12: 4.0,
                    13: 4.0,
                    },
        )


def getPierceResistanceValue(char, passive=1, active=1, attribs=1, states=1, material=1):
    return getTypeResistanceValue(
        char,
        passive,
        active,
        attribs,
        states,
        material,
        damageType = datfiles.PT_DAMAGE_BLOCKED_PIERCE,
        attribTypes =      {'armoured': 0.5,
                            'thin skinned': 2.0,
                            },
        stateAttribTypes = {'tough guy': 0.5,
                            'toughguy': 0.5,
                            },
        matTypes = {1: 0.5,
                    2: 0.25,
                    5: 0.5,
                    6: 0.5,
                    7: 0.5,
                    8: 0.25,
                    9: 0.5,
                    10: 4.0,
                    12: 4.0,
                    13: 4.0,
                    },
        )

def getEnergyResistanceValue(char, passive=1, active=1, attribs=1, states=1, material=1):
    return getTypeResistanceValue(
        char,
        passive,
        active,
        attribs,
        states,
        material,
        damageType = datfiles.PT_DAMAGE_BLOCKED_ENERGY,
        attribTypes =      {'strange visitor': 0.5,
                            'cosmic chump': 2.0,
                            },
        stateAttribTypes = {'tough guy': 0.5,
                            'toughguy': 0.5,
                            },
        matTypes = {1: 2.0,
                    5: 2.0,
                    6: 0.25,
                    7: 0.5,
                    9: 0.5,
                    10: 2.0,
                    12: 4.0,
                    13: 4.0,
                    },
        )

def getFireResistanceValue(char, passive=1, active=1, attribs=1, states=1, material=1):
    return getTypeResistanceValue(
        char,
        passive,
        active,
        attribs,
        states,
        material,
        damageType = datfiles.PT_DAMAGE_BLOCKED_FIRE,
        attribTypes =      {'temperature control': 0.5,
                            'volcanic': 0.5,
                            'heat sensitive': 2.0,
                            },
        stateAttribTypes = {},
        matTypes = {1: 0.5,
                    2: 0.5,
                    3: 2.0,
                    4: 0.25,
                    7: 2.0,
                    8: 0.5,
                    9: 4.0,
                    10: 2.0,
                    12: 4.0,
                    },
        )

def getElectricalResistanceValue(char, passive=1, active=1, attribs=1, states=1, material=1):
    return getTypeResistanceValue(
        char,
        passive,
        active,
        attribs,
        states,
        material,
        damageType = datfiles.PT_DAMAGE_BLOCKED_ELECTRICAL,
        attribTypes =      {'charged': 0.5,
                            'grounded': 2.0,
                            },
        stateAttribTypes = {},
        matTypes = {1: 4.0,
                    3: 0.25,
                    5: 2.0,
                    7: 0.5,
                    8: 0.5,
                    12: 4.0,
                    13: 4.0,
                    },
        )

def getRadiationResistanceValue(char, passive=1, active=1, attribs=1, states=1, material=1):
    return getTypeResistanceValue(
        char,
        passive,
        active,
        attribs,
        states,
        material,
        damageType = datfiles.PT_DAMAGE_BLOCKED_RADIATION,
        attribTypes =      {'radioactive': 0.25,
                            'invertebrate': 0.5,
                            'rapid metabolism': 2.0,
                            },
        stateAttribTypes = {'tough guy': 0.5,
                            'toughguy': 0.5,
                            'ironguts': 0.0,
                            },
        matTypes = {1: 0.5,
                    2: 0.5,
                    3: 2.0,
                    4: 0.5,
                    5: 2.0,
                    6: 0.5,
                    7: 2.0,
                    8: 0.5,
                    10: 0.25,
                    12: 4.0,
                    },
        )

def getAcidResistanceValue(char, passive=1, active=1, attribs=1, states=1, material=1):
    return getTypeResistanceValue(
        char,
        passive,
        active,
        attribs,
        states,
        material,
        damageType = datfiles.PT_DAMAGE_BLOCKED_ACID,
        attribTypes =      {'alkaline': 0.5,
                            'rapid metabolism': 2.0,
                            },
        stateAttribTypes = {'tough guy': 0.5,
                            'toughguy': 0.5,
                            'ironguts': 0.0,
                            },
        matTypes = {3: 2.0,
                    4: 0.5,
                    6: 0.5,
                    8: 0.5,
                    7: 2.0,
                    10: 2.0,
                    12: 4.0,
                    13: 4.0,
                    },
        )

def getColdResistanceValue(char, passive=1, active=1, attribs=1, states=1, material=1):
    return getTypeResistanceValue(
        char,
        passive,
        active,
        attribs,
        states,
        material,
        damageType = datfiles.PT_DAMAGE_BLOCKED_COLD,
        attribTypes =      {'hirsute': 0.5,
                            'cold blooded': 2.0,
                            'temperature control': 0.5,
                            },
        stateAttribTypes = {'tough guy': 0.5,
                            'toughguy': 0.5,
                            },
        matTypes = {3: 2.0,
                    4: 4.0,
                    7: 0.5,
                    9: 0.25,
                    12: 4.0,
                    },
        )

def getMentalResistanceValue(char, passive=1, active=1, attribs=1, states=1, material=1):
    return getTypeResistanceValue(
        char,
        passive,
        active,
        attribs,
        states,
        material,
        damageType = datfiles.PT_DAMAGE_BLOCKED_MENTAL,
        attribTypes =     {'cybernetic brain': 0.5,
                           'disciplined': 0.5,
                           'level headed': 0.5,
                           'levelheaded': 0.5,
                           'mindless': 0.5,
                           'tough guy': 0.5,
                           'toughguy': 0.5,
                           'weak minded': 2.0,
                           },
        stateAttribTypes = {},
        matTypes = {12: 2.0,
                    13: 2.0,
                    },
        )

def getMysticalResistanceValue(char, passive=1, active=1, attribs=1, states=1, material=1):
    return getTypeResistanceValue(
        char,
        passive,
        active,
        attribs,
        states,
        material,
        damageType = datfiles.PT_DAMAGE_BLOCKED_MYSTICAL,
        attribTypes =     {'level headed': 0.5,
                           'levelheaded': 0.5,
                           'tough guy': 0.5,
                           'toughguy': 0.5,
                           'unbeliever': 0.5,
                           'bedevilled': 2.0,
                           },
        stateAttribTypes = {},
        matTypes = {1: 0.5,
                    2: 2.0,
                    5: 0.5,
                    7: 2.0
                    },
        )

def getTypeResistanceValue(char, passive, active, attribs, states, material, damageType, attribTypes, stateAttribTypes, matTypes):
    vuln = 1.0
    charObject = chardata.GetCharacterData(char)
    #passive defences
    if passive:
        passiveD = chardata.Character_HasPassiveDefence(char, damageType, datfiles.PT_MELEE_BLOCKED)
        passiveD = passiveD + chardata.Character_HasPassiveDefence(char, damageType, datfiles.PT_RANGED_BLOCKED)
        passiveD = passiveD + chardata.Character_HasPassiveDefence(char, damageType, datfiles.PT_AREA_BLOCKED)
        passiveD = passiveD + chardata.Character_HasPassiveDefence(char, damageType, datfiles.PT_DIRECT_BLOCKED)
        vuln = vuln * (1.0 - (passiveD / 4.0))
    #active defences
    if active:
        # don't use Character_HasActiveDefence() since we need powerLevel, duration and ep cost
        activePower = []
        activePower = chardata.Character_GetPower(char, 'PowerType', datfiles.PT_ACTIVE_DEFENCE, 'DamageTypesBlocked', damageType)
        # let's assume that there is only one active defence for each damage type
        if len(activePower) > 0:
            # adjust for powerlevel/bought only
            activeLevel = charObject['powerLevels'][ activePower[0]['PowerName'] ]
            if activeLevel > 0:            
                activeD = 0
                attackModesBlocked = activePower[0]['AttackModesBlocked']
                for mode in (datfiles.PT_MELEE_BLOCKED, datfiles.PT_RANGED_BLOCKED, datfiles.PT_AREA_BLOCKED, datfiles.PT_DIRECT_BLOCKED):
                    if attackModesBlocked & mode:
                        activeD = activeD + 1
                activeD = activeD / 4.0
                epCost = activePower[0]['EPCost']
                costValue = (1.0, 0.75, 0.75, 0.75, 0.75, 0.5, 0.25, 0.1, 0.1) # gives an arbitrary value inverse to power cost; FFvsTTR valid costs are 0, 4, 5 and 6
                activeD = activeD * costValue[epCost]
                duration = activePower[0]['Duration']
                durationValue = (0.25, 0.5, 0.75, 1.0) # gives an arbitrary value proportional to power duration
                activeD = activeD * durationValue[duration]                
                activeLevel = (activeLevel - 1.0) * 0.05 + 1 # arbitrary 5 % bonus for every level above the first
                activeD = min(activeD * activeLevel, 1.0) # min() prevents getting negative vulnerability
                vuln = vuln * (1.0 - activeD)
    #attributes
    if attribs:
        adapted = FFX_ObjectGetAttr(char, 'adapted')
        for attr in attribTypes.keys():
            #using hasAttribute() instead of chardata to detect character-specific attributes (added or removed)
            if hasAttribute(char, attr):
                if adapted:
                    mult = 1 / max(attribTypes[attr],0.25)
                else:
                    mult = attribTypes[attr]
                vuln = vuln * mult
        #attributes modifying state alteration resistances
        if states:
            for attr in stateAttribTypes.keys():
                if hasAttribute(char, attr):
                    if adapted:
                        mult = 1 / max(stateAttribTypes[attr],0.25)
                    else:
                        mult = stateAttribTypes[attr]
                    vuln = vuln * mult
    #material
    if material:
        materialD = Object_GetAttr(char, 'material')
        for mat in matTypes.keys():
            if materialD == mat:
                vuln = vuln * matTypes[mat]
    return vuln


#---------------------------------------------
#---Pseudo Event_RegisterSinks helpers using timers
#---------------------------------------------    

# Detect secondary state changes
# uses FFvsTTR's new EVENT_CHARACTER_SEC_STATE_CHANGED, which has no cshelper wrapper.
# Added FFX 3.2
def regSecondaryState2(char, state, function, user = 0, string = '', persistent = 0):
    js.Event_RegisterSink(EVENT_CHARACTER_SEC_STATE_CHANGED, function, char, string, user, state, persistent)

# Detect secondary state change, because some secondary states don't register.
# Note: Please use regSecondaryState2() above instead, as it's faster, less quirky and offers more parameters.
# If regSecondaryState2() proves to support correctly all states, regSecondaryState() will be made obsolete.
# Added FFX 2.5
def regSecondaryState(char, state, function, time = 0.5, persistent = 0):
    """regSecondaryState(char, state, function, time = 0.5, persistent = 0)"""
    #if state is currently active, detect its absence and vice versa; created as an attribute because there's no free parameter left
    if isUnderSecondaryState(char, state):
        FFX_ObjectSetAttr(char,'regSecondaryStateOnOff',1)
    else:
        FFX_ObjectSetAttr(char,'regSecondaryStateOnOff',0)
    #persistence needs to be checked manually; otherwise, each time the state is checked to be the same, a new instance will be created
    if persistent > 0:
        FFX_ObjectSetAttr(char,'regSecondaryStatePersistent',1)
    else:
        FFX_ObjectSetAttr(char,'regSecondaryStatePersistent',0)
    Event_RegisterSink(EVENT_TIMER, 'OnSecondaryStateCheck', char, function, time, state, 0)

def OnSecondaryStateCheck(event):
    char = event.object
    function = event.string
    state = event.user
    time = event.float
    if isUnderSecondaryState(char, state) != FFX_ObjectGetAttr(char,'regSecondaryStateOnOff'):
        Event_RegisterSink(EVENT_TIMER, function, char, '', 0.05, 0, 0)
        if FFX_ObjectGetAttr(char,'regSecondaryStatePersistent'):
            Event_RegisterSink(EVENT_TIMER, 'OnSecondaryStateCheck', char, function, time, state, 0)
    else:
        Event_RegisterSink(EVENT_TIMER, 'OnSecondaryStateCheck', char, function, time, state, 0)


# Detect if a condition involving a variable or an attribute becomes true
def regCondition(char, condition, function, time = 0.5, user = 0,persistent = 0):
    #examples:
    """
    regCondition('hero_1', 'Object_GetAttr(char,"speed") > 3', 'functionName', time = 0.5, persistent = 0)
    regCondition('hero_2', 'FFX_ObjectGetAttr(char,"regSecondaryStateOnOff") == 1', 'functionName', time = 3, persistent = 1)
    regCondition('', 'FFQ_EP_DISGUISE != 50', 'functionName')
    """
    #persistence needs to be check manually; otherwise, each time the state is checked to be the same, a new instance will be created
    if persistent > 0:
        FFX_ObjectSetAttr(char,'regConditionPersistent',1)
    else:
        FFX_ObjectSetAttr(char,'regConditionPersistent',0)
    conditionPlusFunction = condition + ';' +function # 3 strings needed, only 2 available, so we merge these 2
    Event_RegisterSink(EVENT_TIMER, 'OnConditionCheck', char, conditionPlusFunction, time, user, 0)

def OnConditionCheck(event):
    char = event.object
    user = event.user
    time = event.float
    conditionPlusFunction = event.string
    conditionPlusFunctionList = string.split(conditionPlusFunction, ';')
    condition = conditionPlusFunctionList[0]
    function = conditionPlusFunctionList[1]
    answer = 0
    action = 'if ' + condition + ':answer=1'
    exec action
    if answer:
        Event_RegisterSink(EVENT_TIMER, function, char, '', 0.05, 0, 0)
        if FFX_ObjectGetAttr(char,'regConditionPersistent'):
            Event_RegisterSink(EVENT_TIMER, "OnConditionCheck", char, conditionPlusFunction, time, user, 0)
    else:
        Event_RegisterSink(EVENT_TIMER, "OnConditionCheck", char, conditionPlusFunction, time, user, 0)


# Alternative method for prolonged damage states
# Advantage:
# -doesn't use memory needlessly
# -no risk (?) of damage being triggered a second time before the function is called.
# Disadvantages:
# -slower
# -if the prolonged damage state isn't powerful enough to damage, it won't trigger the function;
# -also, if the character health gets higher, damage may not register. EDIT: repaired!
# Added FFX 2.5
def regAcidBurnt(char, function, user = 0, persistent = 0):
    Mission_SetAttr("%s_%s_acidPersistent"%(char, function), persistent)
    Event_RegisterSink(EVENT_OBJ_HEALTHCHANGED, 'OnRegAcidBurnt', char, function, 1000, user, 0) #persistence is managed manually 

def OnRegAcidBurnt(event):
    char = event.object
    user = event.user
    function = event.string
    persistent = Mission_GetAttr("%s_%s_acidPersistent"%(char, function))
    if (Object_GetSecondaryStates(char) & SCSTATE_ACID_BURNT) != 0:
        Event_RegisterSink(EVENT_TIMER, function, char, '', 0.05, user, 0)
        if persistent:
            regAcidBurnt(char, function, user, persistent)
    else:
        regAcidBurnt(char, function, user, persistent)

def regIrradiated(char, function, user = 0, persistent = 0):
    Mission_SetAttr("%s_%s_irradPersistent"%(char, function), persistent)
    Event_RegisterSink(EVENT_OBJ_HEALTHCHANGED, 'OnRegIrradiated', char, function, 1000, user, 0) #persistence is managed manually 

def OnRegIrradiated(event):
    char = event.object
    user = event.user
    function = event.string
    persistent = Mission_GetAttr("%s_%s_irradPersistent"%(char, function))
    if (Object_GetSecondaryStates(char) & SCSTATE_IRRADIATED) != 0:
        Event_RegisterSink(EVENT_TIMER, function, char, '', 0.05, user, 0)
        if persistent:
            regIrradiated(char, function, user, persistent)
    else:
        regIrradiated(char, function, user, persistent)


# Pseudo-event registration of new characters. This has a latency of up to 1.0 sec.
# Spawned characters' FFX attributes initialisation is started before this event is fired.
# Calling regCharacterInitialized() from def OnPostInit() should register characters present at startup.
# You should use only one of the three following parameters: object, template and objectClass.
# To detect any new character, leave all three parameters 
# Note that your registered function will still have to check whether the character should be processed or not
# (i.e, is it a special hidden object such as a tiggot, disguise, etc.)
# Added FFX 3.2
# stumpy 2006-09-25: I've renamed the 'spawned' parts of these functions and 
# variable to initialized, to avoid confusing with the spawn sinks in mlogreader.
CHAR_INITIALIZED_EVENT = 504  # some arbitrary value

# code ripped off Stumpy's mlogreader.regAnimation()
def regCharacterInitialized(fn, object = '', template = '', objectClass = 0, persistent = 0, float = 0, user = 0, string = ''):
    callbacks = missionobjvar.Mission_GetVar('EVENT_CHARINITIALIZED_CB', defaultVal = [])
    newCallback = (fn, object, template, objectClass, persistent, float, user, string)
    if callbacks:
        if not newCallback in callbacks: # prevents multiple copies of the same exact event registration
            callbacks.append(newCallback)
    else:
        callbacks = [newCallback]
    missionobjvar.Mission_SetVar('EVENT_CHARINITIALIZED_CB', callbacks)

# Cancel a CHAR_INITIALIZED_EVENT sink for a particular callback function and the corresponding object/template/objectClass parameter
# code ripped off Stumpy's mlogreader.cancelAnimationCallbackSink()
def cancelCharacterInitializedCallbackSink(fn, object = '', template = '', objectClass = 0):
    callbacks = missionobjvar.Mission_GetVar('EVENT_CHARINITIALIZED_CB', defaultVal = [])
    if not callbacks:   # don't make a list if there were no callbacks
        return
    keptcallbacks = []
    for cb in callbacks:
        if not ( (cb[0] == fn) and (cb[1] == object) and (cb[2] == template) and (cb[3] == objectClass) ):
            keptcallbacks.append(cb)
    missionobjvar.Mission_SetVar('EVENT_CHARINITIALIZED_CB', keptcallbacks)

# used by initialiseChar(), which is called each 1.0 sec. by FFX.
# code ripped off Stumpy's mlogreader.HandleAnimationCallbacks()
def CharacterInitializedEvent(char):
    charTemplate = FFX_GetTemplate(char)
    charClass = Object_GetClass(char)
    callbacks = missionobjvar.Mission_GetVar('EVENT_CHARINITIALIZED_CB', defaultVal = [])
    changed = 0
    keptcallbacks = []  # the persistent ones
    for cb in callbacks:
        if (char == cb[1]) or (charTemplate == cb[2]) or ( (charClass & cb[3]) or (cb[3] == 0) ):
            if not cb[4]:   # this was not a persistent sink
                changed = 1
            else:
                keptcallbacks.append(cb)
            event = PseudoInitializeEvent(CHAR_INITIALIZED_EVENT, objectStr = char, stringStr = cb[7], floatVal = cb[5], dataVal = cb[4], userVal = cb[6])
            fn = cb[0]
            eventeval(fn, event)      
    if changed:
        missionobjvar.Mission_SetVar('EVENT_CHARINITIALIZED_CB', keptcallbacks)


# LOW-LEVEL GENERIC EVENT MANAGEMENT

# This is simply a copy of Stumpy's class from mlogreader module
# Note: while the format was kept the same for potential compatibility, eventType=FLIGHT_START_EVENT
# was changed to eventType=66 (the value of mlogreader.FLIGHT_START_EVENT) to avoid creating two
# versions of the same global variable.
# stumpy 2006-09-24: modified to make distinct from other pseudo events
# Added FFX 3.2
class PseudoInitializeEvent:
    def __init__(self, eventType=66, objectStr='', stringStr='', floatVal=0.0, dataVal=0.0, userVal=0.0):
        self.event = eventType
        self.object = objectStr
        self.string = stringStr
        self.float = floatVal
        self.data = dataVal
        self.user = userVal

# This is simply a slightly modified copy of Stumpy's function from mlogreader module
def eventeval(fn,event):
    try: #not trying to determine the appropriate module seems to avoid AttributeError exceptions better when all the code is invoked from ffx.py (?) - Ep.
        eval(fn+'(event)')
        return #return + except: pass = lazy way of keeping Stumpy's code below absolutely unchanged
    except:
        pass
    if '.' in fn:   # module was specified
        try:
            eval(fn+'(event)')
        except:
            try:    # maybe we haven't imported it
                dotpos = len(fn)-2
                while fn[dotpos]!='.':  dotpos=dotpos-1
                module = fn[:dotpos]
                exec('import '+module)
                eval(fn+'(event)')
            except:
                print 'eventeval: problem evaluating string %s' % repr(fn+'(event)')
                raise
    else:   # no module specified: take some guesses then try them all
        success = 0
        tryfirst = ['ff.','cshelper.','ffx.','m25ai.']
        for module in tryfirst: # try the preferred modules
            try:
                eval(module+fn+'(event)')
                success = 1
                break
            except:
                try:    # maybe we haven't imported it
                    exec('import '+module[:-1])
                    eval(module+fn+'(event)')
                    success = 1
                    break
                except:
                    pass
        if not success:
            for module in sys.modules.keys():   # try all the imported modules
                try:
                    eval(module+'.'+fn+'(event)')
                    success = 1
                    break
                except:
                    try:    # maybe we haven't imported it
                        exec('import '+module)
                        eval(module+'.'+fn+'(event)')
                        success = 1
                        break
                    except:
                        pass
        if not success:
            print 'eventeval: unable to evaluate string %s in any module.' \
                  % repr(fn+'(event)')
            raise


#---------------------------------------------
#---look, move, speak and other cutscene-related helpers
#---------------------------------------------

# snaps the camera to the first living character from a list
# modified from the original cshelper function look()
def aliveLook(charactersArray, zoom = 0, heading = 0, time = 0, fn = ''):
    for char in charactersArray:
        if Object_IsAlive(char):
            cshelper.lookAtObject(char, zoom, heading, time, fn)
            break

# scrolls the camera to the first living character from a list
# modified from the original cshelper function lookTo()
def aliveLookTo(charactersArray, fn = '', time = 3):
    for char in charactersArray:
        if Object_IsAlive(char):
            cshelper.lookToObject(char, fn, time)
            break

        
# ripped off Dr. mike's turnAllTo(), which works on customs only
# Changed FFX 3.2.0 alpha :added a random delay to make it look more natural
# turn all customs to given point (eg speaker)
def turnControllablesTo(target):
    count = 0.05
    for hero in getAllHeroes():
        if hero!=target:
            RegTimer('OnTurnControllablesTo', 0 + count, 0, hero, target)
            count = count + (0.05 * randint(1, 8))

def OnTurnControllablesTo(event):
    hero = event.object
    target = event.string
    if hero!=target:
        print hero
        if Object_Exists(target):
            turnTo(hero,target)
        else:
            try:
                turn(hero,target)
            except:
                donothing=0

# ripped off Dr. mike's moveAllTo(), which works on customs only
# maybe range should be randomized
# move all customs to given point
def moveControllablesTo(target):
    for hero in getAllHeroes():
        if hero!=target:
            if Object_Exists(target):
                moveTo(hero,target)
            else:
                try:
                    move(hero,target)
                except:
                    donothing=0


# mutually exclusive dialogue calls; if optional speech returns a result, don't play the next dialogue(s)
# used when you want a character to say something if he's in the mission, and if not, use another speech instead
# example: Microwave says something if he's in the mission; if he isn't, Liberty Lad speaks instead, if he's there;
# if not, use optionalForceSpeak() to have a character in the mission or not (such as Microwave), speak a different line.
# if you don't want to force a speech if there is no one, you can use only a succession exclusiveOptionalSpeak() and,
# after the last one, add the following line to your cutscene script:
Mission_SetAttr('exclusiveSpeechPlayed',0)

# call this function first
def exclusiveOptionalSpeak(template, tag):
    if Mission_GetAttr('exclusiveSpeechPlayed') == 0:
        if js.Object_Exists(template):
            object = template
        else:
            object = cshelper.findHero(template)
        if object and js.Object_IsAlive(object):
            cshelper.speakInternal(object, tag, fn = 'onStepCB')
            Mission_SetAttr('exclusiveSpeechPlayed',1)
            Mission_SetAttr('exclusiveSpeechPlayed2',1)
            return object
        cshelper.null()
        Mission_SetAttr('exclusiveSpeechPlayed2',2)
        return ''
    else:
        cshelper.null()
        Mission_SetAttr('exclusiveSpeechPlayed2',3)
        return ''

        
# call this function last if there is another step in the cutscene after
def optionalForceSpeak(object, tag, telepathy = 2):
    if Mission_GetAttr('exclusiveSpeechPlayed') == 0:
        cshelper.forceSpeak(object, tag, telepathy)
        Mission_SetAttr('exclusiveSpeechPlayed3',1)
    else:
        Mission_SetAttr('exclusiveSpeechPlayed',0)
        Mission_SetAttr('exclusiveSpeechPlayed3',2)
        cshelper.null()
    
# call this function last if it's the last step of the cutscene
def optionalForceSpeakNoCB(object, tag, telepathy = 1):
    if Mission_GetAttr('exclusiveSpeechPlayed') == 0:
        cshelper.forceSpeakNoCB(object, tag, telepathy)
    else:
        Mission_SetAttr('exclusiveSpeechPlayed',0)



        


######################################################################
## 
## Plugins Importer
## By pimthe
## 
######################################################################

# This imports .py files located inside any first-level subfolder located inside the "[plugins folder's name]\active\" folder.

# The idea of plugins is that with EZScript and FFX, allowing people to install one's own selection among additional features/content
# should both be simplified for end users and made more modular for debugging.

# This assumes that additional .py files are located in an existing MODFOLDER\[path, defaults to missions\scripts\ffxplugins]\active\ folder.

# Please refer to the plugins_readme.txt file inside the "ffxplugins" folder for more info.

# VERSION HISTORY
# 0.1:
# - Proof of concept.
# 1.0 2006-06-11
# - First complete version. Added subfolder detection and path abstraction. Made into a module.
# 1.1 2006-06-12
# - Added OnPostInit() call.
# 2.0 2006-06-21
# - Plugin modules are now imported with a "from module import *" rather than an "import module" statement, because events weren't working reliably otherwise...
# - Moved back into FFX because events didn't work either when called from a distinct module... Event not fired = debugging in the dark. What a pain.
# 2.1 2006-06-29
# - Patched a bug preventing plugins from different folders from importing.
# -Improved error catching in pseudo OnPostInit().
# - First release.



# Calls the specified module's pseudo OnPostInit() after the game has *started* loading dynamic objects
# Note that the EVENT_MISSION_READY mentioned in the FF Scripting doc isn't implemented in the game.
def pseudoOnPostInit(thisPlugin):
    RegTimer('OnPseudoOnPostInitCheck', 2.5, 0, thisPlugin)

def OnPseudoOnPostInitCheck(event):
    thisPlugin = event.object
    if len(js.Mission_GetDynamicObjects()) > 0:
        RegTimer('OnPseudoOnPostInitGo', 0.5, 0, thisPlugin)
    else:
        RegTimer('OnPseudoOnPostInitCheck', 0.5, 0, thisPlugin)

def OnPseudoOnPostInitGo(event):
    thisPlugin = event.object
    try:
        OnPostInit = "%s.OnPostInit()" % thisPlugin
        exec OnPostInit
        print "Plugin '%s' OnPostInit() called" % thisPlugin
    except AttributeError:
        print "Plugin '%s' has no OnPostInit()" % thisPlugin
        pass


def importPlugins(pluginsRootFolder = "missions\\scripts\\ffxplugins"):
    ffPath = os.getcwd()
    pluginsRootFolder_FullPath = "%s\\%s\\%s\\active" % (ffPath, sysutils.getModFolder(), pluginsRootFolder)
    pluginsFolders = []
    try:
        #looking for plugin subfolders inside the "active\" folder
        pluginsRootFolder_Files = os.listdir(pluginsRootFolder_FullPath)
        for file in pluginsRootFolder_Files:
            fileType = os.stat("%s\\%s" % (pluginsRootFolder_FullPath, file))[0]
            if fileType == 16895: #this is the id of directories
                #print "Plugin folder found: '%s'" % file
                pluginsFolders.append(file)
        if len(pluginsFolders) == 0:
            print "No active Python modules plugins found."
            return pluginsFolders
        #check the files inside each plugin folder
        pluginsFiles = []
        for folder in pluginsFolders:
            pluginsSubFolder_FullPath = "%s\\%s" % (pluginsRootFolder_FullPath, folder)
            pluginsSubFolder_Files = os.listdir(pluginsSubFolder_FullPath)
            for f in pluginsSubFolder_Files:
                if f[-3:] == ".py":
                    pluginsFiles.append(f[:-3])
            if len(pluginsFiles) != 0:
                sys.path.append(pluginsSubFolder_FullPath)
                #print "Importing plugin folder '%s'" % pluginsSubFolder_FullPath
        return pluginsFiles
    except WindowsError:
        print "importPlugins() fatal error:"
        print "    Plugins folders missing: cannot find"
        print "    %s" % pluginsRootFolder_FullPath
        return pluginsFolders
    except:
        print "importPlugins() fatal error:"
        print "    Unknown exception."
        return pluginsFolders

#Start the Plugins Importer
#Plugins Importer now looks for plugin modules to load
pluginsFiles = importPlugins(pluginsRootFolder = "missions\\scripts\\ffxplugins")
for thisPlugin in pluginsFiles:
    initImport = "import %s" % thisPlugin
    initFrom = "from %s import *" % thisPlugin
    try:
        exec initImport
        exec initFrom
        print "FFX Mission Plugin '%s' imported" % thisPlugin
        pseudoOnPostInit(thisPlugin)
    except:
        print "FFX Mission Plugins non-fatal error:"
        print "    couldn't import plugin '%s'" % thisPlugin
        raise


##################### test area #######################################


##################### Dizzy #######################################
# You have a poor sense of balance. Whenever you're hit or spend energy, you risk falling over.
# v.0.9
# Added FFX 3.3 pre-alpha

def initffqdizzy(char, update=0, remove=0):
    if remove:
        if FFX_ObjectGetAttr(char, 'ffqdizzy'):
            FFX_ObjectSetAttr(char, 'ffqdizzy', 0)
        return
    if not FFX_ObjectGetAttr(char, 'ffqdizzy'):
        FFX_ObjectSetAttr(char, 'ffqdizzy', 1)
        Object_SetAttr(char, 'lastHealthFFQDizzy', Object_GetAttr(char, 'health'))
        RegDamage(char, 'OnFFQDizzyHit')
        RegTimer('OnFFQDizzyEnergy', 5, Object_GetAttr(char, 'energyPoints'), char)

def OnFFQDizzyHit(event):
    char = event.object
    if not FFX_ObjectGetAttr(char, 'ffqdizzy'):
        return
    damage = Object_GetAttr(char, 'lastHealthFFQDizzy') - Object_GetAttr(char, 'health')
    if damage > -1: #even invulnerable characters should be susceptible
        if FFX_Rand(0, 2) == 2:
            fallOver(char)
            Object_PlayEffect(char, 'effect_ffx_vertigo', '', 0, 0, 'Bip01 Head')
    Object_SetAttr(char, 'lastHealthFFQDizzy', Object_GetAttr(char, 'health'))
    RegDamage(char, 'OnFFQDizzyHit')

def OnFFQDizzyEnergy(event):
    char = event.object
    if not FFX_ObjectGetAttr(char, 'ffqdizzy'):
        return
    oldEP = event.user
    newEP = Object_GetAttr(char, 'energyPoints')
    if Object_IsAlive(char):
        if newEP < oldEP:
            if FFX_Rand(0,5) == 5:
                fallOver(char)
                Object_PlayEffect(char, 'effect_ffx_vertigo', '', 0, 0, 'Bip01 Head')
        RegTimer('OnFFQDizzyEnergy', 5, newEP, char)
    else:
        RegTimer('OnFFQDizzyEnergy', 30, newEP, char)




##################### Alternate Current #######################################
# Based on a request by Urthman (who beta-tested it in FF1, thanks)... and by myself to Dr. Mike in 2002.
# Allows you to leech energy from electrical-powered objects, damaging them in the process.
# You can absorb from a single source more than once; however subsequent tries might stun
# you for 5-15 secs or trigger an explosion (electrical and fire).
# v. 1.0
# Added (hidden) FFX 3.2
# TO DO:
# - Add AI

#Move this to ffxcustom2.py
FFX_FFQALTCURRENT_CUSTOM=[
["default", "electricalSources", "ffx_magnetic_lift", 3, "CUSTOM_FFQALTCURRENT", "effect_ffx_magnetised"],
["types", "ASource List", "dDummy Power", "iRange", "CCommand", "EFX"],
]

def initffqaltcurrent(char, update=0, remove=0):
    if remove:
        if FFX_ObjectGetAttr(char, 'ffqaltcurrent'):
            FFX_ObjectSetAttr(char, 'ffqaltcurrent', 0)
            action = getByTemplate(char, FFX_FFQALTCURRENT_CUSTOM, 4)
            sources = eval( getByTemplate(char, FFX_FFQALTCURRENT_CUSTOM, 1) )
            for template in sources: #defaults to FFvsTTR tuple of electrical sources in ffxextras.py
                Mission_RemoveCustomAction(action, char, template)
        return
    if not FFX_ObjectGetAttr(char, 'ffqaltcurrent'):
        FFX_ObjectSetAttr(char, 'ffqaltcurrent', 1)
        action = getByTemplate(char, FFX_FFQALTCURRENT_CUSTOM, 4)
        range = getByTemplate(char, FFX_FFQALTCURRENT_CUSTOM, 3)
        sources = eval( getByTemplate(char, FFX_FFQALTCURRENT_CUSTOM, 1) )
        for template in sources: #defaults to FFvsTTR tuple of electrical sources in ffxextras.py
            Mission_CustomAction(action, char, template, 'OnFFQAltCurrent', range, 0)

def OnFFQAltCurrent(target, char):
    power = getByTemplate(char, FFX_FFQALTCURRENT_CUSTOM, 2)
    Trigger_Power(char, target, power, '')
    RegTimer('OnFFQAltCurrent2', 2, 0, char, target)

def OnFFQAltCurrent2(event):
    char = event.object
    target = event.string
    fx = getByTemplate(char, FFX_FFQALTCURRENT_CUSTOM, 5)
    Object_PlayEffect(target, fx, '', 0, 0, 'centre')
    oldHP = Object_GetAttr(target, "health")
    damage = min(oldHP, randint(10, 20))
    Trigger_Damage(target, damage)
    if FFX_ObjectGetAttr(target, 'FFQ_AltCurrent_Leeched'):
        danger = randint(1, 10)
        if danger == 8:
            Object_SetPrimaryState(char, PCSTATE_STUNNED, 5)
            return
        if danger == 9:
            Object_SetPrimaryState(char, PCSTATE_STUNNED, 15)
            return
        if danger == 10:
            Trigger_Explosion(target, 'ffx_ex_elec_small', -1)
            Trigger_Explosion(target, 'ffx_ex_fire_small')
            return
    else:
        FFX_ObjectSetAttr(target, 'FFQ_AltCurrent_Leeched', 1)
    newEP = int( min( Object_GetAttr(char,'maxEnergyPoints'), Object_GetAttr(char,'energyPoints') + (damage*2) ) )
    RegTimer('OnFFQAltCurrentFX', 0.5, newEP, char)

def OnFFQAltCurrentFX(event):
    char = event.object
    target = event.string
    newEP = event.user
    Object_SetAttr(char, 'energyPoints', newEP)
    fx = getByTemplate(char, FFX_FFQALTCURRENT_CUSTOM, 5)
    Object_PlayEffect(char, fx, '', 0, 0, 'centre')
    


####################### GESTALT/AMALGAM #################################
# You can change into amalgamed temporary forms by merging with specific character templates or common objects.
# - If the target is an enemy character, this power can only be used once per specific target *object* (not template),
#   even if using different Gestalt characters.
# - If the Amalgam is KO'ed, the Gestalt source character is too, but not the target.
# - If the target has moved too far, the command won't work.
# - Both attributes are removable. Removing the Amalgam attribute reverts the character to his base Gestalt form;
#   however, the Gestalt attribute will stil be functional and will need to be disabled separately.

# Ripped off Dr. Mike's Shapeshifter and Accidental Change code.
# The following functions and constants have been changed to work with Gestalt:
# - morph()
# - getMorphFX()
# - tempCheck()
# - initAttribs()
# - attrDesc list
# - added getCustomTemplateName()

# v. 1.0
# Added FFX 3.3 pre-alpha
# TO DO:
# - Add AI (good luck with that...)

def initffqgestalt(char, update=0, remove=0):
    if isMP():
        return
    if remove:
        if not FFX_ObjectGetAttr(char, 'ffqgestalt'):
            return
        FFX_ObjectSetAttr(char, 'ffqgestalt', 0)
        for i in (2, 4, 6):
            target = getByTemplate(char, FFX_FFQGESTALT_CUSTOM, i)
            if target != '':
                Mission_RemoveCustomAction('CUSTOM_FFQGESTALTMERGE', char, target)
                #custom action for RR's custom_template_n target characters
                targetRealName = getCustomTemplateName(target)
                if targetRealName != None:
                    Mission_RemoveCustomAction('CUSTOM_FFQGESTALTMERGE', char, targetRealName)
        return
    if FFX_ObjectGetAttr(char, 'ffqgestalt'):
        return
    FFX_ObjectSetAttr(char, 'ffqgestalt', 1)
    #store the original row
    for i in (3, 5, 7):
        form = getByTemplate(char, FFX_FFQGESTALT_CUSTOM, i)
        target = getByTemplate(char, FFX_FFQGESTALT_CUSTOM, i-1)
        if not '' in (form, target):
            action='OnFFQGestaltForm%i'%(i)
            Mission_CustomAction('CUSTOM_FFQGESTALTMERGE', char, target, action, 3, 0)
            #custom action for RR's custom_template_n target characters
            targetRealName = getCustomTemplateName(target)
            if targetRealName != None:
                Mission_CustomAction('CUSTOM_FFQGESTALTMERGE', char, targetRealName, action, 3, 0)
    #store the original row
    template=Object_GetTemplate(char)
    realName=''
    print FFX_FFQGESTALT_CUSTOM
    if template[:6]=='custom':
        realName=FFX_GetTemplate(char)
        newSet=[]
        needToAdd=1
        for set in FFX_FFQGESTALT_CUSTOM:
            if set[0]==realName:
                for entry in set:
                    newSet.append(entry) 
            if set[0]==template:
                needToAdd=0
        if needToAdd:
            if len(newSet) > 0:
                newSet[0]=template
            else:
                newSet = FFX_FFQGESTALT_CUSTOM[0][:] #append as a copy to avoid messing with the original data
                newSet[0] = template
            FFX_FFQGESTALT_CUSTOM.append(newSet)
    i=0
    for set in FFX_FFQGESTALT_CUSTOM:
        if (set[0]==template) | (set[0]==realName):
            FFX_ObjectSetAttr(char,'ffqgestaltRow',i)
            break
        i=i+1

def OnFFQGestaltForm3(target, char):
    OnFFQGestaltChange(char, target, 3)

def OnFFQGestaltForm5(target, char):
    OnFFQGestaltChange(char, target, 5)

def OnFFQGestaltForm7(target, char):
    OnFFQGestaltChange(char, target, 7)

def OnFFQGestaltChange(char, target, index):
    print target
    if not Object_Exists(target):
        return
    if isBuilding(target) | ( Object_GetAttr(target, 'minHealth') > 0 ) | ( Object_GetAttr(target, 'physical') == 0 ):
        Mission_StatusText("Invalid target type for Gestalt. You may need to update your FFX Control Centre settings.")
        return
    #if the target is an enemy, has any Gestalt power already been used against this character?
    if FFX_ObjectGetAttr(target, 'ffqgestalt_target', 0):
        Mission_StatusText("This character has become resistant to Gestalt attacks.")
        return
    #is the target still in range or has it moved too far?
    charPos = Get_ObjectPos(char)
    targetPos = Get_ObjectPos(target) 
    if ( distance2D(charPos, targetPos) > 60 ):
        Mission_StatusText("Missed! The target has moved away.")
        return
    if chargeEP(char,0)==0:
        return
    #move to the target's position and orientation
    heading = Object_GetOrientation(target)[1]
    teleportToPos(char, targetPos, heading)
    #amalgam identified - let's go! find the original form
    originalForm = FFX_FFQGESTALT_CUSTOM[ int(FFX_ObjectGetAttr(char, 'ffqgestaltRow')) ][0]
    newTemplate = getByTemplate(originalForm, FFX_FFQGESTALT_CUSTOM, index, 1)
    name=getFormName()
    #make the target disappear
    RegTimer("OnFFQGestaltHideTarget", 0.2, 0, target, name)
    morph(name,char,newTemplate,1,1)
    
def OnFFQGestaltHideTarget(event):
    target = event.object
    name = event.string
    #store the amalgam's target component's class type and name
    isCharacter = ( ( Object_GetClass(target) & FFX_CHARACTER ) != 0 )
    missionobjvar.Object_SetVar( name, 'ffqgestalt_target', (isCharacter, FFX_GetTemplate(target), target) )
    #if a character, hide and disable
    if isCharacter:
        Object_SetPrimaryState(target, PCSTATE_EXILE, 10000, 0)
        Object_SetSecondaryState(target, SCSTATE_INVISIBLE, 10000, 0)
        if Object_GetClass(target) & OC_CONTROLLABLE:
            FFX_AdjustPortrait(target, 0)
        AIDisable(target)
        #if the target is an enemy, make the power a one-shot deal against this character
        if not FFQ_isSameSide(name, target):
            FFX_ObjectSetAttr(target, 'ffqgestalt_target', 1)
            RegTimer("OnFFQGestaltTargetEnemy", 15, 0, target)
        FFX_ObjectSetAttr(target, 'ffqgestalt_hidden', 1) #used by OnFFQGestaltTargetEnemy()
    #otherwise, just destroy it
    else:
        Object_Destroy(target)

# If the hidden target(s) is an enemy character and a bad guy, check periodically to see if it's the last standing enemy;
# if it is, display a message to the player once.
def OnFFQGestaltTargetEnemy(event):
    target = event.object
    if not FFX_ObjectGetAttr(target, 'ffqgestalt_hidden'):
        return
    for baddie in cshelper.getAllBaddies(1):
        if not FFX_ObjectGetAttr(baddie, 'ffqgestalt_hidden'):
            RegTimer("OnFFQGestaltTargetEnemy", 15, 0, target)
            return
    #the only bad guys left are gestalt targets; alert the player
    Mission_StatusText("The only enemies left are amalgamed with your Gestalt heroes. Revert to beat them.")
        
    
def initffqamalgam(char,update=0, remove=0):
    global FFX_FFQGESTALT_CUSTOM
    if isMP():
        return
    if remove:
        FFX_ObjectSetAttr(char, 'ffqamalgam', 0)
        FFX_ObjectSetAttr(char, 'ffqgestaltReverting', 1)
        OnFFQAmalgamRevertFromTemp(char, char, 1)
        return
    FFX_ObjectSetAttr(char, 'ffqamalgam', 1)
    #at startup add them into the default slots for gestalt
    if Mission_GetAttr('shapeReady')==0: #shapeReady is used by various attributes
        for hero in cshelper.getAllHeroes():
            if hasAttribute(hero,'ffqgestalt'):
                row=-1
                index=0
                template = Object_GetTemplate(hero)
                for set in FFX_FFQGESTALT_CUSTOM:
                    if set[0] == template:
                        row=index
                    index=index+1
                if row==-1:
                    row=len(FFX_FFQGESTALT_CUSTOM)
                    newSet = FFX_FFQGESTALT_CUSTOM[0]
                    newSet[0] = template
                    FFX_FFQGESTALT_CUSTOM.append(newSet)
                for index in (3, 5, 7):
                    if FFX_FFQGESTALT_CUSTOM[row][index]=='':
                        FFX_FFQGESTALT_CUSTOM[row][index]=Object_GetTemplate(char)
                        break
        RegTimer('destroyTemp',1,0,char)
        return
    #put in a revert command to original form
    Mission_CustomAction('CUSTOM_FFQGESTALTREVERT', char, char, 'OnFFQAmalgamRevertFromTemp', 5, 0)
    #start checking for forced split
    revertFn=getByTemplate(char, FFX_FFQAMALGAM_CUSTOM, 3)
    if revertFn not in ("", "isNever"):
        RegTimer('OnFFQAmalgamForceRevertCheck',1,0,char,revertFn)

def OnFFQAmalgamForceRevertCheck(event):
    char=event.object
    if not Object_Exists(char):
        return
    if FFX_ObjectGetAttr(char,'ffqgestaltReverting',0) != 0:
        return
    #if the amalgam is KO, revert it now, hero points notwistanding
    if not Object_IsAlive(char):
        ffqAmalgamRevertFromTemp(char,char,1)
        return
    fn=event.string
    RegTimer('OnFFQAmalgamForceRevertCheck',1,0,char,fn)
    forceback=0
    code='forceback=%s(char)'%(fn)
    exec code
    if forceback:
        FFX_ObjectSetAttr(char,'ffqgestaltReverting',1)
        OnFFQAmalgamRevertFromTemp(char,char,1)

def OnFFQAmalgamRevertFromTemp(dummy,char,forced=0):
    if forced==0:
        if chargeEP(char,0)==0:
            return
    row=int(FFX_ObjectGetAttr(char,'ffqgestaltRow'))
    template = FFX_FFQGESTALT_CUSTOM[row][0]
    if FFX_TemplateExists(template)==0:
        customTemplate=getTemplateFromRealName(template)
        if FFX_TemplateExists(customTemplate):
            template=customTemplate
    #reveal the target object and set the positions
    pos = Get_ObjectPos(char)
    newPos = (pos[0]+10, pos[1]+10, pos[2])
    targetData = missionobjvar.Object_GetVar(char, 'ffqgestalt_target')
    target = targetData[2]
    if targetData[0]: #if a character
        teleportToPos(target, pos)
        Object_SetPrimaryState(target, PCSTATE_EXILE, 0, REMOVE_STATE)
        Object_SetSecondaryState(target, SCSTATE_INVISIBLE, 0, REMOVE_STATE)
        FFX_ObjectSetAttr(target, 'ffqgestalt_hidden', 0) #used by OnFFQGestaltTargetEnemy()
        if Object_GetClass(target) & OC_CONTROLLABLE:
            FFX_AdjustPortrait(target, 1)
        AIEnable(target)
    else:
        Object_SpawnAt(targetData[1], pos, target)
    teleportToPos(char, newPos)
    alignWith(target, char)
    #morph back the character
    name = getFormName()
    if FFX_HasPortrait(char): 
        morph(name,char,template,1,1)
    else:
        morph(name,char,template,1,0)




########################### C4 ATTRIBUTES #########################################

##################### Cannonball #######################################

#Ep. 2006-09-05: redone using MLOG
def initcannonball(char, update=0, remove=0):
    if remove:
        FFX_ObjectSetAttr(char, 'cannonball', 0)
        mlogreader.cancelAnimationCallbackSink(char, 'cannonballFly')
        mlogreader.cancelAnimationCallbackSink(char, 'cannonballLand')
        if mlogreader.MLOG_IsFlying(char):
            removeShield(char, duration = 1, fx = '')
    else:
        FFX_ObjectSetAttr(char, 'cannonball', 1)
        mlogreader.regFlightStart(char, 'cannonballFly', persistent=1)
        mlogreader.regFlightStop(char, 'cannonballLand', persistent=1)

def cannonballFly(event):
    char = event.object
    if FFX_ObjectGetAttr(char, 'permanent_shield') < 1: #Ep. 2006-09-23: prevents disabling permanent active defences (ghostly, illusion, etc.)
        shield = getByTemplate(char, FFX_C4CANNONBALL_CUSTOM, 1)
        Trigger_Power(char, char, shield, '')

def cannonballLand(event):
    char = event.object
    if FFX_ObjectGetAttr(char, 'permanent_shield') < 1:
        removeShield(char, duration = 1, fx = '')
    area = getByTemplate(char, FFX_C4CANNONBALL_CUSTOM, 2)
    if area != '':
        Trigger_Explosion(char, area)


########################### Rage ##############################################
### Need fixing up - relate hp to maxhealth and not have two 60's in there! ###
### plus interfere w/ accidental cloning -> pulled out for now

def initrage(char,update=0):
    ffx.Object_SetAttr(char,'lastHealthAC',Object_GetAttr(char,'health'))
    ffx.RegDamage(char,'OnBerzerk')

def OnBerzerk(event):
    char=event.object
    damage=Object_GetAttr(char,'lastHealthAC')-Object_GetAttr(char,'health')
    if damage<30:
        if FFX_Rand(1,80)<damage:
            ffx.Object_SetPrimaryState(char, PCSTATE_ENRAGED, 10)
        ffx.Mission_StatusText('man he is pissed')
    elif damage<60:
        if FFX_Rand(1,70)<damage:
            ffx.Object_SetPrimaryState(char, PCSTATE_ENRAGED, 15)
        ffx.Mission_StatusText('puny human')
    elif damage>60:
        if FFX_Rand(1,50)<damage:
            ffx.Object_SetPrimaryState(char, PCSTATE_ENRAGED, 30)
        ffx.Mission_StatusText('raaarrrg!! hulk smash')
    ffx.Object_SetAttr(char,'lastHealthAC',Object_GetAttr(char,'health'))
    ffx.RegDamage(char,'OnBerzerk')

###################### Rage Grade2 ##########################################

def initrage2(char,update=0):
    ffx.Object_SetAttr(char,'lastHealthAC',Object_GetAttr(char,'health'))
    ffx.RegDamage(char,'OnBerzerk2')

def OnBerzerk2(event):
    char=event.object
    damage=Object_GetAttr(char,'lastHealthAC')-Object_GetAttr(char,'health')
    if damage<30:
        if FFX_Rand(1,50)<damage:
            ffx.Object_SetPrimaryState(char, PCSTATE_ENRAGED, 15)
        ffx.Mission_StatusText('man he is pissed')
    elif damage<60:
        if FFX_Rand(1,40)<damage:
            ffx.Object_SetPrimaryState(char, PCSTATE_ENRAGED, 20)
        ffx.Mission_StatusText('puny human')
    elif damage>60:
        if FFX_Rand(1,10)<damage:
            ffx.Object_SetPrimaryState(char, PCSTATE_ENRAGED, 100)
        ffx.Mission_StatusText('raaarrrg!! hulk smash')
    ffx.Object_SetAttr(char,'lastHealthAC',Object_GetAttr(char,'health'))
    ffx.RegDamage(char,'OnBerzerk2')

#################### Lesser Regeneration #################################
#Ep. 2007-03-24: replaced updatefasthealer() code with call to modified updatesuperhealer()
def initlesserregeneration(char,update=0,remove=0):
    if remove:
        FFX_ObjectSetAttr(char,'lesserregeneration',0)
    else:
        FFX_ObjectSetAttr(char,'lesserregeneration',1)
    if update==0:
        RegDamage(char, 'updatesuperhealer', user = 1, persistent = 0, string = '')


################## Aerial Scout ####################################

def initairscout(char,update=0):
    if update==0:
        ffx.FFX_ObjectSetAttr(char,'airborne2',0)
        ffx.FFX_ObjectSetAttr(char,'flyCheck',0)
        if (Object_GetClass(char)&OC_CONTROLLABLE): #Quick fix: disable attr for non-player, since we're using Mission_SetDetectionEnabled()
            ffx.RegTimer('FlierScoutCheck',1,0,char)

def FlierScoutCheck(event):
    char=event.object
    if Object_Exists(char)==0:
        return
    ffx.RegTimer('FlierScoutCheck',1,0,char)
    if not Object_IsAlive(char): ###!
        return
    flying = mlogreader.MLOG_IsFlying(char) #Ep. 2007-02-4: replaced obsolete FFQ_IsFlying()
    wasFlying=ffx.FFX_ObjectGetAttr(char,'airborne2')
    if flying and (wasFlying==0):
#       Mission_StatusText("crikey!")
        ffx.Mission_SetDetectionEnabled(0)
        ffx.FFX_ObjectSetAttr(char,'airborne2',1)
    if (flying==0) and wasFlying:
#       Mission_StatusText("where did they go?")
        ffx.Mission_SetDetectionEnabled(1)
        ffx.FFX_ObjectSetAttr(char,'airborne2',0)

######################Natural Teleporter#########################################
##! Updated for FFvsTTR, based on Gremlin's request for Speedforce:
# - hi-speed inability to attack (FF1 made char out of synch at speed > 9) restored using Displace Image
# - invalid timeout repaired
# - hidden duplicate menu entry hidden by timeout bug repaired
# - agility modifier removed - you're not supposed to get hit anyway
# - added Density Max to the character because of the flight acceleration out of map bug due
#   to the extra-high speed; increased speed to compensate

# Bugs:
# -Since object states can't be detected, characters cured of density max while using Natural Teleporter
#  may fly again and thus suffer from the accelerating flier bug.
# -When the Natural Teleporter effect ends, the character is cured of any density maxification.

def initteleporter(char,update=0):
    cmd1=getByTemplate(char,FFX_C4TELEPORTER_CUSTOM,4)
    Mission_CustomAction(cmd1,char,char,'OnNATTP',0,0)

def OnNATTP(char,hero):
    if chargeEP(char,33)==0:
        return
    cmd1=getByTemplate(char,FFX_C4TELEPORTER_CUSTOM,4)
    cmd2=getByTemplate(char,FFX_C4TELEPORTER_CUSTOM,5)
    FFX_ObjectSetAttr(char, 'c4NATTP_on', 1)
    Mission_RemoveCustomAction(cmd1,char,char)
    Mission_CustomAction(cmd2,char,char,'OnNATTPStop',0,0)
    speed=Object_GetAttr(char,'templateSpeed')+3000
    if speed>3000:
        speed=3000
    ffx.Object_SetAttr(char,'speed',speed)
    ffx.RegTimer('OnNATTPStopEvent',15,0,char)
    fx=getByTemplate(char,FFX_C4TELEPORTER_CUSTOM,1)
    if fx!='':
        Object_PlayEffect(char,fx,'')
    fx=getByTemplate(char,FFX_C4TELEPORTER_CUSTOM,2)
    if fx!='':
        handle=Object_PlayEffect(char,fx,'',FX_LOOP|FX_TRACK_OBJECT_POS)
        FFX_ObjectSetAttr(char,'c4tpfx',handle)
    ff.RESULTBUBBLE_SCALE = 0
    RegTimer('bubblesOn', 0.1)
    Object_SetSecondaryState(char, SCSTATE_DISPLACE_IMAGE, 15, 0)
    Object_SetGenericState(char, OBJSTATE_DENSITY_CHANGE, 15, 0)
    RegTimer('OnNATTPCheck', 0.3, 0, char)

def OnNATTPCheck(event):
    char = event.object
    if Object_GetSecondaryStates(char) & SCSTATE_DISPLACE_IMAGE:
        RegTimer('OnNATTPCheck', 0.3, 0, char)
    else:
        OnNATTPStop(char, '')

def OnNATTPStopEvent(event):
    char = event.object
    OnNATTPStop(char, '')

def OnNATTPStop(char,hero):
    if FFX_ObjectGetAttr(char, 'c4NATTP_on') != 1:
        return
    FFX_ObjectSetAttr(char, 'c4NATTP_on', 0)
    cmd1=getByTemplate(char,FFX_C4TELEPORTER_CUSTOM,4)
    cmd2=getByTemplate(char,FFX_C4TELEPORTER_CUSTOM,5)
    Mission_RemoveCustomAction(cmd2,char,char)
    Mission_CustomAction(cmd1,char,char,'OnNATTP',0,0)
    speed=Object_GetAttr(char,'templateSpeed')
    ffx.Object_SetAttr(char,'speed',speed)
    ffx.Object_SetAttr(char,'baseSpeed',speed)
    fx=getByTemplate(char,FFX_C4TELEPORTER_CUSTOM,3)
    if fx!='':
        Object_PlayEffect(char,fx,'')
    handle=FFX_ObjectGetAttr(char,'c4tpfx')
    Object_StopEffect(char,handle)
    Object_SetGenericState(char, OBJSTATE_DENSITY_CHANGE, 0, REMOVE_STATE)

######################Speed force#########################################
##! Updated for FFvsTTR, at Gremlin's request:
# - hi-speed inability to attack (FF1 made char out of synch at speed > 9) replaced by customizable
#   side effect (defaults to  blind and power null)
# - invalid timeout repaired
# - hidden duplicate menu entry hidden by timeout bug repaired

def initspeedforce(char,update=0):
    cmd1=getByTemplate(char,FFX_SPEEDFORCE_CUSTOM,4)
    Mission_CustomAction(cmd1,char,char,'OnSpeedForce',0,0)

def OnSpeedForce(char,hero):
    if chargeEP(char,33)==0:
        return
    cmd1=getByTemplate(char,FFX_SPEEDFORCE_CUSTOM,4)
    cmd2=getByTemplate(char,FFX_SPEEDFORCE_CUSTOM,5)
    FFX_ObjectSetAttr(char, 'speedForce_on', 1)
    Mission_RemoveCustomAction(cmd1,char,char)
    Mission_CustomAction(cmd2,char,char,'OnSpeedStop',0,0)
    speed=Object_GetAttr(char,'templateSpeed')+10
    if speed>900:
        speed=900
    ffx.Object_SetAttr(char,'speed',speed)
    agility=Object_GetAttr(char,'templateAgility')+10
    if agility>900:
        agility=900
    ffx.Object_SetAttr(char,'agility',agility)
    ffx.RegTimer('OnSpeedStopEvent', 15, 0, char)
    fx=getByTemplate(char,FFX_SPEEDFORCE_CUSTOM,1)
    if fx!='':
        Object_PlayEffect(char,fx,'')
    fx=getByTemplate(char,FFX_SPEEDFORCE_CUSTOM,2)
    if fx!='':
        handle=Object_PlayEffect(char,fx,'',FX_LOOP|FX_TRACK_OBJECT_POS)
        FFX_ObjectSetAttr(char,'c4tpfx',handle)
    sideEffect = getByTemplate(char, FFX_SPEEDFORCE_CUSTOM, 6)
    RegTimer(sideEffect, 0.1, 0, char)

def OnSpeedStopEvent(event):
    char = event.object
    OnSpeedStop(char, '')
    
def OnSpeedStop(char,hero):
    if FFX_ObjectGetAttr(char, 'speedForce_on') != 1:
        return
    FFX_ObjectSetAttr(char, 'speedForce_on', 0)
    cmd1=getByTemplate(char,FFX_SPEEDFORCE_CUSTOM,4)
    cmd2=getByTemplate(char,FFX_SPEEDFORCE_CUSTOM,5)
    Mission_RemoveCustomAction(cmd2,char,char)
    Mission_CustomAction(cmd1,char,char,'OnSpeedForce',0,0)
    speed=Object_GetAttr(char,'templateSpeed')
    ffx.Object_SetAttr(char,'speed',speed)
    ffx.Object_SetAttr(char,'baseSpeed',speed)
    agility=Object_GetAttr(char,'templateAgility')
    ffx.Object_SetAttr(char,'agility',agility)
    ffx.Object_SetAttr(char,'baseAgility',agility)
    fx=getByTemplate(char,FFX_SPEEDFORCE_CUSTOM,3)
    if fx!='':
        Object_PlayEffect(char,fx,'')
    handle=FFX_ObjectGetAttr(char,'c4tpfx')
    Object_StopEffect(char,handle)


########################### SHAZAM'S ATTRIBUTES #########################################

########################### INVULNERABLE/DURABILITY: NEW GRADES #########################
# See Invulnerable under Dr. Mike's section

########################### TOUGH GUY 2 #################################################
# In collaboration with Shazam

########################### SOLAR STORES ################################################
# Updated for FFX 2.5 by pimthe using Dr. Mike's Energy Tanks

def initsolarstores(char,update=0):
    baseMaxEP = Object_GetAttr(char, 'maxEnergyPoints')
    baseEP = Object_GetAttr(char, 'energyPoints')
    Object_SetAttr(char, 'maxEnergyPoints',4 * baseMaxEP)
    Object_SetAttr(char, 'energyPoints',4 * baseEP)
    FFX_ObjectSetAttr(char, 'maxEP', baseMaxEP)


############################ BODY AURA ##################################################
# Updated for FFX 2.5 by pimthe


def initbodyaura(char,update=0):
    FFX_ObjectSetAttr(char,'baura',-1)
    Object_SetAttr(char,'lastHealthBA',Object_GetAttr(char,'health'))
    RegDamage(char, 'OnBAura', user = 0, persistent = 1)

def OnBAura(event):
    char=event.object
    if not Object_IsAlive(char):
        return
    damage=Object_GetAttr(char,'lastHealthBA')-Object_GetAttr(char,'health')
    Object_SetAttr(char,'lastHealthBA',Object_GetAttr(char,'health'))
    if FFX_ObjectGetAttr(char,'baura')==0:
        return
    if damage>0:
        payBack=Object_GetAttr(char,'energyPoints')
        print 'OnBAura (%s): damage = %d, payBack = %d' % (char,damage,payBack)    # *** stumpy
        if damage<payBack:
            payBack=damage
        Object_SetAttr(char,'health',Object_GetAttr(char,'health')+payBack)
        Object_SetAttr(char,'energyPoints',Object_GetAttr(char,'energyPoints')-payBack)
        fx=getByTemplate(char,FFX_BODYAURA_CUSTOM,1)
        if fx!='':
            Object_PlayEffect(char,fx,'',0,0,bodyPart[randint(0,4)])



########################### STUMPY'S ATTRIBUTES #########################################

########################### INVULNERABLE/DURABILITY: NEW GRADES #########################
# See Invulnerable under Dr. Mike's section

########################### TOUGH GUY 2/PHYSICAL RESISTANCE #############################
# In collaboration with Shazam

def inittoughguy2(char,update=0):
    print 'inittoughguy2: char=<%s>' % (char,)
    if not isinstance(char,StringType): # called from RegTimer
        char = char.object
    invFraction = FFX_ObjectGetAttr(char,'tg2Fraction',0)
    if update==0:
        print 'inittoughguy2: initializing for %s' % (char,)
        FFX_ObjectSetAttr(char,'tg2Fraction',invFraction+0.5)
        FFX_ObjectSetAttr(char,'ivlastdam',Object_GetAttr(char,'health'))
        if not FFX_ObjectGetAttr(char,'DamageManagement',0):
            RegDamage(char,'DamageManagement')
            FFX_ObjectSetAttr(char,'DamageManagement',1)

############### Damage Refund Management Callback #########
# Currently used by Invulnerable, Temporary Invulnerability and Tough Guy 2
# stumpy 2007-12-16: added BODY ARMOR to the mix.

def DamageManagement(event):
    char=event.object
    lasthealth = FFX_ObjectGetAttr(char,'ivlastdam')

    # BODY ARMOR: invulnerability that wears down through repeated damage
    BAPoints = FFX_ObjectGetAttr(char,'BAPoints',0)
    if BAPoints > 0:
        health = Object_GetAttr(char,'health')
        damage = lasthealth - health
        if Object_IsAlive(char):
            if damage>0:
                payback=BAPoints
                if payback>damage:              # don't refund more damage than we took
                    payback=damage
                if payback+health > lasthealth: # don't bring char above pre-damage health
                    payback = lasthealth - health
                Object_SetAttr(char,'health',health+payback)
                if damage > BAPoints:
                    # took more damage than armor's rating, armor is damaged
                    BAPoints = max( BAPoints - int(0.99+0.10*(damage-BAPoints)), 0 )
                    FFX_ObjectSetAttr(char,'BAPoints',BAPoints)
        
    # toughguy2: fractional damage refund
    if FFX_ObjectGetAttr(char,'tg2Fraction',0) > 0.0:
        health = Object_GetAttr(char,'health')
        damage = lasthealth - health
        if Object_IsAlive(char):
            if damage>0:
                payback = int(damage*FFX_ObjectGetAttr(char,'tg2Fraction')+0.5)
                if payback>damage:              # don't refund more damage than we took
                    payback=damage
                if payback+health > lasthealth: # don't bring char above pre-damage health
                    payback = lasthealth - health
                Object_SetAttr(char,'health',health+payback)

    # invulnerability: flat damage refund
    if FFX_ObjectGetAttr(char,'invPoints',0):
        health = Object_GetAttr(char,'health')
        damage = lasthealth - health
        if Object_IsAlive(char):
            if damage>0:
                payback=FFX_ObjectGetAttr(char,'invPoints')
                if payback>damage:              # don't refund more damage than we took
                    payback=damage
                if payback+health > lasthealth: # don't bring char above pre-damage health
                    payback = lasthealth - health
                Object_SetAttr(char,'health',health+payback)

    FFX_ObjectSetAttr(char,'ivlastdam',Object_GetAttr(char,'health'))               
    RegDamage(char,'DamageManagement')




######################################## SEAT FILLER ##########################################

# stumpy 2007-12-21: see http://freedomreborn.net/simple/index.php?topic=45618.0
# This is for a character that players can choose to take on a mission
# when all they want is to take a smaller squad. So they can recruit a
# character (or more than one) with this attribute and, right after
# the character spawns, he vanishes, leaving the other "real"
# characters for the squad.

# FFEdit attribute name and cost: seatfiller -49 CP
# strings.txt entries
# attrib_seatfiller_01, seat filler
# attrib_seatfiller_desc_01, this character exists only to fill out the squad roster and will disappear as soon as he is spawned. (for use when you don't to take as many characters as required for the squad)

def initseatfiller(char,update=0):
    Object_Destroy(char)
    
######################################## SPEEDPHASER ##########################################

def initspeedphaser(char,update=0,remove=0):
    if remove:
        FFX_ObjectSetAttr(char,'speedphaser',0)
        return
    FFX_ObjectSetAttr(char,'speedphaser',1)
    RegCharState(char,PCSTATE_STATIC,'speedphaserupdate')
    RegCharState(char,PCSTATE_FROZEN,'speedphaserupdate')


def speedphaserupdate(event):
    char=event.object
    if not ( Object_Exists(char) and FFX_ObjectGetAttr(char,'speedphaser') ):
        return
    state = Object_GetPrimaryState(char)
    percentage=Object_GetAttr(char,'energyPoints') / max( 1.0, Object_GetAttr(char,'maxEnergyPoints') ) #Ep. 2006-08-30: prevented division by zero
    if (percentage>=0.5) and Object_IsAlive(char):
        effect = getByTemplate(char,FFX_SPEEDPHASER_CUSTOM,1)
        if effect:
            RegTimer('speedphaser_escape1',1,0,char)
        else:   # there was no effect to play
            RegTimer('speedphaser_escape2',2,0,char)
    else:
        RegCharState(char,state,'speedphaserupdate')

def speedphaser_escape1(event): # play escape animation
    char=event.object
    effect = getByTemplate(char,FFX_SPEEDPHASER_CUSTOM,1)
    try:
        handle = Object_PlayEffect(char,effect,'speedphaser_escape2')
        Object_StopEffect(char, handle-2)
        Object_StopEffect(char, handle-1)
    except:
        print 'speedphaserupdate(%s): unable to play effect %s' % (repr(char),repr(effect))

def speedphaser_escape2(event):
    char=event.object
    if not ( Object_Exists(char) and FFX_ObjectGetAttr(char,'speedphaser') ):
        return
    state = Object_GetPrimaryState(char)
    if state != PCSTATE_NORMAL: # check that we still need this
        Object_SetPrimaryState(char,state,0,REMOVE_STATE)
        RegTimer('landonfeet',0.1,0,char)
    RegCharState(char,state,'speedphaserupdate')

########################### ENCHANTER ###################################################
# By Stumpy, based on an idea by Taskmaster X and prototype code by SouperIan and Taskmaster X.
# *** stumpy: see http://freedomreborn.net/quattro/index.php?topic=37007
# This attribute allows the possessor to grant an attribute to another character.
# I think the original suggestion was for the attribute to be mutator (or something)
# but I wrote this so that it allows the attribute to be defined in a global called
# FFX_ENCHANTER_CUSTOM, defined in ffxcustoms.py.

# pimthe, 2006-09-23:
# - Added two other grades.
# - There is now a maximum of three different attributes that can be bestowed.
# - Implemented a "mana pool". 1 mana point = 1 attribute point cost which can be bestowed.
# - Duration is customizable for removable attributes; set to 0 to make permanent. Upon expiration, a portion
#   (relative to the duration) of a bestowed attribute's cost is refunded to the mana pool.
# - Optional side effect is customizable; set to "" to disable. Accepting a side effect doubles the mana pool points.
# - Range is customizable.
# Ep. 2007-03-24:
# - Refactored various elements to make maintenance and debugging easier by replacing redundant conditional calls
#   to FFX_ENCHANTERn_CUSTOM with a generic version.
# - Corrected an issue where refund was calculated incorrectly (inverted min and max).
# Ep. 2007-04-15:
# - The previous fix revealed and issue: Added error message if attributes cost too much; replaced
#   Enchanter3 default attributes so they fit under the pts cap and increased it to 1500 instead of 1000.

def initenchanter1(char, update=0, remove=0):
    FFX_ObjectSetAttr(char,'enchanter',1)
    PostInitEnchanter(char, remove, 400, 1)

def initenchanter2(char, update=0, remove=0):
    FFX_ObjectSetAttr(char,'enchanter',2)
    PostInitEnchanter(char, remove, 1000, 2)

def initenchanter3(char, update=0, remove=0):
    FFX_ObjectSetAttr(char,'enchanter',3)
    PostInitEnchanter(char, remove, 2000, 3)

def PostInitEnchanter(char, remove, manaPool, grade):
    if remove:
        FFX_ObjectSetAttr(char,'enchanter',0)
        RemoveEnchanterCmds(char, -100000)
        return
    enchanterCustomList = eval ( "FFX_ENCHANTER%i_CUSTOM" % grade )
    # If the enchanter is set to take side effects, double the available attribute points
    if getByTemplate(char, enchanterCustomList, -1) != '':
        manaPool = manaPool * 2
    FFX_ObjectSetAttr(char, 'enchanter_manapool', manaPool)
    RegTimer('SetEnchanterCmds',0.1,0,char)

def SetEnchanterCmds(event):
    char = event.object
    update = event.user
    grade = FFX_ObjectGetAttr(char,'enchanter',0)
    if not grade:
        return  # leave without setting timer event
    RegTimer('SetEnchanterCmds',2,1,char) #TEMP!!! should use a spawn event instead... or not: manaPool refunds wouldn't add back the attributes then, unless we add code for that
    if ( not Object_IsAlive(char) ) or ( not Object_GetClass(char) & OC_CONTROLLABLE ):
        return
    manaPool = FFX_ObjectGetAttr(char, 'enchanter_manapool')
    enchanterCustomList = eval ( "FFX_ENCHANTER%i_CUSTOM" % grade )
    range = getByTemplate(char, enchanterCustomList, 5)
    attributesDAT = datfiles.Campaign_ReadAttributes()
    item = 0           
    for attrib in ( getByTemplate(char, enchanterCustomList, 1), getByTemplate(char, enchanterCustomList, 2), getByTemplate(char, enchanterCustomList, 3) ):
        item = item + 1
        if attrib == '': # skip the rest for the current attrib
            continue
        if not attributesDAT.has_key(attrib):
            if not update:
                print "SetEnchanterCmds() non-fatal error for '%s':" % char
                print "    attribute '%s' not found in attributes.dat" % attrib
                Mission_StatusText("Error in Enchanter with '%s':" % getCharDisplayName(char))
                Mission_StatusText("attribute '%s' doesn't exist." % attrib)
            continue
        cost = attributesDAT[attrib]
        if cost > manaPool:
            if not update:
                print "SetEnchanterCmds() non-fatal error for '%s':" % char
                print "    attribute '%s' costs %i while max total is %i" % (attrib, cost, manaPool)
                Mission_StatusText("Error in 'enchanter' with '%s':" % getCharDisplayName(char))
                Mission_StatusText("attribute '%s' costs too much." % attrib)
            continue
        if ( 'Campaign_FindDisplayString' in dir(datfiles) ) and datfiles.Campaign_FindDisplayString('attrib_%s_01'%attrib):
            CmdName = 'bestow ' + datfiles.Campaign_FindDisplayString('attrib_%s_01'%attrib)
        else:
            CmdName = 'bestow ' + attrib
    ##    targets = list(filter(isCharacter,Mission_GetDynamicObjects()))
    ##    targets.remove(char)
#            for target in getAllTeammates(char):
        for target in Mission_GetObjects():
            if ((Object_GetClass(target) & FFX_CHARACTER)!=0) & (target!=char):
                if not hasAttribute(target, attrib): # avoid reducing manaPool if the target already has the attribute
                    Mission_RemoveCustomAction(CmdName,char,target)
                    Mission_CustomAction(CmdName, char, target, 'BestowEnchantment%i' % item, range, 1)

def RemoveEnchanterCmds(char, manaPool):
    if ( not Object_IsAlive(char) ) or ( not Object_GetClass(char)&OC_CONTROLLABLE ):
        return
    attributesDAT = datfiles.Campaign_ReadAttributes()
    enchanterCustomList = eval ( "FFX_ENCHANTER%i_CUSTOM" % FFX_ObjectGetAttr(char,'enchanter') )
    for attrib in ( getByTemplate(char,enchanterCustomList,1), getByTemplate(char,enchanterCustomList,2), getByTemplate(char,enchanterCustomList,3) ):
        if attrib == '':
            continue # skip the rest for the current attrib
        if not attributesDAT.has_key(attrib):
            continue
        # remove attributes costing more than the points the enchanter has got left in the pool
        if attributesDAT[attrib] > manaPool:
            cmdName = getEnchanterCommandName(attrib)
            #for target in getAllTeammates(char):
            for target in Mission_GetObjects():
                Mission_RemoveCustomAction(cmdName, char, target)

#get the display name of the attribute for the custom command
def getEnchanterCommandName(attrib):
    if ( 'Campaign_FindDisplayString' in dir(datfiles) ) and datfiles.Campaign_FindDisplayString('attrib_%s_01'%attrib):
        return 'bestow ' + datfiles.Campaign_FindDisplayString('attrib_%s_01'%attrib)
    else:
        return 'bestow ' + attrib

def BestowEnchantment1(target,enchanter):
    BestowEnchantment(target,enchanter, 1)

def BestowEnchantment2(target,enchanter):
    BestowEnchantment(target,enchanter, 2)

def BestowEnchantment3(target,enchanter):
    BestowEnchantment(target,enchanter, 3)

def BestowEnchantment(target,enchanter, attribNo):
    enchanterCustomList = eval ( "FFX_ENCHANTER%i_CUSTOM" % FFX_ObjectGetAttr(enchanter,'enchanter') )
    Object_PlayEffect( enchanter, getByTemplate(enchanter, enchanterCustomList, -2) )
    Trigger_Power(enchanter, target, 'ffx_blank', 'OnBestowEnchantment', 0, Get_ObjectPos(target), attribNo)

def OnBestowEnchantment(event):
    enchanter = event.string
    target = event.object
    attribNo = int(event.user)
    enchanterCustomList = eval ( "FFX_ENCHANTER%i_CUSTOM" % FFX_ObjectGetAttr(enchanter,'enchanter') )
    Object_PlayEffect( target, getByTemplate(enchanter, enchanterCustomList, -2) )
    attrib = getByTemplate(enchanter, enchanterCustomList, attribNo)
    cmdName = getEnchanterCommandName(attrib)
##    Mission_RemoveCustomAction(cmdName, enchanter, target)
    attribCost = max( 100, datfiles.Campaign_ReadAttributes()[attrib] ) #attributes will always cost at least 100 points, even if their value is less
    EPCost = max(attribCost/15,33)
    if not chargeEP(enchanter,EPCost):
        if EPCost > Object_GetAttr(enchanter, 'maxEnergyPoints'):
            Mission_StatusText("Enchanter error: attribute %s too costly" % attrib)
        return
    #do the optional FFX_SIDEEFFECTS penalty
    sideEffect = getByTemplate(enchanter, enchanterCustomList, -1)
    if sideEffect != '':
        RegTimer(sideEffect, 1, 0, enchanter) # note that user = 0 so we don't interfere with boost/miracle attributes
    #reduce the mana pool and remove commands which are too costly
    manaPool = max( 0, FFX_ObjectGetAttr(enchanter, 'enchanter_manapool') - attribCost )
    FFX_ObjectSetAttr(enchanter, 'enchanter_manapool', manaPool)
    Mission_StatusText('%s: %i pool: %i' % (attrib, datfiles.Campaign_ReadAttributes()[attrib], manaPool))
    RemoveEnchanterCmds(enchanter, manaPool)
    #add the attribute to the target
    ffxMultisList = map(lambda combo: combo[0],ffxMultis)
    if attrib in ffxMultisList: # if this is a combo
        attlist = ffxMultis[ffxMultisList.index(attrib)][1:]
    else:
        attlist = [attrib]
    success = 0
    for att in attlist:
        if hasAttribute(target, att) == 0:  # prevent doubling up
            success = addFFXAttrib(target, att)
            if success:
                print 'OnBestowEnchantment(%s,%s): added %s' % (repr(target),repr(enchanter),repr(att))
##                FFX_ObjectSetAttr(target, 'enchanter_%s' % att, 1) # identifies the attribute as being bestowed so we don't remove a "real" attribute later on
            else:
                print 'OnBestowEnchantment(%s,%s): unable to add %s' % (repr(target),repr(enchanter),repr(att))
        else:
            print 'OnBestowEnchantment(%s,%s): target already has attribute %s' % (repr(target),repr(enchanter),repr(att))
    #optionally remove the attribute after x seconds
    if success:
        duration = getByTemplate(enchanter, enchanterCustomList, 4)       
        if duration > 0:
            if attrib in ffxMultisList:
                if isComboAttributeRemovable(attrib):
                    for att in attlist:
                        RegTimer2('removeFFXAttrib', duration, (target, att))
                    RegTimer2('OnEnchantmentEnd', duration, (enchanter, target, duration, attribCost))
            else:
                if isAttributeRemovable(attrib):
                    RegTimer2('removeFFXAttrib', duration, (target, attrib))
                    RegTimer2('OnEnchantmentEnd', duration, (enchanter, target, duration, attribCost))

#play FX and add back 10 to 90% of the attribute's value to the enchanter's pool, based on duration
def OnEnchantmentEnd(enchanter, target, duration, attribCost):
    payback = max( attribCost * 0.1, attribCost * 15 / (duration + 5) )
    payback = min( attribCost * 0.9, payback )
    manaPool = FFX_ObjectGetAttr(enchanter, 'enchanter_manapool') + int(payback)
    Mission_StatusText('payback... mana pool: %i' % manaPool)
    FFX_ObjectSetAttr(enchanter, 'enchanter_manapool', manaPool)
    enchanterCustomList = eval ( "FFX_ENCHANTER%i_CUSTOM" % FFX_ObjectGetAttr(enchanter,'enchanter') )
    Object_PlayEffect( target, getByTemplate(enchanter, enchanterCustomList, -2) )
    RegTimer('OnEnchantmentEnd2', 0.5, 0, enchanter)

def OnEnchantmentEnd2(event):
    enchanter = event.object
    enchanterCustomList = eval ( "FFX_ENCHANTER%i_CUSTOM" % FFX_ObjectGetAttr(enchanter,'enchanter') )
    Object_PlayEffect( enchanter, getByTemplate(enchanter, enchanterCustomList, -2) )


################## RANDOM MUTATION ##################
### Part of Mutator originally built for bestowing random powers for Enchanter. To prevent having to make
### an unusable dummy Attribute, this is now an Attribute all on it's on that gives random powers to the
### character at the start of each mission that, unlike Mutator, last until the end of the mission.

def initrandommutation(char,update=0, remove=0):
    if remove:
        FFX_ObjectSetAttr(char, 'mutator', 0)
        removeprim(char, FFX_ObjectGetAttr(char, 'mut1'))
        removesecond(char, FFX_ObjectGetAttr(char, 'mut2'))        
        return
    FFX_ObjectSetAttr(char, 'mutator', 1)
    if (Object_GetClass(char)&OC_CHARACTER)==0:
        return
    p1=getmutation(primPowers)
    p2=getmutation(secondPowers)
    ffx.FFX_ObjectSetAttr(char,'mut1',p1)
    ffx.FFX_ObjectSetAttr(char,'mut2',p2)
    addprim(char,p1)
    addsecond(char,p2)


########################### STUMPY'S HELPERS #########################################

########################### RegTimer2
#
# For questions and comments, please go to
# http://freedomreborn.net/phpbb/viewtopic.php?t=2579
#
# Allows you to pass as many variables of any type that you want through by packing them into a tuple
# and using str() or repr() to convert that tuple into a string. Then just unpack the tuple string in
# the callback function using eval().
# If you use one or more modules frequently, there might be an efficiency improvement in adding it to
# the tryfirst list.
#
# Syntax example:
#   #Energize our valiant spaceman in three seconds
#   RegTimer2('Object_SetSecondaryState', 3.0, ('spiff',SCSTATE_ENERGIZED,10))
#
#   #will execute this function with these arguments after the 3 seconds:
#   Object_SetSecondaryState('spiff',SCSTATE_ENERGIZED,10)
#
# Note:
# Python doesn't recognize one-element tuples as such and read directly the element inside, unless there
# is a trailing comma. So if you use a single element as parameter in arglist, please add the comma after
# or add a dummy variable. (Of course, you could also use the standard RegTimer, either alone, if you know
# that there is always only one element in the tuple or, otherwise, with missionobjvar.Mission_SetVar() or
# missionobjvar.Object_SetVar().)

def RegTimer2(fn, time, arglist=(), persistent = 0):
    user = 0    # no real use for this
    args = repr(arglist)
    js.Event_RegisterSink(EVENT_TIMER, 'Timer2Unwrapper', fn, args, time, user, persistent)

def Timer2Unwrapper(event):
    fn = event.object
    arglist = event.string
    if '.' in fn:   # module was specified
        try:
            eval(fn+arglist)
        except:
            try:    # maybe we haven't imported it
                dotpos = len(fn)-2
                while fn[dotpos]!='.':  dotpos=dotpos-1
                module = fn[:dotpos]
                exec('import '+module)
                eval(fn+arglist)
            except:
                print 'RegTimer2: problem evaluating string %s' % repr(fn+arglist)
                raise
    else:   # no module specified: take some guesses then try them all
        success = 0
        tryfirst = ['ff.','cshelper.','ffx.']
        for module in tryfirst: # try the preferred modules
            try:
                eval(module+fn+arglist)
                success = 1
                break
            except:
                try:    # maybe we haven't imported it
                    exec('import '+module[:-1])
                    eval(module+fn+arglist)
                    success = 1
                    break
                except:
                    pass

        if not success:
            for module in sys.modules.keys():   # try all the imported modules
                try:
                    eval(module+'.'+fn+arglist)
                    success = 1
                    break
                except:
                    try:    # maybe we haven't imported it
                        exec('import '+module)
                        eval(module+'.'+fn+arglist)
                        success = 1
                        break
                    except:
                        pass
        if not success:
            print 'RegTimer2: unable to evaluate string %s in any module.' \
                  % repr(fn+arglist)
            raise


########################### SetMapLimits / Mission_GetMostObjects
#
# For questions and comments, please go to
# http://freedomreborn.net/phpbb/viewtopic.php?t=21640
#
# NOTE:
# These two functions try to read the mission.dat file of the current map, which should work with most
# mods and Danger Room missions. However, maps from the main FF campaign (either in campaign mode or while
# replaying a campaign episode in the Danger Room) usually won't have a readable mission.dat (see details
# below). To counter this, both functions will use an alternate method which doesn't rely on reading
# mission.dat. As such, the results may vary somewhat.
#
# Reading mission.dat: an explanation
# For these functions to work, there must actually be a mission.dat (or base.dat) file in the mission
# folder for whatever mission is running. I think that's usually true (at least in all the mods I've
# seen), but keep in mind that it is possible to distribute a mod with these files compressed (zipped)
# into .ff files that the engine decompresses internally (I assume) without putting the DAT file anywhere
# nice. That's what the main campaign does and you have to unzip the missions.ff file manually if you want
# to experiment with those missions using these functions.
#
# Related info available in datfiles.py

# Get the approximate size of the map by finding the min and max positions of stuff on the map
def SetMapLimits():
    try:  # stumpy: why not just reading the map extents directly?
        extents = datfiles.Mission_GetMapExtents()
        Mission_SetAttr ('iXMin', extents[3])
        Mission_SetAttr ('iXMax', extents[0])
        Mission_SetAttr ('iYMin', extents[4])
        Mission_SetAttr ('iYMax', extents[1])
        Mission_SetAttr ('iZMin', extents[5])
        Mission_SetAttr ('iZMax', extents[2])
    except IOError:
        markers = []
        objects = Mission_GetObjects()
        for tig in filter(lambda obj: Object_GetTemplate(obj)=='ffx_tiggot',
                          Mission_GetDynamicObjects()):
            objects.pop(objects.index(tig))
        pos_markers = map(Get_MarkerPos,markers)
        pos_objects = map(Get_ObjectPos,objects)
        xvals = map(lambda pos: pos[0], pos_markers)
        xvals.extend(map(lambda pos: pos[0], pos_objects))
        yvals = map(lambda pos: pos[1], pos_markers)
        yvals.extend(map(lambda pos: pos[1], pos_objects))
        zvals = map(lambda pos: pos[2], pos_markers)
        zvals.extend(map(lambda pos: pos[2], pos_objects))
        Mission_SetAttr ('iXMin', min(xvals))
        Mission_SetAttr ('iXMax', max(xvals))
        Mission_SetAttr ('iYMin', min(yvals))
        Mission_SetAttr ('iYMax', max(yvals))
        Mission_SetAttr ('iZMin', min(zvals))
        Mission_SetAttr ('iZMax', max(zvals))

def flytracker(char):
    Object_SetAttr(char,'flytrack',1)
    name='%s_ft'%(char)
    cshelper.spawn(name,'ffx_tiggot',char)
    RegTimer('flytrack',1,0,char)

def flytrack(event):
    char=event.object
    name='%s_ft'%(char)
    Object_SetAttr(char,'flytrack',1+Object_GetAttr(char,'flytrack'))
    Trigger_Power(name,char,'ffx_flytrack','OnFlyTrackBeam')
    RegTimer('flytrack',1,0,char)

def OnFlyTrackBeam(event):
    char=event.object
    Mission_StatusText('flytrack: code=%d'%(Object_GetAttr(char,'flytrack')))
    Object_SetAttr(char,'flytrack',-1)


########################### Get Base Health
# stumpy: Find the base maximum health the object would have, *before* any FFX modifications
def GetBaseHealth(obj):
   baseEnd = GetCharacterData(obj)['endurance']
   attribs = Character_HasAttribute(obj,'nimble')
   bonus = 1 - 0.10*Character_HasAttribute(obj,'nimble') + 0.10*Character_HasAttribute(obj,'slow moving')
   if Object_GetClass(obj) & OC_CONTROLLABLE:  # this is a player-controlled char
       return int ( bonus * ( baseEnd**2 + baseEnd + 2 ) * 5 )
   else:
       diff6health = (15,30,60,105,165,480,660,870,1110,1380)
       diffdiv = (0, 9, 4, 3, 2, 1.5, 1, 0)     # the 0s are a check since difficulty should never be outside 1..6
       return int( bonus * diff6health[baseEnd]/diffdiv[int(ff.RPG_GAME_DIFFICULTY)] )



################### DR MIKE'S FINAL ADDITIONS #####################
    
################## NEXUS TEST STUFF ###############################
#
#   E=FX, X=Explosion power, D=Dummy Ranged power, C=Command Name
#
#FFX_OVERHEATED_CUSTOM=[
#["default","effect_ffx_flames","ffx_overheated"],
#["types","EFX","XExplosion"],
#]
#
#FFX_ENVCONTROLA_CUSTOM=[
#["default","ffx_earth_control2","CUSTOM_MAGMAVENT","ffx_geovent","ffx_firestorm"],
#["types","DDummy Power","CCommand","OObject","XExplosion"],
#]
####################################################################

FFX_ATTRIBUTES=['OVERHEATED','ENVCONTROLA']
FFX_NEXUS_FX=['effect_ffx_flames','effect_ffx_density','effect_ffx_electricsparks']
FFX_NEXUS_AREA=['ffx_frostbite','ffx_exile_area']
FFX_NEXUS_DUMMY=['ffx_tk_lift','ffx_tk_lift2']

def initnexus():
    cshelper.peace()
    RPG_SetActive(0)
    y=-20
    addEntries('FFX_NEXUS_FX','E')
    addEntries('FFX_NEXUS_AREA','X')
    addEntries('FFX_NEXUS_DUMMY','D')
    for fx in FFX_NEXUS_FX:
        print fx
        cshelper.spawn(fx,'ffx_nexusobj_fx',(-60,y,0))
        y=y+20
        Object_PlayEffect(fx,fx,'',FX_LOOP)
    y=-40
    for area in FFX_NEXUS_AREA:
        print area
        cshelper.spawn(area,'ffx_nexusobj_area',(60,y,0))
        y=y+40
        RegTimer('OnNexusArea',randint(100,500)/100,0,area)
    y=-40
    for power in FFX_NEXUS_DUMMY:
        print power
        cshelper.spawn(power,'ffx_nexusobj_dummy',(120,y,0))
        tgt='tgt%s'%(power)
        cshelper.spawn(tgt,'barrel',(180,y,0))
        y=y+40
        RegTimer('OnNexusDummy',randint(100,500)/100,0,power,tgt)

def addEntries(name,code):
    print 'addentries:%s'%(name)
    list=[]
    exec('list=%s'%(name))
    for att in FFX_ATTRIBUTES:
        array=[]
        exec('array=FFX_%s_CUSTOM'%(att))
        if len(array)>=2:
            count=len(array[1])
            if array[1][0]=='types':
                for set in array:
                    if set[0]!='types':
                        for i in range(1,count):
                            if array[1][i][0]==code:
                                print set[i]
                                value=set[i]
                                match=0
                                for item in list:
                                    if item==value:
                                        match=1
                                if match==0:
                                    exec('ffx.%s.append(value)'%(name))

def OnNexusArea(event):
    area=event.object
    Trigger_Explosion(area,area)
    RegTimer('OnNexusArea',5,0,area)

def OnNexusDummy(event):
    power=event.object
    tgt=event.string
    print 'OnNexusDummy:%s->%s'%(power,tgt)
    Trigger_Power(power,tgt,power,'')
    RegTimer('OnNexusDummy',5,0,power,tgt)

def saveNexus():
    f1 = open('data/missions/scripts/ffocustom.py', 'w')
    for att in FFX_ATTRIBUTES:
        saveNexusArray(att,f1)
    f1.close()

def saveNexusArray(name,f1):
    f1.write('FFX_%s_CUSTOM=[\n'%(name))
    array=[]
    exec('array=FFX_%s_CUSTOM'%(name))
    for set in array:
        line='%s,\n'%(set)
        for i in range(0,len(line)):
            if line[i]=="'":
                f1.write('"')
            elif line[i]!=' ':
                f1.write(line[i])
    f1.write(']\n\n')

def addNexusCommands(char,array,arrayName):
    if len(array)<=1:
        Mission_StatusText('command array %s does not have enough entries'%(arrayName))
        return
    types=array[1]
    if types[0]!='types':
        Mission_StatusText('command array %s does not have types entries'%(arrayName))
        return
    index=0
    for entry in types:
        if entry!='types':
            cmd='%s: pick %s'%(arrayName,entry[1:])
            if entry[0]=='E':
                fn='OnChooseObjName%s%d'%(arrayName,index)
# TODO - write this out to nexuscmd.py?
#                comd="def %s(target,char): SetCustomEntryByName(target,char,'%s',%d)"%(fn,arrayName,index)
#                print comd
#                exec comd
                Mission_CustomAction(cmd,char,'ffx_nexusobj_fx',fn,30,0)
            elif entry[0]=='X':
                fn='OnChooseObjName%s%d'%(arrayName,index)
                Mission_CustomAction(cmd,char,'ffx_nexusobj_area',fn,30,0)
            elif entry[0]=='D':
                fn='OnChooseObjName%s%d'%(arrayName,index)
                Mission_CustomAction(cmd,char,'ffx_nexusobj_dummy',fn,30,0)
        index=index+1

def OnChooseObjNameOVERHEATED1(target,char):
    SetCustomEntryByName(char,target,'OVERHEATED',1)
    RefreshChar(char)

def OnChooseObjNameOVERHEATED2(target,char):
    SetCustomEntryByName(char,target,'OVERHEATED',2)

def OnChooseObjNameENVCONTROLA1(target,char):
    SetCustomEntryByName(char,target,'ENVCONTROLA',1)

def OnChooseObjNameENVCONTROLA4(target,char):
    SetCustomEntryByName(char,target,'ENVCONTROLA',4)

def RefreshChar(char):
    name=getFormName()
    morph(name,char,Object_GetTemplate(char))

##########################
#
# eg SetCustomEntryByName(char,target,'OVERHEATED',1)
#
##########################

def SetCustomEntryByName(char,value,arrayName,index):
    cmd="SetCustomEntry(char,value,ffxcustom.FFX_%s_CUSTOM,arrayName,index)"%(arrayName)
    exec(cmd)

def SetCustomEntry(char,value,array,arrayName,index):
    template=FFX_GetTemplate(char)
    row=0
    myRow=-1
    for set in array:
        if set[0]==template:
           myRow=row
        row=row+1
    if myRow==-1:
        newSet=[template,]
        for elem in array[0]:
            if elem!='default':
                newSet.append(elem)
        cmd="ffxcustom.FFX_%s_CUSTOM.append(newSet)"%(arrayName)
        exec(cmd)
        myRow=row
    cmd="ffxcustom.FFX_%s_CUSTOM[myRow][index]=value"%(arrayName)
    exec(cmd)

#spawns, writes out template to log file (even for customs) and aligns with obj
def FFX_Spawn(name,template,obj,anim=1):
    cshelper.spawn(name,template,obj)
    alignWith(name,obj)
    if anim and Object_GetClass(name)&FFX_CHARACTER:
        aname='a%s'%(name)
        cshelper.spawn(aname,'ffx_tiggot',(-6000,-6000,0))
        AI_Animate(aname,template)
        Object_Destroy(aname)
    #RegTimer('FFX_alignWithEvent',0.01,anim,name,obj)
    #if anim: RegTimer('FFX_Spawn2',0.1,anim, name, template)
    
def FFX_Spawn2(event):
    name, anim, template = event.object, event.user, event.string
    if anim and Object_GetClass(name)&FFX_CHARACTER:
        aname='a%s'%(name)
        cshelper.spawn(aname,'ffx_tiggot',(-6000,-6000,0))
        AI_Animate(aname,template)
        Object_Destroy(aname)

def FFX_alignWithEvent(event):
    alignWith(event.object, event.string)

def alignWith(char,obj):
    angle=-(Object_GetOrientation(obj)[1])*57.3
    Object_SetOrientation(char,angle,(0,0,1))

################# GRENADE TRACKING HEURISTICS ########################

lastMissiles=[]
staticMissiles=[]

def projCheck(event):
    missiles=[]
    ffx.staticMissiles=[]
    RegTimer('projCheck',0.01)
    for obj in getAll('projectile_standin'):
        pos=Get_ObjectPos(obj)
        if Object_GetAttr(obj,'lastX')==-6000:
            Object_SetAttr(obj,'lastX',pos[0])
        if Object_GetAttr(obj,'lastY')==-6000:
            Object_SetAttr(obj,'lastY',pos[1])
        missile=[obj,(pos[0],pos[1],pos[2])]
        missiles.append(missile)
        for set in ffx.lastMissiles:
            if set==missile:
                missile.append((Object_GetAttr(obj,'lastX'),Object_GetAttr(obj,'lastY')))
                ffx.staticMissiles.append(missile)
    ffx.lastMissiles=missiles

def findMissile(event):
    char=event.object
    fn=event.string
    pos=Get_ObjectPos(char)
    res=''
    #reasonable distance a character can move in 0.2 seconds...
    mindist=20000
    for set in ffx.staticMissiles:
        dx=pos[0]-set[2][0]
        dy=pos[1]-set[2][1]
        dist=dx*dx+dy*dy
        print '%s:%d'%(set[0],dist)
        if dist<mindist:
            res=set[0]
            mindist=dist
    print 'findMissile:res=%s'%(res)
    if res!='':
        RegTimer(fn,0.1,0,res)

#        FFX_ObjectSetAttr(res,'_x',set[1][0])
#        FFX_ObjectSetAttr(res,'_y',set[1][1])
#        FFX_ObjectSetAttr(res,'_z',set[1][2])
#        FFX_ObjectSetAttr(res,'_src',Object_GetAttr(char,'ffxID'))
#        RegTimer('checkForProjEnd',0.1,0,fn,res)
#        RegTimer('checkForProjEnd',0.01,0,fn,res)

def checkForProjEnd(event):
    proj=event.string
    fn=event.object
    if Object_Exists(proj)==0 or event.user==1:
        print 'grenade has vanished!'
        x=FFX_ObjectGetAttr(proj,'_x')
        y=FFX_ObjectGetAttr(proj,'_y')
        z=FFX_ObjectGetAttr(proj,'_z')
        list=[]
        mask=FFX_CHARACTER
        if fn[-5:]=='throw' or fn[-4:]=='pull' or fn[-4:]=='port':
            list=Mission_GetObjects()
            mask=mask|OC_GENERIC
        else:
            list=Mission_GetDynamicObjects()
        source=findCharByID(FFX_ObjectGetAttr(proj,'_src'))
        for obj in list:
            if Object_GetClass(obj)&mask:
                pos=Get_ObjectPos(obj)
                dx=x-pos[0]
                dy=y-pos[1]
                if dx*dx+dy*dy<40000:
                    print 'checking:%s for %s (%s)'%(obj,fn,source)
                    RegTimer(fn,0.01,1,obj,source)
    elif event.user==0:
        RegTimer('checkForProjEnd',0.1,0,fn,proj)

############# GRENADE SWAPS #########################################

#def hextocrystalliseG(event):
#    grenadehit(event.string,event.object,'hextocrystallise')

def grenadehit(source,target,fn):
    projCheck(event)
    RegTimer('findMissile',0.2,0,source,fn)

def grenadetomagnetpull(event):
    print 'grenadetomagnetpull'
    grenadehit(event.string,event.object,'displacetomagnetpull')

def grenadetopull(event):
    grenadehit(event.string,event.object,'displacetopull')

def writeobj():
    for obj in Mission_GetObjects():
        print Object_GetTemplate(obj)

############### LIGHTING FIX #########################################

def initLightingFixCommands():
    for hero in getAllHeroes():
        addCommandChars('CUSTOM_FIXLIGHTING',hero,'OnLightingFix',100,0)
    RegTimer('updateLF',5)

def updateLF(event):
    for hero in getAllHeroes():
        addCommandChars('CUSTOM_FIXLIGHTING',hero,'OnLightingFix',100,1)
    RegTimer('updateLF',5)

def getMesh(template):
    mesh=''
    for meshPair in ffxMeshes:
        if meshPair[0]==template:
            mesh=meshPair[1]
    return mesh

def OnLightingFixRetry(event):
    OnLightingFix(event.object,'')

def OnLightingFix(target,dummy):
    mesh=getMesh(Object_GetTemplate(target))
    if mesh=='':
        AI_Animate(target,Object_GetTemplate(target))
        RegTimer('parseLogFile',0.8)
        RegTimer('OnLightingFixRetry',3,0,target)
    else:
        print mesh
        print GetWinTempPath()
        print GetFFPath()
        path=GetFFPath()+"\\data\\art\\"+mesh+"character.nif"
        print path
        try:
            ChangeLighting(path)
        except:
            print '...'
        path=GetFFPath()+"\\ffx3\\art\\"+mesh+"character.nif"
        print path
        try:
            ChangeLighting(path)
        except:
            print '...'
        path=GetFFPath()+"\\%s\\art\\"+mesh+"character.nif" % sysutils.getModFolder() ###! Ep 2006-05-06: added mod path auto-detection
        print path
        try:
            ChangeLighting(path)
        except:
            print '...'
        path=GetWinTempPath()+"\\custom\\art\\"+mesh+"character.nif"
        print path
        try:
            ChangeLighting(path)
        except:
            print '...'

################## MAIN SKIRMISH LOOP #####################

arrowedBadGuy=''

def FFX_SkirmishCheck(event):
    RegTimer('FFX_SkirmishCheck',1)

    #remove standard skirmish arrows:
    targets = getAllByPrefix('_sk')
    for target in targets:
        removeArrow(target + "_arrow")

    #check for badguys
    threat=0
    oldthreat=0
    if ffx.arrowedBadGuy!='':
        oldthreat=1
        if Object_Exists(ffx.arrowedBadGuy)==0:
            ffx.arrowedBadGuy=''
#           Mission_StatusText('non-existant')
        else:
            if not Object_IsAlive(ffx.arrowedBadGuy):
                ffx.arrowedBadGuy=''
#               Mission_StatusText('dead')
            else:   # stumpy 2006-10-10: don't call GetTeam() on KOed
                if m25ai.GetTeam(ffx.arrowedBadGuy)==m25ai.TEAM_GOODGUYS:
                    ffx.arrowedBadGuy=''
#                   Mission_StatusText('one of us')
    for obj in Mission_GetDynamicObjects():
        if Object_IsAlive(obj) and m25ai.GetTeam(obj)>m25ai.TEAM_GOODGUYS:  # stumpy 2006-10-10:  check KOed first
#           print '%s is a threat'%(obj)
            threat=1
            if ffx.arrowedBadGuy=='':
#               Mission_StatusText('arrowing %s'%(obj))
                ffx.arrowedBadGuy=obj
                removeArrow('_sk_arrow')
                addArrow('_sk_arrow',obj)
    if threat==0 and oldthreat!=0:
        print 'FFX_SkirmishCheck: calling BadGuys fn'
        ff.OnNoMoreBadGuys()

def classTest(mask):
    for o in Mission_GetObjects():
        if Object_GetClass(o)&mask:
            print '%s(%s)'%(o,Object_GetTemplate(o))

####### stores pre-cached power IDs for powers ########

def generatePowerIDs():
    ffxpowerids.powerIDs=[]
    powers=datfiles.Campaign_ReadPowers()
    i=0
    for power in powers.keys():
        pdata=powers[power]
        if pdata['PowerType'] == PT_MELEE or pdata['PowerType'] == PT_RANGED:
            ffxpowerids.powerIDs.append([power,i,0])
            powerTest(power,i)
            i=i+1
    RegTimer('powerfin',10)

def powerfin(event):
    Mission_StatusText('writing powerIDs to file')
    print ffxpowerids.powerIDs
    ###! 2006-05-06 Ep: write to the current mod's ffxpowerid.py's rather than the hardcoded ffx3 one
    modfolder = sysutils.getModFolder()
    print "POWER ID Generator powerfin() will write to '%s/ffxpowerids.py' folder" % modfolder
    file=open("%s/missions/scripts/ffxpowerids.py" % modfolder,"w")
    file.write('powerIDs=[\n')
    for set in ffxpowerids.powerIDs:
        file.write(`set`+',\n')
    file.write(']\n')
    file.close()
    RegTimer('EndLevel',3)

def EndLevel(event):
    Mission_Win()

def powerTest(powerName,i):
    y=30+FFX_ObjectGetAttr('gun','y',6000)
    FFX_ObjectSetAttr('gun','y',y)
    gun='ffxgun'
    target='ffxtarget'
    Trigger_Power(gun,target,powerName,'OnPowerTest2',0,Get_ObjectPos(target),i)
    js.AI_NullController(gun)

def OnPowerTest2(event):
    for set in ffxpowerids.powerIDs:
        if set[1]==event.user:
            set[2]=event.float

###################### FFX 3.05 alpha ATTRIBUTES #########################################

############ adaptation (active) ##########################

def initadaptive2(char,update=0):
    Mission_CustomAction('CUSTOM_ADAPT',char,char,'OnAdapt',5,0)
    FFX_ObjectSetAttr(char,'adapted',0)

def OnAdapt(dummy,char):
    if FFX_ObjectGetAttr(char,'adapted'):
        FFX_ObjectSetAttr(char,'adapted',0)
        Object_SetGenericState(char,OBJSTATE_ALTERED_STRUCTURE,0,REMOVE_STATE)
    else:
        FFX_ObjectSetAttr(char,'adapted',1)
        Object_SetGenericState(char,OBJSTATE_ALTERED_STRUCTURE,10000,0)

################## magnetic induction #######################

def initinduction(char,update=0):
    Object_SetAttr(char,'lastHealthIN',Object_GetAttr(char,'health'))
    RegDamage(char,'OnInduction')

def OnInduction(event):
    char=event.object
    damage=Object_GetAttr(char,'lastHealthIN')-Object_GetAttr(char,'health')
    if damage>0:
        Trigger_Explosion(char,'ffx_blankarea')
        RegTimer('magnetiseCheck',1,1+damage*0.05,char)
    Object_SetAttr(char,'lastHealthIN',Object_GetAttr(char,'health'))
    RegDamage(char,'OnInduction')

###################### vehicle and driver ##########################
# Dr. Mike's code, with some bugfixes and tweaks by Ep. inspired by Thor Reborn.
# Updated FFX 3.3 alpha
# status: 2.0
# TODO: M25 AI character code (yeah, right).

### Driver / Vehicle customization updated to include more options; this breaks the version in FFX 3.2 - using fallback code for this, though.
# Valid interface method names are "beside", "inside", "spawn" and "away"; set the default to "beside"
# contrarily to Dr Mike's intention, since his Driver demo character CatLaser also has the Utility Belt attribute.
# beside: vehicle appears next to driver
# inside: vehicle replaces driver
# away: vehicle is away and will need to be called
# spawn: vehicle pops out of thin air when called


def initvehicle(char,update=0):
    #remove a portrait if there is one
    FFX_AdjustPortrait(char,0)
    Object_SetAttr(char,'heroPoints', 0) #Ep.: I suppose the idea with this line was to prevent issues with "destroyed" vehicles

def initdriver(char,update=0):
    #find their vehicle
    template=getVehicle(char)
    name=getFormName()
    pos=Get_ObjectPos(char)
    try: #for compatibility with the shorter list format in FFX 3.2
        method = getByTemplate(char, FFX_DRIVER_CUSTOM, 4)
    except:
        method = 'beside'
        print "Driver attribute non-fatal error:"
        print "    '%' is not a valid interface method name, Please update yout FFX_DRIVER_CUSTOM configuration." % method
    if method == 'inside':
        RegTimer('OnSetVehicleInside', 0.5, 0, name)
    elif method == 'beside':
        pos = (pos[0]+30, pos[1]+30, pos[2])
    elif method == 'away':
        RegTimer('OnSetVehicleAway', 2.5, 0, name) #increased delay is necessary to get the vehicle to move all the way
    elif method == 'spawn':
        RegTimer('OnSetVehicleSpawn', 0.5, 0, name)
    else:
        Mission_StatusText('driver attribute error: invalid method %s' % method)
        print 'driver attribute fatal error:'
        print "    '%' is not a valid interface method name" % method
        return
    cshelper.spawn(name, template, pos)
    if (method == 'away') or (method == 'spawn'):
        #vehicle invisibility should kick in immediately 
        Object_SetSecondaryState(name, SCSTATE_INVISIBLE, 10000, 0)
    alignWith(name, char)
    Mission_CustomAction('CUSTOM_ENTERVEHICLE',char,name,'OnEnterVehicle',5,0)
    Mission_CustomAction('CUSTOM_EXITVEHICLE',name,name,'OnExitVehicle',5,0)
    Object_SetVar(name,'vehicle_getDriver',char)
    AIDisable(name)

#Ep. 2007-08-16: adds a delay to make OnEnterVehicle() work
def OnSetVehicleInside(event):
    target = event.object
    char = Object_GetVar(target, 'vehicle_getDriver')
    OnEnterVehicle(target, char)

def OnSetVehicleAway(event):
    vehicle = event.object
    driver = Object_GetVar(vehicle, 'vehicle_getDriver')
    Object_SetVar(driver, 'driver_getVehicle', vehicle)
    #vehicle should be invisible when first sent away
    Object_SetSecondaryState(vehicle, SCSTATE_DISPLACE_IMAGE, 10000, 0)
    OnUnsummonVehicleAway(vehicle, driver)

def OnSummonVehicleAway(driver, dummy):
    vehicle = Object_GetVar(driver, 'driver_getVehicle')
    #make the vehicle reappear if needed
    Object_SetSecondaryState(vehicle, SCSTATE_DISPLACE_IMAGE, 0, REMOVE_STATE)
    Object_SetSecondaryState(vehicle, SCSTATE_INVISIBLE, 0, REMOVE_STATE)
    #recall the vehicle
    pos = Get_ObjectPos(driver)
    movementType = m25ai.AIDetermineMoveType(vehicle, "", 10000) #flying vehicles should fly
    Trigger_Move(vehicle, movementType, (pos[0]+30, pos[1]+30, pos[2]+20))
    Mission_CustomAction('CUSTOM_UNSUMMONVEHICLE', driver, vehicle, 'OnUnsummonVehicleAway', 50, 1)

def OnUnsummonVehicleAway(vehicle, driver):
    #make the vehicle go away
    movementType = m25ai.AIDetermineMoveType(vehicle, "", 10000)
    Trigger_Move(vehicle, movementType, getNearestMapSide(vehicle))
    Mission_CustomAction('CUSTOM_SUMMONVEHICLE', driver, driver, 'OnSummonVehicleAway', 1, 1)

def OnSetVehicleSpawn(event):
    vehicle = event.object
    driver = Object_GetVar(vehicle, 'vehicle_getDriver')
    Object_SetVar(driver, 'driver_getVehicle', vehicle)
    OnUnsummonVehicleSpawn(vehicle, driver)

def OnSummonVehicleSpawn(driver, dummy):
    vehicle = Object_GetVar(driver, 'driver_getVehicle')
    pos = Get_ObjectPos(driver)
    pos = (pos[0]+30, pos[1]+30, pos[2])
    FFX_Teleport(vehicle, pos)
    alignWith(vehicle, driver)
    #make the vehicle reappear
    Object_SetPrimaryState(vehicle, PCSTATE_EXILE, 0, REMOVE_STATE)
    Object_SetSecondaryState(vehicle, SCSTATE_INVISIBLE, 0, REMOVE_STATE)
    Mission_CustomAction('CUSTOM_UNSUMMONVEHICLE', driver, vehicle, 'OnUnsummonVehicleSpawn', 5, 1)

def OnUnsummonVehicleSpawn(vehicle, driver):
    #make the vehicle disappear
    Object_SetPrimaryState(vehicle, PCSTATE_EXILE, 10000, 0)
    Object_SetSecondaryState(vehicle, SCSTATE_INVISIBLE, 10000, 0)
    Mission_CustomAction('CUSTOM_SUMMONVEHICLE', driver, driver, 'OnSummonVehicleSpawn', 1, 1)

def OnEnterVehicle(vehicle, driver):
    #make the driver disappear
    Object_SetPrimaryState(driver, PCSTATE_EXILE, 10000, 0)
    Object_SetSecondaryState(driver, SCSTATE_INVISIBLE, 10000, 0)
    FFX_AdjustPortrait(driver, 0)
    RegTimer('OnEnterVehicle2', 2, 0, vehicle) #Increased delay to reduce risk of losing control of character
    regDeath(vehicle, 'OnVehicleDie')
    #for passengers; would need to be updated if Driver ever gets M25 AI
    maxMass = float( getByTemplate(vehicle, FFX_VEHICLE_CUSTOM, 1) ) / 2.2
    FFX_ObjectSetAttr(vehicle, 'vehiclePassengerMass', 0)
    for hero in GetAllHeroes():
        if hero not in (driver, vehicle):
            if Object_GetAttr(hero, 'mass') <= maxMass:
                Mission_CustomAction('CUSTOM_PASSENGERINVEHICLE', hero, vehicle, 'OnPassengerEnterVehicle', 5, 0)

#used for both entering (where target is the vehicle) and exiting (where it's the driver)
def OnEnterVehicle2(event):
    target=event.object
    FFX_AdjustPortrait(target,1)
    Mission_SelectHero(target)
    AIEnable(target)

def OnPassengerEnterVehicle(vehicle, passenger):
    if not FFX_HasPortrait(vehicle):
        Mission_StatusText("Wait for the driver!")
        return
    maxMass = float( getByTemplate(vehicle, FFX_VEHICLE_CUSTOM, 1) ) / 2.2
    currentMass = FFX_ObjectGetAttr(vehicle, 'vehiclePassengerMass')
    passengerMass = Object_GetAttr(passenger, 'mass')
    if (currentMass + passengerMass) > maxMass:
        Mission_StatusText("Not enough place left in vehicle!")
        Mission_StatusText("Left: %i  you: %i" % ( (maxMass-currentMass)*2.2, passengerMass*2.2 ))
        return
    FFX_ObjectGetAttr(vehicle, 'vehiclePassengerMass', currentMass + passengerMass)
    #make the passenger disappear
    Object_SetPrimaryState(passenger, PCSTATE_EXILE, 10000, 0)
    Object_SetSecondaryState(passenger, SCSTATE_INVISIBLE, 10000, 0)
    FFX_AdjustPortrait(passenger, 0)
    currentPassengers = missionobjvar.Object_GetVar(vehicle, 'vehicle_getPassengers', {'passenger1': '', 'passenger2': '', 'passenger3': '', })
    nbr = 0
    #simulates an ordered dictionary
    while nbr < 4:
        nbr = nbr + 1
        k = 'passenger%i'%nbr
        if currentPassengers[k] == '':
            currentPassengers[k] = passenger
            break
    missionobjvar.Object_SetVar(vehicle, 'vehicle_getPassengers', currentPassengers)
    Mission_CustomAction('drop %s' % getCharDisplayNameFromDAT(passenger), vehicle, vehicle, 'OnPassenger%iExitVehicle'%nbr, 1, 1)

def OnPassenger1ExitVehicle(vehicle, dummy):
    OnPassengerXExitVehicle(vehicle, 1)

def OnPassenger2ExitVehicle(vehicle, dummy):
    OnPassengerXExitVehicle(vehicle, 2)

def OnPassenger3ExitVehicle(vehicle, dummy):
    OnPassengerXExitVehicle(vehicle, 3)

# find the passenger associated with the custom command and remove it for the dictionary
def OnPassengerXExitVehicle(vehicle, nbr):
    currentPassengers = missionobjvar.Object_GetVar(vehicle, 'vehicle_getPassengers')
    passenger = currentPassengers['passenger%i'%nbr]
    currentPassengers['passenger%i'%nbr] = ''
    missionobjvar.Object_SetVar(vehicle, 'vehicle_getPassengers', currentPassengers)
    OnPassengerExitVehicle(vehicle, passenger)

def OnPassengerExitVehicle(vehicle, passenger):
    currentMass = FFX_ObjectGetAttr(vehicle, 'vehiclePassengerMass')
    passengerMass = Object_GetAttr(passenger, 'mass')
    FFX_ObjectGetAttr(vehicle, 'vehiclePassengerMass', currentMass - passengerMass)
    pos = Get_ObjectPos(vehicle)
    posOffset = (-50, -40, -30, 30, 40, 50)
    pos = (pos[0] + posOffset[randint(0,5)], pos[1] + posOffset[randint(0,3)], pos[2])
    FFX_Teleport(passenger, pos)
    alignWith(passenger, vehicle)
    Object_SetPrimaryState(passenger, PCSTATE_EXILE,0,REMOVE_STATE)
    Object_SetSecondaryState(passenger, SCSTATE_INVISIBLE,0,REMOVE_STATE)
    RegTimer('OnEnterVehicle2', 0.5, 0, passenger)

def OnVehicleDie(event):
    vehicle=event.object
    driver=Object_GetVar(vehicle,'vehicle_getDriver')
    Mission_RemoveCustomAction('CUSTOM_ENTERVEHICLE',driver,vehicle)
    RegTimer('OnVehicleDie2', 0.2, 0, vehicle)
    if FFX_HasPortrait(vehicle):
        OnExitVehicle('',vehicle)

def OnVehicleDie2(event):
    vehicle=event.object
    Trigger_Explosion(vehicle, 'ffx_ex_fire_small')
    Object_PlayEffect(vehicle, 'effect_buildingfire', '', 0, 0, 'centre')

def OnExitVehicle(dummy,vehicle):
    #figure out who our driver is...
    driver = Object_GetVar(vehicle, 'vehicle_getDriver')
    pos = Get_ObjectPos(vehicle)
    pos = (pos[0]+30, pos[1]+30, pos[2])
    FFX_Teleport(driver, pos)
    alignWith(driver, vehicle)
    Object_SetPrimaryState(driver, PCSTATE_EXILE,0,REMOVE_STATE)
    Object_SetSecondaryState(driver, SCSTATE_INVISIBLE,0,REMOVE_STATE)
    FFX_AdjustPortrait(vehicle, 0)
    AIDisable(vehicle)
    RegTimer('OnEnterVehicle2', 0.5, 0, driver)
    #drop all passengers still in vehicle
    currentPassengers = missionobjvar.Object_GetVar(vehicle, 'vehicle_getPassengers', {'passenger1': '', 'passenger2': '', 'passenger3': '', })
    for k in currentPassengers.keys():
        if currentPassengers[k] != '':
            OnPassengerExitVehicle(vehicle, currentPassengers[k])
            currentPassengers[k] = ''
    missionobjvar.Object_SetVar(vehicle, 'vehicle_getPassengers', currentPassengers)
    #remove custom commands from former and would-be passengers - doesn't work?
    for hero in GetAllHeroes():
        Mission_RemoveCustomAction('CUSTOM_PASSENGERINVEHICLE', hero, vehicle)
    for hero in getAllDisabledCharacters(): #not really the list of heroes (disabled don't have portraits), but rather of every disabled char
        Mission_RemoveCustomAction('CUSTOM_PASSENGERINVEHICLE', hero, vehicle) # repeats the for hero in GetAllHeroes() above in case of timing issues
        Mission_RemoveCustomAction('drop %s' % getCharDisplayNameFromDAT(hero), vehicle, vehicle)
    try: #for compatibility with the shorter list format in FFX 3.2
        method = getByTemplate(driver, FFX_DRIVER_CUSTOM, 4)
    except:
        method = 'beside'
    if method == 'spawn':
        Mission_CustomAction('CUSTOM_SUMMONVEHICLE', driver, driver, 'OnSummonVehicleSpawn', 1, 1)
    elif method == 'away':
        Mission_CustomAction('CUSTOM_SUMMONVEHICLE', driver, driver, 'OnSummonVehicleAway', 1, 1)

#Ep. 2006-03-31: Added optional randomisation, using the unused list entries. Inspired by a request by Benton Grey.
def getVehicle(char):
    templates = []
    for i in (1, 2, 3):
        temp = getByTemplate(char, FFX_DRIVER_CUSTOM, i)
        if temp != '':
            templates.append(temp)
    return templates[ randint(0, len(templates)-1) ]

############### spellcaster ############################

def initspellcaster(char,update=0):
    FFX_ObjectSetAttr(char,'spell1',-1)
    FFX_ObjectSetAttr(char,'spell2',-1)
    FFX_ObjectSetAttr(char,'spell3',-1)
    spellStage1(char)

def spellStage1(char):
    FFX_ObjectSetAttr(char,'spellStage',1)
    Mission_CustomAction('SPELL_INCREASE',char,char,'OnSpellIncrease',5,0)
    Mission_CustomAction('SPELL_DECREASE',char,char,'OnSpellDecrease',5,0)

def OnSpellIncrease(dummy,char):
    OnSpellStage1(char,0)
def OnSpellDecrease(dummy,char):
    OnSpellStage1(char,1)

def OnSpellStage1(char,val):
    slot=GetNextSpellSlot(char)
    FFX_ObjectSetAttr(char,'currentSpell',slot)
    attr='spell%i'%(slot)
    print 'OnSpellStage1: slot=%i attr=%s val=%i'%(slot,attr,val)
    FFX_ObjectSetAttr(char,attr,val)
    spellStage2(char)

def GetNextSpellSlot(char):
    if FFX_ObjectGetAttr(char,'spell1',-1)==-1:
        return 1
    if FFX_ObjectGetAttr(char,'spell2',-1)==-1:
        return 2
    if FFX_ObjectGetAttr(char,'spell3',-1)==-1:
        return 3
    return 0

def spellStage2(char):
    FFX_ObjectSetAttr(char,'spellStage',2)

    Mission_RemoveCustomAction('SPELL_INCREASE',char,char)
    Mission_RemoveCustomAction('SPELL_DECREASE',char,char)

    Mission_CustomAction('SPELL_TEMPERATURE',char,char,'OnSpellTemperature',5,0)
    Mission_CustomAction('SPELL_GRAVITY',char,char,'OnSpellGravity',5,0)
    Mission_CustomAction('SPELL_THOUGHT',char,char,'OnSpellThought',5,0)
    Mission_CustomAction('SPELL_MOTION',char,char,'OnSpellMotion',5,0)

def OnSpellTemperature(dummy,char):
    OnSpellStage2(char,0)

def OnSpellGravity(dummy,char):
    OnSpellStage2(char,2)

def OnSpellThought(dummy,char):
    OnSpellStage2(char,4)

def OnSpellMotion(dummy,char):
    OnSpellStage2(char,6)

def OnSpellStage2(char,val):
    slot=FFX_ObjectGetAttr(char,'currentSpell')
    attr='spell%i'%(slot)
    FFX_ObjectSetAttr(char,attr,FFX_ObjectGetAttr(char,attr)+val)
    print 'OnSpellStage2:slot=%i attr=%s val=%i'%(slot,attr,FFX_ObjectGetAttr(char,attr))
    spellStage3(char)

def spellStage3(char):
    FFX_ObjectSetAttr(char,'spellStage',3)

    Mission_RemoveCustomAction('SPELL_TEMPERATURE',char,char)
    Mission_RemoveCustomAction('SPELL_GRAVITY',char,char)
    Mission_RemoveCustomAction('SPELL_THOUGHT',char,char)
    Mission_RemoveCustomAction('SPELL_MOTION',char,char)

    Mission_CustomAction('SPELL_SELF',char,char,'OnSpellSelf',5,0)
    Mission_CustomAction('SPELL_SELFRADIUS',char,char,'OnSpellSelfRadius',5,0)
    Mission_CustomAction('SPELL_OTHER',char,char,'OnSpellOther',5,0)
    Mission_CustomAction('SPELL_OTHERRADIUS',char,char,'OnSpellOtherRadius',5,0)

FFX_SPELLCASTER_CUSTOM=[
["default","area","effect_ffx_magic","ffx_tk_throw"],
]

def OnSpellSelf(dummy,char):
    OnSpellStage3(char,0)

def OnSpellSelfRadius(dummy,char):
    OnSpellStage3(char,8)

def OnSpellOther(dummy,char):
    OnSpellStage3(char,16)

def OnSpellOtherRadius(dummy,char):
    OnSpellStage3(char,24)

def OnSpellStage3(char,val):
    slot=FFX_ObjectGetAttr(char,'currentSpell')
    attr='spell%i'%(slot)
    FFX_ObjectSetAttr(char,attr,FFX_ObjectGetAttr(char,attr)+val)
    print 'OnSpellStage3:slot=%i attr=%s val=%i'%(slot,attr,FFX_ObjectGetAttr(char,attr))
    AI_Animate(char,getByTemplate(char,FFX_SPELLCASTER_CUSTOM,1),'OnSpellComplete')
    Object_PlayEffect(char,getByTemplate(char,FFX_SPELLCASTER_CUSTOM,2))

def OnSpellComplete(event):
    char=event.object
    slot=FFX_ObjectGetAttr(char,'currentSpell')
    attr='spell%i'%(slot)
    code=int(FFX_ObjectGetAttr(char,attr))
    command=spellData[code][0]
    Mission_StatusText("spell %s memorised"%(command))
    print 'OnSpellComplete:slot=%i attr=%s val=%i code=%i'%(slot,attr,FFX_ObjectGetAttr(char,attr),code)
    Mission_RemoveCustomAction('SPELL_SELF',char,char)
    Mission_RemoveCustomAction('SPELL_SELFRADIUS',char,char)
    Mission_RemoveCustomAction('SPELL_OTHER',char,char)
    Mission_RemoveCustomAction('SPELL_OTHERRADIUS',char,char)
    next=GetNextSpellSlot(char)
    if next!=0:
        spellStage1(char)
    else:
        FFX_ObjectSetAttr(char,'spellStage',4)
    addSpellCommands(char,slot,0)

def addSpellCommands(char,slot,update):
    attr='spell%i'%(slot)
    code=int(FFX_ObjectGetAttr(char,attr))
    command=spellData[code][0]
    fn='OnCastSpell%i'%(slot)
    print 'addSpellCommands: command=%s fn=%s code=%i'%(command,fn,code)
    if code>15:
        addCommand(command,char,fn,30,update)
        RegTimer('spellUpdate',5,slot,char)
    else:
        Mission_CustomAction(command,char,char,fn,5,0)

def spellUpdate(event):
    slot=int(event.user)
    char=event.object
    attr='spell%i'%(slot)
    code=int(FFX_ObjectGetAttr(char,attr))
    if code!=-1:
        command=spellData[code][0]
        fn='OnCastSpell%i'%(slot)
        addCommand(command,char,fn,30,1)
        RegTimer('spellUpdate',5,slot,char)

def OnCastSpell1(target,char):
    OnCastSpell(target,char,1)

def OnCastSpell2(target,char):
    OnCastSpell(target,char,2)

def OnCastSpell3(target,char):
    OnCastSpell(target,char,3)

def OnCastSpell(target,char,index):
    attr='spell%i'%(index)
    code=int(FFX_ObjectGetAttr(char,attr))
    power=spellData[code][1]
    fn=spellData[code][2]
    type=code&24
    pct=33
    print 'OnCastSpell: code=%i index=%i power=%s fn=%s type=%i'%(code,index,power,fn,type)
    if type==0: #self
        if code==0:
            count=FFX_ObjectGetAttr(char,'magicflame')+10
            FFX_ObjectSetAttr(char,'magicflame',count)
            if count<=10:
                handle=Object_PlayEffect(char,'effect_ffx_flames','',FX_LOOP|FX_TRACK_OBJECT_POS)
                FFX_ObjectSetAttr(char,'magicflamehandle',handle)
                RegTimer('magicflames',1,0,char)
        elif code==6: #heal self
            Trigger_Damage(char,-randint(12,36))
        elif code==2: #increase own density
            OnMassUp(char,char)
            RegTimer('onMassDown',30,0,char)
        elif code==3:
            Object_SetSecondaryState(char,SCSTATE_BUOYANT,40,0)
        else:
            Trigger_Power(char,char,power,'')
        if code!=4:
            pct=100
    elif type==8: #self radius
        Trigger_Explosion(char,power)
        if fn!='':
            RegTimer(fn,1,3,char)
    elif type==16: #other
        Trigger_Power(char,target,power,fn)
    elif type==24: #other radius
        name=getDummyName()
        pos=Get_ObjectPos(target)
        spawn(name,'portal_start_proxy',(pos[0]+randint(-50,50),pos[1]+randint(-50,50),pos[2]))
        RegTimer('magicExplode',1,code,name)
        Trigger_Power(char,name,getByTemplate(char,FFX_SPELLCASTER_CUSTOM,3),"")
    if randint(1,100)<pct:
        forgetSpell(char,index)

def magicExplode(event):
    name=event.object
    code=int(event.user)
    power=spellData[code][1]
    fn=spellData[code][2]
    Trigger_Explosion(name,power)
    if fn!='':
        RegTimer(fn,1,3,name)
    RegTimer('destroyTemp',6,0,name)

def forgetSpell(char,index):
    attr='spell%i'%(index)
    code=int(FFX_ObjectGetAttr(char,attr))
    command=spellData[code][0]
    if code>15:
        removeCommand(command,char)
    else:
        Mission_RemoveCustomAction(command,char,char)
    FFX_ObjectSetAttr(char,attr,-1)
    Mission_StatusText('spell %s has been forgotten'%(command))
    if FFX_ObjectGetAttr(char,'spellStage')==4:
        spellStage1(char)

def onMassDown(event):
    char=event.object
    OnMassDown(char,char)

def magicflames(event):
    char=event.object
    count=FFX_ObjectGetAttr(char,'magicflame')-1
    FFX_ObjectSetAttr(char,'magicflame',count)
    Mission_StatusText('%d'%(count))
    if count>0:
        Trigger_Explosion(char,'ffx_overheated',2)
        RegTimer('magicflames',2,0,char)
    else:
        Object_StopEffect(char,FFX_ObjectGetAttr(char,'magicflamehandle'))

spellData=[
['FLAMING AURA','',''],
['COBALT SHELL','ffx_mag_iceshield',''],
['MASS INCREASE','',''],
['LEVITATE','',''],
['MENTAL MIRROR','ffx_mag_empathy',''],
['MIND HALT','ffx_mag_mindshield',''],
['SWIFT HEAL','',''],
['MOTION STOP','ffx_mag_kineticshell',''],

['INFERNAL WAVE','ffx_ex_fire_med',''],
['COLD SPELL','ffx_ex_ice_med',''],
['EARTHLY PULL','ffx_ex_magic_med','gravityCheck'],
['REVERSO','ffx_ex_grav_med',''],
['FEAR WAVE','ffx_ex_hypno_med',''],
['SOOTHING WAVE','ffx_ex_blank_med',''],
['MOTION WAVE','ffx_ex_speed_med',''],
['TIME WAVE','ffx_ex_stasis_med',''],

['FIERY CURSE','ffx_dr_fire',''],
['FREEZING CURSE','ffx_dr_freeze',''],
['WEIGHTY CURSE','ffx_pr_magic','hextogravityincrease'],
['LUNAR CURSE','ffx_pr_magic','hextozerog'],
['TERROR CURSE','ffx_dr_panic',''],
['SOOTHING HEX','ffx_dr_blank',''],
['MOTION BLUR','ffx_dr_speed',''],
['TIME STOP','ffx_dr_stasis',''],

['INFERNAL WAVE','ffx_ex_fire_med',''],
['COLD SPELL','ffx_ex_ice_med',''],
['EARTHLY PULL','ffx_ex_magic_med','gravityCheck'],
['REVERSO','ffx_ex_grav_med',''],
['FEAR WAVE','ffx_ex_panic_med',''],
['SOOTHING WAVE','ffx_ex_blank_med',''],
['MOTION WAVE','ffx_ex_speed_med',''],
['TIME WAVE','ffx_ex_stasis_med',''],
]

def printSpellData(char):
    print 'currentSpell=%i'%(FFX_ObjectGetAttr(char,'currentSpell'))
    print 'slots=[%i,%i,%i]'%(FFX_ObjectGetAttr(char,'spell1'),FFX_ObjectGetAttr(char,'spell2'),FFX_ObjectGetAttr(char,'spell3'))

#################### UNSTABLE TEMPERATURE #####################

heatPowers=['thermite fireball','thermite ignite']
coldPowers=['thermite chill','thermite freeze ray']

def initunstabletemp(char,update=0):
    FFX_ObjectSetAttr(char,'temperature',50)
    RegTimer('updateTemp',1,0,char)
#    RegTimer('updateTemp2',1,0,char)
    for p in heatPowers:
        regPowerUse(char,p,'heatG',1)
    for p in coldPowers:
        regPowerUse(char,p,'coldG',1)
    FFX_ObjectSetAttr(char,'deltaT',0)

def updateTemp2(event):
    char=event.object
    hid=[]
    cid=[]
    for pow in ffxpowerids.powerIDs:
        for h in heatPowers:
            if h==pow[0]:
                hid.append(pow[2])
        for c in coldPowers:
            if c==pow[0]:
                cid.append(pow[2])
    if len(hid)>0:
        regPowerAgainstChars(char,'heatG',hid,event.user)
    if len(cid)>0:
        regPowerAgainstChars(char,'coldG',cid,event.user)
    RegTimer('updateTemp2',5,1,char)

def heatG(event):
#    Mission_StatusText('hot!')
    char=event.string
    FFX_ObjectSetAttr(char,'deltaT',-5)

def coldG(event):
#    Mission_StatusText('cool!')
    char=event.string
    FFX_ObjectSetAttr(char,'deltaT',5)

def updateTemp(event):
    char=event.object
    if Object_Exists(char)==0:
        return
    RegTimer('updateTemp',0.5,0,char)
    temp=FFX_ObjectGetAttr(char,'temperature')
    delta=(float(randint(3,5))*Object_GetAttr(char,'energyPoints'))/Object_GetAttr(char,'maxEnergyPoints')
    if randint(1,100)>50:
        temp=temp+delta
    else:
        temp=temp-delta
    delta=FFX_ObjectGetAttr(char,'deltaT')
    temp=temp+delta
    if delta>0:
        delta=delta-1
        if delta<0: delta=0
    if delta<0:
        delta=delta+1
        if delta>0: delta=0
    FFX_ObjectSetAttr(char,'deltaT',delta)
    if temp<randint(5,20):
        Trigger_Explosion(char,'ffx_ex_ice_large')
        Object_SetPrimaryState(char,PCSTATE_FROZEN,5,0)
        temp=temp+50
    elif temp>randint(80,95):
        Trigger_Explosion(char,'ffx_ex_fire_large')
        Object_SetPrimaryState(char,PCSTATE_STUNNED,5,0)
        temp=temp-50
    Mission_DisplayTimer("temperature('C)",int(temp)*60)
    FFX_ObjectSetAttr(char,'temperature',temp)




########################### TASKMASTERX'S ATTRIBUTES ETC. #########################################


##################################### NEW ABSORBER ##############################################
# By TaskmasterX with help from the scripting gods Epimethee and M25. This is basically a hack of the original
# Absorber attribute by DrMike, with the ability to work with M25's AI subtypes and uses
# several other features of DrMike's FFX.
#################################################################################################

################## Absorb Materials ##################
absorbmaterialNames=['flesh','metal','stone','rubber','fire','energy','air','wood','concrete','frozen','cloth','electricity','radiation','sound','adamantium','divine_metal','super_alloy','liquid','acid','sand','gas','diamond','alien_mineral']

def initabsorbmat(char, update=0):
    objects = Mission_GetObjects()
    for obj in objects:
        if ((Object_GetClass(obj)&FFX_CHARACTER)!=0) & (obj!=char):
            Object_SetAttr(char,'basehealth',Object_GetAttr(char,'health'))
            Object_SetAttr(char,'baseMaxhealth',Object_GetAttr(char,'maxHealth'))
            if not initabsorbMaterial_subtype(char, obj):
                initabsorbMaterial_nosubtype(char,obj)
        elif obj!=char:
            initabsorbMaterial_nosubtype(char,obj)
    RegTimer('addAbsorbMatCmd', 3, 0, char)

def addAbsorbMatCmd(event):
    char=event.object
    for obj in Mission_GetObjects():
        if ((Object_GetClass(obj)&FFX_CHARACTER)!=0) & (obj!=char):
            if FFX_ObjectGetAttr(obj,'absorbMatCmd',0)==0:
                Object_SetAttr(char,'basehealth',Object_GetAttr(char,'health'))
                Object_SetAttr(char,'baseMaxhealth',Object_GetAttr(char,'maxHealth'))
                if not initabsorbMaterial_subtype(char, obj):
                    initabsorbMaterial_nosubtype(char,obj)
                elif obj!=char:
                    initabsorbMaterial_nosubtype(char,obj)
                FFX_ObjectSetAttr(obj,'absorbMatCmd',1)
    RegTimer('addAbsorbMatCmd', 2, 0, char)

# initialize the absorb material attribute based on the subtype given in the AI definition
# returns 1 if an appropriate subtype is found
# returns 0 if no appropriate subtype is found            
def initabsorbMaterial_subtype(char, obj):
    subtype = m25ai.FindTacticType(obj, 'subtype')
    if ('metal' in subtype):
        Mission_CustomAction('ABSORB_METAL',char,obj,'AbsorbMetalmat',FFX_ABSORBRANGE,0)
    if ('stone' in subtype):
        Mission_CustomAction('ABSORB_STONE',char,obj,'AbsorbStonemat',FFX_ABSORBRANGE,0)
    if ('rubber' in subtype):
        Mission_CustomAction('ABSORB_RUBBER',char,obj,'AbsorbRubbermat',FFX_ABSORBRANGE,0)
    if ('wood' in subtype):
        Mission_CustomAction('ABSORB_WOOD',char,obj,'AbsorbWoodmat',FFX_ABSORBRANGE,0)
    if ('ice' in subtype):
        Mission_CustomAction('ABSORB_ICE',char,obj,'AbsorbIcemat',FFX_ABSORBRANGE,0)
    if ('cloth' in subtype):
        Mission_CustomAction('ABSORB_CLOTH',char,obj,'AbsorbClothmat',FFX_ABSORBRANGE,0)
    if ('air' in subtype):
        Mission_CustomAction('ABSORB_AIR',char,obj,'AbsorbAirmat',FFX_ABSORBRANGE,0)
        if m25ai.HasPowerType(obj,'crushing','ranged'):
            Mission_CustomAction('ABSORB_AIR_ATTACK',char,obj,'AbsorbAir',30,0)
    if ('concrete' in subtype):
        Mission_CustomAction('ABSORB_CONCRETE',char,obj,'AbsorbConcretemat',FFX_ABSORBRANGE,0)
    if ('adamantium' in subtype):
        Mission_CustomAction('ABSORB_ADAMANTIUM',char,obj,'AbsorbAdamantiummat',FFX_ABSORBRANGE,0)
    if ('divine_metal' in subtype):
        Mission_CustomAction('ABSORB_DIVINE_METAL',char,obj,'AbsorbDivineMetalmat',FFX_ABSORBRANGE,0)
        Mission_CustomAction('ABSORB_DIVINE_METAL_ATTACK',char,obj,'AbsorbDivineMetal',30,0)
    if ('super_alloy' in subtype):
        Mission_CustomAction('ABSORB_SUPER_ALLOY',char,obj,'AbsorbSuperAlloymat',FFX_ABSORBRANGE,0)
        Mission_CustomAction('ABSORB_SUPER_ALLOY_ATTACK',char,obj,'AbsorbSuperAlloy',30,0)
    if ('liquid' in subtype):
        Mission_CustomAction('ABSORB_LIQUID',char,obj,'AbsorbWatermat',FFX_ABSORBRANGE,0)
        if m25ai.HasPowerType(obj,'crushing','ranged'):
            Mission_CustomAction('ABSORB_LIQUID_ATTACK',char,obj,'AbsorbWater',30,0)
    if ('acid' in subtype):
        Mission_CustomAction('ABSORB_ACID',char,obj,'AbsorbAcidmat',FFX_ABSORBRANGE,0)
        if m25ai.HasPowerType(obj,'acid','ranged'):
            Mission_CustomAction('ABSORB_ACID_ATTACK',char,obj,'AbsorbAcid',30,0)
    if ('sand' in subtype):
        Mission_CustomAction('ABSORB_SAND',char,obj,'AbsorbSandmat',FFX_ABSORBRANGE,0)
        if m25ai.HasPowerType(obj,'crushing','ranged') | m25ai.HasPowerType(obj,'piercing','ranged'):
            Mission_CustomAction('ABSORB_SAND_ATTACK',char,obj,'AbsorbSand',30,0)
    if ('gas' in subtype) | (Object_GetAttr(obj,'ffxState')==FFX_STATE_GAS):
        Mission_CustomAction('ABSORB_GAS',char,obj,'AbsorbGasmat',FFX_ABSORBRANGE,0)
    if ('diamond' in subtype):
        Mission_CustomAction('ABSORB_DIAMOND',char,obj,'AbsorbDiamondmat',FFX_ABSORBRANGE,0)
    if ('alien_mineral' in subtype):
        Mission_CustomAction('ABSORB_ALIEN_MINERAL',char,obj,'AbsorbAlienMineralmat',FFX_ABSORBRANGE,0)
    if ('liquid_powers' in subtype):
        Mission_CustomAction('ABSORB_LIQUID_ATTACK',char,obj,'AbsorbWater',30,0)
    if ('pierce_weapon' in subtype):
        if m25ai.HasPowerType(obj,'piercing','ranged'):
            Mission_CustomAction('ABSORB_METAL_ATTACK',char,obj,'AbsorbMetal',30,0)
    if ('flesh' in subtype) | ('metal' in subtype) | ('stone' in subtype) | ('rubber' in subtype) | ('wood' in subtype) | ('ice' in subtype) | ('cloth' in subtype) | ('air' in subtype) | ('concrete' in subtype) | ('adamantium' in subtype) | ('uru' in subtype) | ('cap_shield' in subtype) | ('liquid' in subtype) | ('acid' in subtype) | ('sand' in subtype) | ('gas' in subtype):
        return 1
        FFX_ObjectSetAttr(obj,'absorbMatCmd',1)
    else:
        return 0

def initabsorbMaterial_nosubtype(char, obj):
    ###absorb by power damage###
    if ((Object_GetClass(obj)&FFX_CHARACTER)!=0):
        if m25ai.HasPowerType(obj,'cold','ranged'):
            Mission_CustomAction('ABSORB_ICE_ATTACK',char,obj,'AbsorbIce',30,0)
        if m25ai.HasPowerType(obj,'acid','ranged'):
            Mission_CustomAction('ABSORB_ACID_ATTACK',char,obj,'AbsorbAcid',30,0)
    ###absorb by object template###
    if Object_GetTemplate(obj) in ('mp_car', 'mp_truck', 'truck_ger_cargo', 'truck_ger_military'):
        Mission_CustomAction('ABSORB_RUBBER',char,obj,'AbsorbRubber',FFX_ABSORBRANGE,0)
    elif Object_GetTemplate(obj) in ('ffx_icewall', 'ffx_icepatch') or (isFrozen(obj)):
        Mission_CustomAction('ABSORB_ICE',char,obj,'AbsorbIce',FFX_ABSORBRANGE,0)
    elif Object_GetTemplate(obj) in ('pat_fire_hydrant', 'pat_park_fountain', 'park_fountain_berlin', 'park_fountain_marble_berlin'):
        Mission_CustomAction('ABSORB_LIQUID',char,obj,'AbsorbWater',FFX_ABSORBRANGE,0)
    ###absorb by object's material###
    mat=Object_GetAttr(obj,'material')
    if mat == 1:
        Mission_CustomAction('ABSORB_METAL',char,obj,'AbsorbMetalmat',FFX_ABSORBRANGE,0)
    elif mat == 2:
        Mission_CustomAction('ABSORB_STONE',char,obj,'AbsorbStonemat',FFX_ABSORBRANGE,0)
    elif mat == 3:
        Mission_CustomAction('ABSORB_RUBBER',char,obj,'AbsorbRubber',FFX_ABSORBRANGE,0)
    elif mat == 7:
        Mission_CustomAction('ABSORB_WOOD',char,obj,'AbsorbWood',FFX_ABSORBRANGE,0)
    elif mat == 8:
        Mission_CustomAction('ABSORB_CONCRETE',char,obj,'AbsorbConcrete',FFX_ABSORBRANGE,0)
    elif mat == 9:
        Mission_CustomAction('ABSORB_ICE',char,obj,'AbsorbIcemat',FFX_ABSORBRANGE,0)
    elif mat == 10:
        Mission_CustomAction('ABSORB_CLOTH',char,obj,'AbsorbCloth',FFX_ABSORBRANGE,0)
    FFX_ObjectSetAttr(obj,'absorbMatCmd',1)

def AbsorbMetalmat(target,char): 
    RegTimer('AbsorbMetalmove', 1, 0, char, target)

### Epimethee's code for chasing down the target ###
def AbsorbMetalmove(event): 
    char = event.object
    target = event.string 
    pos1 = Get_ObjectPos(char) 
    pos2 = Get_ObjectPos(target) 
    dist = cshelper.distance2D(pos1, pos2) #since the distance now need to be used twice, let's reduce the processing by storing it in a variable first
    if dist > 150: #150 is just a guess 
        return  #prevents the code from running ad vitam aeternam if the target has moved too far
    if dist > 50: 
        Trigger_Move(char,'move',pos2) 
        RegTimer('AbsorbMetalmove', 1, 0, char, target) 
    else: 
        AbsorbMetal(target,char)

def resetHealth(event):
    char=event.object
    Object_SetAttr(char,'health',(Object_GetAttr(char,'health'))*GetBaseHealth(char)/Object_GetAttr(char,'maxHealth'))
    Object_SetAttr(char,'maxHealth',(GetBaseHealth(char)))

def AbsorbMetal(target,char):
    mat=1
    temp=FFX_GetTemplate(char)
    root=GetRootName(temp)
    name=getFormName()
    portrait=FFX_HasPortrait(char)
    #create the new material marker
    template='%s_%s'%(root,absorbmaterialNames[int(mat)])
    Trigger_Power(char,target,getByTemplate(char,FFX_ABSORBMATERIAL_CUSTOM,1),'')
    #print 'try template:%s?'%(template)
    if Template_Exists(template):
        morph(name,char,template,0,portrait)
        Mission_CustomAction('CUSTOM_REVERT',name,name,'OnRevertAbsorb',5,0)
        RegTimer('resetHealth',1,0,name)
        return
    template='%s (%s)'%(root,absorbmaterialNames[int(mat)])
    #print 'try custom:%s?'%(template)
    if Custom_Exists(template):
        morph(name,char,template,0,portrait)
        Mission_CustomAction('CUSTOM_REVERT',name,name,'OnRevertAbsorb',5,0)
        RegTimer('resetHealth',1,0,name)
        return
    else:
        str=Object_GetAttr(char,'baseStrength')+2
        Object_SetAttr(char,'strength',str)
        Object_SetAttr(char,'speed',Object_GetAttr(char,'baseSpeed'))
        Object_SetAttr(char,'health',(Object_GetAttr(char,'health'))*GetBaseHealth(char)/Object_GetAttr(char,'maxHealth'))
        Object_SetAttr(char,'maxHealth',(GetBaseHealth(char)))
        Object_SetAttr(char,'material',1)
        FFX_ObjectSetAttr(char,'absorbrubber',0)
        FFX_ObjectSetAttr(char,'absorbsand',0)
        FFX_ObjectSetAttr(char,'absorbacid',0)
        FFX_ObjectSetAttr(char,'dispersedForm',0)
        FFX_ObjectSetAttr(char,'alien_mineral',0)
        FFX_ObjectSetAttr(char,'absorbliquid',0)
        FFX_ObjectSetAttr(char,'absorbelectric',0)
        FFX_ObjectSetAttr(char,'absorbradiation',0)
        FFX_ObjectSetAttr(char,'absorbsound',0)
        FFX_ObjectSetAttr(char,'absorbenergy',0)
        FFX_ObjectSetAttr(char,'invPoints',FFX_ObjectGetAttr(char,'baseInvPoints'))
        removeOldMaterial(char)
        if getByTemplate(char,FFX_ABSORBPOWERS_CUSTOM,3)=='single':
            removeSingleAbsorber(target,char)
            removeSingleSubtype(target,char)

def AbsorbStonemat(target,char): 
    RegTimer('AbsorbStonemove', 1, 0, char, target)

def AbsorbStonemove(event): 
    char = event.object
    target = event.string 
    pos1 = Get_ObjectPos(char) 
    pos2 = Get_ObjectPos(target) 
    dist = cshelper.distance2D(pos1, pos2)
    if dist > 150:
        return
    if dist > 50: 
        Trigger_Move(char,'move',pos2) 
        RegTimer('AbsorbStonemove', 1, 0, char, target) 
    else: 
        AbsorbStone(target,char)

def AbsorbStone(target,char):
    mat=2
    temp=FFX_GetTemplate(char)
    root=GetRootName(temp)
    name=getFormName()
    portrait=FFX_HasPortrait(char)
    template='%s_%s'%(root,absorbmaterialNames[int(mat)])
    Trigger_Power(char,target,getByTemplate(char,FFX_ABSORBMATERIAL_CUSTOM,1),'')
    if Template_Exists(template):
        morph(name,char,template,0,portrait)
        Mission_CustomAction('CUSTOM_REVERT',name,name,'OnRevertAbsorb',5,0)
        RegTimer('resetHealth',1,0,name)
        return
    template='%s (%s)'%(root,absorbmaterialNames[int(mat)])
    if Custom_Exists(template):
        morph(name,char,template,0,portrait)
        Mission_CustomAction('CUSTOM_REVERT',name,name,'OnRevertAbsorb',5,0)
        RegTimer('resetHealth',1,0,name)
        return
    else:
        str=Object_GetAttr(char,'baseStrength')+1
        Object_SetAttr(char,'strength',str)
        spd=Object_GetAttr(char,'baseSpeed')-1
        if spd<0:
            spd=0
        Object_SetAttr(char,'speed',spd)
        Object_SetAttr(char,'material',2)
        FFX_ObjectSetAttr(char,'invPoints',FFX_ObjectGetAttr(char,'baseInvPoints'))
        Object_SetAttr(char,'health',(Object_GetAttr(char,'health'))*GetBaseHealth(char)/Object_GetAttr(char,'maxHealth'))
        Object_SetAttr(char,'maxHealth',(GetBaseHealth(char)))
        FFX_ObjectSetAttr(char,'absorbacid',0)
        FFX_ObjectSetAttr(char,'absorbsand',0)
        FFX_ObjectSetAttr(char,'absorbrubber',0)
        FFX_ObjectSetAttr(char,'dispersedForm',0)
        FFX_ObjectSetAttr(char,'alien_mineral',0)
        FFX_ObjectSetAttr(char,'absorbliquid',0)
        FFX_ObjectSetAttr(char,'absorbelectric',0)
        FFX_ObjectSetAttr(char,'absorbradiation',0)
        FFX_ObjectSetAttr(char,'absorbsound',0)
        FFX_ObjectSetAttr(char,'absorbenergy',0)
        removeOldMaterial(char)
        if getByTemplate(char,FFX_ABSORBPOWERS_CUSTOM,3)=='single':
            removeSingleAbsorber(target,char)
            removeSingleSubtype(target,char)

def AbsorbRubbermat(target,char): 
    RegTimer('AbsorbRubbermove', 1, 0, char, target)

def AbsorbRubbermove(event): 
    char = event.object
    target = event.string 
    pos1 = Get_ObjectPos(char) 
    pos2 = Get_ObjectPos(target) 
    dist = cshelper.distance2D(pos1, pos2)
    if dist > 150:
        return
    if dist > 50: 
        Trigger_Move(char,'move',pos2) 
        RegTimer('AbsorbRubbermove', 1, 0, char, target) 
    else: 
        AbsorbRubber(target,char)

def AbsorbRubber(target,char):
    mat=3
    temp=FFX_GetTemplate(char)
    root=GetRootName(temp)
    name=getFormName()
    portrait=FFX_HasPortrait(char)
    template='%s_%s'%(root,absorbmaterialNames[int(mat)])
    Trigger_Power(char,target,getByTemplate(char,FFX_ABSORBMATERIAL_CUSTOM,1),'')
    if Template_Exists(template):
        morph(name,char,template,0,portrait)
        Mission_CustomAction('CUSTOM_REVERT',name,name,'OnRevertAbsorb',5,0)
        RegTimer('resetHealth',1,0,name)
        return
    template='%s (%s)'%(root,absorbmaterialNames[int(mat)])
    if Custom_Exists(template):
        morph(name,char,template,0,portrait)
        Mission_CustomAction('CUSTOM_REVERT',name,name,'OnRevertAbsorb',5,0)
        RegTimer('resetHealth',1,0,name)
        return
    else:
        spd=Object_GetAttr(char,'baseSpeed')+2
        if spd>9:
            spd=9
        Object_SetAttr(char,'speed',spd)
        Object_SetAttr(char,'strength',Object_GetAttr(char,'baseStrength'))
        Object_SetAttr(char,'health',(Object_GetAttr(char,'health'))*GetBaseHealth(char)/Object_GetAttr(char,'maxHealth'))
        Object_SetAttr(char,'maxHealth',(GetBaseHealth(char)))
        if FFX_ObjectGetAttr(char,'super leaper',0)==0:
            ffx.addCommand('custom_leapto',char,'custom_leapto',40,0)
        Object_SetAttr(char,'material',3)
        FFX_ObjectSetAttr(char,'absorbrubber',1)
        FFX_ObjectSetAttr(char,'absorbsand',0)
        FFX_ObjectSetAttr(char,'absorbacid',0)
        FFX_ObjectSetAttr(char,'dispersedForm',0)
        FFX_ObjectSetAttr(char,'alien_mineral',0)
        FFX_ObjectSetAttr(char,'absorbliquid',0)
        FFX_ObjectSetAttr(char,'absorbelectric',0)
        FFX_ObjectSetAttr(char,'absorbradiation',0)
        FFX_ObjectSetAttr(char,'absorbsound',0)
        FFX_ObjectSetAttr(char,'absorbenergy',0)
        FFX_ObjectSetAttr(char,'invPoints',FFX_ObjectGetAttr(char,'baseInvPoints'))
        removeOldMaterial(char)
        if getByTemplate(char,FFX_ABSORBPOWERS_CUSTOM,3)=='single':
            removeSingleAbsorber(target,char)
            removeSingleSubtype(target,char)
        m25ai.AddGoal_DynamicAbility(char, temp_attribute='super leaper', tactic='TSuperLeap()')
        m25ai.AddGoal_DynamicAbility(char, temp_attribute='super leaper', tactic='TSuperLeapAway()')

def AbsorbAirmat(target,char): 
    RegTimer('AbsorbAirmove', 1, 0, char, target)

def AbsorbAirmove(event): 
    char = event.object
    target = event.string 
    pos1 = Get_ObjectPos(char) 
    pos2 = Get_ObjectPos(target) 
    dist = cshelper.distance2D(pos1, pos2)
    if dist > 150: #150 is just a guess 
        return
    if dist > 50: 
        Trigger_Move(char,'move',pos2) 
        RegTimer('AbsorbAirmove', 1, 0, char, target) 
    else: 
        AbsorbAir(target,char)

def AbsorbAir(target,char):
    mat=6
    temp=FFX_GetTemplate(char)
    root=GetRootName(temp)
    name=getFormName()
    portrait=FFX_HasPortrait(char)
    template='%s_%s'%(root,absorbmaterialNames[int(mat)])
    Trigger_Power(char,target,getByTemplate(char,FFX_ABSORBMATERIAL_CUSTOM,1),'')
    if Template_Exists(template):
        morphAir(name,char,template,0,portrait)
        Mission_CustomAction('CUSTOM_REVERT',name,name,'OnRevertAbsorb',5,0)
        RegTimer('resetHealth',1,0,name)
        return
    template='%s (%s)'%(root,absorbmaterialNames[int(mat)])
    if Custom_Exists(template):
        morphAir(name,char,template,0,portrait)
        Mission_CustomAction('CUSTOM_REVERT',name,name,'OnRevertAbsorb',5,0)
        RegTimer('resetHealth',1,0,name)
        return
    else:
        spd=Object_GetAttr(char,'baseSpeed')+1
        if spd>9:
            spd=9
        Object_SetAttr(char,'speed',spd)
        Object_SetAttr(char,'strength',Object_GetAttr(char,'baseStrength'))
        Object_SetAttr(char,'health',(Object_GetAttr(char,'health'))*GetBaseHealth(char)/Object_GetAttr(char,'maxHealth'))
        Object_SetAttr(char,'maxHealth',(GetBaseHealth(char)))
        FFX_ObjectSetAttr(char,'absorbgas',0)
        FFX_ObjectSetAttr(char,'absorbair',1)
        FFX_ObjectSetAttr(char,'absorbacid',0)
        FFX_ObjectSetAttr(char,'absorbrubber',0)
        FFX_ObjectSetAttr(char,'absorbsand',0)
        FFX_ObjectSetAttr(char,'absorbliquid',0)
        FFX_ObjectSetAttr(char,'dispersedForm',0)
        FFX_ObjectSetAttr(char,'alien_mineral',0)
        FFX_ObjectSetAttr(char,'absorbelectric',0)
        FFX_ObjectSetAttr(char,'absorbradiation',0)
        FFX_ObjectSetAttr(char,'absorbsound',0)
        FFX_ObjectSetAttr(char,'absorbenergy',0)
        Object_SetAttr(char,'material',6)
        handle=Object_PlayEffect(char,'effect_sandstorm','',FX_LOOP|FX_TRACK_OBJECT_POS,0,'centre')
        FFX_ObjectSetAttr(char,'absorbAirHandle',handle)
        RegTimer('makeAir',0.1,handle,char)
        RegTimer('OnAir',0.7,1,char)
        RegTimer('makepass_thru',1,0,char)
        FFX_ObjectSetAttr(char,'invPoints',FFX_ObjectGetAttr(char,'baseInvPoints'))
        removeOldMaterial(char)
        if getByTemplate(char,FFX_ABSORBPOWERS_CUSTOM,3)=='single':
            removeSingleAbsorber(target,char)
            removeSingleSubtype(target,char)

def makeAir(event):
    char=event.object
    if FFX_ObjectGetAttr(char,'absorbair',0)==1:
        RegTimer('makeAir',1,event.user,char)
        if not hasAttribute(char,'flier') or hasAttribute(char,'levitate') or js.Object_GetSecondaryStates(char) & js.SCSTATE_BUOYANT:
            ff.RESULTBUBBLE_SCALE=0
            RegTimer('bubblesOn',0.1)
            Object_SetSecondaryState(char,SCSTATE_BUOYANT,10000,0)
            RegTimer('removeFX',0.5,1,char)
    else:
        Object_SetSecondaryState(char,SCSTATE_BUOYANT,0,REMOVE_STATE)
        handle=FFX_ObjectGetAttr(char,'absorbAirHandle')
        Object_StopEffect(char,handle)
        removePassThruDefence(char)
    if not Object_GetAttr(char,'material')==6:
        FFX_ObjectSetAttr(char,'absorbair',0)

def OnAir(event):
    char=event.object
    if FFX_ObjectGetAttr(char,'absorbair',0)==1:
        Trigger_Explosion(char,'ffx_superrotate_blank')
        RegTimer('OnAir',1,0,char)

def makepass_thru(event):
    char=event.object
    if not Object_IsAlive(char):
        return
    if Object_GetAttr(char,'material')==6:
        if FFX_ObjectGetAttr(char,'absorbair',0)==1 or FFX_ObjectGetAttr(char,'absorbgas',0)==1:
            if usingM25AI():
                m25ai.AIDoPower(char, power='ffx_air_defence', target=char, priority=m25ai.TACTIC_PRIORITY_CRITICAL, description='transforming into air')
            else:
                Trigger_Power(char,char,'ffx_air_defence','')
    if Object_GetAttr(char,'material')==5:
        if FFX_ObjectGetAttr(char,'absorbelectric',0)==1 or FFX_ObjectGetAttr(char,'absorbradiation',0)==1 or FFX_ObjectGetAttr(char,'absorbenergy',0)==1 or FFX_ObjectGetAttr(char,'absorbsound',0)==1:
            if usingM25AI():
                m25ai.AIDoPower(char, power='ffx_energy_defense', target=char, priority=m25ai.TACTIC_PRIORITY_CRITICAL, description='transforming into energy')
            else:
                Trigger_Power(char,char,'ffx_energy_defense','')

def morphAir(name,char,template,proportional=0,hasPortrait=1):
    morphVars=['shapeRow','originalIndex','shots0','shots1','shots2','shots3']
    if FFX_ObjectGetAttr(char,'morphing',0)==1:
        return
    FFX_ObjectSetAttr(char,'morphing',1)
    OnDrop(char,char)
    #store the RPG state of the character
    Mission_SetAttr('maxHealth_%s'%(name),Object_GetAttr(char,'maxHealth'))
    Mission_SetAttr('health_%s'%(name),Object_GetAttr(char,'health'))
    Mission_SetAttr('energyPoints_%s'%(name),Object_GetAttr(char,'energyPoints'))
    Mission_SetAttr('maxEnergyPoints_%s'%(name),Object_GetAttr(char,'maxEnergyPoints'))
    Mission_SetAttr('heroPoints_%s'%(name),Object_GetAttr(char,'heroPoints'))
    for var in morphVars:
        FFX_ObjectSetAttr(name,var,FFX_ObjectGetAttr(char,var))
    #set up appropriate M25 AI variables
    try:
        Mission_SetAttr('team_%s'%(name),m25ai.GetTeam(char))
        Mission_SetAttr('brawler_%s'%(name),m25ai.GetBrawler(char))
    except:
        pass
    #destroy the old portrait and turn off AI
    if (hasPortrait):
        AI_DestroyHeroAI(char)
    m25ai.AIDisable(char)
    Trigger_Move(char,'lock')
    cmd="morphAir2('%s','%s','%s',%d,%d)"%(name,char,template,proportional,hasPortrait)
    RegTimer('execTimer',0.1,0,cmd)
    RegTimer('destroyTemp',0.2,0,char)

def morphAir2(name,char,template,proportional,hasPortrait):
    #spawn the new form in the same spot as the old one
    FFX_Spawn(name,template,char)
    FFX_ObjectSetAttr(name,'morph',1)
    #make sure they have a template as appropriate
    if hasPortrait and (Object_GetClass(name)&OC_CONTROLLABLE)==0:
        AI_MakeIntoHero(name)
    if (hasPortrait==0) and (Object_GetClass(name)&OC_CONTROLLABLE)!=0:
        FFX_DestroyPortrait(name)
    if hasPortrait:
        Mission_SelectHero(name)
    team=Mission_GetAttr('team_%s'%(name))
    initMinionAI(name,team,'',isEvil(name))
    if usingM25AI():
    	m25ai.TransferAI(name,char)
    Object_PlayEffect(name,getMorphFX(char),'',FX_TRACK_OBJECT_FULL)
    #restore health etc as appropriate
    if proportional==0:
        Object_SetAttr(name,'health',Mission_GetAttr('health_%s'%(name)))
        Object_SetAttr(name,'maxHealth',Mission_GetAttr('maxHealth_%s'%(name)))
    else:
        #maxhealth is set by template
        Object_SetAttr(name,'health',(Mission_GetAttr('health_%s'%(name))*Object_GetAttr(name,'maxHealth'))/Mission_GetAttr('maxHealth_%s'%(name)))
    Object_SetAttr(name,'energyPoints',Mission_GetAttr('energyPoints_%s'%(name)))
    Object_SetAttr(name,'heroPoints',Mission_GetAttr('heroPoints_%s'%(name)))
    subtype = m25ai.FindTacticType(name, 'subtype')
    if ('air' in subtype):
        handle=Object_PlayEffect(name,'effect_sandstorm','',FX_LOOP|FX_TRACK_OBJECT_POS)
        RegTimer('makeAir',1,handle,name)
        RegTimer('OnAir',1,1,name)
        FFX_ObjectSetAttr(name,'absorbgas',0)
        FFX_ObjectSetAttr(name,'absorbair',1)
    elif ('gas' in subtype):
        handle=Object_PlayEffect(name,'effect_ffx_gaseousform','',FX_LOOP|FX_TRACK_OBJECT_POS)
        RegTimer('makeGas',1,handle,name)
        RegTimer('OnGas',1,1,name)
        FFX_ObjectSetAttr(name,'absorbgas',1)
        FFX_ObjectSetAttr(name,'absorbair',0)
    if Object_IsAlive(name)==0:
        Object_SetAttr(name,'health',1)
        kill(name)

def AbsorbWoodmat(target,char): 
    RegTimer('AbsorbWoodmove', 1, 0, char, target)

def AbsorbWoodmove(event): 
    char = event.object
    target = event.string 
    pos1 = Get_ObjectPos(char) 
    pos2 = Get_ObjectPos(target) 
    dist = cshelper.distance2D(pos1, pos2)
    if dist > 150:
        return
    if dist > 50: 
        Trigger_Move(char,'move',pos2) 
        RegTimer('AbsorbWoodmove', 1, 0, char, target) 
    else: 
        AbsorbWood(target,char)

def AbsorbWood(target,char):
    mat=7
    temp=FFX_GetTemplate(char)
    root=GetRootName(temp)
    name=getFormName()
    portrait=FFX_HasPortrait(char)
    template='%s_%s'%(root,absorbmaterialNames[int(mat)])
    Trigger_Power(char,target,getByTemplate(char,FFX_ABSORBMATERIAL_CUSTOM,1),'')
    if Template_Exists(template):
        morph(name,char,template,0,portrait)
        Mission_CustomAction('CUSTOM_REVERT',name,name,'OnRevertAbsorb',5,0)
        RegTimer('resetHealth',1,0,name)
        return
    template='%s (%s)'%(root,absorbmaterialNames[int(mat)])
    if Custom_Exists(template):
        morph(name,char,template,0,portrait)
        Mission_CustomAction('CUSTOM_REVERT',name,name,'OnRevertAbsorb',5,0)
        RegTimer('resetHealth',1,0,name)
        return
    else:
        Object_SetAttr(char,'material',7)
        Object_SetAttr(char,'strength',Object_GetAttr(char,'baseStrength'))
        Object_SetAttr(char,'speed',Object_GetAttr(char,'baseSpeed'))
        Object_SetAttr(char,'lastHealthSP',Object_GetAttr(char,'health'))
        Object_SetAttr(char,'health',(Object_GetAttr(char,'health'))*GetBaseHealth(char)/Object_GetAttr(char,'maxHealth'))
        Object_SetAttr(char,'maxHealth',(GetBaseHealth(char)))
        RegDamage(char,'OnWood')
        FFX_ObjectSetAttr(char,'absorbrubber',0)
        FFX_ObjectSetAttr(char,'absorbacid',0)
        FFX_ObjectSetAttr(char,'absorbsand',0)
        FFX_ObjectSetAttr(char,'dispersedForm',0)
        FFX_ObjectSetAttr(char,'alien_mineral',0)
        FFX_ObjectSetAttr(char,'absorbliquid',0)
        FFX_ObjectSetAttr(char,'absorbelectric',0)
        FFX_ObjectSetAttr(char,'absorbradiation',0)
        FFX_ObjectSetAttr(char,'absorbsound',0)
        FFX_ObjectSetAttr(char,'absorbenergy',0)
        FFX_ObjectSetAttr(char,'invPoints',FFX_ObjectGetAttr(char,'baseInvPoints'))
        removeOldMaterial(char)
        if getByTemplate(char,FFX_ABSORBPOWERS_CUSTOM,3)=='single':
            removeSingleAbsorber(target,char)
            removeSingleSubtype(target,char)

def OnWood(event):
    char=event.object
    if Object_GetAttr(char,'material')==7:
        damage=Object_GetAttr(char,'lastHealthSP')-Object_GetAttr(char,'health')
        if damage>0:
            Trigger_Explosion(char,'ffx_spiny',-1)
        Object_SetAttr(char,'lastHealthSP',Object_GetAttr(char,'health'))
        RegDamage(char,'OnWood')

def AbsorbConcretemat(target,char): 
    RegTimer('AbsorbConcretemove', 1, 0, char, target)

def AbsorbConcretemove(event): 
    char = event.object
    target = event.string 
    pos1 = Get_ObjectPos(char) 
    pos2 = Get_ObjectPos(target) 
    dist = cshelper.distance2D(pos1, pos2)
    if dist > 150:
        return
    if dist > 50: 
        Trigger_Move(char,'move',pos2) 
        RegTimer('AbsorbConcretemove', 1, 0, char, target) 
    else: 
        AbsorbConcrete(target,char)

def AbsorbConcrete(target,char):
    mat=8
    temp=FFX_GetTemplate(char)
    root=GetRootName(temp)
    name=getFormName()
    portrait=FFX_HasPortrait(char)
    template='%s_%s'%(root,absorbmaterialNames[int(mat)])
    Trigger_Power(char,target,getByTemplate(char,FFX_ABSORBMATERIAL_CUSTOM,1),'')
    if Template_Exists(template):
        morph(name,char,template,0,portrait)
        Mission_CustomAction('CUSTOM_REVERT',name,name,'OnRevertAbsorb',5,0)
        RegTimer('resetHealth',1,0,name)
        return
    template='%s (%s)'%(root,absorbmaterialNames[int(mat)])
    if Custom_Exists(template):
        morph(name,char,template,0,portrait)
        Mission_CustomAction('CUSTOM_REVERT',name,name,'OnRevertAbsorb',5,0)
        RegTimer('resetHealth',1,0,name)
        return
    else:
        str=Object_GetAttr(char,'baseStrength')+1
        Object_SetAttr(char,'strength',str)
        spd=Object_GetAttr(char,'baseSpeed')-1
        if spd<0:
            spd=0
        Object_SetAttr(char,'speed',spd)
        FFX_ObjectSetAttr(char,'invPoints',FFX_ObjectGetAttr(char,'baseInvPoints'))
        Object_SetAttr(char,'health',(Object_GetAttr(char,'health'))*GetBaseHealth(char)/Object_GetAttr(char,'maxHealth'))
        Object_SetAttr(char,'maxHealth',(GetBaseHealth(char)))
        Object_SetAttr(char,'material',8)
        FFX_ObjectSetAttr(char,'absorbacid',0)
        FFX_ObjectSetAttr(char,'absorbliquid',0)
        FFX_ObjectSetAttr(char,'absorbrubber',0)
        FFX_ObjectSetAttr(char,'absorbsand',0)
        FFX_ObjectSetAttr(char,'dispersedForm',0)
        FFX_ObjectSetAttr(char,'alien_mineral',0)
        FFX_ObjectSetAttr(char,'absorbelectric',0)
        FFX_ObjectSetAttr(char,'absorbradiation',0)
        FFX_ObjectSetAttr(char,'absorbsound',0)
        FFX_ObjectSetAttr(char,'absorbenergy',0)
        removeOldMaterial(char)
        if getByTemplate(char,FFX_ABSORBPOWERS_CUSTOM,3)=='single':
            removeSingleAbsorber(target,char)
            removeSingleSubtype(target,char)

def AbsorbIcemat(target,char): 
    RegTimer('AbsorbIcemove', 1, 0, char, target) #notice the target parameter 

def AbsorbIcemat(event): 
    char = event.object
    target = event.string 
    pos1 = Get_ObjectPos(char) 
    pos2 = Get_ObjectPos(target) 
    dist = cshelper.distance2D(pos1, pos2)
    if dist > 150: #150 is just a guess 
        return
    if dist > 50: 
        Trigger_Move(char,'move',pos2) 
        RegTimer('AbsorbIcemove', 1, 0, char, target) 
    else: 
        AbsorbIce(target,char)

def AbsorbIce(target,char):
    mat=9
    temp=FFX_GetTemplate(char)
    root=GetRootName(temp)
    name=getFormName()
    portrait=FFX_HasPortrait(char)
    template='%s_%s'%(root,absorbmaterialNames[int(mat)])
    Trigger_Power(char,target,getByTemplate(char,FFX_ABSORBMATERIAL_CUSTOM,1),'')
    if Template_Exists(template):
        morph(name,char,template,0,portrait)
        Mission_CustomAction('CUSTOM_REVERT',name,name,'OnRevertAbsorb',5,0)
        RegTimer('resetHealth',1,0,name)
        return
    template='%s (%s)'%(root,absorbmaterialNames[int(mat)])
    if Custom_Exists(template):
        morph(name,char,template,0,portrait)
        Mission_CustomAction('CUSTOM_REVERT',name,name,'OnRevertAbsorb',5,0)
        RegTimer('resetHealth',1,0,name)
        return
    else:
        handle=Object_PlayEffect(char,'effect_ffx_icesparks','',FX_LOOP|FX_TRACK_OBJECT_POS)
        RegTimer('OnIce',1,handle,char)
        Object_SetAttr(char,'strength',Object_GetAttr(char,'baseStrength'))
        Object_SetAttr(char,'speed',Object_GetAttr(char,'baseSpeed'))
        Object_SetAttr(char,'health',(Object_GetAttr(char,'health'))*GetBaseHealth(char)/Object_GetAttr(char,'maxHealth'))
        Object_SetAttr(char,'maxHealth',(GetBaseHealth(char)))
        Object_SetAttr(char,'material',9)
        FFX_ObjectSetAttr(char,'invPoints',FFX_ObjectGetAttr(char,'baseInvPoints'))
        FFX_ObjectSetAttr(char,'dispersedForm',0)
        FFX_ObjectSetAttr(char,'absorbacid',0)
        FFX_ObjectSetAttr(char,'absorbrubber',0)
        FFX_ObjectSetAttr(char,'absorbliquid',0)
        FFX_ObjectSetAttr(char,'absorbsand',0)
        FFX_ObjectSetAttr(char,'alien_mineral',0)
        FFX_ObjectSetAttr(char,'absorbelectric',0)
        FFX_ObjectSetAttr(char,'absorbradiation',0)
        FFX_ObjectSetAttr(char,'absorbsound',0)
        FFX_ObjectSetAttr(char,'absorbenergy',0)
        removeOldMaterial(char)
        if getByTemplate(char,FFX_ABSORBPOWERS_CUSTOM,3)=='single':
            removeSingleAbsorber(target,char)
            removeSingleSubtype(target,char)

def OnIce(event):
    char=event.object
    if Object_GetAttr(char,'material')==9:
        RegTimer('OnIce',1,event.user,char)
        Trigger_Explosion(char,'ffx_frostbite')
    else:
        Object_StopEffect(char,int(event.user))

def AbsorbClothmat(target,char): 
    RegTimer('AbsorbClothmove', 1, 0, char, target)

def AbsorbClothmove(event): 
    char = event.object
    target = event.string 
    pos1 = Get_ObjectPos(char) 
    pos2 = Get_ObjectPos(target) 
    dist = cshelper.distance2D(pos1, pos2)
    if dist > 150:
        return
    if dist > 50: 
        Trigger_Move(char,'move',pos2) 
        RegTimer('AbsorbClothmove', 1, 0, char, target) 
    else: 
        AbsorbCloth(target,char)

def AbsorbCloth(target,char):
    mat=10
    temp=FFX_GetTemplate(char)
    root=GetRootName(temp)
    name=getFormName()
    portrait=FFX_HasPortrait(char)
    template='%s_%s'%(root,absorbmaterialNames[int(mat)])
    Trigger_Power(char,target,getByTemplate(char,FFX_ABSORBMATERIAL_CUSTOM,1),'')
    if Template_Exists(template):
        morph(name,char,template,0,portrait)
        Mission_CustomAction('CUSTOM_REVERT',name,name,'OnRevertAbsorb',5,0)
        RegTimer('resetHealth',1,0,name)
        return
    template='%s (%s)'%(root,absorbmaterialNames[int(mat)])
    if Custom_Exists(template):
        morph(name,char,template,0,portrait)
        Mission_CustomAction('CUSTOM_REVERT',name,name,'OnRevertAbsorb',5,0)
        RegTimer('resetHealth',1,0,name)
        return
    else:
        str=Object_GetAttr(char,'baseStrength')-2
        Object_SetAttr(char,'strength',str)
        Object_SetAttr(char,'speed',Object_GetAttr(char,'baseSpeed'))
        Object_SetAttr(char,'health',(Object_GetAttr(char,'health'))*GetBaseHealth(char)/Object_GetAttr(char,'maxHealth'))
        Object_SetAttr(char,'maxHealth',(GetBaseHealth(char)))
        Object_SetAttr(char,'material',10)
        FFX_ObjectSetAttr(char,'invPoints',FFX_ObjectGetAttr(char,'baseInvPoints'))
        FFX_ObjectSetAttr(char,'absorbliquid',0)
        FFX_ObjectSetAttr(char,'dispersedForm',0)
        FFX_ObjectSetAttr(char,'absorbacid',0)
        FFX_ObjectSetAttr(char,'absorbrubber',0)
        FFX_ObjectSetAttr(char,'absorbsand',0)
        FFX_ObjectSetAttr(char,'alien_mineral',0)
        FFX_ObjectSetAttr(char,'absorbelectric',0)
        FFX_ObjectSetAttr(char,'absorbradiation',0)
        FFX_ObjectSetAttr(char,'absorbsound',0)
        FFX_ObjectSetAttr(char,'absorbenergy',0)
        removeOldMaterial(char)
        if getByTemplate(char,FFX_ABSORBPOWERS_CUSTOM,3)=='single':
            removeSingleAbsorber(target,char)
            removeSingleSubtype(target,char)

def AbsorbAdamantiummat(target,char): 
    RegTimer('AbsorbAdamantiummove', 1, 0, char, target)

def AbsorbAdamantiummove(event): 
    char = event.object
    target = event.string 
    pos1 = Get_ObjectPos(char) 
    pos2 = Get_ObjectPos(target) 
    dist = cshelper.distance2D(pos1, pos2)
    if dist > 150:
        return
    if dist > 50: 
        Trigger_Move(char,'move',pos2) 
        RegTimer('AbsorbAdamantiummove', 1, 0, char, target) 
    else: 
        AbsorbAdamantium(target,char)

def AbsorbAdamantium(target,char):
    mat=14
    temp=FFX_GetTemplate(char)
    root=GetRootName(temp)
    name=getFormName()
    portrait=FFX_HasPortrait(char)
    template='%s_%s'%(root,absorbmaterialNames[int(mat)])
    Trigger_Power(char,target,getByTemplate(char,FFX_ABSORBMATERIAL_CUSTOM,1),'')
    if Template_Exists(template):
        morph(name,char,template,0,portrait)
        Mission_CustomAction('CUSTOM_REVERT',name,name,'OnRevertAbsorb',5,0)
        RegTimer('resetHealth',1,0,name)
        return
    template='%s (%s)'%(root,absorbmaterialNames[int(mat)])
    if Custom_Exists(template):
        morph(name,char,template,0,portrait)
        Mission_CustomAction('CUSTOM_REVERT',name,name,'OnRevertAbsorb',5,0)
        RegTimer('resetHealth',1,0,name)
        return
    else:
        str=Object_GetAttr(char,'baseStrength')+2
        Object_SetAttr(char,'strength',str)
        Object_SetAttr(char,'speed',Object_GetAttr(char,'baseSpeed'))
        Object_SetAttr(char,'health',(Object_GetAttr(char,'health'))*GetBaseHealth(char)/Object_GetAttr(char,'maxHealth'))
        Object_SetAttr(char,'maxHealth',(GetBaseHealth(char)))
        Object_SetAttr(char,'material',8)
        invPoints=FFX_ObjectGetAttr(char,'invPoints')
        if invPoints==0:
            FFX_ObjectSetAttr(char,'ivlastdam',Object_GetAttr(char,'health'))
            if not FFX_ObjectGetAttr(char,'DamageManagement',0):
                RegDamage(char,'DamageManagement')
                FFX_ObjectSetAttr(char,'DamageManagement',1)
        if invPoints < 10:
            FFX_ObjectSetAttr(char,'invPoints',10)
        FFX_ObjectSetAttr(char,'absorbliquid',0)
        FFX_ObjectSetAttr(char,'absorbacid',0)
        FFX_ObjectSetAttr(char,'absorbrubber',0)
        FFX_ObjectSetAttr(char,'absorbsand',0)
        FFX_ObjectSetAttr(char,'dispersedForm',0)
        FFX_ObjectSetAttr(char,'alien_mineral',0)
        FFX_ObjectSetAttr(char,'absorbelectric',0)
        FFX_ObjectSetAttr(char,'absorbradiation',0)
        FFX_ObjectSetAttr(char,'absorbsound',0)
        FFX_ObjectSetAttr(char,'absorbenergy',0)
        removeOldMaterial(char)
        if getByTemplate(char,FFX_ABSORBPOWERS_CUSTOM,3)=='single':
            removeSingleAbsorber(target,char)
            removeSingleSubtype(target,char)

def AbsorbDivineMetalmat(target,char): 
    RegTimer('AbsorbDivineMetalmove', 1, 0, char, target) 

def AbsorbDivineMetalmove(event): 
    char = event.object
    target = event.string 
    pos1 = Get_ObjectPos(char) 
    pos2 = Get_ObjectPos(target) 
    dist = cshelper.distance2D(pos1, pos2)
    if dist > 150: 
        return
    if dist > 50: 
        Trigger_Move(char,'move',pos2) 
        RegTimer('AbsorbDivineMetalmove', 1, 0, char, target) 
    else: 
        AbsorbDivineMetal(target,char)

def AbsorbDivineMetal(target,char):
    mat=15
    temp=FFX_GetTemplate(char)
    root=GetRootName(temp)
    name=getFormName()
    portrait=FFX_HasPortrait(char)
    template='%s_%s'%(root,absorbmaterialNames[int(mat)])
    Trigger_Power(char,target,getByTemplate(char,FFX_ABSORBMATERIAL_CUSTOM,1),'')
    if Template_Exists(template):
        morph(name,char,template,0,portrait)
        Mission_CustomAction('CUSTOM_REVERT',name,name,'OnRevertAbsorb',5,0)
        RegTimer('resetHealth',1,0,name)
        return
    template='%s (%s)'%(root,absorbmaterialNames[int(mat)])
    if Custom_Exists(template):
        morph(name,char,template,0,portrait)
        Mission_CustomAction('CUSTOM_REVERT',name,name,'OnRevertAbsorb',5,0)
        RegTimer('resetHealth',1,0,name)
        return
    else:
        str=Object_GetAttr(char,'baseStrength')+3
        Object_SetAttr(char,'strength',str)
        Object_SetAttr(char,'speed',Object_GetAttr(char,'baseSpeed'))
        Object_SetAttr(char,'health',(Object_GetAttr(char,'health'))*GetBaseHealth(char)/Object_GetAttr(char,'maxHealth'))
        Object_SetAttr(char,'maxHealth',(GetBaseHealth(char)))
        Object_SetAttr(char,'material',8)
        invPoints=FFX_ObjectGetAttr(char,'invPoints')
        if invPoints==0:
            FFX_ObjectSetAttr(char,'ivlastdam',Object_GetAttr(char,'health'))
            if not FFX_ObjectGetAttr(char,'DamageManagement',0):
                RegDamage(char,'DamageManagement')
                FFX_ObjectSetAttr(char,'DamageManagement',1)
        if invPoints < 20:
            FFX_ObjectSetAttr(char,'invPoints',20)
        FFX_ObjectSetAttr(char,'absorbliquid',0)
        FFX_ObjectSetAttr(char,'absorbrubber',0)
        FFX_ObjectSetAttr(char,'absorbsand',0)
        FFX_ObjectSetAttr(char,'absorbacid',0)
        FFX_ObjectSetAttr(char,'dispersedForm',0)
        FFX_ObjectSetAttr(char,'alien_mineral',0)
        FFX_ObjectSetAttr(char,'absorbelectric',0)
        FFX_ObjectSetAttr(char,'absorbradiation',0)
        FFX_ObjectSetAttr(char,'absorbsound',0)
        FFX_ObjectSetAttr(char,'absorbenergy',0)
        removeOldMaterial(char)
        if getByTemplate(char,FFX_ABSORBPOWERS_CUSTOM,3)=='single':
            removeSingleAbsorber(target,char)
            removeSingleSubtype(target,char)

def AbsorbSuperAlloymat(target,char): 
    RegTimer('AbsorbSuperAlloymove', 1, 0, char, target) #notice the target parameter 

def AbsorbSuperAlloymove(event): 
    char = event.object
    target = event.string 
    pos1 = Get_ObjectPos(char) 
    pos2 = Get_ObjectPos(target) 
    dist = cshelper.distance2D(pos1, pos2)
    if dist > 150: #150 is just a guess 
        return
    if dist > 50: 
        Trigger_Move(char,'move',pos2) 
        RegTimer('AbsorbSuperAlloymove', 1, 0, char, target) 
    else: 
        AbsorbSuperAlloy(target,char)

def AbsorbSuperAlloy(target,char):
    mat=16
    temp=FFX_GetTemplate(char)
    root=GetRootName(temp)
    name=getFormName()
    portrait=FFX_HasPortrait(char)
    template='%s_%s'%(root,absorbmaterialNames[int(mat)])
    Trigger_Power(char,target,getByTemplate(char,FFX_ABSORBMATERIAL_CUSTOM,1),'')
    if Template_Exists(template):
        morph(name,char,template,0,portrait)
        Mission_CustomAction('CUSTOM_REVERT',name,name,'OnRevertAbsorb',5,0)
        RegTimer('resetHealth',1,0,name)
        return
    template='%s (%s)'%(root,absorbmaterialNames[int(mat)])
    if Custom_Exists(template):
        morph(name,char,template,0,portrait)
        Mission_CustomAction('CUSTOM_REVERT',name,name,'OnRevertAbsorb',5,0)
        RegTimer('resetHealth',1,0,name)
        return
    else:
        str=Object_GetAttr(char,'baseStrength')+3
        Object_SetAttr(char,'strength',str)
        Object_SetAttr(char,'speed',Object_GetAttr(char,'baseSpeed'))
        Object_SetAttr(char,'health',(Object_GetAttr(char,'health'))*GetBaseHealth(char)/Object_GetAttr(char,'maxHealth'))
        Object_SetAttr(char,'maxHealth',(GetBaseHealth(char)))
        Object_SetAttr(char,'material',8)
        invPoints=FFX_ObjectGetAttr(char,'invPoints')
        if invPoints==0:
            FFX_ObjectSetAttr(char,'ivlastdam',Object_GetAttr(char,'health'))
            if not FFX_ObjectGetAttr(char,'DamageManagement',0):
                RegDamage(char,'DamageManagement')
                FFX_ObjectSetAttr(char,'DamageManagement',1)
        if invPoints < 20:
            FFX_ObjectSetAttr(char,'invPoints',20)
        FFX_ObjectSetAttr(char,'absorbacid',0)
        FFX_ObjectSetAttr(char,'absorbliquid',0)
        FFX_ObjectSetAttr(char,'absorbrubber',0)
        FFX_ObjectSetAttr(char,'absorbsand',0)
        FFX_ObjectSetAttr(char,'dispersedForm',0)
        FFX_ObjectSetAttr(char,'alien_mineral',0)
        FFX_ObjectSetAttr(char,'absorbelectric',0)
        FFX_ObjectSetAttr(char,'absorbradiation',0)
        FFX_ObjectSetAttr(char,'absorbsound',0)
        FFX_ObjectSetAttr(char,'absorbenergy',0)
        removeOldMaterial(char)
        if getByTemplate(char,FFX_ABSORBPOWERS_CUSTOM,3)=='single':
            removeSingleAbsorber(target,char)
            removeSingleSubtype(target,char)

def AbsorbWatermat(target,char): 
    RegTimer('AbsorbWatermove', 1, 0, char, target)

def AbsorbWatermove(event): 
    char = event.object
    target = event.string 
    pos1 = Get_ObjectPos(char) 
    pos2 = Get_ObjectPos(target) 
    dist = cshelper.distance2D(pos1, pos2)
    if dist > 150:
        return
    if dist > 50: 
        Trigger_Move(char,'move',pos2) 
        RegTimer('AbsorbWatermove', 1, 0, char, target) 
    else: 
        AbsorbWater(target,char)

def AbsorbWater(target,char):
    mat=17
    temp=FFX_GetTemplate(char)
    root=GetRootName(temp)
    name=getFormName()
    portrait=FFX_HasPortrait(char)
    template='%s_%s'%(root,absorbmaterialNames[int(mat)])
    Trigger_Power(char,target,getByTemplate(char,FFX_ABSORBMATERIAL_CUSTOM,1),'')
    if Template_Exists(template):
        morph(name,char,template,0,portrait)
        Mission_CustomAction('CUSTOM_REVERT',name,name,'OnRevertAbsorb',5,0)
        RegTimer('resetHealth',1,0,name)
        return
    template='%s (%s)'%(root,absorbmaterialNames[int(mat)])
    if Custom_Exists(template):
        morph(name,char,template,0,portrait)
        Mission_CustomAction('CUSTOM_REVERT',name,name,'OnRevertAbsorb',5,0)
        RegTimer('resetHealth',1,0,name)
        return
    else:
        Object_SetAttr(char,'material',2)
        Object_SetAttr(char,'strength',Object_GetAttr(char,'baseStrength'))
        Object_SetAttr(char,'speed',Object_GetAttr(char,'baseSpeed'))
        FFX_ObjectSetAttr(char,'invPoints',FFX_ObjectGetAttr(char,'baseInvPoints'))
        Object_SetAttr(char,'health',(Object_GetAttr(char,'health'))*GetBaseHealth(char)/Object_GetAttr(char,'maxHealth'))
        Object_SetAttr(char,'maxHealth',(GetBaseHealth(char)))
        FFX_ObjectSetAttr(char,'absorbrubber',0)
        FFX_ObjectSetAttr(char,'absorbsand',0)
        FFX_ObjectSetAttr(char,'absorbacid',0)
        FFX_ObjectSetAttr(char,'alien_mineral',0)
        FFX_ObjectSetAttr(char,'dispersedForm',1)
        FFX_ObjectSetAttr(char,'absorbliquid',1)
        FFX_ObjectSetAttr(char,'wasdispersed',1)
        FFX_ObjectSetAttr(char,'absorbelectric',0)
        FFX_ObjectSetAttr(char,'absorbradiation',0)
        FFX_ObjectSetAttr(char,'absorbsound',0)
        FFX_ObjectSetAttr(char,'absorbenergy',0)
        addFFXAttrib(char,'dispersed')
        removeOldMaterial(char)
        if getByTemplate(char,FFX_ABSORBPOWERS_CUSTOM,3)=='single':
            removeSingleAbsorber(target,char)
            removeSingleSubtype(target,char)
        addCommand('CUSTOM_WATERBLAST',char,'water_blast',30)
        m25ai.AddGoal_DynamicAbility(char, temp_attribute='water blast', tactic='TRanged("manowar Water Jet")')

def AbsorbAcidmat(target,char): 
    RegTimer('AbsorbAcidmove', 1, 0, char, target)

def AbsorbAcidmove(event): 
    char = event.object
    target = event.string 
    pos1 = Get_ObjectPos(char) 
    pos2 = Get_ObjectPos(target) 
    dist = cshelper.distance2D(pos1, pos2)
    if dist > 150:
        return
    if dist > 50: 
        Trigger_Move(char,'move',pos2) 
        RegTimer('AbsorbAcidmove', 1, 0, char, target) 
    else: 
        AbsorbAcid(target,char)

def AbsorbAcid(target,char):
    mat=18
    temp=FFX_GetTemplate(char)
    root=GetRootName(temp)
    name=getFormName()
    portrait=FFX_HasPortrait(char)
    template='%s_%s'%(root,absorbmaterialNames[int(mat)])
    Trigger_Power(char,target,getByTemplate(char,FFX_ABSORBMATERIAL_CUSTOM,1),'')
    if Template_Exists(template):
        morph(name,char,template,0,portrait)
        Mission_CustomAction('CUSTOM_REVERT',name,name,'OnRevertAbsorb',5,0)
        RegTimer('resetHealth',1,0,name)
        return
    template='%s (%s)'%(root,absorbmaterialNames[int(mat)])
    if Custom_Exists(template):
        morph(name,char,template,0,portrait)
        Mission_CustomAction('CUSTOM_REVERT',name,name,'OnRevertAbsorb',5,0)
        RegTimer('resetHealth',1,0,name)
        return
    else:
        Object_SetAttr(char,'material',6)
        Object_SetAttr(char,'strength',Object_GetAttr(char,'baseStrength'))
        Object_SetAttr(char,'speed',Object_GetAttr(char,'baseSpeed'))
        FFX_ObjectSetAttr(char,'invPoints',FFX_ObjectGetAttr(char,'baseInvPoints'))
        Object_SetAttr(char,'health',(Object_GetAttr(char,'health'))*GetBaseHealth(char)/Object_GetAttr(char,'maxHealth'))
        Object_SetAttr(char,'maxHealth',(GetBaseHealth(char)))
        FFX_ObjectSetAttr(char,'absorbrubber',0)
        FFX_ObjectSetAttr(char,'absorbsand',0)
        FFX_ObjectSetAttr(char,'alien_mineral',0)
        FFX_ObjectSetAttr(char,'absorbacid',1)
        FFX_ObjectSetAttr(char,'dispersedForm',1)
        FFX_ObjectSetAttr(char,'wasdispersed',1)
        FFX_ObjectSetAttr(char,'absorbliquid',0)
        FFX_ObjectSetAttr(char,'absorbelectric',0)
        FFX_ObjectSetAttr(char,'absorbradiation',0)
        FFX_ObjectSetAttr(char,'absorbsound',0)
        FFX_ObjectSetAttr(char,'absorbenergy',0)
        addFFXAttrib(char,'dispersed')
        Object_SetAttr(char,'lastHealthAB',Object_GetAttr(char,'health'))
        RegDamage(char,'OnAcid')
        removeOldMaterial(char)
        if getByTemplate(char,FFX_ABSORBPOWERS_CUSTOM,3)=='single':
            removeSingleAbsorber(target,char)
            removeSingleSubtype(target,char)

def OnAcid(event):
    char=event.object
    if FFX_ObjectGetAttr(char,'absorbacid',0)==1:
        damage=Object_GetAttr(char,'lastHealthAB')-Object_GetAttr(char,'health')
        if damage>0:
            Trigger_Explosion(char,'ffx_acidblood')
        Object_SetAttr(char,'lastHealthAB',Object_GetAttr(char,'health'))
        RegDamage(char,'OnAcid')

def AbsorbSandmat(target,char): 
    RegTimer('AbsorbSandmove', 1, 0, char, target)

def AbsorbSandmove(event): 
    char = event.object
    target = event.string 
    pos1 = Get_ObjectPos(char) 
    pos2 = Get_ObjectPos(target) 
    dist = cshelper.distance2D(pos1, pos2)
    if dist > 150:
        return
    if dist > 50: 
        Trigger_Move(char,'move',pos2) 
        RegTimer('AbsorbSandmove', 1, 0, char, target) 
    else: 
        AbsorbSand(target,char)

def AbsorbSand(target,char):
    mat=19
    temp=FFX_GetTemplate(char)
    root=GetRootName(temp)
    name=getFormName()
    portrait=FFX_HasPortrait(char)
    template='%s_%s'%(root,absorbmaterialNames[int(mat)])
    Trigger_Power(char,target,getByTemplate(char,FFX_ABSORBMATERIAL_CUSTOM,1),'')
    if Template_Exists(template):
        morph(name,char,template,0,portrait)
        Mission_CustomAction('CUSTOM_REVERT',name,name,'OnRevertAbsorb',5,0)
        RegTimer('resetHealth',1,0,name)
        return
    template='%s (%s)'%(root,absorbmaterialNames[int(mat)])
    if Custom_Exists(template):
        morph(name,char,template,0,portrait)
        Mission_CustomAction('CUSTOM_REVERT',name,name,'OnRevertAbsorb',5,0)
        RegTimer('resetHealth',1,0,name)
        return
    else:
        Object_SetAttr(char,'material',6)
        Object_SetAttr(char,'strength',Object_GetAttr(char,'baseStrength'))
        Object_SetAttr(char,'speed',Object_GetAttr(char,'baseSpeed'))
        FFX_ObjectSetAttr(char,'invPoints',FFX_ObjectGetAttr(char,'baseInvPoints'))
        Object_SetAttr(char,'health',(Object_GetAttr(char,'health'))*GetBaseHealth(char)/Object_GetAttr(char,'maxHealth'))
        Object_SetAttr(char,'maxHealth',(GetBaseHealth(char)))
        Mission_CustomAction('CUSTOM_SANDSTORM',char,char,'OnSandStorm',5,0)
        FFX_ObjectSetAttr(char,'absorbsand',1)
        FFX_ObjectSetAttr(char,'absorbrubber',0)
        FFX_ObjectSetAttr(char,'absorbacid',0)
        FFX_ObjectSetAttr(char,'alien_mineral',0)
        FFX_ObjectSetAttr(char,'dispersedForm',1)
        FFX_ObjectSetAttr(char,'wasdispersed',1)
        FFX_ObjectSetAttr(char,'absorbliquid',0)
        FFX_ObjectSetAttr(char,'absorbelectric',0)
        FFX_ObjectSetAttr(char,'absorbradiation',0)
        FFX_ObjectSetAttr(char,'absorbsound',0)
        FFX_ObjectSetAttr(char,'absorbenergy',0)
        addFFXAttrib(char,'dispersed')
        removeOldMaterial(char)
        if getByTemplate(char,FFX_ABSORBPOWERS_CUSTOM,3)=='single':
            removeSingleAbsorber(target,char)
            removeSingleSubtype(target,char)
        m25ai.AddGoal_DynamicAbility(char, temp_attribute='absorbsand', tactic='TSandStorm()')

def AbsorbGasmat(target,char): 
    RegTimer('AbsorbGasmove', 1, 0, char, target)

def AbsorbGasmove(event): 
    char = event.object
    target = event.string 
    pos1 = Get_ObjectPos(char) 
    pos2 = Get_ObjectPos(target) 
    dist = cshelper.distance2D(pos1, pos2)
    if dist > 150:
        return
    if dist > 50: 
        Trigger_Move(char,'move',pos2) 
        RegTimer('AbsorbGasmove', 1, 0, char, target) 
    else: 
        AbsorbGas(target,char)

def AbsorbGas(target,char):
    mat=20
    temp=FFX_GetTemplate(char)
    root=GetRootName(temp)
    name=getFormName()
    portrait=FFX_HasPortrait(char)
    template='%s_%s'%(root,absorbmaterialNames[int(mat)])
    Trigger_Power(char,target,getByTemplate(char,FFX_ABSORBMATERIAL_CUSTOM,1),'')
    if Template_Exists(template):
        morphAir(name,char,template,0,portrait)
        Mission_CustomAction('CUSTOM_REVERT',name,name,'OnRevertAbsorb',5,0)
        RegTimer('resetHealth',1,0,name)
        return
    template='%s (%s)'%(root,absorbmaterialNames[int(mat)])
    if Custom_Exists(template):
        morphAir(name,char,template,0,portrait)
        Mission_CustomAction('CUSTOM_REVERT',name,name,'OnRevertAbsorb',5,0)
        RegTimer('resetHealth',1,0,name)
        return
    else:
        spd=Object_GetAttr(char,'baseSpeed')/2
        if spd<2:
            spd=2
        if spd>4:
            spd=4
        Object_SetAttr(char,'speed',spd)
        Object_SetAttr(char,'strength',Object_GetAttr(char,'baseStrength'))
        FFX_ObjectSetAttr(char,'absorbrubber',0)
        FFX_ObjectSetAttr(char,'absorbsand',0)
        FFX_ObjectSetAttr(char,'absorbacid',0)
        FFX_ObjectSetAttr(char,'absorbgas',1)
        FFX_ObjectSetAttr(char,'absorbair',0)
        FFX_ObjectSetAttr(char,'dispersedForm',0)
        FFX_ObjectSetAttr(char,'absorbliquid',0)
        FFX_ObjectSetAttr(char,'alien_mineral',0)
        FFX_ObjectSetAttr(char,'absorbelectric',0)
        FFX_ObjectSetAttr(char,'absorbradiation',0)
        FFX_ObjectSetAttr(char,'absorbsound',0)
        FFX_ObjectSetAttr(char,'absorbenergy',0)
        FFX_ObjectSetAttr(char,'invPoints',FFX_ObjectGetAttr(char,'baseInvPoints'))
        Object_SetAttr(char,'health',(Object_GetAttr(char,'health'))*GetBaseHealth(char)/Object_GetAttr(char,'maxHealth'))
        Object_SetAttr(char,'maxHealth',(GetBaseHealth(char)))
        Object_SetAttr(char,'material',6)
        handle=Object_PlayEffect(char,'effect_ffx_gaseousform','',FX_LOOP|FX_TRACK_OBJECT_FULL,0,'centre')
        FFX_ObjectSetAttr(char,'absorbGasHandle',handle)
        RegTimer('makeGas',0.1,handle,char)
        RegTimer('OnGas',0.7,1,char)
        RegTimer('makepass_thru',1,0,char)
        removeOldMaterial(char)
        if getByTemplate(char,FFX_ABSORBPOWERS_CUSTOM,3)=='single':
            removeSingleAbsorber(target,char)
            removeSingleSubtype(target,char)

def makeGas(event):
    char=event.object
    if FFX_ObjectGetAttr(char,'absorbgas',0)==1:
        RegTimer('makeGas',1,event.user,char)
        Object_PlayEffect(char,'effect_ffx_gaseousform','',FX_TRACK_OBJECT_FULL)
        if not hasAttribute(char,'flier') or hasAttribute(char,'levitate') or js.Object_GetSecondaryStates(char) & js.SCSTATE_BUOYANT:
            ff.RESULTBUBBLE_SCALE=0
            RegTimer('bubblesOn',0.1)
            Object_SetSecondaryState(char,SCSTATE_BUOYANT,10000,0)
            RegTimer('removeFX',0.5,1,char)
    else:
        Object_SetSecondaryState(char,SCSTATE_BUOYANT,0,REMOVE_STATE)
        handle=FFX_ObjectGetAttr(char,'absorbGasHandle')
        Object_StopEffect(char,handle)
        Object_SetAttr(char,'speed',Object_GetAttr(char,'baseSpeed'))
        removePassThruDefence(char)
    if not Object_GetAttr(char,'material')==6:
        FFX_ObjectSetAttr(char,'absorbgas',0)

def OnGas(event):
    char=event.object
    if FFX_ObjectGetAttr(char,'absorbgas',0)==1:
        RegTimer('OnGas',1,event.user,char)
        Object_PlayEffect(char,'effect_ffx_gaseousform','',FX_TRACK_OBJECT_FULL)
        Trigger_Explosion(char,'ffx_gaseousform')


def AbsorbDiamondmat(target,char): 
    RegTimer('AbsorbDiamondmove', 1, 0, char, target)

def AbsorbDiamondmove(event): 
    char = event.object
    target = event.string 
    pos1 = Get_ObjectPos(char)
    pos2 = Get_ObjectPos(target) 
    dist = cshelper.distance2D(pos1, pos2)
    if dist > 150:
        return
    if dist > 50: 
        Trigger_Move(char,'move',pos2) 
        RegTimer('AbsorbDiamondmove', 1, 0, char, target) 
    else: 
        AbsorbDiamond(target,char)

def AbsorbDiamond(target,char):
    mat=21
    temp=FFX_GetTemplate(char)
    root=GetRootName(temp)
    name=getFormName()
    portrait=FFX_HasPortrait(char)
    template='%s_%s'%(root,absorbmaterialNames[int(mat)])
    Trigger_Power(char,target,getByTemplate(char,FFX_ABSORBMATERIAL_CUSTOM,1),'')
    if Template_Exists(template):
        morph(name,char,template,0,portrait)
        Mission_CustomAction('CUSTOM_REVERT',name,name,'OnRevertAbsorb',5,0)
        RegTimer('resetHealth',1,0,name)
        return
    template='%s (%s)'%(root,absorbmaterialNames[int(mat)])
    if Custom_Exists(template):
        morph(name,char,template,0,portrait)
        Mission_CustomAction('CUSTOM_REVERT',name,name,'OnRevertAbsorb',5,0)
        RegTimer('resetHealth',1,0,name)
        return
    else:
        str=Object_GetAttr(char,'baseStrength')+2
        Object_SetAttr(char,'strength',str)
        Object_SetAttr(char,'speed',Object_GetAttr(char,'baseSpeed'))
        Object_SetAttr(char,'health',(Object_GetAttr(char,'health'))*GetBaseHealth(char)/Object_GetAttr(char,'maxHealth'))
        Object_SetAttr(char,'maxHealth',(GetBaseHealth(char)))
        Object_SetAttr(char,'material',8)
        invPoints=FFX_ObjectGetAttr(char,'invPoints')
        if invPoints==0:
            FFX_ObjectSetAttr(char,'ivlastdam',Object_GetAttr(char,'health'))
            if not FFX_ObjectGetAttr(char,'DamageManagement',0):
                RegDamage(char,'DamageManagement')
                FFX_ObjectSetAttr(char,'DamageManagement',1)
        if invPoints < 5:
            FFX_ObjectSetAttr(char,'invPoints',5)
        FFX_ObjectSetAttr(char,'absorbacid',0)
        FFX_ObjectSetAttr(char,'absorbrubber',0)
        FFX_ObjectSetAttr(char,'absorbsand',0)
        FFX_ObjectSetAttr(char,'dispersedForm',0)
        FFX_ObjectSetAttr(char,'alien_mineral',0)
        FFX_ObjectSetAttr(char,'absorbliquid',0)
        FFX_ObjectSetAttr(char,'absorbelectric',0)
        FFX_ObjectSetAttr(char,'absorbradiation',0)
        FFX_ObjectSetAttr(char,'absorbsound',0)
        FFX_ObjectSetAttr(char,'absorbenergy',0)
        removeOldMaterial(char)
        if getByTemplate(char,FFX_ABSORBPOWERS_CUSTOM,3)=='single':
            removeSingleAbsorber(target,char)
            removeSingleSubtype(target,char)

def AbsorbAlienMineralmat(target,char): 
    RegTimer('AbsorbAlienMineralmove', 1, 0, char, target)

def AbsorbAlienMineralmove(event): 
    char = event.object
    target = event.string 
    pos1 = Get_ObjectPos(char) 
    pos2 = Get_ObjectPos(target) 
    dist = cshelper.distance2D(pos1, pos2)
    if dist > 150:
        return
    if dist > 50: 
        Trigger_Move(char,'move',pos2) 
        RegTimer('AbsorbAlienMineralmove', 1, 0, char, target) 
    else: 
        AbsorbAlienMineral(target,char)

def AbsorbAlienMineral(target,char):
    mat=22
    temp=FFX_GetTemplate(char)
    root=GetRootName(temp)
    name=getFormName()
    portrait=FFX_HasPortrait(char)
    template='%s_%s'%(root,absorbmaterialNames[int(mat)])
    Trigger_Power(char,target,getByTemplate(char,FFX_ABSORBMATERIAL_CUSTOM,1),'')
    if Template_Exists(template):
        morph(name,char,template,0,portrait)
        Mission_CustomAction('CUSTOM_REVERT',name,name,'OnRevertAbsorb',5,0)
        RegTimer('resetHealth',1,0,name)
        return
    template='%s (%s)'%(root,absorbmaterialNames[int(mat)])
    if Custom_Exists(template):
        morph(name,char,template,0,portrait)
        Mission_CustomAction('CUSTOM_REVERT',name,name,'OnRevertAbsorb',5,0)
        RegTimer('resetHealth',1,0,name)
        return
    else:
        str=Object_GetAttr(char,'baseStrength')+1
        Object_SetAttr(char,'strength',str)
        Object_SetAttr(char,'speed',Object_GetAttr(char,'baseSpeed'))
        Object_SetAttr(char,'health',(Object_GetAttr(char,'health'))*GetBaseHealth(char)/Object_GetAttr(char,'maxHealth'))
        Object_SetAttr(char,'maxHealth',(GetBaseHealth(char)))
        Object_SetAttr(char,'material',2)
        FFX_ObjectSetAttr(char,'invPoints',FFX_ObjectGetAttr(char,'baseInvPoints'))
        FFX_ObjectSetAttr(char,'absorbacid',0)
        FFX_ObjectSetAttr(char,'absorbsand',0)
        FFX_ObjectSetAttr(char,'absorbrubber',0)
        FFX_ObjectSetAttr(char,'dispersedForm',0)
        FFX_ObjectSetAttr(char,'mineralised',1)
        FFX_ObjectSetAttr(char,'alien_mineral',1)
        FFX_ObjectSetAttr(char,'absorbliquid',0)
        FFX_ObjectSetAttr(char,'absorbelectric',0)
        FFX_ObjectSetAttr(char,'absorbradiation',0)
        FFX_ObjectSetAttr(char,'absorbsound',0)
        FFX_ObjectSetAttr(char,'absorbenergy',0)
        removeOldMaterial(char)
        if getByTemplate(char,FFX_ABSORBPOWERS_CUSTOM,3)=='single':
            removeSingleAbsorber(target,char)
            removeSingleSubtype(target,char)

def removeOldMaterial(char):
    if FFX_ObjectGetAttr(char,'absorbrubber',0)!=1:
        removeCommand('custom_leapto',char)
    if FFX_ObjectGetAttr(char,'absorbsand',0)!=1:
        removeCommand('CUSTOM_SANDSTORM',char)
    if FFX_ObjectGetAttr(char,'wasdispersed',0)==1:
        if FFX_ObjectGetAttr(char,'dispersedForm',0)!=1:
            removeFFXAttrib(char,'dispersed')
            FFX_ObjectSetAttr(char,'wasdispersed',0)
    if FFX_ObjectGetAttr(char,'alien_mineral',0)!=1:
        if not hasAttribute(char,'toxic'):
            FFX_ObjectSetAttr(char,'mineralised',0)
    if FFX_ObjectGetAttr(char,'absorbelectric',0)!=1:
        removeCommand('CUSTOM_BOLTTO',char)
    if FFX_ObjectGetAttr(char,'absorbradiation',0)!=1:
        removeCommand('CUSTOM_BEAMTO',char)
    if FFX_ObjectGetAttr(char,'absorbenergy',0)!=1:
        removeCommand('CUSTOM_LASERTO',char)
    if FFX_ObjectGetAttr(char,'absorbsound',0)!=1:
        removeCommand('CUSTOM_SONICWAVE',char)
    if Object_GetAttr(char,'material')!=4:
        removeCommand('CUSTOM_FLAMEBLAST',char)
    if FFX_ObjectGetAttr(char,'absorbliquid',0)!=1:
        removeCommand('CUSTOM_WATERBLAST',char)

def isNotSpecialMat(mat):
    if mat==0:
        return 0
    return 1

def GetRootName(name):
    if name[-4:]=='_npc':
        name=name[:-4]
    for m in absorbmaterialNames:
        suffix='_%s'%(m)
        l=len(suffix)
        if name[-l:]==suffix:
            return name[:-l]
        suffix=' (%s)'%(m)
        l=len(suffix)
        if name[-l:]==suffix:
            return name[:-l]
    return name

def Custom_Exists(name):
    for set in ffxID.ffxIDs:
        if name==set[0]:
            return 1
    return 0

def OnRevertAbsorb(dummy,char):
    template=getOriginalTemplate(char)
    name=getFormName()
    morph(name,char,template,0,1)


################## Absorb Energy ##################
def initabsorbenergy(char,update=0):
    objects = Mission_GetObjects()
    for obj in objects:
        if ((Object_GetClass(obj)&FFX_CHARACTER)!=0) & (obj!=char):
            if not initabsorbEnergy_subtype(char, obj):
                initabsorbEnergy_nosubtype(char,obj)
        elif obj!=char:
            initabsorbEnergy_nosubtype(char,obj)
    RegTimer('addAbsorbEnergyCmd', 3, 0, char)

def addAbsorbEnergyCmd(event):
    char=event.object
    for obj in Mission_GetObjects():
        if ((Object_GetClass(obj)&FFX_CHARACTER)!=0) & (obj!=char):
            if FFX_ObjectGetAttr(obj,'absorbEnergyCmd',0)==0:
                if not initabsorbEnergy_subtype(char, obj):
                    initabsorbEnergy_nosubtype(char,obj)
                elif obj!=char:
                    initabsorbEnergy_nosubtype(char,obj)
                FFX_ObjectSetAttr(obj,'absorbEnergyCmd',1)
    RegTimer('addAbsorbEnergyCmd', 2, 0, char)

# initialize the absorb energy attribute based on the subtype given in the AI definition
# returns 1 if an appropriate subtype is found
# returns 0 if no appropriate subtype is found
def initabsorbEnergy_subtype(char, obj):
    subtype = m25ai.FindTacticType(obj, 'subtype')
    if ('energy' in subtype):
        Mission_CustomAction('ABSORB_ENERGY',char,obj,'AbsorbEnergymat',FFX_ABSORBRANGE,0)
    if ('fire' in subtype):
        Mission_CustomAction('ABSORB_FIRE',char,obj,'AbsorbFiremat',FFX_ABSORBRANGE,0)
    if ('electricity' in subtype):
        Mission_CustomAction('ABSORB_ELECTRICITY',char,obj,'AbsorbElectricalmat',FFX_ABSORBRANGE,0)
    if ('radiation' in subtype):
        Mission_CustomAction('ABSORB_RADIATION',char,obj,'AbsorbRadiationmat',FFX_ABSORBRANGE,0)
    if ('sound' in subtype):
        Mission_CustomAction('ABSORB_SOUND',char,obj,'AbsorbSoundmat',FFX_ABSORBRANGE,0)
    if ('sonic' in subtype):
        Mission_CustomAction('ABSORB_SOUND_ATTACK',char,obj,'AbsorbSound',30,0)
    if ('energy' in subtype) | ('fire' in subtype) | ('electricity' in subtype) | ('radiation' in subtype) | ('sound' in subtype):
        return 1
        FFX_ObjectSetAttr(obj,'absorbEnergyCmd',1)
    else:
        return 0

def initabsorbEnergy_nosubtype(char, obj):
    ###absorb by type of power damage###
    if ((Object_GetClass(obj)&FFX_CHARACTER)!=0):
        if m25ai.HasPowerType(obj,'electrical','ranged') | m25ai.HasPowerType(obj,'electrical','area'):
            Mission_CustomAction('ABSORB_ELECTRICAL_ATTACK',char,obj,'AbsorbElectrical',30,0)
        if m25ai.HasPowerType(obj,'radiation','ranged') | m25ai.HasPowerType(obj,'radiation','area'):
            Mission_CustomAction('ABSORB_RADIATION_ATTACK',char,obj,'AbsorbRadiation',30,0)
        if m25ai.HasPowerType(obj,'fire','ranged') | m25ai.HasPowerType(obj,'fire','area'):
            Mission_CustomAction('ABSORB_FIRE_ATTACK',char,obj,'AbsorbFire',30,0)
        if m25ai.HasPowerType(obj,'energy','ranged') | m25ai.HasPowerType(obj,'energy','area'):
            Mission_CustomAction('ABSORB_ENERGY_ATTACK',char,obj,'AbsorbEnergy',30,0)
    ###absorb by object template###
    if Object_GetTemplate(obj)=='abomb':
        Mission_CustomAction('ABSORB_RADIATION',char,obj,'AbsorbRadiationmat',FFX_ABSORBRANGE,0)
    elif Object_GetTemplate(obj)=='ffx_staticcage' or (isElectricalGrid(obj)):
        Mission_CustomAction('ABSORB_ELECTRICITY',char,obj,'AbsorbElectricalmat',FFX_ABSORBRANGE,0)
    elif Object_GetTemplate(obj) in ('ffx_firecage', 'ffx_flames', 'cub_military_crate', 'ger_crate_ammo', 'truck_ger_ammo', 'cub_fuel_barrels', 'ger_barrel'):
        Mission_CustomAction('ABSORB_FIRE',char,obj,'AbsorbFiremat',FFX_ABSORBRANGE,0)
    ###absorb by object's material###
    mat=Object_GetAttr(obj,'material')
    if mat==4:
        Mission_CustomAction('ABSORB_FIRE',char,obj,'AbsorbFiremat',FFX_ABSORBRANGE,0)
    elif mat==5:
       Mission_CustomAction('ABSORB_ENERGY',char,obj,'AbsorbEnergymat',FFX_ABSORBRANGE,0)
    FFX_ObjectSetAttr(obj,'absorbEnergyCmd',1)

def AbsorbElectricalmat(target,char): 
    RegTimer('AbsorbElectricalmove', 1, 0, char, target)

def AbsorbElectricalmove(event): 
    char = event.object
    target = event.string 
    pos1 = Get_ObjectPos(char) 
    pos2 = Get_ObjectPos(target) 
    dist = cshelper.distance2D(pos1, pos2)
    if dist > 150:
        return
    if dist > 50: 
        Trigger_Move(char,'move',pos2) 
        RegTimer('AbsorbElectricalmove', 1, 0, char, target) 
    else: 
        AbsorbElectrical(target,char)

def AbsorbElectrical(target,char):
    mat=11
    temp=FFX_GetTemplate(char)
    root=GetRootName(temp)
    name=getFormName()
    portrait=FFX_HasPortrait(char)
    template='%s_%s'%(root,absorbmaterialNames[int(mat)])
    Trigger_Power(char,target,getByTemplate(char,FFX_ABSORBENERGY_CUSTOM,1),'')
    if Template_Exists(template):
        morph(name,char,template,0,portrait)
        Mission_CustomAction('CUSTOM_REVERT',name,name,'OnRevertAbsorb',5,0)
        RegTimer('resetHealth',1,0,name)
        return
    template='%s (%s)'%(root,absorbmaterialNames[int(mat)])
    if Custom_Exists(template):
        morph(name,char,template,0,portrait)
        Mission_CustomAction('CUSTOM_REVERT',name,name,'OnRevertAbsorb',5,0)
        RegTimer('resetHealth',1,0,name)
        return
    else:
        FFX_ObjectSetAttr(char,'invPoints',FFX_ObjectGetAttr(char,'baseInvPoints'))
        Object_SetAttr(char,'material',5)
        Object_SetAttr(char,'strength',Object_GetAttr(char,'baseStrength'))
        Object_SetAttr(char,'speed',Object_GetAttr(char,'baseSpeed'))
        Object_SetAttr(char,'health',(Object_GetAttr(char,'health'))*GetBaseHealth(char)/Object_GetAttr(char,'maxHealth'))
        Object_SetAttr(char,'maxHealth',(GetBaseHealth(char)))
        handle=Object_PlayEffect(char,'effect_ffx_electricsparks','',FX_LOOP|FX_TRACK_OBJECT_POS)
        FFX_ObjectSetAttr(char,'absorbElectricHandle',handle)
        RegTimer('OnElectric',1,handle,char)
        FFX_ObjectSetAttr(char,'dispersedForm',0)
        FFX_ObjectSetAttr(char,'absorbrubber',0)
        FFX_ObjectSetAttr(char,'absorbsand',0)
        FFX_ObjectSetAttr(char,'absorbacid',0)
        FFX_ObjectSetAttr(char,'absorbelectric',1)
        FFX_ObjectSetAttr(char,'absorbradiation',0)
        FFX_ObjectSetAttr(char,'absorbsound',0)
        FFX_ObjectSetAttr(char,'absorbenergy',0)
        FFX_ObjectSetAttr(char,'alien_mineral',0)
        FFX_ObjectSetAttr(char,'absorbliquid',0)
        FFX_ObjectSetAttr(char,'absorbgas',0)
        FFX_ObjectSetAttr(char,'absorbair',0)
        RegTimer('makepass_thru',1,0,char)
        removeOldMaterial(char)
        if getByTemplate(char,FFX_ABSORBPOWERS_CUSTOM,3)=='single':
            removeSingleAbsorber(target,char)
            removeSingleSubtype(target,char)
        addCommand('CUSTOM_BOLTTO',char,'OnEnergyAbsorbLaserTo',30)
        m25ai.AddGoal_DynamicAbility(char, temp_attribute='absorb_electric', tactic='TLivingLaser()')
        m25ai.AddGoal_DynamicAbility(char, temp_attribute='absorb_electric', tactic='TLivingLaserAway()')

def AbsorbRadiationmat(target,char): 
    RegTimer('AbsorbRadiationmove', 1, 0, char, target)

def AbsorbRadiationmove(event): 
    char = event.object
    target = event.string 
    pos1 = Get_ObjectPos(char) 
    pos2 = Get_ObjectPos(target) 
    dist = cshelper.distance2D(pos1, pos2)
    if dist > 150:
        return
    if dist > 50: 
        Trigger_Move(char,'move',pos2) 
        RegTimer('AbsorbRadiationmove', 1, 0, char, target) 
    else: 
        AbsorbRadiation(target,char)

def AbsorbRadiation(target,char):
    mat=12
    temp=FFX_GetTemplate(char)
    root=GetRootName(temp)
    name=getFormName()
    portrait=FFX_HasPortrait(char)
    template='%s_%s'%(root,absorbmaterialNames[int(mat)])
    Trigger_Power(char,target,getByTemplate(char,FFX_ABSORBENERGY_CUSTOM,1),'')
    if Template_Exists(template):
        morph(name,char,template,0,portrait)
        Mission_CustomAction('CUSTOM_REVERT',name,name,'OnRevertAbsorb',5,0)
        RegTimer('resetHealth',1,0,name)
        return
    template='%s (%s)'%(root,absorbmaterialNames[int(mat)])
    if Custom_Exists(template):
        morph(name,char,template,0,portrait)
        Mission_CustomAction('CUSTOM_REVERT',name,name,'OnRevertAbsorb',5,0)
        RegTimer('resetHealth',1,0,name)
        return
    else:
        FFX_ObjectSetAttr(char,'invPoints',FFX_ObjectGetAttr(char,'baseInvPoints'))
        Object_SetAttr(char,'material',5)
        Object_SetAttr(char,'strength',Object_GetAttr(char,'baseStrength'))
        Object_SetAttr(char,'speed',Object_GetAttr(char,'baseSpeed'))
        Object_SetAttr(char,'health',(Object_GetAttr(char,'health'))*GetBaseHealth(char)/Object_GetAttr(char,'maxHealth'))
        Object_SetAttr(char,'maxHealth',(GetBaseHealth(char)))
        handle=Object_PlayEffect(char,'effect_ffx_energysparks','',FX_LOOP|FX_TRACK_OBJECT_POS)
        FFX_ObjectSetAttr(char,'absorbRadiationHandle',handle)
        RegTimer('OnRadiation',1,handle,char)
        FFX_ObjectSetAttr(char,'dispersedForm',0)
        FFX_ObjectSetAttr(char,'absorbrubber',0)
        FFX_ObjectSetAttr(char,'absorbsand',0)
        FFX_ObjectSetAttr(char,'absorbacid',0)
        FFX_ObjectSetAttr(char,'absorbliquid',0)
        FFX_ObjectSetAttr(char,'absorbradiation',1)
        FFX_ObjectSetAttr(char,'absorbelectric',0)
        FFX_ObjectSetAttr(char,'absorbsound',0)
        FFX_ObjectSetAttr(char,'absorbenergy',0)
        FFX_ObjectSetAttr(char,'alien_mineral',0)
        FFX_ObjectSetAttr(char,'absorbgas',0)
        FFX_ObjectSetAttr(char,'absorbair',0)
        RegTimer('makepass_thru',1,0,char)
        removeOldMaterial(char)
        if getByTemplate(char,FFX_ABSORBPOWERS_CUSTOM,3)=='single':
            removeSingleAbsorber(target,char)
            removeSingleSubtype(target,char)
        addCommand('CUSTOM_BEAMTO',char,'OnEnergyAbsorbLaserTo',30)
        m25ai.AddGoal_DynamicAbility(char, temp_attribute='absorb_radiation', tactic='TLivingLaser()')
        m25ai.AddGoal_DynamicAbility(char, temp_attribute='absorb_radiation', tactic='TLivingLaserAway()')

def AbsorbFiremat(target,char): 
    RegTimer('AbsorbFiremove', 1, 0, char, target)

def AbsorbFiremove(event): 
    char = event.object
    target = event.string 
    pos1 = Get_ObjectPos(char) 
    pos2 = Get_ObjectPos(target) 
    dist = cshelper.distance2D(pos1, pos2)
    if dist > 150:
        return
    if dist > 50: 
        Trigger_Move(char,'move',pos2) 
        RegTimer('AbsorbFiremove', 1, 0, char, target) 
    else: 
        AbsorbFire(target,char)

def AbsorbFire(target,char):
    mat=4
    temp=FFX_GetTemplate(char)
    root=GetRootName(temp)
    name=getFormName()
    portrait=FFX_HasPortrait(char)
    template='%s_%s'%(root,absorbmaterialNames[int(mat)])
    Trigger_Power(char,target,getByTemplate(char,FFX_ABSORBENERGY_CUSTOM,1),'')
    if Template_Exists(template):
        morph(name,char,template,0,portrait)
        Mission_CustomAction('CUSTOM_REVERT',name,name,'OnRevertAbsorb',5,0)
        RegTimer('resetHealth',1,0,name)
        return
    template='%s (%s)'%(root,absorbmaterialNames[int(mat)])
    if Custom_Exists(template):
        morph(name,char,template,0,portrait)
        Mission_CustomAction('CUSTOM_REVERT',name,name,'OnRevertAbsorb',5,0)
        RegTimer('resetHealth',1,0,name)
        return
    else:
        FFX_ObjectSetAttr(char,'absorbrubber',0)
        FFX_ObjectSetAttr(char,'absorbsand',0)
        FFX_ObjectSetAttr(char,'absorbacid',0)
        FFX_ObjectSetAttr(char,'dispersedForm',0)
        FFX_ObjectSetAttr(char,'alien_mineral',0)
        FFX_ObjectSetAttr(char,'absorbliquid',0)
        FFX_ObjectSetAttr(char,'absorbgas',0)
        FFX_ObjectSetAttr(char,'absorbair',0)
        FFX_ObjectSetAttr(char,'invPoints',FFX_ObjectGetAttr(char,'baseInvPoints'))
        Object_SetAttr(char,'material',mat)
        Object_SetAttr(char,'strength',Object_GetAttr(char,'baseStrength'))
        Object_SetAttr(char,'speed',Object_GetAttr(char,'baseSpeed'))
        Object_SetAttr(char,'health',(Object_GetAttr(char,'health'))*GetBaseHealth(char)/Object_GetAttr(char,'maxHealth'))
        Object_SetAttr(char,'maxHealth',(GetBaseHealth(char)))
        handle=Object_PlayEffect(char,'effect_ffx_flames','',FX_LOOP|FX_TRACK_OBJECT_POS)
        FFX_ObjectSetAttr(char,'absorbFIrenHandle',handle)
        RegTimer('OnFire',1,handle,char)
        removeOldMaterial(char)
        if getByTemplate(char,FFX_ABSORBPOWERS_CUSTOM,3)=='single':
            removeSingleAbsorber(target,char)
            removeSingleSubtype(target,char)
        addCommand('CUSTOM_FLAMEBLAST',char,'flame_blast',30)
        m25ai.AddGoal_DynamicAbility(char, temp_attribute='flame blast', tactic='TRanged("eldiablo Flame Projection")')

def AbsorbEnergymat(target,char): 
    RegTimer('AbsorbEnergymove', 1, 0, char, target)

def AbsorbEnergymove(event): 
    char = event.object
    target = event.string 
    pos1 = Get_ObjectPos(char) 
    pos2 = Get_ObjectPos(target) 
    dist = cshelper.distance2D(pos1, pos2)
    if dist > 150:
        return
    if dist > 50:
        Trigger_Move(char,'move',pos2)
        RegTimer('AbsorbEnergylmove', 1, 0, char, target)
    else:
        AbsorbEnergy(target,char)

def AbsorbEnergy(target,char):
    mat=5
    temp=FFX_GetTemplate(char)
    root=GetRootName(temp)
    name=getFormName()
    portrait=FFX_HasPortrait(char)
    template='%s_%s'%(root,absorbmaterialNames[int(mat)])
    Trigger_Power(char,target,getByTemplate(char,FFX_ABSORBENERGY_CUSTOM,1),'')
    if Template_Exists(template):
        morph(name,char,template,0,portrait)
        Mission_CustomAction('CUSTOM_REVERT',name,name,'OnRevertAbsorb',5,0)
        RegTimer('resetHealth',1,0,name)
        return
    template='%s (%s)'%(root,absorbmaterialNames[int(mat)])
    if Custom_Exists(template):
        morph(name,char,template,0,portrait)
        Mission_CustomAction('CUSTOM_REVERT',name,name,'OnRevertAbsorb',5,0)
        RegTimer('resetHealth',1,0,name)
        return
    else:
        FFX_ObjectSetAttr(char,'invPoints',FFX_ObjectGetAttr(char,'baseInvPoints'))
        Object_SetAttr(char,'material',5)
        Object_SetAttr(char,'strength',Object_GetAttr(char,'baseStrength'))
        Object_SetAttr(char,'speed',Object_GetAttr(char,'baseSpeed'))
        Object_SetAttr(char,'health',(Object_GetAttr(char,'health'))*GetBaseHealth(char)/Object_GetAttr(char,'maxHealth'))
        Object_SetAttr(char,'maxHealth',(GetBaseHealth(char)))
        FFX_ObjectSetAttr(char,'dispersedForm',0)
        FFX_ObjectSetAttr(char,'absorbliquid',0)
        FFX_ObjectSetAttr(char,'absorbrubber',0)
        FFX_ObjectSetAttr(char,'absorbsand',0)
        FFX_ObjectSetAttr(char,'absorbacid',0)
        FFX_ObjectSetAttr(char,'alien_mineral',0)
        FFX_ObjectSetAttr(char,'absorbenergy',1)
        FFX_ObjectSetAttr(char,'absorbradiation',0)
        FFX_ObjectSetAttr(char,'absorbsound',0)
        FFX_ObjectSetAttr(char,'absorbelectric',0)
        FFX_ObjectSetAttr(char,'absorbgas',0)
        FFX_ObjectSetAttr(char,'absorbair',0)
        RegTimer('makepass_thru',1,0,char)
        addCommand('CUSTOM_LASERTO',char,'OnEnergyAbsorbLaserTo',30)
        Object_SetSecondaryState(char,SCSTATE_ENERGIZED,10,0)
        handle=Object_PlayEffect(char,'effect_ffx_energysparks','',FX_LOOP|FX_TRACK_OBJECT_POS)
        FFX_ObjectSetAttr(char,'absorbEnergyHandle',handle)
        RegTimer('OnEnergy',1,handle,char)
        removeOldMaterial(char)
        if getByTemplate(char,FFX_ABSORBPOWERS_CUSTOM,3)=='single':
            removeSingleAbsorber(target,char)
            removeSingleSubtype(target,char)
        m25ai.AddGoal_DynamicAbility(char, temp_attribute='absorb_energy', tactic='TLivingLaser()')
        m25ai.AddGoal_DynamicAbility(char, temp_attribute='absorb_energy', tactic='TLivingLaserAway()')

def AbsorbSoundmat(target,char): 
    RegTimer('AbsorbSoundmove', 1, 0, char, target)

def AbsorbSoundmove(event): 
    char = event.object
    target = event.string 
    pos1 = Get_ObjectPos(char) 
    pos2 = Get_ObjectPos(target) 
    dist = cshelper.distance2D(pos1, pos2)
    if dist > 150:
        return
    if dist > 50: 
        Trigger_Move(char,'move',pos2) 
        RegTimer('AbsorbSoundmove', 1, 0, char, target) 
    else: 
        AbsorbSound(target,char)

def AbsorbSound(target,char):
    mat=13
    temp=FFX_GetTemplate(char)
    root=GetRootName(temp)
    name=getFormName()
    portrait=FFX_HasPortrait(char)
    template='%s_%s'%(root,absorbmaterialNames[int(mat)])
    Trigger_Power(char,target,getByTemplate(char,FFX_ABSORBENERGY_CUSTOM,1),'')
    if Template_Exists(template):
        morph(name,char,template,0,portrait)
        Mission_CustomAction('CUSTOM_REVERT',name,name,'OnRevertAbsorb',5,0)
        RegTimer('resetHealth',1,0,name)
        return
    template='%s (%s)'%(root,absorbmaterialNames[int(mat)])
    if Custom_Exists(template):
        morph(name,char,template,0,portrait)
        Mission_CustomAction('CUSTOM_REVERT',name,name,'OnRevertAbsorb',5,0)
        RegTimer('resetHealth',1,0,name)
        return
    else:
        Object_SetAttr(char,'material',5)
        Object_SetAttr(char,'strength',Object_GetAttr(char,'baseStrength'))
        Object_SetAttr(char,'speed',Object_GetAttr(char,'baseSpeed'))
        Object_SetAttr(char,'health',(Object_GetAttr(char,'health'))*GetBaseHealth(char)/Object_GetAttr(char,'maxHealth'))
        Object_SetAttr(char,'maxHealth',(GetBaseHealth(char)))
        FFX_ObjectSetAttr(char,'invPoints',FFX_ObjectGetAttr(char,'baseInvPoints'))
        handle=Object_PlayEffect(char,'effect_ffx_energysparks','',FX_LOOP|FX_TRACK_OBJECT_POS)
        FFX_ObjectSetAttr(char,'absorbSoundHandle',handle)
        RegTimer('OnSound',1,handle,char)
        FFX_ObjectSetAttr(char,'dispersedForm',0)
        FFX_ObjectSetAttr(char,'absorbrubber',0)
        FFX_ObjectSetAttr(char,'absorbsand',0)
        FFX_ObjectSetAttr(char,'absorbacid',0)
        FFX_ObjectSetAttr(char,'alien_mineral',0)
        FFX_ObjectSetAttr(char,'absorbsound',1)
        FFX_ObjectSetAttr(char,'absorbradiation',0)
        FFX_ObjectSetAttr(char,'absorbelectric',0)
        FFX_ObjectSetAttr(char,'absorbliquid',0)
        FFX_ObjectSetAttr(char,'absorbenergy',0)
        FFX_ObjectSetAttr(char,'absorbgas',0)
        FFX_ObjectSetAttr(char,'absorbair',0)
        RegTimer('makepass_thru',1,0,char)
        removeOldMaterial(char)
        if getByTemplate(char,FFX_ABSORBPOWERS_CUSTOM,3)=='single':
            removeSingleAbsorber(target,char)
            removeSingleSubtype(target,char)
        addCommand('CUSTOM_SONICWAVE',char,'OnEnergyAbsorbLaserTo',30)
        m25ai.AddGoal_DynamicAbility(char, temp_attribute='absorb_sound', tactic='TLivingLaser()')
        m25ai.AddGoal_DynamicAbility(char, temp_attribute='absorb_sound', tactic='TLivingLaserAway()')

def OnEnergyAbsorbLaserTo(target,hero):
    if chargeEP(hero,FFX_EP_LIVINGLASER)==0:
        return
    name=getDummyName()
    spawn(name,'portal_start_proxy',hero)
    alignWith(name,hero)
    if FFX_ObjectGetAttr(hero,'absorbelectric',0)==1:
        FFX_LIVINGLASER_CUSTOM=[["default","timemaster Electrical Bolt","effect_ffx_electricsparks","effect_ffx_electricsparks","CUSTOM_BOLTTO"]]
    elif FFX_ObjectGetAttr(hero,'absorbsound',0)==1:
        FFX_LIVINGLASER_CUSTOM=[["default","ffx_sonic_beam","effect_the_ant_antenna","effect_the_ant_antenna","CUSTOM_SONICWAVE"]]
    elif FFX_ObjectGetAttr(hero,'absorbradiation',0)==1:
        FFX_LIVINGLASER_CUSTOM=[["default","ffx_radiation_beam","effect_portal_activate","effect_portal_activate","CUSTOM_BEAMTO"]]
    else:
        FFX_LIVINGLASER_CUSTOM=[["default","ffx_living_laser","effect_portal_activate","effect_portal_activate","CUSTOM_LASERTO"]]
    Object_PlayEffect(hero,getByTemplate(hero,FFX_LIVINGLASER_CUSTOM,2),'',0)
    Trigger_Power(hero,target,getByTemplate(hero,FFX_LIVINGLASER_CUSTOM,1),'')
    RegTimer('OnLaser',0.5,0,hero,target)
    RegTimer('OnLaser2',2.8,0,hero,target)
    RegTimer('UnEnergyAbsorberLaser',3,10,hero,target)

def UnEnergyAbsorberLaser(event):
    hero=event.object
    target=event.string
    makeUncloak(hero)
    makeUnphase(hero)
    if FFX_ObjectGetAttr(hero,'absorbelectric',0)==1:
        FFX_LIVINGLASER_CUSTOM=[["default","timemaster Electrical Bolt","effect_ffx_electricsparks","effect_ffx_electricsparks","CUSTOM_BOLTTO"]]
    elif FFX_ObjectGetAttr(hero,'absorbsound',0)==1:
        FFX_LIVINGLASER_CUSTOM=[["default","ffx_sonic_beam","effect_the_ant_antenna","effect_the_ant_antenna","CUSTOM_SONICWAVE"]]
    elif FFX_ObjectGetAttr(hero,'absorbradiation',0)==1:
        FFX_LIVINGLASER_CUSTOM=[["default","ffx_radiation_beam","effect_portal_activate","effect_portal_activate","CUSTOM_BEAMTO"]]
    else:
        FFX_LIVINGLASER_CUSTOM=[["default","ffx_living_laser","effect_portal_activate","effect_portal_activate","CUSTOM_LASERTO"]]
    Object_PlayEffect(hero,getByTemplate(hero,FFX_LIVINGLASER_CUSTOM,3),'',0)
    turnTo(hero,target)

def removePassThruDefence(char):
    name=getDummyName()
    Object_SpawnAt('ffx_tiggot',Get_ObjectPos(char),name)
    if usingM25AI():
        m25ai.AIDoPower(name, power='ffq_remove_defence', target=char, priority=m25ai.TACTIC_PRIORITY_CRITICAL, description='removing passthru defence')
    else:
        Trigger_Power(name,char,'ffq_remove_defence','')
    RegTimer('ffx.destroyTemp',3,0,name)

def OnElectric(event):
    char=event.object
    if FFX_ObjectGetAttr(char,'absorbelectric',0)==1:
        RegTimer('OnElectric',1,event.user,char)
        Trigger_Explosion(char,'ffx_shortcircuit')
    else:
        removePassThruDefence(char)
        handle=FFX_ObjectGetAttr(char,'absorbElectricHandle')
        Object_StopEffect(char,handle)
    if not Object_GetAttr(char,'material')==5:
        FFX_ObjectSetAttr(char,'absorbelectric',0)

def OnRadiation(event):
    char=event.object
    if FFX_ObjectGetAttr(char,'absorbradiation',0)==1:
        RegTimer('OnRadiation',1,event.user,char)
        Trigger_Explosion(char,'ffx_biohazard')
    else:
        removePassThruDefence(char)
        handle=FFX_ObjectGetAttr(char,'absorbRadiationHandle')
        Object_StopEffect(char,handle)
    if not Object_GetAttr(char,'material')==5:
        FFX_ObjectSetAttr(char,'absorbradiation',0)

def OnSound(event):
    char=event.object
    if FFX_ObjectGetAttr(char,'absorbsound',0)==1:
        RegTimer('OnSound',1,event.user,char)
        Trigger_Explosion(char,'the ant Ultrasonic Field')
    else:
        removePassThruDefence(char)
        handle=FFX_ObjectGetAttr(char,'absorbSoundHandle')
        Object_StopEffect(char,handle)
    if not Object_GetAttr(char,'material')==5:
        FFX_ObjectSetAttr(char,'absorbsound',0)

def OnEnergy(event):
    char=event.object
    if FFX_ObjectGetAttr(char,'absorbenergy',0)==1:
        RegTimer('OnEnergy',1,event.user,char)
        Trigger_Explosion(char,'ffx_biohazard_energy')
    else:
        removePassThruDefence(char)
        handle=FFX_ObjectGetAttr(char,'absorbEnergyHandle')
        Object_StopEffect(char,handle)
        if not hasAttribute(char,'livinglaser'):
            removeCommand('CUSTOM_LASERTO',char)
    if not Object_GetAttr(char,'material')==5:
        FFX_ObjectSetAttr(char,'absorbenergy',0)

def OnFire(event):
    char=event.object
    if Object_GetAttr(char,'material')==4:
        RegTimer('OnFire',1,event.user,char)
        Trigger_Explosion(char,'ffx_overheated')
    else:
        removePassThruDefence(char)
        handle=FFX_ObjectGetAttr(char,'absorbFireHandle')
        Object_StopEffect(char,handle)

################## Absorb Powers ##################
def GetSubtypeMaterial(target):
    subtype = m25ai.FindTacticType(target, 'subtype')
    if ('flesh' in subtype) | ('normal_human' in subtype):
        return 0
    elif ('metal' in subtype):
        return 1
    elif ('stone' in subtype):
        return 2
    elif ('rubber' in subtype):
        return 3
    elif ('fire' in subtype):
        return 4
    elif ('energy' in subtype):
        return 5
    elif ('air' in subtype):
        return 6
    elif ('wood' in subtype):
        return 7
    elif ('concrete' in subtype):
        return 8
    elif ('ice' in subtype):
        return 9
    elif ('cloth' in subtype):
        return 10
    elif ('electricity' in subtype):
        return 11
    elif ('radiation' in subtype):
        return 12
    elif ('sound' in subtype):
        return 13
    elif ('adamantium' in subtype):
        return 14
    elif ('divine_metal' in subtype):
        return 15
    elif ('super_alloy' in subtype):
        return 16
    elif ('liquid' in subtype):
        return 17
    elif ('acid' in subtype):
        return 18
    elif ('sand' in subtype):
        return 19
    elif ('gas' in subtype):
        return 20
    elif ('diamond' in subtype):
        return 21
    elif ('alien_mineral' in subtype):
        return 22
    else:
        mat=Object_GetAttr(target,'material')
        return mat

ORIGINAL_FORM = 0

def initabsorbpower(char,update=0):
    FFX_ObjectSetAttr(char,'templateEnergy',Object_GetAttr(char,'energy'))
    FFX_ObjectSetAttr(char,'baseMat',GetSubtypeMaterial(char))
    FFX_ObjectSetAttr(char,'baseInvPoints',FFX_ObjectGetAttr(char,'invPoints'))
    FFX_ObjectSetAttr(char,'baseMass',Object_GetAttr(char,'mass'))
    Object_SetAttr(char,'basehealth',Object_GetAttr(char,'health'))
    Object_SetAttr(char,'baseMaxhealth',Object_GetAttr(char,'maxHealth'))
    FFX_ObjectSetAttr(char,'kinetic bolt',0)
    FFX_ObjectSetAttr(char,'kinetic blast',0)
    FFX_ObjectSetAttr(char,'electric shock',0)
    FFX_ObjectSetAttr(char,'electric blast',0)
    FFX_ObjectSetAttr(char,'electric explosion',0)
    FFX_ObjectSetAttr(char,'radioactive blast',0)
    FFX_ObjectSetAttr(char,'radioactive touch',0)
    FFX_ObjectSetAttr(char,'radioactive explosion',0)
    FFX_ObjectSetAttr(char,'acid fist',0)
    FFX_ObjectSetAttr(char,'area acid',0)
    FFX_ObjectSetAttr(char,'shoot acid',0)
    FFX_ObjectSetAttr(char,'fire fist',0)
    FFX_ObjectSetAttr(char,'flame blast',0)
    FFX_ObjectSetAttr(char,'flame breath',0)
    FFX_ObjectSetAttr(char,'fire explosion',0)
    FFX_ObjectSetAttr(char,'heat blast',0)
    FFX_ObjectSetAttr(char,'heat explosion',0)
    FFX_ObjectSetAttr(char,'frozen touch',0)
    FFX_ObjectSetAttr(char,'icy blast',0)
    FFX_ObjectSetAttr(char,'frozen explosion',0)
    FFX_ObjectSetAttr(char,'energy touch',0)
    FFX_ObjectSetAttr(char,'energy blast',0)
    FFX_ObjectSetAttr(char,'energy explosion',0)
    FFX_ObjectSetAttr(char,'absorb flying',0)
    FFX_ObjectSetAttr(char,'nature master',0)
    FFX_ObjectSetAttr(char,'urban animator',0)
    FFX_ObjectSetAttr(char,'ice power',0)
    FFX_ObjectSetAttr(char,'flame powers',0)
    FFX_ObjectSetAttr(char,'earth powers',0)
    FFX_ObjectSetAttr(char,'weather powers',0)
    FFX_ObjectSetAttr(char,'tk',0)
    FFX_ObjectSetAttr(char,'super leaper',0)
    FFX_ObjectSetAttr(char,'sonic powers',0)
    FFX_ObjectSetAttr(char,'gravity powers',0)
    FFX_ObjectSetAttr(char,'magnetic powers',0)
    FFX_ObjectSetAttr(char,'liquid powers',0)
    FFX_ObjectSetAttr(char,'cloning',0)
    FFX_ObjectSetAttr(char,'ice powers',0)
    FFX_ObjectSetAttr(char,'vanish',0)
    FFX_ObjectSetAttr(char,'force field',0)
    FFX_ObjectSetAttr(char,'mental powers',0)
    FFX_ObjectSetAttr(char,'mystic powers',0)
    FFX_ObjectSetAttr(char,'teleportation',0)
    FFX_ObjectSetAttr(char,'phaser',0)
    FFX_ObjectSetAttr(char,'super speed',0)
    FFX_ObjectSetAttr(char,'probability good',0)
    FFX_ObjectSetAttr(char,'probability bad',0)
    FFX_ObjectSetAttr(char,'hyper sense',0)
    FFX_ObjectSetAttr(char,'rapidhealing',0)
    FFX_ObjectSetAttr(char,'regenerative',0)
    FFX_ObjectSetAttr(char,'superhealing',0)
    FFX_ObjectSetAttr(char,'light powers',0)
    FFX_ObjectSetAttr(char,'density control',0)
    FFX_ObjectSetAttr(char,'metamorph',0)
    FFX_ObjectSetAttr(char,'sand storm',0)
    FFX_ObjectSetAttr(char,'ice cloud',0)
    FFX_ObjectSetAttr(char,'gaseous form',0)
    FFX_ObjectSetAttr(char,'plasma sculpting',0)
    FFX_ObjectSetAttr(char,'heat vision',0)
    FFX_ObjectSetAttr(char,'crush vision',0)
    FFX_ObjectSetAttr(char,'energy vision',0)
    FFX_ObjectSetAttr(char,'electric vision',0)
    FFX_ObjectSetAttr(char,'rad vision',0)
    FFX_ObjectSetAttr(char,'hyperbreath',0)
    FFX_ObjectSetAttr(char,'digger',0)
    FFX_ObjectSetAttr(char,'sonic_scream',0)
    FFX_ObjectSetAttr(char,'darkforce',0)
    global ORIGINAL_FORM
    ORIGINAL_FORM = m25template.GetComplexTemplate(char)
    objects = Mission_GetDynamicObjects()
    for obj in objects:
        if((Object_GetClass(obj)&FFX_CHARACTER)!=0) & (obj!=char):
            subtype = m25ai.FindTacticType(obj, 'subtype')
            mat=GetSubtypeMaterial(obj)
            mymat=GetSubtypeMaterial(char)
            temp=FFX_GetTemplate(char)
            root=GetRootName(temp)
            template='%s_%s'%(root,absorbmaterialNames[int(mat)])
            if Template_Exists(template) & (mymat!=mat):
                absorbPowerSetCustomCommand(char, obj, changeForm=1)
            template='%s (%s)'%(root,absorbmaterialNames[int(mat)])
            if Custom_Exists(template) & (mymat!=mat):
                absorbPowerSetCustomCommand(char, obj, changeForm=1)
            else:
                absorbPowerSetCustomCommand(char, obj, changeForm=0)

def addAbsorbPowerCmd(event):
    char=event.object
    for obj in Mission_GetDynamicObjects():
        if ((Object_GetClass(obj) & FFX_CHARACTER)!=0) & (obj!=char) & ((Object_GetClass(obj)&js.OC_VEHICLE)==0) & ((Object_GetClass(obj)&js.OC_GENERIC)==0):
            if FFX_ObjectGetAttr(obj,'absorbCmd',0)==0:
                changeForm=FFX_ObjectGetAttr(char,'changeForm')
                if changeForm: #if the value of the changeForm parameter == 1:
                    absorbPower = 'absorbMove_changeForm'
                else:
                    absorbPower = 'absorbMove'
                if getByTemplate(char,FFX_ABSORBPOWERS_CUSTOM,3)=='steal':
                    Mission_CustomAction('STEAL_POWERS',char,obj,absorbPower,FFX_ABSORBRANGE,0)
                else:
                    Mission_CustomAction('ABSORB_POWERS',char,obj,absorbPower,FFX_ABSORBRANGE,0)
                FFX_ObjectSetAttr(obj,'absorbCmd',1)
    RegTimer('addAbsorbPowerCmd', 2, 0, char)

def absorbPowerSetCustomCommand(char, obj, changeForm=0):
    subtype = m25ai.FindTacticType(obj, 'subtype')
    if FFX_ObjectGetAttr(char,'phased',0)==1:
        return
    if ('robot' in subtype) or ('hitech' in subtype):
        return
    FFX_ObjectSetAttr(char,'changeForm',changeForm)
    if changeForm: #if the value of the changeForm parameter == 1:
        absorbPower = 'absorbMove_changeForm'
    else:
        absorbPower = 'absorbMove'
    if getByTemplate(char,FFX_ABSORBPOWERS_CUSTOM,3)=='steal':
        Mission_CustomAction('STEAL_POWERS',char,obj,absorbPower,FFX_ABSORBRANGE,0)
    else:
        Mission_CustomAction('ABSORB_POWERS',char,obj,absorbPower,FFX_ABSORBRANGE,0)
    FFX_ObjectSetAttr(obj,'absorbCmd',1)
    RegTimer('addAbsorbPowerCmd', 3, 0, char)

def absorb(char,target,attr):
    myAttr=Object_GetAttr(char,attr)
    yourAttr=Object_GetAttr(target,attr)
    if attr=='speed':
        myAttr=FFX_GetSpeed(char)
        yourAttr=FFX_GetSpeed(target)
    if yourAttr>myAttr:
        if attr=='energy':
            FFX_SetEnergy(char,yourAttr)
        else:
            Object_SetAttr(char,attr,yourAttr)
            if attr=='speed':
                Object_SetAttr(char,'baseSpeed',yourAttr)
            if attr=='agility':
                Object_SetAttr(char,'agility',yourAttr)
            if attr=='energy':
                Object_SetAttr(char,'baseEnergy',yourAttr)
        if attr=='maxHealth':
            hp=Object_GetAttr(char,'health')
            hp=(hp*yourAttr)/myAttr
            Object_SetAttr(char,'health',hp)

def absorbMove(target,char): 
    RegTimer('AbsorbPowersmove', 1, 0, char, target)

def AbsorbPowersmove(event): 
    char = event.object
    target = event.string 
    pos1 = Get_ObjectPos(char) 
    pos2 = Get_ObjectPos(target) 
    dist = cshelper.distance2D(pos1, pos2)
    if dist > 150:
        return
    if dist > 50: 
        Trigger_Move(char,'move',pos2) 
        RegTimer('AbsorbPowersmove', 1, 0, char, target) 
    else: 
        absorbPower(target,char)

def absorbMove_changeForm(target,char): 
    RegTimer('AbsorbPowersmove_cf', 1, 0, char, target)

def AbsorbPowersmove_cf(event): 
    char = event.object
    target = event.string 
    pos1 = Get_ObjectPos(char) 
    pos2 = Get_ObjectPos(target) 
    dist = cshelper.distance2D(pos1, pos2)
    if dist > 150:
        return
    if dist > 50: 
        Trigger_Move(char,'move',pos2) 
        RegTimer('AbsorbPowersmove_cf', 1, 0, char, target) 
    else: 
        absorbPower_changeForm(target,char)

def absorbPower_changeForm(target,char):
    mat=GetSubtypeMaterial(target)
    myMat=GetSubtypeMaterial(char)
    subtype = m25ai.FindTacticType(target, 'subtype')
    Trigger_Power(char,target,getByTemplate(char,FFX_ABSORBPOWERS_CUSTOM,1),'')
    ### Remove commands related to materials no longer active ###
    FFX_ObjectSetAttr(char,'absorbrubber',0)
    FFX_ObjectSetAttr(char,'absorbsand',0)
    FFX_ObjectSetAttr(char,'absorbacid',0)
    FFX_ObjectSetAttr(char,'dispersedForm',0)
    FFX_ObjectSetAttr(char,'alien_mineral',0)
    FFX_ObjectSetAttr(char,'absorbliquid',0)
    FFX_ObjectSetAttr(char,'absorbelectric',0)
    FFX_ObjectSetAttr(char,'absorbradiation',0)
    FFX_ObjectSetAttr(char,'absorbsound',0)
    FFX_ObjectSetAttr(char,'absorbenergy',0)
    removeOldMaterial(char)
    if getByTemplate(char,FFX_ABSORBPOWERS_CUSTOM,3)=='steal':
        targetStr=Object_GetAttr(target,'baseStrength')
        targetHealth=Object_GetAttr(target,'maxHealth')
        targetEng=Object_GetAttr(target,'energy')
        if targetStr>=9 | (targetHealth>=300) | (targetEng>=9):
            if randint(1,100)<75:
                Object_SetPrimaryState(char,PCSTATE_STUNNED,10,0)
                return
        Object_SetPrimaryState(target,PCSTATE_STUNNED,20,0)
        Object_SetSecondaryState(target,SCSTATE_POWER_NULLIFICATION,20,0)
        RegTimer(getByTemplate(char,FFX_ABSORBPOWERS_CUSTOM,4),0.2,1,char)
        RegCharState(target,PCSTATE_NORMAL,'removeStolen',0,0,char)
    RegDeath(target,'removeStolen')
    if getByTemplate(char,FFX_ABSORBPOWERS_CUSTOM,2)=='single':
        if mat!=myMat:
            temp=FFX_GetTemplate(char)
            root=GetRootName(temp)
            name=getFormName()
            portrait=FFX_HasPortrait(char)
            template='%s_%s'%(root,absorbmaterialNames[int(mat)])
            if Template_Exists(template):
                if mat==20 | (mat==6):
                    morphAir(name,char,template,0,portrait)
                else:
                    morph(name,char,template,0,portrait)
                RegTimer('giveTempPowers',1,0,name,target)
                Mission_CustomAction('CUSTOM_REVERT',name,name,'OnRevertAbsorb',5,0)
                return
            template='%s (%s)'%(root,absorbmaterialNames[int(mat)])
            if Custom_Exists(template):
                if mat==20 | (mat==6):
                    morphAir(name,char,template,0,portrait)
                else:
                    morph(name,char,template,0,portrait)
                RegTimer('giveTempPowers',1,0,name,target)
                Mission_CustomAction('CUSTOM_REVERT',name,name,'OnRevertAbsorb',5,0)
                return
            removeSingleAbsorber(target,char)
            removeSingleSubtype(target,char)
            powers_Absorbed(target,char)
            return
        removeSingleAbsorber(target,char)
        removeSingleSubtype(target,char)
        powers_Absorbed(target,char)
    else:
        if mat!=0:
            if myMat==15 | (myMat==16):
                powers_Absorbed(target,char)
                return
            if myMat==21:
                if not mat==15 | (mat==16) | (mat==14):
                    powers_Absorbed(target,char)
                    return
            if myMat==14:
                if not mat==15 | (mat==16):
                    powers_Absorbed(target,char)
                    return
            if myMat==8:
                if not mat==15 | (mat==16) | (mat==14) | (mat==21):
                    powers_Absorbed(target,char)
                    return
            if myMat==2:
                if not mat==15 | (mat==16) | (mat==14) | (mat==8) | (mat==21):
                    powers_Absorbed(target,char)
                    return
            else:
                temp=FFX_GetTemplate(char)
                root=GetRootName(temp)
                name=getFormName()
                portrait=FFX_HasPortrait(char)
                template='%s_%s'%(root,absorbmaterialNames[int(mat)])
                if Template_Exists(template):
                    if mat==20 | (mat==6):
                        morphAir(name,char,template,0,portrait)
                    else:
                        morph(name,char,template,0,portrait)
                    RegTimer('giveTempPowers',1,0,name,target)
                    Mission_CustomAction('CUSTOM_REVERT',name,name,'OnRevertAbsorb',5,0)
                template='%s (%s)'%(root,absorbmaterialNames[int(mat)])
                if Custom_Exists(template):
                    if mat==20 | (mat==6):
                        morphAir(name,char,template,0,portrait)
                    else:
                        morph(name,char,template,0,portrait)
                    RegTimer('giveTempPowers',1,0,name,target)
                    Mission_CustomAction('CUSTOM_REVERT',name,name,'OnRevertAbsorb',5,0)
                    return
        if mat==0:
            mat=Object_GetAttr(target,'material')
            if mat > 0:
                if myMat==15 | (myMat==16) | (myMat==21) | (myMat==14) | (myMat==0):
                    powers_Absorbed(target,char)
                    return
                else:
                    mat=0
                    temp=FFX_GetTemplate(char)
                    root=GetRootName(temp)
                    name=getFormName()
                    portrait=FFX_HasPortrait(char)
                    template='%s_%s'%(root,absorbmaterialNames[int(mat)])
                    if Template_Exists(template):
                        morph(name,char,template,0,portrait)
                        RegTimer('giveTempPowers',1,0,name,target)
                        Mission_CustomAction('CUSTOM_REVERT',name,name,'OnRevertAbsorb',5,0)
                        return
                    template='%s (%s)'%(root,absorbmaterialNames[int(mat)])
                    if Custom_Exists(template):
                        morph(name,char,template,0,portrait)
                        RegTimer('giveTempPowers',1,0,name,target)
                        Mission_CustomAction('CUSTOM_REVERT',name,name,'OnRevertAbsorb',5,0)
                        return
            else:
                powers_Absorbed(target,char)

def giveTempPowers(event):
    char=event.object
    target=event.string
    powers_Absorbed(target,char)
    removeSingleAbsorber(target,char)
    removeSingleSubtype(target,char)

def absorbPower(target,char):
    subtype = m25ai.FindTacticType(target,'subtype')
    mat=GetSubtypeMaterial(target)
    myMat=GetSubtypeMaterial(char)
    Trigger_Power(char,target,getByTemplate(char,FFX_ABSORBPOWERS_CUSTOM,1),'')
    ### Remove commands related to materials no longer active ###
    FFX_ObjectSetAttr(char,'absorbrubber',0)
    FFX_ObjectSetAttr(char,'absorbsand',0)
    FFX_ObjectSetAttr(char,'absorbacid',0)
    FFX_ObjectSetAttr(char,'dispersedForm',0)
    FFX_ObjectSetAttr(char,'alien_mineral',0)
    FFX_ObjectSetAttr(char,'absorbliquid',0)
    FFX_ObjectSetAttr(char,'absorbelectric',0)
    FFX_ObjectSetAttr(char,'absorbradiation',0)
    FFX_ObjectSetAttr(char,'absorbsound',0)
    FFX_ObjectSetAttr(char,'absorbenergy',0)
    removeOldMaterial(char)
    if getByTemplate(char,FFX_ABSORBPOWERS_CUSTOM,3)=='steal':
        targetStr=Object_GetAttr(target,'baseStrength')
        targetHealth=Object_GetAttr(target,'maxHealth')
        targetEng=Object_GetAttr(target,'energy')
        if targetStr>=9 | (targetHealth>=300) | (targetEng>=9):
            if randint(1,100)<75:
                Object_SetPrimaryState(char,PCSTATE_STUNNED,10,0)
                return
        Object_SetPrimaryState(target,PCSTATE_STUNNED,20,0)
        Object_SetSecondaryState(target,SCSTATE_POWER_NULLIFICATION,20,0)
        RegTimer(getByTemplate(char,FFX_ABSORBPOWERS_CUSTOM,4),0.2,1,char)
        RegCharState(target,PCSTATE_NORMAL,'removeStolen',0,0,char)
    RegDeath(target,'removeStolen')
    ### Absorb Material of the Target ###
    if getByTemplate(char,FFX_ABSORBPOWERS_CUSTOM,2)=='single':
        if mat!=myMat:
            if mat<=10:
                Object_SetAttr(char,'material',mat)
            if ('flesh' in subtype):
                mat=Object_GetAttr(target,'material')
                Object_SetAttr(char,'material',mat)
            if mat==5:
                AbsorbEnergy(target,char)
            if mat==7:
                AbsorbWood(target,char)
            if mat==9:
                AbsorbIce(target,char)
            if mat==6:
                AbsorbAir(target,char)
            if mat==3:
                AbsorbRubber(target,char)
            if mat==11:
                AbsorbElectrical(target,char)
            if mat==12:
                AbsorbRadiation(target,char)
            if mat==13:
                AbsorbSound(target,char)
            if mat==14:
                AbsorbAdamantium(target,char)
            if mat==15:
                AbsorbDivineMetal(target,char)
            if mat==16:
                AbsorbSuperAlloy(target,char)
            if mat==18:
                AbsorbAcid(target,char)
            if mat==19:
                AbsorbSand(target,char)
            if mat==20:
                AbsorbGas(target,char)
            if mat==21:
                AbsorbDiamond(target,char)
            if mat==22:
                AbsorbAlienMineral(target,char)
            removeSingleAbsorber(target,char)
            removeSingleSubtype(target,char)
            powers_Absorbed(target,char)
            return
        else:
            removeSingleAbsorber(target,char)
            removeSingleSubtype(target,char)
            powers_Absorbed(target,char)
    else:
        if mat!=myMat:
            if myMat==8 | (myMat==2):
                if mat!=8 | (mat!=14) | (mat!=15) | (mat!=16):
                    powers_Absorbed(target,char)
                    return
            else:
                if mat<=10:
                    Object_SetAttr(char,'material',mat)
                if ('flesh' in subtype):
                    mat=Object_GetAttr(target,'material')
                    Object_SetAttr(char,'material',mat)
                if mat==5:
                    AbsorbEnergy(target,char)
                if mat==11:
                    AbsorbElectrical(target,char)
                if mat==12:
                    AbsorbRadiation(target,char)
                if mat==13:
                    AbsorbSound(target,char)
                if mat==14:
                    AbsorbAdamantium(target,char)
                if mat==15:
                    AbsorbDivineMetal(target,char)
                if mat==16:
                    AbsorbSuperAlloy(target,char)
                if mat==18:
                    AbsorbAcid(target,char)
                if mat==19:
                    AbsorbSand(target,char)
                if mat==20:
                    AbsorbGas(target,char)
                powers_Absorbed(target,char)
                return
        powers_Absorbed(target,char)


def removeSingleAbsorber(target,char):
    ### Section for Single Target Absorber ###
    if getByTemplate(char,FFX_ABSORBPOWERS_CUSTOM,2)=='single':
        ### Remove Power Commands if the Absorber is a Single Target Absorber ###
        if not m25ai.HasPowerType(target,'electrical','melee'):
            for obj in Mission_GetObjects():
                Mission_RemoveCustomAction('CUSTOM_ELECTRICSHOCK',char,obj)
            FFX_ObjectSetAttr(char,'electric shock',0)
        if not m25ai.HasPowerType(target,'electrical','ranged'):
            for obj in Mission_GetObjects():
                Mission_RemoveCustomAction('CUSTOM_ELECTRICBLAST',char,obj)
            FFX_ObjectSetAttr(char,'electric blast',0)
        if not m25ai.HasPowerType(target,'electrical','area'):
            for obj in Mission_GetObjects():
                Mission_RemoveCustomAction('CUSTOM_ELECTRICAREA',char,obj)
            FFX_ObjectSetAttr(char,'electric explosion',0)
        if not m25ai.HasPowerType(target,'radiation','ranged'):
            for obj in Mission_GetObjects():
                Mission_RemoveCustomAction('CUSTOM_RADIATIONBLAST',char,obj)
            FFX_ObjectSetAttr(char,'radioactive blast',0)
        if not m25ai.HasPowerType(target,'radiation','melee'):
            for obj in Mission_GetObjects():
                Mission_RemoveCustomAction('CUSTOM_RADIATIONTOUCH',char,obj)
            FFX_ObjectSetAttr(char,'radioactive touch',0)
        if not m25ai.HasPowerType(target,'radiation','area'):
            for obj in Mission_GetObjects():
                Mission_RemoveCustomAction('CUSTOM_RADIATIONAREA',char,obj)
            FFX_ObjectSetAttr(char,'radioactive explosion',0)
        if not m25ai.HasPowerType(target,'acid','ranged'):
            for obj in Mission_GetObjects():
                Mission_RemoveCustomAction('CUSTOM_ACIDBLAST',char,obj)
            FFX_ObjectSetAttr(char,'shoot acid',0)
        if not m25ai.HasPowerType(target,'acid','melee'):
            for obj in Mission_GetObjects():
                Mission_RemoveCustomAction('CUSTOM_ACIDMELEE',char,obj)
            FFX_ObjectSetAttr(char,'acid fist',0)
        if not m25ai.HasPowerType(target,'acid','area'):
            for obj in Mission_GetObjects():
                Mission_RemoveCustomAction('CUSTOM_ACIDAREA',char,obj)
            FFX_ObjectSetAttr(char,'area acid',0)
        if not m25ai.HasPowerType(target,'fire','melee'):
            for obj in Mission_GetObjects():
                Mission_RemoveCustomAction('CUSTOM_FIREFIST',char,obj)
            FFX_ObjectSetAttr(char,'fire fist',0)
        if not m25ai.HasPowerType(target,'fire','ranged'):
            for obj in Mission_GetObjects():
                Mission_RemoveCustomAction('CUSTOM_FLAMEBLAST',char,obj)
            FFX_ObjectSetAttr(char,'flame blast',0)
        if not m25ai.HasPowerType(target,'fire','area'):
            for obj in Mission_GetObjects():
                Mission_RemoveCustomAction('CUSTOM_FIREAREA',char,obj)
            FFX_ObjectSetAttr(char,'fire explosion',0)
        if not m25ai.HasPowerType(target,'cold','melee'):
            for obj in Mission_GetObjects():
                Mission_RemoveCustomAction('CUSTOM_COLDTOUCH',char,obj)
            FFX_ObjectSetAttr(char,'frozen touch',0)
        if not m25ai.HasPowerType(target,'cold','ranged'):
            for obj in Mission_GetObjects():
                Mission_RemoveCustomAction('CUSTOM_COLDBLAST',char,obj)
            FFX_ObjectSetAttr(char,'icy blast',0)
        if not m25ai.HasPowerType(target,'cold','area'):
            for obj in Mission_GetObjects():
                Mission_RemoveCustomAction('CUSTOM_COLDAREA',char,obj)
            FFX_ObjectSetAttr(char,'frozen explosion',0)
        if not m25ai.HasPowerType(target,'energy','melee'):
            for obj in Mission_GetObjects():
                Mission_RemoveCustomAction('CUSTOM_ENERGYTOUCH',char,obj)
            FFX_ObjectSetAttr(char,'energy touch',0)
        if not  m25ai.HasPowerType(target,'energy','ranged'):
            for obj in Mission_GetObjects():
                Mission_RemoveCustomAction('CUSTOM_ENERGYBLAST',char,obj)
            FFX_ObjectSetAttr(char,'energy blast',0)
        if not m25ai.HasPowerType(target,'energy','area'):
            for obj in Mission_GetObjects():
                Mission_RemoveCustomAction('CUSTOM_ENERGYAREA',char,obj)
            FFX_ObjectSetAttr(char,'energy explosion',0)
        ### Remove Attributes if the Absorber is a Single Target Absorber ###
        if not hasAttribute(target,'flier') or hasAttribute(target,'levitate'):
            Object_SetSecondaryState(char,SCSTATE_BUOYANT,0,REMOVE_STATE)
            FFX_ObjectSetAttr(char,'absorb flying',0)
        if not hasAttribute(target,'puppetn'):
            temps=[]
            ffx.RegTimer('masterDie',0.1,2,char)
            for template in natureTemplates:
                Mission_RemoveCustomAction('CUSTOM_ANIMATE',char,template[0])
                match=0
                for temp in temps:
                    if temp==template[1]:
                        match=1
                if match==0:
                    Mission_RemoveCustomAction('CUSTOM_DEANIMATE',char,template[1])
                    Mission_RemoveCustomAction('CUSTOM_SUSTAIN',char,template[1])
                    temps.append(template[1])
            FFX_ObjectSetAttr(char,'nature master',0)
        if not hasAttribute(target,'puppetu'):
            temps=[]
            ffx.RegTimer('masterDie',0.1,2,char)
            for template in urbanTemplates:
                Mission_RemoveCustomAction('CUSTOM_ANIMATE',char,template[0])
                match=0
                for temp in temps:
                    if temp==template[1]:
                        match=1
                if match==0:
                    Mission_RemoveCustomAction('CUSTOM_DEANIMATE',char,template[1])
                    Mission_RemoveCustomAction('CUSTOM_SUSTAIN',char,template[1])
                    temps.append(template[1])
            FFX_ObjectSetAttr(char,'urban animator',0)
        if not hasAttribute(target,'icecontrol'):
            for obj in Mission_GetObjects():
                Mission_RemoveCustomAction('CUSTOM_ICEWALL',char,obj)
                Mission_RemoveCustomAction('CUSTOM_ICEPATCH',char,obj)
            FFX_ObjectSetAttr(char,'ice power',0)
        if not hasAttribute(target,'firecontrol'):
            for obj in Mission_GetObjects():
                Mission_RemoveCustomAction('CUSTOM_EXTINGUISH',char,obj)
                Mission_RemoveCustomAction('CUSTOM_FIREWALL',char,obj)
            FFX_ObjectSetAttr(char,'flame powers',0)
        if not hasAttribute(target,'earthcontrol'):
            ffx.FFX_ObjectSetAttr(Object_GetTemplate(char),'earthcontrol',0)
            for temp in ffx.templates:
                Mission_RemoveCustomAction('CUSTOM_LIFT',char,temp[0])
                Mission_RemoveCustomAction('CUSTOM_THROWTO',char,temp[0])
                Mission_RemoveCustomAction('CUSTOM_MOVETO',char,temp[0])
            for obj in Mission_GetObjects():
                Mission_RemoveCustomAction('CUSTOM_LIFT',char,obj)
                Mission_RemoveCustomAction('CUSTOM_SPIKE',char,obj)
                Mission_RemoveCustomAction('CUSTOM_WALL',char,obj)
            FFX_ObjectSetAttr(char,'earth powers',0)
        if not hasAttribute(target,'weathercontrol'):
            ffx.FFX_ObjectSetAttr(Object_GetTemplate(char),'weathercontrol',0)
            Mission_RemoveCustomAction('CUSTOM_STORM',char,char)
            Mission_RemoveCustomAction('CUSTOM_HAIL',char,char)
            Mission_RemoveCustomAction('CUSTOM_LIGHTNING',char,char)
            Mission_RemoveCustomAction('CUSTOM_RAIN',char,char)
            FFX_ObjectSetAttr(char,'weather powers',0)
        if not hasAttribute(target,'supertk'):
            ffx.FFX_ObjectSetAttr(Object_GetTemplate(char),'supertk',0)
            Mission_RemoveCustomAction('CUSTOM_DROP',char,char)
            for obj in Mission_GetObjects():
                Mission_RemoveCustomAction('CUSTOM_LIFT',char,obj)
                Mission_RemoveCustomAction('CUSTOM_THROWTO',char,obj)
                Mission_RemoveCustomAction('CUSTOM_MOVETO',char,obj)
            FFX_ObjectSetAttr(char,'tk',0)
        if not hasAttribute(target,'ffhighjumper') | hasAttribute(target,'ffqlowjumper') | hasAttribute(target,'superleaper') | hasAttribute(target,'jumper'):
            for obj in Mission_GetObjects():
                Mission_RemoveCustomAction('custom_leapto',char,obj)
            FFX_ObjectSetAttr(char,'super leaper',0)
        if not hasAttribute(target,'telepathy'):
            Mission_RemoveCustomAction('CUSTOM_SCAN',char,char)
            FFX_ObjectSetAttr(char,'hyper sense',0)
        if not hasAttribute(target,'fast healing'):
            FFX_ObjectSetAttr(char,'sparehp',0)
            FFX_ObjectSetAttr(char,'rapidhealing',0)
        if not hasAttribute(target,'lesserregeneration'):
            removeFFXAttrib(char,'lesserregeneration')
            FFX_ObjectSetAttr(char,'regenerative',0)
        if not hasAttribute(target,'superhealer'):
            removeFFXAttrib(char,'superhealer')
            FFX_ObjectSetAttr(char,'superhealing',0)
        if not hasAttribute(target,'lightcontrol'):
            Mission_RemoveCustomAction('CUSTOM_DARKEN',char,char)
            Mission_RemoveCustomAction('CUSTOM_RESTORELIGHT',char,char)
            Mission_RemoveCustomAction('CUSTOM_LIGHTEN',char,char)
            FFX_ObjectSetAttr(char,'light powers',0)
        if not hasAttribute(target,'masscontrol'):
            Mission_RemoveCustomAction('CUSTOM_MASSUP',char,char)
            Mission_RemoveCustomAction('CUSTOM_MASSDOWN',char,char)
            FFX_ObjectSetAttr(char,'density control',0)
        if not hasAttribute(target,'metamorphic'):
            Mission_RemoveCustomAction('CUSTOM_ICECLOUD',char,char)
            Mission_RemoveCustomAction('CUSTOM_SANDSTORM',char,char)
            Mission_RemoveCustomAction('CUSTOM_GASEOUSFORM',char,char)
            FFX_ObjectSetAttr(char,'metamorph',0)
        if not hasAttribute(target,'gaseousform'):
            Mission_RemoveCustomAction('CUSTOM_GASEOUSFORM',char,char)
            FFX_ObjectSetAttr(char,'gaseous form',0)
        if not hasAttribute(target,'icecloud'):
            Mission_RemoveCustomAction('CUSTOM_ICECLOUD',char,char)
            FFX_ObjectSetAttr(char,'ice cloud',0)
        if not hasAttribute(target,'sandstorm'):
            Mission_RemoveCustomAction('CUSTOM_SANDSTORM',char,char)
            FFX_ObjectSetAttr(char,'sand storm',0)
        if not hasAttribute(target,'plasmasculptor'):
            removeCommand('CUSTOM_GIVETHROW',char)
            removeCommand('CUSTOM_GIVEWIELD',char)
            removeCommand('CUSTOM_MAKEDROP',char)
            removeCommand('CUSTOM_MAKEBARRIER',char)
            FFX_ObjectSetAttr(char,'plasma sculpting',0)
        if not hasAttribute(target,'phasing'):
            Mission_RemoveCustomAction('CUSTOM_PHASEOUT',char,char)
            Mission_RemoveCustomAction('CUSTOM_PHASEIN',char,char)
            if FFX_ObjectGetAttr(char,'phased',0)==1:
                FFX_ObjectSetAttr(char,'phased',0)
                Object_SetAttr(char,'attackBonus',1)
                Object_SetAttr(char,'oldAttackBonus',1)
                Object_SetGenericState(char,OBJSTATE_ATTACKBONUS,0,REMOVE_STATE)
                Trigger_Power(char,char,'ffq_remove_defence','')
                str=Object_GetAttr(char,'templateStrength')
                Object_SetAttr(char,'strength',str)
                FFX_ObjectSetAttr(char, 'permanent_shield', FFX_ObjectGetAttr(char, 'permanent_shield') - 1 ) 
                Object_SetSecondaryState(char,SCSTATE_BUOYANT,0,REMOVE_STATE)
                speed=Object_GetAttr(char,'baseSpeed')
                Object_SetAttr(char,'speed',speed)
                FFX_ObjectSetAttr(char,'baseSpeed',speed)
            FFX_ObjectSetAttr(char,'phaser',0)


def powers_Absorbed(target,char):
    subtype = m25ai.FindTacticType(target, 'subtype')
    ### Absorb Invulnerable Points ###
    if not ('normal_human' in subtype):
        bip=FFX_ObjectGetAttr(target,'baseInvPoints')
        invPoints=FFX_ObjectGetAttr(target,'invPoints')
        mybip=FFX_ObjectGetAttr(char,'baseInvPoints')
        myinvPoints=FFX_ObjectGetAttr(char,'invPoints')
        if getByTemplate(char,FFX_ABSORBPOWERS_CUSTOM,2)=='single':
            if mybip==0:
                FFX_ObjectSetAttr(char,'ivlastdam',Object_GetAttr(char,'health'))
                if not FFX_ObjectGetAttr(char,'DamageManagement',0):
                    RegDamage(char,'DamageManagement')
                    FFX_ObjectSetAttr(char,'DamageManagement',1)
                    FFX_ObjectSetAttr(char,'invPoints',invPoints)
                    FFX_ObjectSetAttr(char,'baseInvPoints',0)
            else:
                FFX_ObjectSetAttr(char,'invPoints',invPoints)
        if getByTemplate(char,FFX_ABSORBPOWERS_CUSTOM,2)=='multiple':
            if invPoints>myinvPoints:
                if mybip==0:
                    FFX_ObjectSetAttr(char,'ivlastdam',Object_GetAttr(char,'health'))
                    if not FFX_ObjectGetAttr(char,'DamageManagement',0):
                        RegDamage(char,'DamageManagement')
                        FFX_ObjectSetAttr(char,'DamageManagement',1)
                        FFX_ObjectSetAttr(char,'invPoints',invPoints)
                        FFX_ObjectSetAttr(char,'baseInvPoints',0)
                else:
                    FFX_ObjectSetAttr(char,'invPoints',invPoints)
    ### Section for Single Target Absorber ###
    if getByTemplate(char,FFX_ABSORBPOWERS_CUSTOM,2)=='single':
        ### Absorb strength, energy, speed, agility, material, mass and health ###
        targetStr=Object_GetAttr(target,'baseStrength')
        Object_SetAttr(char,'strength',targetStr)
        targetSpd=Object_GetAttr(target,'baseSpeed')
        Object_SetAttr(char,'speed',targetSpd)
        targetAgl=Object_GetAttr(target,'agility')
        Object_SetAttr(char,'agility',targetAgl)
        if FFX_ObjectGetAttr(char,'dispersedForm',0)!=1:
            absorb(char,target,'maxHealth')
        targetEng=Object_GetAttr(target,'energy')
        Object_SetAttr(char,'energy',targetEng)
        FFX_Report('absorbed_single(%s): St=%f Sp=%f M=%d E=%f A=%f'%(char,Object_GetAttr(char,'strength'),Object_GetAttr(char,'speed'),Object_GetAttr(char,'material'),Object_GetAttr(char,'energy'),Object_GetAttr(char,'agility')))
    ### Section for Multiple Target Absorber ###
    if getByTemplate(char,FFX_ABSORBPOWERS_CUSTOM,2)=='multiple':
        ### Absorb strength, energy, speed, agility, material, mass and health ###
        myStr=Object_GetAttr(char,'strength')
        targetStr=Object_GetAttr(target,'strength')
        if targetStr>myStr:
            Object_SetAttr(char,'strength',targetStr)
        mySpd=Object_GetAttr(char,'speed')
        targetSpd=Object_GetAttr(target,'templateSpeed')
        if targetSpd>mySpd:
            Object_SetAttr(char,'speed',targetSpd)
        myAgl=Object_GetAttr(char,'agility')
        targetAgl=Object_GetAttr(target,'agility')
        if targetAgl>myAgl:
            Object_SetAttr(char,'agility',targetAgl)
        myHealth=Object_GetAttr(char,'health')
        targetHealth=Object_GetAttr(target,'health')
        myMaxHealth=Object_GetAttr(char,'maxHealth')
        targetMaxHealth=Object_GetAttr(target,'maxHealth')
        if myHealth < targetHealth:
            if myMaxHealth < targetMaxHealth:
                Object_SetAttr(char,'health',(Object_GetAttr(target,'health'))*Object_GetAttr(char,'health')/GetBaseHealth(char))
                Object_SetAttr(char,'maxHealth',Object_GetAttr(target,'maxHealth'))
        absorb(char,target,'energy')
        FFX_Report('absorbed_multiple(%s): St=%f Sp=%f M=%d E=%f A=%f'%(char,Object_GetAttr(char,'strength'),Object_GetAttr(char,'speed'),Object_GetAttr(char,'material'),Object_GetAttr(char,'energy'),Object_GetAttr(char,'agility')))
    ### Absorb Powers ###
    ### normal_humans are not allowed past this point! ###
    if not ('normal_human' in subtype):
        if ('flesh' in subtype):
            mat=Object_GetAttr(target,'material')
            Object_SetAttr(char,'material',mat)
        FFX_ObjectSetAttr(char,'baseMass',Object_GetAttr(char,'mass'))
        myMass=FFX_ObjectGetAttr(char,'mass')
        mass=FFX_ObjectGetAttr(target,'mass')
        if getByTemplate(char,FFX_ABSORBPOWERS_CUSTOM,2)=='single':
            if FFX_ObjectGetAttr(char,'dispersedForm',0)!=0:
                Object_SetAttr(char,'mass',mass)
        if getByTemplate(char,FFX_ABSORBPOWERS_CUSTOM,2)=='multiple':
            if mass>myMass:
                Object_SetAttr(char,'mass',mass)
        ### Attributes ###
        if not hasAttribute(char,'flier') or hasAttribute(char,'levitate') or \
        js.Object_GetSecondaryStates(char) & js.SCSTATE_BUOYANT:
            if hasAttribute(target,'flier') or hasAttribute(target,'levitate'):
                if FFX_ObjectGetAttr(char,'absorb flying',0)==1:
                    FFX_ObjectSetAttr(char,'absorb flying',2)
                if FFX_ObjectGetAttr(char,'absorb flying',0)==0:
                    FFX_ObjectSetAttr(char,'absorb flying',1)
                    ff.RESULTBUBBLE_SCALE=0
                    RegTimer('bubblesOn',0.1)
                    Object_SetSecondaryState(char,SCSTATE_BUOYANT,10000,0)
                    RegTimer('removeFX',0.1,1,char)
        if hasAttribute(target,'magnetic') or hasAttribute(target,'magnetic2'):
            if FFX_ObjectGetAttr(char,'magnetic powers',0)==1:
                FFX_ObjectSetAttr(char,'magnetic powers',2)
            if FFX_ObjectGetAttr(char,'magnetic powers',0)==0:
                ffx.FFX_ObjectSetAttr(Object_GetTemplate(char),'magnetic',1)
                ffx.initmagnetic(char,0)
                m25ai.AddGoal_DynamicAbility(char, temp_attribute='magnetic powers', tactic='TMagneticRepel()')
                m25ai.AddGoal_DynamicAbility(char, temp_attribute='magnetic powers', tactic='TMagneticAttract()')
                m25ai.AddGoal_DynamicAbility(char, temp_attribute='magnetic powers', tactic='TMagneticCustom()')
                m25ai.AddGoal_DynamicAbility(char, temp_attribute='magnetic powers', tactic='TTK()')
                FFX_ObjectSetAttr(char,'magnetic powers',1)
        if hasAttribute(target,'puppetn'):
            if FFX_ObjectGetAttr(char,'nature master',0)==1:
                FFX_ObjectSetAttr(char,'nature master',2)
            if FFX_ObjectGetAttr(char,'nature master',0)==0:
                ffx.initpuppetn(char,0)
                FFX_ObjectSetAttr(char,'nature master',1)
                m25ai.AddGoal_DynamicAbility(char, temp_attribute='nature master', tactic='TPuppetMasterNature()')
        if hasAttribute(target,'puppetu'):
            if FFX_ObjectGetAttr(char,'urban animator',0)==1:
                FFX_ObjectSetAttr(char,'urban animator',2)
            if FFX_ObjectGetAttr(char,'urban animator',0)==0:
                ffx.initpuppetu(char,0)
                FFX_ObjectSetAttr(char,'urban animator',1)
                m25ai.AddGoal_DynamicAbility(char, temp_attribute='nature master', tactic='TPuppetMasterUrban()')
        if hasAttribute(target,'icecontrol'):
            if FFX_ObjectGetAttr(char,'ice power',0)==1:
                FFX_ObjectSetAttr(char,'ice power',2)
            if FFX_ObjectGetAttr(char,'ice power',0)==0:
                if getByTemplate(char,FFX_ABSORBPOWERS_CUSTOM,2)=='multiple':
                    x=randint(1,2)
                    if x == 1:
                        for obj in Mission_GetObjects():
                            if ((Object_GetClass(obj) & js.OC_TERRAIN)==0) & (obj!=char):
                                Mission_CustomAction('CUSTOM_ICEWALL',char,obj,'OnIceWall',30,0)
                    if x == 2:
                        for obj in Mission_GetObjects():
                            if ((Object_GetClass(obj) & js.OC_TERRAIN)==0) & (obj!=char):
                                Mission_CustomAction('CUSTOM_ICEPATCH',char,obj,'OnIcePatch',30,0)
                else:
                    for obj in Mission_GetObjects():
                        if ((Object_GetClass(obj) & js.OC_TERRAIN)==0) & (obj!=char):
                            Mission_CustomAction('CUSTOM_ICEWALL',char,obj,'OnIceWall',30,0)
                            Mission_CustomAction('CUSTOM_ICEPATCH',char,obj,'OnIcePatch',30,0)
                m25ai.AddGoal_DynamicAbility(char, temp_attribute='ice power', tactic='TIceWall()')
                m25ai.AddGoal_DynamicAbility(char, temp_attribute='ice power', tactic='TIcePatch()')
                FFX_ObjectSetAttr(char,'ice power',1)
        if hasAttribute(target,'firecontrol'):
            if FFX_ObjectGetAttr(char,'flame powers',0)==1:
                FFX_ObjectSetAttr(char,'flame powers',2)
            if FFX_ObjectGetAttr(char,'flame powers',0)==0:
                FFX_ObjectSetAttr(Object_GetTemplate(char),'firecontrol',1)
                Mission_CustomAction('CUSTOM_EXTINGUISH',char,'ffx_flames','OnExtinguish',30,0)
                Mission_CustomAction('CUSTOM_EXTINGUISH',char,'ffx_firecage','OnExtinguish',30,0)
                for obj in Mission_GetObjects():
                    if ((Object_GetClass(obj) & js.OC_TERRAIN)==0) & (obj!=char):
                        Mission_CustomAction('CUSTOM_FIREWALL',char,obj,'OnFireWall',30,0)
                m25ai.AddGoal_DynamicAbility(char, temp_attribute='flame powers', tactic='TFireWall()')
                FFX_ObjectSetAttr(char,'flame powers',1)
        if hasAttribute(target,'earthcontrol'):
            if FFX_ObjectGetAttr(char,'earth powers',0)==1:
                FFX_ObjectSetAttr(char,'earth powers',2)
            if FFX_ObjectGetAttr(char,'earth powers',0)==0:
                FFX_ObjectSetAttr(Object_GetTemplate(char),'earthcontrol',1)
                initearthcontrol(char,0)
                m25ai.AddGoal_DynamicAbility(char, temp_attribute='earth powers', tactic='TEarthSpike()')
                m25ai.AddGoal_DynamicAbility(char, temp_attribute='earth powers', tactic='TEarthWall()')
                FFX_ObjectSetAttr(char,'earth powers',1)
        if hasAttribute(target,'weathercontrol'):
            if FFX_ObjectGetAttr(char,'weather powers',0)==1:
                FFX_ObjectSetAttr(char,'weather powers',2)
            if FFX_ObjectGetAttr(char,'weather powers',0)==0:
                FFX_ObjectSetAttr(Object_GetTemplate(char),'weathercontrol',1)
                initweathercontrol(char,0)
                m25ai.AddGoal_DynamicAbility(char, temp_attribute='weather powers', tactic='TWeatherControlHail()')
                m25ai.AddGoal_DynamicAbility(char, temp_attribute='weather powers', tactic='TWeatherControlLightning()')
                m25ai.AddGoal_DynamicAbility(char, temp_attribute='weather powers', tactic='TWeatherControlRain()')
                FFX_ObjectSetAttr(char,'weather powers',1)
        if hasAttribute(target,'supertk'):
            if FFX_ObjectGetAttr(char,'tk',0)==1:
                FFX_ObjectSetAttr(char,'tk',2)
            if FFX_ObjectGetAttr(char,'tk',0)==0:
                FFX_ObjectSetAttr(Object_GetTemplate(char),'supertk',1)
                initsupertk(char,0)
                m25ai.AddGoal_DynamicAbility(char, temp_attribute='tk', tactic='TTK()')
                FFX_ObjectSetAttr(char,'tk',1)
        if hasAttribute(target,'ffhighjumper') | hasAttribute(target,'ffqlowjumper') | hasAttribute(target,'superleaper') | hasAttribute(target,'jumper'):
            if FFX_ObjectGetAttr(char,'absorbrubber',0)==0:
                if FFX_ObjectGetAttr(char,'super leaper',0)==1:
                    FFX_ObjectSetAttr(char,'super leaper',2)
                if FFX_ObjectGetAttr(char,'super leaper',0)==0:
                    for obj in Mission_GetObjects():
                        if ((Object_GetClass(obj) & js.OC_TERRAIN)==0) & (obj!=char):
                            Mission_CustomAction('custom_leapto',char,obj,'custom_leapto',40,0)
                    FFX_ObjectSetAttr(char,'super leaper',1)
                    m25ai.AddGoal_DynamicAbility(char, temp_attribute='super leaper', tactic='TSuperLeap(situation=["not flying","not invisible"])')
                    m25ai.AddGoal_DynamicAbility(char, temp_attribute='super leaper', tactic='TSuperLeapAway(situation=["not flying","not invisible"])')
        if hasAttribute(target,'telepathy'):
            if FFX_ObjectGetAttr(char,'hyper sense',0)==1:
                FFX_ObjectSetAttr(char,'hyper sense',2)
            if FFX_ObjectGetAttr(char,'hyper sense',0)==0:
                Mission_CustomAction('CUSTOM_SCAN',char,char,'OnScan',5,0)
                FFX_ObjectSetAttr(char,'hyper sense',1)
        if hasAttribute(target,'fast healing'):
            if FFX_ObjectGetAttr(char,'rapidhealing',0)==1:
                FFX_ObjectSetAttr(char,'rapidhealing',2)
            if FFX_ObjectGetAttr(char,'rapidhealing',0)==0:
                initfasthealing(char)
                FFX_ObjectSetAttr(char,'sparehp',100)
                FFX_ObjectSetAttr(char,'rapidhealing',1)
        if hasAttribute(target,'lesserregeneration'):
            if FFX_ObjectGetAttr(char,'regenerative',0)==1:
                FFX_ObjectSetAttr(char,'regenerative',2)
            if FFX_ObjectGetAttr(char,'regenerative',0)==0:
                addFFXAttrib(char, 'lesserregeneration')
                FFX_ObjectSetAttr(char,'regenerative',1)
        if hasAttribute(target,'superhealer'):
            if FFX_ObjectGetAttr(char,'superhealing',0)==1:
                FFX_ObjectSetAttr(char,'superhealing',2)
            if FFX_ObjectGetAttr(char,'superhealing',0)==0:
                addFFXAttrib(char, 'superhealer')
                FFX_ObjectSetAttr(char,'superhealing',1)
        if hasAttribute(target,'lightcontrol'):
            if FFX_ObjectGetAttr(char,'light powers',0)==1:
                FFX_ObjectSetAttr(char,'light powers',2)
            if FFX_ObjectGetAttr(char,'light powers',0)==0:
                Mission_CustomAction('CUSTOM_DARKEN',char,char,'OnDarken',5,0)
                Mission_CustomAction('CUSTOM_LIGHTEN',char,char,'OnLighten',5,0)
                ### No Light Control Tactics? m25ai.AddGoal_DynamicAbility(char, temp_attribute='light powers', tactic='')
                FFX_ObjectSetAttr(char,'light powers',1)
        if hasAttribute(target,'masscontrol'):
            if FFX_ObjectGetAttr(char,'density control',0)==1:
                FFX_ObjectSetAttr(char,'density control',2)
            if FFX_ObjectGetAttr(char,'density control',0)==0:
                Mission_CustomAction('CUSTOM_MASSUP',char,char,'OnMassUp',5,0)
                Mission_CustomAction('CUSTOM_MASSDOWN',char,char,'OnMassDown',5,0)
                m25ai.AddGoal_DynamicAbility(char, temp_attribute='density control', tactic='TMassControl()')
                FFX_ObjectSetAttr(char,'density control',1)
        if hasAttribute(target,'metamorphic'):
            if FFX_ObjectGetAttr(char,'metamorph',0)==1:
                FFX_ObjectSetAttr(char,'metamorph',2)
            if FFX_ObjectGetAttr(char,'metamorph',0)==0:
                if getByTemplate(char,FFX_ABSORBPOWERS_CUSTOM,2)=='multiple':
                    x=randint(1,3)
                    if x == 1:
                        Mission_CustomAction('CUSTOM_ICECLOUD',char,char,'OnIceCloud',5,0)
                        updateIceCloud(char)
                        m25ai.AddGoal_DynamicAbility(char, temp_attribute='transform icecloud', tactic='TIceCloud()')
                    if x == 2:
                        Mission_CustomAction('CUSTOM_SANDSTORM',char,char,'OnSandStorm',5,0)
                        updateSandstorm(char)
                        m25ai.AddGoal_DynamicAbility(char, temp_attribute='transform sand', tactic='TSandStorm()')
                    if x == 3:
                        Mission_CustomAction('CUSTOM_GASEOUSFORM',char,char,'OnGaseousForm',5,0)
                        updateGaseousForm(char)
                        m25ai.AddGoal_DynamicAbility(char, temp_attribute='transform gascloud', tactic='TGaseousForm()')
                else:
                    Mission_CustomAction('CUSTOM_ICECLOUD',char,char,'OnIceCloud',5,0)
                    updateIceCloud(char)
                    m25ai.AddGoal_DynamicAbility(char, temp_attribute='metamorph', tactic='TIceCloud()')
                    Mission_CustomAction('CUSTOM_SANDSTORM',char,char,'OnSandStorm',5,0)
                    updateSandstorm(char)
                    m25ai.AddGoal_DynamicAbility(char, temp_attribute='metamorph', tactic='TSandStorm()')
                    Mission_CustomAction('CUSTOM_GASEOUSFORM',char,char,'OnGaseousForm',5,0)
                    updateGaseousForm(char)
                    m25ai.AddGoal_DynamicAbility(char, temp_attribute='metamorph', tactic='TGaseousForm()')
                FFX_ObjectSetAttr(char,'metamorph',1)
        if hasAttribute(target,'icecloud'):
            if FFX_ObjectGetAttr(char,'ice cloud',0)==1:
                FFX_ObjectSetAttr(char,'ice cloud',2)
            if FFX_ObjectGetAttr(char,'ice cloud',0)==0:
                Mission_CustomAction('CUSTOM_ICECLOUD',char,char,'OnIceCloud',5,0)
                m25ai.AddGoal_DynamicAbility(char, temp_attribute='ice cloud', tactic='TIceCloud()')
                FFX_ObjectSetAttr(char,'ice cloud',1)
        if hasAttribute(target,'sandstorm'):
            if FFX_ObjectGetAttr(char,'sand storm',0)==1:
                FFX_ObjectSetAttr(char,'sand storm',2)
            if FFX_ObjectGetAttr(char,'sand storm',0)==0:
                Mission_CustomAction('CUSTOM_SANDSTORM',char,char,'OnSandStorm',5,0)
                m25ai.AddGoal_DynamicAbility(char, temp_attribute='sandstorm', tactic='TSandStorm()')
                FFX_ObjectSetAttr(char,'sand storm',1)
        if hasAttribute(target,'gaseousform'):
            if FFX_ObjectGetAttr(char,'gaseous form',0)==1:
                FFX_ObjectSetAttr(char,'gaseous form',2)
            if FFX_ObjectGetAttr(char,'gaseous form',0)==0:
                Mission_CustomAction('CUSTOM_GASEOUSFORM',char,char,'OnGaseousForm',5,0)
                m25ai.AddGoal_DynamicAbility(char, temp_attribute='gaseous form', tactic='TGaseousForm()')
                FFX_ObjectSetAttr(char,'gaseous form',1)
        if hasAttribute(target,'plasmasculptor'):
            if FFX_ObjectGetAttr(char,'plasma sculpting',0)==1:
                FFX_ObjectSetAttr(char,'plasma sculpting',2)
            if FFX_ObjectGetAttr(char,'plasma sculpting',0)==0:
                if getByTemplate(char,FFX_ABSORBPOWERS_CUSTOM,2)=='multiple':
                    x=randint(1,4)
                    if x == 1:
                        addCommandChars('CUSTOM_GIVETHROW',char,'OnGiveThrow',30)
                    if x == 2:
                        addCommandChars('CUSTOM_GIVEWIELD',char,'OnGiveWield',30)
                    ### no tactics for givewield or givethrow?
                    if x == 3:
                        addCommandChars('CUSTOM_MAKEDROP',char,'OnMakeDrop',30,char)
                    if x == 4:
                        addCommandChars('CUSTOM_MAKEBARRIER',char,'OnMakeBarrier',30,char)
                else:
                    addCommandChars('CUSTOM_GIVETHROW',char,'OnGiveThrow',30)
                    addCommandChars('CUSTOM_GIVEWIELD',char,'OnGiveWield',30)
                    addCommandChars('CUSTOM_MAKEDROP',char,'OnMakeDrop',30,char)
                    addCommandChars('CUSTOM_MAKEBARRIER',char,'OnMakeBarrier',30,char)
                m25ai.AddGoal_DynamicAbility(char, temp_attribute='plasma sculpting', tactic='TPlasmaSculptorDrop()')
                m25ai.AddGoal_DynamicAbility(char, temp_attribute='plasma sculpting', tactic='TPlasmaSculptorBarrier()')
                FFX_ObjectSetAttr(char,'plasma sculpting',1)
        if hasAttribute(target,'phasing'):
            if FFX_ObjectGetAttr(char,'phaser',0)==1:
                FFX_ObjectSetAttr(char,'phaser',2)
            if FFX_ObjectGetAttr(char,'phaser',0)==0:
                Mission_CustomAction('CUSTOM_PHASEOUT',char,char,'displacement',5,0)
                m25ai.AddGoal_DynamicAbility(char, temp_attribute='phaser', tactic='TPhaseOut(situation="swarmed or lowerhealthpct 50")')
                FFX_ObjectSetAttr(char,'phaser',1)
        ### subtype_only is not allowed past this point! ###
        if ('subtype_only' in subtype):
            power_Subtypes(target,char)
            return
        power_Subtypes(target,char)
        ### Power Types ###
        if m25ai.HasPowerType(target,'electrical','melee'):
            if FFX_ObjectGetAttr(char,'electric shock',0)==1:
                FFX_ObjectSetAttr(char,'electric shock',2)
            if FFX_ObjectGetAttr(char,'electric shock',0)==0:
                for obj in Mission_GetObjects():
                    if ((Object_GetClass(obj) & js.OC_TERRAIN)==0) & (obj!=char):
                        Mission_CustomAction('CUSTOM_ELECTRICSHOCK',char,obj,'electric_shock',5,0)
                FFX_ObjectSetAttr(char,'electric shock',1)
                m25ai.AddGoal_DynamicAbility(char, temp_attribute='electric shock', tactic='TMelee("manowar Electric Arc")')
        if m25ai.HasPowerType(target,'electrical','ranged'):
            if FFX_ObjectGetAttr(char,'electric blast',0)==1:
                FFX_ObjectSetAttr(char,'electric blast',2)
            if FFX_ObjectGetAttr(char,'electric blast',0)==0:
                for obj in Mission_GetObjects():
                    if ((Object_GetClass(obj) & js.OC_TERRAIN)==0) & (obj!=char):
                        Mission_CustomAction('CUSTOM_ELECTRICBLAST',char,obj,'electric_blast',30,0)
                FFX_ObjectSetAttr(char,'electric blast',1)
                m25ai.AddGoal_DynamicAbility(char, temp_attribute='electric blast', tactic='TRanged("timemaster Electrical extra",mindist=70,pct=50)')
        if m25ai.HasPowerType(target,'electrical','area'):
            if FFX_ObjectGetAttr(char,'electric explosion',0)==1:
                FFX_ObjectSetAttr(char,'electric explosion',2)
            if FFX_ObjectGetAttr(char,'electric explosion',0)==0:
                for obj in Mission_GetObjects():
                    if ((Object_GetClass(obj) & js.OC_TERRAIN)==0) & (obj!=char):
                        Mission_CustomAction('CUSTOM_ELECTRICAREA',char,obj,'electric_explosion',10,0)
                FFX_ObjectSetAttr(char,'electric explosion',1)
                m25ai.AddGoal_DynamicAbility(char, temp_attribute='electric explosion', tactic='TArea("blue darkmen Electrical Field",situation="swarmed",pct=50)')
        if m25ai.HasPowerType(target,'radiation','melee'):
            if FFX_ObjectGetAttr(char,'radioactive touch',0)==1:
                FFX_ObjectSetAttr(char,'radioactive touch',2)
            if FFX_ObjectGetAttr(char,'radioactive touch',0)==0:
                for obj in Mission_GetObjects():
                    if ((Object_GetClass(obj) & js.OC_TERRAIN)==0) & (obj!=char):
                        Mission_CustomAction('CUSTOM_RADIATIONTOUCH',char,obj,'radioactive_touch',5,0)
                FFX_ObjectSetAttr(char,'radioactive touch',1)
                m25ai.AddGoal_DynamicAbility(char, temp_attribute='radioactive touch', tactic='TMelee("ffx_radioactive_touch")')
        if m25ai.HasPowerType(target,'radiation','ranged'):
            if FFX_ObjectGetAttr(char,'radioactive blast',0)==1:
                FFX_ObjectSetAttr(char,'radioactive blast',2)
            if FFX_ObjectGetAttr(char,'radioactive blast',0)==0:
                for obj in Mission_GetObjects():
                    if ((Object_GetClass(obj) & js.OC_TERRAIN)==0) & (obj!=char):
                        Mission_CustomAction('CUSTOM_RADIATIONBLAST',char,obj,'radioactive_blast',30,0)
                FFX_ObjectSetAttr(char,'radioactive blast',1)
                m25ai.AddGoal_DynamicAbility(char, temp_attribute='radioactive blast', tactic='TRanged("eye of the reich Rad extra",mindist=70,pct=50)')
        if m25ai.HasPowerType(target,'radiation','area'):
            if FFX_ObjectGetAttr(char,'radioactive explosion',0)==1:
                FFX_ObjectSetAttr(char,'radioactive explosion',2)
            if FFX_ObjectGetAttr(char,'radioactive explosion',0)==0:
                for obj in Mission_GetObjects():
                    if ((Object_GetClass(obj) & js.OC_TERRAIN)==0) & (obj!=char):
                        Mission_CustomAction('CUSTOM_RADIATIONAREA',char,obj,'radioactive_explosion',10,0)
                FFX_ObjectSetAttr(char,'radioactive explosion',1)
                m25ai.AddGoal_DynamicAbility(char, temp_attribute='radioactive explosion', tactic='TArea("rad_explosion",situation="swarmed",pct=50)')
        if m25ai.HasPowerType(target,'acid','melee'):
            if FFX_ObjectGetAttr(char,'acid fist',0)==1:
                FFX_ObjectSetAttr(char,'acid fist',2)
            if FFX_ObjectGetAttr(char,'acid fist',0)==0:
                for obj in Mission_GetObjects():
                    if ((Object_GetClass(obj) & js.OC_TERRAIN)==0) & (obj!=char):
                        Mission_CustomAction('CUSTOM_ACIDMELEE',char,obj,'acid_fist',5,0)
                FFX_ObjectSetAttr(char,'acid fist',1)
                m25ai.AddGoal_DynamicAbility(char, temp_attribute='acid fist', tactic='TMelee("green bacchite Poison Spear")')
        if m25ai.HasPowerType(target,'acid','area'):
            if FFX_ObjectGetAttr(char,'area acid',0)==1:
                FFX_ObjectSetAttr(char,'area acid',2)
            if FFX_ObjectGetAttr(char,'area acid',0)==0:
                for obj in Mission_GetObjects():
                    if ((Object_GetClass(obj) & js.OC_TERRAIN)==0) & (obj!=char):
                        Mission_CustomAction('CUSTOM_ACIDAREA',char,obj,'area_acid',10,0)
                FFX_ObjectSetAttr(char,'area acid',1)
                m25ai.AddGoal_DynamicAbility(char, temp_attribute='area acid', tactic='TArea("ffx_acid_explosion",situation="swarmed",pct=50)')
        if m25ai.HasPowerType(target,'acid','ranged'):
            if FFX_ObjectGetAttr(char,'shoot acid',0)==1:
                FFX_ObjectSetAttr(char,'shoot acid',2)
            if FFX_ObjectGetAttr(char,'shoot acid',0)==0:
                for obj in Mission_GetObjects():
                    if ((Object_GetClass(obj) & js.OC_TERRAIN)==0) & (obj!=char):
                        Mission_CustomAction('CUSTOM_ACIDBLAST',char,obj,'mut_acid',30,0)
                FFX_ObjectSetAttr(char,'shoot acid',1)
                m25ai.AddGoal_DynamicAbility(char, temp_attribute='shoot acid', tactic='TRanged("mut_acid",mindist=70,pct=50)')
        if m25ai.HasPowerType(target,'fire','melee'):
            if FFX_ObjectGetAttr(char,'fire fist',0)==1:
                FFX_ObjectSetAttr(char,'fire fist',2)
            if FFX_ObjectGetAttr(char,'fire fist',0)==0:
                for obj in Mission_GetObjects():
                    if ((Object_GetClass(obj) & js.OC_TERRAIN)==0) & (obj!=char):
                        Mission_CustomAction('CUSTOM_FIREFIST',char,obj,'fire_fist',5,0)
                FFX_ObjectSetAttr(char,'fire fist',1)
                m25ai.AddGoal_DynamicAbility(char, temp_attribute='fire fist', tactic='TMelee("eldiablo Flaming Fist")')
        if m25ai.HasPowerType(target,'cold','melee'):
            if FFX_ObjectGetAttr(char,'frozen touch',0)==1:
                FFX_ObjectSetAttr(char,'frozen touch',2)
            if FFX_ObjectGetAttr(char,'frozen touch',0)==0:
                for obj in Mission_GetObjects():
                    if ((Object_GetClass(obj) & js.OC_TERRAIN)==0) & (obj!=char):
                        Mission_CustomAction('CUSTOM_COLDTOUCH',char,obj,'frozen_touch',5,0)
                FFX_ObjectSetAttr(char,'frozen touch',1)
                m25ai.AddGoal_DynamicAbility(char, temp_attribute='frozen touch', tactic='TMelee("snow man Frozen Pummel")')
        if m25ai.HasPowerType(target,'cold','ranged'):
            if FFX_ObjectGetAttr(char,'icy blast',0)==1:
                FFX_ObjectSetAttr(char,'icy blast',2)
            if FFX_ObjectGetAttr(char,'icy blast',0)==0:
                for obj in Mission_GetObjects():
                    if ((Object_GetClass(obj) & js.OC_TERRAIN)==0) & (obj!=char):
                        Mission_CustomAction('CUSTOM_COLDBLAST',char,obj,'icy_blast',30,0)
                FFX_ObjectSetAttr(char,'icy blast',1)
                m25ai.AddGoal_DynamicAbility(char, temp_attribute='icy blast', tactic='TRanged("eye of the reich Cold Beam",mindist=70,pct=50)')
        if m25ai.HasPowerType(target,'cold','area'):
            if FFX_ObjectGetAttr(char,'frozen explosion',0)==1:
                FFX_ObjectSetAttr(char,'frozen explosion',2)
            if FFX_ObjectGetAttr(char,'frozen explosion',0)==0:
                for obj in Mission_GetObjects():
                    if ((Object_GetClass(obj) & js.OC_TERRAIN)==0) & (obj!=char):
                        Mission_CustomAction('CUSTOM_COLDAREA',char,obj,'frozen_explosion',10,0)
                FFX_ObjectSetAttr(char,'frozen explosion',1)
                m25ai.AddGoal_DynamicAbility(char, temp_attribute='frozen explosion', tactic='TArea("ffx_cold_explosion",situation="swarmed",pct=50)')
        if m25ai.HasPowerType(target,'energy','melee'):
            if FFX_ObjectGetAttr(char,'energy touch',0)==1:
                FFX_ObjectSetAttr(char,'energy touch',2)
            if FFX_ObjectGetAttr(char,'energy touch',0)==0:
                for obj in Mission_GetObjects():
                    if ((Object_GetClass(obj) & js.OC_TERRAIN)==0) & (obj!=char):
                        Mission_CustomAction('CUSTOM_ENERGYTOUCH',char,obj,'energy_touch',5,0)
                FFX_ObjectSetAttr(char,'energy touch',1)
                m25ai.AddGoal_DynamicAbility(char, temp_attribute='energy touch', tactic='TMelee("microwave Materialize")')
        if not ('sonic' in subtype) & ('subtype_replace' in subtype):
            if not ('sonic_scream' in subtype) & ('subtype_replace' in subtype):
                if m25ai.HasPowerType(target,'energy','area'):
                    if FFX_ObjectGetAttr(char,'energy explosion',0)==1:
                        FFX_ObjectSetAttr(char,'energy explosion',2)
                    if FFX_ObjectGetAttr(char,'energy explosion',0)==0:
                        for obj in Mission_GetObjects():
                            if ((Object_GetClass(obj) & js.OC_TERRAIN)==0) & (obj!=char):
                                Mission_CustomAction('CUSTOM_ENERGYAREA',char,obj,'energy_explosion',10,0)
                        FFX_ObjectSetAttr(char,'energy explosion',1)
                        m25ai.AddGoal_DynamicAbility(char, temp_attribute='energy explosion', tactic='TArea("ffx_energy_explosion",situation="swarmed",pct=50)')
        if not ('heat_blast' in subtype) & ('subtype_replace' in subtype):
            if m25ai.HasPowerType(target,'fire','ranged'):
                if FFX_ObjectGetAttr(char,'flame blast',0)==1:
                    FFX_ObjectSetAttr(char,'flame blast',2)
                if FFX_ObjectGetAttr(char,'flame blast',0)==0:
                    for obj in Mission_GetObjects():
                        if ((Object_GetClass(obj) & js.OC_TERRAIN)==0) & (obj!=char):
                            Mission_CustomAction('CUSTOM_FLAMEBLAST',char,obj,'flame_blast',30,0)
                    FFX_ObjectSetAttr(char,'flame blast',1)
                    m25ai.AddGoal_DynamicAbility(char, temp_attribute='flame blast', tactic='TRanged("flame_projection",mindist=70,pct=50)')
        if not ('heat_explosion' in subtype) & ('subtype_replace' in subtype):
            if m25ai.HasPowerType(target,'fire','area'):
                if FFX_ObjectGetAttr(char,'fire explosion',0)==1:
                    FFX_ObjectSetAttr(char,'fire explosion',2)
                if FFX_ObjectGetAttr(char,'fire explosion',0)==0:
                    for obj in Mission_GetObjects():
                        if ((Object_GetClass(obj) & js.OC_TERRAIN)==0) & (obj!=char):
                            Mission_CustomAction('CUSTOM_FIREAREA',char,obj,'fire_explosion',10,0)
                    FFX_ObjectSetAttr(char,'fire explosion',1)
                    m25ai.AddGoal_DynamicAbility(char, temp_attribute='fire explosion', tactic='TArea("ffx_fire_explosion",situation="swarmed",pct=50)')
        if not ('sonic' in subtype) & ('subtype_replace' in subtype):
            if not ('sonic_scream' in subtype) & ('subtype_replace' in subtype):
                if m25ai.HasPowerType(target,'energy','ranged'):
                    if FFX_ObjectGetAttr(char,'energy blast',0)==1:
                        FFX_ObjectSetAttr(char,'energy blast',2)
                    if FFX_ObjectGetAttr(char,'energy blast',0)==0:
                        for obj in Mission_GetObjects():
                            if ((Object_GetClass(obj) & js.OC_TERRAIN)==0) & (obj!=char):
                                Mission_CustomAction('CUSTOM_ENERGYBLAST',char,obj,'energy_blast',30,0)
                        FFX_ObjectSetAttr(char,'energy blast',1)
                        m25ai.AddGoal_DynamicAbility(char, temp_attribute='energy blast', tactic='TRanged("timemaster Energy X extra",mindist=100,pct=30,energy=66)')


def removeSingleSubtype(target,char):
    subtype = m25ai.FindTacticType(target, 'subtype')
    ### Remove Commands if the Absorber is a Single Absorber ###
    if getByTemplate(char,FFX_ABSORBPOWERS_CUSTOM,2)=='single':
        if not ('heat_blast' in subtype):
            for obj in Mission_GetObjects():
                Mission_RemoveCustomAction('CUSTOM_HEATBLAST',char,obj)
            FFX_ObjectSetAttr(char,'heat blast',0)
        if not ('heat_explosion' in subtype):
            for obj in Mission_GetObjects():
                Mission_RemoveCustomAction('CUSTOM_HEATAREA',char,obj)
            FFX_ObjectSetAttr(char,'heat explosion',0)
        if not ('kinetic_bolt' in subtype):
            for obj in Mission_GetObjects():
                Mission_RemoveCustomAction('CUSTOM_KINETICBOLT',char,obj)
            FFX_ObjectSetAttr(char,'kinetic bolt',0)
        if not ('kinetic_blast' in subtype):
            for obj in Mission_GetObjects():
                Mission_RemoveCustomAction('CUSTOM_KINETICBLAST',char,obj)
            FFX_ObjectSetAttr(char,'kinetic blast',0)
        if not ('sonic_scream' in subtype):
            for obj in Mission_GetObjects():
                Mission_RemoveCustomAction('CUSTOM_SONICSCREAM',char,obj)
            FFX_ObjectSetAttr(char,'sonic_scream',0)
        if not ('digger' in subtype):
            for obj in Mission_GetObjects():
                Mission_RemoveCustomAction('CUSTOM_DIG',char,obj)
            FFX_ObjectSetAttr(char,'digger',0)
        if not ('hyperbreath' in subtype):
            for obj in Mission_GetObjects():
                Mission_RemoveCustomAction('CUSTOM_HYPERBREATH',char,obj)
            FFX_ObjectSetAttr(char,'hyperbreath',0)
        if not ('sonic' in subtype):
            for obj in Mission_GetObjects():
                Mission_RemoveCustomAction('CUSTOM_SONICBLAST',char,obj)
            FFX_ObjectSetAttr(char,'sonic powers',0)
        if not ('heat_vision' in subtype):
            for obj in Mission_GetObjects():
                Mission_RemoveCustomAction('CUSTOM_HEATVISION',char,obj)
            FFX_ObjectSetAttr(char,'heat vision',0)
        if not ('energy_vision' in subtype):
            for obj in Mission_GetObjects():
                Mission_RemoveCustomAction('CUSTOM_ENERGYVISION',char,obj)
            FFX_ObjectSetAttr(char,'energy vision',0)
        if not ('electric_vision' in subtype):
            for obj in Mission_GetObjects():
                Mission_RemoveCustomAction('CUSTOM_ELECTRICVISION',char,obj)
            FFX_ObjectSetAttr(char,'electric vision',0)
        if not ('rad_vision' in subtype):
            for obj in Mission_GetObjects():
                Mission_RemoveCustomAction('CUSTOM_RADVISION',char,obj)
            FFX_ObjectSetAttr(char,'rad vision',0)
        if not ('crushing_vision' in subtype):
            for obj in Mission_GetObjects():
                Mission_RemoveCustomAction('CUSTOM_CRUSHVISION',char,obj)
            FFX_ObjectSetAttr(char,'crush vision',0)
        if not ('gravity' in subtype):
            for obj in Mission_GetObjects():
                Mission_RemoveCustomAction('mut_gravity_up',char,obj)
                Mission_RemoveCustomAction('mut_gravity_down',char,obj)
            Mission_RemoveCustomAction('gravity_well',char,char)
            FFX_ObjectSetAttr(char,'gravity powers',0)
        if not ('magnetism' in subtype):
            ffx.FFX_ObjectSetAttr(Object_GetTemplate(char),'magnetic',0)
            for temp in ffx.templates:
                Mission_RemoveCustomAction('CUSTOM_LIFT',char,temp[0])
            for obj in Mission_GetDynamicObjects():
                Mission_RemoveCustomAction('CUSTOM_LIFT',char,obj)
                Mission_RemoveCustomAction('CUSTOM_ATTRACT',char,obj)
                Mission_RemoveCustomAction('CUSTOM_REPEL',char,obj)
            FFX_ObjectSetAttr(char,'magnetic powers',0)
        if not ('liquid_powers' in subtype) | ('liquid' in subtype):
            for obj in Mission_GetObjects():
                Mission_RemoveCustomAction('CUSTOM_WATERBLAST',char,obj)
            FFX_ObjectSetAttr(char,'liquid powers',0)
        if not ('cloner' in subtype):
            Mission_RemoveCustomAction('mut_clone',char,char)
            temp=Object_GetTemplate(char)
            for obj in Mission_GetDynamicObjects():
                if obj[:4]=='mobj' and Object_GetTemplate(obj)==temp:
                    Object_Destroy(obj)
            FFX_ObjectSetAttr(char,'cloning',0)
        if not ('ice_powers' in subtype):
            for obj in Mission_GetObjects():
                Mission_RemoveCustomAction('mut_icebeam',char,obj)
                Mission_RemoveCustomAction('custom_icepatch',char,obj)
                Mission_RemoveCustomAction('CUSTOM_ICEWALL',char,obj)
            ffx.removeShield(char)
            FFX_ObjectSetAttr(char,'ice powers',0)
        if not ('invisibility' in subtype):
            ffx.removeCommand('CUSTOM_INVISIBLE',char)
            Object_SetSecondaryState(char,SCSTATE_INVISIBLE,0,REMOVE_STATE)
            FFX_ObjectSetAttr(char,'vanish',0)
        if not ('teleporter' in subtype):
            for obj in Mission_GetObjects():
                Mission_RemoveCustomAction('CUSTOM_TELEPORT',char,obj)
            FFX_ObjectSetAttr(char,'teleportation',0)
        if not ('force_field' in subtype):
            ffx.removeCommand('CUSTOM_RAISESHIELD',char)
            Trigger_Power(char,char,'ffq_remove_defence','')
            FFX_ObjectSetAttr(char,'force field',0)
        if not ('mental' in subtype):
            for obj in Mission_GetDynamicObjects():
                Mission_RemoveCustomAction('CUSTOM_MINDWIPE',char,obj)
                Mission_RemoveCustomAction('CUSTOM_RAGE',char,obj)
                Mission_RemoveCustomAction('CUSTOM_FEAR',char,obj)
            FFX_ObjectSetAttr(char,'mental powers',0)
        if not ('mystic' in subtype):
            for obj in Mission_GetDynamicObjects():
                Mission_RemoveCustomAction('CUSTOM_MYSTICSPELL',char,obj)
                Mission_RemoveCustomAction('CUSTOM_BANISH',char,obj)
                Mission_RemoveCustomAction('CUSTOM_CURSE',char,obj)
            FFX_ObjectSetAttr(char,'mystic powers',0)
        if not ('superspeed' in subtype):
            for obj in Mission_GetObjects():
                Mission_RemoveCustomAction('CUSTOM_HYPERSPEED',char,obj)
                Mission_RemoveCustomAction('CUSTOM_HYPERSPEEDCHARGE',char,obj)
            FFX_ObjectSetAttr(char,'super speed',0)
        if not ('good_luck' in subtype):
            FFX_ObjectSetAttr(char,'probability good',0)
        if not ('bad_luck' in subtype):
            FFX_ObjectSetAttr(char,'probability bad',0)
        if not ('darkforce' in subtype):
            for obj in Mission_GetDynamicObjects():
                Mission_RemoveCustomAction('CUSTOM_DARKFORCE_BLAST',char,obj)
                Mission_RemoveCustomAction('CUSTOM_DARKFORCE_BLIND',char,obj)
            FFX_ObjectSetAttr(char,'darkforce',0)
        if not ('flame_breath' in subtype):
            for obj in Mission_GetObjects():
                Mission_RemoveCustomAction('CUSTOM_FLAMEBREATH',char,obj)
            FFX_ObjectSetAttr(char,'flame breath',0)

def power_Subtypes(target,char):
    subtype = m25ai.FindTacticType(target, 'subtype')
    ### Add Commands per Subtype ###
    if ('flame_breath' in subtype):
        if m25ai.HasPowerType(target,'fire','ranged'):
            if FFX_ObjectGetAttr(char,'flame breath',0)==1:
                FFX_ObjectSetAttr(char,'flame breath',2)
            if FFX_ObjectGetAttr(char,'flame breath',0)==0:
                for obj in Mission_GetObjects():
                    if ((Object_GetClass(obj) & js.OC_TERRAIN)==0) & (obj!=char):
                        Mission_CustomAction('CUSTOM_FLAMEBREATH',char,obj,'flame_breath',30,0)
                FFX_ObjectSetAttr(char,'flame breath',1)
                m25ai.AddGoal_DynamicAbility(char, temp_attribute='flame breath', tactic='TRanged("ffx_flame_breath",mindist=70,pct=50)')
    if ('heat_blast' in subtype):
        if m25ai.HasPowerType(target,'fire','ranged'):
            if FFX_ObjectGetAttr(char,'heat blast',0)==1:
                FFX_ObjectSetAttr(char,'heat blast',2)
            if FFX_ObjectGetAttr(char,'heat blast',0)==0:
                for obj in Mission_GetObjects():
                    if ((Object_GetClass(obj) & js.OC_TERRAIN)==0) & (obj!=char):
                        Mission_CustomAction('CUSTOM_HEATBLAST',char,obj,'heat_blast',30,0)
                FFX_ObjectSetAttr(char,'heat blast',1)
                m25ai.AddGoal_DynamicAbility(char, temp_attribute='heat blast', tactic='TRanged("heat_beam",mindist=70,pct=50)')
    if ('heat_explosion' in subtype):
        if m25ai.HasPowerType(target,'fire','area'):
            if FFX_ObjectGetAttr(char,'heat explosion',0)==1:
                FFX_ObjectSetAttr(char,'heat explosion',2)
            if FFX_ObjectGetAttr(char,'heat explosion',0)==0:
                for obj in Mission_GetObjects():
                    if ((Object_GetClass(obj) & js.OC_TERRAIN)==0) & (obj!=char):
                        Mission_CustomAction('CUSTOM_HEATAREA',char,obj,'heat_explosion',10,0)
                FFX_ObjectSetAttr(char,'heat explosion',1)
                m25ai.AddGoal_DynamicAbility(char, temp_attribute='heat explosion', tactic='TArea("heat_explosion",situation="swarmed",pct=50)')
    if ('sonic' in subtype):
        if m25ai.HasPowerType(target,'energy','ranged'):
            if FFX_ObjectGetAttr(char,'sonic powers',0)==1:
                FFX_ObjectSetAttr(char,'sonic powers',2)
            if FFX_ObjectGetAttr(char,'sonic powers',0)==0:
                for obj in Mission_GetObjects():
                    if ((Object_GetClass(obj) & js.OC_TERRAIN)==0) & (obj!=char):
                        Mission_CustomAction('CUSTOM_SONICBLAST',char,obj,'sonic_blast',30,0)
                FFX_ObjectSetAttr(char,'sonic powers',1)
                m25ai.AddGoal_DynamicAbility(char, temp_attribute='sonic powers', tactic='TRanged("ffx_sonic_blast",mindist=100)')
    if ('sonic_scream' in subtype):
        if FFX_ObjectGetAttr(char,'sonic_scream',0)==1:
            FFX_ObjectSetAttr(char,'sonic_scream',2)
        if FFX_ObjectGetAttr(char,'sonic_scream',0)==0:
            for obj in Mission_GetObjects():
                if ((Object_GetClass(obj) & js.OC_TERRAIN)==0) & (obj!=char):
                    Mission_CustomAction('CUSTOM_SONICSCREAM',char,obj,'sonic_scream',30,0)
            FFX_ObjectSetAttr(char,'sonic_scream',1)
            m25ai.AddGoal_DynamicAbility(char, temp_attribute='sonic_scream', tactic='TRanged("ffx_sonicscream")')
    if ('kinetic_bolt' in subtype):
        if m25ai.HasPowerType(target,'crushing','ranged'):
            if FFX_ObjectGetAttr(char,'kinetic bolt',0)==1:
                FFX_ObjectSetAttr(char,'kinetic bolt',2)
            if FFX_ObjectGetAttr(char,'kinetic bolt',0)==0:
                for obj in Mission_GetObjects():
                    if ((Object_GetClass(obj) & js.OC_TERRAIN)==0) & (obj!=char):
                        Mission_CustomAction('CUSTOM_KINETICBOLT',char,obj,'kinetic_bolt',30,0)
                FFX_ObjectSetAttr(char,'kinetic bolt',1)
                m25ai.AddGoal_DynamicAbility(char, temp_attribute='kinetic bolt', tactic='TRanged("ffx_kinetic_bolt",mindist=100,pct=30)')
    if ('kinetic_blast' in subtype):
        if m25ai.HasPowerType(target,'crushing','area'):
            if FFX_ObjectGetAttr(char,'kinetic blast',0)==1:
                FFX_ObjectSetAttr(char,'kinetic blast',2)
            if FFX_ObjectGetAttr(char,'kinetic blast',0)==0:
                for obj in Mission_GetObjects():
                    if ((Object_GetClass(obj) & js.OC_TERRAIN)==0) & (obj!=char):
                        Mission_CustomAction('CUSTOM_KINETICBLAST',char,obj,'kinetic_blast',10,0)
                FFX_ObjectSetAttr(char,'kinetic blast',1)
                m25ai.AddGoal_DynamicAbility(char, temp_attribute='kinetic blast', tactic='TArea("ffx_kinetic_blast",mindist=100)')
    if ('gravity' in subtype):
        if FFX_ObjectGetAttr(char,'gravity powers',0)==1:
            FFX_ObjectSetAttr(char,'gravity powers',2)
        if FFX_ObjectGetAttr(char,'gravity powers',0)==0:
            if getByTemplate(char,FFX_ABSORBPOWERS_CUSTOM,2)=='multiple':
                x=randint(1,3)
                if x == 1:
                    for obj in Mission_GetObjects():
                        if ((Object_GetClass(obj) & js.OC_TERRAIN)==0) & (obj!=char):
                            Mission_CustomAction('mut_gravity_up',char,obj,'mut_gravity_up',30,0)
                if x == 2:
                    for obj in Mission_GetDynamicObjects():
                        if obj!=char:
                            Mission_CustomAction('mut_gravity_down',char,obj,'mut_gravity_down',30,0)
                if x == 3:
                    Mission_CustomAction('gravity_well',char,char,'gravity_well',5,0)
            else:
                for obj in Mission_GetObjects():
                    if ((Object_GetClass(obj) & js.OC_TERRAIN)==0) & (obj!=char):
                        Mission_CustomAction('mut_gravity_up',char,obj,'mut_gravity_up',30,0)
                for obj in Mission_GetDynamicObjects():
                    if obj!=char:
                        Mission_CustomAction('mut_gravity_down',char,obj,'mut_gravity_down',30,0)
                Mission_CustomAction('gravity_well',char,char,'gravity_well',5,0)
                m25ai.AddGoal_DynamicAbility(char, temp_attribute='gravity powers', tactic='TDirect("mut_gravity_up")')
                m25ai.AddGoal_DynamicAbility(char, temp_attribute='gravity powers', tactic='TDirect("mut_gravity_down")')
                m25ai.AddGoal_DynamicAbility(char, temp_attribute='gravity powers', tactic='TGravityWell()')
            FFX_ObjectSetAttr(char,'gravity powers',1)
    if ('magnetism' in subtype):
        if FFX_ObjectGetAttr(char,'magnetic powers',0)==1:
            FFX_ObjectSetAttr(char,'magnetic powers',2)
        if FFX_ObjectGetAttr(char,'magnetic powers',0)==0:
            ffx.FFX_ObjectSetAttr(Object_GetTemplate(char),'magnetic',1)
            ffx.initmagnetic(char,0)
            m25ai.AddGoal_DynamicAbility(char, temp_attribute='magnetic powers', tactic='TMagneticRepel(pct=80)')
            m25ai.AddGoal_DynamicAbility(char, temp_attribute='magnetic powers', tactic='TMagneticAttract(pct=80)')
            m25ai.AddGoal_DynamicAbility(char, temp_attribute='magnetic powers', tactic='TMagneticCustom(pct=80)')
            m25ai.AddGoal_DynamicAbility(char, temp_attribute='magnetic powers', tactic='TTK()')
            FFX_ObjectSetAttr(char,'magnetic powers',1)
    if ('liquid_powers' in subtype):
        if FFX_ObjectGetAttr(char,'liquid powers',0)==1:
            FFX_ObjectSetAttr(char,'liquid powers',2)
        if FFX_ObjectGetAttr(char,'liquid powers',0)==0:
            for obj in Mission_GetObjects():
                if ((Object_GetClass(obj) & js.OC_TERRAIN)==0) & (obj!=char):
                    Mission_CustomAction('CUSTOM_WATERBLAST',char,obj,'water_blast',30,0)
            FFX_ObjectSetAttr(char,'liquid powers',1)
            m25ai.AddGoal_DynamicAbility(char, temp_attribute='liquid powers', tactic='TRanged("manowar Water Jet",mindist=100)')
    if ('cloner' in subtype):
        if FFX_ObjectGetAttr(char,'cloning',0)==1:
            FFX_ObjectSetAttr(char,'cloning',2)
        if FFX_ObjectGetAttr(char,'cloning',0)==0:
            Mission_CustomAction('mut_clone',char,char,'mut_clone',5,0)
            m25ai.AddGoal_DynamicAbility(char, temp_attribute='cloner', tactic='TCloneSelf("dejavu Clone Self",situation="not lowerenergy 90")')
            FFX_ObjectSetAttr(char,'cloning',1)
    if ('ice_powers' in subtype):
        if FFX_ObjectGetAttr(char,'ice powers',0)==1:
            FFX_ObjectSetAttr(char,'ice powers',2)
        if FFX_ObjectGetAttr(char,'ice powers',0)==0:
            if getByTemplate(char,FFX_ABSORBPOWERS_CUSTOM,2)=='multiple':
                x=randint(1,3)
                if x == 1:
                    for obj in Mission_GetObjects():
                        if ((Object_GetClass(obj) & js.OC_TERRAIN)==0) & (obj!=char):
                            Mission_CustomAction('mut_icebeam',char,obj,'mut_icebeam',30,0)
                if x == 2:
                    for obj in Mission_GetObjects():
                        if ((Object_GetClass(obj) & js.OC_TERRAIN)==0) & (obj!=char):
                            Mission_CustomAction('custom_icepatch',char,obj,'custom_icepatch',30,0)
                if x == 3:
                    for obj in Mission_GetObjects():
                        if ((Object_GetClass(obj) & js.OC_TERRAIN)==0) & (obj!=char):
                            Mission_CustomAction('CUSTOM_ICEWALL',char,obj,'OnIceWall',30)
            else:
                for obj in Mission_GetObjects():
                    if ((Object_GetClass(obj) & js.OC_TERRAIN)==0) & (obj!=char):
                        Mission_CustomAction('mut_icebeam',char,obj,'mut_icebeam',30,0)
                        Mission_CustomAction('custom_icepatch',char,obj,'custom_icepatch',30,0)
                        Mission_CustomAction('CUSTOM_ICEWALL',char,obj,'OnIceWall',30)
            FFX_ObjectSetAttr(char,'ice powers',1)
            m25ai.AddGoal_DynamicAbility(char, temp_attribute='ice powers', tactic='TIceWall()')
            m25ai.AddGoal_DynamicAbility(char, temp_attribute='ice powers', tactic='TIcePatch()')
            m25ai.AddGoal_DynamicAbility(char, temp_attribute='ice powers', tactic='TRanged("mut_icebeam",mindist=70)')
    if ('invisibility' in subtype):
        if FFX_ObjectGetAttr(char,'vanish',0)==1:
            FFX_ObjectSetAttr(char,'vanish',2)
        if FFX_ObjectGetAttr(char,'vanish',0)==0:
            Mission_CustomAction('CUSTOM_INVISIBLE',char,char,'turn_invisible',5,0)
            m25ai.AddGoal_DynamicAbility(char, temp_attribute='vanish', tactic='TCloak("ffx_invisibility")')
            FFX_ObjectSetAttr(char,'vanish',1)
    if ('force_field' in subtype):
        if FFX_ObjectGetAttr(char,'force field',0)==1:
            FFX_ObjectSetAttr(char,'force field',2)
        if FFX_ObjectGetAttr(char,'force field',0)==0:
            Mission_CustomAction('CUSTOM_RAISESHIELD',char,char,'absorbedshield',5,0)
            m25ai.AddGoal_DynamicAbility(char, temp_attribute='force field', tactic='TActiveDefense("ffx_force_field",situation="not active_defense")')
            FFX_ObjectSetAttr(char,'force field',1)
    if ('mental' in subtype):
        if FFX_ObjectGetAttr(char,'mental powers',0)==1:
            FFX_ObjectSetAttr(char,'mental powers',2)
        if FFX_ObjectGetAttr(char,'mental powers',0)==0:
            if getByTemplate(char,FFX_ABSORBPOWERS_CUSTOM,2)=='multiple':
                x=randint(1,3)
                if x == 1:
                    for obj in Mission_GetDynamicObjects():
                        if obj!=char:
                            Mission_CustomAction('CUSTOM_MINDWIPE',char,obj,'mental_blank',30,0)
                if x == 2:
                    for obj in Mission_GetDynamicObjects():
                        if obj!=char:
                            Mission_CustomAction('CUSTOM_RAGE',char,obj,'mental_enrage',30,0)
                if x == 3:
                    for obj in Mission_GetDynamicObjects():
                        if obj!=char:
                            Mission_CustomAction('CUSTOM_FEAR',char,obj,'mental_panic',30,0)
            else:
                for obj in Mission_GetDynamicObjects():
                    if obj!=char:
                        Mission_CustomAction('CUSTOM_MINDWIPE',char,obj,'mental_blank',30,0)
                        Mission_CustomAction('CUSTOM_RAGE',char,obj,'mental_enrage',30,0)
                        Mission_CustomAction('CUSTOM_FEAR',char,obj,'mental_panic',30,0)
            FFX_ObjectSetAttr(char,'mental powers',1)
            m25ai.AddGoal_DynamicAbility(char, temp_attribute='mental powers', tactic='TDirect("ffx_mental_blank")')
            m25ai.AddGoal_DynamicAbility(char, temp_attribute='mental powers', tactic='TDirect("ffx_mental_enrage")')
            m25ai.AddGoal_DynamicAbility(char, temp_attribute='mental powers', tactic='TDirect("ffx_mental_panic")')
    if ('mystic' in subtype):
        if FFX_ObjectGetAttr(char,'mystic powers',0)==1:
            FFX_ObjectSetAttr(char,'mystic powers',2)
        if FFX_ObjectGetAttr(char,'mystic powers',0)==0:
            if getByTemplate(char,FFX_ABSORBPOWERS_CUSTOM,2)=='multiple':
                x=randint(1,3)
                if x == 1:
                    for obj in Mission_GetDynamicObjects():
                        if obj!=char:
                            Mission_CustomAction('CUSTOM_MYSTICSPELL',char,obj,'mystic_alteration',30,0)
                if x == 2:
                    for obj in Mission_GetDynamicObjects():
                        if obj!=char:
                            Mission_CustomAction('CUSTOM_BANISH',char,obj,'mystic_banish',30,0)
                if x == 3:
                    for obj in Mission_GetDynamicObjects():
                        if obj!=char:
                            Mission_CustomAction('curse',char,obj,'mystic_hex',30,0)
            else:
                for obj in Mission_GetDynamicObjects():
                    if obj!=char:
                        Mission_CustomAction('CUSTOM_MYSTICSPELL',char,obj,'mystic_alteration',30,0)
                        Mission_CustomAction('CUSTOM_BANISH',char,obj,'mystic_banish',30,0)
                        Mission_CustomAction('CUSTOM_CURSE',char,obj,'mystic_hex',30,0)
            FFX_ObjectSetAttr(char,'mystic powers',1)
            m25ai.AddGoal_DynamicAbility(char, temp_attribute='mystic powers', tactic='TDirect("ffx_mystic_alteration")')
            m25ai.AddGoal_DynamicAbility(char, temp_attribute='mystic powers', tactic='TDirect("ffx_mystic_banish")')
            m25ai.AddGoal_DynamicAbility(char, temp_attribute='mystic powers', tactic='TDirect("ffx_mystic_hex")')
    if ('teleporter' in subtype):
        if FFX_ObjectGetAttr(char,'teleportation',0)==1:
            FFX_ObjectSetAttr(char,'teleportation',2)
        if FFX_ObjectGetAttr(char,'teleportation',0)==0:
            for obj in Mission_GetObjects():
                if ((Object_GetClass(obj) & js.OC_TERRAIN)==0) & (obj!=char):
                    Mission_CustomAction('CUSTOM_TELEPORT',char,obj,'ffx_absorber_teleport',30,0)
            FFX_ObjectSetAttr(char,'teleportation',1)
            m25ai.AddGoal_DynamicAbility(char, temp_attribute='teleportation', tactic='TTeleport("ffx_teleport")')
            m25ai.AddGoal_DynamicAbility(char, temp_attribute='teleportation', tactic='TTeleportAway("ffx_teleport")')
    if ('superspeed' in subtype):
        if FFX_ObjectGetAttr(char,'super speed',0)==1:
            FFX_ObjectSetAttr(char,'super speed',2)
        if FFX_ObjectGetAttr(char,'super speed',0)==0:
            if getByTemplate(char,FFX_ABSORBPOWERS_CUSTOM,2)=='multiple':
                x=randint(1,100)
                if x < 50:
                    for obj in Mission_GetObjects():
                        if ((Object_GetClass(obj) & js.OC_TERRAIN)==0) & (obj!=char):
                            Mission_CustomAction('CUSTOM_HYPERSPEED',char,obj,'superspeed_sprint',30,0)
                if x > 50:
                    for obj in Mission_GetObjects():
                        if ((Object_GetClass(obj) & js.OC_TERRAIN)==0) & (obj!=char):
                            Mission_CustomAction('CUSTOM_HYPERSPEEDCHARGE',char,obj,'superspeed_bullet',30,0)
            else:
                for obj in Mission_GetObjects():
                    if ((Object_GetClass(obj) & js.OC_TERRAIN)==0) & (obj!=char):
                        Mission_CustomAction('CUSTOM_HYPERSPEED',char,obj,'superspeed_sprint',30,0)
                    if ((Object_GetClass(obj) & js.OC_TERRAIN)==0) & (obj!=char):
                        Mission_CustomAction('CUSTOM_HYPERSPEEDCHARGE',char,obj,'superspeed_bullet',30,0)
            FFX_ObjectSetAttr(char,'super speed',1)
            m25ai.AddGoal_DynamicAbility(char, temp_attribute='super speed', tactic='TSpeedingBullet("bullet Speeding Bullet",pct=50,mindist=100)')
            m25ai.AddGoal_DynamicAbility(char, temp_attribute='super speed', tactic='TSprint("bullet Sprint",pct=50,mindist=100)')
            m25ai.AddGoal_DynamicAbility(char, temp_attribute='super speed', tactic='TSprintAway("bullet Sprint",pct=50,situation="lowerhealthpct 33")')
            if hasAttribute(target,'flier'):
                m25ai.AddGoal_DynamicAbility(char, temp_attribute='super speed', tactic='TSpeedingBullet("bullet Speeding Bullet",pct=50,situation="flying",subtype="flying",mindist=150)')
                m25ai.AddGoal_DynamicAbility(char, temp_attribute='super speed', tactic='TSprint("bullet Sprint",pct=50,situation="flying",mindist=150)')
                m25ai.AddGoal_DynamicAbility(char, temp_attribute='super speed', tactic='TSprintAway("bullet Sprint",pct=50,situation=["lowerhealthpct 33","flying"])')
    if ('good_luck' in subtype):
        if FFX_ObjectGetAttr(char,'probability good',0)==1:
            FFX_ObjectSetAttr(char,'probability good',2)
        if FFX_ObjectGetAttr(char,'probability good',0)==0:
            RegTimer('updateLuck',1,0,char)
            FFX_ObjectSetAttr(char,'probability good',1)
    if ('bad_luck' in subtype):
        if FFX_ObjectGetAttr(char,'probability bad',0)==1:
            FFX_ObjectSetAttr(char,'probability bad',2)
        if FFX_ObjectGetAttr(char,'probability bad',0)==0:
            RegTimer('updatebadLuck',1,0,char,target)
            FFX_ObjectSetAttr(char,'probability bad',1)
    if ('heat_vision' in subtype):
        if FFX_ObjectGetAttr(char,'heat vision',0)==1:
            FFX_ObjectSetAttr(char,'heat vision',2)
        if FFX_ObjectGetAttr(char,'heat vision',0)==0:
            for obj in Mission_GetObjects():
                if ((Object_GetClass(obj) & js.OC_TERRAIN)==0) & (obj!=char):
                    Mission_CustomAction('CUSTOM_HEATVISION',char,obj,'heat_vision',30,0)
            FFX_ObjectSetAttr(char,'heat vision',1)
            m25ai.AddGoal_DynamicAbility(char, temp_attribute='heat vision', tactic='TRanged("ffx_heat_vision")')
    if ('crushing_vision' in subtype):
        if FFX_ObjectGetAttr(char,'crush vision',0)==1:
            FFX_ObjectSetAttr(char,'crush vision',2)
        if FFX_ObjectGetAttr(char,'crush vision',0)==0:
            for obj in Mission_GetObjects():
                if ((Object_GetClass(obj) & js.OC_TERRAIN)==0) & (obj!=char):
                    Mission_CustomAction('CUSTOM_CRUSHVISION',char,obj,'crush_vision',30,0)
            FFX_ObjectSetAttr(char,'crush vision',1)
            m25ai.AddGoal_DynamicAbility(char, temp_attribute='crush vision', tactic='TRanged("ffx_crush_vision")')
    if ('energy_vision' in subtype):
        if FFX_ObjectGetAttr(char,'energy vision',0)==1:
            FFX_ObjectSetAttr(char,'energy vision',2)
        if FFX_ObjectGetAttr(char,'energy vision',0)==0:
            for obj in Mission_GetObjects():
                if ((Object_GetClass(obj) & js.OC_TERRAIN)==0) & (obj!=char):
                    Mission_CustomAction('CUSTOM_ENERGYVISION',char,obj,'energy_vision',30,0)
            FFX_ObjectSetAttr(char,'energy vision',1)
            m25ai.AddGoal_DynamicAbility(char, temp_attribute='energy vision', tactic='TRanged("ffx_energy_vision")')
    if ('electric_vision' in subtype):
        if FFX_ObjectGetAttr(char,'electric vision',0)==1:
            FFX_ObjectSetAttr(char,'electric vision',2)
        if FFX_ObjectGetAttr(char,'electric vision',0)==0:
            for obj in Mission_GetObjects():
                if ((Object_GetClass(obj) & js.OC_TERRAIN)==0) & (obj!=char):
                    Mission_CustomAction('CUSTOM_ELECTRICVISION',char,obj,'electric_vision',30,0)
            FFX_ObjectSetAttr(char,'electric vision',1)
            m25ai.AddGoal_DynamicAbility(char, temp_attribute='electric vision', tactic='TRanged("ffx_electric_vision")')
    if ('rad_vision' in subtype):
        if FFX_ObjectGetAttr(char,'rad vision',0)==1:
            FFX_ObjectSetAttr(char,'rad vision',2)
        if FFX_ObjectGetAttr(char,'rad vision',0)==0:
            for obj in Mission_GetObjects():
                if ((Object_GetClass(obj) & js.OC_TERRAIN)==0) & (obj!=char):
                    Mission_CustomAction('CUSTOM_RADVISION',char,obj,'rad_vision',30,0)
            FFX_ObjectSetAttr(char,'rad vision',1)
            m25ai.AddGoal_DynamicAbility(char, temp_attribute='rad vision', tactic='TRanged("ffx_rad_vision")')
    if ('hyperbreath' in subtype):
        if FFX_ObjectGetAttr(char,'hyperbreath',0)==1:
            FFX_ObjectSetAttr(char,'hyperbreath',2)
        if FFX_ObjectGetAttr(char,'hyperbreath',0)==0:
            for obj in Mission_GetObjects():
                if ((Object_GetClass(obj) & js.OC_TERRAIN)==0) & (obj!=char):
                    Mission_CustomAction('CUSTOM_HYPERBREATH',char,obj,'hyper_breath',30,0)
            FFX_ObjectSetAttr(char,'energy vision',1)
            m25ai.AddGoal_DynamicAbility(char, temp_attribute='hyperbreath', tactic='TRanged("ffx_hyperbreath")')
    if ('digger' in subtype):
        if FFX_ObjectGetAttr(char,'digger',0)==1:
            FFX_ObjectSetAttr(char,'digger',2)
        if FFX_ObjectGetAttr(char,'digger',0)==0:
            for obj in Mission_GetObjects():
                if ((Object_GetClass(obj) & js.OC_TERRAIN)==0) & (obj!=char):
                    Mission_CustomAction('CUSTOM_DIG',char,obj,'dig_tunnel',30,0)
            FFX_ObjectSetAttr(char,'digger',1)
            m25ai.AddGoal_DynamicAbility(char, temp_attribute='digger', tactic='TTunnelTravel("the ant Tunnel")')
            m25ai.AddGoal_DynamicAbility(char, temp_attribute='digger', tactic='TTunnelTravelAway("the ant Tunnel")')
    if ('darkforce' in subtype):
        if FFX_ObjectGetAttr(char,'darkforce',0)==1:
            FFX_ObjectSetAttr(char,'darkforce',2)
        if FFX_ObjectGetAttr(char,'darkforce',0)==0:
            if getByTemplate(char,FFX_ABSORBPOWERS_CUSTOM,2)=='multiple':
                x=randint(1,2)
                if x == 1:
                    for obj in Mission_GetDynamicObjects():
                        if obj!=char:
                            Mission_CustomAction('CUSTOM_DARKFORCE_BLAST',char,obj,'darkforce_blast',30,0)
                if x == 2:
                    for obj in Mission_GetDynamicObjects():
                        if obj!=char:
                            Mission_CustomAction('CUSTOM_DARKFORCE_BLIND',char,obj,'darkforce_blind',30,0)
            else:
                for obj in Mission_GetDynamicObjects():
                    if obj!=char:
                        Mission_CustomAction('CUSTOM_DARKFORCE_BLAST',char,obj,'darkforce_blast',30,0)
                        Mission_CustomAction('CUSTOM_DARKFORCE_BLIND',char,obj,'darkforce_blind',30,0)
            FFX_ObjectSetAttr(char,'darkforce',1)
            m25ai.AddGoal_DynamicAbility(char, temp_attribute='darkforce', tactic='TRanged("ffx_darkforce_blast")')
            m25ai.AddGoal_DynamicAbility(char, temp_attribute='darkforce', tactic='TRanged("ffx_darkforce_blind")')


def removeStolen(event):
    target=event.object
    char=event.string
    removeStolencmds(target,char)

def removeStolencmds(target,char):
    global ORIGINAL_FORM
    str=Object_GetAttr(char,'templateStrength')
    myStr=Object_GetAttr(char,'strength')
    targetStr=Object_GetAttr(target,'strength')
    if not myStr>targetStr:
        Object_SetAttr(char,'strength',str)
    spd=Object_GetAttr(char,'templateSpeed')
    mySpd=Object_GetAttr(char,'speed')
    targetSpd=Object_GetAttr(target,'templateSpeed')
    if not mySpd>targetSpd:
        Object_SetAttr(char,'speed',spd)
    agility=Object_GetAttr(char,'templateAgility')
    myAgl=Object_GetAttr(char,'agility')
    targetAgl=Object_GetAttr(target,'agility')
    if not myAgl>targetAgl:
        Object_SetAttr(char,'agility',agility)
    energy=FFX_ObjectGetAttr(char,'templateEnergy')
    myEng=Object_GetAttr(char,'energy')
    targetEng=Object_GetAttr(target,'energy')
    if not myEng>targetEng:
        Object_SetAttr(char,'energy',energy)
    material=FFX_ObjectGetAttr(char,'baseMat')
    myMat=Object_GetAttr(char,'material')
    targetMat=Object_GetAttr(target,'material')
    if myMat==targetMat:
        name=getFormName()
        template=ORIGINAL_FORM
        if Template_Exists(template):
            morph(name,char,template,0,portrait)
        else:
            Object_SetAttr(char,'material',material)
    bip=FFX_ObjectGetAttr(char,'baseInvPoints')
    myinv=FFX_ObjectGetAttr(char,'invPoints')
    targetinv=FFX_ObjectGetAttr(target,'invPoints')
    if myinv!=0:
        if myinv==targetinv:
            FFX_ObjectSetAttr(char,'invPoints',bip)
    myMaxHealth=Object_GetAttr(char,'maxHealth')
    myHealth=Object_GetAttr(char,'health')
    targetMaxHealth=Object_GetAttr(target,'maxHealth')
    if myMaxHealth==targetMaxHealth:
        Object_SetAttr(char,'health',(Object_GetAttr(char,'health'))*GetBaseHealth(char)/Object_GetAttr(char,'maxHealth'))
        Object_SetAttr(char,'maxHealth',(GetBaseHealth(char)))
    FFX_Report('absorbed_multiple(%s): St=%f Sp=%f M=%d E=%f A=%f'%(char,Object_GetAttr(char,'strength'),Object_GetAttr(char,'speed'),Object_GetAttr(char,'material'),Object_GetAttr(char,'energy'),Object_GetAttr(char,'agility')))
    ### Remove commands related to material ###
    if FFX_ObjectGetAttr(char,'absorbrubber',0)!=1:
        removeCommand('custom_leapto',char)
    if FFX_ObjectGetAttr(char,'absorbsand',0)!=1:
        removeCommand('CUSTOM_SANDSTORM',char)
    ### Power Subtypes ###
    subtype = m25ai.FindTacticType(target, 'subtype')
    if ('kinetic_bolt' in subtype):
        if FFX_ObjectGetAttr(char,'kinetic bolt',0)==1:
            for obj in Mission_GetObjects():
                Mission_RemoveCustomAction('CUSTOM_KINETICBOLT',char,obj)
                FFX_ObjectSetAttr(char,'kinetic bolt',0)
        else:
            if FFX_ObjectGetAttr(char,'kinetic bolt',0)==2:
                FFX_ObjectSetAttr(char,'kinetic bolt',1)
    if ('kinetic_blast' in subtype):
        if FFX_ObjectGetAttr(char,'kinetic blast',0)==1:
            for obj in Mission_GetObjects():
                Mission_RemoveCustomAction('CUSTOM_KINETICBLAST',char,obj)
                FFX_ObjectSetAttr(char,'kinetic blast',0)
        else:
            if FFX_ObjectGetAttr(char,'kinetic blast',0)==2:
                FFX_ObjectSetAttr(char,'kinetic blast',1)
    if ('sonic_scream' in subtype):
        if FFX_ObjectGetAttr(char,'sonic_scream',0)==1:
            for obj in Mission_GetObjects():
                Mission_RemoveCustomAction('CUSTOM_SONICSCREAM',char,obj)
            FFX_ObjectSetAttr(char,'sonic_scream',0)
        else:
            if FFX_ObjectGetAttr(char,'sonic_scream',0)==2:
                FFX_ObjectSetAttr(char,'sonic_scream',1)
    if ('digger' in subtype):
        if FFX_ObjectGetAttr(char,'digger',0)==1:
            for obj in Mission_GetObjects():
                Mission_RemoveCustomAction('CUSTOM_DIG',char,obj)
            FFX_ObjectSetAttr(char,'digger',0)
        else:
            if FFX_ObjectGetAttr(char,'digger',0)==2:
                FFX_ObjectSetAttr(char,'digger',1)
    if ('hyperbreath' in subtype):
        if FFX_ObjectGetAttr(char,'hyperbreath',0)==1:
            for obj in Mission_GetObjects():
                Mission_RemoveCustomAction('CUSTOM_HYPERBREATH',char,obj)
            FFX_ObjectSetAttr(char,'hyperbreath',0)
        else:
            if FFX_ObjectGetAttr(char,'hyperbreath',0)==2:
                FFX_ObjectSetAttr(char,'hyperbreath',1)
    if ('sonic' in subtype):
        if FFX_ObjectGetAttr(char,'sonic powers',0)==1:
            for obj in Mission_GetObjects():
                Mission_RemoveCustomAction('CUSTOM_SONICBLAST',char,obj)
            FFX_ObjectSetAttr(char,'sonic powers',0)
        else:
            if FFX_ObjectGetAttr(char,'sonic powers',0)==2:
                FFX_ObjectSetAttr(char,'sonic powers',1)
    if ('heat_vision' in subtype):
        if FFX_ObjectGetAttr(char,'heat vision',0)==1:
            for obj in Mission_GetObjects():
                Mission_RemoveCustomAction('CUSTOM_HEATVISION',char,obj)
            FFX_ObjectSetAttr(char,'heat vision',0)
        else:
            if FFX_ObjectGetAttr(char,'heat vision',0)==2:
                FFX_ObjectSetAttr(char,'heat vision',1)
    if ('energy_vision' in subtype):
        if FFX_ObjectGetAttr(char,'energy vision',0)==1:
            for obj in Mission_GetObjects():
                Mission_RemoveCustomAction('CUSTOM_ENERGYVISION',char,obj)
            FFX_ObjectSetAttr(char,'energy vision',0)
        else:
            if FFX_ObjectGetAttr(char,'energy vision',0)==2:
                FFX_ObjectSetAttr(char,'energy vision',1)
    if ('crushing_vision' in subtype):
        if FFX_ObjectGetAttr(char,'crush vision',0)==1:
            for obj in Mission_GetObjects():
                Mission_RemoveCustomAction('CUSTOM_CRUSHVISION',char,obj)
            FFX_ObjectSetAttr(char,'crush vision',0)
        else:
            if FFX_ObjectGetAttr(char,'crush vision',0)==2:
                FFX_ObjectSetAttr(char,'crush vision',1)
    if ('electric_vision' in subtype):
        if FFX_ObjectGetAttr(char,'electric vision',0)==1:
            for obj in Mission_GetObjects():
                Mission_RemoveCustomAction('CUSTOM_ELECTRICVISION',char,obj)
            FFX_ObjectSetAttr(char,'electric vision',0)
        else:
            if FFX_ObjectGetAttr(char,'electric vision',0)==2:
                FFX_ObjectSetAttr(char,'electric vision',1)
    if ('rad_vision' in subtype):
        if FFX_ObjectGetAttr(char,'rad vision',0)==1:
            for obj in Mission_GetObjects():
                Mission_RemoveCustomAction('CUSTOM_RADVISION',char,obj)
            FFX_ObjectSetAttr(char,'rad vision',0)
        else:
            if FFX_ObjectGetAttr(char,'rad vision',0)==2:
                FFX_ObjectSetAttr(char,'rad vision',1)
    if ('gravity' in subtype):
        if FFX_ObjectGetAttr(char,'gravity powers',0)==1:
            for obj in Mission_GetObjects():
                Mission_RemoveCustomAction('mut_gravity_up',char,obj)
                Mission_RemoveCustomAction('mut_gravity_down',char,obj)
            Mission_RemoveCustomAction('gravity_well',char,char)
            FFX_ObjectSetAttr(char,'gravity powers',0)
        else:
            if FFX_ObjectGetAttr(char,'gravity powers',0)==2:
                FFX_ObjectSetAttr(char,'gravity powers',1)
    if ('magnetism' in subtype):
        if FFX_ObjectGetAttr(char,'magnetic powers',0)==1:
            ffx.FFX_ObjectSetAttr(Object_GetTemplate(char),'magnetic',0)
            for temp in ffx.templates:
                Mission_RemoveCustomAction('CUSTOM_LIFT',char,temp[0])
            for obj in Mission_GetDynamicObjects():
                Mission_RemoveCustomAction('CUSTOM_LIFT',char,obj)
                Mission_RemoveCustomAction('CUSTOM_ATTRACT',char,obj)
                Mission_RemoveCustomAction('CUSTOM_REPEL',char,obj)
                FFX_ObjectSetAttr(char,'magnetic powers',0)
        else:
            if FFX_ObjectGetAttr(char,'magnetic powers',0)==2:
                FFX_ObjectSetAttr(char,'magnetic powers',1)
    if ('liquid_powers' in subtype):
        if FFX_ObjectGetAttr(char,'liquid powers',0)==1:
            for obj in Mission_GetObjects():
                Mission_RemoveCustomAction('CUSTOM_WATERBLAST',char,obj)
            FFX_ObjectSetAttr(char,'liquid powers',0)
        else:
            if FFX_ObjectGetAttr(char,'liquid powers',0)==2:
                FFX_ObjectSetAttr(char,'liquid powers',1)
    if ('cloner' in subtype):
        if FFX_ObjectGetAttr(char,'cloning',0)==1:
            Mission_RemoveCustomAction('mut_clone',char,char)
            temp=Object_GetTemplate(char)
            for obj in Mission_GetDynamicObjects():
                if obj[:4]=='mobj' and Object_GetTemplate(obj)==temp:
                    Object_Destroy(obj)
            FFX_ObjectSetAttr(char,'cloning',0)
        else:
            if FFX_ObjectGetAttr(char,'cloning',0)==2:
                FFX_ObjectSetAttr(char,'cloning',1)
    if ('ice_powers' in subtype):
        if FFX_ObjectGetAttr(char,'ice powers',0)==1:
            for obj in Mission_GetObjects():
                Mission_RemoveCustomAction('mut_icebeam',char,obj)
                Mission_RemoveCustomAction('custom_icepatch',char,obj)
                Mission_RemoveCustomAction('CUSTOM_ICEWALL',char,obj)
            ffx.removeShield(char)
            FFX_ObjectSetAttr(char,'ice powers',0)
        else:
            if FFX_ObjectGetAttr(char,'ice powers',0)==2:
                FFX_ObjectSetAttr(char,'ice powers',1)
    if ('invisibility' in subtype):
        if FFX_ObjectGetAttr(char,'vanish',0)==1:
            ffx.removeCommand('CUSTOM_INVISIBLE',char)
            Object_SetSecondaryState(char,SCSTATE_INVISIBLE,0,REMOVE_STATE)
            FFX_ObjectSetAttr(char,'vanish',0)
        else:
            if FFX_ObjectGetAttr(char,'vanish',0)==2:
                FFX_ObjectSetAttr(char,'vanish',1)
    if ('teleporter' in subtype):
        if FFX_ObjectGetAttr(char,'teleportation',0)==1:
            for obj in Mission_GetObjects():
                Mission_RemoveCustomAction('CUSTOM_TELEPORT',char,obj)
            FFX_ObjectSetAttr(char,'teleportation',0)
        else:
            if FFX_ObjectGetAttr(char,'teleportation',0)==2:
                FFX_ObjectSetAttr(char,'teleportation',1)
    if ('force_field' in subtype):
        if FFX_ObjectGetAttr(char,'force field',0)==1:
            ffx.removeCommand('CUSTOM_RAISESHIELD',char)
            Trigger_Power(char,char,'ffq_remove_defence','')
            FFX_ObjectSetAttr(char,'force field',0)
        else:
            if FFX_ObjectGetAttr(char,'force field',0)==2:
                FFX_ObjectSetAttr(char,'force field',1)
    if ('mental' in subtype):
        if FFX_ObjectGetAttr(char,'mental powers',0)==1:
            for obj in Mission_GetDynamicObjects():
                Mission_RemoveCustomAction('CUSTOM_MINDWIPE',char,obj)
                Mission_RemoveCustomAction('CUSTOM_RAGE',char,obj)
                Mission_RemoveCustomAction('CUSTOM_FEAR',char,obj)
            FFX_ObjectSetAttr(char,'mental powers',0)
        else:
            if FFX_ObjectGetAttr(char,'mental powers',0)==2:
                FFX_ObjectSetAttr(char,'mental powers',1)
    if ('mystic' in subtype):
        if FFX_ObjectGetAttr(char,'mystic powers',0)==1:
            for obj in Mission_GetDynamicObjects():
                Mission_RemoveCustomAction('CUSTOM_MYSTICSPELL',char,obj)
                Mission_RemoveCustomAction('CUSTOM_BANISH',char,obj)
                Mission_RemoveCustomAction('CUSTOM_CURSE',char,obj)
            FFX_ObjectSetAttr(char,'mystic powers',0)
        else:
            if FFX_ObjectGetAttr(char,'mystic powers',0)==2:
                FFX_ObjectSetAttr(char,'mystic powers',1)
    if ('superspeed' in subtype):
        if FFX_ObjectGetAttr(char,'super speed',0)==1:
            for obj in Mission_GetObjects():
                Mission_RemoveCustomAction('CUSTOM_HYPERSPEED',char,obj)
                Mission_RemoveCustomAction('CUSTOM_HYPERSPEEDCHARGE',char,obj)
            FFX_ObjectSetAttr(char,'super speed',0)
        else:
            if FFX_ObjectGetAttr(char,'super speed',0)==2:
                FFX_ObjectSetAttr(char,'super speed',1)
    if ('good_luck' in subtype):
        if FFX_ObjectGetAttr(char,'probability good',0)==1:
            FFX_ObjectSetAttr(char,'probability good',0)
        else:
            if FFX_ObjectGetAttr(char,'probability good',0)==2:
                FFX_ObjectSetAttr(char,'probability good',1)
    if ('bad_luck' in subtype):
        if FFX_ObjectGetAttr(char,'probability bad',0)==1:
            FFX_ObjectSetAttr(char,'probability bad',0)
        else:
            if FFX_ObjectGetAttr(char,'probability bad',0)==2:
                FFX_ObjectSetAttr(char,'probability bad',1)
    if ('flame_breath' in subtype):
        if m25ai.HasPowerType(target,'fire','ranged'):
            if FFX_ObjectGetAttr(char,'flame breath',0)==1:
                for obj in Mission_GetObjects():
                    Mission_RemoveCustomAction('CUSTOM_FLAMEBREATH',char,obj)
                FFX_ObjectSetAttr(char,'flame breath',0)
            else:
                if FFX_ObjectGetAttr(char,'flame breath',0)==2:
                    FFX_ObjectSetAttr(char,'flame breath',1)
    if ('heat_blast' in subtype):
        if m25ai.HasPowerType(target,'fire','ranged'):
            if FFX_ObjectGetAttr(char,'heat blast',0)==1:
                for obj in Mission_GetObjects():
                    Mission_RemoveCustomAction('CUSTOM_HEATBLAST',char,obj)
                FFX_ObjectSetAttr(char,'heat blast',0)
            else:
                if FFX_ObjectGetAttr(char,'heat blast',0)==2:
                    FFX_ObjectSetAttr(char,'heat blast',1)
    if ('heat_explosion' in subtype):
        if m25ai.HasPowerType(target,'fire','area'):
            if FFX_ObjectGetAttr(char,'heat explosion',0)==1:
                for obj in Mission_GetObjects():
                    Mission_RemoveCustomAction('CUSTOM_HEATAREA',char,obj)
                FFX_ObjectSetAttr(char,'heat explosion',0)
            else:
                if FFX_ObjectGetAttr(char,'heat explosion',0)==2:
                    FFX_ObjectSetAttr(char,'heat explosion',1)
    if ('darkforce' in subtype):
        if FFX_ObjectGetAttr(char,'darkforce',0)==1:
            for obj in Mission_GetDynamicObjects():
                Mission_RemoveCustomAction('CUSTOM_DARKFORCE_BLAST',char,obj)
                Mission_RemoveCustomAction('CUSTOM_DARKFORCE_BLIND',char,obj)
            FFX_ObjectSetAttr(char,'darkforce',0)
        else:
            if FFX_ObjectGetAttr(char,'darkforce',0)==2:
                FFX_ObjectSetAttr(char,'darkforce',1)
    baseMass=FFX_ObjectGetAttr(char,'baseMass')
    Object_SetAttr(char,'mass',baseMass)
    ### Power Types ###
    if m25ai.HasPowerType(target,'crushing','ranged'):
        if FFX_ObjectGetAttr(char,'kinetic bolt',0)==1:
            for obj in Mission_GetObjects():
                Mission_RemoveCustomAction('CUSTOM_KINETICBOLT',char,obj)
            FFX_ObjectSetAttr(char,'kinetic bolt',0)
        else:
            if FFX_ObjectGetAttr(char,'kinetic bolt',0)==2:
                FFX_ObjectSetAttr(char,'kinetic bolt',1)
    if m25ai.HasPowerType(target,'crushing','area'):
        if FFX_ObjectGetAttr(char,'kinetic blast',0)==1:
            for obj in Mission_GetObjects():
                Mission_RemoveCustomAction('CUSTOM_KINETICBLAST',char,obj)
            FFX_ObjectSetAttr(char,'kinetic blast',0)
        else:
            if FFX_ObjectGetAttr(char,'kinetic blast',0)==2:
                FFX_ObjectSetAttr(char,'kinetic blast',1)
    if m25ai.HasPowerType(target,'electrical','melee'):
        if FFX_ObjectGetAttr(char,'electric shock',0)==1:
            for obj in Mission_GetObjects():
                Mission_RemoveCustomAction('CUSTOM_ELECTRICSHOCK',char,obj)
            FFX_ObjectSetAttr(char,'electric shock',0)
        else:
            if FFX_ObjectGetAttr(char,'electric shock',0)==2:
                FFX_ObjectSetAttr(char,'electric shock',1)
    if m25ai.HasPowerType(target,'electrical','ranged'):
        if FFX_ObjectGetAttr(char,'electric blast',0)==1:
            for obj in Mission_GetObjects():
                Mission_RemoveCustomAction('CUSTOM_ELECTRICBLAST',char,obj)
            FFX_ObjectSetAttr(char,'electric blast',0)
        else:
            if FFX_ObjectGetAttr(char,'electric blast',0)==2:
                FFX_ObjectSetAttr(char,'electric blast',1)
    if m25ai.HasPowerType(target,'electrical','area'):
        if FFX_ObjectGetAttr(char,'electric explosion',0)==1:
            for obj in Mission_GetObjects():
                Mission_RemoveCustomAction('CUSTOM_ELECTRICAREA',char,obj)
            FFX_ObjectSetAttr(char,'electric explosion',0)
        else:
            if FFX_ObjectGetAttr(char,'electric explosion',0)==2:
                FFX_ObjectSetAttr(char,'electric explosion',1)
    if m25ai.HasPowerType(target,'radiation','melee'):
        if FFX_ObjectGetAttr(char,'radioactive touch',0)==1:
            for obj in Mission_GetObjects():
                Mission_RemoveCustomAction('CUSTOM_RADIATIONTOUCH',char,obj)
            FFX_ObjectSetAttr(char,'radioactive touch',0)
        else:
            if FFX_ObjectGetAttr(char,'radioactive touch',0)==2:
                FFX_ObjectSetAttr(char,'radioactive touch',1)
    if m25ai.HasPowerType(target,'radiation','area'):
        if FFX_ObjectGetAttr(char,'radioactive explosion',0)==1:
            for obj in Mission_GetObjects():
                Mission_RemoveCustomAction('CUSTOM_RADIATIONAREA',char,obj)
            FFX_ObjectSetAttr(char,'radioactive explosion',0)
        else:
            if FFX_ObjectGetAttr(char,'radioactive explosion',0)==2:
                FFX_ObjectSetAttr(char,'radioactive explosion',1)
    if m25ai.HasPowerType(target,'radiation','ranged'):
        if FFX_ObjectGetAttr(char,'radioactive blast',0)==1:
            for obj in Mission_GetObjects():
                Mission_RemoveCustomAction('CUSTOM_RADIATIONBLAST',char,obj)
            FFX_ObjectSetAttr(char,'radioactive blast',0)
        else:
            if FFX_ObjectGetAttr(char,'radioactive blast',0)==2:
                FFX_ObjectSetAttr(char,'radioactive blast',1)
    if m25ai.HasPowerType(target,'acid','melee'):
        if FFX_ObjectGetAttr(char,'acid fist',0)==1:
            for obj in Mission_GetObjects():
                Mission_RemoveCustomAction('CUSTOM_ACIDMELEE',char,obj)
            FFX_ObjectSetAttr(char,'acid fist',0)
        else:
            if FFX_ObjectGetAttr(char,'acid fist',0)==2:
                FFX_ObjectSetAttr(char,'acid fist',1)
    if m25ai.HasPowerType(target,'acid','area'):
        if FFX_ObjectGetAttr(char,'area acid',0)==1:
            for obj in Mission_GetObjects():
                Mission_RemoveCustomAction('CUSTOM_ACIDAREA',char,obj)
            FFX_ObjectSetAttr(char,'area acid',0)
        else:
            if FFX_ObjectGetAttr(char,'area acid',0)==2:
                FFX_ObjectSetAttr(char,'area acid',1)
    if m25ai.HasPowerType(target,'acid','ranged'):
        if FFX_ObjectGetAttr(char,'shoot acid',0)==1:
            for obj in Mission_GetObjects():
                Mission_RemoveCustomAction('CUSTOM_ACIDBLAST',char,obj)
            FFX_ObjectSetAttr(char,'shoot acid',0)
        else:
            if FFX_ObjectGetAttr(char,'shoot acid',0)==2:
                FFX_ObjectSetAttr(char,'shoot acid',1)
    if m25ai.HasPowerType(target,'fire','melee'):
        if FFX_ObjectGetAttr(char,'fire fist',0)==1:
            for obj in Mission_GetObjects():
                Mission_RemoveCustomAction('CUSTOM_FIREFIST',char,obj)
            FFX_ObjectSetAttr(char,'fire fist',0)
        else:
            if FFX_ObjectGetAttr(char,'fire fist',0)==2:
                FFX_ObjectSetAttr(char,'fire fist',1)
    if m25ai.HasPowerType(target,'fire','ranged'):
        if FFX_ObjectGetAttr(char,'flame blast',0)==1:
            for obj in Mission_GetObjects():
                Mission_RemoveCustomAction('CUSTOM_FLAMEBLAST',char,obj)
            FFX_ObjectSetAttr(char,'flame blast',0)
        else:
            if FFX_ObjectGetAttr(char,'flame blast',0)==2:
                FFX_ObjectSetAttr(char,'flame blast',1)
    if m25ai.HasPowerType(target,'fire','area'):
        if FFX_ObjectGetAttr(char,'fire explosion',0)==1:
            for obj in Mission_GetObjects():
                Mission_RemoveCustomAction('CUSTOM_FIREAREA',char,obj)
            FFX_ObjectSetAttr(char,'fire explosion',0)
        else:
            if FFX_ObjectGetAttr(char,'fire explosion',0)==2:
                FFX_ObjectSetAttr(char,'fire explosion',1)
    if m25ai.HasPowerType(target,'cold','melee'):
        if FFX_ObjectGetAttr(char,'frozen touch',0)==1:
            for obj in Mission_GetObjects():
                Mission_RemoveCustomAction('CUSTOM_COLDTOUCH',char,obj)
            FFX_ObjectSetAttr(char,'frozen touch',0)
        else:
            if FFX_ObjectGetAttr(char,'frozen touch',0)==2:
                FFX_ObjectSetAttr(char,'frozen touch',1)
    if m25ai.HasPowerType(target,'cold','ranged'):
        if FFX_ObjectGetAttr(char,'icy blast',0)==1:
            for obj in Mission_GetObjects():
                Mission_RemoveCustomAction('CUSTOM_COLDBLAST',char,obj)
            FFX_ObjectSetAttr(char,'icy blast',0)
        else:
            if FFX_ObjectGetAttr(char,'icy blast',0)==2:
                FFX_ObjectSetAttr(char,'icy blast',1)
    if m25ai.HasPowerType(target,'cold','area'):
        if FFX_ObjectGetAttr(char,'frozen explosion',0)==1:
            for obj in Mission_GetObjects():
                Mission_RemoveCustomAction('CUSTOM_COLDAREA',char,obj)
            FFX_ObjectSetAttr(char,'frozen explosion',0)
        else:
            if FFX_ObjectGetAttr(char,'frozen explosion',0)==2:
                FFX_ObjectSetAttr(char,'frozen explosion',1)
    if m25ai.HasPowerType(target,'energy','melee'):
        if FFX_ObjectGetAttr(char,'energy touch',0)==1:
            for obj in Mission_GetObjects():
                Mission_RemoveCustomAction('CUSTOM_ENERGYTOUCH',char,obj)
            FFX_ObjectSetAttr(char,'energy touch',0)
        else:
            if FFX_ObjectGetAttr(char,'energy touch',0)==2:
                FFX_ObjectSetAttr(char,'energy touch',1)
    if m25ai.HasPowerType(target,'energy','ranged'):
        if FFX_ObjectGetAttr(char,'energy blast',0)==1:
            for obj in Mission_GetObjects():
                Mission_RemoveCustomAction('CUSTOM_ENERGYBLAST',char,obj)
            FFX_ObjectSetAttr(char,'energy blast',0)
        else:
            if FFX_ObjectGetAttr(char,'energy blast',0)==2:
                FFX_ObjectSetAttr(char,'energy blast',1)
    if m25ai.HasPowerType(target,'energy','area'):
        if FFX_ObjectGetAttr(char,'energy explosion',0)==1:
            for obj in Mission_GetObjects():
                Mission_RemoveCustomAction('CUSTOM_ENERGYAREA',char,obj)
            FFX_ObjectSetAttr(char,'energy explosion',0)
        else:
            if FFX_ObjectGetAttr(char,'energy explosion',0)==2:
                FFX_ObjectSetAttr(char,'energy explosion',1)
    ### Attributes ###
    if hasAttribute(target,'flier') or hasAttribute(target,'levitate'):
        if FFX_ObjectGetAttr(char,'absorb flying',0)==1:
            if Object_GetSecondaryStates(char)&SCSTATE_BUOYANT:
                Object_SetSecondaryState(char,SCSTATE_BUOYANT,0,REMOVE_STATE)
                FFX_ObjectSetAttr(char,'absorb flying',0)
        else:
            if FFX_ObjectGetAttr(char,'absorb flying',0)==2:
                FFX_ObjectSetAttr(char,'absorb flying',1)
    if hasAttribute(target,'puppetn'):
        if FFX_ObjectGetAttr(char,'nature master',0)==1:
            temps=[]
            ffx.RegTimer('masterDie',0.1,2,char)
            for template in natureTemplates:
                Mission_RemoveCustomAction('CUSTOM_ANIMATE',char,template[0])
                match=0
                for temp in temps:
                    if temp==template[1]:
                        match=1
                if match==0:
                    Mission_RemoveCustomAction('CUSTOM_DEANIMATE',char,template[1])
                    Mission_RemoveCustomAction('CUSTOM_SUSTAIN',char,template[1])
                    temps.append(template[1])
            FFX_ObjectSetAttr(char,'nature master',0)
        else:
            if FFX_ObjectGetAttr(char,'nature master',0)==2:
                FFX_ObjectSetAttr(char,'nature master',1)
    if hasAttribute(target,'puppetu'):
        if FFX_ObjectGetAttr(char,'urban animator',0)==1:
            temps=[]
            ffx.RegTimer('masterDie',0.1,2,char)
            for template in urbanTemplates:
                Mission_RemoveCustomAction('CUSTOM_ANIMATE',char,template[0])
                match=0
                for temp in temps:
                    if temp==template[1]:
                        match=1
                if match==0:
                    Mission_RemoveCustomAction('CUSTOM_DEANIMATE',char,template[1])
                    Mission_RemoveCustomAction('CUSTOM_SUSTAIN',char,template[1])
                    temps.append(template[1])
            FFX_ObjectSetAttr(char,'urban animator',0)
        else:
            if FFX_ObjectGetAttr(char,'urban animator',0)==2:
                FFX_ObjectSetAttr(char,'urban animator',1)
    if hasAttribute(target,'icecontrol'):
        if FFX_ObjectGetAttr(char,'ice power',0)==1:
            for obj in Mission_GetObjects():
                Mission_RemoveCustomAction('CUSTOM_ICEWALL',char,obj)
                Mission_RemoveCustomAction('CUSTOM_ICEPATCH',char,obj)
            FFX_ObjectSetAttr(char,'ice power',0)
        else:
            if FFX_ObjectGetAttr(char,'ice power',0)==2:
                FFX_ObjectSetAttr(char,'ice power',1)
    if hasAttribute(target,'firecontrol'):
        if FFX_ObjectGetAttr(char,'flame powers',0)==1:
            FFX_ObjectSetAttr(Object_GetTemplate(char),'firecontrol',0)
            for obj in Mission_GetObjects():
                Mission_RemoveCustomAction('CUSTOM_EXTINGUISH',char,obj)
                Mission_RemoveCustomAction('CUSTOM_FIREWALL',char,obj)
            FFX_ObjectSetAttr(char,'flame powers',0)
        else:
            if FFX_ObjectGetAttr(char,'flame powers',0)==2:
                FFX_ObjectSetAttr(char,'flame powers',1)
    if hasAttribute(target,'earthcontrol'):
        if FFX_ObjectGetAttr(char,'earth powers',0)==1:
            FFX_ObjectSetAttr(Object_GetTemplate(char),'earthcontrol',0)
            Mission_RemoveCustomAction('CUSTOM_DROP',char,char)
            for temp in ffx.templates:
                Mission_RemoveCustomAction('CUSTOM_LIFT',char,temp[0])
                Mission_RemoveCustomAction('CUSTOM_THROWTO',char,temp[0])
                Mission_RemoveCustomAction('CUSTOM_MOVETO',char,temp[0])
            for obj in Mission_GetObjects():
                Mission_RemoveCustomAction('CUSTOM_LIFT',char,obj)
                Mission_RemoveCustomAction('CUSTOM_SPIKE',char,obj)
                Mission_RemoveCustomAction('CUSTOM_WALL',char,obj)
            FFX_ObjectSetAttr(char,'earth powers',0)
        else:
            if FFX_ObjectGetAttr(char,'earth powers',0)==2:
                FFX_ObjectSetAttr(char,'earth powers',1)
    if hasAttribute(target,'weathercontrol'):
        if FFX_ObjectGetAttr(char,'weather powers',0)==1:
            FFX_ObjectSetAttr(Object_GetTemplate(char),'weathercontrol',0)
            Mission_RemoveCustomAction('CUSTOM_STORM',char,char)
            Mission_RemoveCustomAction('CUSTOM_RAIN',char,char)
            Mission_RemoveCustomAction('CUSTOM_HAIL',char,char)
            Mission_RemoveCustomAction('CUSTOM_LIGHTNING',char,char)
            FFX_ObjectSetAttr(char,'weather powers',0)
        else:
            if FFX_ObjectGetAttr(char,'weather powers',0)==2:
                FFX_ObjectSetAttr(char,'weather powers',1)
    if hasAttribute(target,'supertk'):
        if FFX_ObjectGetAttr(char,'tk',0)==1:
            FFX_ObjectSetAttr(Object_GetTemplate(char),'supertk',0)
            Mission_RemoveCustomAction('CUSTOM_DROP',char,char)
            for obj in Mission_GetObjects():
                Mission_RemoveCustomAction('CUSTOM_LIFT',char,obj)
                Mission_RemoveCustomAction('CUSTOM_THROWTO',char,obj)
                Mission_RemoveCustomAction('CUSTOM_MOVETO',char,obj)
            FFX_ObjectSetAttr(char,'tk',0)
        else:
            if FFX_ObjectGetAttr(char,'tk',0)==2:
                FFX_ObjectSetAttr(char,'tk',1)
    if hasAttribute(target,'ffhighjumper') | hasAttribute(target,'ffqlowjumper') | hasAttribute(target,'superleaper') | hasAttribute(target,'jumper'):
        if FFX_ObjectGetAttr(char,'super leaper',0)==1:
            for obj in Mission_GetObjects():
                Mission_RemoveCustomAction('custom_leapto',char,obj)
            FFX_ObjectSetAttr(char,'super leaper',0)
        else:
            if FFX_ObjectGetAttr(char,'super leaper',0)==2:
                FFX_ObjectSetAttr(char,'super leaper',1)
    if hasAttribute(target,'telepathy'):
        if FFX_ObjectGetAttr(char,'hyper sense',0)==1:
            Mission_RemoveCustomAction('CUSTOM_SCAN',char,char)
            FFX_ObjectSetAttr(char,'hyper sense',0)
        else:
            if FFX_ObjectGetAttr(char,'hyper sense',0)==2:
                FFX_ObjectSetAttr(char,'hyper sense',1)
    if hasAttribute(target,'fast healing'):
        if FFX_ObjectGetAttr(char,'rapidhealing',0)==1:
            FFX_ObjectSetAttr(char,'sparehp',0)
            FFX_ObjectSetAttr(char,'rapidhealing',0)
        else:
            if FFX_ObjectGetAttr(char,'rapidhealing',0)==2:
                FFX_ObjectSetAttr(char,'rapidhealing',1)
    if hasAttribute(target,'lesserregeneration'):
        if FFX_ObjectGetAttr(char,'regenerative',0)==1:
            FFX_ObjectSetAttr(char,'regenerative',0)
            removeFFXAttrib(char, 'lesserregeneration')
        else:
            if FFX_ObjectGetAttr(char,'regenerative',0)==2:
                FFX_ObjectSetAttr(char,'regenerative',1)
    if hasAttribute(target,'superhealer'):
        if FFX_ObjectGetAttr(char,'superhealing',0)==1:
            FFX_ObjectSetAttr(char,'superhealing',0)
            removeFFXAttrib(char, 'superhealer')
        else:
            if FFX_ObjectGetAttr(char,'superhealing',0)==2:
                FFX_ObjectSetAttr(char,'superhealing',1)
    if hasAttribute(target,'lightcontrol'):
        if FFX_ObjectGetAttr(char,'light powers',0)==1:
            Mission_RemoveCustomAction('CUSTOM_DARKEN',char,char)
            Mission_RemoveCustomAction('CUSTOM_LIGHTEN',char,char)
            Mission_RemoveCustomAction('CUSTOM_RESTORELIGHT',char,char)
            FFX_ObjectSetAttr(char,'light powers',0)
        else:
            if FFX_ObjectGetAttr(char,'light powers',0)==2:
                FFX_ObjectSetAttr(char,'light powers',1)
    if hasAttribute(target,'masscontrol'):
        if FFX_ObjectGetAttr(char,'density control',0)==1:
            Mission_RemoveCustomAction('CUSTOM_MASSUP',char,char)
            Mission_RemoveCustomAction('CUSTOM_MASSDOWN',char,char)
            FFX_ObjectSetAttr(char,'density control',0)
        else:
            if FFX_ObjectGetAttr(char,'density control',0)==2:
                FFX_ObjectSetAttr(char,'density control',1)
    if hasAttribute(target,'metamorphic'):
        if FFX_ObjectGetAttr(char,'metamorph',0)==1:
            Mission_RemoveCustomAction('CUSTOM_ICECLOUD',char,char)
            Mission_RemoveCustomAction('CUSTOM_SANDSTORM',char,char)
            Mission_RemoveCustomAction('CUSTOM_GASEOUSFORM',char,char)
            FFX_ObjectSetAttr(char,'metamorph',0)
        else:
            if FFX_ObjectGetAttr(char,'metamorph',0)==2:
                FFX_ObjectSetAttr(char,'metamorph',1)
    if hasAttribute(target,'icecloud'):
        if FFX_ObjectGetAttr(char,'ice cloud',0)==1:
            Mission_RemoveCustomAction('CUSTOM_ICECLOUD',char,char)
            FFX_ObjectSetAttr(char,'ice cloud',0)
        else:
            if FFX_ObjectGetAttr(char,'ice cloud',0)==2:
                FFX_ObjectSetAttr(char,'ice cloud',1)
    if hasAttribute(target,'sandstorm'):
        if FFX_ObjectGetAttr(char,'sand storm',0)==1:
            Mission_RemoveCustomAction('CUSTOM_SANDSTORM',char,char)
            FFX_ObjectSetAttr(char,'sand storm',0)
        else:
            if FFX_ObjectGetAttr(char,'sand storm',0)==2:
                FFX_ObjectSetAttr(char,'sand storm',1)
    if hasAttribute(target,'gaseousform'):
        if FFX_ObjectGetAttr(char,'gaseous form',0)==1:
            Mission_RemoveCustomAction('CUSTOM_GASEOUSFORM',char,char)
            FFX_ObjectSetAttr(char,'gaseous form',0)
        else:
            if FFX_ObjectGetAttr(char,'gaseous form',0)==2:
                FFX_ObjectSetAttr(char,'gaseous form',1)
    if hasAttribute(target,'plasmasculptor'):
        if FFX_ObjectGetAttr(char,'plasma sculpting',0)==1:
            removeCommand('CUSTOM_GIVETHROW',char)
            removeCommand('CUSTOM_GIVEWIELD',char)
            removeCommand('CUSTOM_MAKEDROP',char)
            removeCommand('CUSTOM_MAKEBARRIER',char)
            FFX_ObjectSetAttr(char,'plasma sculpting',0)
        else:
            if FFX_ObjectGetAttr(char,'plasma sculpting',0)==2:
                FFX_ObjectSetAttr(char,'plasma sculpting',1)
    if not hasAttribute(target,'phasing'):
        if FFX_ObjectGetAttr(char,'phaser',0)==1:
            Mission_RemoveCustomAction('CUSTOM_PHASEOUT',char,char)
            Mission_RemoveCustomAction('CUSTOM_PHASEIN',char,char)
            if FFX_ObjectGetAttr(char,'phased',0)==1:
                FFX_ObjectSetAttr(char,'phased',0)
                Object_SetAttr(char,'attackBonus',1)
                Object_SetAttr(char,'oldAttackBonus',1)
                Object_SetGenericState(char,OBJSTATE_ATTACKBONUS,0,REMOVE_STATE)
                Trigger_Power(char,char,'ffq_remove_defence','')
                str=Object_GetAttr(char,'templateStrength')
                Object_SetAttr(char,'strength',str)
                FFX_ObjectSetAttr(char, 'permanent_shield', FFX_ObjectGetAttr(char, 'permanent_shield') - 1 ) 
                Object_SetSecondaryState(char,SCSTATE_BUOYANT,0,REMOVE_STATE)
                speed=Object_GetAttr(char,'baseSpeed')
                Object_SetAttr(char,'speed',speed)
                FFX_ObjectSetAttr(char,'baseSpeed',speed)
        else:
            if FFX_ObjectGetAttr(char,'phaser',0)==2:
                FFX_ObjectSetAttr(char,'phaser',1)


def kinetic_bolt(target,char):
    Trigger_Power(char,target,'ffx_kinetic_bolt','')

def kinetic_blast(target,char):
    Trigger_Explosion(char,'ffx_kinetic_blast')

def electric_shock(target,char):
    Trigger_Power(char,target,'manowar Electric Arc','')

def electric_blast(target,char):
    Trigger_Power(char,target,'timemaster Electrical extra','')

def electric_explosion(target,char):
    Trigger_Explosion(char,'blue darkmen Electrical Field')

def radioactive_touch(target,char):
    Trigger_Power(char,target,'ffx_radioactive_touch','')

def radioactive_blast(target,char):
    Trigger_Power(char,target,'eye of the reich Rad extra','')

def radioactive_explosion(target,char):
    Trigger_Explosion(char,'rad_explosion')

def acid_fist(target,char):
    Trigger_Power(char,target,'green bacchite Poison Spear','')

def acid_area(target,char):
    Trigger_Explosion(char,'ffx_acid_explosion')

def fire_fist(target,char):
    Trigger_Power(char,target,'eldiablo Flaming Fist','')

def flame_blast(target,char):
    Trigger_Power(char,target,'ffx_flame_generation','')

def flame_breath(target,char):
    Trigger_Power(char,target,'ffx_flame_breath','')

def fire_explosion(target,char):
    Trigger_Explosion(char,'ffx_fire_explosion')

def heat_blast(target,char):
    Trigger_Power(char,target,'heat_beam','')

def heat_explosion(target,char):
    Trigger_Explosion(char,'heat_explosion')

def frozen_touch(target,char):
    Trigger_Power(char,target,'snow man Frozen Pummel','')

def icy_blast(target,char):
    Trigger_Power(char,target,'eye of the reich Cold Beam','')

def frozen_explosion(target,char):
    Trigger_Explosion(char,'ffx_cold_explosion')

def energy_touch(target,char):
    Trigger_Power(char,target,'microwave Materialize','')

def energy_blast(target,char):
    Trigger_Power(char,target,'timemaster Energy X extra','')

def energy_explosion(target,char):
    Trigger_Power(char,target,'ffx_energy_explosion','')

def energy_direct(target,char):
    Trigger_Power(char,target,'ffx_energy_direct','')

def sonic_blast(target,char):
    Trigger_Power(char,target,'ffx_sonic_blast','')

def water_blast(target,char):
    Trigger_Power(char,target,'manowar Water Jet','')

def turn_invisible(target,char):
    Trigger_Power(char,target,'ffx_invisibility','')

def displacement(target,char):
    FFX_ObjectSetAttr(char,'phased',1)
    RegTimer('makePhased',0.1,0,char)

def ffx_absorber_teleport(target,char):
    Trigger_Power(char,target,'ffx_teleport','')

def absorbedshield(target,char):
    Trigger_Power(char,target,'ffx_force_field','')

def mental_blank(target,char):
    Trigger_Power(char,target,'ffx_mental_blank','')

def mental_enrage(target,char):
    Trigger_Power(char,target,'ffx_mental_enrage','')

def mental_panic(target,char):
    Trigger_Power(char,target,'ffx_mental_panic','')

def mystic_alteration(target,char):
    Trigger_Power(char,target,'ffx_mystic_alteration','')

def mystic_hex(target,char):
    Trigger_Power(char,target,'ffx_mystic_hex','')

def mystic_banish(target,char):
    Trigger_Power(char,target,'ffx_mystic_banish','')

def superspeed_sprint(target,char):
    Trigger_Power(char,target,'bullet Sprint','')

def superspeed_bullet(target,char):
    Trigger_Power(char,target,'bullet Speeding Bullet','')

def hyper_breath(target,char):
    Trigger_Power(char,target,'ffx_hyperbreath','')

def sonic_scream(target,char):
    Trigger_Power(char,target,'ffx_sonicscream','')

def dig_tunnel(target,char):
    Trigger_Power(char,target,'the ant Tunnel','')

def heat_vision(target,char):
    Trigger_Power(char,target,'ffx_heat_vision','')

def crush_vision(target,char):
    Trigger_Power(char,target,'ffx_crush_vision','')

def electric_vision(target,char):
    Trigger_Power(char,target,'ffx_electric_vision','')

def rad_vision(target,char):
    Trigger_Power(char,target,'ffx_rad_vision','')

def energy_vision(target,char):
    Trigger_Power(char,target,'ffx_energy_vision','')

def darkforce_blast(target,char):
    Trigger_Power(char,target,'ffx_darkforce_blast','')

def darkforce_blind(target,char):
    Trigger_Power(char,target,'ffx_darkforce_blind','')

def updateLuck(event):
    char=event.object
    if FFX_ObjectGetAttr(char,'probability good',0)!=0:
        bonus=3
        if cshelper.normal(char)==0:
            bonus=0
        RegTimer('updateLuck',1,0,char)
        for obj in Mission_GetDynamicObjects():
            if Object_GetClass(obj)&FFX_CHARACTER & Object_IsAlive(char):
                addAgility(obj,bonus)
                Object_SetAttr(obj,'attackBonus',2)

def updatebadLuck(event):
    obj=event.object
    if FFX_ObjectGetAttr(obj,'probability bad',0)!=0:
        RegTimer('updatebadLuck',5,0,obj)
        if Object_IsAlive(obj)==0:
            return
        for char in Mission_GetDynamicObjects():
            if ((Object_GetClass(char)&FFX_CHARACTER)!=0) & (char!=obj) & Object_IsAlive(char):
                if distanceSq(char,obj)<(300*300):
                    if FFX_Rand(1,100)<=FFX_JINX_CHANCE_JAM:
                        Object_SetSecondaryState(char,SCSTATE_POWER_NULLIFICATION,15,0)
                    if FFX_Rand(1,100)<=FFX_JINX_CHANCE_SLIP:
                        fallOver(char)

################## End of New Absorber ##################


############################### AMPLIFIER ######################################################
# new attribute idea by TaskmasterX with help from the scripting gods Epimethee and Souper_Ian.
# Adds attributes with negative effects to the target depending on what the target's powers are
# to simulate their powers being Amplified beyond their control.

def initamplifier(char, update=0):
    for obj in Mission_GetObjects():
        if((Object_GetClass(obj)&FFX_CHARACTER)!=0):
            subtype = m25ai.FindTacticType(obj, 'subtype')
            if not ('robot' in subtype) | ('hitech' in subtype) | ('normal_human' in subtype):
                Mission_CustomAction('AMPLIFY_POWERS',char,obj,'amplify',10,0)

def amplify(target,user):
    turnTo(user,target)
    AI_Animate(user,'ranged')
    EPCost = max(50,33)
    if not chargeEP(user,EPCost):
        return
    energy=Object_GetAttr(target,'energy')+1
    amps=Object_GetAttr(user,'energy')+1
    if energy>amps:
        diff=energy-amps
        chance=5-diff
    if energy==amps:
        chance=5
    if amps>energy:
        energy=energy-2
        diff=amps-energy
        chance=5+diff
    cancelAmp=randint(1,10)
    if cancelAmp > chance:
        FFX_ApplyDamage(user,energy,mental=0)
        return
    subtype = m25ai.FindTacticType(target, 'subtype')
    str=Object_GetAttr(target,'strength')
    if str>4:
        attrib='butterfingers'
        if not hasAttribute(target,attrib):
            addFFXAttrib(target, attrib)
            RegTimer('removeAmpdAttrib',12,0,target,attrib)
    ### Amplify by Material or Power Type ###
    mat=GetSubtypeMaterial(target)
    if hasAttribute(target,'firecontrol') | (mat==4) | m25ai.HasPowerType(target,'fire','ranged') | m25ai.HasPowerType(target,'fire','area'):
        Object_SetSecondaryState(target,SCSTATE_POWER_NULLIFICATION,12,0)
        attrib='overheated'
        if not hasAttribute(target,attrib):
            addFFXAttrib(target, attrib)
            RegTimer('removeAmpdAttrib',12,0,target,attrib)
    if mat==5 | m25ai.HasPowerType(target,'energy','ranged') | m25ai.HasPowerType(target,'energy','area'):
        Object_SetSecondaryState(target,SCSTATE_POWER_NULLIFICATION,12,0)
        Object_SetSecondaryState(target,SCSTATE_ENERGIZED,10)
    if mat==9 | hasAttribute(target,'icecontrol') | m25ai.HasPowerType(target,'cold','ranged') | m25ai.HasPowerType(target,'cold','area'):
        Object_SetSecondaryState(target,SCSTATE_POWER_NULLIFICATION,12,0)
        attrib='frostbite'
        if not hasAttribute(target,attrib):
            addFFXAttrib(target, attrib)
            RegTimer('removeAmpdAttrib',12,0,target,attrib)
    if ('radiation' in subtype) | m25ai.HasPowerType(target,'radiation','ranged') | m25ai.HasPowerType(target,'radiation','area'):
        Object_SetSecondaryState(target,SCSTATE_POWER_NULLIFICATION,12,0)
        attrib='biohazard'
        if not hasAttribute(target,attrib):
            addFFXAttrib(target, attrib)
            RegTimer('removeAmpdAttrib',12,0,target,attrib)
    if ('electricity' in subtype) | m25ai.HasPowerType(target,'electrical','ranged') | m25ai.HasPowerType(target,'electrical','area'):
        Object_SetSecondaryState(target,SCSTATE_POWER_NULLIFICATION,12,0)
        attrib='shortcirc'
        if not hasAttribute(target,attrib):
            addFFXAttrib(target, attrib)
            RegTimer('removeAmpdAttrib',12,0,target,attrib)
    if m25ai.HasPowerType(target,'acid','ranged') | m25ai.HasPowerType(target,'acid','area'):
        Object_SetSecondaryState(target,SCSTATE_POWER_NULLIFICATION,12,0)
        attrib='acidblood'
        if not hasAttribute(target,attrib):
            addFFXAttrib(target, attrib)
            RegTimer('removeAmpdAttrib',12,0,target,attrib)
    ### Amplify by Attribute ###
    if hasAttribute(target,'telekinetic'):
        Object_SetSecondaryState(target,SCSTATE_POWER_NULLIFICATION,12,0)
        attrib='poltergeist'
        if not hasAttribute(target,attrib):
            addFFXAttrib(target, attrib)
            Object_SetPrimaryState(target,PCSTATE_ENRAGED,12)
            RegTimer('removeAmpdAttrib',12,0,target,attrib)
    if hasAttribute(target,'supertk'):
        Object_SetSecondaryState(target,SCSTATE_POWER_NULLIFICATION,12,0)
        attrib='poltergeist'
        if not hasAttribute(target,attrib):
            addFFXAttrib(target, attrib)
            Object_SetPrimaryState(target,PCSTATE_ENRAGED,12)
            RegTimer('removeAmpdAttrib',12,0,target,attrib)
        attrib='ffqaurauntouchable'
        if not hasAttribute(target,attrib):
            FFX_ObjectSetAttr(target,'noantimissiles',1)
            addFFXAttrib(target, attrib)
            RegTimer('removeAmpdAttrib',12,0,target,attrib)
    if hasAttribute(target,'sensitive'):
        Object_SetSecondaryState(target,SCSTATE_POWER_NULLIFICATION,12,0)
        attrib='empath'
        if not hasAttribute(target,attrib):
            addFFXAttrib(target, attrib)
            RegTimer('removeAmpdAttrib',12,0,target,attrib)
    if hasAttribute(target,'telepathy'):
        Object_SetSecondaryState(target,SCSTATE_POWER_NULLIFICATION,12,0)
        attrib='empath'
        if not hasAttribute(target,attrib):
            addFFXAttrib(target, attrib)
            RegTimer('removeAmpdAttrib',12,0,target,attrib)
    if hasAttribute(target,'masscontrol'):
        Object_SetSecondaryState(target,SCSTATE_POWER_NULLIFICATION,12,0)
        Object_SetGenericState(target,OBJSTATE_DENSITY_CHANGE,12,0)
    if hasAttribute(target,'magnetic'):
        Object_SetSecondaryState(target,SCSTATE_POWER_NULLIFICATION,12,0)
        FFX_ObjectSetAttr(target,'magnetised',12)
    if hasAttribute(target,'ffqprecognitive'):
        Object_SetSecondaryState(target,SCSTATE_POWER_NULLIFICATION,12,0)
        attrib='depressed'
        if not hasAttribute(target,attrib):
            addFFXAttrib(target, attrib)
            RegTimer('removeAmpdAttrib',12,0,target,attrib)
    if hasAttribute(target,'absorbmat'):
        Object_SetSecondaryState(target,SCSTATE_POWER_NULLIFICATION,12,0)
        attrib='absorbmat'
        mat=GetSubtypeMaterial(target)
        FFX_ObjectSetAttr(target,'ampabsorber',1)
        RegTimer('amplifyAbsorber',0.5,mat,target)
        RegTimer('removeAmpdAttrib',10,0,target,attrib)
    if hasAttribute(target,'weathercontrol'):
        Object_SetSecondaryState(target,SCSTATE_POWER_NULLIFICATION,12,0)
        x=randint(1,2)
        if x==1:
            OnLightningStorm(target, target)
        if x==2:
            OnHailStorm(target, target)
    if hasAttribute(target,'lightcontrol'):
        Object_SetSecondaryState(target,SCSTATE_POWER_NULLIFICATION,12,0)
        RegTimer('amplifyLight',0.5,15,target)
        RegTimer('removeAmpdAttrib',15,0,target)
    ### Amplify by Subtype ###
    if ('gravity' in subtype):
        Object_SetSecondaryState(target,SCSTATE_POWER_NULLIFICATION,12,0)
        RegTimer('amplifyGravity',1,10,target)
    if ('sonic' in subtype):
        Object_SetSecondaryState(target,SCSTATE_POWER_NULLIFICATION,12,0)
        RegTimer('amplifySonic',1,10,target)
    if ('mystic' in subtype):
        Object_SetSecondaryState(target,SCSTATE_POWER_NULLIFICATION,12,0)
        RegTimer('amplifyMystic',1,10,target)
    if ('mental' in subtype):
        Object_SetSecondaryState(target,SCSTATE_POWER_NULLIFICATION,12,0)
        RegTimer('amplifyMental',1,10,target)
    if ('animalchanger' in subtype):
        Object_SetPrimaryState(target,PCSTATE_TOAD,12)
    if ('shapechanger' in subtype):
        Object_SetPrimaryState(target,PCSTATE_OBJECT,12)

def removeAmpdAttrib(event):
    target=event.object
    attrib=event.string
    subtype = m25ai.FindTacticType(target, 'subtype')
    if hasAttribute(target, 'lightcontrol'):
        doLight(target,'RestoreLight2')
        removeFFXAttrib(target, attrib)
        return
    if FFX_ObjectGetAttr(target,'untouchableaura',0)==1:
        removeFFXAttrib(target, attrib)
        return
    if FFX_ObjectGetAttr(target,'ampabsorber',0)==1:
        FFX_ObjectSetAttr(target,'ampabsorber',0)
        return
    else:
        removeFFXAttrib(target, attrib)

def amplifyMystic(event):
    target=event.object
    subtype = m25ai.FindTacticType(target, 'subtype')
    if ('mystic' in subtype) & (event.user>0):
        RegTimer('amplifyMystic',2,event.user-1,target)
        Trigger_Explosion(target,'ffx_ex_magic_med')

def amplifyMental(event):
    target=event.object
    subtype = m25ai.FindTacticType(target, 'subtype')
    if ('mental' in subtype) & (event.user>0):
        RegTimer('amplifyMental',2,event.user-1,target)
        Trigger_Explosion(target,'ffx_ex_panic_med')

def amplifySonic(event):
    target=event.object
    subtype = m25ai.FindTacticType(target, 'subtype')
    if ('sonic' in subtype) & (event.user>0):
        RegTimer('amplifySonic',2,event.user-1,target)
        Trigger_Explosion(target,'the ant Ultrasonic Field')

def amplifyGravity(event):
    target=event.object
    subtype = m25ai.FindTacticType(target, 'subtype')
    if ('gravity' in subtype) & (event.user>0):
        ffx.pullCheck(target,16)
        RegTimer('amplifyGravity',2,event.user-1,target)

def amplifyLight(event):
    target=event.object
    if hasAttribute(target, 'lightcontrol'):
        if (event.user>0):
            x=randint(1,2)
            if x==1:
                doLight(target,'Lighten2')
            if x==2:
                doLight(target,'Darken2')
            RegTimer('amplifyLight',5,event.user-1,target)

def amplifyAbsorber(event):
    target=event.object
    mat=event.user
    if FFX_ObjectGetAttr(target,'ampabsorber',0)==1:
        material=FFX_Rand(1,7)
        if material==4:
            material=9
        if material==5:
            material=8
        Object_SetAttr(target,'material',material)
        RegTimer('amplifyAbsorber',5,0,target)
    else:
        Object_SetAttr(target,'material',mat)

#################### End of Amplifier ####################


####################### VOLATILE STORAGE ######################################
# see http://www.freedomreborn.net/invision/index.php?showtopic=35949&st=0
# Variation on ENERGY TANKS that does damage to the character if he
# keeps his stored energy over 150 EP.  As is, accumulates 0.50 HP of
# damage per second he has over 150 EP and if he is over for long
# enough to accumulate 3.0 HP, the damage is applied.
# -Stumpy
#
# 4/25/2006 1.1 version updated by TaskmasterX to allow customizing in FFX Control Center.
#

def initvolatilestorage(char,update):
    if not update:
        FFX_ObjectSetAttr(char,'ivlasteng',Object_GetAttr(char,'energyPoints'))
        base=Object_GetAttr(char,'maxEnergyPoints')
        Object_SetAttr(char,'maxEnergyPoints',2*base)
        RegTimer('updatevolatilestorage',1,0,char)
        FFX_ObjectSetAttr(char,'maxEP',base)

def updatevolatilestorage(event):
    char=event.object
    if not Object_Exists(char):
        return
    energy=Object_GetAttr(char,'energyPoints')
    maxEP=FFX_ObjectGetAttr(char,'maxEP')
    if getByTemplate(char,FFX_VOLATILESTORAGE_CUSTOM,4)=='ambient':
        if energy>maxEP:
            if Object_GetPrimaryState(char)==PCSTATE_ENRAGED:
                Object_SetAttr(char,'energy',3)
            if Object_GetPrimaryState(char)==PCSTATE_PANICKED:
                Object_SetAttr(char,'energy',3)
            else:
                Object_SetAttr(char,'energy',1)
        else:
            Object_SetAttr(char,'energy',FFX_ObjectGetAttr(char,'baseEnergy'))
    else:
        if energy>maxEP:
            Object_SetAttr(char,'energy',0)
        else:
            Object_SetAttr(char,'energy',FFX_ObjectGetAttr(char,'baseEnergy'))
    if getByTemplate(char,FFX_VOLATILESTORAGE_CUSTOM,5)=='vsBattery':
        if energy > (maxEP+10):
            if FFX_ObjectGetAttr(char,'volatile',0)==0:
                FFX_ObjectSetAttr(char,'volatile',1)
                volatilestorageFX(char)
            x=randint(1,100)
            if x<(energy-150):
                RegTimer(getByTemplate(char,FFX_VOLATILESTORAGE_CUSTOM,2),1,1,char)
        else:
            FFX_ObjectSetAttr(char,'volatile',0)
            volatilestorageFX(char)
    if getByTemplate(char,FFX_VOLATILESTORAGE_CUSTOM,5)=='vsRedirect':
        if energy > (maxEP+10):
            if FFX_ObjectGetAttr(char,'volatile',0)==0:
                FFX_ObjectSetAttr(char,'volatile',1)
                volatilestorageFX(char)
                RegTimer(getByTemplate(char,FFX_VOLATILESTORAGE_CUSTOM,2),6,1,char)
        else:
            FFX_ObjectSetAttr(char,'volatile',0)
            volatilestorageFX(char)
    RegTimer('updatevolatilestorage',1,0,char)

def volatilestorageFX(char):
    if FFX_ObjectGetAttr(char,'volatile',0)==1:
        handle=Object_PlayEffect(char,getByTemplate(char,FFX_VOLATILESTORAGE_CUSTOM,1),'',FX_LOOP|FX_TRACK_OBJECT_FULL,0,'centre')
        FFX_ObjectSetAttr(char,'volatileFX',handle)
    else:
        Object_StopEffect(char,FFX_ObjectGetAttr(char,'volatileFX'))

def vsProgressivedamage(event):
    char=event.object
    energy=Object_GetAttr(char,'energyPoints')
    maxEP=FFX_ObjectGetAttr(char,'maxEP')
    if energy>(maxEP+10):
        if energy<(maxEP+34):
            Trigger_Damage(char,randint(1,3))
    if energy>(maxEP+33):
        if energy<(maxEP+67):
            Trigger_Damage(char,randint(4,6))
    if energy>(maxEP+66):
        Trigger_Damage(char,randint(7,10))

def vsExplode(event):
    char=event.object
    energy=Object_GetAttr(char,'energyPoints')
    maxEP=FFX_ObjectGetAttr(char,'maxEP')
    if energy>(maxEP+10):
        if energy<(maxEP+34):
            Trigger_Explosion(char,getByTemplate(char,FFX_VOLATILESTORAGE_CUSTOM,3))
    if energy>(maxEP+33):
        if energy<(maxEP+67):
            Trigger_Explosion(char,getByTemplate(char,FFX_VOLATILESTORAGE_CUSTOM,3),1.5)
    if energy>(maxEP+66):
        Trigger_Explosion(char,getByTemplate(char,FFX_VOLATILESTORAGE_CUSTOM,3),2)
    Object_SetAttr(char,'energyPoints',maxEP)

def vsZapEnergy(event):
    char=event.object
    energy=Object_GetAttr(char,'energyPoints')
    maxEP=FFX_ObjectGetAttr(char,'maxEP')
    if energy>(maxEP+10):
        if energy<(maxEP+34):
            Object_SetAttr(char,'energy',2)
            Object_SetAttr(char,'energyPoints',66)
    if energy>(maxEP+33):
        if energy<(maxEP+67):
            Object_SetAttr(char,'energy',1)
            Object_SetAttr(char,'energyPoints',33)
    if energy>(maxEP+66):
            Object_SetAttr(char,'energy',0)
            Object_SetAttr(char,'energyPoints',0)
    RegTimer('unzapEnergy',5,0,char)

def vsStun(event):
    char=event.object
    energy=Object_GetAttr(char,'energyPoints')
    maxEP=FFX_ObjectGetAttr(char,'maxEP')
    if energy>(maxEP+10):
        if energy<(maxEP+34):
            Object_SetPrimaryState(char,PCSTATE_STUNNED,3,0)
    if energy>(maxEP+33):
        if energy<(maxEP+67):
            Object_SetPrimaryState(char,PCSTATE_STUNNED,6,0)
    if energy>(maxEP+66):
        Object_SetPrimaryState(char,PCSTATE_STUNNED,10,0)
    Object_SetAttr(char,'energyPoints',maxEP)

def vsHalfHealth(event):
    char=event.object
    energy=Object_GetAttr(char,'energyPoints')
    maxEP=FFX_ObjectGetAttr(char,'maxEP')
    if energy>(maxEP+10):
        FFX_FactorHealth(char,0.5)
    Object_SetAttr(char,'energyPoints',maxEP)

def vsIrradiate(event):
    char=event.object
    energy=Object_GetAttr(char,'energyPoints')
    maxEP=FFX_ObjectGetAttr(char,'maxEP')
    if energy>(maxEP+10):
        if energy<(maxEP+34):
            Object_SetSecondaryState(char,SCSTATE_IRRADIATED,3,0)
    if energy>(maxEP+33):
        if energy<(maxEP+67):
            Object_SetSecondaryState(char,SCSTATE_IRRADIATED,6,0)
    if energy>(maxEP+66):
        Object_SetSecondaryState(char,SCSTATE_IRRADIATED,10,0)
    Object_SetAttr(char,'energyPoints',maxEP)

def vsTakedamage(event):
    char=event.object
    energy=Object_GetAttr(char,'energyPoints')
    maxEP=FFX_ObjectGetAttr(char,'maxEP')
    if energy>(maxEP+10):
        if energy<(maxEP+34):
            Trigger_Damage(char,randint(3,8))
    if energy>(maxEP+33):
        if energy<(maxEP+67):
            Trigger_Damage(char,randint(9,14))
    if energy>(maxEP+66):
        Trigger_Damage(char,randint(15,20))
    Object_SetAttr(char,'energyPoints',maxEP)
####################### End of Volatile Storage #######################

####################### Velcro Feet ###################################
# stumpy 2007-11-12:
# As suggested by bearded (see http://freedomreborn.net/simple/index.php?topic=45190.0)
# FFEdit name: velcrofeet, cost 100
# strings.txt entries:
## attrib_velcrofeet_01, velcro feet
## attrib_velcrofeet_desc_01, due to grippy footwear, a slushy composition, or an overabundance of higg's bosons, you are twice as resistant to knockback as your mass alone would suggest.

def initvelcrofeet(char,update=0,remove=0):
    if remove and ( FFX_ObjectGetAttr(char,'velcrofeet',0) != 0 ) :
        FFX_ObjectSetAttr(char,'velcrofeet',0)
        Object_SetAttr(char, 'minForce', FFX_ObjectGetAttr(char,'templateMinForce'))
        FFX_ObjectSetAttr(char, 'baseMinForce', FFX_ObjectGetAttr(char,'templateMinForce'))
    else:
        FFX_ObjectSetAttr(char,'velcrofeet',1)
        # Not doing it, but should we check that minForce isn't arlready tweaked? 
        FFX_ObjectSetAttr(char, 'templateMinForce', Object_GetAttr(char,'minForce'))
        Object_SetAttr(char, 'minForce', Object_GetAttr(char,'mass')*20)
        # change baseMinForce so that this plays well with ffqrooted etc.
        FFX_ObjectSetAttr(char, 'baseMinForce', Object_GetAttr(char,'mass')*20)
####################### end of Velcro Feet #############################
        

############################## TWISTER ###########################
# Adds the Human Top superrotate Power to the character while flying
# - TaskmasterX
###################################################################

def inittwister(char,update=0):
    if update==0:
        RegTimer('twisterCheck',1,0,char)
        FFX_ObjectSetAttr(char,'airborne_twister',0)
        FFX_ObjectSetAttr(char,'flyCheck',0)

def twisterCheck(event):
    char=event.object
    if not Object_Exists(char):
        return
    if not Object_IsAlive(char):
        return
    RegTimer('twisterCheck',1,0,char)
    flying=mlogreader.MLOG_IsFlying(char) #Ep. 2007-02-04: Replace obsolete FQ_IsFlying()
    wasFlying=FFX_ObjectGetAttr(char,'airborne_twister')
    if flying:
        Trigger_Explosion(char,'ffx_superrotate')
        if wasFlying==0:
            FFX_ObjectSetAttr(char,'airborne_twister',1)
            handle=Object_PlayEffect(char,getByTemplate(char,FFX_TWISTER_CUSTOM,1),'',FX_LOOP|FX_TRACK_OBJECT_POS)
            FFX_ObjectSetAttr(char,'twisterfx',handle)
    elif not flying:
        Object_StopEffect(char,FFX_ObjectGetAttr(char,'twisterfx'))
        FFX_ObjectSetAttr(char,'airborne_twister',0)




### Stuff taken from posts in Freedom Reborn and added/adapted by catwhowalksbyhimself
########################### SOUPERIAN'S ATTRIBUTES ETC. #########################################
        
####################### Knockout gas state swap #######################
#Stumpy and Ep. 2007-02-26 to 2007-03-10:
# - Streamlined the process, and patched a few bugs and UI issues.
# - Prevented the KO Gas from working on robots and characters with FFX_ObjectSetAttr(char, 'nonbreather', 1)


def stuntoknockoutgas(event):
    kogasP(event,PCSTATE_STUNNED,COST_STUN)
def hypnosistoknockoutgas(event):
    kogasP(event,PCSTATE_HYPNOTISED,COST_HYPNO)
def ragetoknockoutgas(event):
    kogasP(event,PCSTATE_ENRAGED,COST_RAGE)
def exiletoknockoutgas(event):
    kogasP(event,PCSTATE_EXILE,COST_EXILE)
def blanktoknockoutgas(event):
    kogasP(event,PCSTATE_BLANK,COST_BLANK)
def panictoknockoutgas(event):
    kogasP(event,PCSTATE_PANICKED,COST_PANIC)

def hextoknockoutgas(event):
    kogasS(event,SCSTATE_HEXED,COST_HEX)
def blindtoknockoutgas(event):
    kogasS(event,SCSTATE_BLIND,COST_BLIND)
def powernulltoknockoutgas(event):
    kogasS(event,SCSTATE_POWER_NULLIFICATION,COST_NULL)
def weakentoknockoutgas(event):
    kogasS(event,SCSTATE_WEAKENED,COST_WEAKEN)
def speeddecreasetoknockoutgas(event):
    kogasS(event,SCSTATE_SPEED_DECREASED,COST_DECREASE)

def kogasP(event,state,intensity):
    char=event.object
    source=event.string
    if Object_GetPrimaryState(char)==state:
        Object_SetPrimaryState(char,state,0,REMOVE_STATE)
        knockoutgas(char, source, (intensity * 3) + 3)

def kogasS(event,state,intensity):
    char=event.object
    source=event.string
    if Object_GetSecondaryStates(char)&state:
        Object_SetSecondaryState(char,state,0,REMOVE_STATE)
        knockoutgas(char, source, (intensity * 3) + 3)

def knockoutgas(target, source, duration):
    FFX_UpdateStates(target)
    if (getGender(target) == FFX_GENDER_ROBOT) or ( FFX_ObjectGetAttr(target, 'nonbreather') ):
        #if the character is immune to gas, display the "resisted!" bubble
        dummy = getDummyName()
        pos = Get_ObjectPos(target)
        pos = (pos[0], pos[1], pos[2] - 10)
        Object_SpawnAt('podium_invisible', pos, dummy)
        #wait a bit so the object is activated before triggering the explosion
        #hopefully, the target won't have moved away too much
        RegTimer('makeknockedoutresist', 0.1, 0, dummy)
        return
    Trigger_Force(target,0,0,1,Object_GetAttr(target,'minForce'),TF_ABSOLUTE)
    #add the visual effect only if it's not already on so it doesn't get permanent
    if FFX_ObjectGetAttr(target, 'ffs_knockedout') != 1: 
        handle = Object_PlayEffect(target, 'effect_ffx_gaseousform', '', FX_LOOP|FX_TRACK_OBJECT_POS, 0, 'bottom', (0,0,-35))
        FFX_ObjectSetAttr(target, 'knockoutgas_handle', handle)
    mlogreader.regFlailStop(target,'makeknockedouta',user=duration)

def makeknockedoutresist(event):
    dummy = event.object
    Trigger_Explosion(dummy, 'ffx_gaseousform', -2)
    RegTimer('makeknockedoutresistend', 1, 0, dummy) #wait a bit so the explosion actually runs before removing the object

def makeknockedoutresistend(event):
    dummy = event.object
    Object_Destroy(dummy)

def makeknockedouta(event):
    char = event.object
    duration = event.user
    Trigger_Move(char,'lock')
    AI_Animate(char,'fall')
    FFX_ObjectSetAttr(char, 'ffs_knockedout', 1)
    ff.RESULTBUBBLE_SCALE=0
    setPowerNullState(char, duration)
    RegTimer('removeFX',0.5,1,char)
    RegTimer('makeunknockedout', duration, 0, char)
    RegTimer('makeknockedoutb', 0.3, 0, char) #wait a bit so the powernull state is set before registering its end

def makeknockedoutb(event):
    char = event.object
    bubblesOn(event)
    if isPowerNulled(char):
        #if the secondary state ends before the time is up, catch this too, as it should mean a hero point etc. has been spent to stop the KO Gas effect
        regSecondaryState2(char, SCSTATE_POWER_NULLIFICATION, 'makeunknockedout', user = 0, string = '', persistent = 0)
    else: #if the state is alredy removed, remove the KO Gas state too
        makeunknockedoutb(char)

def makeunknockedout(event):
    char = event.object
    makeunknockedoutb(char)

def makeunknockedoutb(char):
    if FFX_ObjectGetAttr(char, 'ffs_knockedout') == 1: #make sure we don't wake them up twice
        setPowerNullState(char, 0)
        handle = FFX_ObjectGetAttr(char, 'knockoutgas_handle')
        Object_StopEffect(char, handle)
        Trigger_Move(char, 'unlock')
        Object_SetAttr(char, 'ffs_knockedout', 0)



########################### APFARMAKIS'S ATTRIBUTES ETC. #########################################

####################### HUMAN ROCKET ########################################
# A hack of Dr Mike's FAST FLIER for super-fast fliers by apfarmakis
# Sets speed to a fixed value independant of landspeed while flying.
# Modified by catwhowalksbyhimself to allow removability and different grades
# Ep. 2006-09-24:
# - minor updates (replaced obsolete flight detection; reduced speed by 1 so
#   in-game values correspond to displayed values; removed obsolete redundant
#   functions).
# Ep. 2007-02-06:
# - Converted to MLOG Reader's event method, i.e., riped off Stumpy's updated
#   Fast Flier.

def inithumanrocket10(char,update=0,remove=0):
    humanrocket(char,9,update,remove)
    
def inithumanrocket15(char,update=0,remove=0):
    humanrocket(char,14,update,remove)
    
def inithumanrocket20(char,update=0,remove=0):
    humanrocket(char,19,update,remove)
    
def inithumanrocket25(char,update=0,remove=0):
    humanrocket(char,24,update,remove)
        
def humanrocket(char,grade,update,remove):
    if update==0:
        if remove == 0:
            mlogreader.regFlightStart(char,'ffx.onHumanRocketStart',persistent=1)
            FFX_ObjectSetAttr(char,'humanrocket',1)
            FFX_ObjectSetAttr(char,'humanrocketgrade',grade)
        else:
            mlogreader.cancelAnimationCallbackSink(char,'ffx.onHumanRocketStart')
            FFX_ObjectSetAttr(char,'humanrocket',0)

def onHumanRocketStart(event):
    char=event.object
    if not ( Object_IsAlive(char) and FFX_ObjectGetAttr(char,'humanrocket',0) ):
        return
    speed=FFX_ObjectGetAttr(char,'humanrocketgrade')
    Object_SetAttr(char,'speed',speed)
    FFX_ObjectSetAttr(char,'baseSpeed',speed)
    mlogreader.regFlightStop(char,'ffx.onHumanRocketStop')

def onHumanRocketStop(event):
    char=event.object
    if not ( Object_IsAlive(char) and FFX_ObjectGetAttr(char,'humanrocket',0) ):
        return
    speed=Object_GetAttr(char,'templateSpeed')
    Object_SetAttr(char,'speed',speed)
    FFX_ObjectSetAttr(char,'baseSpeed',speed)


########################### CHAZZ DA MIGHTY'S ATTRIBUTES ETC. #########################################
############### COMBAT SKILL/CHI POWER ###############################
#  Adds a bonus % to attack damage
# Cat. 2007-02-10: reduced bonus intensity, since it was several times higher than intended
# Ep. 2007-02-10: Changed attributes names to reflect that these are different grades of the same power

def initcombatskill(char,update=0):
    #combines increaseS attack bonus
    if isMP():
        return
    if update==0:
        Object_SetGenericState(char,OBJSTATE_ATTACKBONUS,10000,0) 
        bonus=0.0+Object_GetAttr(char,'attackBonus')
        Object_SetAttr(char,'attackBonus',bonus+0.25)

def initcombatskill2(char,update=0):
    #combines FFX increase attack bonus 
    if isMP():
        return
    if update==0:
        Object_SetGenericState(char,OBJSTATE_ATTACKBONUS,10000,0) 
        bonus=0.0+Object_GetAttr(char,'attackBonus')
        Object_SetAttr(char,'attackBonus',bonus+0.5)

########################### CATWHOWALKSBYHIMSELF'S ATTRIBUTES ETC. #########################################

### Some very simple attributes by catwhowalksbyhimself, intended for campaigns only
        
# stumpy 2008-03-22: we should prevent them being run more than once
# per character to prevent chaos with FFX re-spawns (via SHAPESHIFTER,
# etc.), cloning, etc.

def initquicklearner(char,update=0,remove=0):
    if update==1:
        return
    temp = Object_GetTemplate(char)
    if remove:
        CPBonus = FFX_ObjectGetAttr(temp,'CPBonus',0)
        Campaign_AddCP(temp,-CPBonus)
    else:
        if FFX_ObjectGetAttr(temp,'CPBonus',0) == 0:
            Campaign_AddCP(temp,75)        
            FFX_ObjectSetAttr(temp,'CPBonus',75)
            
def initslowlearner(char,update=0,remove=0):
    if update==1:
        return
    temp = Object_GetTemplate(char)
    if remove:
        CPPenalty = FFX_ObjectGetAttr(temp,'CPPenalty',0)
        Campaign_AddCP(temp,-CPPenalty)
    else:
        if FFX_ObjectGetAttr(temp,'CPPenalty',0) == 0:
            Campaign_AddCP(temp,-50)        
            FFX_ObjectSetAttr(temp,'CPPenalty',-50)

def initpopular(char,update=0,remove=0):
    if update==1:
        return
    temp = Object_GetTemplate(char)
    if remove:
        PPBonus = FFX_ObjectGetAttr(temp,'PPBonus',0)
        Campaign_AddPrestige(-PPBonus)
    else:
        if FFX_ObjectGetAttr(temp,'PPBonus',0) == 0:
            Campaign_AddPrestige(300)        
            FFX_ObjectSetAttr(temp,'PPBonus',300)

def initfamous(char,update=0,remove=0):
    if update==1:
        return
    temp = Object_GetTemplate(char)
    if remove:
        CPPenalty = FFX_ObjectGetAttr(temp,'PPPenalty',0)
        Campaign_AddPrestige(-PPPenalty)
    else:
        if FFX_ObjectGetAttr(temp,'PPPenalty',0) == 0:
            Campaign_AddPrestige(-200)        
            FFX_ObjectSetAttr(temp,'PPPenalty',-200)

#### Catwhowalksbyhimself's Bleeding state swap
#Work in progress

def stuntobleed(event):
    bleedP(event,PCSTATE_STUNNED,COST_STUN)

def bleedP(event,state,intensity):
    char=event.object
    source=event.string
    if Object_GetSecondaryStates(char)&state:
        Object_SetSecondaryState(char,state,0,REMOVE_STATE)
        FFX_UpdateStates(char)
        if FFX_ObjectGetAttr(char,bleedingamt)==0:
            bamt=1
            btime=5
        else:
            bamt=FFX_ObjectGetAttr(char,bleedingamt)
            bamt=bamt+1
            btime=FFX_ObjectGetAttr(char,bleedingtime)
            btime=btime+5
        FFX_ObjectSetAttr(Object_GetTemplate(char),bleedingamt,bamt)
        FFX_ObjectSetAttr(Object_GetTemplate(char),bleedingtime,btime)
        FFX_ObjectSetAttr(Object_GetTemplate(char),bleedingstop,0)
        RegTimer('Onbleed',5,char)

def ONbleed(victim):
    char=victim.object
    FFX_SetDamageAttrs(victim,Object_GetAttr(char,'health')-damage)
    Trigger_Damage(victim,damage)
    btime = FFX_ObjectGetAttr(victim,bleedingtime)
    btime = btime - 1
    if FFX_ObjectGetAttr(victim,bleedingstop)==1:
        FFX_ObjectSetAttr(Object_GetTemplate(victim),bleedingtime,0)
    if FFX_ObjectGetAttr(victim,bleedingtime) > 0:
        RegTimer('Onbleed',5,victim)

#################### FFX3.2.1 TMX Add-Ons ####################

############################## Invulnerable Flier ###########################
# Adds Invulnerable points to the character while flying
# - TaskmasterX
#############################################################################

def initinvflier5(char,update=0):
	invflier(char,5,update)
	
def initinvflier10(char,update=0):
	invflier(char,10,update)
	
def initinvflier15(char,update=0):
	invflier(char,15,update)
	
def initinvflier20(char,update=0):
	invflier(char,20,update)

def initinvflier30(char,update=0):
	invflier(char,30,update)

def invflier(char,grade,update=0):
    if update==0:
        RegTimer('invflierCheck',1,0,char)
        FFX_ObjectSetAttr(char,'invfliergrade',grade)
        FFX_ObjectSetAttr(char,'airborne_inv',0)
        FFX_ObjectSetAttr(char,'flyCheck',0)

def invflierCheck(event):
    char=event.object
    if not Object_Exists(char):
        return
    if not Object_IsAlive(char):
        return
    flying=mlogreader.MLOG_IsFlying(char)
    wasFlying=FFX_ObjectGetAttr(char,'airborne_inv')
    RegTimer('invflierCheck',1,0,char)
    if flying:
        invPoints=FFX_ObjectGetAttr(char,'invPoints')
        bip=FFX_ObjectGetAttr(char,'baseInvPoints')
        grade=FFX_ObjectGetAttr(char,'invfliergrade')
        if invPoints==0:
            FFX_ObjectSetAttr(char,'ivlastdam',Object_GetAttr(char,'health'))
            if not FFX_ObjectGetAttr(char,'DamageManagement',0):
                RegDamage(char,'DamageManagement')
                FFX_ObjectSetAttr(char,'DamageManagement',1)
            FFX_ObjectSetAttr(char,'invPoints',grade)
            FFX_ObjectSetAttr(char,'baseInvPoints',0)
        elif invPoints==bip:
            FFX_ObjectSetAttr(char,'invPoints',invPoints+grade)
        if wasFlying==0:
            FFX_ObjectSetAttr(char,'airborne_inv',1)
    if not flying:
        FFX_ObjectSetAttr(char,'airborne_inv',0)
        bip=FFX_ObjectGetAttr(char,'baseInvPoints')
        invPoints=FFX_ObjectGetAttr(char,'invPoints')
        if bip==0:
            FFX_ObjectSetAttr(char,'DamageManagement',0)
            FFX_ObjectSetAttr(char,'invPoints',0)
        else:
            FFX_ObjectSetAttr(char,'invPoints',bip)


######################### ENERGY REDIRECTOR ##########################
# This attribute detects when energy is absorbed and then adds custom#
# commands for powers the character can then use. If the power is not#
# used within 10 seconds then a custom negative effect occurs.       #
# - TaskMasterX                                                      #
######################################################################

def initenergyredirector(char,update):
    if not update:
        Object_SetAttr(char,'energy_redirect',-1)
        FFX_ObjectSetAttr(char,'absorbed_energy',0)
        FFX_ObjectSetAttr(char,'absorbed_hits',0)
        FFX_ObjectSetAttr(char,'energyPts2',0)
        FFX_ObjectSetAttr(char,'energyRedirectorBegin',1)
        FFX_ObjectSetAttr(char,'preventDrawback',0)
        FFX_ObjectSetAttr(char,'energyMaxed',0)
        base=Object_GetAttr(char,'maxEnergyPoints')
        energy=Object_GetAttr(char,'energyPoints')
        if energy>=base:
            Object_SetAttr(char,'energy',0)
        Object_SetAttr(char,'maxEnergyPoints',2*base)
        FFX_ObjectSetAttr(char,'baseMaxEP',base)
        RegTimer('updateenergyRedirect',1,0,char)

def updateenergyRedirect(event):
    char=event.object
    if not Object_Exists(char):
        return
    if not Object_IsAlive(char):
        return
    if FFX_ObjectGetAttr(char,'energyRedirectorBegin',0)==1:
        FFX_ObjectSetAttr(char,'ivlasteng',Object_GetAttr(char,'energyPoints'))
        FFX_ObjectSetAttr(char,'energyRedirectorBegin',0)
    energyRank=FFX_ObjectGetAttr(char,'baseEnergy')+1
    energyCurrent=Object_GetAttr(char,'energy')
    energy=Object_GetAttr(char,'energyPoints')
    baseMaxEP=FFX_ObjectGetAttr(char,'baseMaxEP')
    maxEP=Object_GetAttr(char,'maxEnergyPoints')
    lastenergy = FFX_ObjectGetAttr(char,'ivlasteng')
    absorbed = energy - lastenergy
    absorbed2 = FFX_ObjectGetAttr(char,'absorbed_intensity2')
    cmd1=getByTemplate(char,FFX_ENERGYREDIRECTION_CUSTOM,4)
    cmd2=getByTemplate(char,FFX_ENERGYREDIRECTION_CUSTOM,6)
    cmd3=getByTemplate(char,FFX_ENERGYREDIRECTION_CUSTOM,8)
    cmd4=getByTemplate(char,FFX_ENERGYREDIRECTION_CUSTOM,10)
    effect=getByTemplate(char,FFX_ENERGYREDIRECTION_CUSTOM,2)
    RegTimer('updateenergyRedirect',0.1,0,char)
    if energy == maxEP: ## if a hero point is used
        Object_SetAttr(char,'energyPoints',maxEP/2)
        FFX_ObjectSetAttr(char,'ivlasteng',Object_GetAttr(char,'energyPoints'))
        return
    if FFX_ObjectGetAttr(char,'erZappedEnergy')==0:
        if (Object_GetClass(char)&OC_CONTROLLABLE)==0:
            energyStat=(0.4 + 0.6*RPG_GAME_DIFFICULTY)*energyRank
            energyStat=energyStat/10
        else:
            energyStat=energyRank*1.3
            energyStat=energyStat/10
    if (Object_GetSecondaryStates(char)&SCSTATE_AREA_ENERGIZED) or (Object_GetSecondaryStates(char)&SCSTATE_ENERGIZED):
        energyStat=energyStat*3
    if energy>=baseMaxEP:
        Object_SetAttr(char,'energy',0)
    else:
        Object_SetAttr(char,'energy',FFX_ObjectGetAttr(char,'baseEnergy'))
    if energy<lastenergy:
        energyUsed=lastenergy - energy
        if energyUsed>1:
            if energy<baseMaxEP:
                if lastenergy<66:
                    energyUsed=100
                    absorbed = 0
                else:
                    energyUsed=energyUsed + energyStat
            else:
                energyUsed=lastenergy - energy
            if energyUsed < 35:
                absorbed = 33 - energyUsed
            else:
                if energyUsed < 67:
                    absorbed = 66 - energyUsed
    absorbed_energy=FFX_ObjectGetAttr(char,'absorbed_energy')
    spentEnergy=FFX_ObjectGetAttr(char,'spent_energy')
    absorbed_hits=FFX_ObjectGetAttr(char,'absorbed_hits')
    energyWasFull=FFX_ObjectGetAttr(char,'energyWasFull')
    energyFull=FFX_ObjectGetAttr(char,'energyFull')
    if absorbed > energyStat:
        handle=Object_PlayEffect(char,getByTemplate(char,FFX_ENERGYREDIRECTION_CUSTOM,1),'',FX_TRACK_OBJECT_FULL|FX_LOOP,0,'centre')
        Object_SetAttr(char,'energy_redirect',handle)
        if FFX_ObjectGetAttr(char,'absorbed_energy')==2:
            FFX_ObjectSetAttr(char,'absorbed_energy',3)
            FFX_ObjectSetAttr(char,'absorbed_intensity3',absorbed)
            if effect!='':
                RegTimer(getByTemplate(char,FFX_ENERGYREDIRECTION_CUSTOM,2),0.1,1,char)
            return
        if FFX_ObjectGetAttr(char,'absorbed_energy')==1:
            if FFX_ObjectGetAttr(char,'energyWasFull')==1:
                FFX_ObjectSetAttr(char,'absorbed_intensity',absorbed2)
                FFX_ObjectSetAttr(char,'absorbed_intensity2',absorbed)
                FFX_ObjectSetAttr(char,'absorbed_hits',1)
                FFX_ObjectSetAttr(char,'energyPts2',Object_GetAttr(char,'energyPoints'))
            if FFX_ObjectGetAttr(char,'spent_energy')==0:
                FFX_ObjectSetAttr(char,'absorbed_energy',2)
                FFX_ObjectSetAttr(char,'absorbed_intensity2',absorbed)
                FFX_ObjectSetAttr(char,'energyFull',1)
                FFX_ObjectSetAttr(char,'energyPts2',Object_GetAttr(char,'energyPoints'))
        if FFX_ObjectGetAttr(char,'absorbed_energy')==0:
            FFX_ObjectSetAttr(char,'absorbed_energy',1)
            FFX_ObjectSetAttr(char,'spent_energy',0)
            FFX_ObjectSetAttr(char,'absorbed_intensity',absorbed)
            FFX_ObjectSetAttr(char,'absorbed_intensity2',0)
            FFX_ObjectSetAttr(char,'energyPts',Object_GetAttr(char,'energyPoints'))
            if cmd1!='':
                for obj in Mission_GetObjects():
                    if ((Object_GetClass(obj) & js.OC_TERRAIN)==0) & (obj!=char):
                        Mission_CustomAction(cmd1,char,obj,'custom_energyRelease1',30,0)
            if cmd2!='':
                for obj in Mission_GetObjects():
                    if ((Object_GetClass(obj) & js.OC_TERRAIN)==0) & (obj!=char):
                        Mission_CustomAction(cmd2,char,obj,'custom_energyRelease2',30,0)
            if cmd3!='':
                for obj in Mission_GetObjects():
                    if ((Object_GetClass(obj) & js.OC_TERRAIN)==0) & (obj!=char):
                        Mission_CustomAction(cmd3,char,obj,'custom_energyRelease3',30,0)
            if cmd4!='':
                for obj in Mission_GetObjects():
                    if ((Object_GetClass(obj) & js.OC_TERRAIN)==0) & (obj!=char):
                        Mission_CustomAction(cmd4,char,obj,'custom_energyRelease4',30,0)
        if (Object_GetClass(char)&OC_CONTROLLABLE)==0:
            if FFX_ObjectGetAttr(char,'absorbed_energy')!=3:
                timer=randint(1,11)
                RegTimer('addERCmdsforAI',timer,0,char)
        if effect!='':
            RegTimer(getByTemplate(char,FFX_ENERGYREDIRECTION_CUSTOM,2),10,1,char)
    FFX_ObjectSetAttr(char,'ivlasteng',Object_GetAttr(char,'energyPoints'))

def addERCmdsforAI(event):
    char=event.object
    target = m25ai.FindTarget(char)
    absorbed=FFX_ObjectGetAttr(char,'absorbed_intensity')
    absorbed2=FFX_ObjectGetAttr(char,'absorbed_intensity2')
    spentEnergy=FFX_ObjectGetAttr(char,'spent_energy')
    absorbed_hits=FFX_ObjectGetAttr(char,'absorbed_hits')
    energyWasFull=FFX_ObjectGetAttr(char,'energyWasFull')
    energyFull=FFX_ObjectGetAttr(char,'energyFull')
    energy=Object_GetAttr(char,'energyPoints')
    newEnergy = energy - absorbed
    newEnergy2 = energy - absorbed2
    absorbed_energy=FFX_ObjectGetAttr(char,'absorbed_energy')
    if FFX_ObjectGetAttr(char,'absorbed_energy')==0:
        return
    if (Object_GetPrimaryState(char)!=PCSTATE_NORMAL) | (Object_IsAlive(char)==0) | (ffx.FFX_ObjectGetAttr(char,'grappled',0)==1) | (ffx.FFX_ObjectGetAttr(char,'rangedgrappled',0)==1) | (ffx.FFX_ObjectGetAttr(char,'tangled',0)==1) | (ffx.FFX_ObjectGetAttr(char,'eTangled',0)==1) | (ffx.FFX_ObjectGetAttr(char,'thrownCharacter',0)==1):
        return
    if FFX_ObjectGetAttr(char,'absorbed_energy')==1:
        if spentEnergy==0:
            if energyWasFull==1:
                intensity = absorbed2/10
                if intensity < 1:
                    Object_SetAttr(char,'energyPoints',newEnergy2)
                m25ai.AIDoPower(char,getByTemplate(char,FFX_ENERGYREDIRECTION_CUSTOM,5),target,priority=m25ai.TACTIC_PRIORITY_CRITICAL,time=3,description='using absorbed energy')
                Object_SetAttr(char,'energy_redirect',-1)
                Object_StopEffect(char,Object_GetAttr(char,'energy_redirect'))
                FFX_ObjectSetAttr(char,'absorbed_energy',0)
                FFX_ObjectSetAttr(char,'energyWasFull',0)
            else:
                intensity = absorbed/10
                if intensity < 1:
                    Object_SetAttr(char,'energyPoints',newEnergy)
                m25ai.AIDoPower(char,getByTemplate(char,FFX_ENERGYREDIRECTION_CUSTOM,5),target,priority=m25ai.TACTIC_PRIORITY_CRITICAL,time=3,description='using absorbed energy')
                Object_SetAttr(char,'energy_redirect',-1)
                Object_StopEffect(char,Object_GetAttr(char,'energy_redirect'))
                FFX_ObjectSetAttr(char,'absorbed_energy',0)
                FFX_ObjectSetAttr(char,'preventDrawback',1)
        if spentEnergy==1:
            intensity = absorbed2/10
            if intensity < 1:
                Object_SetAttr(char,'energyPoints',newEnergy2)
            m25ai.AIDoPower(char,getByTemplate(char,FFX_ENERGYREDIRECTION_CUSTOM,5),target,priority=m25ai.TACTIC_PRIORITY_CRITICAL,time=3,description='using absorbed energy')
            Object_SetAttr(char,'energy_redirect',-1)
            Object_StopEffect(char,Object_GetAttr(char,'energy_redirect'))
            FFX_ObjectSetAttr(char,'absorbed_energy',0)
            FFX_ObjectSetAttr(char,'spent_energy',0)
            FFX_ObjectSetAttr(char,'energyWasFull',0)
    if FFX_ObjectGetAttr(char,'absorbed_energy')==2:
        intensity = absorbed/10
        if intensity < 1:
            Object_SetAttr(char,'energyPoints',newEnergy)
        m25ai.AIDoPower(char,getByTemplate(char,FFX_ENERGYREDIRECTION_CUSTOM,5),target,priority=m25ai.TACTIC_PRIORITY_CRITICAL,time=3,description='using absorbed energy')
        FFX_ObjectSetAttr(char,'absorbed_energy',1)
        FFX_ObjectSetAttr(char,'spent_energy',1)
        FFX_ObjectSetAttr(char,'energyFull',0)
        FFX_ObjectSetAttr(char,'energyWasFull',1)
        FFX_ObjectSetAttr(char,'absorbed_hits',0)
    FFX_ObjectSetAttr(char,'ivlasteng',Object_GetAttr(char,'energyPoints'))

def custom_energyRelease1(obj,char):
    absorbed=FFX_ObjectGetAttr(char,'absorbed_intensity')
    absorbed2=FFX_ObjectGetAttr(char,'absorbed_intensity2')
    spentEnergy=FFX_ObjectGetAttr(char,'spent_energy')
    absorbed_hits=FFX_ObjectGetAttr(char,'absorbed_hits')
    energyWasFull=FFX_ObjectGetAttr(char,'energyWasFull')
    energyFull=FFX_ObjectGetAttr(char,'energyFull')
    energy=Object_GetAttr(char,'energyPoints')
    newEnergy = energy - absorbed
    newEnergy2 = energy - absorbed2
    absorbed_energy=FFX_ObjectGetAttr(char,'absorbed_energy')
    if FFX_ObjectGetAttr(char,'absorbed_energy')==1:
        if spentEnergy==0:
            if energyWasFull==1:
                intensity = absorbed2/10
                if intensity < 1:
                    Object_SetAttr(char,'energyPoints',newEnergy2)
                Trigger_Power(char,obj,getByTemplate(char,FFX_ENERGYREDIRECTION_CUSTOM,5),'',intensity)
                Object_SetAttr(char,'energy_redirect',-1)
                Object_StopEffect(char,Object_GetAttr(char,'energy_redirect'))
                FFX_ObjectSetAttr(char,'absorbed_energy',0)
                FFX_ObjectSetAttr(char,'energyWasFull',0)
                removeEnergyRedirectCmds(char)
            else:
                intensity = absorbed/10
                if intensity < 1:
                    Object_SetAttr(char,'energyPoints',newEnergy)
                Trigger_Power(char,obj,getByTemplate(char,FFX_ENERGYREDIRECTION_CUSTOM,5),'',intensity)
                Object_SetAttr(char,'energy_redirect',-1)
                Object_StopEffect(char,Object_GetAttr(char,'energy_redirect'))
                FFX_ObjectSetAttr(char,'absorbed_energy',0)
                FFX_ObjectSetAttr(char,'preventDrawback',1)
                removeEnergyRedirectCmds(char)
        if spentEnergy==1:
            if absorbed_hits==1:
                intensity = absorbed/10
                if intensity < 1:
                    Object_SetAttr(char,'energyPoints',newEnergy)
                Trigger_Power(char,obj,getByTemplate(char,FFX_ENERGYREDIRECTION_CUSTOM,5),'',intensity)
                Object_SetAttr(char,'energy_redirect',-1)
                Object_StopEffect(char,Object_GetAttr(char,'energy_redirect'))
                FFX_ObjectSetAttr(char,'absorbed_energy',1)
                FFX_ObjectSetAttr(char,'absorbed_hits',0)
            else:
                intensity = absorbed2/10
                if intensity < 1:
                    Object_SetAttr(char,'energyPoints',newEnergy2)
                Trigger_Power(char,obj,getByTemplate(char,FFX_ENERGYREDIRECTION_CUSTOM,5),'',intensity)
                Object_SetAttr(char,'energy_redirect',-1)
                Object_StopEffect(char,Object_GetAttr(char,'energy_redirect'))
                removeEnergyRedirectCmds(char)
                FFX_ObjectSetAttr(char,'absorbed_energy',0)
                FFX_ObjectSetAttr(char,'spent_energy',0)
                FFX_ObjectSetAttr(char,'energyWasFull',0)
    if FFX_ObjectGetAttr(char,'absorbed_energy')==2:
        intensity = absorbed/10
        if intensity < 1:
            Object_SetAttr(char,'energyPoints',newEnergy)
        Trigger_Power(char,obj,getByTemplate(char,FFX_ENERGYREDIRECTION_CUSTOM,5),'',intensity)
        FFX_ObjectSetAttr(char,'absorbed_energy',1)
        FFX_ObjectSetAttr(char,'spent_energy',1)
        FFX_ObjectSetAttr(char,'energyFull',0)
        FFX_ObjectSetAttr(char,'energyWasFull',1)
        FFX_ObjectSetAttr(char,'absorbed_hits',0)
    FFX_ObjectSetAttr(char,'ivlasteng',Object_GetAttr(char,'energyPoints'))

def custom_energyRelease2(obj,char):
    absorbed=FFX_ObjectGetAttr(char,'absorbed_intensity')
    absorbed2=FFX_ObjectGetAttr(char,'absorbed_intensity2')
    spentEnergy=FFX_ObjectGetAttr(char,'spent_energy')
    absorbed_hits=FFX_ObjectGetAttr(char,'absorbed_hits')
    energyWasFull=FFX_ObjectGetAttr(char,'energyWasFull')
    energyFull=FFX_ObjectGetAttr(char,'energyFull')
    energy=Object_GetAttr(char,'energyPoints')
    newEnergy = energy - absorbed
    newEnergy2 = energy - absorbed2
    absorbed_energy=FFX_ObjectGetAttr(char,'absorbed_energy')
    if FFX_ObjectGetAttr(char,'absorbed_energy')==1:
        if spentEnergy==0:
            if energyWasFull==1:
                intensity = absorbed2/10
                if intensity < 1:
                    Object_SetAttr(char,'energyPoints',newEnergy2)
                Trigger_Power(char,obj,getByTemplate(char,FFX_ENERGYREDIRECTION_CUSTOM,7),'',intensity)
                Object_SetAttr(char,'energy_redirect',-1)
                Object_StopEffect(char,Object_GetAttr(char,'energy_redirect'))
                FFX_ObjectSetAttr(char,'absorbed_energy',0)
                FFX_ObjectSetAttr(char,'energyWasFull',0)
                removeEnergyRedirectCmds(char)
            else:
                intensity = absorbed/10
                if intensity < 1:
                    Object_SetAttr(char,'energyPoints',newEnergy)
                Trigger_Power(char,obj,getByTemplate(char,FFX_ENERGYREDIRECTION_CUSTOM,7),'',intensity)
                Object_SetAttr(char,'energy_redirect',-1)
                FFX_ObjectSetAttr(char,'preventDrawback',1)
                Object_StopEffect(char,Object_GetAttr(char,'energy_redirect'))
                FFX_ObjectSetAttr(char,'absorbed_energy',0)
                removeEnergyRedirectCmds(char)
        if spentEnergy==1:
            if absorbed_hits==1:
                intensity = absorbed/10
                if intensity < 1:
                    Object_SetAttr(char,'energyPoints',newEnergy)
                Trigger_Power(char,obj,getByTemplate(char,FFX_ENERGYREDIRECTION_CUSTOM,7),'',intensity)
                Object_SetAttr(char,'energy_redirect',-1)
                Object_StopEffect(char,Object_GetAttr(char,'energy_redirect'))
                FFX_ObjectSetAttr(char,'absorbed_energy',1)
                FFX_ObjectSetAttr(char,'absorbed_hits',0)
            else:
                intensity = absorbed2/10
                if intensity < 1:
                    Object_SetAttr(char,'energyPoints',newEnergy2)
                Trigger_Power(char,obj,getByTemplate(char,FFX_ENERGYREDIRECTION_CUSTOM,7),'',intensity)
                Object_SetAttr(char,'energy_redirect',-1)
                Object_StopEffect(char,Object_GetAttr(char,'energy_redirect'))
                removeEnergyRedirectCmds(char)
                FFX_ObjectSetAttr(char,'absorbed_energy',0)
                FFX_ObjectSetAttr(char,'spent_energy',0)
                FFX_ObjectSetAttr(char,'energyWasFull',0)
    if FFX_ObjectGetAttr(char,'absorbed_energy')==2:
        intensity = absorbed/10
        if intensity < 1:
            Object_SetAttr(char,'energyPoints',newEnergy)
        Trigger_Power(char,obj,getByTemplate(char,FFX_ENERGYREDIRECTION_CUSTOM,7),'',intensity)
        FFX_ObjectSetAttr(char,'absorbed_energy',1)
        FFX_ObjectSetAttr(char,'spent_energy',1)
        FFX_ObjectSetAttr(char,'energyFull',0)
        FFX_ObjectSetAttr(char,'energyWasFull',1)
        FFX_ObjectSetAttr(char,'absorbed_hits',0)
    FFX_ObjectSetAttr(char,'ivlasteng',Object_GetAttr(char,'energyPoints'))

def custom_energyRelease3(obj,char):
    absorbed=FFX_ObjectGetAttr(char,'absorbed_intensity')
    absorbed2=FFX_ObjectGetAttr(char,'absorbed_intensity2')
    spentEnergy=FFX_ObjectGetAttr(char,'spent_energy')
    absorbed_hits=FFX_ObjectGetAttr(char,'absorbed_hits')
    energyWasFull=FFX_ObjectGetAttr(char,'energyWasFull')
    energyFull=FFX_ObjectGetAttr(char,'energyFull')
    energy=Object_GetAttr(char,'energyPoints')
    newEnergy = energy - absorbed
    newEnergy2 = energy - absorbed2
    absorbed_energy=FFX_ObjectGetAttr(char,'absorbed_energy')
    if FFX_ObjectGetAttr(char,'absorbed_energy')==1:
        if spentEnergy==0:
            if energyWasFull==1:
                intensity = absorbed2/10
                if intensity < 1:
                    Object_SetAttr(char,'energyPoints',newEnergy2)
                Trigger_Power(char,obj,getByTemplate(char,FFX_ENERGYREDIRECTION_CUSTOM,9),'',intensity)
                Object_SetAttr(char,'energy_redirect',-1)
                Object_StopEffect(char,Object_GetAttr(char,'energy_redirect'))
                FFX_ObjectSetAttr(char,'absorbed_energy',0)
                FFX_ObjectSetAttr(char,'energyWasFull',0)
                removeEnergyRedirectCmds(char)
            else:
                intensity = absorbed/10
                if intensity < 1:
                    Object_SetAttr(char,'energyPoints',newEnergy)
                Trigger_Power(char,obj,getByTemplate(char,FFX_ENERGYREDIRECTION_CUSTOM,9),'',intensity)
                Object_SetAttr(char,'energy_redirect',-1)
                FFX_ObjectSetAttr(char,'preventDrawback',1)
                Object_StopEffect(char,Object_GetAttr(char,'energy_redirect'))
                FFX_ObjectSetAttr(char,'absorbed_energy',0)
                removeEnergyRedirectCmds(char)
        if spentEnergy==1:
            if absorbed_hits==1:
                intensity = absorbed/10
                if intensity < 1:
                    Object_SetAttr(char,'energyPoints',newEnergy)
                Trigger_Power(char,obj,getByTemplate(char,FFX_ENERGYREDIRECTION_CUSTOM,9),'',intensity)
                Object_SetAttr(char,'energy_redirect',-1)
                Object_StopEffect(char,Object_GetAttr(char,'energy_redirect'))
                FFX_ObjectSetAttr(char,'absorbed_energy',1)
                FFX_ObjectSetAttr(char,'absorbed_hits',0)
            else:
                intensity = absorbed2/10
                if intensity < 1:
                    Object_SetAttr(char,'energyPoints',newEnergy2)
                Trigger_Power(char,obj,getByTemplate(char,FFX_ENERGYREDIRECTION_CUSTOM,9),'',intensity)
                Object_SetAttr(char,'energy_redirect',-1)
                Object_StopEffect(char,Object_GetAttr(char,'energy_redirect'))
                removeEnergyRedirectCmds(char)
                FFX_ObjectSetAttr(char,'absorbed_energy',0)
                FFX_ObjectSetAttr(char,'spent_energy',0)
                FFX_ObjectSetAttr(char,'energyWasFull',0)
    if FFX_ObjectGetAttr(char,'absorbed_energy')==2:
        intensity = absorbed/10
        if intensity < 1:
            Object_SetAttr(char,'energyPoints',newEnergy)
        Trigger_Power(char,obj,getByTemplate(char,FFX_ENERGYREDIRECTION_CUSTOM,9),'',intensity)
        FFX_ObjectSetAttr(char,'absorbed_energy',1)
        FFX_ObjectSetAttr(char,'spent_energy',1)
        FFX_ObjectSetAttr(char,'energyFull',0)
        FFX_ObjectSetAttr(char,'energyWasFull',1)
        FFX_ObjectSetAttr(char,'absorbed_hits',0)
    FFX_ObjectSetAttr(char,'ivlasteng',Object_GetAttr(char,'energyPoints'))

def custom_energyRelease4(obj,char):
    absorbed=FFX_ObjectGetAttr(char,'absorbed_intensity')
    absorbed2=FFX_ObjectGetAttr(char,'absorbed_intensity2')
    spentEnergy=FFX_ObjectGetAttr(char,'spent_energy')
    absorbed_hits=FFX_ObjectGetAttr(char,'absorbed_hits')
    energyWasFull=FFX_ObjectGetAttr(char,'energyWasFull')
    energyFull=FFX_ObjectGetAttr(char,'energyFull')
    energy=Object_GetAttr(char,'energyPoints')
    newEnergy = energy - absorbed
    newEnergy2 = energy - absorbed2
    absorbed_energy=FFX_ObjectGetAttr(char,'absorbed_energy')
    if FFX_ObjectGetAttr(char,'absorbed_energy')==1:
        if spentEnergy==0:
            if energyWasFull==1:
                intensity = absorbed2/10
                if intensity < 1:
                    Object_SetAttr(char,'energyPoints',newEnergy2)
                Trigger_Power(char,obj,getByTemplate(char,FFX_ENERGYREDIRECTION_CUSTOM,11),'',intensity)
                Object_SetAttr(char,'energy_redirect',-1)
                Object_StopEffect(char,Object_GetAttr(char,'energy_redirect'))
                FFX_ObjectSetAttr(char,'absorbed_energy',0)
                FFX_ObjectSetAttr(char,'energyWasFull',0)
                removeEnergyRedirectCmds(char)
            else:
                intensity = absorbed/10
                if intensity < 1:
                    Object_SetAttr(char,'energyPoints',newEnergy)
                Trigger_Power(char,obj,getByTemplate(char,FFX_ENERGYREDIRECTION_CUSTOM,11),'',intensity)
                Object_SetAttr(char,'energy_redirect',-1)
                FFX_ObjectSetAttr(char,'preventDrawback',1)
                Object_StopEffect(char,Object_GetAttr(char,'energy_redirect'))
                FFX_ObjectSetAttr(char,'absorbed_energy',0)
                removeEnergyRedirectCmds(char)
        if spentEnergy==1:
            if absorbed_hits==1:
                intensity = absorbed/10
                if intensity < 1:
                    Object_SetAttr(char,'energyPoints',newEnergy)
                Trigger_Power(char,obj,getByTemplate(char,FFX_ENERGYREDIRECTION_CUSTOM,11),'',intensity)
                Object_SetAttr(char,'energy_redirect',-1)
                Object_StopEffect(char,Object_GetAttr(char,'energy_redirect'))
                FFX_ObjectSetAttr(char,'absorbed_energy',1)
                FFX_ObjectSetAttr(char,'absorbed_hits',0)
            else:
                intensity = absorbed2/10
                if intensity < 1:
                    Object_SetAttr(char,'energyPoints',newEnergy2)
                Trigger_Power(char,obj,getByTemplate(char,FFX_ENERGYREDIRECTION_CUSTOM,11),'',intensity)
                Object_SetAttr(char,'energy_redirect',-1)
                Object_StopEffect(char,Object_GetAttr(char,'energy_redirect'))
                removeEnergyRedirectCmds(char)
                FFX_ObjectSetAttr(char,'absorbed_energy',0)
                FFX_ObjectSetAttr(char,'spent_energy',0)
                FFX_ObjectSetAttr(char,'energyWasFull',0)
    if FFX_ObjectGetAttr(char,'absorbed_energy')==2:
        intensity = absorbed/10
        if intensity < 1:
            Object_SetAttr(char,'energyPoints',newEnergy)
        Trigger_Power(char,obj,getByTemplate(char,FFX_ENERGYREDIRECTION_CUSTOM,11),'',intensity)
        Object_SetAttr(char,'energyPoints',newEnergy)
        FFX_ObjectSetAttr(char,'absorbed_energy',1)
        FFX_ObjectSetAttr(char,'spent_energy',1)
        FFX_ObjectSetAttr(char,'energyFull',0)
        FFX_ObjectSetAttr(char,'energyWasFull',1)
        FFX_ObjectSetAttr(char,'absorbed_hits',0)
    FFX_ObjectSetAttr(char,'ivlasteng',Object_GetAttr(char,'energyPoints'))

def removeEnergyRedirectCmds(char):
    cmd1=getByTemplate(char,FFX_ENERGYREDIRECTION_CUSTOM,4)
    cmd2=getByTemplate(char,FFX_ENERGYREDIRECTION_CUSTOM,6)
    cmd3=getByTemplate(char,FFX_ENERGYREDIRECTION_CUSTOM,8)
    cmd4=getByTemplate(char,FFX_ENERGYREDIRECTION_CUSTOM,10)
    for obj in Mission_GetObjects():
        Mission_RemoveCustomAction(cmd1,char,obj)
        Mission_RemoveCustomAction(cmd2,char,obj)
        Mission_RemoveCustomAction(cmd3,char,obj)
        Mission_RemoveCustomAction(cmd4,char,obj)

def erProgressivedamage(event):
    char=event.object
    absorbed=FFX_ObjectGetAttr(char,'absorbed_intensity')
    absorbed2=FFX_ObjectGetAttr(char,'absorbed_intensity2')
    absorbed_hits=FFX_ObjectGetAttr(char,'absorbed_hits')
    spentEnergy=FFX_ObjectGetAttr(char,'spent_energy')
    energyWasFull=FFX_ObjectGetAttr(char,'energyWasFull')
    energyFull=FFX_ObjectGetAttr(char,'energyFull')
    energy=Object_GetAttr(char,'energyPoints')
    if FFX_ObjectGetAttr(char,'absorbed_energy')==0:
        removeEnergyRedirectCmds(char)
        return
    if FFX_ObjectGetAttr(char,'absorbed_energy')==1:
        if FFX_ObjectGetAttr(char,'absorbed_hits')==1:
            FFX_ObjectSetAttr(char,'absorbed_energy',2)
            FFX_ObjectSetAttr(char,'spent_energy',0)
            return
        if FFX_ObjectGetAttr(char,'energyFull')==1:
            RegTimer(getByTemplate(char,FFX_ENERGYREDIRECTION_CUSTOM,2),1,1,char)
            Trigger_Damage(char,randint(1,3))
            return
        if FFX_ObjectGetAttr(char,'spent_energy')!=0:
            FFX_ObjectSetAttr(char,'spent_energy',0)
            return
        if FFX_ObjectGetAttr(char,'spent_energy')==0:
            if FFX_ObjectGetAttr(char,'preventDrawback')==1:
                FFX_ObjectSetAttr(char,'preventDrawback',0)
                return
            if FFX_ObjectGetAttr(char,'energyWasFull')==0:
                RegTimer(getByTemplate(char,FFX_ENERGYREDIRECTION_CUSTOM,2),1,1,char)
                Trigger_Damage(char,randint(1,3))
            if FFX_ObjectGetAttr(char,'energyWasFull')==1:
                RegTimer(getByTemplate(char,FFX_ENERGYREDIRECTION_CUSTOM,2),1,1,char)
                Trigger_Damage(char,randint(1,3))
    if FFX_ObjectGetAttr(char,'absorbed_energy')==2:
        if FFX_ObjectGetAttr(char,'spent_energy')!=0:
            FFX_ObjectSetAttr(char,'absorbed_energy',1)
            FFX_ObjectSetAttr(char,'spent_energy',0)
            return
        else:
            RegTimer(getByTemplate(char,FFX_ENERGYREDIRECTION_CUSTOM,2),1,1,char)
            Trigger_Damage(char,randint(1,3))
    if FFX_ObjectGetAttr(char,'absorbed_energy')==3:
            damage = absorbed + absorbed2
            damage = damage/2
            Trigger_Damage(char,damage)
            FFX_ObjectSetAttr(char,'absorbed_energy',0)
            FFX_ObjectSetAttr(char,'energyFull',0)
            newEnergy = energy - absorbed
            newEnergy2 = newEnergy - absorbed2
            absorbed3=FFX_ObjectGetAttr(char,'absorbed_intensity3')
            newEnergy3 = newEnergy2 - absorbed3
            Object_SetAttr(char,'energyPoints',newEnergy3)
            removeEnergyRedirectCmds(char)
    FFX_ObjectSetAttr(char,'ivlasteng',Object_GetAttr(char,'energyPoints'))

def erExplode(event):
    char=event.object
    absorbed=FFX_ObjectGetAttr(char,'absorbed_intensity')
    absorbed2=FFX_ObjectGetAttr(char,'absorbed_intensity2')
    absorbed_hits=FFX_ObjectGetAttr(char,'absorbed_hits')
    spentEnergy=FFX_ObjectGetAttr(char,'spent_energy')
    energyWasFull=FFX_ObjectGetAttr(char,'energyWasFull')
    energyFull=FFX_ObjectGetAttr(char,'energyFull')
    energy=Object_GetAttr(char,'energyPoints')
    if FFX_ObjectGetAttr(char,'absorbed_energy')==0:
        return
    if FFX_ObjectGetAttr(char,'absorbed_energy')==1:
        if FFX_ObjectGetAttr(char,'absorbed_hits')==1:
            FFX_ObjectSetAttr(char,'absorbed_energy',2)
            FFX_ObjectSetAttr(char,'spent_energy',0)
            return
        if FFX_ObjectGetAttr(char,'energyFull')==1:
            Trigger_Explosion(char,getByTemplate(char,FFX_ENERGYREDIRECTION_CUSTOM,3))
            newEnergy2 = energy - absorbed2
            Object_SetAttr(char,'energyPoints',newEnergy2)
            FFX_ObjectSetAttr(char,'absorbed_energy',0)
            FFX_ObjectSetAttr(char,'energyFull',0)
            return
        if FFX_ObjectGetAttr(char,'spent_energy')!=0:
            FFX_ObjectSetAttr(char,'spent_energy',0)
            return
        if FFX_ObjectGetAttr(char,'spent_energy')==0:
            if FFX_ObjectGetAttr(char,'preventDrawback')==1:
                FFX_ObjectSetAttr(char,'preventDrawback',0)
                return
            if FFX_ObjectGetAttr(char,'energyWasFull')==0:
                FFX_ObjectSetAttr(char,'absorbed_energy',0)
                Trigger_Explosion(char,getByTemplate(char,FFX_ENERGYREDIRECTION_CUSTOM,3))
                newEnergy = energy - absorbed
                Object_SetAttr(char,'energyPoints',newEnergy)
                removeEnergyRedirectCmds(char)
            if FFX_ObjectGetAttr(char,'energyWasFull')==1:
                Trigger_Explosion(char,getByTemplate(char,FFX_ENERGYREDIRECTION_CUSTOM,3))
                newEnergy2 = energy - absorbed2
                Object_SetAttr(char,'energyPoints',newEnergy2)
                FFX_ObjectSetAttr(char,'absorbed_energy',0)
                FFX_ObjectSetAttr(char,'energyWasFull',0)
                removeEnergyRedirectCmds(char)
    if FFX_ObjectGetAttr(char,'absorbed_energy')==2:
        if FFX_ObjectGetAttr(char,'spent_energy')!=0:
            FFX_ObjectSetAttr(char,'absorbed_energy',1)
            FFX_ObjectSetAttr(char,'spent_energy',0)
            return
        else:
            Trigger_Explosion(char,getByTemplate(char,FFX_ENERGYREDIRECTION_CUSTOM,3))
            newEnergy = energy - absorbed
            FFX_ObjectSetAttr(char,'absorbed_energy',1)
            FFX_ObjectSetAttr(char,'absorbed_hits',0)
            FFX_ObjectSetAttr(char,'spent_energy',0)
            FFX_ObjectSetAttr(char,'energyFull',0)
            Object_SetAttr(char,'energyPoints',newEnergy)
    if FFX_ObjectGetAttr(char,'absorbed_energy')==3:
            Trigger_Explosion(char,getByTemplate(char,FFX_ENERGYREDIRECTION_CUSTOM,3))
            FFX_ObjectSetAttr(char,'absorbed_energy',0)
            FFX_ObjectSetAttr(char,'energyFull',0)
            newEnergy = energy - absorbed
            newEnergy2 = newEnergy - absorbed2
            absorbed3=FFX_ObjectGetAttr(char,'absorbed_intensity3')
            newEnergy3 = newEnergy2 - absorbed3
            Object_SetAttr(char,'energyPoints',newEnergy3)
            removeEnergyRedirectCmds(char)
    FFX_ObjectSetAttr(char,'ivlasteng',Object_GetAttr(char,'energyPoints'))

def erZapEnergy(event):
    char=event.object
    absorbed=FFX_ObjectGetAttr(char,'absorbed_intensity')
    absorbed2=FFX_ObjectGetAttr(char,'absorbed_intensity2')
    absorbed_hits=FFX_ObjectGetAttr(char,'absorbed_hits')
    spentEnergy=FFX_ObjectGetAttr(char,'spent_energy')
    energyWasFull=FFX_ObjectGetAttr(char,'energyWasFull')
    energyFull=FFX_ObjectGetAttr(char,'energyFull')
    energy=Object_GetAttr(char,'energyPoints')
    energyStat=Object_GetAttr(char,'energy')
    if FFX_ObjectGetAttr(char,'absorbed_energy')==0:
        FFX_ObjectSetAttr(char,'erZappedEnergy',0)
        return
    if FFX_ObjectGetAttr(char,'absorbed_energy')==1:
        if FFX_ObjectGetAttr(char,'absorbed_hits')==1:
            FFX_ObjectSetAttr(char,'absorbed_energy',2)
            FFX_ObjectSetAttr(char,'spent_energy',0)
            FFX_ObjectSetAttr(char,'erZappedEnergy',0)
            return
        if FFX_ObjectGetAttr(char,'energyFull')==1:
            if energyStat!=1:
                Object_SetAttr(char,'energyPoints',0)
                Object_SetAttr(char,'energy',1)
                FFX_ObjectSetAttr(char,'erZappedEnergy',1)
                RegTimer('unzapEnergy',10,0,char)
            if energyStat==1:
                Object_SetAttr(char,'energyPoints',0)
                FFX_ObjectSetAttr(char,'erZappedEnergy',1)
                RegTimer('unzapEnergy',10,0,char)
            FFX_ObjectSetAttr(char,'absorbed_energy',0)
            FFX_ObjectSetAttr(char,'energyFull',0)
            return
        if FFX_ObjectGetAttr(char,'spent_energy')!=0:
            FFX_ObjectSetAttr(char,'spent_energy',0)
            FFX_ObjectSetAttr(char,'erZappedEnergy',0)
            return
        if FFX_ObjectGetAttr(char,'spent_energy')==0:
            if FFX_ObjectGetAttr(char,'preventDrawback')==1:
                FFX_ObjectSetAttr(char,'preventDrawback',0)
                FFX_ObjectSetAttr(char,'erZappedEnergy',0)
                return
            if FFX_ObjectGetAttr(char,'energyWasFull')==0:
                FFX_ObjectSetAttr(char,'absorbed_energy',0)
                if energyStat!=1:
                    Object_SetAttr(char,'energyPoints',0)
                    Object_SetAttr(char,'energy',1)
                    FFX_ObjectSetAttr(char,'erZappedEnergy',1)
                    RegTimer('unzapEnergy',10,0,char)
                if energyStat==1:
                    Object_SetAttr(char,'energyPoints',0)
                    FFX_ObjectSetAttr(char,'erZappedEnergy',1)
                    RegTimer('unzapEnergy',10,0,char)
                removeEnergyRedirectCmds(char)
            if FFX_ObjectGetAttr(char,'energyWasFull')==1:
                if energyStat!=1:
                    Object_SetAttr(char,'energyPoints',0)
                    Object_SetAttr(char,'energy',1)
                    FFX_ObjectSetAttr(char,'erZappedEnergy',1)
                    RegTimer('unzapEnergy',10,0,char)
                if energyStat==1:
                    Object_SetAttr(char,'energyPoints',0)
                    FFX_ObjectSetAttr(char,'erZappedEnergy',1)
                    RegTimer('unzapEnergy',10,0,char)
                FFX_ObjectSetAttr(char,'absorbed_energy',0)
                FFX_ObjectSetAttr(char,'energyWasFull',0)
                removeEnergyRedirectCmds(char)
    if FFX_ObjectGetAttr(char,'absorbed_energy')==2:
        if FFX_ObjectGetAttr(char,'spent_energy')!=0:
            FFX_ObjectSetAttr(char,'absorbed_energy',1)
            FFX_ObjectSetAttr(char,'spent_energy',0)
            FFX_ObjectSetAttr(char,'erZappedEnergy',0)
            return
        else:
            if energyStat!=1:
                Object_SetAttr(char,'energyPoints',0)
                Object_SetAttr(char,'energy',1)
                FFX_ObjectSetAttr(char,'erZappedEnergy',1)
                RegTimer('unzapEnergy',10,0,char)
            if energyStat==1:
                Object_SetAttr(char,'energyPoints',0)
                FFX_ObjectSetAttr(char,'erZappedEnergy',1)
                RegTimer('unzapEnergy',10,0,char)
            FFX_ObjectSetAttr(char,'absorbed_energy',1)
            FFX_ObjectSetAttr(char,'absorbed_hits',0)
            FFX_ObjectSetAttr(char,'spent_energy',0)
            FFX_ObjectSetAttr(char,'energyFull',0)
    if FFX_ObjectGetAttr(char,'absorbed_energy')==3:
            if energyStat!=1:
                Object_SetAttr(char,'energyPoints',0)
                Object_SetAttr(char,'energy',1)
                FFX_ObjectSetAttr(char,'erZappedEnergy',1)
                RegTimer('unzapEnergy',10,0,char)
            if energyStat==1:
                Object_SetAttr(char,'energyPoints',0)
                FFX_ObjectSetAttr(char,'erZappedEnergy',1)
                RegTimer('unzapEnergy',10,0,char)
            FFX_ObjectSetAttr(char,'absorbed_energy',0)
            FFX_ObjectSetAttr(char,'energyFull',0)
            removeEnergyRedirectCmds(char)
    FFX_ObjectSetAttr(char,'ivlasteng',Object_GetAttr(char,'energyPoints'))

def erStun(event):
    char=event.object
    absorbed=FFX_ObjectGetAttr(char,'absorbed_intensity')
    absorbed2=FFX_ObjectGetAttr(char,'absorbed_intensity2')
    absorbed_hits=FFX_ObjectGetAttr(char,'absorbed_hits')
    spentEnergy=FFX_ObjectGetAttr(char,'spent_energy')
    energyWasFull=FFX_ObjectGetAttr(char,'energyWasFull')
    energyFull=FFX_ObjectGetAttr(char,'energyFull')
    energy=Object_GetAttr(char,'energyPoints')
    if FFX_ObjectGetAttr(char,'absorbed_energy')==0:
        return
    if FFX_ObjectGetAttr(char,'absorbed_energy')==1:
        if FFX_ObjectGetAttr(char,'absorbed_hits')==1:
            FFX_ObjectSetAttr(char,'absorbed_energy',2)
            FFX_ObjectSetAttr(char,'spent_energy',0)
            return
        if FFX_ObjectGetAttr(char,'energyFull')==1:
            Object_SetPrimaryState(char,PCSTATE_STUNNED,10,0)
            newEnergy2 = energy - absorbed2
            Object_SetAttr(char,'energyPoints',newEnergy2)
            FFX_ObjectSetAttr(char,'absorbed_energy',0)
            FFX_ObjectSetAttr(char,'energyFull',0)
            return
        if FFX_ObjectGetAttr(char,'spent_energy')!=0:
            FFX_ObjectSetAttr(char,'spent_energy',0)
            return
        if FFX_ObjectGetAttr(char,'spent_energy')==0:
            if FFX_ObjectGetAttr(char,'preventDrawback')==1:
                FFX_ObjectSetAttr(char,'preventDrawback',0)
                return
            if FFX_ObjectGetAttr(char,'energyWasFull')==0:
                FFX_ObjectSetAttr(char,'absorbed_energy',0)
                Object_SetPrimaryState(char,PCSTATE_STUNNED,10,0)
                newEnergy = energy - absorbed
                Object_SetAttr(char,'energyPoints',newEnergy)
                removeEnergyRedirectCmds(char)
            if FFX_ObjectGetAttr(char,'energyWasFull')==1:
                Object_SetPrimaryState(char,PCSTATE_STUNNED,10,0)
                newEnergy2 = energy - absorbed2
                Object_SetAttr(char,'energyPoints',newEnergy2)
                FFX_ObjectSetAttr(char,'absorbed_energy',0)
                FFX_ObjectSetAttr(char,'energyWasFull',0)
                removeEnergyRedirectCmds(char)
    if FFX_ObjectGetAttr(char,'absorbed_energy')==2:
        if FFX_ObjectGetAttr(char,'spent_energy')!=0:
            FFX_ObjectSetAttr(char,'absorbed_energy',1)
            FFX_ObjectSetAttr(char,'spent_energy',0)
            return
        else:
            Object_SetPrimaryState(char,PCSTATE_STUNNED,5,0)
            newEnergy = energy - absorbed
            FFX_ObjectSetAttr(char,'absorbed_energy',1)
            FFX_ObjectSetAttr(char,'absorbed_hits',0)
            FFX_ObjectSetAttr(char,'spent_energy',0)
            FFX_ObjectSetAttr(char,'energyFull',0)
            Object_SetAttr(char,'energyPoints',newEnergy)
    if FFX_ObjectGetAttr(char,'absorbed_energy')==3:
            Object_SetPrimaryState(char,PCSTATE_STUNNED,10,0)
            FFX_ObjectSetAttr(char,'absorbed_energy',0)
            FFX_ObjectSetAttr(char,'energyFull',0)
            newEnergy = energy - absorbed
            newEnergy2 = newEnergy - absorbed2
            absorbed3=FFX_ObjectGetAttr(char,'absorbed_intensity3')
            newEnergy3 = newEnergy2 - absorbed3
            Object_SetAttr(char,'energyPoints',newEnergy3)
            removeEnergyRedirectCmds(char)
    FFX_ObjectSetAttr(char,'ivlasteng',Object_GetAttr(char,'energyPoints'))

def erHalfHealth(event):
    char=event.object
    absorbed=FFX_ObjectGetAttr(char,'absorbed_intensity')
    absorbed2=FFX_ObjectGetAttr(char,'absorbed_intensity2')
    absorbed_hits=FFX_ObjectGetAttr(char,'absorbed_hits')
    spentEnergy=FFX_ObjectGetAttr(char,'spent_energy')
    energyWasFull=FFX_ObjectGetAttr(char,'energyWasFull')
    energyFull=FFX_ObjectGetAttr(char,'energyFull')
    energy=Object_GetAttr(char,'energyPoints')
    if FFX_ObjectGetAttr(char,'absorbed_energy')==0:
        return
    if FFX_ObjectGetAttr(char,'absorbed_energy')==1:
        if FFX_ObjectGetAttr(char,'absorbed_hits')==1:
            FFX_ObjectSetAttr(char,'absorbed_energy',2)
            FFX_ObjectSetAttr(char,'spent_energy',0)
            return
        if FFX_ObjectGetAttr(char,'energyFull')==1:
            FFX_FactorHealth(char,0.5)
            newEnergy2 = energy - absorbed2
            Object_SetAttr(char,'energyPoints',newEnergy2)
            FFX_ObjectSetAttr(char,'absorbed_energy',0)
            FFX_ObjectSetAttr(char,'energyFull',0)
            return
        if FFX_ObjectGetAttr(char,'spent_energy')!=0:
            FFX_ObjectSetAttr(char,'spent_energy',0)
            return
        if FFX_ObjectGetAttr(char,'spent_energy')==0:
            if FFX_ObjectGetAttr(char,'preventDrawback')==1:
                FFX_ObjectSetAttr(char,'preventDrawback',0)
                return
            if FFX_ObjectGetAttr(char,'energyWasFull')==0:
                FFX_ObjectSetAttr(char,'absorbed_energy',0)
                FFX_FactorHealth(char,0.5)
                newEnergy = energy - absorbed
                Object_SetAttr(char,'energyPoints',newEnergy)
                removeEnergyRedirectCmds(char)
            if FFX_ObjectGetAttr(char,'energyWasFull')==1:
                FFX_FactorHealth(char,0.5)
                newEnergy2 = energy - absorbed2
                Object_SetAttr(char,'energyPoints',newEnergy2)
                FFX_ObjectSetAttr(char,'absorbed_energy',0)
                FFX_ObjectSetAttr(char,'energyWasFull',0)
                removeEnergyRedirectCmds(char)
    if FFX_ObjectGetAttr(char,'absorbed_energy')==2:
        if FFX_ObjectGetAttr(char,'spent_energy')!=0:
            FFX_ObjectSetAttr(char,'absorbed_energy',1)
            FFX_ObjectSetAttr(char,'spent_energy',0)
            return
        else:
            FFX_FactorHealth(char,0.5)
            newEnergy = energy - absorbed
            FFX_ObjectSetAttr(char,'absorbed_energy',1)
            FFX_ObjectSetAttr(char,'absorbed_hits',0)
            FFX_ObjectSetAttr(char,'spent_energy',0)
            FFX_ObjectSetAttr(char,'energyFull',0)
            Object_SetAttr(char,'energyPoints',newEnergy)
    if FFX_ObjectGetAttr(char,'absorbed_energy')==3:
            FFX_FactorHealth(char,0.5)
            FFX_ObjectSetAttr(char,'absorbed_energy',0)
            FFX_ObjectSetAttr(char,'energyFull',0)
            newEnergy = energy - absorbed
            newEnergy2 = newEnergy - absorbed2
            absorbed3=FFX_ObjectGetAttr(char,'absorbed_intensity3')
            newEnergy3 = newEnergy2 - absorbed3
            Object_SetAttr(char,'energyPoints',newEnergy3)
            removeEnergyRedirectCmds(char)
    FFX_ObjectSetAttr(char,'ivlasteng',Object_GetAttr(char,'energyPoints'))

def erIrradiate(event):
    char=event.object
    absorbed=FFX_ObjectGetAttr(char,'absorbed_intensity')
    absorbed2=FFX_ObjectGetAttr(char,'absorbed_intensity2')
    absorbed_hits=FFX_ObjectGetAttr(char,'absorbed_hits')
    spentEnergy=FFX_ObjectGetAttr(char,'spent_energy')
    energyWasFull=FFX_ObjectGetAttr(char,'energyWasFull')
    energyFull=FFX_ObjectGetAttr(char,'energyFull')
    energy=Object_GetAttr(char,'energyPoints')
    if FFX_ObjectGetAttr(char,'absorbed_energy')==0:
        return
    if FFX_ObjectGetAttr(char,'absorbed_energy')==1:
        if FFX_ObjectGetAttr(char,'absorbed_hits')==1:
            FFX_ObjectSetAttr(char,'absorbed_energy',2)
            FFX_ObjectSetAttr(char,'spent_energy',0)
            return
        if FFX_ObjectGetAttr(char,'energyFull')==1:
            Object_SetSecondaryState(char,SCSTATE_IRRADIATED,10,0)
            newEnergy2 = energy - absorbed2
            Object_SetAttr(char,'energyPoints',newEnergy2)
            FFX_ObjectSetAttr(char,'absorbed_energy',0)
            FFX_ObjectSetAttr(char,'energyFull',0)
            return
        if FFX_ObjectGetAttr(char,'spent_energy')!=0:
            FFX_ObjectSetAttr(char,'spent_energy',0)
            return
        if FFX_ObjectGetAttr(char,'spent_energy')==0:
            if FFX_ObjectGetAttr(char,'preventDrawback')==1:
                FFX_ObjectSetAttr(char,'preventDrawback',0)
                return
            if FFX_ObjectGetAttr(char,'energyWasFull')==0:
                FFX_ObjectSetAttr(char,'absorbed_energy',0)
                Object_SetSecondaryState(char,SCSTATE_IRRADIATED,10,0)
                newEnergy = energy - absorbed
                Object_SetAttr(char,'energyPoints',newEnergy)
                removeEnergyRedirectCmds(char)
            if FFX_ObjectGetAttr(char,'energyWasFull')==1:
                Object_SetSecondaryState(char,SCSTATE_IRRADIATED,10,0)
                newEnergy2 = energy - absorbed2
                Object_SetAttr(char,'energyPoints',newEnergy2)
                FFX_ObjectSetAttr(char,'absorbed_energy',0)
                FFX_ObjectSetAttr(char,'energyWasFull',0)
                removeEnergyRedirectCmds(char)
    if FFX_ObjectGetAttr(char,'absorbed_energy')==2:
        if FFX_ObjectGetAttr(char,'spent_energy')!=0:
            FFX_ObjectSetAttr(char,'absorbed_energy',1)
            FFX_ObjectSetAttr(char,'spent_energy',0)
            return
        else:
            Object_SetSecondaryState(char,SCSTATE_IRRADIATED,5,0)
            newEnergy = energy - absorbed
            FFX_ObjectSetAttr(char,'absorbed_energy',1)
            FFX_ObjectSetAttr(char,'absorbed_hits',0)
            FFX_ObjectSetAttr(char,'spent_energy',0)
            FFX_ObjectSetAttr(char,'energyFull',0)
            Object_SetAttr(char,'energyPoints',newEnergy)
    if FFX_ObjectGetAttr(char,'absorbed_energy')==3:
            Object_SetSecondaryState(char,SCSTATE_IRRADIATED,10,0)
            FFX_ObjectSetAttr(char,'absorbed_energy',0)
            FFX_ObjectSetAttr(char,'energyFull',0)
            newEnergy = energy - absorbed
            newEnergy2 = newEnergy - absorbed2
            absorbed3=FFX_ObjectGetAttr(char,'absorbed_intensity3')
            newEnergy3 = newEnergy2 - absorbed3
            Object_SetAttr(char,'energyPoints',newEnergy3)
            removeEnergyRedirectCmds(char)
    FFX_ObjectSetAttr(char,'ivlasteng',Object_GetAttr(char,'energyPoints'))

def erTakedamage(event):
    char=event.object
    absorbed=FFX_ObjectGetAttr(char,'absorbed_intensity')
    absorbed2=FFX_ObjectGetAttr(char,'absorbed_intensity2')
    absorbed_hits=FFX_ObjectGetAttr(char,'absorbed_hits')
    spentEnergy=FFX_ObjectGetAttr(char,'spent_energy')
    energyWasFull=FFX_ObjectGetAttr(char,'energyWasFull')
    energyFull=FFX_ObjectGetAttr(char,'energyFull')
    energy=Object_GetAttr(char,'energyPoints')
    if FFX_ObjectGetAttr(char,'absorbed_energy')==0:
        return
    if FFX_ObjectGetAttr(char,'absorbed_energy')==1:
        if FFX_ObjectGetAttr(char,'absorbed_hits')==1:
            FFX_ObjectSetAttr(char,'absorbed_energy',2)
            FFX_ObjectSetAttr(char,'spent_energy',0)
            return
        if FFX_ObjectGetAttr(char,'energyFull')==1:
            Trigger_Damage(char,randint(3,8))
            newEnergy2 = energy - absorbed2
            Object_SetAttr(char,'energyPoints',newEnergy2)
            FFX_ObjectSetAttr(char,'absorbed_energy',0)
            FFX_ObjectSetAttr(char,'energyFull',0)
            return
        if FFX_ObjectGetAttr(char,'spent_energy')!=0:
            FFX_ObjectSetAttr(char,'spent_energy',0)
            return
        if FFX_ObjectGetAttr(char,'spent_energy')==0:
            if FFX_ObjectGetAttr(char,'preventDrawback')==1:
                FFX_ObjectSetAttr(char,'preventDrawback',0)
                return
            if FFX_ObjectGetAttr(char,'energyWasFull')==0:
                FFX_ObjectSetAttr(char,'absorbed_energy',0)
                Trigger_Damage(char,randint(3,8))
                newEnergy = energy - absorbed
                Object_SetAttr(char,'energyPoints',newEnergy)
                removeEnergyRedirectCmds(char)
            if FFX_ObjectGetAttr(char,'energyWasFull')==1:
                Trigger_Damage(char,randint(3,8))
                newEnergy2 = energy - absorbed2
                Object_SetAttr(char,'energyPoints',newEnergy2)
                FFX_ObjectSetAttr(char,'absorbed_energy',0)
                FFX_ObjectSetAttr(char,'energyWasFull',0)
                removeEnergyRedirectCmds(char)
    if FFX_ObjectGetAttr(char,'absorbed_energy')==2:
        if FFX_ObjectGetAttr(char,'spent_energy')!=0:
            FFX_ObjectSetAttr(char,'absorbed_energy',1)
            FFX_ObjectSetAttr(char,'spent_energy',0)
            return
        else:
            Trigger_Damage(char,randint(3,8))
            newEnergy = energy - absorbed
            FFX_ObjectSetAttr(char,'absorbed_energy',1)
            FFX_ObjectSetAttr(char,'absorbed_hits',0)
            FFX_ObjectSetAttr(char,'spent_energy',0)
            FFX_ObjectSetAttr(char,'energyFull',0)
            Object_SetAttr(char,'energyPoints',newEnergy)
    if FFX_ObjectGetAttr(char,'absorbed_energy')==3:
            damage = absorbed + absorbed2
            Trigger_Damage(char,damage)
            FFX_ObjectSetAttr(char,'absorbed_energy',0)
            FFX_ObjectSetAttr(char,'energyFull',0)
            newEnergy = energy - absorbed
            newEnergy2 = newEnergy - absorbed2
            absorbed3=FFX_ObjectGetAttr(char,'absorbed_intensity3')
            newEnergy3 = newEnergy2 - absorbed3
            Object_SetAttr(char,'energyPoints',newEnergy3)
            removeEnergyRedirectCmds(char)
    FFX_ObjectSetAttr(char,'ivlasteng',Object_GetAttr(char,'energyPoints'))

####################### KINETIC ABSORBER #######################
def initkineticabsorber(char,update):
    if not update:
        Object_SetAttr(char,'kinetic_absorb',-1)
        Object_SetAttr(char,'absorbed_Kenergy',0)
        FFX_ObjectSetAttr(char,'absorbed_Kintensity',0)
        FFX_ObjectSetAttr(char,'kineticAbsorberBegin',1)
        base=Object_GetAttr(char,'maxEnergyPoints')
        Object_SetAttr(char,'maxEnergyPoints',2*base)
        FFX_ObjectSetAttr(char,'baseMaxEP',base)
        RegTimer('updatekineticabsorb',1,0,char)

def updatekineticabsorb(event):
    char=event.object
    if FFX_ObjectGetAttr(char,'kineticAbsorberBegin')==1:
        FFX_ObjectSetAttr(char,'ivlasteng',Object_GetAttr(char,'energyPoints'))
        FFX_ObjectSetAttr(char,'kineticAbsorberBegin',0)
    RegTimer('updatekineticabsorb',0.1,1,char)
    energy=Object_GetAttr(char,'energyPoints')
    energyRank=Object_GetAttr(char,'energy')+1
    maxEP=Object_GetAttr(char,'maxEnergyPoints')
    baseMaxEP=FFX_ObjectGetAttr(char,'baseMaxEP')+1
    absorbed_energy=FFX_ObjectGetAttr(char,'absorbed_Kenergy')
    spentEnergy=FFX_ObjectGetAttr(char,'spent_Kenergy')
    lastenergy = FFX_ObjectGetAttr(char,'ivlasteng')
    absorbed = energy - lastenergy
    myStr=Object_GetAttr(char,'strength')
    mybaseStr=Object_GetAttr(char,'baseStrength')
    if energy == maxEP: ## if a hero point is used
        Object_SetAttr(char,'energyPoints',maxEP/2)
        FFX_ObjectSetAttr(char,'ivlasteng',Object_GetAttr(char,'energyPoints'))
        return
    if FFX_ObjectGetAttr(char,'KZappedEnergy')==0:
        if (Object_GetClass(char)&OC_CONTROLLABLE)==0:
            energyStat=(0.4 + 0.6*RPG_GAME_DIFFICULTY)*energyRank
            energyStat=energyStat/10
        else:
            energyStat=energyRank*1.3
            energyStat=energyStat/10
    if (Object_GetSecondaryStates(char)&SCSTATE_AREA_ENERGIZED) or (Object_GetSecondaryStates(char)&SCSTATE_ENERGIZED):
        energyStat=energyStat*3
    if energy>=baseMaxEP:
        Object_SetAttr(char,'energy',0)
    else:
        Object_SetAttr(char,'energy',FFX_ObjectGetAttr(char,'baseEnergy'))
    if absorbed > energyStat:
        intensityModifier = (mybaseStr+1)*5
        intensity = absorbed/intensityModifier
        newStr = mybaseStr + intensity
        if newStr > 10:
            newStr = 10
        prevAbsorbed=FFX_ObjectGetAttr(char,'absorbed_Kintensity')
        totalAbsorbed = absorbed + prevAbsorbed
        FFX_ObjectSetAttr(char,'absorbed_Kintensity',totalAbsorbed)
        if FFX_ObjectGetAttr(char,'absorbed_Kenergy')==1:
            if newStr > myStr:
                Object_SetAttr(char,'strength',newStr)
        if FFX_ObjectGetAttr(char,'absorbed_Kenergy')==0:
            if newStr > myStr:
                Object_SetAttr(char,'strength',newStr)
                handle=Object_PlayEffect(char,getByTemplate(char,FFX_KINETICABSORBER_CUSTOM,1),'',FX_TRACK_OBJECT_FULL|FX_LOOP,0,'centre')
                Object_SetAttr(char,'kinetic_absorb',handle)
                FFX_ObjectSetAttr(char,'absorbed_Kenergy',1)
                FFX_ObjectSetAttr(char,'KenergyPts',Object_GetAttr(char,'energyPoints'))
                RegTimer(getByTemplate(char,FFX_KINETICABSORBER_CUSTOM,2),10,1,char)
                cmd=getByTemplate(char,FFX_KINETICABSORBER_CUSTOM,4)
                if cmd!='':
                    for obj in Mission_GetObjects():
                        if ((Object_GetClass(obj) & js.OC_TERRAIN)==0) & (obj!=char):
                            Mission_CustomAction(cmd,char,obj,'kinetic_energyRelease',30,0)
            if (Object_GetClass(char)&OC_CONTROLLABLE)==0:
                if FFX_ObjectGetAttr(char,'absorbed_Kenergy')==1:
                    timer=randint(1,11)
                    RegTimer('addKACmdsforAI',timer,0,char)
        str=Object_GetAttr(char,'strength')
        absorbed_energy=FFX_ObjectGetAttr(char,'absorbed_Kenergy')
        totalAbsorbed=FFX_ObjectGetAttr(char,'absorbed_Kintensity')
    FFX_ObjectSetAttr(char,'ivlasteng',Object_GetAttr(char,'energyPoints'))

def addKACmdsforAI(event):
    char=event.object
    target = m25ai.FindTarget(char)
    absorbed=FFX_ObjectGetAttr(char,'absorbed_Kintensity')
    spentEnergy=FFX_ObjectGetAttr(char,'spent_Kenergy')
    mybaseStr=Object_GetAttr(char,'baseStrength')
    myStr=Object_GetAttr(char,'strength')
    energy=Object_GetAttr(char,'energyPoints')
    absorbed_energy=FFX_ObjectGetAttr(char,'absorbed_Kenergy')
    if FFX_ObjectGetAttr(char,'absorbed_Kenergy')==0:
        return
    if (Object_GetPrimaryState(char)!=PCSTATE_NORMAL) | (Object_IsAlive(char)==0) | (ffx.FFX_ObjectGetAttr(char,'grappled',0)==1) | (ffx.FFX_ObjectGetAttr(char,'rangedgrappled',0)==1) | (ffx.FFX_ObjectGetAttr(char,'tangled',0)==1) | (ffx.FFX_ObjectGetAttr(char,'eTangled',0)==1) | (ffx.FFX_ObjectGetAttr(char,'thrownCharacter',0)==1):
        return
    if FFX_ObjectGetAttr(char,'absorbed_Kenergy')==1:
        m25ai.AIDoPower(char,getByTemplate(char,FFX_KINETICABSORBER_CUSTOM,5),target,priority=m25ai.TACTIC_PRIORITY_CRITICAL,time=3,description='using absorbed kinetic energy')
        Object_SetAttr(char,'kinetic_absorb',-1)
        Object_StopEffect(char,Object_GetAttr(char,'kinetic_absorb'))
        Object_SetAttr(char,'strength',mybaseStr)
        newEnergy = energy - absorbed
        Object_SetAttr(char,'energyPoints',newEnergy)
        FFX_ObjectSetAttr(char,'absorbed_Kenergy',0)
        FFX_ObjectSetAttr(char,'spent_Kenergy',1)
        FFX_ObjectSetAttr(char,'absorbed_Kintensity',0)
    FFX_ObjectSetAttr(char,'ivlasteng',Object_GetAttr(char,'energyPoints'))

def removeKineticEnergyCmds(char):
    cmd=getByTemplate(char,FFX_KINETICABSORBER_CUSTOM,4)
    for obj in Mission_GetObjects():
        Mission_RemoveCustomAction(cmd,char,obj)

def kinetic_energyRelease(obj,char):
    absorbed=FFX_ObjectGetAttr(char,'absorbed_Kintensity')
    spentEnergy=FFX_ObjectGetAttr(char,'spent_Kenergy')
    energy=Object_GetAttr(char,'energyPoints')
    mybaseStr=Object_GetAttr(char,'baseStrength')
    myStr=Object_GetAttr(char,'strength')
    absorbed_energy=FFX_ObjectGetAttr(char,'absorbed_Kenergy')
    if FFX_ObjectGetAttr(char,'absorbed_Kenergy')==1:
        Trigger_Power(char,obj,getByTemplate(char,FFX_KINETICABSORBER_CUSTOM,5),'')
        Object_SetAttr(char,'kinetic_absorb',-1)
        Object_StopEffect(char,Object_GetAttr(char,'kinetic_absorb'))
        Object_SetAttr(char,'strength',mybaseStr)
        newEnergy = energy - absorbed
        Object_SetAttr(char,'energyPoints',newEnergy)
        FFX_ObjectSetAttr(char,'absorbed_Kenergy',0)
        FFX_ObjectSetAttr(char,'spent_Kenergy',1)
        FFX_ObjectSetAttr(char,'absorbed_Kintensity',0)
        removeKineticEnergyCmds(char)
    FFX_ObjectSetAttr(char,'ivlasteng',Object_GetAttr(char,'energyPoints'))


def KProgressivedamage(event):
    char=event.object
    absorbed=FFX_ObjectGetAttr(char,'absorbed_Kintensity')
    spentEnergy=FFX_ObjectGetAttr(char,'spent_Kenergy')
    energy=Object_GetAttr(char,'energyPoints')
    mybaseStr=Object_GetAttr(char,'baseStrength')
    myStr=Object_GetAttr(char,'strength')
    if FFX_ObjectGetAttr(char,'absorbed_Kenergy')==0:
        removeKineticEnergyCmds(char)
        if FFX_ObjectGetAttr(char,'spent_Kenergy')!=0:
            FFX_ObjectSetAttr(char,'spent_Kenergy',0)
        return
    if FFX_ObjectGetAttr(char,'absorbed_Kenergy')==1:
        if FFX_ObjectGetAttr(char,'spent_Kenergy')!=0:
            FFX_ObjectSetAttr(char,'spent_Kenergy',0)
            return
        if FFX_ObjectGetAttr(char,'spent_Kenergy')==0:
            Trigger_Damage(char,randint(1,3))
            RegTimer(getByTemplate(char,FFX_KINETICABSORBER_CUSTOM,2),1,1,char)
    FFX_ObjectSetAttr(char,'ivlasteng',Object_GetAttr(char,'energyPoints'))

def KExplode(event):
    char=event.object
    absorbed=FFX_ObjectGetAttr(char,'absorbed_Kintensity')
    spentEnergy=FFX_ObjectGetAttr(char,'spent_Kenergy')
    energy=Object_GetAttr(char,'energyPoints')
    mybaseStr=Object_GetAttr(char,'baseStrength')
    myStr=Object_GetAttr(char,'strength')
    if FFX_ObjectGetAttr(char,'absorbed_Kenergy')==0:
        if FFX_ObjectGetAttr(char,'spent_Kenergy')!=0:
            FFX_ObjectSetAttr(char,'spent_Kenergy',0)
        return
    if FFX_ObjectGetAttr(char,'absorbed_Kenergy')==1:
        if FFX_ObjectGetAttr(char,'spent_Kenergy')!=0:
            FFX_ObjectSetAttr(char,'spent_Kenergy',0)
            return
        if FFX_ObjectGetAttr(char,'spent_Kenergy')==0:
            FFX_ObjectSetAttr(char,'absorbed_Kenergy',0)
            FFX_ObjectSetAttr(char,'absorbed_Kintensity',0)
            Trigger_Explosion(char,getByTemplate(char,FFX_KINETICABSORBER_CUSTOM,3))
            Object_SetAttr(char,'strength',mybaseStr)
            newEnergy = energy - absorbed
            Object_SetAttr(char,'energyPoints',newEnergy)
            removeKineticEnergyCmds(char)
    FFX_ObjectSetAttr(char,'ivlasteng',Object_GetAttr(char,'energyPoints'))

def KZapEnergy(event):
    char=event.object
    absorbed=FFX_ObjectGetAttr(char,'absorbed_Kintensity')
    spentEnergy=FFX_ObjectGetAttr(char,'spent_Kenergy')
    energy=Object_GetAttr(char,'energyPoints')
    mybaseStr=Object_GetAttr(char,'baseStrength')
    myStr=Object_GetAttr(char,'strength')
    if FFX_ObjectGetAttr(char,'absorbed_Kenergy')==0:
        FFX_ObjectSetAttr(char,'erZappedEnergy',0)
        if FFX_ObjectGetAttr(char,'spent_Kenergy')!=0:
            FFX_ObjectSetAttr(char,'spent_Kenergy',0)
        return
    if FFX_ObjectGetAttr(char,'absorbed_Kenergy')==1:
        if FFX_ObjectGetAttr(char,'spent_Kenergy')!=0:
            FFX_ObjectSetAttr(char,'spent_Kenergy',0)
            return
        if FFX_ObjectGetAttr(char,'spent_Kenergy')==0:
            FFX_ObjectSetAttr(char,'absorbed_Kenergy',0)
            FFX_ObjectSetAttr(char,'absorbed_Kintensity',0)
            if energyStat!=1:
                Object_SetAttr(char,'energyPoints',0)
                Object_SetAttr(char,'energy',1)
                FFX_ObjectSetAttr(char,'erZappedEnergy',1)
                RegTimer('unzapEnergy',10,0,char)
            if energyStat==1:
                Object_SetAttr(char,'energyPoints',0)
                FFX_ObjectSetAttr(char,'erZappedEnergy',1)
                RegTimer('unzapEnergy',10,0,char)
            Object_SetAttr(char,'strength',mybaseStr)
            newEnergy = energy - absorbed
            Object_SetAttr(char,'energyPoints',newEnergy)
            removeKineticEnergyCmds(char)
    FFX_ObjectSetAttr(char,'ivlasteng',Object_GetAttr(char,'energyPoints'))

def KStun(event):
    char=event.object
    absorbed=FFX_ObjectGetAttr(char,'absorbed_Kintensity')
    spentEnergy=FFX_ObjectGetAttr(char,'spent_Kenergy')
    energy=Object_GetAttr(char,'energyPoints')
    mybaseStr=Object_GetAttr(char,'baseStrength')
    myStr=Object_GetAttr(char,'strength')
    if FFX_ObjectGetAttr(char,'absorbed_Kenergy')==0:
        if FFX_ObjectGetAttr(char,'spent_Kenergy')!=0:
            FFX_ObjectSetAttr(char,'spent_Kenergy',0)
        return
    if FFX_ObjectGetAttr(char,'absorbed_Kenergy')==1:
        if FFX_ObjectGetAttr(char,'spent_Kenergy')!=0:
            FFX_ObjectSetAttr(char,'spent_Kenergy',0)
            return
        if FFX_ObjectGetAttr(char,'spent_Kenergy')==0:
            FFX_ObjectSetAttr(char,'absorbed_Kenergy',0)
            FFX_ObjectSetAttr(char,'absorbed_Kintensity',0)
            Object_SetPrimaryState(char,PCSTATE_STUNNED,10,0)
            Object_SetAttr(char,'strength',mybaseStr)
            newEnergy = energy - absorbed
            Object_SetAttr(char,'energyPoints',newEnergy)
            removeKineticEnergyCmds(char)
    FFX_ObjectSetAttr(char,'ivlasteng',Object_GetAttr(char,'energyPoints'))

def KHalfHealth(event):
    char=event.object
    absorbed=FFX_ObjectGetAttr(char,'absorbed_Kintensity')
    spentEnergy=FFX_ObjectGetAttr(char,'spent_Kenergy')
    energy=Object_GetAttr(char,'energyPoints')
    mybaseStr=Object_GetAttr(char,'baseStrength')
    myStr=Object_GetAttr(char,'strength')
    if FFX_ObjectGetAttr(char,'absorbed_Kenergy')==0:
        if FFX_ObjectGetAttr(char,'spent_Kenergy')!=0:
            FFX_ObjectSetAttr(char,'spent_Kenergy',0)
        return
    if FFX_ObjectGetAttr(char,'absorbed_Kenergy')==1:
        if FFX_ObjectGetAttr(char,'spent_Kenergy')!=0:
            FFX_ObjectSetAttr(char,'spent_Kenergy',0)
            return
        if FFX_ObjectGetAttr(char,'spent_Kenergy')==0:
            FFX_ObjectSetAttr(char,'absorbed_Kenergy',0)
            FFX_ObjectSetAttr(char,'absorbed_Kintensity',0)
            FFX_FactorHealth(char,0.5)
            Object_SetAttr(char,'strength',mybaseStr)
            newEnergy = energy - absorbed
            Object_SetAttr(char,'energyPoints',newEnergy)
            removeKineticEnergyCmds(char)
    FFX_ObjectSetAttr(char,'ivlasteng',Object_GetAttr(char,'energyPoints'))

def KIrradiate(event):
    char=event.object
    absorbed=FFX_ObjectGetAttr(char,'absorbed_Kintensity')
    spentEnergy=FFX_ObjectGetAttr(char,'spent_Kenergy')
    energy=Object_GetAttr(char,'energyPoints')
    mybaseStr=Object_GetAttr(char,'baseStrength')
    myStr=Object_GetAttr(char,'strength')
    if FFX_ObjectGetAttr(char,'absorbed_Kenergy')==0:
        if FFX_ObjectGetAttr(char,'spent_Kenergy')!=0:
            FFX_ObjectSetAttr(char,'spent_Kenergy',0)
        return
    if FFX_ObjectGetAttr(char,'absorbed_Kenergy')==1:
        if FFX_ObjectGetAttr(char,'spent_Kenergy')!=0:
            FFX_ObjectSetAttr(char,'spent_Kenergy',0)
            return
        if FFX_ObjectGetAttr(char,'spent_Kenergy')==0:
            FFX_ObjectSetAttr(char,'absorbed_Kenergy',0)
            FFX_ObjectSetAttr(char,'absorbed_Kintensity',0)
            Object_SetSecondaryState(char,SCSTATE_IRRADIATED,10,0)
            Object_SetAttr(char,'strength',mybaseStr)
            newEnergy = energy - absorbed
            Object_SetAttr(char,'energyPoints',newEnergy)
            removeKineticEnergyCmds(char)
    FFX_ObjectSetAttr(char,'ivlasteng',Object_GetAttr(char,'energyPoints'))

def KTakedamage(event):
    char=event.object
    absorbed=FFX_ObjectGetAttr(char,'absorbed_Kintensity')
    spentEnergy=FFX_ObjectGetAttr(char,'spent_Kenergy')
    energy=Object_GetAttr(char,'energyPoints')
    mybaseStr=Object_GetAttr(char,'baseStrength')
    myStr=Object_GetAttr(char,'strength')
    if FFX_ObjectGetAttr(char,'absorbed_Kenergy')==0:
        if FFX_ObjectGetAttr(char,'spent_Kenergy')!=0:
            FFX_ObjectSetAttr(char,'spent_Kenergy',0)
        return
    if FFX_ObjectGetAttr(char,'absorbed_Kenergy')==1:
        if FFX_ObjectGetAttr(char,'spent_Kenergy')!=0:
            FFX_ObjectSetAttr(char,'spent_Kenergy',0)
            return
        if FFX_ObjectGetAttr(char,'spent_Kenergy')==0:
            FFX_ObjectSetAttr(char,'absorbed_Kenergy',0)
            FFX_ObjectSetAttr(char,'absorbed_Kintensity',0)
            Trigger_Damage(char,randint(3,8))
            Object_SetAttr(char,'strength',mybaseStr)
            newEnergy = energy - absorbed
            Object_SetAttr(char,'energyPoints',newEnergy)
            removeKineticEnergyCmds(char)
    FFX_ObjectSetAttr(char,'ivlasteng',Object_GetAttr(char,'energyPoints'))


#################### FF Active Defense ###################################

def initffactivedefense10(char,update=0):
    if isMP():
        return
    FFX_ObjectSetAttr(char,'ffactivedefense',0)
    FFX_ObjectSetAttr(char,'ffactivedefenseMaxHP',10)
    if update==0:
        remote=getByTemplate(char,FFX_FFACTIVEDEFENSE_CUSTOM,6)
        if remote != 'Remote Only':
            addCommandChars('%s_SELF'%getByTemplate(char,FFX_FFACTIVEDEFENSE_CUSTOM,1),char,'OnffActiveDefenseSelf',100,update)
        if remote == 'No Remote':
            return
        else:
            addCommandChars('%s_REMOTE'%getByTemplate(char,FFX_FFACTIVEDEFENSE_CUSTOM,1),char,'OnffActiveDefense',30,update,char)

def initffactivedefense20(char,update=0):
    if isMP():
        return
    FFX_ObjectSetAttr(char,'ffactivedefense',0)
    FFX_ObjectSetAttr(char,'ffactivedefenseMaxHP',20)
    if update==0:
        remote=getByTemplate(char,FFX_FFACTIVEDEFENSE_CUSTOM,6)
        if remote != 'Remote Only':
            addCommandChars('%s_SELF'%getByTemplate(char,FFX_FFACTIVEDEFENSE_CUSTOM,1),char,'OnffActiveDefenseSelf',100,update)
        if remote == 'No Remote':
            return
        else:
            addCommandChars('%s_REMOTE'%getByTemplate(char,FFX_FFACTIVEDEFENSE_CUSTOM,1),char,'OnffActiveDefense',30,update,char)

def initffactivedefense35(char,update=0):
    if isMP():
        return
    FFX_ObjectSetAttr(char,'ffactivedefense',0)
    FFX_ObjectSetAttr(char,'ffactivedefenseMaxHP',35)
    if update==0:
        remote=getByTemplate(char,FFX_FFACTIVEDEFENSE_CUSTOM,6)
        if remote != 'Remote Only':
            addCommandChars('%s_SELF'%getByTemplate(char,FFX_FFACTIVEDEFENSE_CUSTOM,1),char,'OnffActiveDefenseSelf',100,update)
        if remote == 'No Remote':
            return
        else:
            addCommandChars('%s_REMOTE'%getByTemplate(char,FFX_FFACTIVEDEFENSE_CUSTOM,1),char,'OnffActiveDefense',30,update,char)

def initffactivedefense50(char,update=0):
    if isMP():
        return
    FFX_ObjectSetAttr(char,'ffactivedefense',0)
    FFX_ObjectSetAttr(char,'ffactivedefenseMaxHP',50)
    if update==0:
        remote=getByTemplate(char,FFX_FFACTIVEDEFENSE_CUSTOM,6)
        if remote != 'Remote Only':
            addCommandChars('%s_SELF'%getByTemplate(char,FFX_FFACTIVEDEFENSE_CUSTOM,1),char,'OnffActiveDefenseSelf',100,update)
        if remote == 'No Remote':
            return
        else:
            addCommandChars('%s_REMOTE'%getByTemplate(char,FFX_FFACTIVEDEFENSE_CUSTOM,1),char,'OnffActiveDefense',30,update,char)

def OnffActiveDefenseSelf(target,char):
    FFX_ObjectSetAttr(char,'ffactivedefenseSelf',1)
    OnffActiveDefense(char,char)

def OnffActiveDefense(target,char):
    power=getByTemplate(char,FFX_FFACTIVEDEFENSE_CUSTOM,2)
    epCost=getByTemplate(char,FFX_FFACTIVEDEFENSE_CUSTOM,7)
    if not hasAttribute(target,'energytanks') or hasAttribute(target,'volatilestorage') or hasAttribute(target,'energyredirector'):
        powers = datfiles.Campaign_ReadPowers()
        pdata=powers[power]
        if pdata['BlockType'] == datfiles.PT_BLOCK_TYPE_ABSORB:
            base=Object_GetAttr(target,'maxEnergyPoints')
            Object_SetAttr(target,'maxEnergyPoints',2*base)
            FFX_ObjectSetAttr(target,'baseMaxEP',base)
            FFX_ObjectSetAttr(target,'ffactivedefenseAbsorb',1)
    if chargeEP(char,epCost)==0:
        if FFX_ObjectGetAttr(target,'ffactivedefenseAbsorb',0)==1:
            Object_SetAttr(target,'maxEnergyPoints',base)
            FFX_ObjectSetAttr(target,'ffactivedefenseAbsorb',0)
        return
    hp=FFX_ObjectGetAttr(char,'ffactivedefenseMaxHP')
    anim=pdata['animation']
    duration=getByTemplate(char,FFX_FFACTIVEDEFENSE_CUSTOM,3)
    regenerate=getByTemplate(char,FFX_FFACTIVEDEFENSE_CUSTOM,5)
    lock=getByTemplate(char,FFX_FFACTIVEDEFENSE_CUSTOM,8)
    animtime=m25generateai.GetAnimationTime(char,anim)
    locktime=getByTemplate(char,FFX_FFACTIVEDEFENSE_CUSTOM,9)
    FFX_ObjectSetAttr(target,'ffactivedefenseHP',hp)
    FFX_ObjectSetAttr(target,'ffactivedefenseMaxHP',hp)
    FFX_ObjectSetAttr(target,'ffADduration',duration)
    FFX_ObjectSetAttr(target,'ffactivedefense',1)
    m25ai.AddRole(target,'active_defense')
    if FFX_ObjectGetAttr(target,'ffactivedefenseAbsorb',0)==1:
        ffADsetLastEnergy(char,target)
    hasPortrait=ffx.FFX_HasPortrait(char)
    pcAIEnabled=m25ai.AIInWatch(char)
    if pcAIEnabled or not hasPortrait:
        m25ai.AIDisable(char)
    if lock == 'Yes':
        RegTimer('ffADlock',locktime,0,char)
        mlogreader.regFlailStart(char,'cancelffADevent',0,0,0)
        RegTimer('ffADrestoreAI',duration,0,char)
    else:
        RegTimer('ffADrestoreAI',animtime,0,char)
    RegTimer('ffADStateCheck',1,0,char,target)
    RegTimer('ffADpower',0.5,0,char,target)
    if char!=target:
        turnTo(char,target)

def ffADStateCheck(event):
    char=event.object
    target=event.string
    if (Object_GetPrimaryState(char)!=PCSTATE_NORMAL) | (Object_IsAlive(char)==0) | (ffx.FFX_ObjectGetAttr(char,'grappled',0)==1) | (ffx.FFX_ObjectGetAttr(char,'rangedgrappled',0)==1) | (ffx.FFX_ObjectGetAttr(char,'tangled',0)==1) | (ffx.FFX_ObjectGetAttr(char,'eTangled',0)==1) | (ffx.FFX_ObjectGetAttr(char,'thrownCharacter',0)==1):
        cancelffAD(target,char)
        return
    RegTimer('ffADStateCheck',1,0,char,target)

def ffADpower(event):
    char=event.object
    target=event.string
    if FFX_ObjectGetAttr(target,'ffactivedefense')==0:
        return
    power=getByTemplate(char,FFX_FFACTIVEDEFENSE_CUSTOM,2)
    duration=getByTemplate(char,FFX_FFACTIVEDEFENSE_CUSTOM,3)
    moveable=getByTemplate(char,FFX_FFACTIVEDEFENSE_CUSTOM,4)
    regenerate=getByTemplate(char,FFX_FFACTIVEDEFENSE_CUSTOM,5)
    if char==target:
        if usingM25AI():
            m25ai.AISupport_DoSelfPowerTimed(char, power, char, m25ai.TACTIC_PRIORITY_CRITICAL, 1.0, desc='activating ffAD')
        else:
            Trigger_Power(char,char,power,'')
    else:
        Trigger_Power(char,target,power,'')
    if moveable == 'Not Moveable':
        pos=Get_ObjectPos(target)
        FFX_ObjectSetAttr(target,'lastY',pos[1])
        FFX_ObjectSetAttr(target,'lastX',pos[0])
        RegTimer('ffADmoveCheck',0.5,0,target,char)
    if regenerate == 'Regenerate':
        RegTimer('ffADregenerate',2,0,target)
    RegTimer('cancelffADevent',duration,0,target,char)

def ffADrestoreAI(event):
    char=event.object
    hasPortrait=ffx.FFX_HasPortrait(char)
    pcAIEnabled=m25ai.AIInWatch(char)
    if pcAIEnabled or not hasPortrait:
        if m25ai.IsAIDisabled(char):
            m25ai.ClearAIStandardOnly(char)
            m25ai.AIEnable(char)
            m25ai.AIEnableCustom(char)
            m25ai.SetBrawler(char)

def ffADsetLastEnergy(char,target):
    FFX_ObjectSetAttr(target,'ivlasteng',Object_GetAttr(target,'energyPoints'))
    ivlasteng=FFX_ObjectGetAttr(target,'ivlasteng')
    if ivlasteng < 0:
        FFX_ObjectSetAttr(target,'ivlasteng',0)
    RegTimer('ffADabsorbCheck',0.1,0,target,char)

def ffADlock(event):
    char=event.object
    flailing=mlogreader.MLOG_IsFlailing(char)
    if FFX_ObjectGetAttr(char,'ffactivedefense')==0:
        return
    if flailing:
        return
    AI_Animate(char,'lock')
    RegTimer('ffADlock',1,0,char)

def ffADabsorbCheck(event):
    char=event.object
    source=event.string
    if not Object_Exists(source):
        return
    if not Object_IsAlive(source):
        return
    energyRank=FFX_ObjectGetAttr(char,'baseEnergy')+1
    energy=Object_GetAttr(char,'energy')+1
    ep=Object_GetAttr(char,'energyPoints')
    lastEP = FFX_ObjectGetAttr(char,'ivlasteng')
    absorbed = ep - lastEP
    hp=FFX_ObjectGetAttr(char,'ffactivedefenseHP')
    maxEP=Object_GetAttr(char,'maxEnergyPoints')
    baseMaxEP=FFX_ObjectGetAttr(char,'baseMaxEP')
    if ep == maxEP:## if a hero point is used
        Object_SetAttr(char,'energyPoints',maxEP/2)
        FFX_ObjectSetAttr(char,'ivlasteng',Object_GetAttr(char,'energyPoints'))
        return
    if not hasAttribute(char,'energytanks') or  not hasAttribute(char,'volatilestorage') or not hasAttribute(char,'energyredirector'):
        if (Object_GetClass(char)&OC_CONTROLLABLE)!=0:
            energyRecharge=energy*1.3
            energyRecharge=energyRecharge/10
        else:
            #energyRecharge=(0.226 + 0.2244*RPG_GAME_DIFFICULTY)*energy
            energyRecharge=(0.4 + 0.6*RPG_GAME_DIFFICULTY)*energyRank
            energyRecharge=energyRecharge/10
        if ep>=baseMaxEP:
            if FFX_ObjectGetAttr(char,'ffactivedefense')!=0:
                Object_SetAttr(char,'energy',0)
        else:
            Object_SetAttr(char,'energy',FFX_ObjectGetAttr(char,'baseEnergy'))
    if (Object_GetSecondaryStates(char)&SCSTATE_AREA_ENERGIZED) or (Object_GetSecondaryStates(char)&SCSTATE_ENERGIZED):
        energyRecharge=energyRecharge*2
    if absorbed > energyRecharge:
        if not hasAttribute(char,'energytanks') or  not hasAttribute(char,'volatilestorage') or not hasAttribute(char,'energyredirector'):
            energyreset=ep-absorbed
            Object_SetAttr(char,'energyPoints',energyreset)
        newHP=hp-absorbed
        if newHP <= 0:
            Mission_StatusText('Active Defense Failed!')
            adj=-1
            damage=newHP*adj
            Trigger_Damage(char,damage)
            cancelffAD(char,source)
            return
        else:
            FFX_ObjectSetAttr(char,'ffactivedefenseHP',newHP)
            FFX_ObjectSetAttr(char, 'roundedHP', int(round(newHP)))
            roundedHP=FFX_ObjectGetAttr(char, 'roundedHP')
            Mission_StatusText('%d hit points remaining in active defense'%(roundedHP))
    if FFX_ObjectGetAttr(char,'ffactivedefense')==0:
        return
    ep=Object_GetAttr(char,'energyPoints')
    FFX_ObjectSetAttr(char,'ivlasteng',ep)
    RegTimer('ffADabsorbCheck',0.1,1,char,source)

def ffADmoveCheck(event):
    char = event.object
    source = event.string
    if FFX_ObjectGetAttr(char,'ffactivedefense')==0:
        return
    pos=Get_ObjectPos(char)
    dist=(pos[0]-FFX_ObjectGetAttr(char,'lastX'),pos[1]-FFX_ObjectGetAttr(char,'lastY'),0)
    FFX_ObjectSetAttr(char,'lastY',pos[1])
    FFX_ObjectSetAttr(char,'lastX',pos[0])
    if (dist[0]*dist[0]+dist[1]*dist[1]) > 10:
        cancelffAD(char,source)
    else:
        RegTimer('ffADmoveCheck',1,0,char,source)

def ffADregenerate(event):
    char = event.object
    if FFX_ObjectGetAttr(char,'ffactivedefense')==0:
        return
    hp=FFX_ObjectGetAttr(char,'ffactivedefenseHP')
    maxHP=FFX_ObjectGetAttr(char,'ffactivedefenseMaxHP')
    RegTimer('ffADregenerate',2,0,char)
    if hp < maxHP:
        FFX_ObjectSetAttr(char,'ffactivedefenseHP',hp+1)
        if hp > maxHP:
            FFX_ObjectSetAttr(char,'ffactivedefenseHP',maxHP)
        FFX_ObjectSetAttr(char, 'roundedHP', int(round(FFX_ObjectGetAttr(char,'ffactivedefenseHP'))))
        roundedHP=FFX_ObjectGetAttr(char, 'roundedHP')
        Mission_StatusText('%d hit points regenerating!'%(roundedHP))

def cancelffADevent(event):
    char = event.object
    source = event.string
    if FFX_ObjectGetAttr(char,'ffactivedefense')==0:
        return
    cancelffAD(char,source)

def cancelffAD(char,source):
    if not Object_Exists(char):
        if FFX_ObjectGetAttr(char,'ffactivedefense')==0:
            return
    if not Object_IsAlive(char):
        if FFX_ObjectGetAttr(char,'ffactivedefense')==0:
            return
    if not Object_Exists(source):
        if FFX_ObjectGetAttr(char,'ffactivedefense')==0:
            return
    if not Object_IsAlive(source):
        if FFX_ObjectGetAttr(char,'ffactivedefense')==0:
            return
    if FFX_ObjectGetAttr(char,'ffactivedefenseAbsorb',0)==1:
        base=FFX_ObjectGetAttr(char,'baseMaxEP')
        baseEnergy=FFX_ObjectGetAttr(char,'baseEnergy')
        Object_SetAttr(char,'maxEnergyPoints',base)
        Object_SetAttr(char,'energy',baseEnergy)
        FFX_ObjectSetAttr(char,'ffactivedefenseAbsorb',0)
    power=getByTemplate(source,FFX_FFACTIVEDEFENSE_CUSTOM,2)
    lock=getByTemplate(source,FFX_FFACTIVEDEFENSE_CUSTOM,8)
    removeShield(char, duration = 1, fx = '')
    FFX_ObjectSetAttr(char,'ffactivedefense',0)
    m25ai.RemoveRole(char,'active_defense')
    FFX_ObjectSetAttr(char,'ffactivedefenseSelf',0)
    maxHP=FFX_ObjectGetAttr(source,'ffactivedefenseMaxHP')
    FFX_ObjectSetAttr(source,'ffactivedefenseHP',maxHP)
    if lock == 'Yes':
        AI_Animate(source, 'unlock')
        AI_Animate(source, 'melee_idle')


############################## BATTLE COMPUTER ########################################
# Allows the character to have a database of up to 5 characters. When the character
# is within range of one of these characters, they get +2 agility and two new commands
# that appear only on the target and can be used to simulate the character's existing
# powers but with higher accuracy, speed, magnitude, stun, etc.
# The character can also add targets to the database during a mission, filling empty
# slots or overwrite existing slots, at any time.
# -TaskmasterX
#######################################################################################

FFX_ADD_TARGET_TO_DB1 = 0
FFX_ADD_TARGET_TO_DB2 = 0
FFX_ADD_TARGET_TO_DB3 = 0
FFX_ADD_TARGET_TO_DB4 = 0
FFX_ADD_TARGET_TO_DB5 = 0

def initbattlecomputer(char,update):
    RegTimer('enemyCheck',0.1,0,char)
    FFX_ObjectSetAttr(char,'battleComputer',1)
    FFX_ObjectSetAttr(char,'BCaglBonus',0)
    objects = Mission_GetDynamicObjects()
    for obj in objects:
        if ((Object_GetClass(obj)&FFX_CHARACTER)!=0) & (obj!=char):
            Mission_CustomAction('ADD_TARGET_TO_DATABASE',char,obj,'addToDBSlot',30,0)
            FFX_ObjectSetAttr(obj,'BCaddTargetCmd',1)

def addToDBSlot(obj,char):
    global FFX_ADD_TARGET_TO_DB1
    global FFX_ADD_TARGET_TO_DB2
    global FFX_ADD_TARGET_TO_DB3
    global FFX_ADD_TARGET_TO_DB4
    global FFX_ADD_TARGET_TO_DB5
    dbEntry1=getByTemplate(char,FFX_BATTLECOMPUTER_CUSTOM,1)
    dbEntry2=getByTemplate(char,FFX_BATTLECOMPUTER_CUSTOM,2)
    dbEntry3=getByTemplate(char,FFX_BATTLECOMPUTER_CUSTOM,3)
    dbEntry4=getByTemplate(char,FFX_BATTLECOMPUTER_CUSTOM,4)
    dbEntry5=getByTemplate(char,FFX_BATTLECOMPUTER_CUSTOM,5)
    target=getTargetname(obj)
    Mission_RemoveCustomAction('ADD_TARGET_TO_DATABASE',char,obj)
    if FFX_ADD_TARGET_TO_DB5 == 0:
        if dbEntry5!='':
            Mission_CustomAction('SLOT 5: %s'%getByTemplate(char,FFX_BATTLECOMPUTER_CUSTOM,5),char,obj,'studyTarget5',30,0)
        else:
            Mission_CustomAction('SLOT 5: ',char,obj,'studyTarget5',30,0)
    else:
        Mission_CustomAction('SLOT 5: %s'%FFX_ADD_TARGET_TO_DB5,char,obj,'studyTarget5',30,0)
    if FFX_ADD_TARGET_TO_DB4 == 0:
        if dbEntry4!='':
            Mission_CustomAction('SLOT 4: %s'%getByTemplate(char,FFX_BATTLECOMPUTER_CUSTOM,4),char,obj,'studyTarget4',30,0)
        else:
            Mission_CustomAction('SLOT 4: ',char,obj,'studyTarget4',30,0)
    else:
        Mission_CustomAction('SLOT 4: %s'%FFX_ADD_TARGET_TO_DB4,char,obj,'studyTarget4',30,0)
    if FFX_ADD_TARGET_TO_DB3 == 0:
        if dbEntry3!='':
            Mission_CustomAction('SLOT 3: %s'%getByTemplate(char,FFX_BATTLECOMPUTER_CUSTOM,3),char,obj,'studyTarget3',30,0)
        else:
            Mission_CustomAction('SLOT 3: ',char,obj,'studyTarget3',30,0)
    else:
        Mission_CustomAction('SLOT 3: %s'%FFX_ADD_TARGET_TO_DB3,char,obj,'studyTarget3',30,0)
    if FFX_ADD_TARGET_TO_DB2 == 0:
        if dbEntry2!='':
            Mission_CustomAction('SLOT 2: %s'%getByTemplate(char,FFX_BATTLECOMPUTER_CUSTOM,2),char,obj,'studyTarget2',30,0)
        else:
            Mission_CustomAction('SLOT 2: ',char,obj,'studyTarget2',30,0)
    else:
        Mission_CustomAction('SLOT 2: %s'%FFX_ADD_TARGET_TO_DB2,char,obj,'studyTarget2',30,0)
    if FFX_ADD_TARGET_TO_DB1 == 0:
        if dbEntry1!='':
            Mission_CustomAction('SLOT 1: %s'%getByTemplate(char,FFX_BATTLECOMPUTER_CUSTOM,1),char,obj,'studyTarget1',30,0)
        else:
            Mission_CustomAction('SLOT 1: ',char,obj,'studyTarget1',30,0)
    else:
        Mission_CustomAction('SLOT 1: %s'%FFX_ADD_TARGET_TO_DB1,char,obj,'studyTarget1',30,0)


def removeBCcmds(char,obj):
    global FFX_ADD_TARGET_TO_DB1
    global FFX_ADD_TARGET_TO_DB2
    global FFX_ADD_TARGET_TO_DB3
    global FFX_ADD_TARGET_TO_DB4
    global FFX_ADD_TARGET_TO_DB5
    Mission_RemoveCustomAction('SLOT 5: %s'%getByTemplate(char,FFX_BATTLECOMPUTER_CUSTOM,5),char,obj)
    Mission_RemoveCustomAction('SLOT 5: ',char,obj)
    Mission_RemoveCustomAction('SLOT 5: %s'%FFX_ADD_TARGET_TO_DB5,char,obj)
    Mission_RemoveCustomAction('SLOT 4: %s'%getByTemplate(char,FFX_BATTLECOMPUTER_CUSTOM,4),char,obj)
    Mission_RemoveCustomAction('SLOT 4: ',char,obj)
    Mission_RemoveCustomAction('SLOT 4: %s'%FFX_ADD_TARGET_TO_DB4,char,obj)
    Mission_RemoveCustomAction('SLOT 3: %s'%getByTemplate(char,FFX_BATTLECOMPUTER_CUSTOM,3),char,obj)
    Mission_RemoveCustomAction('SLOT 3: ',char,obj)
    Mission_RemoveCustomAction('SLOT 3: %s'%FFX_ADD_TARGET_TO_DB3,char,obj)
    Mission_RemoveCustomAction('SLOT 2: %s'%getByTemplate(char,FFX_BATTLECOMPUTER_CUSTOM,2),char,obj)
    Mission_RemoveCustomAction('SLOT 2: ',char,obj)
    Mission_RemoveCustomAction('SLOT 2: %s'%FFX_ADD_TARGET_TO_DB2,char,obj)
    Mission_RemoveCustomAction('SLOT 1: %s'%getByTemplate(char,FFX_BATTLECOMPUTER_CUSTOM,1),char,obj)
    Mission_RemoveCustomAction('SLOT 1: ',char,obj)
    Mission_RemoveCustomAction('SLOT 1: %s'%FFX_ADD_TARGET_TO_DB1,char,obj)


def studyTarget1(obj,char):
    global FFX_ADD_TARGET_TO_DB1
    global FFX_BC_DB1
    target=getTargetname(obj)
    dbEntry1=getByTemplate(char,FFX_BATTLECOMPUTER_CUSTOM,1)
    if FFX_ADD_TARGET_TO_DB1 != 0:
        Mission_RemoveCustomAction('SLOT 1: %s'%FFX_ADD_TARGET_TO_DB1,char,obj)
        FFX_ADD_TARGET_TO_DB1 = 0
        oldTarget = FFX_BC_DB1
        FFX_ObjectSetAttr(oldTarget,'bcRunning',0)
        FFX_ObjectSetAttr(oldTarget,'addedToDB',0)
        FFX_ObjectSetAttr(oldTarget,'wasAddedToDB',1)
        Mission_CustomAction('ADD_TARGET_TO_DATABASE',char,oldTarget,'addToDBSlot',30,0)
        d=distanceSq(oldTarget,char)
        radius=getByTemplate(char,FFX_BATTLECOMPUTER_CUSTOM,6)
        radius2=radius*radius
        if d < radius2:
            cmd1=getByTemplate(char,FFX_BATTLECOMPUTER_CUSTOM,7)
            cmd2=getByTemplate(char,FFX_BATTLECOMPUTER_CUSTOM,9)
            Mission_RemoveCustomAction(cmd1,char,oldTarget)
            Mission_RemoveCustomAction(cmd2,char,oldTarget)
            aglBonus=FFX_ObjectGetAttr(char,'BCaglBonus')-1
            if aglBonus<=0:
                agility=Object_GetAttr(char,'templateAgility')
                Object_SetAttr(char,'agility',agility)
            newAgility=Object_GetAttr(char,'agility')
            FFX_ObjectSetAttr(char,'BCaglBonus',aglBonus)
    elif dbEntry1 != '':
        Mission_RemoveCustomAction('SLOT 1: %s'%getByTemplate(char,FFX_BATTLECOMPUTER_CUSTOM,1),char,obj)
        for object in Mission_GetDynamicObjects():
            if ((Object_GetClass(object)&FFX_CHARACTER)!=0) & (object!=char):
                oldtarget=getTargetname(object)
                if dbEntry1==oldtarget:
                    FFX_ObjectSetAttr(object,'bcRunning',0)
                    FFX_ObjectSetAttr(object,'addedToDB',0)
                    FFX_ObjectSetAttr(object,'wasAddedToDB',1)
                    Mission_CustomAction('ADD_TARGET_TO_DATABASE',char,object,'addToDBSlot',30,0)
                    d=distanceSq(object,char)
                    radius=getByTemplate(char,FFX_BATTLECOMPUTER_CUSTOM,6)
                    radius2=radius*radius
                    if d < radius2:
                        cmd1=getByTemplate(char,FFX_BATTLECOMPUTER_CUSTOM,7)
                        cmd2=getByTemplate(char,FFX_BATTLECOMPUTER_CUSTOM,9)
                        Mission_RemoveCustomAction(cmd1,char,object)
                        Mission_RemoveCustomAction(cmd2,char,object)
                        aglBonus=FFX_ObjectGetAttr(char,'BCaglBonus')-1
                        if aglBonus<=0:
                            agility=Object_GetAttr(char,'templateAgility')
                            Object_SetAttr(char,'agility',agility)
                        newAgility=Object_GetAttr(char,'agility')
                        FFX_ObjectSetAttr(char,'BCaglBonus',aglBonus)
    FFX_ObjectSetAttr(obj,'dbSlot',1)
    studyTarget(obj,char)

def studyTarget2(obj,char):
    global FFX_ADD_TARGET_TO_DB2
    global FFX_BC_DB2
    target=getTargetname(obj)
    dbEntry2=getByTemplate(char,FFX_BATTLECOMPUTER_CUSTOM,2)
    if FFX_ADD_TARGET_TO_DB2 != 0:
        Mission_RemoveCustomAction('SLOT 2: %s'%FFX_ADD_TARGET_TO_DB2,char,obj)
        FFX_ADD_TARGET_TO_DB2 = 0
        oldTarget = FFX_BC_DB2
        FFX_ObjectSetAttr(oldTarget,'bcRunning',0)
        FFX_ObjectSetAttr(oldTarget,'addedToDB',0)
        FFX_ObjectSetAttr(oldTarget,'wasAddedToDB',1)
        Mission_CustomAction('ADD_TARGET_TO_DATABASE',char,oldTarget,'addToDBSlot',30,0)
        d=distanceSq(oldTarget,char)
        radius=getByTemplate(char,FFX_BATTLECOMPUTER_CUSTOM,6)
        radius2=radius*radius
        if d < radius2:
            cmd1=getByTemplate(char,FFX_BATTLECOMPUTER_CUSTOM,7)
            cmd2=getByTemplate(char,FFX_BATTLECOMPUTER_CUSTOM,9)
            Mission_RemoveCustomAction(cmd1,char,oldTarget)
            Mission_RemoveCustomAction(cmd2,char,oldTarget)
            aglBonus=FFX_ObjectGetAttr(char,'BCaglBonus')-1
            if aglBonus<=0:
                agility=Object_GetAttr(char,'templateAgility')
                Object_SetAttr(char,'agility',agility)
            newAgility=Object_GetAttr(char,'agility')
            FFX_ObjectSetAttr(char,'BCaglBonus',aglBonus)
    elif dbEntry2 != '':
        Mission_RemoveCustomAction('SLOT 2: %s'%getByTemplate(char,FFX_BATTLECOMPUTER_CUSTOM,2),char,obj)
        for object in Mission_GetDynamicObjects():
            if ((Object_GetClass(object)&FFX_CHARACTER)!=0) & (object!=char):
                oldtarget=getTargetname(object)
                if dbEntry2==oldtarget:
                    FFX_ObjectSetAttr(object,'bcRunning',0)
                    FFX_ObjectSetAttr(object,'addedToDB',0)
                    FFX_ObjectSetAttr(object,'wasAddedToDB',1)
                    Mission_CustomAction('ADD_TARGET_TO_DATABASE',char,object,'addToDBSlot',30,0)
                    d=distanceSq(object,char)
                    radius=getByTemplate(char,FFX_BATTLECOMPUTER_CUSTOM,6)
                    radius2=radius*radius
                    if d < radius2:
                        cmd1=getByTemplate(char,FFX_BATTLECOMPUTER_CUSTOM,7)
                        cmd2=getByTemplate(char,FFX_BATTLECOMPUTER_CUSTOM,9)
                        Mission_RemoveCustomAction(cmd1,char,object)
                        Mission_RemoveCustomAction(cmd2,char,object)
                        aglBonus=FFX_ObjectGetAttr(char,'BCaglBonus')-1
                        if aglBonus<=0:
                            agility=Object_GetAttr(char,'templateAgility')
                            Object_SetAttr(char,'agility',agility)
                        newAgility=Object_GetAttr(char,'agility')
                        FFX_ObjectSetAttr(char,'BCaglBonus',aglBonus)
    FFX_ObjectSetAttr(obj,'dbSlot',2)
    studyTarget(obj,char)

def studyTarget3(obj,char):
    global FFX_ADD_TARGET_TO_DB3
    global FFX_BC_DB3
    target=getTargetname(obj)
    dbEntry3=getByTemplate(char,FFX_BATTLECOMPUTER_CUSTOM,3)
    if FFX_ADD_TARGET_TO_DB3 != 0:
        Mission_RemoveCustomAction('SLOT 3: %s'%FFX_ADD_TARGET_TO_DB3,char,obj)
        FFX_ADD_TARGET_TO_DB3 = 0
        oldTarget = FFX_BC_DB3
        FFX_ObjectSetAttr(oldTarget,'bcRunning',0)
        FFX_ObjectSetAttr(oldTarget,'addedToDB',0)
        FFX_ObjectSetAttr(oldTarget,'wasAddedToDB',1)
        Mission_CustomAction('ADD_TARGET_TO_DATABASE',char,oldTarget,'addToDBSlot',30,0)
        d=distanceSq(oldTarget,char)
        radius=getByTemplate(char,FFX_BATTLECOMPUTER_CUSTOM,6)
        radius2=radius*radius
        if d < radius2:
            cmd1=getByTemplate(char,FFX_BATTLECOMPUTER_CUSTOM,7)
            cmd2=getByTemplate(char,FFX_BATTLECOMPUTER_CUSTOM,9)
            Mission_RemoveCustomAction(cmd1,char,oldTarget)
            Mission_RemoveCustomAction(cmd2,char,oldTarget)
            aglBonus=FFX_ObjectGetAttr(char,'BCaglBonus')-1
            if aglBonus<=0:
                agility=Object_GetAttr(char,'templateAgility')
                Object_SetAttr(char,'agility',agility)
            newAgility=Object_GetAttr(char,'agility')
            FFX_ObjectSetAttr(char,'BCaglBonus',aglBonus)
    elif dbEntry3 != '':
        Mission_RemoveCustomAction('SLOT 3: %s'%getByTemplate(char,FFX_BATTLECOMPUTER_CUSTOM,3),char,obj)
        for object in Mission_GetDynamicObjects():
            if ((Object_GetClass(object)&FFX_CHARACTER)!=0) & (object!=char):
                oldtarget=getTargetname(object)
                if dbEntry3==oldtarget:
                    FFX_ObjectSetAttr(object,'bcRunning',0)
                    FFX_ObjectSetAttr(object,'addedToDB',0)
                    FFX_ObjectSetAttr(object,'wasAddedToDB',1)
                    Mission_CustomAction('ADD_TARGET_TO_DATABASE',char,object,'addToDBSlot',30,0)
                    d=distanceSq(object,char)
                    radius=getByTemplate(char,FFX_BATTLECOMPUTER_CUSTOM,6)
                    radius2=radius*radius
                    if d < radius2:
                        cmd1=getByTemplate(char,FFX_BATTLECOMPUTER_CUSTOM,7)
                        cmd2=getByTemplate(char,FFX_BATTLECOMPUTER_CUSTOM,9)
                        Mission_RemoveCustomAction(cmd1,char,object)
                        Mission_RemoveCustomAction(cmd2,char,object)
                        aglBonus=FFX_ObjectGetAttr(char,'BCaglBonus')-1
                        if aglBonus<=0:
                            agility=Object_GetAttr(char,'templateAgility')
                            Object_SetAttr(char,'agility',agility)
                        newAgility=Object_GetAttr(char,'agility')
                        FFX_ObjectSetAttr(char,'BCaglBonus',aglBonus)
    FFX_ObjectSetAttr(obj,'dbSlot',3)
    studyTarget(obj,char)

def studyTarget4(obj,char):
    global FFX_ADD_TARGET_TO_DB4
    global FFX_BC_DB4
    target=getTargetname(obj)
    dbEntry4=getByTemplate(char,FFX_BATTLECOMPUTER_CUSTOM,4)
    if FFX_ADD_TARGET_TO_DB4 != 0:
        Mission_RemoveCustomAction('SLOT 4: %s'%FFX_ADD_TARGET_TO_DB4,char,obj)
        FFX_ADD_TARGET_TO_DB4 = 0
        oldTarget = FFX_BC_DB4
        FFX_ObjectSetAttr(oldTarget,'bcRunning',0)
        FFX_ObjectSetAttr(oldTarget,'addedToDB',0)
        FFX_ObjectSetAttr(oldTarget,'wasAddedToDB',1)
        Mission_CustomAction('ADD_TARGET_TO_DATABASE',char,oldTarget,'addToDBSlot',30,0)
        d=distanceSq(oldTarget,char)
        radius=getByTemplate(char,FFX_BATTLECOMPUTER_CUSTOM,6)
        radius2=radius*radius
        if d < radius2:
            cmd1=getByTemplate(char,FFX_BATTLECOMPUTER_CUSTOM,7)
            cmd2=getByTemplate(char,FFX_BATTLECOMPUTER_CUSTOM,9)
            Mission_RemoveCustomAction(cmd1,char,oldTarget)
            Mission_RemoveCustomAction(cmd2,char,oldTarget)
            aglBonus=FFX_ObjectGetAttr(char,'BCaglBonus')-1
            if aglBonus<=0:
                agility=Object_GetAttr(char,'templateAgility')
                Object_SetAttr(char,'agility',agility)
            newAgility=Object_GetAttr(char,'agility')
            FFX_ObjectSetAttr(char,'BCaglBonus',aglBonus)
    elif dbEntry4 != '':
        Mission_RemoveCustomAction('SLOT 4: %s'%getByTemplate(char,FFX_BATTLECOMPUTER_CUSTOM,4),char,obj)
        for object in Mission_GetDynamicObjects():
            if ((Object_GetClass(object)&FFX_CHARACTER)!=0) & (object!=char):
                oldtarget=getTargetname(object)
                if dbEntry4==oldtarget:
                    FFX_ObjectSetAttr(object,'bcRunning',0)
                    FFX_ObjectSetAttr(object,'addedToDB',0)
                    FFX_ObjectSetAttr(object,'wasAddedToDB',1)
                    Mission_CustomAction('ADD_TARGET_TO_DATABASE',char,object,'addToDBSlot',30,0)
                    d=distanceSq(object,char)
                    radius=getByTemplate(char,FFX_BATTLECOMPUTER_CUSTOM,6)
                    radius2=radius*radius
                    if d < radius2:
                        cmd1=getByTemplate(char,FFX_BATTLECOMPUTER_CUSTOM,7)
                        cmd2=getByTemplate(char,FFX_BATTLECOMPUTER_CUSTOM,9)
                        Mission_RemoveCustomAction(cmd1,char,object)
                        Mission_RemoveCustomAction(cmd2,char,object)
                        aglBonus=FFX_ObjectGetAttr(char,'BCaglBonus')-1
                        if aglBonus<=0:
                            agility=Object_GetAttr(char,'templateAgility')
                            Object_SetAttr(char,'agility',agility)
                        newAgility=Object_GetAttr(char,'agility')
                        FFX_ObjectSetAttr(char,'BCaglBonus',aglBonus)
    FFX_ObjectSetAttr(obj,'dbSlot',4)
    studyTarget(obj,char)

def studyTarget5(obj,char):
    global FFX_ADD_TARGET_TO_DB5
    target=getTargetname(obj)
    dbEntry5=getByTemplate(char,FFX_BATTLECOMPUTER_CUSTOM,5)
    if FFX_ADD_TARGET_TO_DB5 != 0:
        Mission_RemoveCustomAction('SLOT 5: %s'%FFX_ADD_TARGET_TO_DB5,char,obj)
        FFX_ADD_TARGET_TO_DB5 = 0
        oldTarget = FFX_BC_DB5
        FFX_ObjectSetAttr(oldTarget,'bcRunning',0)
        FFX_ObjectSetAttr(oldTarget,'addedToDB',0)
        FFX_ObjectSetAttr(oldTarget,'wasAddedToDB',1)
        Mission_CustomAction('ADD_TARGET_TO_DATABASE',char,oldTarget,'addToDBSlot',30,0)
        d=distanceSq(oldTarget,char)
        radius=getByTemplate(char,FFX_BATTLECOMPUTER_CUSTOM,6)
        radius2=radius*radius
        if d < radius2:
            cmd1=getByTemplate(char,FFX_BATTLECOMPUTER_CUSTOM,7)
            cmd2=getByTemplate(char,FFX_BATTLECOMPUTER_CUSTOM,9)
            Mission_RemoveCustomAction(cmd1,char,oldTarget)
            Mission_RemoveCustomAction(cmd2,char,oldTarget)
            aglBonus=FFX_ObjectGetAttr(char,'BCaglBonus')-1
            if aglBonus<=0:
                agility=Object_GetAttr(char,'templateAgility')
                Object_SetAttr(char,'agility',agility)
            newAgility=Object_GetAttr(char,'agility')
            FFX_ObjectSetAttr(char,'BCaglBonus',aglBonus)
    elif dbEntry5 != '':
        Mission_RemoveCustomAction('SLOT 5: %s'%getByTemplate(char,FFX_BATTLECOMPUTER_CUSTOM,5),char,obj)
        for object in Mission_GetDynamicObjects():
            if ((Object_GetClass(object)&FFX_CHARACTER)!=0) & (object!=char):
                oldtarget=getTargetname(object)
                if dbEntry5==oldtarget:
                    FFX_ObjectSetAttr(object,'bcRunning',0)
                    FFX_ObjectSetAttr(object,'addedToDB',0)
                    FFX_ObjectSetAttr(object,'wasAddedToDB',1)
                    Mission_CustomAction('ADD_TARGET_TO_DATABASE',char,object,'addToDBSlot',30,0)
                    d=distanceSq(object,char)
                    radius=getByTemplate(char,FFX_BATTLECOMPUTER_CUSTOM,6)
                    radius2=radius*radius
                    if d < radius2:
                        cmd1=getByTemplate(char,FFX_BATTLECOMPUTER_CUSTOM,7)
                        cmd2=getByTemplate(char,FFX_BATTLECOMPUTER_CUSTOM,9)
                        Mission_RemoveCustomAction(cmd1,char,object)
                        Mission_RemoveCustomAction(cmd2,char,object)
                        aglBonus=FFX_ObjectGetAttr(char,'BCaglBonus')-1
                        if aglBonus<=0:
                            agility=Object_GetAttr(char,'templateAgility')
                            Object_SetAttr(char,'agility',agility)
                        newAgility=Object_GetAttr(char,'agility')
                        FFX_ObjectSetAttr(char,'BCaglBonus',aglBonus)
    FFX_ObjectSetAttr(obj,'dbSlot',5)
    studyTarget(obj,char)

def studyTarget(obj,char):
    turnTo(char,obj)
    Mission_StatusText('adding target to Battle Computer...')
    removeBCcmds(char,obj)
    FFX_ObjectSetAttr(char,'addingToDB',1)
    FFX_ObjectSetAttr(obj,'addingToDB',1)
    RegTimer('checkRangeBC',1,0,char,obj)
    RegTimer('addTargettoDB',10,0,char,obj)
    FFX_ObjectSetAttr(char,'ivlasteng',Object_GetAttr(char,'energyPoints'))
    RegTimer('checkEnergyUseBC',1,0,char,obj)
    RegCharState(char,PCSTATE_BLANK,'battleComputerFail',0,0,obj)
    RegCharState(char,PCSTATE_EXILE,'battleComputerFail',0,0,obj)
    RegCharState(char,PCSTATE_STATIC,'battleComputerFail',0,0,obj)
    RegCharState(char,PCSTATE_ENRAGED,'battleComputerFail',0,0,obj)
    RegCharState(char,PCSTATE_HYPNOTISED,'battleComputerFail',0,0,obj)
    RegCharState(char,PCSTATE_PANICKED,'battleComputerFail',0,0,obj)
    RegCharState(char,PCSTATE_STUNNED,'battleComputerFail',0,0,obj)

def battleComputerFail(event):
    char=event.object
    obj=event.string
    if FFX_ObjectGetAttr(obj,'addedToDB',0)==1:
        return
    elif FFX_ObjectGetAttr(obj,'wasAddedToDB',0)==1:
        FFX_ObjectSetAttr(obj,'wasAddedToDB',0)
        return
    if FFX_ObjectGetAttr(obj,'addingToDBFailed',0)==1:
        return
    if FFX_ObjectGetAttr(char,'addingToDB',0)==1:
        Mission_StatusText('Battle Computer failed! try again')
        FFX_ObjectSetAttr(obj,'addingToDB',0)
        FFX_ObjectSetAttr(char,'addingToDB',0)
        FFX_ObjectSetAttr(obj,'addingToDBFailed',1)
        Mission_CustomAction('ADD_TARGET_TO_DATABASE',char,obj,'addToDBSlot',30,0)

def checkEnergyUseBC(event):
    char=event.object
    obj=event.string
    if Object_IsAlive(obj)==0:
        return
    if Object_IsAlive(char)==0:
        return
    if FFX_ObjectGetAttr(obj,'addingToDBFailed')==1:
        return
    if FFX_ObjectGetAttr(obj,'addedToDB')==1:
        return
#    if FFX_ObjectGetAttr(char,'battleComputer')==1:
#        FFX_ObjectSetAttr(char,'ivlasteng',Object_GetAttr(char,'energyPoints'))
#        FFX_ObjectSetAttr(char,'battleComputer',0)
    energy=Object_GetAttr(char,'energyPoints')
    lastenergy = FFX_ObjectGetAttr(char,'ivlasteng')
    if energy<lastenergy:
        if FFX_ObjectGetAttr(obj,'addingToDB')!=0:
            Mission_StatusText('you used energy the Battle Computer needs! try again!')
            FFX_ObjectSetAttr(obj,'addingToDB',0)
            FFX_ObjectSetAttr(char,'addingToDB',0)
            FFX_ObjectSetAttr(obj,'addingToDBFailed',1)
            Mission_CustomAction('ADD_TARGET_TO_DATABASE',char,obj,'addToDBSlot',30,0)
    else:
        RegTimer('checkEnergyUseBC',0.1,0,char,obj)
    FFX_ObjectSetAttr(char,'ivlasteng',Object_GetAttr(char,'energyPoints'))

def checkRangeBC(event):
    char=event.object
    obj=event.string
    if Object_IsAlive(obj)==0:
        return
    if Object_IsAlive(char)==0:
        return
    if FFX_ObjectGetAttr(obj,'addingToDBFailed')==1:
        return
    pos1 = Get_ObjectPos(char)
    pos2 = Get_ObjectPos(obj)
    dist = cshelper.distance2D(pos1, pos2)
    radius=getByTemplate(char,FFX_BATTLECOMPUTER_CUSTOM,6)
    if FFX_ObjectGetAttr(obj,'addedToDB')==1:
        return
    if dist > radius:
        if FFX_ObjectGetAttr(obj,'addingToDB')!=0:
            Mission_StatusText('target is out of range and can not be added to Battle Computer! try again!')
            FFX_ObjectSetAttr(obj,'addingToDB',0)
            FFX_ObjectSetAttr(char,'addingToDB',0)
            FFX_ObjectSetAttr(obj,'addingToDBFailed',1)
            Mission_CustomAction('ADD_TARGET_TO_DATABASE',char,obj,'addToDBSlot',30,0)
    if dist < radius:
        RegTimer('checkRangeBC',1,0,char,obj)

def addTargettoDB(event):
    char=event.object
    obj=event.string
    if Object_IsAlive(obj)==0:
        return
    if Object_IsAlive(char)==0:
        return
    global FFX_ADD_TARGET_TO_DB1
    global FFX_ADD_TARGET_TO_DB2
    global FFX_ADD_TARGET_TO_DB3
    global FFX_ADD_TARGET_TO_DB4
    global FFX_ADD_TARGET_TO_DB5
    global FFX_BC_DB1
    global FFX_BC_DB2
    global FFX_BC_DB3
    global FFX_BC_DB4
    global FFX_BC_DB5
    if FFX_ObjectGetAttr(obj,'addingToDBFailed')==1:
        FFX_ObjectSetAttr(obj,'addingToDBFailed',0)
    else:
        if FFX_ObjectGetAttr(obj,'addingToDB')!=0:
            FFX_ObjectSetAttr(obj,'addedToDB',1)
            FFX_ObjectSetAttr(obj,'wasAddedToDB',0)
            FFX_ObjectSetAttr(char,'addingToDB',0)
            FFX_ObjectSetAttr(obj,'addingToDB',0)
            Mission_StatusText('successfully added target to Battle Computer!')
            dbSlot = FFX_ObjectGetAttr(obj,'dbSlot')
            target=getTargetname(obj)
            if dbSlot == 1:
                FFX_ADD_TARGET_TO_DB1 = target
                FFX_BC_DB1 = obj
            if dbSlot == 2:
                FFX_ADD_TARGET_TO_DB2 = target
                FFX_BC_DB2 = obj
            if dbSlot == 3:
                FFX_ADD_TARGET_TO_DB3 = target
                FFX_BC_DB3 = obj
            if dbSlot == 4:
                FFX_ADD_TARGET_TO_DB4 = target
                FFX_BC_DB4 = obj
            if dbSlot == 5:
                FFX_ADD_TARGET_TO_DB5 = target
                FFX_BC_DB5 = obj
        else:
            Mission_StatusText('target failed to be entered into Battle Computer! try again!')
            FFX_ObjectSetAttr(obj,'addingToDB',0)
            FFX_ObjectSetAttr(char,'addingToDB',0)
            Mission_CustomAction('ADD_TARGET_TO_DATABASE',char,obj,'addToDBSlot',30,0)

def enemyCheck(event):
    char=event.object
    if Object_IsAlive(char)==0:
        return
    radius=getByTemplate(char,FFX_BATTLECOMPUTER_CUSTOM,6)
    radius2=radius*radius
    dbEntry1=getByTemplate(char,FFX_BATTLECOMPUTER_CUSTOM,1)
    dbEntry2=getByTemplate(char,FFX_BATTLECOMPUTER_CUSTOM,2)
    dbEntry3=getByTemplate(char,FFX_BATTLECOMPUTER_CUSTOM,3)
    dbEntry4=getByTemplate(char,FFX_BATTLECOMPUTER_CUSTOM,4)
    dbEntry5=getByTemplate(char,FFX_BATTLECOMPUTER_CUSTOM,5)
    RegTimer('enemyCheck',3,0,char)
    for obj in Mission_GetDynamicObjects():
        if ((Object_GetClass(obj) & FFX_CHARACTER)!=0) & (obj!=char) & ((Object_GetClass(obj)&js.OC_VEHICLE)==0) & ((Object_GetClass(obj)&js.OC_GENERIC)==0):
            team=m25ai.GetTeam(obj)
            myTeam=m25ai.GetTeam(char)
            target=getTargetname(obj)
            if (dbEntry1==target) | (dbEntry2==target) | (dbEntry3==target) | (dbEntry4==target):
                FFX_ObjectSetAttr(obj,'addedToDB',1)
            hasPortrait=FFX_HasPortrait(obj)
            pcAIEnabled=m25ai.AIInWatch(obj)
            if myTeam==team:
                if pcAIEnabled or hasPortrait:
                    Mission_RemoveCustomAction('ADD_TARGET_TO_DATABASE',char,obj)
                else:
                    if Mission_GetAttr('ffxSkirmish')==0:
                        if FFX_ObjectGetAttr(obj,'bcRunning',0)==0:
                            d=distanceSq(obj,char)
                            if d<radius2:
                                target=getTargetname(obj)
                                lookupTargetinBattleComputer(char,target,obj)
                    else:
                        Mission_RemoveCustomAction('ADD_TARGET_TO_DATABASE',char,obj)
            else:
                if FFX_ObjectGetAttr(obj,'bcRunning',0)==0:
                    d=distanceSq(obj,char)
                    if d<radius2:
                        target=getTargetname(obj)
                        lookupTargetinBattleComputer(char,target,obj)
            if FFX_ObjectGetAttr(obj,'BCaddTargetCmd',0)==0:
                Mission_CustomAction('ADD_TARGET_TO_DATABASE',char,obj,'addToDBSlot',30,0)
                FFX_ObjectSetAttr(obj,'BCaddTargetCmd',1)

def lookupTargetinBattleComputer(char,target,obj):
    if Object_IsAlive(char)==0:
        return
    global FFX_ADD_TARGET_TO_DB1
    global FFX_ADD_TARGET_TO_DB2
    global FFX_ADD_TARGET_TO_DB3
    global FFX_ADD_TARGET_TO_DB4
    global FFX_ADD_TARGET_TO_DB5
    dbEntry1=getByTemplate(char,FFX_BATTLECOMPUTER_CUSTOM,1)
    dbEntry2=getByTemplate(char,FFX_BATTLECOMPUTER_CUSTOM,2)
    dbEntry3=getByTemplate(char,FFX_BATTLECOMPUTER_CUSTOM,3)
    dbEntry4=getByTemplate(char,FFX_BATTLECOMPUTER_CUSTOM,4)
    team=m25ai.GetTeam(obj)
    myTeam=m25ai.GetTeam(char)
    hasPortrait=FFX_HasPortrait(obj)
    pcAIEnabled=m25ai.AIInWatch(obj)
    if (FFX_ADD_TARGET_TO_DB1==target) | (FFX_ADD_TARGET_TO_DB2==target) | (FFX_ADD_TARGET_TO_DB3==target) | (FFX_ADD_TARGET_TO_DB4==target) | (FFX_ADD_TARGET_TO_DB5==target):
        if ((Object_IsAlive(obj)!=0) & (myTeam!=team)) or ((Object_IsAlive(obj)!=0) & (myTeam==team) & (not pcAIEnabled) & (not hasPortrait)):
            applyBCbonus(char,obj)
            return
    if (dbEntry1==target) | (dbEntry2==target) | (dbEntry3==target) | (dbEntry4==target):
        if ((Object_IsAlive(obj)!=0) & (myTeam!=team) & (FFX_ObjectGetAttr(obj,'wasAddedToDB',0)==0)) or ((Object_IsAlive(obj)!=0) & (myTeam==team) & (FFX_ObjectGetAttr(obj,'wasAddedToDB',0)==0) & (not pcAIEnabled) & (not hasPortrait)):
            applyBCbonus(char,obj)

def applyBCbonus(char,obj):
    cmd1=getByTemplate(char,FFX_BATTLECOMPUTER_CUSTOM,7)
    cmd2=getByTemplate(char,FFX_BATTLECOMPUTER_CUSTOM,9)
    FFX_ObjectSetAttr(obj,'bcRunning',1)
    Mission_RemoveCustomAction('ADD_TARGET_TO_DATABASE',char,obj)
    Mission_CustomAction(cmd1,char,obj,'bcPower1',30,0)
    Mission_CustomAction(cmd2,char,obj,'bcPower2',30,0)
    if (Object_GetPrimaryState(obj)==PCSTATE_EXILE) | (Object_GetPrimaryState(obj)==PCSTATE_STATIC) | (Object_GetPrimaryState(obj)==PCSTATE_BLANK) | (Object_GetPrimaryState(obj)==PCSTATE_PANICKED) | (Object_GetPrimaryState(obj)==PCSTATE_FROZEN):
        if FFX_ObjectGetAttr(obj,'BCaglBonusOff',0)==0:
            FFX_ObjectSetAttr(obj,'BCaglBonusOff',1)
            RegCharState(obj,PCSTATE_NORMAL,'bcAgilityBonus',char)
    else:
        newAgility=Object_GetAttr(char,'templateAgility')+2
        Object_SetAttr(char,'agility',newAgility)
        aglBonus=FFX_ObjectGetAttr(char,'BCaglBonus')+1
        FFX_ObjectSetAttr(char,'BCaglBonus',aglBonus)
        Mission_StatusText('battle computer detected known enemy in range!')
        RegTimer('trackTarget',1,0,char,obj)
        if not FFX_HasPortrait(char) or m25ai.AIInWatch(char):
            RegTimer('addBCcmdsforAI',1,0,char,obj)

def bcAgilityBonus(event):
    target=event.object
    char=event.string
    if FFX_ObjectGetAttr(target,'bcRunning',0)==1:
        newAgility=Object_GetAttr(char,'templateAgility')+2
        Object_SetAttr(char,'agility',newAgility)
        aglBonus=FFX_ObjectGetAttr(char,'BCaglBonus')+1
        FFX_ObjectSetAttr(char,'BCaglBonus',aglBonus)
        FFX_ObjectSetAttr(obj,'BCaglBonusOff',0)


def addBCcmdsforAI(event):
    char=event.object
    target=event.string
    if FFX_ObjectGetAttr(target,'bcRunning',0)==1:
        RegTimer('addBCcmdsforAI',5,0,char,target)
        pwr1=getByTemplate(char,FFX_BATTLECOMPUTER_CUSTOM,8)
        pwr2=getByTemplate(char,FFX_BATTLECOMPUTER_CUSTOM,10)
        x=randint(1,100)
        if x < 26:
            m25ai.AIDoPower(char,pwr1,target,priority=m25ai.TACTIC_PRIORITY_MEDIUM,time=3,description='battle computer power1')
        if x > 25:
            if x < 50:
                m25ai.AIDoPower(char,pwr2,target,priority=m25ai.TACTIC_PRIORITY_MEDIUM,time=3,description='battle computer power2')

def bcPower1(target,char):
    pwr1=getByTemplate(char,FFX_BATTLECOMPUTER_CUSTOM,8)
    Trigger_Power(char,target,pwr1,'')

def bcPower2(target,char):
    pwr2=getByTemplate(char,FFX_BATTLECOMPUTER_CUSTOM,10)
    Trigger_Power(char,target,pwr2,'')

def trackTarget(event):
    char=event.object
    obj=event.string
    if Object_IsAlive(obj)==0:
        return
    if Object_IsAlive(char)==0:
        return
    if FFX_ObjectGetAttr(obj,'bcRunning',0)==0:
        return
    d=distanceSq(obj,char)
    radius=getByTemplate(char,FFX_BATTLECOMPUTER_CUSTOM,6)
    radius2=radius*radius
    if d > radius2:
        Mission_StatusText('enemy out of range of battle computer!')
        removeBCBonus(char,obj)
    if d < radius2:
        if (Object_GetPrimaryState(obj)==PCSTATE_EXILE) | (Object_GetPrimaryState(obj)==PCSTATE_STATIC) | (Object_GetPrimaryState(obj)==PCSTATE_BLANK) | (Object_GetPrimaryState(obj)==PCSTATE_PANICKED) | (Object_GetPrimaryState(obj)==PCSTATE_FROZEN):
            if FFX_ObjectGetAttr(obj,'BCaglBonusOff',0)==0:
                aglBonus=FFX_ObjectGetAttr(char,'BCaglBonus')-1
                if aglBonus<=0:
                    agility=Object_GetAttr(char,'templateAgility')
                    Object_SetAttr(char,'agility',agility)
                newAgility=Object_GetAttr(char,'agility')
                FFX_ObjectSetAttr(char,'BCaglBonus',aglBonus)
                FFX_ObjectSetAttr(obj,'BCaglBonusOff',1)
                RegCharState(obj,PCSTATE_NORMAL,'bcAgilityBonus',char)
        RegTimer('trackTarget',1,0,char,obj)

def removeBCBonus(char,obj):
    cmd1=getByTemplate(char,FFX_BATTLECOMPUTER_CUSTOM,7)
    cmd2=getByTemplate(char,FFX_BATTLECOMPUTER_CUSTOM,9)
    Mission_RemoveCustomAction(cmd1,char,obj)
    Mission_RemoveCustomAction(cmd2,char,obj)
    aglBonus=FFX_ObjectGetAttr(char,'BCaglBonus')-1
    if aglBonus<=0:
        agility=Object_GetAttr(char,'templateAgility')
        Object_SetAttr(char,'agility',agility)
    newAgility=Object_GetAttr(char,'agility')
    FFX_ObjectSetAttr(char,'BCaglBonus',aglBonus)
    FFX_ObjectSetAttr(obj,'bcRunning',0)

def getTargetname(obj):
    temp=FFX_GetTemplate(obj)
    name=GetRootName(temp)
    return name


######################## Wrestler Attribute ##############################################

def initwrestler(char,update=0):
    if isMP():
        return
    if update==0:
        str=Object_GetAttr(char,'strength')+1
        wStr=str+2
        FFX_ObjectSetAttr(char,'wrestler',wStr)


############################## Power Reserve ######################################################
# Allows the character to boost one physical stat (Strength, Speed, Agility, or Endurance)
# +2 points or increase damage output of powers temporarily while lowering the Energy Stat
# -3 and by spending 66 points of Energy.
# -TaskmasterX
###################################################################################################

def initpowerreserve(char,update):
    cmd1=getByTemplate(char,FFX_POWERRESERVE_CUSTOM,2)
    cmd2=getByTemplate(char,FFX_POWERRESERVE_CUSTOM,3)
    cmd3=getByTemplate(char,FFX_POWERRESERVE_CUSTOM,4)
    cmd4=getByTemplate(char,FFX_POWERRESERVE_CUSTOM,5)
    cmd5=getByTemplate(char,FFX_POWERRESERVE_CUSTOM,6)
    cmd6=getByTemplate(char,FFX_POWERRESERVE_CUSTOM,7)
    if cmd1!='':
        Mission_CustomAction(cmd1,char,char,'boostStr',5,0)
    if cmd2!='':
        Mission_CustomAction(cmd2,char,char,'boostSpd',5,0)
    if cmd3!='':
        Mission_CustomAction(cmd3,char,char,'boostAgl',5,0)
    if cmd4!='':
        Mission_CustomAction(cmd4,char,char,'boostEnd',5,0)
    if cmd5!='':
        Mission_CustomAction(cmd5,char,char,'boostPwr',5,0)
    if cmd6!='':
        Mission_CustomAction(cmd6,char,char,'boostResist',5,0)

def boostStr(target,char):
    if chargeEP(char,66)==0:
        return
    Trigger_Power(char,char,getByTemplate(char,FFX_POWERRESERVE_CUSTOM,1),'')
    basestr=Object_GetAttr(char,'templateStrength')
    newStrength=basestr+2
    Object_SetAttr(char,'strength',newStrength)
    Object_SetAttr(char,'baseStrength',newStrength)
    FFX_ObjectSetAttr(char,'PRstr',1)
    prBoost2(char)

def boostSpd(target,char):
    if chargeEP(char,66)==0:
        return
    Trigger_Power(char,char,getByTemplate(char,FFX_POWERRESERVE_CUSTOM,1),'')
    basespd=Object_GetAttr(char,'templateSpeed')
    newSpeed=basespd+2
    Object_SetAttr(char,'speed',newSpeed)
    Object_SetAttr(char,'baseSpeed',newSpeed)
    FFX_ObjectSetAttr(char,'PRspd',1)
    prBoost2(char)

def boostAgl(target,char):
    if chargeEP(char,66)==0:
        return
    Trigger_Power(char,char,getByTemplate(char,FFX_POWERRESERVE_CUSTOM,1),'')
    baseagl=Object_GetAttr(char,'templateAgility')
    newAgility=baseagl+2
    Object_SetAttr(char,'agility',newAgility)
    Object_SetAttr(char,'baseAgility',newAgility)
    FFX_ObjectSetAttr(char,'PRagl',1)
    prBoost2(char)

def boostEnd(target,char):
    if chargeEP(char,66)==0:
        return
    Trigger_Power(char,char,getByTemplate(char,FFX_POWERRESERVE_CUSTOM,1),'')
    baseHealth = GetBaseHealth(char)
    maxHP=Object_GetAttr(char,'maxHealth')
    hp=Object_GetAttr(char,'health')
    FFX_ObjectSetAttr(char,'prMaxHP',maxHP)
    newMaxHP=getPRHealth(char)
    Object_SetAttr(char,'maxHealth',newMaxHP)
    hpBonus = newMaxHP - maxHP
    FFX_ObjectSetAttr(char,'prHPBonus',hpBonus)
    newHP = hp + hpBonus
    Object_SetAttr(char,'health',newHP)
    FFX_ObjectSetAttr(char,'PRend',1)
    prBoost2(char)

def boostResist(target,char):
    if chargeEP(char,66)==0:
        return
    Trigger_Power(char,char,getByTemplate(char,FFX_POWERRESERVE_CUSTOM,1),'')
    FFX_ObjectSetAttr(char,'grimresolve',1)
    RegCharState(char,PCSTATE_STUNNED,'OnFFQPrimaryResist',persistent=1,user=0,string='grimresolve')
    FFX_ObjectSetAttr(char,'shakeitoff',1)
    regAcidBurnt(char,'OnFFQSecondaryDamageStateCheck',user = SCSTATE_ACID_BURNT,persistent = 1)
    regIrradiated(char,'OnFFQSecondaryDamageStateCheck',user = SCSTATE_IRRADIATED,persistent = 1)
    FFX_ObjectSetAttr(char,'PRresist',1)
    prBoost2(char)


def boostPwr(target,char):
    if chargeEP(char,66)==0:
        return
    Trigger_Power(char,char,getByTemplate(char,FFX_POWERRESERVE_CUSTOM,1),'')
    Object_SetAttr(char, 'attackBonus', 3)
    Object_SetGenericState(char,OBJSTATE_ATTACKBONUS,15,0)
    FFX_ObjectSetAttr(char,'PRpwr',1)
    prBoost2(char)

def prBoost2(char):
    baseeng=Object_GetAttr(char,'energy')
    newEnergy=baseeng-3
    if newEnergy < 0:
        newEnergy=0
    Object_SetAttr(char,'energy',newEnergy)
    RegTimer('playPREffect',1,0,char)
    cmd1=getByTemplate(char,FFX_POWERRESERVE_CUSTOM,2)
    cmd2=getByTemplate(char,FFX_POWERRESERVE_CUSTOM,3)
    cmd3=getByTemplate(char,FFX_POWERRESERVE_CUSTOM,4)
    cmd4=getByTemplate(char,FFX_POWERRESERVE_CUSTOM,5)
    cmd5=getByTemplate(char,FFX_POWERRESERVE_CUSTOM,6)
    cmd6=getByTemplate(char,FFX_POWERRESERVE_CUSTOM,7)
    Mission_CustomAction('TURN_OFF_POWER_RESERVE',char,char,'turnOffPR',5,0)
    removeCommand(cmd1,char)
    removeCommand(cmd2,char)
    removeCommand(cmd3,char)
    removeCommand(cmd4,char)
    removeCommand(cmd5,char)
    removeCommand(cmd6,char)
    RegTimer('powerReserveOff',15,0,char)

def getPRHealth(char):
    baseEnd = GetCharacterData(char)['endurance']+2
    if Object_GetClass(char) & OC_CONTROLLABLE:
        return int (( baseEnd**2 + baseEnd + 2 ) * 5 )
    else:
        diff6health = (15,30,60,105,165,480,660,870,1110,1380)
        diffdiv = (0, 9, 4, 3, 2, 1.5, 1, 0)
        return int(diff6health[baseEnd]/diffdiv[int(ff.RPG_GAME_DIFFICULTY)] )

def turnOffPR(target,char):
    FFX_ObjectSetAttr(char,'PRoffByCmd',1)
    RegTimer('powerReserveOff',.1,0,char)

def playPREffect(event):
    char=event.object
    if FFX_ObjectGetAttr(char,'PRoff')==1:
        FFX_ObjectSetAttr(char,'PRoff',0)
        return
    if FFX_ObjectGetAttr(char,'PRstr')==1:
        handle=Object_PlayEffect(char,'effect_ffxpurplestrength','',FX_TRACK_OBJECT_FULL)
        Object_SetAttr(char,'powerreserve_str',handle)
    if FFX_ObjectGetAttr(char,'PRspd')==1:
        handle=Object_PlayEffect(char,'effect_ffxpurplespeed','',FX_TRACK_OBJECT_FULL)
        Object_SetAttr(char,'powerreserve_spd',handle)
    if FFX_ObjectGetAttr(char,'PRagl')==1:
        handle=Object_PlayEffect(char,'effect_ffxabsorbspeed','',FX_TRACK_OBJECT_FULL)
        Object_SetAttr(char,'powerreserve_agl',handle)
    if FFX_ObjectGetAttr(char,'PRend')==1:
        handle=Object_PlayEffect(char,'effect_ffxabsorbstrength','',FX_TRACK_OBJECT_FULL)
        Object_SetAttr(char,'powerreserve_end',handle)
    if FFX_ObjectGetAttr(char,'PRresist')==1:
        handle=Object_PlayEffect(char,'effect_ffxabsorbenergy','',FX_TRACK_OBJECT_FULL)
        Object_SetAttr(char,'powerreserve_res',handle)
    RegTimer('playPREffect',1,0,char)

def powerReserveOff(event):
    char=event.object
    if FFX_ObjectGetAttr(char,'PRoffByCmdoff')==1:
        FFX_ObjectSetAttr(char,'PRoffByCmdoff',0)
        return
    if FFX_ObjectGetAttr(char,'PRoffByCmd')==1:
        FFX_ObjectSetAttr(char,'PRoffByCmd',0)
        FFX_ObjectSetAttr(char,'PRoffByCmdoff',1)
    FFX_ObjectSetAttr(char,'PRoff',1)
    eng=Object_GetAttr(char,'energy')+3
    Object_SetAttr(char,'energy',eng)
    if FFX_ObjectGetAttr(char,'PRstr')==1:
        str=Object_GetAttr(char,'templateStrength')
        Object_SetAttr(char,'strength',str)
        Object_SetAttr(char,'baseStrength',str)
        Object_StopEffect(char,Object_GetAttr(char,'powerreserve_str'))
        FFX_ObjectSetAttr(char,'PRstr',0)
    if FFX_ObjectGetAttr(char,'PRspd')==1:
        oldSpd=Object_GetAttr(char,'templateSpeed')
        Object_SetAttr(char,'speed',oldSpd)
        Object_SetAttr(char,'baseSpeed',oldSpd)
        Object_StopEffect(char,Object_GetAttr(char,'powerreserve_spd'))
        FFX_ObjectSetAttr(char,'PRspd',0)
    if FFX_ObjectGetAttr(char,'PRagl')==1:
        agl=Object_GetAttr(char,'templateAgility')
        Object_SetAttr(char,'agility',agl)
        Object_SetAttr(char,'baseAgility',agl)
        Object_StopEffect(char,Object_GetAttr(char,'powerreserve_agl'))
        FFX_ObjectSetAttr(char,'PRagl',0)
    if FFX_ObjectGetAttr(char,'PRend')==1:
        oldMaxHP=FFX_ObjectGetAttr(char,'prMaxHP')
        hpBonus=FFX_ObjectGetAttr(char,'prHPBonus')
        Object_SetAttr(char,'maxHealth',oldMaxHP)
        hp=Object_GetAttr(char,'health')-hpBonus
        Object_SetAttr(char,'health',hp)
        Object_StopEffect(char,Object_GetAttr(char,'powerreserve_end'))
        FFX_ObjectSetAttr(char,'PRend',0)
    if FFX_ObjectGetAttr(char,'PRresist')==1:
        FFX_ObjectSetAttr(char,'grimresolve',0)
        FFX_ObjectSetAttr(char,'shakeitoff',0)
        Object_StopEffect(char,Object_GetAttr(char,'powerreserve_res'))
        FFX_ObjectSetAttr(char,'PRresist',0)
    if FFX_ObjectGetAttr(char,'PRpwr')==1:
        Object_SetGenericState(char, OBJSTATE_ATTACKBONUS, 0, REMOVE_STATE)
        FFX_ObjectSetAttr(char,'PRpwr',0)
    cmd1=getByTemplate(char,FFX_POWERRESERVE_CUSTOM,2)
    cmd2=getByTemplate(char,FFX_POWERRESERVE_CUSTOM,3)
    cmd3=getByTemplate(char,FFX_POWERRESERVE_CUSTOM,4)
    cmd4=getByTemplate(char,FFX_POWERRESERVE_CUSTOM,5)
    cmd5=getByTemplate(char,FFX_POWERRESERVE_CUSTOM,6)
    cmd6=getByTemplate(char,FFX_POWERRESERVE_CUSTOM,7)
    if cmd1!='':
        Mission_CustomAction(cmd1,char,char,'boostStr',5,0)
    if cmd2!='':
        Mission_CustomAction(cmd2,char,char,'boostSpd',5,0)
    if cmd3!='':
        Mission_CustomAction(cmd3,char,char,'boostAgl',5,0)
    if cmd4!='':
        Mission_CustomAction(cmd4,char,char,'boostEnd',5,0)
    if cmd5!='':
        Mission_CustomAction(cmd5,char,char,'boostPwr',5,0)
    if cmd6!='':
        Mission_CustomAction(cmd6,char,char,'boostResist',5,0)
    removeCommand('TURN_OFF_POWER_RESERVE',char)


########################################## Genetic Symbiote ############################################
# Increases physical stats and adds invulnerable points when genetic symbiote is close by.
# The closer they are the higher the bonuses.
# -TaskmasterX
########################################################################################################

def initgeneticsymbiote(char,update=0):
    if update==0:
        RegTimer('geneticSymbioteCheck',1,0,char)

def geneticSymbioteCheck(event):
    char=event.object
    if Object_Exists(char)==0:
        return
    if Object_IsAlive(char)==0:
        return
    radius=getByTemplate(char,FFX_GENETICSYMBIOTE_CUSTOM,1)
    radius2=radius*radius
    RegTimer('geneticSymbioteCheck',2,0,char)
    for obj in Mission_GetDynamicObjects():
        if ((Object_GetClass(obj) & FFX_CHARACTER)!=0) & (obj!=char) & ((Object_GetClass(obj)&js.OC_TERRAIN)==0) & ((Object_GetClass(obj)&js.OC_VEHICLE)==0) & ((Object_GetClass(obj)&js.OC_BUILDING)==0) & ((Object_GetClass(obj)&js.OC_GENERIC)==0):
            if Object_Exists(obj)==0:
                return
            if Object_IsAlive(obj)==0:
                return
            d=distanceSq(obj,char)
            if d<radius2:
                target=getTargetname(obj)
                matchgeneticSymbiote(char,target,obj)

def matchgeneticSymbiote(char,target,obj):
    geneticSym=getByTemplate(char,FFX_GENETICSYMBIOTE_CUSTOM,2)
    if geneticSym==target:
        playSynergyFX(char,FFX_GENETICSYMBIOTE_CUSTOM)
        playGSFXonTargets(char,obj,FFX_GENETICSYMBIOTE_CUSTOM)
        RegTimer('GStrackTarget',0.1,0,char,obj)
        return

def playGSFXonTargets(char,obj,array):
    if FFX_ObjectGetAttr(char,'synfx2',0)==0:
        FFX_ObjectSetAttr(char,'synfx2',1)
        RegTimer('restoreSynFX2',1,0,char)
        fx=getByTemplate(char,array,4)
        if fx!='':
            Object_PlayEffect(obj,fx,'',FX_TRACK_OBJECT_FULL)

def GStrackTarget(event):
    char=event.object
    obj=event.string
    pos1 = Get_ObjectPos(char)
    pos2 = Get_ObjectPos(obj)
    dist = cshelper.distance2D(pos1, pos2)
    radius=getByTemplate(char,FFX_GENETICSYMBIOTE_CUSTOM,1)
    short = radius/3
    medium = short*2
    if Object_Exists(obj)==0:
        cancelGSymbiote(char)
        return
    if Object_IsAlive(obj)==0:
        cancelGSymbiote(char)
        return
    if dist > radius:
        cancelGSymbiote(char)
        return
    if dist < radius:
        RegTimer('GStrackTarget',1,0,char,obj)
        if dist < short:
            strbonus=Object_GetAttr(char,'templateStrength')+3
            Object_SetAttr(char,'strength',strbonus)
            Object_SetAttr(char,'baseStrength',strbonus)
            aglbonus=Object_GetAttr(char,'templateAgility')+3
            Object_SetAttr(char,'agility',aglbonus)
            Object_SetAttr(char,'baseAgility',aglbonus)
            spdbonus=Object_GetAttr(char,'templateSpeed')+1
            Object_SetAttr(char,'speed',spdbonus)
            Object_SetAttr(char,'baseSpeed',spdbonus)
            baseeng=FFX_ObjectGetAttr(char,'baseEnergy')
            newEnergy=baseeng+2
            Object_SetAttr(char,'energy',newEnergy)
            baseHealth = GetBaseHealth(char)
            maxHP=Object_GetAttr(char,'maxHealth')
            hp=Object_GetAttr(char,'health')
            FFX_ObjectSetAttr(char,'gsMaxHP',maxHP)
            endBonus=2
            newMaxHP=getGSHealth(char,endBonus)
            Object_SetAttr(char,'maxHealth',newMaxHP)
            hpBonus = newMaxHP - maxHP
            FFX_ObjectSetAttr(char,'gsHPBonus',hpBonus)
            newHP = hp + hpBonus
            Object_SetAttr(char,'health',newHP)
            bip=FFX_ObjectGetAttr(char,'baseInvPoints')
            if bip==0:
                FFX_ObjectSetAttr(char,'ivlastdam',Object_GetAttr(char,'health'))
                if not FFX_ObjectGetAttr(char,'DamageManagement',0):
                    RegDamage(char,'DamageManagement')
                    FFX_ObjectSetAttr(char,'DamageManagement',1)
                FFX_ObjectSetAttr(char,'invPoints',bip+10)
                FFX_ObjectSetAttr(char,'baseInvPoints',0)
            else:
                FFX_ObjectSetAttr(char,'invPoints',bip+10)
            return
        else:
            if dist < medium:
                strbonus=Object_GetAttr(char,'templateStrength')+2
                Object_SetAttr(char,'strength',strbonus)
                Object_SetAttr(char,'baseStrength',strbonus)
                aglbonus=Object_GetAttr(char,'templateAgility')+2
                Object_SetAttr(char,'agility',aglbonus)
                Object_SetAttr(char,'baseAgility',aglbonus)
                spdbonus=Object_GetAttr(char,'templateSpeed')+1
                Object_SetAttr(char,'speed',spdbonus)
                Object_SetAttr(char,'baseSpeed',spdbonus)
                baseeng=FFX_ObjectGetAttr(char,'baseEnergy')
                newEnergy=baseeng+1
                Object_SetAttr(char,'energy',newEnergy)
                baseHealth = GetBaseHealth(char)
                maxHP=Object_GetAttr(char,'maxHealth')
                hp=Object_GetAttr(char,'health')
                FFX_ObjectSetAttr(char,'gsMaxHP',maxHP)
                endBonus=1
                newMaxHP=getGSHealth(char,endBonus)
                Object_SetAttr(char,'maxHealth',newMaxHP)
                hpBonus = newMaxHP - maxHP
                FFX_ObjectSetAttr(char,'gsHPBonus',hpBonus)
                newHP = hp + hpBonus
                Object_SetAttr(char,'health',newHP)
                bip=FFX_ObjectGetAttr(char,'baseInvPoints')
                if bip==0:
                    FFX_ObjectSetAttr(char,'ivlastdam',Object_GetAttr(char,'health'))
                    if not FFX_ObjectGetAttr(char,'DamageManagement',0):
                        RegDamage(char,'DamageManagement')
                        FFX_ObjectSetAttr(char,'DamageManagement',1)
                    FFX_ObjectSetAttr(char,'invPoints',bip+5)
                    FFX_ObjectSetAttr(char,'baseInvPoints',0)
                else:
                    FFX_ObjectSetAttr(char,'invPoints',bip+5)
                return
            else:
                strbonus=Object_GetAttr(char,'templateStrength')+1
                Object_SetAttr(char,'strength',strbonus)
                Object_SetAttr(char,'baseStrength',strbonus)
                aglbonus=Object_GetAttr(char,'templateAgility')+1
                Object_SetAttr(char,'agility',aglbonus)
                Object_SetAttr(char,'baseAgility',aglbonus)
                spdbonus=Object_GetAttr(char,'templateSpeed')+1
                Object_SetAttr(char,'speed',spdbonus)
                Object_SetAttr(char,'baseSpeed',spdbonus)
                baseeng=FFX_ObjectGetAttr(char,'baseEnergy')
                newEnergy=baseeng+1
                Object_SetAttr(char,'energy',newEnergy)
                baseHealth = GetBaseHealth(char)
                maxHP=Object_GetAttr(char,'maxHealth')
                hp=Object_GetAttr(char,'health')
                FFX_ObjectSetAttr(char,'gsMaxHP',maxHP)
                endBonus=1
                newMaxHP=getGSHealth(char,endBonus)
                Object_SetAttr(char,'maxHealth',newMaxHP)
                hpBonus = newMaxHP - maxHP
                FFX_ObjectSetAttr(char,'gsHPBonus',hpBonus)
                newHP = hp + hpBonus
                Object_SetAttr(char,'health',newHP)
                baseeng=FFX_ObjectGetAttr(char,'baseEnergy')
                Object_SetAttr(char,'energy',baseeng)
                bip=FFX_ObjectGetAttr(char,'baseInvPoints')
                if bip==0:
                    FFX_ObjectSetAttr(char,'ivlastdam',Object_GetAttr(char,'health'))
                    if not FFX_ObjectGetAttr(char,'DamageManagement',0):
                        RegDamage(char,'DamageManagement')
                        FFX_ObjectSetAttr(char,'DamageManagement',1)
                    FFX_ObjectSetAttr(char,'invPoints',bip+2)
                    FFX_ObjectSetAttr(char,'baseInvPoints',0)
                else:
                    FFX_ObjectSetAttr(char,'invPoints',bip+2)

def getGSHealth(char,endBonus):
    baseEnd = GetCharacterData(char)['endurance']+endBonus
    if Object_GetClass(char) & OC_CONTROLLABLE:
        return int (( baseEnd**2 + baseEnd + 2 ) * 5 )
    else:
        diff6health = (15,30,60,105,165,480,660,870,1110,1380)
        diffdiv = (0, 9, 4, 3, 2, 1.5, 1, 0)
        return int(diff6health[baseEnd]/diffdiv[int(ff.RPG_GAME_DIFFICULTY)] )

def cancelGSymbiote(char):
    str=Object_GetAttr(char,'templateStrength')
    Object_SetAttr(char,'strength',str)
    Object_SetAttr(char,'baseStrength',str)
    agl=Object_GetAttr(char,'templateAgility')
    Object_SetAttr(char,'agility',agl)
    Object_SetAttr(char,'baseAgility',agl)
    spd=Object_GetAttr(char,'templateSpeed')
    Object_SetAttr(char,'speed',spd)
    Object_SetAttr(char,'baseSpeed',spd)
    baseeng=FFX_ObjectGetAttr(char,'baseEnergy')
    Object_SetAttr(char,'energy',baseeng)
    baseHealth = GetBaseHealth(char)
    maxHP=Object_GetAttr(char,'maxHealth')
    hp=Object_GetAttr(char,'health')
    FFX_ObjectSetAttr(char,'gsMaxHP',maxHP)
    endBonus=0
    newMaxHP=getGSHealth(char,endBonus)
    Object_SetAttr(char,'maxHealth',newMaxHP)
    hpBonus = newMaxHP - maxHP
    FFX_ObjectSetAttr(char,'gsHPBonus',hpBonus)
    newHP = hp + hpBonus
    Object_SetAttr(char,'health',newHP)
    bip=FFX_ObjectGetAttr(char,'baseInvPoints')
    FFX_ObjectSetAttr(char,'invPoints',bip)


################################# FREE SPIRIT #########################################################
# There is a free-roaming spirit that resides within you that you can release to aid you.
# -TaskmasterX
########################################################################################################

def initfreespirit(char,update=0):
    if isMP():
        return
    if update==0:
        if not FFX_ObjectGetAttr(char,'free_spirit'):
            Mission_CustomAction('RELEASE_SPIRIT',char,char,'OnReleaseSpirit',4,0)
            Mission_CustomAction('LEAVE_HOST',char,char,'OnLeaveHost',4,0)

def OnReleaseSpirit(dummy,char):
    AI_Animate(char,getByTemplate(char,FFX_FREESPIRIT_CUSTOM,2),'OnReleaseSpirit2')
    FFX_ObjectSetAttr(char,'release_spirit',1)

def OnLeaveHost(dummy,char):
    AI_Animate(char,getByTemplate(char,FFX_FREESPIRIT_CUSTOM,2),'OnReleaseSpirit2')
    FFX_ObjectSetAttr(char,'leave_host',1)

def OnReleaseSpirit2(event):
    char=event.object
    spiritFX(char)
    name=getFormName()
    spiritTemplate=getByTemplate(char,FFX_FREESPIRIT_CUSTOM,1)
    OnDrop(char,char)
    if spiritTemplate=='':
        spiritTemplate=Object_GetTemplate(char)
    FFX_Spawn(name,spiritTemplate,char)
    FFX_ObjectSetAttr(name,'morph',1)
    FFX_ObjectSetAttr(name,'free_spirit',1)
    if FFX_ObjectGetAttr(char,'release_spirit')==1:
        if FFX_HasPortrait(char) and not m25ai.AIInWatch(char):
            FFX_AdjustPortrait(char,1)
        FFX_AdjustPortrait(name,0)
    if FFX_ObjectGetAttr(char,'leave_host')==1:
        FFX_AdjustPortrait(char,0)
    makeIllusion(name,1)
    m25ai.SetTeam(name,m25ai.GetTeam(char))
    if m25ai.AIInWatch(char) or not FFX_HasPortrait(char):
        RegTimer('resetSpiritTeam',1,0,char,name)
    RegTimer('removeFX',0.5,3,name)
    RegTimer('OnReleaseSpirit3',1,0,char,name)

def resetSpiritTeam(event):
    char=event.object
    name=event.string
    m25ai.SetTeam(name,m25ai.GetTeam(char))
    myteam=m25ai.GetTeam(char)
    team=m25ai.GetTeam(name)

def OnReleaseSpirit3(event):
    char=event.object
    name=event.string
    maxHP=Object_GetAttr(char,'maxHealth')
    hp=Object_GetAttr(char,'health')
    FFX_ObjectSetAttr(char,'fsMaxHP',maxHP)
    endBonus = -1
    newMaxHP=getAdjustedHealth(char,endBonus)
    Object_SetAttr(char,'maxHealth',newMaxHP)
    newMaxHPa = newMaxHP * 100
    pctLoss1 = newMaxHPa / maxHP
    pctLoss2 = pctLoss1 / 100
    newHP = hp * pctLoss2
    Object_SetAttr(char,'health',newHP)
    str=Object_GetAttr(char,'templateStrength')-1
    Object_SetAttr(char,'strength',str)
    Object_SetAttr(char,'baseStrength',str)
    if FFX_ObjectGetAttr(char,'release_spirit')==1:
        m25ai.ClearAIStandardOnly(name)
        m25ai.AIEnableWatch(name)
        m25ai.AIEnable(name)
        m25ai.AIEnableCustom(name)
        m25ai.SetBrawler(name)
        if FFX_HasPortrait(char) and not m25ai.AIInWatch(char):
            Mission_SelectHero(char)
        Mission_CustomAction('CUSTOM_RETURN_SPIRIT',char,name,'OnSpiritReturn',0,0)
        Mission_CustomAction('CUSTOM_TRANSFER',char,name,'OnTransferFromHost',100,0)
    if FFX_ObjectGetAttr(char,'leave_host')==1:
        m25ai.ClearAIStandardOnly(char)
        m25ai.AIEnableWatch(char)
        m25ai.AIEnable(char)
        m25ai.AIEnableCustom(char)
        m25ai.SetBrawler(char)
        if FFX_HasPortrait(char) and not m25ai.AIInWatch(char):
            Mission_SelectHero(name)
        Mission_CustomAction('CUSTOM_RETURN',name,char,'OnSpiritReturn',0,0)
        Mission_CustomAction('CUSTOM_TRANSFER',name,char,'OnTransferFromSpirit',100,0)
    Mission_RemoveCustomAction('RELEASE_SPIRIT',char,char)
    Mission_RemoveCustomAction('LEAVE_HOST',char,char)
    RegTimer('SpiritLink',1,0,name,char)

def OnTransferFromSpirit(target,char):
    if FFX_ObjectGetAttr(char,'free_spirit')==1:
        FFX_AdjustPortrait(char,0)
        RegTimer('OnSpiritReturn2',0.1,0,target)
        m25ai.SetAIStandardOnly(target)
        m25ai.AIDisableWatch(target)
        m25ai.AIDisableCustom(target)
        m25ai.ClearAIStandardOnly(char)
        m25ai.AIEnableWatch(char)
        m25ai.AIEnable(char)
        m25ai.AIEnableCustom(char)
        m25ai.SetBrawler(char)
        Mission_RemoveCustomAction('CUSTOM_TRANSFER',char,target)
        Mission_RemoveCustomAction('CUSTOM_RETURN',char,target)
        Mission_CustomAction('CUSTOM_RETURN_SPIRIT',target,char,'OnSpiritReturn',0,0)
        Mission_CustomAction('CUSTOM_TRANSFER',target,char,'OnTransferFromHost',100,0)

def OnTransferFromHost(char,target):
    FFX_AdjustPortrait(target,0)
    RegTimer('OnSpiritReturn2',0.1,0,char)
    m25ai.SetAIStandardOnly(char)
    m25ai.AIDisableWatch(char)
    m25ai.AIDisableCustom(char)
    m25ai.ClearAIStandardOnly(target)
    m25ai.AIEnableWatch(target)
    m25ai.AIEnable(target)
    m25ai.AIEnableCustom(target)
    m25ai.SetBrawler(target)
    Mission_RemoveCustomAction('CUSTOM_TRANSFER',target,char)
    Mission_RemoveCustomAction('CUSTOM_RETURN_SPIRIT',target,char)
    Mission_CustomAction('CUSTOM_RETURN',char,target,'OnSpiritReturn',0,0)
    Mission_CustomAction('CUSTOM_TRANSFER',char,target,'OnTransferFromSpirit',100,0)

def OnSpiritReturn(target,char):
    spiritFX(target)
    spiritFX(char)
    if FFX_ObjectGetAttr(char,'free_spirit')==1: #if char is the spirit and not the host then do this
        FFX_AdjustPortrait(char,0)
        RegTimer('destroyTemp',1,0,char)
        RegTimer('OnSpiritReturn2',0.1,0,target)
        normalize(target)
        maxHP=Object_GetAttr(target,'maxHealth')
        hp=Object_GetAttr(target,'health')
        oldmaxHP=FFX_ObjectGetAttr(target,'fsMaxHP')
        Object_SetAttr(target,'maxHealth',oldmaxHP)
        newMaxHPa = oldmaxHP * 100
        pctGain = newMaxHPa / maxHP
        hpBonus = pctGain / 100
        newHP = hp * hpBonus
        Object_SetAttr(target,'health',newHP)
        str=Object_GetAttr(target,'templateStrength')
        Object_SetAttr(target,'strength',str)
        Object_SetAttr(target,'baseStrength',str)
        m25ai.SetAIStandardOnly(target)
        m25ai.AIDisableWatch(target)
        m25ai.AIDisableCustom(target)
        FFX_ObjectSetAttr(target,'leave_host',0)
        FFX_ObjectSetAttr(target,'release_spirit',0)
        Mission_RemoveCustomAction('CUSTOM_RETURN_SPIRIT',target,char)
        Mission_CustomAction('RELEASE_SPIRIT',target,target,'OnReleaseSpirit',4,0)
        Mission_CustomAction('LEAVE_HOST',target,target,'OnLeaveHost',4,0)
        return
    FFX_AdjustPortrait(target,0) #if char is the host and not the spirit then do this
    RegTimer('destroyTemp',1,0,target)
    RegTimer('OnSpiritReturn2',0.1,0,char)
    normalize(char)
    maxHP=Object_GetAttr(char,'maxHealth')
    hp=Object_GetAttr(char,'health')
    oldmaxHP=FFX_ObjectGetAttr(char,'fsMaxHP')
    Object_SetAttr(char,'maxHealth',oldmaxHP)
    newMaxHPa = oldmaxHP * 100
    pctGain = newMaxHPa / maxHP
    hpBonus = pctGain / 100
    newHP = hp * hpBonus
    Object_SetAttr(char,'health',newHP)
    str=Object_GetAttr(char,'templateStrength')
    Object_SetAttr(char,'strength',str)
    Object_SetAttr(char,'baseStrength',str)
    FFX_ObjectSetAttr(char,'leave_host',0)
    FFX_ObjectSetAttr(char,'release_spirit',0)
    Mission_RemoveCustomAction('CUSTOM_RETURN_SPIRIT',char,target)
    Mission_CustomAction('RELEASE_SPIRIT',char,char,'OnReleaseSpirit',4,0)
    Mission_CustomAction('LEAVE_HOST',char,char,'OnLeaveHost',4,0)

def OnSpiritReturn2(event):
    target=event.object
    FFX_AdjustPortrait(target,1)
    Mission_SelectHero(target)

def spiritFX(shell):
    fx=getByTemplate(shell,FFX_FREESPIRIT_CUSTOM,3)
    if fx!='':
        Object_PlayEffect(shell,fx)

def SpiritLink(event):
    c1=event.object
    c2=event.string
    if Object_Exists(c1) & Object_Exists(c2):
        l1=Object_IsAlive(c1)
        l2=Object_IsAlive(c2)
        if l1 and not l2:
            cshelper.kill(c1)
        if l2 and not l1:
            Object_SetPrimaryState(c2,PCSTATE_STUNNED,10)
            return
        RegTimer('SpiritLink',1,0,c1,c2)

def getAdjustedHealth(char,endBonus):
    baseEnd = GetCharacterData(char)['endurance']+endBonus
    if Object_GetClass(char) & OC_CONTROLLABLE:
        return int (( baseEnd**2 + baseEnd + 2 ) * 5 )
    else:
        diff6health = (15,30,60,105,165,480,660,870,1110,1380)
        diffdiv = (0, 9, 4, 3, 2, 1.5, 1, 0)
        return int(diff6health[baseEnd]/diffdiv[int(ff.RPG_GAME_DIFFICULTY)] )


######################################## BODY ARMOR ###########################################
# stumpy 2007-12-16: See http://freedomreborn.net/simple/index.php?topic=45553.0
# stumpy 2007-12-19: Modified so that BA rating is reduced in proportion to excess damage

def initbodyarmor(char, rating, update=0, remove=0):
    if remove:
        BAPoints = max(FFX_ObjectGetAttr(char,'BAPoints',0)-rating,0)
        BaseBAPoints = max(FFX_ObjectGetAttr(char,'BaseBAPoints',0)-rating,0)
        FFX_ObjectSetAttr(char,'BAPoints',BAPoints)
        FFX_ObjectSetAttr(char,'BaseBAPoints',BaseBAPoints)
        return
    if update==0:
        BAPoints = FFX_ObjectGetAttr(char,'BAPoints',0)+rating
        BaseBAPoints = max(FFX_ObjectGetAttr(char,'BaseBAPoints',0)+rating,0)
        if not FFX_ObjectGetAttr(char,'DamageManagement',0):
            FFX_ObjectSetAttr(char,'ivlastdam',Object_GetAttr(char,'health'))
            RegDamage(char,'DamageManagement')
            FFX_ObjectSetAttr(char,'DamageManagement',1)
        FFX_ObjectSetAttr(char,'BAPoints',BAPoints)
        FFX_ObjectSetAttr(char,'BaseBAPoints',BaseBAPoints)

def initbodyarmor02(char, update=0, remove=0):
    initbodyarmor(char, 02, update, remove)

def initbodyarmor05(char, update=0, remove=0):
    initbodyarmor(char, 05, update, remove)

def initbodyarmor10(char, update=0, remove=0):
    initbodyarmor(char, 10, update, remove)

def initbodyarmor20(char, update=0, remove=0):
    initbodyarmor(char, 20, update, remove)

def initbodyarmor30(char, update=0, remove=0):
    initbodyarmor(char, 30, update, remove)


################################## Phasing ##############################################
phasingTemplates=[
['blitz_shield_emitter',],
['blitz_shield_generator',],
['computer',],
['ff_computer',],
['force_field_projector',],
['processor',],
['processor_animated',],
['generator',],
['generator_bigpipe_01',],
['generator_smallpipe_01',],
['ger_radar_large',],
['ger_radar_small',],
['nazihq_computer_big',],
['nazihq_computer_short',],
['nazihq_computer_tall',],
['nazihq_lab_machine_1',],
['nazihq_lab_machine_2',],
['nazihq_lab_machine_3',],
['nazihq_lab_machine_4',],
['nazihq_lab_machine_5',],
['nazihq_lab_machine_6',],
['nazihq_lab_machine_7',],
['nazihq_temporal_amplifier',],
['nazihq_temporal_amplifier_mp',],
['fusebox',],
['pat_fusebox',],
['regulator',],
['shield_dish',],
['shield_box',],
['conveyor',],
['nazihq_hypno_sphere',],
]

def isPhasingTemplate(obj,char=''):
    if not Object_Exists(obj):
        return 0
    temp=Object_GetTemplate(obj)
    for t in phasingTemplates:
        if t==temp:
            return 1
    return 0

def initphasing(char,update=0):
    if isMP():
        return
    if update==0:
        Mission_CustomAction('CUSTOM_PHASEOUT',char,char,'OnPhaseOut',4,0)

def OnPhaseOut(dummy,char):
    AI_Animate(char,getByTemplate(char,FFX_PHASING_CUSTOM,2),'OnPhaseOut2')

def OnPhaseOut2(event):
    char=event.object
    phasedFX(char)
    name=getFormName()
    portrait=FFX_HasPortrait(char)
    phasedTemplate=getByTemplate(char,FFX_PHASING_CUSTOM,1)
    if phasedTemplate=='':
        phasedTemplate=Object_GetTemplate(char)
    morph(name,char,phasedTemplate,0,portrait)
    FFX_ObjectSetAttr(name,'morph',1)
    FFX_ObjectSetAttr(name,'phased',1)
    RegTimer('makePhased',0.1,0,name)

def makePhased(event):
    char=event.object
    ff.RESULTBUBBLE_SCALE=0
    RegTimer('bubblesOn',0.1)
    if usingM25AI():
        m25ai.AISupport_DoSelfPowerTimed(char, 'ffx_phasing_defence', char, m25ai.TACTIC_PRIORITY_CRITICAL, 1.0, desc='phasing out')
    else:   
        Trigger_Power(char,char,'ffx_phasing_defence','')
    Object_SetAttr(char,'oldAttackBonus',Object_GetAttr(char,'attackBonus'))
    Object_SetGenericState(char,OBJSTATE_ATTACKBONUS,10000,0)
    Object_SetAttr(char,'attackBonus',-10)
    Object_SetAttr(char,'strength',0)
    FFX_ObjectSetAttr(char, 'permanent_shield', FFX_ObjectGetAttr(char, 'permanent_shield') + 1 ) #Ep. 2006-09-23: indicates that the character has an active defence which shouldn't be removed by other scripts
    Object_SetSecondaryState(char,SCSTATE_BUOYANT,10000,0)
    Trigger_Move(char,'land')
    RegTimer('removeFX',0.2,3,char)
    Mission_CustomAction('CUSTOM_PHASEIN',char,char,'OnRevertAbsorb',5,0)
    objects = js.Mission_GetDynamicObjects()
    for obj in objects:
        subtype = m25ai.FindTacticType(obj, 'subtype')
        if ('robot' in subtype) or ('hitech' in subtype) or ('computer' in subtype) | (getGender(obj) == FFX_GENDER_ROBOT):
            FFX_ObjectSetAttr(obj,'phaseDisruptTarget',1)
            Mission_CustomAction('CUSTOM_DISRUPT_ELECTRONICS',char,obj,'onPhaseDisrupt',5,0)
    for type in phasingTemplates:
        Mission_CustomAction('CUSTOM_DISRUPT_ELECTRONICS',char,type[0],'onPhaseDisrupt',5,0)
    RegTimer('phasedFlightCheck',1,0,char)
    FFX_ObjectSetAttr(char,'airborne_phased',0)
    FFX_ObjectSetAttr(char,'flyCheck',0)

def phasedFlightCheck(event):
    char=event.object
    if not Object_Exists(char):
        return
    if not Object_IsAlive(char):
        return
    if FFX_ObjectGetAttr(char,'phased',0)==0:
        return
    RegTimer('phasedFlightCheck',1,0,char)
    flying=mlogreader.MLOG_IsFlying(char)
    wasFlying=FFX_ObjectGetAttr(char,'airborne_phased')
    if flying:
        speed=Object_GetAttr(char,'baseSpeed')/2
        Object_SetAttr(char,'speed',speed)
        FFX_ObjectSetAttr(char,'baseSpeed',speed)
        if wasFlying==0:
            FFX_ObjectSetAttr(char,'airborne_phased',1)
    elif not flying:
        FFX_ObjectSetAttr(char,'airborne_phased',0)
        speed=Object_GetAttr(char,'baseSpeed')
        Object_SetAttr(char,'speed',speed)
        FFX_ObjectSetAttr(char,'baseSpeed',speed)

def onPhaseDisrupt(obj,char):
    turnTo(char,obj)
    AI_Animate(char,getByTemplate(char,FFX_PHASING_CUSTOM,2))
    if FFX_ObjectGetAttr(obj,'phaseDisruptTarget',0)==1:
        Object_SetPrimaryState(obj,PCSTATE_STUNNED,10,0)
        Trigger_Damage(obj,randint(15,30))
        FFX_ObjectSetAttr(obj,'phaseDisruptTarget',0)
    else:
        Trigger_Damage(obj,randint(15,30))

def phasedFX(shell):
    fx=getByTemplate(shell,FFX_PHASING_CUSTOM,3)
    if fx!='':
        Object_PlayEffect(shell,fx)

#ShowAllActiveDefenceDurations()
#Campaign_ChangeActiveDefenceDuration('ff_active_',3)

######################################################################
## 
## FFX FOOTER:
## FunctionWrapper import
## 
######################################################################
# The functionwrapper module needs to imported after everything else, including ffx mission plugins.
import functionwrapper
from functionwrapper import * # For customisation of built-in functions


######################################################################
## 
## PLEASE ADD YOUR CODE *ABOVE* FFX FOOTER CODE.
## 
######################################################################
# END OF FILE

